/* A Bison parser, made by GNU Bison 3.7.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30705

/* Bison version string.  */
#define YYBISON_VERSION "3.7.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs

/* First part of user prologue.  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2022, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET constraint_exclusion TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "access/tableam.h"
#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_am.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "commands/trigger.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule, or whose leftmost
 * component was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 *
 * A cleaner answer would be to make YYLLOC_DEFAULT scan all the Rhs
 * locations until it's found one that's not -1.  Then we'd get a correct
 * location for any nonterminal that isn't entirely empty.  But this way
 * would add overhead to every rule reduction, and so far there's not been
 * a compelling reason to pay that overhead.
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	ObjectType	objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* Private struct for the result of opt_select_limit production */
typedef struct SelectLimit
{
	Node	   *limitOffset;
	Node	   *limitCount;
	LimitOption limitOption;
} SelectLimit;

/* Private struct for the result of group_clause production */
typedef struct GroupClause
{
	bool		distinct;
	List	   *list;
} GroupClause;

/* Private structs for the result of key_actions and key_action productions */
typedef struct KeyAction
{
	char		action;
	List	   *cols;
} KeyAction;

typedef struct KeyActions
{
	KeyAction *updateAction;
	KeyAction *deleteAction;
} KeyActions;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static RawStmt *makeRawStmt(Node *stmt, int stmt_location);
static void updateRawStmtEnd(RawStmt *rs, int end_location);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBoolAConst(bool state, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Node *v, int location);
static RoleSpec *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								SelectLimit *limitClause,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Float *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod,
								  int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static RangeVar *makeRangeVarFromQualifiedName(char *name, List *rels,
											   int location,
											   core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static void preprocess_pubobj_list(List *pubobjspec_list,
								   core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 301 "gram.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "gram.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_IDENT = 3,                      /* IDENT  */
  YYSYMBOL_UIDENT = 4,                     /* UIDENT  */
  YYSYMBOL_FCONST = 5,                     /* FCONST  */
  YYSYMBOL_SCONST = 6,                     /* SCONST  */
  YYSYMBOL_USCONST = 7,                    /* USCONST  */
  YYSYMBOL_BCONST = 8,                     /* BCONST  */
  YYSYMBOL_XCONST = 9,                     /* XCONST  */
  YYSYMBOL_Op = 10,                        /* Op  */
  YYSYMBOL_ICONST = 11,                    /* ICONST  */
  YYSYMBOL_PARAM = 12,                     /* PARAM  */
  YYSYMBOL_TYPECAST = 13,                  /* TYPECAST  */
  YYSYMBOL_DOT_DOT = 14,                   /* DOT_DOT  */
  YYSYMBOL_COLON_EQUALS = 15,              /* COLON_EQUALS  */
  YYSYMBOL_EQUALS_GREATER = 16,            /* EQUALS_GREATER  */
  YYSYMBOL_LESS_EQUALS = 17,               /* LESS_EQUALS  */
  YYSYMBOL_GREATER_EQUALS = 18,            /* GREATER_EQUALS  */
  YYSYMBOL_NOT_EQUALS = 19,                /* NOT_EQUALS  */
  YYSYMBOL_ABORT_P = 20,                   /* ABORT_P  */
  YYSYMBOL_ABSENT = 21,                    /* ABSENT  */
  YYSYMBOL_ABSOLUTE_P = 22,                /* ABSOLUTE_P  */
  YYSYMBOL_ACCESS = 23,                    /* ACCESS  */
  YYSYMBOL_ACTION = 24,                    /* ACTION  */
  YYSYMBOL_ADD_P = 25,                     /* ADD_P  */
  YYSYMBOL_ADMIN = 26,                     /* ADMIN  */
  YYSYMBOL_AFTER = 27,                     /* AFTER  */
  YYSYMBOL_AGGREGATE = 28,                 /* AGGREGATE  */
  YYSYMBOL_ALL = 29,                       /* ALL  */
  YYSYMBOL_ALSO = 30,                      /* ALSO  */
  YYSYMBOL_ALTER = 31,                     /* ALTER  */
  YYSYMBOL_ALWAYS = 32,                    /* ALWAYS  */
  YYSYMBOL_ANALYSE = 33,                   /* ANALYSE  */
  YYSYMBOL_ANALYZE = 34,                   /* ANALYZE  */
  YYSYMBOL_AND = 35,                       /* AND  */
  YYSYMBOL_ANY = 36,                       /* ANY  */
  YYSYMBOL_ARRAY = 37,                     /* ARRAY  */
  YYSYMBOL_AS = 38,                        /* AS  */
  YYSYMBOL_ASC = 39,                       /* ASC  */
  YYSYMBOL_ASENSITIVE = 40,                /* ASENSITIVE  */
  YYSYMBOL_ASSERTION = 41,                 /* ASSERTION  */
  YYSYMBOL_ASSIGNMENT = 42,                /* ASSIGNMENT  */
  YYSYMBOL_ASYMMETRIC = 43,                /* ASYMMETRIC  */
  YYSYMBOL_ATOMIC = 44,                    /* ATOMIC  */
  YYSYMBOL_AT = 45,                        /* AT  */
  YYSYMBOL_ATTACH = 46,                    /* ATTACH  */
  YYSYMBOL_ATTRIBUTE = 47,                 /* ATTRIBUTE  */
  YYSYMBOL_AUTHORIZATION = 48,             /* AUTHORIZATION  */
  YYSYMBOL_BACKWARD = 49,                  /* BACKWARD  */
  YYSYMBOL_BEFORE = 50,                    /* BEFORE  */
  YYSYMBOL_BEGIN_P = 51,                   /* BEGIN_P  */
  YYSYMBOL_BETWEEN = 52,                   /* BETWEEN  */
  YYSYMBOL_BIGINT = 53,                    /* BIGINT  */
  YYSYMBOL_BINARY = 54,                    /* BINARY  */
  YYSYMBOL_BIT = 55,                       /* BIT  */
  YYSYMBOL_BOOLEAN_P = 56,                 /* BOOLEAN_P  */
  YYSYMBOL_BOTH = 57,                      /* BOTH  */
  YYSYMBOL_BREADTH = 58,                   /* BREADTH  */
  YYSYMBOL_BY = 59,                        /* BY  */
  YYSYMBOL_CACHE = 60,                     /* CACHE  */
  YYSYMBOL_CALL = 61,                      /* CALL  */
  YYSYMBOL_CALLED = 62,                    /* CALLED  */
  YYSYMBOL_CASCADE = 63,                   /* CASCADE  */
  YYSYMBOL_CASCADED = 64,                  /* CASCADED  */
  YYSYMBOL_CASE = 65,                      /* CASE  */
  YYSYMBOL_CAST = 66,                      /* CAST  */
  YYSYMBOL_CATALOG_P = 67,                 /* CATALOG_P  */
  YYSYMBOL_CHAIN = 68,                     /* CHAIN  */
  YYSYMBOL_CHAR_P = 69,                    /* CHAR_P  */
  YYSYMBOL_CHARACTER = 70,                 /* CHARACTER  */
  YYSYMBOL_CHARACTERISTICS = 71,           /* CHARACTERISTICS  */
  YYSYMBOL_CHECK = 72,                     /* CHECK  */
  YYSYMBOL_CHECKPOINT = 73,                /* CHECKPOINT  */
  YYSYMBOL_CLASS = 74,                     /* CLASS  */
  YYSYMBOL_CLOSE = 75,                     /* CLOSE  */
  YYSYMBOL_CLUSTER = 76,                   /* CLUSTER  */
  YYSYMBOL_COALESCE = 77,                  /* COALESCE  */
  YYSYMBOL_COLLATE = 78,                   /* COLLATE  */
  YYSYMBOL_COLLATION = 79,                 /* COLLATION  */
  YYSYMBOL_COLUMN = 80,                    /* COLUMN  */
  YYSYMBOL_COLUMNS = 81,                   /* COLUMNS  */
  YYSYMBOL_COMMENT = 82,                   /* COMMENT  */
  YYSYMBOL_COMMENTS = 83,                  /* COMMENTS  */
  YYSYMBOL_COMMIT = 84,                    /* COMMIT  */
  YYSYMBOL_COMMITTED = 85,                 /* COMMITTED  */
  YYSYMBOL_COMPRESSION = 86,               /* COMPRESSION  */
  YYSYMBOL_CONCURRENTLY = 87,              /* CONCURRENTLY  */
  YYSYMBOL_CONDITIONAL = 88,               /* CONDITIONAL  */
  YYSYMBOL_CONFIGURATION = 89,             /* CONFIGURATION  */
  YYSYMBOL_CONFLICT = 90,                  /* CONFLICT  */
  YYSYMBOL_CONNECTION = 91,                /* CONNECTION  */
  YYSYMBOL_CONSTRAINT = 92,                /* CONSTRAINT  */
  YYSYMBOL_CONSTRAINTS = 93,               /* CONSTRAINTS  */
  YYSYMBOL_CONTENT_P = 94,                 /* CONTENT_P  */
  YYSYMBOL_CONTINUE_P = 95,                /* CONTINUE_P  */
  YYSYMBOL_CONVERSION_P = 96,              /* CONVERSION_P  */
  YYSYMBOL_COPY = 97,                      /* COPY  */
  YYSYMBOL_COST = 98,                      /* COST  */
  YYSYMBOL_CREATE = 99,                    /* CREATE  */
  YYSYMBOL_CROSS = 100,                    /* CROSS  */
  YYSYMBOL_CSV = 101,                      /* CSV  */
  YYSYMBOL_CUBE = 102,                     /* CUBE  */
  YYSYMBOL_CURRENT_P = 103,                /* CURRENT_P  */
  YYSYMBOL_CURRENT_CATALOG = 104,          /* CURRENT_CATALOG  */
  YYSYMBOL_CURRENT_DATE = 105,             /* CURRENT_DATE  */
  YYSYMBOL_CURRENT_ROLE = 106,             /* CURRENT_ROLE  */
  YYSYMBOL_CURRENT_SCHEMA = 107,           /* CURRENT_SCHEMA  */
  YYSYMBOL_CURRENT_TIME = 108,             /* CURRENT_TIME  */
  YYSYMBOL_CURRENT_TIMESTAMP = 109,        /* CURRENT_TIMESTAMP  */
  YYSYMBOL_CURRENT_USER = 110,             /* CURRENT_USER  */
  YYSYMBOL_CURSOR = 111,                   /* CURSOR  */
  YYSYMBOL_CYCLE = 112,                    /* CYCLE  */
  YYSYMBOL_DATA_P = 113,                   /* DATA_P  */
  YYSYMBOL_DATABASE = 114,                 /* DATABASE  */
  YYSYMBOL_DAY_P = 115,                    /* DAY_P  */
  YYSYMBOL_DEALLOCATE = 116,               /* DEALLOCATE  */
  YYSYMBOL_DEC = 117,                      /* DEC  */
  YYSYMBOL_DECIMAL_P = 118,                /* DECIMAL_P  */
  YYSYMBOL_DECLARE = 119,                  /* DECLARE  */
  YYSYMBOL_DEFAULT = 120,                  /* DEFAULT  */
  YYSYMBOL_DEFAULTS = 121,                 /* DEFAULTS  */
  YYSYMBOL_DEFERRABLE = 122,               /* DEFERRABLE  */
  YYSYMBOL_DEFERRED = 123,                 /* DEFERRED  */
  YYSYMBOL_DEFINER = 124,                  /* DEFINER  */
  YYSYMBOL_DELETE_P = 125,                 /* DELETE_P  */
  YYSYMBOL_DELIMITER = 126,                /* DELIMITER  */
  YYSYMBOL_DELIMITERS = 127,               /* DELIMITERS  */
  YYSYMBOL_DEPENDS = 128,                  /* DEPENDS  */
  YYSYMBOL_DEPTH = 129,                    /* DEPTH  */
  YYSYMBOL_DESC = 130,                     /* DESC  */
  YYSYMBOL_DETACH = 131,                   /* DETACH  */
  YYSYMBOL_DICTIONARY = 132,               /* DICTIONARY  */
  YYSYMBOL_DISABLE_P = 133,                /* DISABLE_P  */
  YYSYMBOL_DISCARD = 134,                  /* DISCARD  */
  YYSYMBOL_DISTINCT = 135,                 /* DISTINCT  */
  YYSYMBOL_DO = 136,                       /* DO  */
  YYSYMBOL_DOCUMENT_P = 137,               /* DOCUMENT_P  */
  YYSYMBOL_DOMAIN_P = 138,                 /* DOMAIN_P  */
  YYSYMBOL_DOUBLE_P = 139,                 /* DOUBLE_P  */
  YYSYMBOL_DROP = 140,                     /* DROP  */
  YYSYMBOL_EACH = 141,                     /* EACH  */
  YYSYMBOL_ELSE = 142,                     /* ELSE  */
  YYSYMBOL_EMPTY_P = 143,                  /* EMPTY_P  */
  YYSYMBOL_ENABLE_P = 144,                 /* ENABLE_P  */
  YYSYMBOL_ENCODING = 145,                 /* ENCODING  */
  YYSYMBOL_ENCRYPTED = 146,                /* ENCRYPTED  */
  YYSYMBOL_END_P = 147,                    /* END_P  */
  YYSYMBOL_ENUM_P = 148,                   /* ENUM_P  */
  YYSYMBOL_ERROR_P = 149,                  /* ERROR_P  */
  YYSYMBOL_ESCAPE = 150,                   /* ESCAPE  */
  YYSYMBOL_EVENT = 151,                    /* EVENT  */
  YYSYMBOL_EXCEPT = 152,                   /* EXCEPT  */
  YYSYMBOL_EXCLUDE = 153,                  /* EXCLUDE  */
  YYSYMBOL_EXCLUDING = 154,                /* EXCLUDING  */
  YYSYMBOL_EXCLUSIVE = 155,                /* EXCLUSIVE  */
  YYSYMBOL_EXECUTE = 156,                  /* EXECUTE  */
  YYSYMBOL_EXISTS = 157,                   /* EXISTS  */
  YYSYMBOL_EXPLAIN = 158,                  /* EXPLAIN  */
  YYSYMBOL_EXPRESSION = 159,               /* EXPRESSION  */
  YYSYMBOL_EXTENSION = 160,                /* EXTENSION  */
  YYSYMBOL_EXTERNAL = 161,                 /* EXTERNAL  */
  YYSYMBOL_EXTRACT = 162,                  /* EXTRACT  */
  YYSYMBOL_FALSE_P = 163,                  /* FALSE_P  */
  YYSYMBOL_FAMILY = 164,                   /* FAMILY  */
  YYSYMBOL_FETCH = 165,                    /* FETCH  */
  YYSYMBOL_FILTER = 166,                   /* FILTER  */
  YYSYMBOL_FINALIZE = 167,                 /* FINALIZE  */
  YYSYMBOL_FIRST_P = 168,                  /* FIRST_P  */
  YYSYMBOL_FLOAT_P = 169,                  /* FLOAT_P  */
  YYSYMBOL_FOLLOWING = 170,                /* FOLLOWING  */
  YYSYMBOL_FOR = 171,                      /* FOR  */
  YYSYMBOL_FORCE = 172,                    /* FORCE  */
  YYSYMBOL_FOREIGN = 173,                  /* FOREIGN  */
  YYSYMBOL_FORMAT = 174,                   /* FORMAT  */
  YYSYMBOL_FORWARD = 175,                  /* FORWARD  */
  YYSYMBOL_FREEZE = 176,                   /* FREEZE  */
  YYSYMBOL_FROM = 177,                     /* FROM  */
  YYSYMBOL_FULL = 178,                     /* FULL  */
  YYSYMBOL_FUNCTION = 179,                 /* FUNCTION  */
  YYSYMBOL_FUNCTIONS = 180,                /* FUNCTIONS  */
  YYSYMBOL_GENERATED = 181,                /* GENERATED  */
  YYSYMBOL_GLOBAL = 182,                   /* GLOBAL  */
  YYSYMBOL_GRANT = 183,                    /* GRANT  */
  YYSYMBOL_GRANTED = 184,                  /* GRANTED  */
  YYSYMBOL_GREATEST = 185,                 /* GREATEST  */
  YYSYMBOL_GROUP_P = 186,                  /* GROUP_P  */
  YYSYMBOL_GROUPING = 187,                 /* GROUPING  */
  YYSYMBOL_GROUPS = 188,                   /* GROUPS  */
  YYSYMBOL_HANDLER = 189,                  /* HANDLER  */
  YYSYMBOL_HAVING = 190,                   /* HAVING  */
  YYSYMBOL_HEADER_P = 191,                 /* HEADER_P  */
  YYSYMBOL_HOLD = 192,                     /* HOLD  */
  YYSYMBOL_HOUR_P = 193,                   /* HOUR_P  */
  YYSYMBOL_IDENTITY_P = 194,               /* IDENTITY_P  */
  YYSYMBOL_IF_P = 195,                     /* IF_P  */
  YYSYMBOL_ILIKE = 196,                    /* ILIKE  */
  YYSYMBOL_IMMEDIATE = 197,                /* IMMEDIATE  */
  YYSYMBOL_IMMUTABLE = 198,                /* IMMUTABLE  */
  YYSYMBOL_IMPLICIT_P = 199,               /* IMPLICIT_P  */
  YYSYMBOL_IMPORT_P = 200,                 /* IMPORT_P  */
  YYSYMBOL_IN_P = 201,                     /* IN_P  */
  YYSYMBOL_INCLUDE = 202,                  /* INCLUDE  */
  YYSYMBOL_INCLUDING = 203,                /* INCLUDING  */
  YYSYMBOL_INCREMENT = 204,                /* INCREMENT  */
  YYSYMBOL_INDEX = 205,                    /* INDEX  */
  YYSYMBOL_INDEXES = 206,                  /* INDEXES  */
  YYSYMBOL_INHERIT = 207,                  /* INHERIT  */
  YYSYMBOL_INHERITS = 208,                 /* INHERITS  */
  YYSYMBOL_INITIALLY = 209,                /* INITIALLY  */
  YYSYMBOL_INLINE_P = 210,                 /* INLINE_P  */
  YYSYMBOL_INNER_P = 211,                  /* INNER_P  */
  YYSYMBOL_INOUT = 212,                    /* INOUT  */
  YYSYMBOL_INPUT_P = 213,                  /* INPUT_P  */
  YYSYMBOL_INSENSITIVE = 214,              /* INSENSITIVE  */
  YYSYMBOL_INSERT = 215,                   /* INSERT  */
  YYSYMBOL_INSTEAD = 216,                  /* INSTEAD  */
  YYSYMBOL_INT_P = 217,                    /* INT_P  */
  YYSYMBOL_INTEGER = 218,                  /* INTEGER  */
  YYSYMBOL_INTERSECT = 219,                /* INTERSECT  */
  YYSYMBOL_INTERVAL = 220,                 /* INTERVAL  */
  YYSYMBOL_INTO = 221,                     /* INTO  */
  YYSYMBOL_INVOKER = 222,                  /* INVOKER  */
  YYSYMBOL_IS = 223,                       /* IS  */
  YYSYMBOL_ISNULL = 224,                   /* ISNULL  */
  YYSYMBOL_ISOLATION = 225,                /* ISOLATION  */
  YYSYMBOL_JOIN = 226,                     /* JOIN  */
  YYSYMBOL_JSON = 227,                     /* JSON  */
  YYSYMBOL_JSON_ARRAY = 228,               /* JSON_ARRAY  */
  YYSYMBOL_JSON_ARRAYAGG = 229,            /* JSON_ARRAYAGG  */
  YYSYMBOL_JSON_EXISTS = 230,              /* JSON_EXISTS  */
  YYSYMBOL_JSON_OBJECT = 231,              /* JSON_OBJECT  */
  YYSYMBOL_JSON_OBJECTAGG = 232,           /* JSON_OBJECTAGG  */
  YYSYMBOL_JSON_QUERY = 233,               /* JSON_QUERY  */
  YYSYMBOL_JSON_SCALAR = 234,              /* JSON_SCALAR  */
  YYSYMBOL_JSON_SERIALIZE = 235,           /* JSON_SERIALIZE  */
  YYSYMBOL_JSON_TABLE = 236,               /* JSON_TABLE  */
  YYSYMBOL_JSON_VALUE = 237,               /* JSON_VALUE  */
  YYSYMBOL_KEY = 238,                      /* KEY  */
  YYSYMBOL_KEYS = 239,                     /* KEYS  */
  YYSYMBOL_KEEP = 240,                     /* KEEP  */
  YYSYMBOL_LABEL = 241,                    /* LABEL  */
  YYSYMBOL_LANGUAGE = 242,                 /* LANGUAGE  */
  YYSYMBOL_LARGE_P = 243,                  /* LARGE_P  */
  YYSYMBOL_LAST_P = 244,                   /* LAST_P  */
  YYSYMBOL_LATERAL_P = 245,                /* LATERAL_P  */
  YYSYMBOL_LEADING = 246,                  /* LEADING  */
  YYSYMBOL_LEAKPROOF = 247,                /* LEAKPROOF  */
  YYSYMBOL_LEAST = 248,                    /* LEAST  */
  YYSYMBOL_LEFT = 249,                     /* LEFT  */
  YYSYMBOL_LEVEL = 250,                    /* LEVEL  */
  YYSYMBOL_LIKE = 251,                     /* LIKE  */
  YYSYMBOL_LIMIT = 252,                    /* LIMIT  */
  YYSYMBOL_LISTEN = 253,                   /* LISTEN  */
  YYSYMBOL_LOAD = 254,                     /* LOAD  */
  YYSYMBOL_LOCAL = 255,                    /* LOCAL  */
  YYSYMBOL_LOCALTIME = 256,                /* LOCALTIME  */
  YYSYMBOL_LOCALTIMESTAMP = 257,           /* LOCALTIMESTAMP  */
  YYSYMBOL_LOCATION = 258,                 /* LOCATION  */
  YYSYMBOL_LOCK_P = 259,                   /* LOCK_P  */
  YYSYMBOL_LOCKED = 260,                   /* LOCKED  */
  YYSYMBOL_LOGGED = 261,                   /* LOGGED  */
  YYSYMBOL_MAPPING = 262,                  /* MAPPING  */
  YYSYMBOL_MATCH = 263,                    /* MATCH  */
  YYSYMBOL_MATCHED = 264,                  /* MATCHED  */
  YYSYMBOL_MATERIALIZED = 265,             /* MATERIALIZED  */
  YYSYMBOL_MAXVALUE = 266,                 /* MAXVALUE  */
  YYSYMBOL_MERGE = 267,                    /* MERGE  */
  YYSYMBOL_METHOD = 268,                   /* METHOD  */
  YYSYMBOL_MINUTE_P = 269,                 /* MINUTE_P  */
  YYSYMBOL_MINVALUE = 270,                 /* MINVALUE  */
  YYSYMBOL_MODE = 271,                     /* MODE  */
  YYSYMBOL_MONTH_P = 272,                  /* MONTH_P  */
  YYSYMBOL_MOVE = 273,                     /* MOVE  */
  YYSYMBOL_NAME_P = 274,                   /* NAME_P  */
  YYSYMBOL_NAMES = 275,                    /* NAMES  */
  YYSYMBOL_NATIONAL = 276,                 /* NATIONAL  */
  YYSYMBOL_NATURAL = 277,                  /* NATURAL  */
  YYSYMBOL_NCHAR = 278,                    /* NCHAR  */
  YYSYMBOL_NESTED = 279,                   /* NESTED  */
  YYSYMBOL_NEW = 280,                      /* NEW  */
  YYSYMBOL_NEXT = 281,                     /* NEXT  */
  YYSYMBOL_NFC = 282,                      /* NFC  */
  YYSYMBOL_NFD = 283,                      /* NFD  */
  YYSYMBOL_NFKC = 284,                     /* NFKC  */
  YYSYMBOL_NFKD = 285,                     /* NFKD  */
  YYSYMBOL_NO = 286,                       /* NO  */
  YYSYMBOL_NONE = 287,                     /* NONE  */
  YYSYMBOL_NORMALIZE = 288,                /* NORMALIZE  */
  YYSYMBOL_NORMALIZED = 289,               /* NORMALIZED  */
  YYSYMBOL_NOT = 290,                      /* NOT  */
  YYSYMBOL_NOTHING = 291,                  /* NOTHING  */
  YYSYMBOL_NOTIFY = 292,                   /* NOTIFY  */
  YYSYMBOL_NOTNULL = 293,                  /* NOTNULL  */
  YYSYMBOL_NOWAIT = 294,                   /* NOWAIT  */
  YYSYMBOL_NULL_P = 295,                   /* NULL_P  */
  YYSYMBOL_NULLIF = 296,                   /* NULLIF  */
  YYSYMBOL_NULLS_P = 297,                  /* NULLS_P  */
  YYSYMBOL_NUMERIC = 298,                  /* NUMERIC  */
  YYSYMBOL_OBJECT_P = 299,                 /* OBJECT_P  */
  YYSYMBOL_OF = 300,                       /* OF  */
  YYSYMBOL_OFF = 301,                      /* OFF  */
  YYSYMBOL_OFFSET = 302,                   /* OFFSET  */
  YYSYMBOL_OIDS = 303,                     /* OIDS  */
  YYSYMBOL_OLD = 304,                      /* OLD  */
  YYSYMBOL_OMIT = 305,                     /* OMIT  */
  YYSYMBOL_ON = 306,                       /* ON  */
  YYSYMBOL_ONLY = 307,                     /* ONLY  */
  YYSYMBOL_OPERATOR = 308,                 /* OPERATOR  */
  YYSYMBOL_OPTION = 309,                   /* OPTION  */
  YYSYMBOL_OPTIONS = 310,                  /* OPTIONS  */
  YYSYMBOL_OR = 311,                       /* OR  */
  YYSYMBOL_ORDER = 312,                    /* ORDER  */
  YYSYMBOL_ORDINALITY = 313,               /* ORDINALITY  */
  YYSYMBOL_OTHERS = 314,                   /* OTHERS  */
  YYSYMBOL_OUT_P = 315,                    /* OUT_P  */
  YYSYMBOL_OUTER_P = 316,                  /* OUTER_P  */
  YYSYMBOL_OVER = 317,                     /* OVER  */
  YYSYMBOL_OVERLAPS = 318,                 /* OVERLAPS  */
  YYSYMBOL_OVERLAY = 319,                  /* OVERLAY  */
  YYSYMBOL_OVERRIDING = 320,               /* OVERRIDING  */
  YYSYMBOL_OWNED = 321,                    /* OWNED  */
  YYSYMBOL_OWNER = 322,                    /* OWNER  */
  YYSYMBOL_PARALLEL = 323,                 /* PARALLEL  */
  YYSYMBOL_PARAMETER = 324,                /* PARAMETER  */
  YYSYMBOL_PARSER = 325,                   /* PARSER  */
  YYSYMBOL_PARTIAL = 326,                  /* PARTIAL  */
  YYSYMBOL_PARTITION = 327,                /* PARTITION  */
  YYSYMBOL_PASSING = 328,                  /* PASSING  */
  YYSYMBOL_PASSWORD = 329,                 /* PASSWORD  */
  YYSYMBOL_PATH = 330,                     /* PATH  */
  YYSYMBOL_PLACING = 331,                  /* PLACING  */
  YYSYMBOL_PLAN = 332,                     /* PLAN  */
  YYSYMBOL_PLANS = 333,                    /* PLANS  */
  YYSYMBOL_POLICY = 334,                   /* POLICY  */
  YYSYMBOL_POSITION = 335,                 /* POSITION  */
  YYSYMBOL_PRECEDING = 336,                /* PRECEDING  */
  YYSYMBOL_PRECISION = 337,                /* PRECISION  */
  YYSYMBOL_PRESERVE = 338,                 /* PRESERVE  */
  YYSYMBOL_PREPARE = 339,                  /* PREPARE  */
  YYSYMBOL_PREPARED = 340,                 /* PREPARED  */
  YYSYMBOL_PRIMARY = 341,                  /* PRIMARY  */
  YYSYMBOL_PRIOR = 342,                    /* PRIOR  */
  YYSYMBOL_PRIVILEGES = 343,               /* PRIVILEGES  */
  YYSYMBOL_PROCEDURAL = 344,               /* PROCEDURAL  */
  YYSYMBOL_PROCEDURE = 345,                /* PROCEDURE  */
  YYSYMBOL_PROCEDURES = 346,               /* PROCEDURES  */
  YYSYMBOL_PROGRAM = 347,                  /* PROGRAM  */
  YYSYMBOL_PUBLICATION = 348,              /* PUBLICATION  */
  YYSYMBOL_QUOTE = 349,                    /* QUOTE  */
  YYSYMBOL_QUOTES = 350,                   /* QUOTES  */
  YYSYMBOL_RANGE = 351,                    /* RANGE  */
  YYSYMBOL_READ = 352,                     /* READ  */
  YYSYMBOL_REAL = 353,                     /* REAL  */
  YYSYMBOL_REASSIGN = 354,                 /* REASSIGN  */
  YYSYMBOL_RECHECK = 355,                  /* RECHECK  */
  YYSYMBOL_RECURSIVE = 356,                /* RECURSIVE  */
  YYSYMBOL_REF = 357,                      /* REF  */
  YYSYMBOL_REFERENCES = 358,               /* REFERENCES  */
  YYSYMBOL_REFERENCING = 359,              /* REFERENCING  */
  YYSYMBOL_REFRESH = 360,                  /* REFRESH  */
  YYSYMBOL_REINDEX = 361,                  /* REINDEX  */
  YYSYMBOL_RELATIVE_P = 362,               /* RELATIVE_P  */
  YYSYMBOL_RELEASE = 363,                  /* RELEASE  */
  YYSYMBOL_RENAME = 364,                   /* RENAME  */
  YYSYMBOL_REPEATABLE = 365,               /* REPEATABLE  */
  YYSYMBOL_REPLACE = 366,                  /* REPLACE  */
  YYSYMBOL_REPLICA = 367,                  /* REPLICA  */
  YYSYMBOL_RESET = 368,                    /* RESET  */
  YYSYMBOL_RESTART = 369,                  /* RESTART  */
  YYSYMBOL_RESTRICT = 370,                 /* RESTRICT  */
  YYSYMBOL_RETURN = 371,                   /* RETURN  */
  YYSYMBOL_RETURNING = 372,                /* RETURNING  */
  YYSYMBOL_RETURNS = 373,                  /* RETURNS  */
  YYSYMBOL_REVOKE = 374,                   /* REVOKE  */
  YYSYMBOL_RIGHT = 375,                    /* RIGHT  */
  YYSYMBOL_ROLE = 376,                     /* ROLE  */
  YYSYMBOL_ROLLBACK = 377,                 /* ROLLBACK  */
  YYSYMBOL_ROLLUP = 378,                   /* ROLLUP  */
  YYSYMBOL_ROUTINE = 379,                  /* ROUTINE  */
  YYSYMBOL_ROUTINES = 380,                 /* ROUTINES  */
  YYSYMBOL_ROW = 381,                      /* ROW  */
  YYSYMBOL_ROWS = 382,                     /* ROWS  */
  YYSYMBOL_RULE = 383,                     /* RULE  */
  YYSYMBOL_SAVEPOINT = 384,                /* SAVEPOINT  */
  YYSYMBOL_SCALAR = 385,                   /* SCALAR  */
  YYSYMBOL_SCHEMA = 386,                   /* SCHEMA  */
  YYSYMBOL_SCHEMAS = 387,                  /* SCHEMAS  */
  YYSYMBOL_SCROLL = 388,                   /* SCROLL  */
  YYSYMBOL_SEARCH = 389,                   /* SEARCH  */
  YYSYMBOL_SECOND_P = 390,                 /* SECOND_P  */
  YYSYMBOL_SECURITY = 391,                 /* SECURITY  */
  YYSYMBOL_SELECT = 392,                   /* SELECT  */
  YYSYMBOL_SEQUENCE = 393,                 /* SEQUENCE  */
  YYSYMBOL_SEQUENCES = 394,                /* SEQUENCES  */
  YYSYMBOL_SERIALIZABLE = 395,             /* SERIALIZABLE  */
  YYSYMBOL_SERVER = 396,                   /* SERVER  */
  YYSYMBOL_SESSION = 397,                  /* SESSION  */
  YYSYMBOL_SESSION_USER = 398,             /* SESSION_USER  */
  YYSYMBOL_SET = 399,                      /* SET  */
  YYSYMBOL_SETS = 400,                     /* SETS  */
  YYSYMBOL_SETOF = 401,                    /* SETOF  */
  YYSYMBOL_SHARE = 402,                    /* SHARE  */
  YYSYMBOL_SHOW = 403,                     /* SHOW  */
  YYSYMBOL_SIMILAR = 404,                  /* SIMILAR  */
  YYSYMBOL_SIMPLE = 405,                   /* SIMPLE  */
  YYSYMBOL_SKIP = 406,                     /* SKIP  */
  YYSYMBOL_SMALLINT = 407,                 /* SMALLINT  */
  YYSYMBOL_SNAPSHOT = 408,                 /* SNAPSHOT  */
  YYSYMBOL_SOME = 409,                     /* SOME  */
  YYSYMBOL_SQL_P = 410,                    /* SQL_P  */
  YYSYMBOL_STABLE = 411,                   /* STABLE  */
  YYSYMBOL_STANDALONE_P = 412,             /* STANDALONE_P  */
  YYSYMBOL_START = 413,                    /* START  */
  YYSYMBOL_STATEMENT = 414,                /* STATEMENT  */
  YYSYMBOL_STATISTICS = 415,               /* STATISTICS  */
  YYSYMBOL_STDIN = 416,                    /* STDIN  */
  YYSYMBOL_STDOUT = 417,                   /* STDOUT  */
  YYSYMBOL_STORAGE = 418,                  /* STORAGE  */
  YYSYMBOL_STORED = 419,                   /* STORED  */
  YYSYMBOL_STRICT_P = 420,                 /* STRICT_P  */
  YYSYMBOL_STRING = 421,                   /* STRING  */
  YYSYMBOL_STRIP_P = 422,                  /* STRIP_P  */
  YYSYMBOL_SUBSCRIPTION = 423,             /* SUBSCRIPTION  */
  YYSYMBOL_SUBSTRING = 424,                /* SUBSTRING  */
  YYSYMBOL_SUPPORT = 425,                  /* SUPPORT  */
  YYSYMBOL_SYMMETRIC = 426,                /* SYMMETRIC  */
  YYSYMBOL_SYSID = 427,                    /* SYSID  */
  YYSYMBOL_SYSTEM_P = 428,                 /* SYSTEM_P  */
  YYSYMBOL_TABLE = 429,                    /* TABLE  */
  YYSYMBOL_TABLES = 430,                   /* TABLES  */
  YYSYMBOL_TABLESAMPLE = 431,              /* TABLESAMPLE  */
  YYSYMBOL_TABLESPACE = 432,               /* TABLESPACE  */
  YYSYMBOL_TEMP = 433,                     /* TEMP  */
  YYSYMBOL_TEMPLATE = 434,                 /* TEMPLATE  */
  YYSYMBOL_TEMPORARY = 435,                /* TEMPORARY  */
  YYSYMBOL_TEXT_P = 436,                   /* TEXT_P  */
  YYSYMBOL_THEN = 437,                     /* THEN  */
  YYSYMBOL_TIES = 438,                     /* TIES  */
  YYSYMBOL_TIME = 439,                     /* TIME  */
  YYSYMBOL_TIMESTAMP = 440,                /* TIMESTAMP  */
  YYSYMBOL_TO = 441,                       /* TO  */
  YYSYMBOL_TRAILING = 442,                 /* TRAILING  */
  YYSYMBOL_TRANSACTION = 443,              /* TRANSACTION  */
  YYSYMBOL_TRANSFORM = 444,                /* TRANSFORM  */
  YYSYMBOL_TREAT = 445,                    /* TREAT  */
  YYSYMBOL_TRIGGER = 446,                  /* TRIGGER  */
  YYSYMBOL_TRIM = 447,                     /* TRIM  */
  YYSYMBOL_TRUE_P = 448,                   /* TRUE_P  */
  YYSYMBOL_TRUNCATE = 449,                 /* TRUNCATE  */
  YYSYMBOL_TRUSTED = 450,                  /* TRUSTED  */
  YYSYMBOL_TYPE_P = 451,                   /* TYPE_P  */
  YYSYMBOL_TYPES_P = 452,                  /* TYPES_P  */
  YYSYMBOL_UESCAPE = 453,                  /* UESCAPE  */
  YYSYMBOL_UNBOUNDED = 454,                /* UNBOUNDED  */
  YYSYMBOL_UNCONDITIONAL = 455,            /* UNCONDITIONAL  */
  YYSYMBOL_UNCOMMITTED = 456,              /* UNCOMMITTED  */
  YYSYMBOL_UNENCRYPTED = 457,              /* UNENCRYPTED  */
  YYSYMBOL_UNION = 458,                    /* UNION  */
  YYSYMBOL_UNIQUE = 459,                   /* UNIQUE  */
  YYSYMBOL_UNKNOWN = 460,                  /* UNKNOWN  */
  YYSYMBOL_UNLISTEN = 461,                 /* UNLISTEN  */
  YYSYMBOL_UNLOGGED = 462,                 /* UNLOGGED  */
  YYSYMBOL_UNTIL = 463,                    /* UNTIL  */
  YYSYMBOL_UPDATE = 464,                   /* UPDATE  */
  YYSYMBOL_USER = 465,                     /* USER  */
  YYSYMBOL_USING = 466,                    /* USING  */
  YYSYMBOL_VACUUM = 467,                   /* VACUUM  */
  YYSYMBOL_VALID = 468,                    /* VALID  */
  YYSYMBOL_VALIDATE = 469,                 /* VALIDATE  */
  YYSYMBOL_VALIDATOR = 470,                /* VALIDATOR  */
  YYSYMBOL_VALUE_P = 471,                  /* VALUE_P  */
  YYSYMBOL_VALUES = 472,                   /* VALUES  */
  YYSYMBOL_VARCHAR = 473,                  /* VARCHAR  */
  YYSYMBOL_VARIADIC = 474,                 /* VARIADIC  */
  YYSYMBOL_VARYING = 475,                  /* VARYING  */
  YYSYMBOL_VERBOSE = 476,                  /* VERBOSE  */
  YYSYMBOL_VERSION_P = 477,                /* VERSION_P  */
  YYSYMBOL_VIEW = 478,                     /* VIEW  */
  YYSYMBOL_VIEWS = 479,                    /* VIEWS  */
  YYSYMBOL_VOLATILE = 480,                 /* VOLATILE  */
  YYSYMBOL_WHEN = 481,                     /* WHEN  */
  YYSYMBOL_WHERE = 482,                    /* WHERE  */
  YYSYMBOL_WHITESPACE_P = 483,             /* WHITESPACE_P  */
  YYSYMBOL_WINDOW = 484,                   /* WINDOW  */
  YYSYMBOL_WITH = 485,                     /* WITH  */
  YYSYMBOL_WITHIN = 486,                   /* WITHIN  */
  YYSYMBOL_WITHOUT = 487,                  /* WITHOUT  */
  YYSYMBOL_WORK = 488,                     /* WORK  */
  YYSYMBOL_WRAPPER = 489,                  /* WRAPPER  */
  YYSYMBOL_WRITE = 490,                    /* WRITE  */
  YYSYMBOL_XML_P = 491,                    /* XML_P  */
  YYSYMBOL_XMLATTRIBUTES = 492,            /* XMLATTRIBUTES  */
  YYSYMBOL_XMLCONCAT = 493,                /* XMLCONCAT  */
  YYSYMBOL_XMLELEMENT = 494,               /* XMLELEMENT  */
  YYSYMBOL_XMLEXISTS = 495,                /* XMLEXISTS  */
  YYSYMBOL_XMLFOREST = 496,                /* XMLFOREST  */
  YYSYMBOL_XMLNAMESPACES = 497,            /* XMLNAMESPACES  */
  YYSYMBOL_XMLPARSE = 498,                 /* XMLPARSE  */
  YYSYMBOL_XMLPI = 499,                    /* XMLPI  */
  YYSYMBOL_XMLROOT = 500,                  /* XMLROOT  */
  YYSYMBOL_XMLSERIALIZE = 501,             /* XMLSERIALIZE  */
  YYSYMBOL_XMLTABLE = 502,                 /* XMLTABLE  */
  YYSYMBOL_YEAR_P = 503,                   /* YEAR_P  */
  YYSYMBOL_YES_P = 504,                    /* YES_P  */
  YYSYMBOL_ZONE = 505,                     /* ZONE  */
  YYSYMBOL_NOT_LA = 506,                   /* NOT_LA  */
  YYSYMBOL_NULLS_LA = 507,                 /* NULLS_LA  */
  YYSYMBOL_WITH_LA = 508,                  /* WITH_LA  */
  YYSYMBOL_WITH_LA_UNIQUE = 509,           /* WITH_LA_UNIQUE  */
  YYSYMBOL_WITHOUT_LA = 510,               /* WITHOUT_LA  */
  YYSYMBOL_MODE_TYPE_NAME = 511,           /* MODE_TYPE_NAME  */
  YYSYMBOL_MODE_PLPGSQL_EXPR = 512,        /* MODE_PLPGSQL_EXPR  */
  YYSYMBOL_MODE_PLPGSQL_ASSIGN1 = 513,     /* MODE_PLPGSQL_ASSIGN1  */
  YYSYMBOL_MODE_PLPGSQL_ASSIGN2 = 514,     /* MODE_PLPGSQL_ASSIGN2  */
  YYSYMBOL_MODE_PLPGSQL_ASSIGN3 = 515,     /* MODE_PLPGSQL_ASSIGN3  */
  YYSYMBOL_516_ = 516,                     /* '<'  */
  YYSYMBOL_517_ = 517,                     /* '>'  */
  YYSYMBOL_518_ = 518,                     /* '='  */
  YYSYMBOL_519_ = 519,                     /* '+'  */
  YYSYMBOL_520_ = 520,                     /* '-'  */
  YYSYMBOL_521_ = 521,                     /* '*'  */
  YYSYMBOL_522_ = 522,                     /* '/'  */
  YYSYMBOL_523_ = 523,                     /* '%'  */
  YYSYMBOL_524_ = 524,                     /* '^'  */
  YYSYMBOL_UMINUS = 525,                   /* UMINUS  */
  YYSYMBOL_526_ = 526,                     /* '['  */
  YYSYMBOL_527_ = 527,                     /* ']'  */
  YYSYMBOL_528_ = 528,                     /* '('  */
  YYSYMBOL_529_ = 529,                     /* ')'  */
  YYSYMBOL_530_ = 530,                     /* '.'  */
  YYSYMBOL_json_table_column = 531,        /* json_table_column  */
  YYSYMBOL_empty_json_unique = 532,        /* empty_json_unique  */
  YYSYMBOL_533_ = 533,                     /* ';'  */
  YYSYMBOL_534_ = 534,                     /* ','  */
  YYSYMBOL_535_ = 535,                     /* ':'  */
  YYSYMBOL_YYACCEPT = 536,                 /* $accept  */
  YYSYMBOL_parse_toplevel = 537,           /* parse_toplevel  */
  YYSYMBOL_stmtmulti = 538,                /* stmtmulti  */
  YYSYMBOL_toplevel_stmt = 539,            /* toplevel_stmt  */
  YYSYMBOL_stmt = 540,                     /* stmt  */
  YYSYMBOL_CallStmt = 541,                 /* CallStmt  */
  YYSYMBOL_CreateRoleStmt = 542,           /* CreateRoleStmt  */
  YYSYMBOL_opt_with = 543,                 /* opt_with  */
  YYSYMBOL_OptRoleList = 544,              /* OptRoleList  */
  YYSYMBOL_AlterOptRoleList = 545,         /* AlterOptRoleList  */
  YYSYMBOL_AlterOptRoleElem = 546,         /* AlterOptRoleElem  */
  YYSYMBOL_CreateOptRoleElem = 547,        /* CreateOptRoleElem  */
  YYSYMBOL_CreateUserStmt = 548,           /* CreateUserStmt  */
  YYSYMBOL_AlterRoleStmt = 549,            /* AlterRoleStmt  */
  YYSYMBOL_opt_in_database = 550,          /* opt_in_database  */
  YYSYMBOL_AlterRoleSetStmt = 551,         /* AlterRoleSetStmt  */
  YYSYMBOL_DropRoleStmt = 552,             /* DropRoleStmt  */
  YYSYMBOL_CreateGroupStmt = 553,          /* CreateGroupStmt  */
  YYSYMBOL_AlterGroupStmt = 554,           /* AlterGroupStmt  */
  YYSYMBOL_add_drop = 555,                 /* add_drop  */
  YYSYMBOL_CreateSchemaStmt = 556,         /* CreateSchemaStmt  */
  YYSYMBOL_OptSchemaName = 557,            /* OptSchemaName  */
  YYSYMBOL_OptSchemaEltList = 558,         /* OptSchemaEltList  */
  YYSYMBOL_schema_stmt = 559,              /* schema_stmt  */
  YYSYMBOL_VariableSetStmt = 560,          /* VariableSetStmt  */
  YYSYMBOL_set_rest = 561,                 /* set_rest  */
  YYSYMBOL_generic_set = 562,              /* generic_set  */
  YYSYMBOL_set_rest_more = 563,            /* set_rest_more  */
  YYSYMBOL_var_name = 564,                 /* var_name  */
  YYSYMBOL_var_list = 565,                 /* var_list  */
  YYSYMBOL_var_value = 566,                /* var_value  */
  YYSYMBOL_iso_level = 567,                /* iso_level  */
  YYSYMBOL_opt_boolean_or_string = 568,    /* opt_boolean_or_string  */
  YYSYMBOL_zone_value = 569,               /* zone_value  */
  YYSYMBOL_opt_encoding = 570,             /* opt_encoding  */
  YYSYMBOL_NonReservedWord_or_Sconst = 571, /* NonReservedWord_or_Sconst  */
  YYSYMBOL_VariableResetStmt = 572,        /* VariableResetStmt  */
  YYSYMBOL_reset_rest = 573,               /* reset_rest  */
  YYSYMBOL_generic_reset = 574,            /* generic_reset  */
  YYSYMBOL_SetResetClause = 575,           /* SetResetClause  */
  YYSYMBOL_FunctionSetResetClause = 576,   /* FunctionSetResetClause  */
  YYSYMBOL_VariableShowStmt = 577,         /* VariableShowStmt  */
  YYSYMBOL_ConstraintsSetStmt = 578,       /* ConstraintsSetStmt  */
  YYSYMBOL_constraints_set_list = 579,     /* constraints_set_list  */
  YYSYMBOL_constraints_set_mode = 580,     /* constraints_set_mode  */
  YYSYMBOL_CheckPointStmt = 581,           /* CheckPointStmt  */
  YYSYMBOL_DiscardStmt = 582,              /* DiscardStmt  */
  YYSYMBOL_AlterTableStmt = 583,           /* AlterTableStmt  */
  YYSYMBOL_alter_table_cmds = 584,         /* alter_table_cmds  */
  YYSYMBOL_partition_cmd = 585,            /* partition_cmd  */
  YYSYMBOL_index_partition_cmd = 586,      /* index_partition_cmd  */
  YYSYMBOL_alter_table_cmd = 587,          /* alter_table_cmd  */
  YYSYMBOL_alter_column_default = 588,     /* alter_column_default  */
  YYSYMBOL_opt_drop_behavior = 589,        /* opt_drop_behavior  */
  YYSYMBOL_opt_collate_clause = 590,       /* opt_collate_clause  */
  YYSYMBOL_alter_using = 591,              /* alter_using  */
  YYSYMBOL_replica_identity = 592,         /* replica_identity  */
  YYSYMBOL_reloptions = 593,               /* reloptions  */
  YYSYMBOL_opt_reloptions = 594,           /* opt_reloptions  */
  YYSYMBOL_reloption_list = 595,           /* reloption_list  */
  YYSYMBOL_reloption_elem = 596,           /* reloption_elem  */
  YYSYMBOL_alter_identity_column_option_list = 597, /* alter_identity_column_option_list  */
  YYSYMBOL_alter_identity_column_option = 598, /* alter_identity_column_option  */
  YYSYMBOL_PartitionBoundSpec = 599,       /* PartitionBoundSpec  */
  YYSYMBOL_hash_partbound_elem = 600,      /* hash_partbound_elem  */
  YYSYMBOL_hash_partbound = 601,           /* hash_partbound  */
  YYSYMBOL_AlterCompositeTypeStmt = 602,   /* AlterCompositeTypeStmt  */
  YYSYMBOL_alter_type_cmds = 603,          /* alter_type_cmds  */
  YYSYMBOL_alter_type_cmd = 604,           /* alter_type_cmd  */
  YYSYMBOL_ClosePortalStmt = 605,          /* ClosePortalStmt  */
  YYSYMBOL_CopyStmt = 606,                 /* CopyStmt  */
  YYSYMBOL_copy_from = 607,                /* copy_from  */
  YYSYMBOL_opt_program = 608,              /* opt_program  */
  YYSYMBOL_copy_file_name = 609,           /* copy_file_name  */
  YYSYMBOL_copy_options = 610,             /* copy_options  */
  YYSYMBOL_copy_opt_list = 611,            /* copy_opt_list  */
  YYSYMBOL_copy_opt_item = 612,            /* copy_opt_item  */
  YYSYMBOL_opt_binary = 613,               /* opt_binary  */
  YYSYMBOL_copy_delimiter = 614,           /* copy_delimiter  */
  YYSYMBOL_opt_using = 615,                /* opt_using  */
  YYSYMBOL_copy_generic_opt_list = 616,    /* copy_generic_opt_list  */
  YYSYMBOL_copy_generic_opt_elem = 617,    /* copy_generic_opt_elem  */
  YYSYMBOL_copy_generic_opt_arg = 618,     /* copy_generic_opt_arg  */
  YYSYMBOL_copy_generic_opt_arg_list = 619, /* copy_generic_opt_arg_list  */
  YYSYMBOL_copy_generic_opt_arg_list_item = 620, /* copy_generic_opt_arg_list_item  */
  YYSYMBOL_CreateStmt = 621,               /* CreateStmt  */
  YYSYMBOL_OptTemp = 622,                  /* OptTemp  */
  YYSYMBOL_OptTableElementList = 623,      /* OptTableElementList  */
  YYSYMBOL_OptTypedTableElementList = 624, /* OptTypedTableElementList  */
  YYSYMBOL_TableElementList = 625,         /* TableElementList  */
  YYSYMBOL_TypedTableElementList = 626,    /* TypedTableElementList  */
  YYSYMBOL_TableElement = 627,             /* TableElement  */
  YYSYMBOL_TypedTableElement = 628,        /* TypedTableElement  */
  YYSYMBOL_columnDef = 629,                /* columnDef  */
  YYSYMBOL_columnOptions = 630,            /* columnOptions  */
  YYSYMBOL_column_compression = 631,       /* column_compression  */
  YYSYMBOL_opt_column_compression = 632,   /* opt_column_compression  */
  YYSYMBOL_ColQualList = 633,              /* ColQualList  */
  YYSYMBOL_ColConstraint = 634,            /* ColConstraint  */
  YYSYMBOL_ColConstraintElem = 635,        /* ColConstraintElem  */
  YYSYMBOL_opt_unique_null_treatment = 636, /* opt_unique_null_treatment  */
  YYSYMBOL_generated_when = 637,           /* generated_when  */
  YYSYMBOL_ConstraintAttr = 638,           /* ConstraintAttr  */
  YYSYMBOL_TableLikeClause = 639,          /* TableLikeClause  */
  YYSYMBOL_TableLikeOptionList = 640,      /* TableLikeOptionList  */
  YYSYMBOL_TableLikeOption = 641,          /* TableLikeOption  */
  YYSYMBOL_TableConstraint = 642,          /* TableConstraint  */
  YYSYMBOL_ConstraintElem = 643,           /* ConstraintElem  */
  YYSYMBOL_opt_no_inherit = 644,           /* opt_no_inherit  */
  YYSYMBOL_opt_column_list = 645,          /* opt_column_list  */
  YYSYMBOL_columnList = 646,               /* columnList  */
  YYSYMBOL_columnElem = 647,               /* columnElem  */
  YYSYMBOL_opt_c_include = 648,            /* opt_c_include  */
  YYSYMBOL_key_match = 649,                /* key_match  */
  YYSYMBOL_ExclusionConstraintList = 650,  /* ExclusionConstraintList  */
  YYSYMBOL_ExclusionConstraintElem = 651,  /* ExclusionConstraintElem  */
  YYSYMBOL_OptWhereClause = 652,           /* OptWhereClause  */
  YYSYMBOL_key_actions = 653,              /* key_actions  */
  YYSYMBOL_key_update = 654,               /* key_update  */
  YYSYMBOL_key_delete = 655,               /* key_delete  */
  YYSYMBOL_key_action = 656,               /* key_action  */
  YYSYMBOL_OptInherit = 657,               /* OptInherit  */
  YYSYMBOL_OptPartitionSpec = 658,         /* OptPartitionSpec  */
  YYSYMBOL_PartitionSpec = 659,            /* PartitionSpec  */
  YYSYMBOL_part_params = 660,              /* part_params  */
  YYSYMBOL_part_elem = 661,                /* part_elem  */
  YYSYMBOL_table_access_method_clause = 662, /* table_access_method_clause  */
  YYSYMBOL_OptWith = 663,                  /* OptWith  */
  YYSYMBOL_OnCommitOption = 664,           /* OnCommitOption  */
  YYSYMBOL_OptTableSpace = 665,            /* OptTableSpace  */
  YYSYMBOL_OptConsTableSpace = 666,        /* OptConsTableSpace  */
  YYSYMBOL_ExistingIndex = 667,            /* ExistingIndex  */
  YYSYMBOL_CreateStatsStmt = 668,          /* CreateStatsStmt  */
  YYSYMBOL_stats_params = 669,             /* stats_params  */
  YYSYMBOL_stats_param = 670,              /* stats_param  */
  YYSYMBOL_AlterStatsStmt = 671,           /* AlterStatsStmt  */
  YYSYMBOL_CreateAsStmt = 672,             /* CreateAsStmt  */
  YYSYMBOL_create_as_target = 673,         /* create_as_target  */
  YYSYMBOL_opt_with_data = 674,            /* opt_with_data  */
  YYSYMBOL_CreateMatViewStmt = 675,        /* CreateMatViewStmt  */
  YYSYMBOL_create_mv_target = 676,         /* create_mv_target  */
  YYSYMBOL_OptNoLog = 677,                 /* OptNoLog  */
  YYSYMBOL_RefreshMatViewStmt = 678,       /* RefreshMatViewStmt  */
  YYSYMBOL_CreateSeqStmt = 679,            /* CreateSeqStmt  */
  YYSYMBOL_AlterSeqStmt = 680,             /* AlterSeqStmt  */
  YYSYMBOL_OptSeqOptList = 681,            /* OptSeqOptList  */
  YYSYMBOL_OptParenthesizedSeqOptList = 682, /* OptParenthesizedSeqOptList  */
  YYSYMBOL_SeqOptList = 683,               /* SeqOptList  */
  YYSYMBOL_SeqOptElem = 684,               /* SeqOptElem  */
  YYSYMBOL_opt_by = 685,                   /* opt_by  */
  YYSYMBOL_NumericOnly = 686,              /* NumericOnly  */
  YYSYMBOL_NumericOnly_list = 687,         /* NumericOnly_list  */
  YYSYMBOL_CreatePLangStmt = 688,          /* CreatePLangStmt  */
  YYSYMBOL_opt_trusted = 689,              /* opt_trusted  */
  YYSYMBOL_handler_name = 690,             /* handler_name  */
  YYSYMBOL_opt_inline_handler = 691,       /* opt_inline_handler  */
  YYSYMBOL_validator_clause = 692,         /* validator_clause  */
  YYSYMBOL_opt_validator = 693,            /* opt_validator  */
  YYSYMBOL_opt_procedural = 694,           /* opt_procedural  */
  YYSYMBOL_CreateTableSpaceStmt = 695,     /* CreateTableSpaceStmt  */
  YYSYMBOL_OptTableSpaceOwner = 696,       /* OptTableSpaceOwner  */
  YYSYMBOL_DropTableSpaceStmt = 697,       /* DropTableSpaceStmt  */
  YYSYMBOL_CreateExtensionStmt = 698,      /* CreateExtensionStmt  */
  YYSYMBOL_create_extension_opt_list = 699, /* create_extension_opt_list  */
  YYSYMBOL_create_extension_opt_item = 700, /* create_extension_opt_item  */
  YYSYMBOL_AlterExtensionStmt = 701,       /* AlterExtensionStmt  */
  YYSYMBOL_alter_extension_opt_list = 702, /* alter_extension_opt_list  */
  YYSYMBOL_alter_extension_opt_item = 703, /* alter_extension_opt_item  */
  YYSYMBOL_AlterExtensionContentsStmt = 704, /* AlterExtensionContentsStmt  */
  YYSYMBOL_CreateFdwStmt = 705,            /* CreateFdwStmt  */
  YYSYMBOL_fdw_option = 706,               /* fdw_option  */
  YYSYMBOL_fdw_options = 707,              /* fdw_options  */
  YYSYMBOL_opt_fdw_options = 708,          /* opt_fdw_options  */
  YYSYMBOL_AlterFdwStmt = 709,             /* AlterFdwStmt  */
  YYSYMBOL_create_generic_options = 710,   /* create_generic_options  */
  YYSYMBOL_generic_option_list = 711,      /* generic_option_list  */
  YYSYMBOL_alter_generic_options = 712,    /* alter_generic_options  */
  YYSYMBOL_alter_generic_option_list = 713, /* alter_generic_option_list  */
  YYSYMBOL_alter_generic_option_elem = 714, /* alter_generic_option_elem  */
  YYSYMBOL_generic_option_elem = 715,      /* generic_option_elem  */
  YYSYMBOL_generic_option_name = 716,      /* generic_option_name  */
  YYSYMBOL_generic_option_arg = 717,       /* generic_option_arg  */
  YYSYMBOL_CreateForeignServerStmt = 718,  /* CreateForeignServerStmt  */
  YYSYMBOL_opt_type = 719,                 /* opt_type  */
  YYSYMBOL_foreign_server_version = 720,   /* foreign_server_version  */
  YYSYMBOL_opt_foreign_server_version = 721, /* opt_foreign_server_version  */
  YYSYMBOL_AlterForeignServerStmt = 722,   /* AlterForeignServerStmt  */
  YYSYMBOL_CreateForeignTableStmt = 723,   /* CreateForeignTableStmt  */
  YYSYMBOL_ImportForeignSchemaStmt = 724,  /* ImportForeignSchemaStmt  */
  YYSYMBOL_import_qualification_type = 725, /* import_qualification_type  */
  YYSYMBOL_import_qualification = 726,     /* import_qualification  */
  YYSYMBOL_CreateUserMappingStmt = 727,    /* CreateUserMappingStmt  */
  YYSYMBOL_auth_ident = 728,               /* auth_ident  */
  YYSYMBOL_DropUserMappingStmt = 729,      /* DropUserMappingStmt  */
  YYSYMBOL_AlterUserMappingStmt = 730,     /* AlterUserMappingStmt  */
  YYSYMBOL_CreatePolicyStmt = 731,         /* CreatePolicyStmt  */
  YYSYMBOL_AlterPolicyStmt = 732,          /* AlterPolicyStmt  */
  YYSYMBOL_RowSecurityOptionalExpr = 733,  /* RowSecurityOptionalExpr  */
  YYSYMBOL_RowSecurityOptionalWithCheck = 734, /* RowSecurityOptionalWithCheck  */
  YYSYMBOL_RowSecurityDefaultToRole = 735, /* RowSecurityDefaultToRole  */
  YYSYMBOL_RowSecurityOptionalToRole = 736, /* RowSecurityOptionalToRole  */
  YYSYMBOL_RowSecurityDefaultPermissive = 737, /* RowSecurityDefaultPermissive  */
  YYSYMBOL_RowSecurityDefaultForCmd = 738, /* RowSecurityDefaultForCmd  */
  YYSYMBOL_row_security_cmd = 739,         /* row_security_cmd  */
  YYSYMBOL_CreateAmStmt = 740,             /* CreateAmStmt  */
  YYSYMBOL_am_type = 741,                  /* am_type  */
  YYSYMBOL_CreateTrigStmt = 742,           /* CreateTrigStmt  */
  YYSYMBOL_TriggerActionTime = 743,        /* TriggerActionTime  */
  YYSYMBOL_TriggerEvents = 744,            /* TriggerEvents  */
  YYSYMBOL_TriggerOneEvent = 745,          /* TriggerOneEvent  */
  YYSYMBOL_TriggerReferencing = 746,       /* TriggerReferencing  */
  YYSYMBOL_TriggerTransitions = 747,       /* TriggerTransitions  */
  YYSYMBOL_TriggerTransition = 748,        /* TriggerTransition  */
  YYSYMBOL_TransitionOldOrNew = 749,       /* TransitionOldOrNew  */
  YYSYMBOL_TransitionRowOrTable = 750,     /* TransitionRowOrTable  */
  YYSYMBOL_TransitionRelName = 751,        /* TransitionRelName  */
  YYSYMBOL_TriggerForSpec = 752,           /* TriggerForSpec  */
  YYSYMBOL_TriggerForOptEach = 753,        /* TriggerForOptEach  */
  YYSYMBOL_TriggerForType = 754,           /* TriggerForType  */
  YYSYMBOL_TriggerWhen = 755,              /* TriggerWhen  */
  YYSYMBOL_FUNCTION_or_PROCEDURE = 756,    /* FUNCTION_or_PROCEDURE  */
  YYSYMBOL_TriggerFuncArgs = 757,          /* TriggerFuncArgs  */
  YYSYMBOL_TriggerFuncArg = 758,           /* TriggerFuncArg  */
  YYSYMBOL_OptConstrFromTable = 759,       /* OptConstrFromTable  */
  YYSYMBOL_ConstraintAttributeSpec = 760,  /* ConstraintAttributeSpec  */
  YYSYMBOL_ConstraintAttributeElem = 761,  /* ConstraintAttributeElem  */
  YYSYMBOL_CreateEventTrigStmt = 762,      /* CreateEventTrigStmt  */
  YYSYMBOL_event_trigger_when_list = 763,  /* event_trigger_when_list  */
  YYSYMBOL_event_trigger_when_item = 764,  /* event_trigger_when_item  */
  YYSYMBOL_event_trigger_value_list = 765, /* event_trigger_value_list  */
  YYSYMBOL_AlterEventTrigStmt = 766,       /* AlterEventTrigStmt  */
  YYSYMBOL_enable_trigger = 767,           /* enable_trigger  */
  YYSYMBOL_CreateAssertionStmt = 768,      /* CreateAssertionStmt  */
  YYSYMBOL_DefineStmt = 769,               /* DefineStmt  */
  YYSYMBOL_definition = 770,               /* definition  */
  YYSYMBOL_def_list = 771,                 /* def_list  */
  YYSYMBOL_def_elem = 772,                 /* def_elem  */
  YYSYMBOL_def_arg = 773,                  /* def_arg  */
  YYSYMBOL_old_aggr_definition = 774,      /* old_aggr_definition  */
  YYSYMBOL_old_aggr_list = 775,            /* old_aggr_list  */
  YYSYMBOL_old_aggr_elem = 776,            /* old_aggr_elem  */
  YYSYMBOL_opt_enum_val_list = 777,        /* opt_enum_val_list  */
  YYSYMBOL_enum_val_list = 778,            /* enum_val_list  */
  YYSYMBOL_AlterEnumStmt = 779,            /* AlterEnumStmt  */
  YYSYMBOL_opt_if_not_exists = 780,        /* opt_if_not_exists  */
  YYSYMBOL_CreateOpClassStmt = 781,        /* CreateOpClassStmt  */
  YYSYMBOL_opclass_item_list = 782,        /* opclass_item_list  */
  YYSYMBOL_opclass_item = 783,             /* opclass_item  */
  YYSYMBOL_opt_default = 784,              /* opt_default  */
  YYSYMBOL_opt_opfamily = 785,             /* opt_opfamily  */
  YYSYMBOL_opclass_purpose = 786,          /* opclass_purpose  */
  YYSYMBOL_opt_recheck = 787,              /* opt_recheck  */
  YYSYMBOL_CreateOpFamilyStmt = 788,       /* CreateOpFamilyStmt  */
  YYSYMBOL_AlterOpFamilyStmt = 789,        /* AlterOpFamilyStmt  */
  YYSYMBOL_opclass_drop_list = 790,        /* opclass_drop_list  */
  YYSYMBOL_opclass_drop = 791,             /* opclass_drop  */
  YYSYMBOL_DropOpClassStmt = 792,          /* DropOpClassStmt  */
  YYSYMBOL_DropOpFamilyStmt = 793,         /* DropOpFamilyStmt  */
  YYSYMBOL_DropOwnedStmt = 794,            /* DropOwnedStmt  */
  YYSYMBOL_ReassignOwnedStmt = 795,        /* ReassignOwnedStmt  */
  YYSYMBOL_DropStmt = 796,                 /* DropStmt  */
  YYSYMBOL_object_type_any_name = 797,     /* object_type_any_name  */
  YYSYMBOL_object_type_name = 798,         /* object_type_name  */
  YYSYMBOL_drop_type_name = 799,           /* drop_type_name  */
  YYSYMBOL_object_type_name_on_any_name = 800, /* object_type_name_on_any_name  */
  YYSYMBOL_any_name_list = 801,            /* any_name_list  */
  YYSYMBOL_any_name = 802,                 /* any_name  */
  YYSYMBOL_attrs = 803,                    /* attrs  */
  YYSYMBOL_type_name_list = 804,           /* type_name_list  */
  YYSYMBOL_TruncateStmt = 805,             /* TruncateStmt  */
  YYSYMBOL_opt_restart_seqs = 806,         /* opt_restart_seqs  */
  YYSYMBOL_CommentStmt = 807,              /* CommentStmt  */
  YYSYMBOL_comment_text = 808,             /* comment_text  */
  YYSYMBOL_SecLabelStmt = 809,             /* SecLabelStmt  */
  YYSYMBOL_opt_provider = 810,             /* opt_provider  */
  YYSYMBOL_security_label = 811,           /* security_label  */
  YYSYMBOL_FetchStmt = 812,                /* FetchStmt  */
  YYSYMBOL_fetch_args = 813,               /* fetch_args  */
  YYSYMBOL_from_in = 814,                  /* from_in  */
  YYSYMBOL_opt_from_in = 815,              /* opt_from_in  */
  YYSYMBOL_GrantStmt = 816,                /* GrantStmt  */
  YYSYMBOL_RevokeStmt = 817,               /* RevokeStmt  */
  YYSYMBOL_privileges = 818,               /* privileges  */
  YYSYMBOL_privilege_list = 819,           /* privilege_list  */
  YYSYMBOL_privilege = 820,                /* privilege  */
  YYSYMBOL_parameter_name_list = 821,      /* parameter_name_list  */
  YYSYMBOL_parameter_name = 822,           /* parameter_name  */
  YYSYMBOL_privilege_target = 823,         /* privilege_target  */
  YYSYMBOL_grantee_list = 824,             /* grantee_list  */
  YYSYMBOL_grantee = 825,                  /* grantee  */
  YYSYMBOL_opt_grant_grant_option = 826,   /* opt_grant_grant_option  */
  YYSYMBOL_GrantRoleStmt = 827,            /* GrantRoleStmt  */
  YYSYMBOL_RevokeRoleStmt = 828,           /* RevokeRoleStmt  */
  YYSYMBOL_opt_grant_admin_option = 829,   /* opt_grant_admin_option  */
  YYSYMBOL_opt_granted_by = 830,           /* opt_granted_by  */
  YYSYMBOL_AlterDefaultPrivilegesStmt = 831, /* AlterDefaultPrivilegesStmt  */
  YYSYMBOL_DefACLOptionList = 832,         /* DefACLOptionList  */
  YYSYMBOL_DefACLOption = 833,             /* DefACLOption  */
  YYSYMBOL_DefACLAction = 834,             /* DefACLAction  */
  YYSYMBOL_defacl_privilege_target = 835,  /* defacl_privilege_target  */
  YYSYMBOL_IndexStmt = 836,                /* IndexStmt  */
  YYSYMBOL_opt_unique = 837,               /* opt_unique  */
  YYSYMBOL_opt_concurrently = 838,         /* opt_concurrently  */
  YYSYMBOL_opt_index_name = 839,           /* opt_index_name  */
  YYSYMBOL_access_method_clause = 840,     /* access_method_clause  */
  YYSYMBOL_index_params = 841,             /* index_params  */
  YYSYMBOL_index_elem_options = 842,       /* index_elem_options  */
  YYSYMBOL_index_elem = 843,               /* index_elem  */
  YYSYMBOL_opt_include = 844,              /* opt_include  */
  YYSYMBOL_index_including_params = 845,   /* index_including_params  */
  YYSYMBOL_opt_collate = 846,              /* opt_collate  */
  YYSYMBOL_opt_class = 847,                /* opt_class  */
  YYSYMBOL_opt_asc_desc = 848,             /* opt_asc_desc  */
  YYSYMBOL_opt_nulls_order = 849,          /* opt_nulls_order  */
  YYSYMBOL_CreateFunctionStmt = 850,       /* CreateFunctionStmt  */
  YYSYMBOL_opt_or_replace = 851,           /* opt_or_replace  */
  YYSYMBOL_func_args = 852,                /* func_args  */
  YYSYMBOL_func_args_list = 853,           /* func_args_list  */
  YYSYMBOL_function_with_argtypes_list = 854, /* function_with_argtypes_list  */
  YYSYMBOL_function_with_argtypes = 855,   /* function_with_argtypes  */
  YYSYMBOL_func_args_with_defaults = 856,  /* func_args_with_defaults  */
  YYSYMBOL_func_args_with_defaults_list = 857, /* func_args_with_defaults_list  */
  YYSYMBOL_func_arg = 858,                 /* func_arg  */
  YYSYMBOL_arg_class = 859,                /* arg_class  */
  YYSYMBOL_param_name = 860,               /* param_name  */
  YYSYMBOL_func_return = 861,              /* func_return  */
  YYSYMBOL_func_type = 862,                /* func_type  */
  YYSYMBOL_func_arg_with_default = 863,    /* func_arg_with_default  */
  YYSYMBOL_aggr_arg = 864,                 /* aggr_arg  */
  YYSYMBOL_aggr_args = 865,                /* aggr_args  */
  YYSYMBOL_aggr_args_list = 866,           /* aggr_args_list  */
  YYSYMBOL_aggregate_with_argtypes = 867,  /* aggregate_with_argtypes  */
  YYSYMBOL_aggregate_with_argtypes_list = 868, /* aggregate_with_argtypes_list  */
  YYSYMBOL_opt_createfunc_opt_list = 869,  /* opt_createfunc_opt_list  */
  YYSYMBOL_createfunc_opt_list = 870,      /* createfunc_opt_list  */
  YYSYMBOL_common_func_opt_item = 871,     /* common_func_opt_item  */
  YYSYMBOL_createfunc_opt_item = 872,      /* createfunc_opt_item  */
  YYSYMBOL_func_as = 873,                  /* func_as  */
  YYSYMBOL_ReturnStmt = 874,               /* ReturnStmt  */
  YYSYMBOL_opt_routine_body = 875,         /* opt_routine_body  */
  YYSYMBOL_routine_body_stmt_list = 876,   /* routine_body_stmt_list  */
  YYSYMBOL_routine_body_stmt = 877,        /* routine_body_stmt  */
  YYSYMBOL_transform_type_list = 878,      /* transform_type_list  */
  YYSYMBOL_opt_definition = 879,           /* opt_definition  */
  YYSYMBOL_table_func_column = 880,        /* table_func_column  */
  YYSYMBOL_table_func_column_list = 881,   /* table_func_column_list  */
  YYSYMBOL_AlterFunctionStmt = 882,        /* AlterFunctionStmt  */
  YYSYMBOL_alterfunc_opt_list = 883,       /* alterfunc_opt_list  */
  YYSYMBOL_opt_restrict = 884,             /* opt_restrict  */
  YYSYMBOL_RemoveFuncStmt = 885,           /* RemoveFuncStmt  */
  YYSYMBOL_RemoveAggrStmt = 886,           /* RemoveAggrStmt  */
  YYSYMBOL_RemoveOperStmt = 887,           /* RemoveOperStmt  */
  YYSYMBOL_oper_argtypes = 888,            /* oper_argtypes  */
  YYSYMBOL_any_operator = 889,             /* any_operator  */
  YYSYMBOL_operator_with_argtypes_list = 890, /* operator_with_argtypes_list  */
  YYSYMBOL_operator_with_argtypes = 891,   /* operator_with_argtypes  */
  YYSYMBOL_DoStmt = 892,                   /* DoStmt  */
  YYSYMBOL_dostmt_opt_list = 893,          /* dostmt_opt_list  */
  YYSYMBOL_dostmt_opt_item = 894,          /* dostmt_opt_item  */
  YYSYMBOL_CreateCastStmt = 895,           /* CreateCastStmt  */
  YYSYMBOL_cast_context = 896,             /* cast_context  */
  YYSYMBOL_DropCastStmt = 897,             /* DropCastStmt  */
  YYSYMBOL_opt_if_exists = 898,            /* opt_if_exists  */
  YYSYMBOL_CreateTransformStmt = 899,      /* CreateTransformStmt  */
  YYSYMBOL_transform_element_list = 900,   /* transform_element_list  */
  YYSYMBOL_DropTransformStmt = 901,        /* DropTransformStmt  */
  YYSYMBOL_ReindexStmt = 902,              /* ReindexStmt  */
  YYSYMBOL_reindex_target_type = 903,      /* reindex_target_type  */
  YYSYMBOL_reindex_target_multitable = 904, /* reindex_target_multitable  */
  YYSYMBOL_AlterTblSpcStmt = 905,          /* AlterTblSpcStmt  */
  YYSYMBOL_RenameStmt = 906,               /* RenameStmt  */
  YYSYMBOL_opt_column = 907,               /* opt_column  */
  YYSYMBOL_opt_set_data = 908,             /* opt_set_data  */
  YYSYMBOL_AlterObjectDependsStmt = 909,   /* AlterObjectDependsStmt  */
  YYSYMBOL_opt_no = 910,                   /* opt_no  */
  YYSYMBOL_AlterObjectSchemaStmt = 911,    /* AlterObjectSchemaStmt  */
  YYSYMBOL_AlterOperatorStmt = 912,        /* AlterOperatorStmt  */
  YYSYMBOL_operator_def_list = 913,        /* operator_def_list  */
  YYSYMBOL_operator_def_elem = 914,        /* operator_def_elem  */
  YYSYMBOL_operator_def_arg = 915,         /* operator_def_arg  */
  YYSYMBOL_AlterTypeStmt = 916,            /* AlterTypeStmt  */
  YYSYMBOL_AlterOwnerStmt = 917,           /* AlterOwnerStmt  */
  YYSYMBOL_CreatePublicationStmt = 918,    /* CreatePublicationStmt  */
  YYSYMBOL_PublicationObjSpec = 919,       /* PublicationObjSpec  */
  YYSYMBOL_pub_obj_list = 920,             /* pub_obj_list  */
  YYSYMBOL_AlterPublicationStmt = 921,     /* AlterPublicationStmt  */
  YYSYMBOL_CreateSubscriptionStmt = 922,   /* CreateSubscriptionStmt  */
  YYSYMBOL_AlterSubscriptionStmt = 923,    /* AlterSubscriptionStmt  */
  YYSYMBOL_DropSubscriptionStmt = 924,     /* DropSubscriptionStmt  */
  YYSYMBOL_RuleStmt = 925,                 /* RuleStmt  */
  YYSYMBOL_RuleActionList = 926,           /* RuleActionList  */
  YYSYMBOL_RuleActionMulti = 927,          /* RuleActionMulti  */
  YYSYMBOL_RuleActionStmt = 928,           /* RuleActionStmt  */
  YYSYMBOL_RuleActionStmtOrEmpty = 929,    /* RuleActionStmtOrEmpty  */
  YYSYMBOL_event = 930,                    /* event  */
  YYSYMBOL_opt_instead = 931,              /* opt_instead  */
  YYSYMBOL_NotifyStmt = 932,               /* NotifyStmt  */
  YYSYMBOL_notify_payload = 933,           /* notify_payload  */
  YYSYMBOL_ListenStmt = 934,               /* ListenStmt  */
  YYSYMBOL_UnlistenStmt = 935,             /* UnlistenStmt  */
  YYSYMBOL_TransactionStmt = 936,          /* TransactionStmt  */
  YYSYMBOL_TransactionStmtLegacy = 937,    /* TransactionStmtLegacy  */
  YYSYMBOL_opt_transaction = 938,          /* opt_transaction  */
  YYSYMBOL_transaction_mode_item = 939,    /* transaction_mode_item  */
  YYSYMBOL_transaction_mode_list = 940,    /* transaction_mode_list  */
  YYSYMBOL_transaction_mode_list_or_empty = 941, /* transaction_mode_list_or_empty  */
  YYSYMBOL_opt_transaction_chain = 942,    /* opt_transaction_chain  */
  YYSYMBOL_ViewStmt = 943,                 /* ViewStmt  */
  YYSYMBOL_opt_check_option = 944,         /* opt_check_option  */
  YYSYMBOL_LoadStmt = 945,                 /* LoadStmt  */
  YYSYMBOL_CreatedbStmt = 946,             /* CreatedbStmt  */
  YYSYMBOL_createdb_opt_list = 947,        /* createdb_opt_list  */
  YYSYMBOL_createdb_opt_items = 948,       /* createdb_opt_items  */
  YYSYMBOL_createdb_opt_item = 949,        /* createdb_opt_item  */
  YYSYMBOL_createdb_opt_name = 950,        /* createdb_opt_name  */
  YYSYMBOL_opt_equal = 951,                /* opt_equal  */
  YYSYMBOL_AlterDatabaseStmt = 952,        /* AlterDatabaseStmt  */
  YYSYMBOL_AlterDatabaseSetStmt = 953,     /* AlterDatabaseSetStmt  */
  YYSYMBOL_DropdbStmt = 954,               /* DropdbStmt  */
  YYSYMBOL_drop_option_list = 955,         /* drop_option_list  */
  YYSYMBOL_drop_option = 956,              /* drop_option  */
  YYSYMBOL_AlterCollationStmt = 957,       /* AlterCollationStmt  */
  YYSYMBOL_AlterSystemStmt = 958,          /* AlterSystemStmt  */
  YYSYMBOL_CreateDomainStmt = 959,         /* CreateDomainStmt  */
  YYSYMBOL_AlterDomainStmt = 960,          /* AlterDomainStmt  */
  YYSYMBOL_opt_as = 961,                   /* opt_as  */
  YYSYMBOL_AlterTSDictionaryStmt = 962,    /* AlterTSDictionaryStmt  */
  YYSYMBOL_AlterTSConfigurationStmt = 963, /* AlterTSConfigurationStmt  */
  YYSYMBOL_any_with = 964,                 /* any_with  */
  YYSYMBOL_CreateConversionStmt = 965,     /* CreateConversionStmt  */
  YYSYMBOL_ClusterStmt = 966,              /* ClusterStmt  */
  YYSYMBOL_cluster_index_specification = 967, /* cluster_index_specification  */
  YYSYMBOL_VacuumStmt = 968,               /* VacuumStmt  */
  YYSYMBOL_AnalyzeStmt = 969,              /* AnalyzeStmt  */
  YYSYMBOL_utility_option_list = 970,      /* utility_option_list  */
  YYSYMBOL_analyze_keyword = 971,          /* analyze_keyword  */
  YYSYMBOL_utility_option_elem = 972,      /* utility_option_elem  */
  YYSYMBOL_utility_option_name = 973,      /* utility_option_name  */
  YYSYMBOL_utility_option_arg = 974,       /* utility_option_arg  */
  YYSYMBOL_opt_analyze = 975,              /* opt_analyze  */
  YYSYMBOL_opt_verbose = 976,              /* opt_verbose  */
  YYSYMBOL_opt_full = 977,                 /* opt_full  */
  YYSYMBOL_opt_freeze = 978,               /* opt_freeze  */
  YYSYMBOL_opt_name_list = 979,            /* opt_name_list  */
  YYSYMBOL_vacuum_relation = 980,          /* vacuum_relation  */
  YYSYMBOL_vacuum_relation_list = 981,     /* vacuum_relation_list  */
  YYSYMBOL_opt_vacuum_relation_list = 982, /* opt_vacuum_relation_list  */
  YYSYMBOL_ExplainStmt = 983,              /* ExplainStmt  */
  YYSYMBOL_ExplainableStmt = 984,          /* ExplainableStmt  */
  YYSYMBOL_PrepareStmt = 985,              /* PrepareStmt  */
  YYSYMBOL_prep_type_clause = 986,         /* prep_type_clause  */
  YYSYMBOL_PreparableStmt = 987,           /* PreparableStmt  */
  YYSYMBOL_ExecuteStmt = 988,              /* ExecuteStmt  */
  YYSYMBOL_execute_param_clause = 989,     /* execute_param_clause  */
  YYSYMBOL_DeallocateStmt = 990,           /* DeallocateStmt  */
  YYSYMBOL_InsertStmt = 991,               /* InsertStmt  */
  YYSYMBOL_insert_target = 992,            /* insert_target  */
  YYSYMBOL_insert_rest = 993,              /* insert_rest  */
  YYSYMBOL_override_kind = 994,            /* override_kind  */
  YYSYMBOL_insert_column_list = 995,       /* insert_column_list  */
  YYSYMBOL_insert_column_item = 996,       /* insert_column_item  */
  YYSYMBOL_opt_on_conflict = 997,          /* opt_on_conflict  */
  YYSYMBOL_opt_conf_expr = 998,            /* opt_conf_expr  */
  YYSYMBOL_returning_clause = 999,         /* returning_clause  */
  YYSYMBOL_DeleteStmt = 1000,              /* DeleteStmt  */
  YYSYMBOL_using_clause = 1001,            /* using_clause  */
  YYSYMBOL_LockStmt = 1002,                /* LockStmt  */
  YYSYMBOL_opt_lock = 1003,                /* opt_lock  */
  YYSYMBOL_lock_type = 1004,               /* lock_type  */
  YYSYMBOL_opt_nowait = 1005,              /* opt_nowait  */
  YYSYMBOL_opt_nowait_or_skip = 1006,      /* opt_nowait_or_skip  */
  YYSYMBOL_UpdateStmt = 1007,              /* UpdateStmt  */
  YYSYMBOL_set_clause_list = 1008,         /* set_clause_list  */
  YYSYMBOL_set_clause = 1009,              /* set_clause  */
  YYSYMBOL_set_target = 1010,              /* set_target  */
  YYSYMBOL_set_target_list = 1011,         /* set_target_list  */
  YYSYMBOL_MergeStmt = 1012,               /* MergeStmt  */
  YYSYMBOL_merge_when_list = 1013,         /* merge_when_list  */
  YYSYMBOL_merge_when_clause = 1014,       /* merge_when_clause  */
  YYSYMBOL_opt_merge_when_condition = 1015, /* opt_merge_when_condition  */
  YYSYMBOL_merge_update = 1016,            /* merge_update  */
  YYSYMBOL_merge_delete = 1017,            /* merge_delete  */
  YYSYMBOL_merge_insert = 1018,            /* merge_insert  */
  YYSYMBOL_merge_values_clause = 1019,     /* merge_values_clause  */
  YYSYMBOL_DeclareCursorStmt = 1020,       /* DeclareCursorStmt  */
  YYSYMBOL_cursor_name = 1021,             /* cursor_name  */
  YYSYMBOL_cursor_options = 1022,          /* cursor_options  */
  YYSYMBOL_opt_hold = 1023,                /* opt_hold  */
  YYSYMBOL_SelectStmt = 1024,              /* SelectStmt  */
  YYSYMBOL_select_with_parens = 1025,      /* select_with_parens  */
  YYSYMBOL_select_no_parens = 1026,        /* select_no_parens  */
  YYSYMBOL_select_clause = 1027,           /* select_clause  */
  YYSYMBOL_simple_select = 1028,           /* simple_select  */
  YYSYMBOL_with_clause = 1029,             /* with_clause  */
  YYSYMBOL_cte_list = 1030,                /* cte_list  */
  YYSYMBOL_common_table_expr = 1031,       /* common_table_expr  */
  YYSYMBOL_opt_materialized = 1032,        /* opt_materialized  */
  YYSYMBOL_opt_search_clause = 1033,       /* opt_search_clause  */
  YYSYMBOL_opt_cycle_clause = 1034,        /* opt_cycle_clause  */
  YYSYMBOL_opt_with_clause = 1035,         /* opt_with_clause  */
  YYSYMBOL_into_clause = 1036,             /* into_clause  */
  YYSYMBOL_OptTempTableName = 1037,        /* OptTempTableName  */
  YYSYMBOL_opt_table = 1038,               /* opt_table  */
  YYSYMBOL_set_quantifier = 1039,          /* set_quantifier  */
  YYSYMBOL_distinct_clause = 1040,         /* distinct_clause  */
  YYSYMBOL_opt_all_clause = 1041,          /* opt_all_clause  */
  YYSYMBOL_opt_distinct_clause = 1042,     /* opt_distinct_clause  */
  YYSYMBOL_opt_sort_clause = 1043,         /* opt_sort_clause  */
  YYSYMBOL_sort_clause = 1044,             /* sort_clause  */
  YYSYMBOL_sortby_list = 1045,             /* sortby_list  */
  YYSYMBOL_sortby = 1046,                  /* sortby  */
  YYSYMBOL_select_limit = 1047,            /* select_limit  */
  YYSYMBOL_opt_select_limit = 1048,        /* opt_select_limit  */
  YYSYMBOL_limit_clause = 1049,            /* limit_clause  */
  YYSYMBOL_offset_clause = 1050,           /* offset_clause  */
  YYSYMBOL_select_limit_value = 1051,      /* select_limit_value  */
  YYSYMBOL_select_offset_value = 1052,     /* select_offset_value  */
  YYSYMBOL_select_fetch_first_value = 1053, /* select_fetch_first_value  */
  YYSYMBOL_I_or_F_const = 1054,            /* I_or_F_const  */
  YYSYMBOL_row_or_rows = 1055,             /* row_or_rows  */
  YYSYMBOL_first_or_next = 1056,           /* first_or_next  */
  YYSYMBOL_group_clause = 1057,            /* group_clause  */
  YYSYMBOL_group_by_list = 1058,           /* group_by_list  */
  YYSYMBOL_group_by_item = 1059,           /* group_by_item  */
  YYSYMBOL_empty_grouping_set = 1060,      /* empty_grouping_set  */
  YYSYMBOL_rollup_clause = 1061,           /* rollup_clause  */
  YYSYMBOL_cube_clause = 1062,             /* cube_clause  */
  YYSYMBOL_grouping_sets_clause = 1063,    /* grouping_sets_clause  */
  YYSYMBOL_having_clause = 1064,           /* having_clause  */
  YYSYMBOL_for_locking_clause = 1065,      /* for_locking_clause  */
  YYSYMBOL_opt_for_locking_clause = 1066,  /* opt_for_locking_clause  */
  YYSYMBOL_for_locking_items = 1067,       /* for_locking_items  */
  YYSYMBOL_for_locking_item = 1068,        /* for_locking_item  */
  YYSYMBOL_for_locking_strength = 1069,    /* for_locking_strength  */
  YYSYMBOL_locked_rels_list = 1070,        /* locked_rels_list  */
  YYSYMBOL_values_clause = 1071,           /* values_clause  */
  YYSYMBOL_from_clause = 1072,             /* from_clause  */
  YYSYMBOL_from_list = 1073,               /* from_list  */
  YYSYMBOL_table_ref = 1074,               /* table_ref  */
  YYSYMBOL_joined_table = 1075,            /* joined_table  */
  YYSYMBOL_alias_clause = 1076,            /* alias_clause  */
  YYSYMBOL_opt_alias_clause = 1077,        /* opt_alias_clause  */
  YYSYMBOL_opt_alias_clause_for_join_using = 1078, /* opt_alias_clause_for_join_using  */
  YYSYMBOL_func_alias_clause = 1079,       /* func_alias_clause  */
  YYSYMBOL_join_type = 1080,               /* join_type  */
  YYSYMBOL_opt_outer = 1081,               /* opt_outer  */
  YYSYMBOL_join_qual = 1082,               /* join_qual  */
  YYSYMBOL_relation_expr = 1083,           /* relation_expr  */
  YYSYMBOL_extended_relation_expr = 1084,  /* extended_relation_expr  */
  YYSYMBOL_relation_expr_list = 1085,      /* relation_expr_list  */
  YYSYMBOL_relation_expr_opt_alias = 1086, /* relation_expr_opt_alias  */
  YYSYMBOL_tablesample_clause = 1087,      /* tablesample_clause  */
  YYSYMBOL_opt_repeatable_clause = 1088,   /* opt_repeatable_clause  */
  YYSYMBOL_func_table = 1089,              /* func_table  */
  YYSYMBOL_rowsfrom_item = 1090,           /* rowsfrom_item  */
  YYSYMBOL_rowsfrom_list = 1091,           /* rowsfrom_list  */
  YYSYMBOL_opt_col_def_list = 1092,        /* opt_col_def_list  */
  YYSYMBOL_opt_ordinality = 1093,          /* opt_ordinality  */
  YYSYMBOL_where_clause = 1094,            /* where_clause  */
  YYSYMBOL_where_or_current_clause = 1095, /* where_or_current_clause  */
  YYSYMBOL_OptTableFuncElementList = 1096, /* OptTableFuncElementList  */
  YYSYMBOL_TableFuncElementList = 1097,    /* TableFuncElementList  */
  YYSYMBOL_TableFuncElement = 1098,        /* TableFuncElement  */
  YYSYMBOL_xmltable = 1099,                /* xmltable  */
  YYSYMBOL_xmltable_column_list = 1100,    /* xmltable_column_list  */
  YYSYMBOL_xmltable_column_el = 1101,      /* xmltable_column_el  */
  YYSYMBOL_xmltable_column_option_list = 1102, /* xmltable_column_option_list  */
  YYSYMBOL_xmltable_column_option_el = 1103, /* xmltable_column_option_el  */
  YYSYMBOL_xml_namespace_list = 1104,      /* xml_namespace_list  */
  YYSYMBOL_xml_namespace_el = 1105,        /* xml_namespace_el  */
  YYSYMBOL_Typename = 1106,                /* Typename  */
  YYSYMBOL_opt_array_bounds = 1107,        /* opt_array_bounds  */
  YYSYMBOL_SimpleTypename = 1108,          /* SimpleTypename  */
  YYSYMBOL_ConstTypename = 1109,           /* ConstTypename  */
  YYSYMBOL_GenericType = 1110,             /* GenericType  */
  YYSYMBOL_opt_type_modifiers = 1111,      /* opt_type_modifiers  */
  YYSYMBOL_Numeric = 1112,                 /* Numeric  */
  YYSYMBOL_opt_float = 1113,               /* opt_float  */
  YYSYMBOL_Bit = 1114,                     /* Bit  */
  YYSYMBOL_ConstBit = 1115,                /* ConstBit  */
  YYSYMBOL_BitWithLength = 1116,           /* BitWithLength  */
  YYSYMBOL_BitWithoutLength = 1117,        /* BitWithoutLength  */
  YYSYMBOL_Character = 1118,               /* Character  */
  YYSYMBOL_ConstCharacter = 1119,          /* ConstCharacter  */
  YYSYMBOL_CharacterWithLength = 1120,     /* CharacterWithLength  */
  YYSYMBOL_CharacterWithoutLength = 1121,  /* CharacterWithoutLength  */
  YYSYMBOL_character = 1122,               /* character  */
  YYSYMBOL_opt_varying = 1123,             /* opt_varying  */
  YYSYMBOL_ConstDatetime = 1124,           /* ConstDatetime  */
  YYSYMBOL_ConstInterval = 1125,           /* ConstInterval  */
  YYSYMBOL_opt_timezone = 1126,            /* opt_timezone  */
  YYSYMBOL_opt_interval = 1127,            /* opt_interval  */
  YYSYMBOL_interval_second = 1128,         /* interval_second  */
  YYSYMBOL_JsonType = 1129,                /* JsonType  */
  YYSYMBOL_a_expr = 1130,                  /* a_expr  */
  YYSYMBOL_b_expr = 1131,                  /* b_expr  */
  YYSYMBOL_json_predicate_type_constraint_opt = 1132, /* json_predicate_type_constraint_opt  */
  YYSYMBOL_json_key_uniqueness_constraint_opt = 1133, /* json_key_uniqueness_constraint_opt  */
  YYSYMBOL_unique_keys = 1134,             /* unique_keys  */
  YYSYMBOL_c_expr = 1135,                  /* c_expr  */
  YYSYMBOL_func_application = 1136,        /* func_application  */
  YYSYMBOL_func_expr = 1137,               /* func_expr  */
  YYSYMBOL_func_expr_windowless = 1138,    /* func_expr_windowless  */
  YYSYMBOL_func_expr_common_subexpr = 1139, /* func_expr_common_subexpr  */
  YYSYMBOL_xml_root_version = 1140,        /* xml_root_version  */
  YYSYMBOL_opt_xml_root_standalone = 1141, /* opt_xml_root_standalone  */
  YYSYMBOL_xml_attributes = 1142,          /* xml_attributes  */
  YYSYMBOL_xml_attribute_list = 1143,      /* xml_attribute_list  */
  YYSYMBOL_xml_attribute_el = 1144,        /* xml_attribute_el  */
  YYSYMBOL_document_or_content = 1145,     /* document_or_content  */
  YYSYMBOL_xml_whitespace_option = 1146,   /* xml_whitespace_option  */
  YYSYMBOL_xmlexists_argument = 1147,      /* xmlexists_argument  */
  YYSYMBOL_xml_passing_mech = 1148,        /* xml_passing_mech  */
  YYSYMBOL_within_group_clause = 1149,     /* within_group_clause  */
  YYSYMBOL_filter_clause = 1150,           /* filter_clause  */
  YYSYMBOL_window_clause = 1151,           /* window_clause  */
  YYSYMBOL_window_definition_list = 1152,  /* window_definition_list  */
  YYSYMBOL_window_definition = 1153,       /* window_definition  */
  YYSYMBOL_over_clause = 1154,             /* over_clause  */
  YYSYMBOL_window_specification = 1155,    /* window_specification  */
  YYSYMBOL_opt_existing_window_name = 1156, /* opt_existing_window_name  */
  YYSYMBOL_opt_partition_clause = 1157,    /* opt_partition_clause  */
  YYSYMBOL_opt_frame_clause = 1158,        /* opt_frame_clause  */
  YYSYMBOL_frame_extent = 1159,            /* frame_extent  */
  YYSYMBOL_frame_bound = 1160,             /* frame_bound  */
  YYSYMBOL_opt_window_exclusion_clause = 1161, /* opt_window_exclusion_clause  */
  YYSYMBOL_row = 1162,                     /* row  */
  YYSYMBOL_explicit_row = 1163,            /* explicit_row  */
  YYSYMBOL_implicit_row = 1164,            /* implicit_row  */
  YYSYMBOL_sub_type = 1165,                /* sub_type  */
  YYSYMBOL_all_Op = 1166,                  /* all_Op  */
  YYSYMBOL_MathOp = 1167,                  /* MathOp  */
  YYSYMBOL_qual_Op = 1168,                 /* qual_Op  */
  YYSYMBOL_qual_all_Op = 1169,             /* qual_all_Op  */
  YYSYMBOL_subquery_Op = 1170,             /* subquery_Op  */
  YYSYMBOL_expr_list = 1171,               /* expr_list  */
  YYSYMBOL_func_arg_list = 1172,           /* func_arg_list  */
  YYSYMBOL_func_arg_expr = 1173,           /* func_arg_expr  */
  YYSYMBOL_func_arg_list_opt = 1174,       /* func_arg_list_opt  */
  YYSYMBOL_type_list = 1175,               /* type_list  */
  YYSYMBOL_array_expr = 1176,              /* array_expr  */
  YYSYMBOL_array_expr_list = 1177,         /* array_expr_list  */
  YYSYMBOL_extract_list = 1178,            /* extract_list  */
  YYSYMBOL_extract_arg = 1179,             /* extract_arg  */
  YYSYMBOL_unicode_normal_form = 1180,     /* unicode_normal_form  */
  YYSYMBOL_overlay_list = 1181,            /* overlay_list  */
  YYSYMBOL_position_list = 1182,           /* position_list  */
  YYSYMBOL_substr_list = 1183,             /* substr_list  */
  YYSYMBOL_trim_list = 1184,               /* trim_list  */
  YYSYMBOL_in_expr = 1185,                 /* in_expr  */
  YYSYMBOL_case_expr = 1186,               /* case_expr  */
  YYSYMBOL_when_clause_list = 1187,        /* when_clause_list  */
  YYSYMBOL_when_clause = 1188,             /* when_clause  */
  YYSYMBOL_case_default = 1189,            /* case_default  */
  YYSYMBOL_case_arg = 1190,                /* case_arg  */
  YYSYMBOL_columnref = 1191,               /* columnref  */
  YYSYMBOL_indirection_el = 1192,          /* indirection_el  */
  YYSYMBOL_opt_slice_bound = 1193,         /* opt_slice_bound  */
  YYSYMBOL_indirection = 1194,             /* indirection  */
  YYSYMBOL_opt_indirection = 1195,         /* opt_indirection  */
  YYSYMBOL_opt_asymmetric = 1196,          /* opt_asymmetric  */
  YYSYMBOL_json_func_expr = 1197,          /* json_func_expr  */
  YYSYMBOL_json_parse_expr = 1198,         /* json_parse_expr  */
  YYSYMBOL_json_scalar_expr = 1199,        /* json_scalar_expr  */
  YYSYMBOL_json_serialize_expr = 1200,     /* json_serialize_expr  */
  YYSYMBOL_json_value_func_expr = 1201,    /* json_value_func_expr  */
  YYSYMBOL_json_api_common_syntax = 1202,  /* json_api_common_syntax  */
  YYSYMBOL_json_context_item = 1203,       /* json_context_item  */
  YYSYMBOL_json_path_specification = 1204, /* json_path_specification  */
  YYSYMBOL_json_as_path_name_clause_opt = 1205, /* json_as_path_name_clause_opt  */
  YYSYMBOL_json_table_path_name = 1206,    /* json_table_path_name  */
  YYSYMBOL_json_passing_clause_opt = 1207, /* json_passing_clause_opt  */
  YYSYMBOL_json_arguments = 1208,          /* json_arguments  */
  YYSYMBOL_json_argument = 1209,           /* json_argument  */
  YYSYMBOL_json_value_expr = 1210,         /* json_value_expr  */
  YYSYMBOL_json_format_clause_opt = 1211,  /* json_format_clause_opt  */
  YYSYMBOL_json_representation = 1212,     /* json_representation  */
  YYSYMBOL_json_encoding_clause_opt = 1213, /* json_encoding_clause_opt  */
  YYSYMBOL_json_encoding = 1214,           /* json_encoding  */
  YYSYMBOL_json_behavior_error = 1215,     /* json_behavior_error  */
  YYSYMBOL_json_behavior_null = 1216,      /* json_behavior_null  */
  YYSYMBOL_json_behavior_true = 1217,      /* json_behavior_true  */
  YYSYMBOL_json_behavior_false = 1218,     /* json_behavior_false  */
  YYSYMBOL_json_behavior_unknown = 1219,   /* json_behavior_unknown  */
  YYSYMBOL_json_behavior_empty = 1220,     /* json_behavior_empty  */
  YYSYMBOL_json_behavior_empty_array = 1221, /* json_behavior_empty_array  */
  YYSYMBOL_json_behavior_empty_object = 1222, /* json_behavior_empty_object  */
  YYSYMBOL_json_behavior_default = 1223,   /* json_behavior_default  */
  YYSYMBOL_json_value_behavior = 1224,     /* json_value_behavior  */
  YYSYMBOL_json_value_on_behavior_clause_opt = 1225, /* json_value_on_behavior_clause_opt  */
  YYSYMBOL_json_query_expr = 1226,         /* json_query_expr  */
  YYSYMBOL_json_wrapper_clause_opt = 1227, /* json_wrapper_clause_opt  */
  YYSYMBOL_json_wrapper_behavior = 1228,   /* json_wrapper_behavior  */
  YYSYMBOL_array_opt = 1229,               /* array_opt  */
  YYSYMBOL_json_conditional_or_unconditional_opt = 1230, /* json_conditional_or_unconditional_opt  */
  YYSYMBOL_json_quotes_clause_opt = 1231,  /* json_quotes_clause_opt  */
  YYSYMBOL_json_quotes_behavior = 1232,    /* json_quotes_behavior  */
  YYSYMBOL_json_on_scalar_string_opt = 1233, /* json_on_scalar_string_opt  */
  YYSYMBOL_json_query_behavior = 1234,     /* json_query_behavior  */
  YYSYMBOL_json_query_on_behavior_clause_opt = 1235, /* json_query_on_behavior_clause_opt  */
  YYSYMBOL_json_table = 1236,              /* json_table  */
  YYSYMBOL_json_table_columns_clause = 1237, /* json_table_columns_clause  */
  YYSYMBOL_json_table_column_definition_list = 1238, /* json_table_column_definition_list  */
  YYSYMBOL_json_table_column_definition = 1239, /* json_table_column_definition  */
  YYSYMBOL_json_table_ordinality_column_definition = 1240, /* json_table_ordinality_column_definition  */
  YYSYMBOL_json_table_regular_column_definition = 1241, /* json_table_regular_column_definition  */
  YYSYMBOL_json_table_exists_column_definition = 1242, /* json_table_exists_column_definition  */
  YYSYMBOL_json_table_error_behavior = 1243, /* json_table_error_behavior  */
  YYSYMBOL_json_table_error_clause_opt = 1244, /* json_table_error_clause_opt  */
  YYSYMBOL_json_table_column_path_specification_clause_opt = 1245, /* json_table_column_path_specification_clause_opt  */
  YYSYMBOL_json_table_formatted_column_definition = 1246, /* json_table_formatted_column_definition  */
  YYSYMBOL_json_table_nested_columns = 1247, /* json_table_nested_columns  */
  YYSYMBOL_path_opt = 1248,                /* path_opt  */
  YYSYMBOL_json_table_plan_clause_opt = 1249, /* json_table_plan_clause_opt  */
  YYSYMBOL_json_table_specific_plan = 1250, /* json_table_specific_plan  */
  YYSYMBOL_json_table_plan = 1251,         /* json_table_plan  */
  YYSYMBOL_json_table_plan_simple = 1252,  /* json_table_plan_simple  */
  YYSYMBOL_json_table_plan_parent_child = 1253, /* json_table_plan_parent_child  */
  YYSYMBOL_json_table_plan_outer = 1254,   /* json_table_plan_outer  */
  YYSYMBOL_json_table_plan_inner = 1255,   /* json_table_plan_inner  */
  YYSYMBOL_json_table_plan_sibling = 1256, /* json_table_plan_sibling  */
  YYSYMBOL_json_table_plan_union = 1257,   /* json_table_plan_union  */
  YYSYMBOL_json_table_plan_cross = 1258,   /* json_table_plan_cross  */
  YYSYMBOL_json_table_plan_primary = 1259, /* json_table_plan_primary  */
  YYSYMBOL_json_table_default_plan = 1260, /* json_table_default_plan  */
  YYSYMBOL_json_table_default_plan_choices = 1261, /* json_table_default_plan_choices  */
  YYSYMBOL_json_table_default_plan_inner_outer = 1262, /* json_table_default_plan_inner_outer  */
  YYSYMBOL_json_table_default_plan_union_cross = 1263, /* json_table_default_plan_union_cross  */
  YYSYMBOL_json_returning_clause_opt = 1264, /* json_returning_clause_opt  */
  YYSYMBOL_json_output_clause_opt = 1265,  /* json_output_clause_opt  */
  YYSYMBOL_json_exists_predicate = 1266,   /* json_exists_predicate  */
  YYSYMBOL_json_exists_error_clause_opt = 1267, /* json_exists_error_clause_opt  */
  YYSYMBOL_json_exists_error_behavior = 1268, /* json_exists_error_behavior  */
  YYSYMBOL_json_value_constructor = 1269,  /* json_value_constructor  */
  YYSYMBOL_json_object_constructor = 1270, /* json_object_constructor  */
  YYSYMBOL_json_object_args = 1271,        /* json_object_args  */
  YYSYMBOL_json_object_func_args = 1272,   /* json_object_func_args  */
  YYSYMBOL_json_object_constructor_args = 1273, /* json_object_constructor_args  */
  YYSYMBOL_json_object_constructor_args_opt = 1274, /* json_object_constructor_args_opt  */
  YYSYMBOL_json_name_and_value_list = 1275, /* json_name_and_value_list  */
  YYSYMBOL_json_name_and_value = 1276,     /* json_name_and_value  */
  YYSYMBOL_json_object_constructor_null_clause_opt = 1277, /* json_object_constructor_null_clause_opt  */
  YYSYMBOL_json_array_constructor = 1278,  /* json_array_constructor  */
  YYSYMBOL_json_value_expr_list = 1279,    /* json_value_expr_list  */
  YYSYMBOL_json_array_constructor_null_clause_opt = 1280, /* json_array_constructor_null_clause_opt  */
  YYSYMBOL_json_aggregate_func = 1281,     /* json_aggregate_func  */
  YYSYMBOL_json_object_aggregate_constructor = 1282, /* json_object_aggregate_constructor  */
  YYSYMBOL_json_array_aggregate_constructor = 1283, /* json_array_aggregate_constructor  */
  YYSYMBOL_json_array_aggregate_order_by_clause_opt = 1284, /* json_array_aggregate_order_by_clause_opt  */
  YYSYMBOL_opt_target_list = 1285,         /* opt_target_list  */
  YYSYMBOL_target_list = 1286,             /* target_list  */
  YYSYMBOL_target_el = 1287,               /* target_el  */
  YYSYMBOL_qualified_name_list = 1288,     /* qualified_name_list  */
  YYSYMBOL_qualified_name = 1289,          /* qualified_name  */
  YYSYMBOL_name_list = 1290,               /* name_list  */
  YYSYMBOL_name = 1291,                    /* name  */
  YYSYMBOL_attr_name = 1292,               /* attr_name  */
  YYSYMBOL_file_name = 1293,               /* file_name  */
  YYSYMBOL_func_name = 1294,               /* func_name  */
  YYSYMBOL_AexprConst = 1295,              /* AexprConst  */
  YYSYMBOL_Iconst = 1296,                  /* Iconst  */
  YYSYMBOL_Sconst = 1297,                  /* Sconst  */
  YYSYMBOL_SignedIconst = 1298,            /* SignedIconst  */
  YYSYMBOL_RoleId = 1299,                  /* RoleId  */
  YYSYMBOL_RoleSpec = 1300,                /* RoleSpec  */
  YYSYMBOL_role_list = 1301,               /* role_list  */
  YYSYMBOL_PLpgSQL_Expr = 1302,            /* PLpgSQL_Expr  */
  YYSYMBOL_PLAssignStmt = 1303,            /* PLAssignStmt  */
  YYSYMBOL_plassign_target = 1304,         /* plassign_target  */
  YYSYMBOL_plassign_equals = 1305,         /* plassign_equals  */
  YYSYMBOL_ColId = 1306,                   /* ColId  */
  YYSYMBOL_type_function_name = 1307,      /* type_function_name  */
  YYSYMBOL_NonReservedWord = 1308,         /* NonReservedWord  */
  YYSYMBOL_ColLabel = 1309,                /* ColLabel  */
  YYSYMBOL_BareColLabel = 1310,            /* BareColLabel  */
  YYSYMBOL_unreserved_keyword = 1311,      /* unreserved_keyword  */
  YYSYMBOL_col_name_keyword = 1312,        /* col_name_keyword  */
  YYSYMBOL_type_func_name_keyword = 1313,  /* type_func_name_keyword  */
  YYSYMBOL_reserved_keyword = 1314,        /* reserved_keyword  */
  YYSYMBOL_bare_label_keyword = 1315       /* bare_label_keyword  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  930
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   119082

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  536
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  780
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3442
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  6471

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   773


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   523,     2,     2,
     528,   529,   521,   519,   534,   520,   530,   522,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   535,   533,
     516,   518,   517,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   526,     2,   527,   524,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   525,   531,   532
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   974,   974,   978,   982,   987,   995,  1003,  1023,  1035,
    1049,  1050,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,
    1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,
    1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,
    1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,
    1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,
    1112,  1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,
    1122,  1123,  1124,  1125,  1126,  1127,  1128,  1129,  1130,  1131,
    1132,  1133,  1134,  1135,  1136,  1137,  1138,  1139,  1140,  1141,
    1142,  1143,  1144,  1145,  1146,  1147,  1148,  1149,  1150,  1151,
    1152,  1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,
    1162,  1163,  1164,  1165,  1166,  1167,  1168,  1169,  1170,  1171,
    1172,  1173,  1174,  1175,  1176,  1177,  1179,  1188,  1204,  1216,
    1217,  1218,  1227,  1228,  1232,  1233,  1237,  1242,  1246,  1256,
    1264,  1268,  1272,  1277,  1281,  1329,  1331,  1335,  1339,  1343,
    1347,  1361,  1380,  1389,  1401,  1402,  1406,  1415,  1424,  1433,
    1455,  1463,  1471,  1479,  1487,  1495,  1513,  1532,  1544,  1545,
    1556,  1567,  1578,  1594,  1613,  1614,  1618,  1625,  1633,  1634,
    1635,  1636,  1637,  1638,  1652,  1659,  1666,  1676,  1685,  1694,
    1698,  1707,  1716,  1724,  1735,  1736,  1745,  1757,  1765,  1774,
    1786,  1795,  1804,  1812,  1822,  1833,  1834,  1838,  1839,  1842,
    1844,  1848,  1849,  1850,  1851,  1855,  1856,  1857,  1863,  1875,
    1879,  1883,  1900,  1908,  1909,  1910,  1914,  1915,  1916,  1920,
    1921,  1925,  1929,  1930,  1938,  1946,  1957,  1965,  1976,  1977,
    1982,  1983,  1988,  1995,  2002,  2009,  2016,  2027,  2038,  2039,
    2043,  2044,  2052,  2068,  2075,  2082,  2089,  2096,  2116,  2126,
    2136,  2146,  2156,  2168,  2180,  2190,  2200,  2210,  2222,  2234,
    2244,  2254,  2264,  2274,  2284,  2294,  2306,  2318,  2328,  2341,
    2342,  2347,  2361,  2374,  2390,  2407,  2417,  2427,  2437,  2447,
    2457,  2466,  2475,  2484,  2494,  2504,  2520,  2530,  2540,  2550,
    2560,  2577,  2587,  2597,  2607,  2618,  2632,  2648,  2658,  2667,
    2683,  2692,  2703,  2714,  2722,  2731,  2740,  2748,  2756,  2765,
    2774,  2783,  2791,  2799,  2808,  2816,  2824,  2833,  2842,  2851,
    2860,  2869,  2878,  2889,  2897,  2906,  2915,  2924,  2933,  2942,
    2951,  2959,  2967,  2975,  2982,  2993,  2994,  2998,  2999,  3000,
    3004,  3013,  3017,  3018,  3022,  3030,  3038,  3046,  3057,  3060,
    3061,  3065,  3066,  3071,  3075,  3079,  3084,  3091,  3093,  3098,
    3102,  3106,  3117,  3125,  3178,  3191,  3205,  3217,  3224,  3228,
    3242,  3255,  3256,  3261,  3271,  3282,  3293,  3320,  3327,  3361,
    3397,  3420,  3421,  3425,  3426,  3435,  3436,  3437,  3440,  3441,
    3446,  3447,  3451,  3455,  3459,  3463,  3467,  3471,  3475,  3479,
    3483,  3487,  3491,  3495,  3499,  3508,  3512,  3516,  3520,  3524,
    3525,  3530,  3534,  3541,  3548,  3549,  3550,  3551,  3552,  3556,
    3560,  3568,  3579,  3599,  3619,  3640,  3661,  3682,  3716,  3717,
    3718,  3719,  3720,  3727,  3734,  3735,  3739,  3740,  3744,  3745,
    3749,  3753,  3760,  3764,  3771,  3772,  3773,  3777,  3778,  3781,
    3804,  3823,  3845,  3846,  3850,  3851,  3855,  3856,  3860,  3868,
    3869,  3870,  3902,  3910,  3918,  3931,  3943,  3956,  3966,  3976,
    4000,  4020,  4021,  4022,  4026,  4027,  4046,  4054,  4062,  4070,
    4082,  4094,  4095,  4096,  4100,  4101,  4102,  4103,  4104,  4105,
    4106,  4107,  4108,  4109,  4118,  4126,  4130,  4144,  4162,  4178,
    4195,  4211,  4231,  4254,  4255,  4259,  4260,  4264,  4265,  4268,
    4274,  4275,  4278,  4282,  4290,  4295,  4301,  4302,  4306,  4311,
    4318,  4319,  4323,  4333,  4343,  4351,  4360,  4373,  4385,  4392,
    4400,  4408,  4416,  4424,  4434,  4435,  4439,  4440,  4443,  4455,
    4456,  4459,  4470,  4481,  4495,  4496,  4501,  4502,  4503,  4506,
    4507,  4508,  4509,  4512,  4513,  4516,  4517,  4520,  4538,  4551,
    4573,  4574,  4577,  4583,  4589,  4606,  4615,  4637,  4651,  4668,
    4684,  4685,  4686,  4698,  4712,  4729,  4743,  4744,  4756,  4777,
    4788,  4802,  4811,  4823,  4824,  4827,  4828,  4831,  4832,  4835,
    4839,  4843,  4847,  4851,  4855,  4859,  4863,  4867,  4871,  4875,
    4880,  4884,  4888,  4894,  4895,  4899,  4900,  4901,  4908,  4911,
    4912,  4924,  4940,  4956,  4957,  4965,  4966,  4970,  4971,  4975,
    4976,  4980,  4981,  4985,  4986,  4996,  5008,  5009,  5022,  5030,
    5048,  5057,  5069,  5072,  5076,  5080,  5084,  5091,  5103,  5114,
    5117,  5121,  5134,  5144,  5154,  5164,  5174,  5184,  5194,  5204,
    5214,  5224,  5234,  5244,  5254,  5273,  5285,  5286,  5287,  5288,
    5292,  5293,  5297,  5298,  5308,  5317,  5330,  5331,  5335,  5339,
    5347,  5351,  5355,  5362,  5366,  5371,  5376,  5383,  5390,  5395,
    5405,  5418,  5434,  5435,  5440,  5441,  5445,  5446,  5456,  5466,
    5475,  5493,  5514,  5535,  5557,  5591,  5607,  5608,  5612,  5621,
    5636,  5646,  5659,  5660,  5672,  5681,  5699,  5724,  5742,  5757,
    5758,  5762,  5763,  5767,  5768,  5772,  5773,  5777,  5791,  5795,
    5796,  5800,  5801,  5802,  5803,  5804,  5814,  5826,  5827,  5838,
    5861,  5893,  5894,  5895,  5899,  5901,  5923,  5925,  5927,  5929,
    5931,  5936,  5937,  5941,  5942,  5946,  5958,  5959,  5963,  5972,
    5976,  5980,  5985,  5995,  5996,  6000,  6001,  6005,  6006,  6010,
    6011,  6015,  6016,  6017,  6021,  6025,  6026,  6027,  6031,  6032,
    6037,  6038,  6065,  6066,  6067,  6068,  6069,  6070,  6083,  6094,
    6109,  6111,  6116,  6121,  6123,  6128,  6139,  6140,  6141,  6142,
    6153,  6172,  6184,  6197,  6208,  6219,  6231,  6240,  6248,  6256,
    6266,  6276,  6286,  6296,  6306,  6317,  6327,  6340,  6343,  6344,
    6347,  6351,  6358,  6359,  6360,  6361,  6362,  6363,  6366,  6369,
    6370,  6378,  6385,  6386,  6389,  6391,  6402,  6414,  6426,  6438,
    6452,  6453,  6469,  6485,  6486,  6490,  6503,  6514,  6523,  6533,
    6543,  6544,  6547,  6548,  6551,  6552,  6553,  6556,  6570,  6575,
    6586,  6596,  6609,  6610,  6614,  6623,  6636,  6647,  6661,  6672,
    6695,  6706,  6725,  6736,  6747,  6758,  6769,  6780,  6791,  6802,
    6813,  6824,  6835,  6846,  6861,  6862,  6863,  6864,  6865,  6866,
    6867,  6868,  6869,  6870,  6871,  6872,  6873,  6883,  6884,  6885,
    6886,  6887,  6891,  6892,  6893,  6894,  6895,  6896,  6897,  6898,
    6903,  6904,  6905,  6909,  6910,  6913,  6914,  6917,  6919,  6924,
    6925,  6936,  6948,  6949,  6950,  6960,  6969,  6978,  6987,  6996,
    7005,  7014,  7023,  7032,  7041,  7055,  7064,  7073,  7082,  7091,
    7100,  7109,  7118,  7130,  7131,  7145,  7156,  7167,  7178,  7189,
    7200,  7211,  7222,  7233,  7244,  7257,  7258,  7261,  7262,  7272,
    7279,  7288,  7297,  7306,  7315,  7324,  7333,  7342,  7351,  7360,
    7369,  7378,  7387,  7396,  7405,  7414,  7423,  7434,  7435,  7438,
    7439,  7449,  7467,  7483,  7511,  7513,  7515,  7517,  7525,  7535,
    7536,  7539,  7547,  7555,  7563,  7570,  7581,  7585,  7592,  7596,
    7607,  7616,  7625,  7634,  7643,  7652,  7661,  7670,  7679,  7688,
    7697,  7706,  7715,  7723,  7732,  7741,  7750,  7759,  7768,  7777,
    7786,  7799,  7800,  7804,  7805,  7810,  7811,  7821,  7835,  7846,
    7859,  7860,  7863,  7864,  7874,  7885,  7886,  7890,  7894,  7898,
    7909,  7923,  7938,  7956,  7957,  7958,  7959,  7960,  7961,  7973,
    8005,  8040,  8041,  8045,  8046,  8050,  8051,  8055,  8056,  8059,
    8060,  8065,  8077,  8096,  8101,  8106,  8113,  8114,  8117,  8118,
    8121,  8122,  8125,  8126,  8129,  8130,  8131,  8134,  8135,  8136,
    8152,  8166,  8181,  8195,  8212,  8213,  8216,  8217,  8221,  8222,
    8226,  8227,  8232,  8246,  8254,  8262,  8278,  8279,  8283,  8284,
    8299,  8309,  8319,  8329,  8339,  8352,  8353,  8354,  8355,  8356,
    8362,  8366,  8381,  8382,  8388,  8398,  8402,  8407,  8415,  8457,
    8461,  8465,  8469,  8477,  8478,  8482,  8494,  8495,  8500,  8501,
    8506,  8507,  8514,  8518,  8522,  8526,  8530,  8534,  8538,  8542,
    8546,  8550,  8554,  8558,  8562,  8566,  8570,  8574,  8579,  8586,
    8590,  8594,  8598,  8602,  8608,  8609,  8615,  8625,  8629,  8640,
    8646,  8655,  8661,  8662,  8666,  8667,  8671,  8672,  8675,  8688,
    8692,  8707,  8716,  8725,  8738,  8739,  8744,  8745,  8762,  8773,
    8784,  8795,  8806,  8817,  8831,  8842,  8856,  8867,  8881,  8889,
    8891,  8893,  8898,  8900,  8905,  8906,  8911,  8930,  8940,  8941,
    8945,  8949,  8961,  8973,  8985,  8999,  9000,  9001,  9005,  9018,
    9019,  9029,  9042,  9046,  9050,  9054,  9061,  9082,  9095,  9108,
    9121,  9136,  9137,  9140,  9141,  9142,  9152,  9162,  9180,  9190,
    9200,  9210,  9220,  9230,  9240,  9250,  9260,  9270,  9280,  9290,
    9300,  9311,  9322,  9332,  9342,  9352,  9362,  9372,  9382,  9393,
    9404,  9415,  9426,  9437,  9448,  9459,  9470,  9481,  9492,  9503,
    9514,  9526,  9538,  9550,  9562,  9574,  9586,  9597,  9608,  9620,
    9632,  9643,  9654,  9663,  9673,  9683,  9693,  9703,  9713,  9723,
    9733,  9743,  9753,  9768,  9769,  9772,  9773,  9783,  9793,  9803,
    9813,  9824,  9834,  9846,  9847,  9857,  9867,  9877,  9887,  9897,
    9907,  9917,  9927,  9937,  9947,  9957,  9967,  9977,  9987,  9997,
   10007, 10017, 10027, 10037, 10047, 10057, 10067, 10077, 10087, 10097,
   10107, 10117, 10136, 10146, 10147, 10150, 10152, 10158, 10159, 10160,
   10161, 10162, 10174, 10190, 10199, 10208, 10217, 10226, 10235, 10244,
   10253, 10262, 10271, 10280, 10289, 10298, 10307, 10316, 10325, 10334,
   10343, 10352, 10361, 10370, 10379, 10388, 10397, 10425, 10433, 10442,
   10468, 10477, 10484, 10490, 10517, 10528, 10537, 10545, 10547, 10569,
   10577, 10587, 10597, 10616, 10635, 10645, 10655, 10665, 10676, 10687,
   10698, 10709, 10720, 10738, 10747, 10764, 10782, 10783, 10784, 10789,
   10795, 10804, 10805, 10806, 10807, 10808, 10812, 10813, 10816, 10817,
   10818, 10819, 10823, 10824, 10825, 10837, 10848, 10849, 10852, 10862,
   10869, 10889, 10898, 10906, 10915, 10924, 10932, 10940, 10948, 10956,
   10964, 10972, 10980, 10991, 10999, 11010, 11011, 11012, 11016, 11019,
   11022, 11025, 11028, 11035, 11037, 11039, 11044, 11046, 11050, 11051,
   11052, 11064, 11078, 11092, 11111, 11133, 11134, 11135, 11136, 11146,
   11163, 11174, 11175, 11179, 11180, 11184, 11188, 11192, 11210, 11211,
   11212, 11213, 11214, 11215, 11216, 11223, 11224, 11235, 11243, 11251,
   11260, 11270, 11288, 11297, 11306, 11315, 11327, 11331, 11342, 11354,
   11372, 11379, 11396, 11410, 11420, 11429, 11438, 11448, 11460, 11472,
   11483, 11484, 11495, 11506, 11518, 11530, 11542, 11554, 11564, 11577,
   11578, 11592, 11617, 11629, 11638, 11650, 11664, 11665, 11677, 11698,
   11709, 11721, 11733, 11737, 11744, 11745, 11749, 11756, 11757, 11761,
   11762, 11763, 11767, 11768, 11772, 11773, 11776, 11777, 11780, 11781,
   11785, 11786, 11790, 11797, 11799, 11804, 11805, 11818, 11826, 11837,
   11845, 11856, 11857, 11858, 11859, 11860, 11861, 11862, 11863, 11864,
   11865, 11875, 11886, 11887, 11891, 11892, 11893, 11894, 11895, 11905,
   11913, 11931, 11951, 11952, 11962, 11969, 11976, 11983, 12000, 12018,
   12022, 12030, 12036, 12043, 12049, 12056, 12065, 12066, 12070, 12072,
   12077, 12088, 12098, 12108, 12114, 12123, 12132, 12138, 12139, 12150,
   12165, 12166, 12177, 12188, 12189, 12192, 12193, 12194, 12195, 12196,
   12197, 12198, 12199, 12202, 12203, 12207, 12208, 12209, 12220, 12239,
   12240, 12244, 12249, 12273, 12284, 12285, 12297, 12315, 12316, 12320,
   12327, 12334, 12341, 12351, 12364, 12365, 12369, 12382, 12395, 12404,
   12413, 12422, 12431, 12443, 12455, 12467, 12470, 12471, 12472, 12473,
   12474, 12475, 12478, 12479, 12480, 12528, 12529, 12533, 12534, 12549,
   12550, 12557, 12565, 12573, 12581, 12589, 12597, 12608, 12609, 12641,
   12657, 12674, 12675, 12694, 12698, 12702, 12717, 12724, 12731, 12741,
   12742, 12745, 12761, 12762, 12763, 12767, 12777, 12788, 12794, 12806,
   12819, 12825, 12826, 12830, 12842, 12850, 12855, 12860, 12865, 12870,
   12878, 12886, 12891, 12896, 12903, 12904, 12908, 12909, 12910, 12917,
   12918, 12922, 12923, 12927, 12928, 12932, 12933, 12937, 12941, 12942,
   12945, 12954, 12967, 12972, 12977, 12981, 12993, 12994, 12998, 13007,
   13023, 13032, 13041, 13050, 13062, 13065, 13070, 13071, 13079, 13099,
   13100, 13102, 13107, 13108, 13112, 13113, 13116, 13117, 13142, 13151,
   13161, 13162, 13166, 13167, 13168, 13169, 13170, 13174, 13187, 13194,
   13201, 13208, 13209, 13213, 13214, 13218, 13219, 13223, 13224, 13228,
   13240, 13241, 13242, 13243, 13247, 13248, 13258, 13265, 13284, 13285,
   13289, 13290, 13296, 13301, 13310, 13318, 13327, 13334, 13342, 13378,
   13404, 13408, 13413, 13420, 13449, 13453, 13467, 13488, 13510, 13523,
   13540, 13546, 13551, 13557, 13564, 13565, 13575, 13581, 13589, 13593,
   13597, 13604, 13612, 13617, 13618, 13619, 13620, 13624, 13625, 13640,
   13644, 13652, 13659, 13666, 13673, 13680, 13691, 13692, 13705, 13709,
   13717, 13731, 13745, 13746, 13761, 13772, 13785, 13790, 13791, 13794,
   13795, 13798, 13799, 13804, 13805, 13810, 13811, 13820, 13825, 13826,
   13830, 13834, 13840, 13865, 13876, 13890, 13891, 13895, 13909, 13966,
   13980, 13982, 13987, 13989, 13991, 13993, 13995, 14000, 14002, 14007,
   14015, 14035, 14040, 14047, 14052, 14058, 14063, 14072, 14074, 14077,
   14081, 14082, 14083, 14084, 14085, 14086, 14091, 14097, 14112, 14113,
   14114, 14115, 14116, 14127, 14133, 14141, 14142, 14148, 14153, 14158,
   14163, 14168, 14173, 14178, 14183, 14189, 14195, 14201, 14208, 14230,
   14239, 14243, 14251, 14255, 14263, 14275, 14296, 14300, 14306, 14310,
   14323, 14331, 14341, 14343, 14345, 14347, 14349, 14351, 14356, 14357,
   14364, 14373, 14381, 14390, 14401, 14409, 14410, 14411, 14415, 14417,
   14419, 14421, 14423, 14425, 14427, 14432, 14437, 14443, 14451, 14456,
   14463, 14470, 14474, 14478, 14486, 14521, 14522, 14524, 14533, 14549,
   14551, 14553, 14555, 14557, 14559, 14561, 14563, 14565, 14567, 14569,
   14571, 14573, 14575, 14578, 14580, 14583, 14585, 14587, 14589, 14592,
   14597, 14606, 14611, 14620, 14625, 14634, 14639, 14649, 14658, 14667,
   14676, 14695, 14704, 14713, 14722, 14731, 14748, 14757, 14766, 14775,
   14784, 14793, 14802, 14806, 14810, 14818, 14826, 14834, 14842, 14863,
   14886, 14898, 14905, 14921, 14926, 14932, 14939, 14946, 14954, 14962,
   14981, 15003, 15029, 15031, 15033, 15035, 15037, 15039, 15041, 15043,
   15045, 15047, 15049, 15051, 15053, 15055, 15057, 15059, 15061, 15063,
   15065, 15069, 15073, 15078, 15087, 15088, 15089, 15090, 15091, 15095,
   15096, 15097, 15101, 15102, 15113, 15114, 15115, 15132, 15145, 15147,
   15149, 15161, 15186, 15198, 15210, 15218, 15229, 15240, 15250, 15256,
   15265, 15275, 15285, 15298, 15308, 15339, 15375, 15385, 15396, 15397,
   15398, 15405, 15412, 15416, 15420, 15424, 15428, 15432, 15436, 15440,
   15444, 15448, 15452, 15456, 15460, 15464, 15468, 15472, 15474, 15481,
   15488, 15495, 15502, 15513, 15527, 15537, 15548, 15564, 15574, 15581,
   15588, 15595, 15599, 15607, 15616, 15625, 15629, 15633, 15637, 15641,
   15645, 15654, 15658, 15668, 15672, 15676, 15681, 15691, 15698, 15700,
   15704, 15706, 15708, 15711, 15714, 15717, 15718, 15721, 15729, 15739,
   15740, 15743, 15744, 15745, 15750, 15754, 15758, 15762, 15769, 15770,
   15778, 15779, 15783, 15784, 15792, 15793, 15797, 15798, 15803, 15812,
   15814, 15829, 15832, 15860, 15861, 15864, 15865, 15873, 15881, 15889,
   15898, 15908, 15926, 15972, 15981, 15990, 15999, 16008, 16020, 16021,
   16022, 16023, 16024, 16038, 16039, 16040, 16043, 16044, 16047, 16050,
   16051, 16052, 16055, 16056, 16059, 16060, 16061, 16062, 16063, 16064,
   16065, 16066, 16067, 16068, 16069, 16070, 16073, 16075, 16080, 16082,
   16087, 16089, 16091, 16093, 16095, 16097, 16109, 16113, 16120, 16124,
   16130, 16134, 16144, 16156, 16157, 16160, 16161, 16164, 16168, 16172,
   16178, 16179, 16184, 16194, 16195, 16196, 16197, 16198, 16199, 16200,
   16201, 16205, 16206, 16207, 16208, 16213, 16218, 16227, 16248, 16252,
   16257, 16268, 16285, 16291, 16292, 16293, 16296, 16304, 16314, 16329,
   16330, 16334, 16346, 16347, 16350, 16351, 16354, 16358, 16365, 16369,
   16373, 16382, 16394, 16395, 16399, 16400, 16404, 16405, 16408, 16409,
   16414, 16415, 16416, 16417, 16418, 16419, 16420, 16424, 16438, 16450,
   16462, 16481, 16497, 16501, 16505, 16506, 16510, 16514, 16515, 16519,
   16520, 16524, 16535, 16542, 16548, 16554, 16562, 16563, 16567, 16571,
   16575, 16579, 16583, 16587, 16591, 16595, 16597, 16601, 16605, 16610,
   16611, 16612, 16616, 16618, 16620, 16623, 16627, 16655, 16656, 16660,
   16661, 16665, 16666, 16670, 16671, 16672, 16676, 16677, 16681, 16682,
   16686, 16687, 16691, 16692, 16693, 16694, 16695, 16699, 16701, 16703,
   16706, 16710, 16729, 16733, 16735, 16740, 16741, 16742, 16743, 16744,
   16748, 16760, 16783, 16804, 16805, 16809, 16810, 16814, 16815, 16819,
   16847, 16863, 16864, 16868, 16869, 16870, 16874, 16878, 16879, 16880,
   16884, 16896, 16897, 16901, 16906, 16911, 16912, 16916, 16918, 16923,
   16925, 16930, 16931, 16939, 16951, 16952, 16954, 16955, 16960, 16961,
   16965, 16966, 16970, 16980, 16984, 16993, 16997, 17015, 17016, 17020,
   17021, 17022, 17023, 17027, 17028, 17032, 17039, 17040, 17044, 17053,
   17064, 17076, 17087, 17089, 17099, 17102, 17107, 17108, 17109, 17113,
   17127, 17144, 17159, 17160, 17164, 17165, 17166, 17170, 17171, 17175,
   17196, 17216, 17217, 17226, 17227, 17231, 17232, 17235, 17243, 17251,
   17259, 17282, 17283, 17294, 17298, 17304, 17306, 17311, 17313, 17315,
   17325, 17327, 17338, 17342, 17346, 17350, 17354, 17363, 17371, 17403,
   17407, 17414, 17422, 17426, 17430, 17436, 17437, 17439, 17440, 17441,
   17445, 17486, 17514, 17518, 17522, 17528, 17530, 17544, 17580, 17593,
   17594, 17597, 17598, 17615, 17616, 17617, 17622, 17623, 17624, 17629,
   17630, 17631, 17632, 17638, 17639, 17640, 17641, 17642, 17648, 17649,
   17669, 17670, 17671, 17672, 17673, 17674, 17675, 17676, 17677, 17678,
   17679, 17680, 17681, 17682, 17683, 17684, 17685, 17686, 17687, 17688,
   17689, 17690, 17691, 17692, 17693, 17694, 17695, 17696, 17697, 17698,
   17699, 17700, 17701, 17702, 17703, 17704, 17705, 17706, 17707, 17708,
   17709, 17710, 17711, 17712, 17713, 17714, 17715, 17716, 17717, 17718,
   17719, 17720, 17721, 17722, 17723, 17724, 17725, 17726, 17727, 17728,
   17729, 17730, 17731, 17732, 17733, 17734, 17735, 17736, 17737, 17738,
   17739, 17740, 17741, 17742, 17743, 17744, 17745, 17746, 17747, 17748,
   17749, 17750, 17751, 17752, 17753, 17754, 17755, 17756, 17757, 17758,
   17759, 17760, 17761, 17762, 17763, 17764, 17765, 17766, 17767, 17768,
   17769, 17770, 17771, 17772, 17773, 17774, 17775, 17776, 17777, 17778,
   17779, 17780, 17781, 17782, 17783, 17784, 17785, 17786, 17787, 17788,
   17789, 17790, 17791, 17792, 17793, 17794, 17795, 17796, 17797, 17798,
   17799, 17800, 17801, 17802, 17803, 17804, 17805, 17806, 17807, 17808,
   17809, 17810, 17811, 17812, 17813, 17814, 17815, 17816, 17817, 17818,
   17819, 17820, 17821, 17822, 17823, 17824, 17825, 17826, 17827, 17828,
   17829, 17830, 17831, 17832, 17833, 17834, 17835, 17836, 17837, 17838,
   17839, 17840, 17841, 17842, 17843, 17844, 17845, 17846, 17847, 17848,
   17849, 17850, 17851, 17852, 17853, 17854, 17855, 17856, 17857, 17858,
   17859, 17860, 17861, 17862, 17863, 17864, 17865, 17866, 17867, 17868,
   17869, 17870, 17871, 17872, 17873, 17874, 17875, 17876, 17877, 17878,
   17879, 17880, 17881, 17882, 17883, 17884, 17885, 17886, 17887, 17888,
   17889, 17890, 17891, 17892, 17893, 17894, 17895, 17896, 17897, 17898,
   17899, 17900, 17901, 17902, 17903, 17904, 17905, 17906, 17907, 17908,
   17909, 17910, 17911, 17912, 17913, 17914, 17915, 17916, 17917, 17918,
   17919, 17920, 17921, 17922, 17923, 17924, 17925, 17926, 17927, 17928,
   17929, 17930, 17931, 17932, 17933, 17934, 17935, 17936, 17937, 17938,
   17939, 17940, 17941, 17942, 17943, 17944, 17945, 17946, 17947, 17948,
   17949, 17950, 17951, 17952, 17953, 17954, 17955, 17956, 17957, 17958,
   17959, 17960, 17961, 17962, 17963, 17964, 17965, 17966, 17967, 17968,
   17969, 17970, 17971, 17972, 17973, 17974, 17975, 17976, 17977, 17978,
   17979, 17980, 17981, 17982, 17983, 17984, 17985, 17986, 17987, 17988,
   17989, 17990, 17991, 17992, 18006, 18007, 18008, 18009, 18010, 18011,
   18012, 18013, 18014, 18015, 18016, 18017, 18018, 18019, 18020, 18021,
   18022, 18023, 18024, 18025, 18026, 18027, 18028, 18029, 18030, 18031,
   18032, 18033, 18034, 18035, 18036, 18037, 18038, 18039, 18040, 18041,
   18042, 18043, 18044, 18045, 18046, 18047, 18048, 18049, 18050, 18051,
   18052, 18053, 18054, 18055, 18056, 18057, 18058, 18059, 18060, 18061,
   18062, 18063, 18064, 18065, 18066, 18067, 18081, 18082, 18083, 18084,
   18085, 18086, 18087, 18088, 18089, 18090, 18091, 18092, 18093, 18094,
   18095, 18096, 18097, 18098, 18099, 18100, 18101, 18102, 18103, 18113,
   18114, 18115, 18116, 18117, 18118, 18119, 18120, 18121, 18122, 18123,
   18124, 18125, 18126, 18127, 18128, 18129, 18130, 18131, 18132, 18133,
   18134, 18135, 18136, 18137, 18138, 18139, 18140, 18141, 18142, 18143,
   18144, 18145, 18146, 18147, 18148, 18149, 18150, 18151, 18152, 18153,
   18154, 18155, 18156, 18157, 18158, 18159, 18160, 18161, 18162, 18163,
   18164, 18165, 18166, 18167, 18168, 18169, 18170, 18171, 18172, 18173,
   18174, 18175, 18176, 18177, 18178, 18179, 18180, 18181, 18182, 18183,
   18184, 18185, 18186, 18187, 18188, 18189, 18202, 18203, 18204, 18205,
   18206, 18207, 18208, 18209, 18210, 18211, 18212, 18213, 18214, 18215,
   18216, 18217, 18218, 18219, 18220, 18221, 18222, 18223, 18224, 18225,
   18226, 18227, 18228, 18229, 18230, 18231, 18232, 18233, 18234, 18235,
   18236, 18237, 18238, 18239, 18240, 18241, 18242, 18243, 18244, 18245,
   18246, 18247, 18248, 18249, 18250, 18251, 18252, 18253, 18254, 18255,
   18256, 18257, 18258, 18259, 18260, 18261, 18262, 18263, 18264, 18265,
   18266, 18267, 18268, 18269, 18270, 18271, 18272, 18273, 18274, 18275,
   18276, 18277, 18278, 18279, 18280, 18281, 18282, 18283, 18284, 18285,
   18286, 18287, 18288, 18289, 18290, 18291, 18292, 18293, 18294, 18295,
   18296, 18297, 18298, 18299, 18300, 18301, 18302, 18303, 18304, 18305,
   18306, 18307, 18308, 18309, 18310, 18311, 18312, 18313, 18314, 18315,
   18316, 18317, 18318, 18319, 18320, 18321, 18322, 18323, 18324, 18325,
   18326, 18327, 18328, 18329, 18330, 18331, 18332, 18333, 18334, 18335,
   18336, 18337, 18338, 18339, 18340, 18341, 18342, 18343, 18344, 18345,
   18346, 18347, 18348, 18349, 18350, 18351, 18352, 18353, 18354, 18355,
   18356, 18357, 18358, 18359, 18360, 18361, 18362, 18363, 18364, 18365,
   18366, 18367, 18368, 18369, 18370, 18371, 18372, 18373, 18374, 18375,
   18376, 18377, 18378, 18379, 18380, 18381, 18382, 18383, 18384, 18385,
   18386, 18387, 18388, 18389, 18390, 18391, 18392, 18393, 18394, 18395,
   18396, 18397, 18398, 18399, 18400, 18401, 18402, 18403, 18404, 18405,
   18406, 18407, 18408, 18409, 18410, 18411, 18412, 18413, 18414, 18415,
   18416, 18417, 18418, 18419, 18420, 18421, 18422, 18423, 18424, 18425,
   18426, 18427, 18428, 18429, 18430, 18431, 18432, 18433, 18434, 18435,
   18436, 18437, 18438, 18439, 18440, 18441, 18442, 18443, 18444, 18445,
   18446, 18447, 18448, 18449, 18450, 18451, 18452, 18453, 18454, 18455,
   18456, 18457, 18458, 18459, 18460, 18461, 18462, 18463, 18464, 18465,
   18466, 18467, 18468, 18469, 18470, 18471, 18472, 18473, 18474, 18475,
   18476, 18477, 18478, 18479, 18480, 18481, 18482, 18483, 18484, 18485,
   18486, 18487, 18488, 18489, 18490, 18491, 18492, 18493, 18494, 18495,
   18496, 18497, 18498, 18499, 18500, 18501, 18502, 18503, 18504, 18505,
   18506, 18507, 18508, 18509, 18510, 18511, 18512, 18513, 18514, 18515,
   18516, 18517, 18518, 18519, 18520, 18521, 18522, 18523, 18524, 18525,
   18526, 18527, 18528, 18529, 18530, 18531, 18532, 18533, 18534, 18535,
   18536, 18537, 18538, 18539, 18540, 18541, 18542, 18543, 18544, 18545,
   18546, 18547, 18548, 18549, 18550, 18551, 18552, 18553, 18554, 18555,
   18556, 18557, 18558, 18559, 18560, 18561, 18562, 18563, 18564, 18565,
   18566, 18567, 18568, 18569, 18570, 18571, 18572, 18573, 18574, 18575,
   18576, 18577, 18578, 18579, 18580, 18581, 18582, 18583, 18584, 18585,
   18586, 18587, 18588, 18589, 18590, 18591, 18592, 18593, 18594, 18595,
   18596, 18597, 18598, 18599, 18600, 18601, 18602, 18603, 18604, 18605,
   18606, 18607, 18608, 18609, 18610, 18611, 18612, 18613, 18614, 18615,
   18616, 18617, 18618, 18619, 18620, 18621, 18622, 18623, 18624, 18625,
   18626, 18627, 18628, 18629, 18630, 18631, 18632, 18633, 18634, 18635,
   18636, 18637, 18638, 18639, 18640, 18641, 18642, 18643, 18644, 18645,
   18646, 18647, 18648
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "IDENT", "UIDENT",
  "FCONST", "SCONST", "USCONST", "BCONST", "XCONST", "Op", "ICONST",
  "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS", "EQUALS_GREATER",
  "LESS_EQUALS", "GREATER_EQUALS", "NOT_EQUALS", "ABORT_P", "ABSENT",
  "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE",
  "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY",
  "ARRAY", "AS", "ASC", "ASENSITIVE", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "ATOMIC", "AT", "ATTACH", "ATTRIBUTE", "AUTHORIZATION",
  "BACKWARD", "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT",
  "BOOLEAN_P", "BOTH", "BREADTH", "BY", "CACHE", "CALL", "CALLED",
  "CASCADE", "CASCADED", "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P",
  "CHARACTER", "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE",
  "CLUSTER", "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COLUMNS",
  "COMMENT", "COMMENTS", "COMMIT", "COMMITTED", "COMPRESSION",
  "CONCURRENTLY", "CONDITIONAL", "CONFIGURATION", "CONFLICT", "CONNECTION",
  "CONSTRAINT", "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P",
  "COPY", "COST", "CREATE", "CROSS", "CSV", "CUBE", "CURRENT_P",
  "CURRENT_CATALOG", "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA",
  "CURRENT_TIME", "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE",
  "DATA_P", "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P",
  "DECLARE", "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER",
  "DELETE_P", "DELIMITER", "DELIMITERS", "DEPENDS", "DEPTH", "DESC",
  "DETACH", "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT", "DO",
  "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE", "EMPTY_P",
  "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ERROR_P",
  "ESCAPE", "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE",
  "EXECUTE", "EXISTS", "EXPLAIN", "EXPRESSION", "EXTENSION", "EXTERNAL",
  "EXTRACT", "FALSE_P", "FAMILY", "FETCH", "FILTER", "FINALIZE", "FIRST_P",
  "FLOAT_P", "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORMAT", "FORWARD",
  "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS", "GENERATED", "GLOBAL",
  "GRANT", "GRANTED", "GREATEST", "GROUP_P", "GROUPING", "GROUPS",
  "HANDLER", "HAVING", "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P",
  "ILIKE", "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P", "IMPORT_P", "IN_P",
  "INCLUDE", "INCLUDING", "INCREMENT", "INDEX", "INDEXES", "INHERIT",
  "INHERITS", "INITIALLY", "INLINE_P", "INNER_P", "INOUT", "INPUT_P",
  "INSENSITIVE", "INSERT", "INSTEAD", "INT_P", "INTEGER", "INTERSECT",
  "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL", "ISOLATION", "JOIN",
  "JSON", "JSON_ARRAY", "JSON_ARRAYAGG", "JSON_EXISTS", "JSON_OBJECT",
  "JSON_OBJECTAGG", "JSON_QUERY", "JSON_SCALAR", "JSON_SERIALIZE",
  "JSON_TABLE", "JSON_VALUE", "KEY", "KEYS", "KEEP", "LABEL", "LANGUAGE",
  "LARGE_P", "LAST_P", "LATERAL_P", "LEADING", "LEAKPROOF", "LEAST",
  "LEFT", "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED", "LOGGED", "MAPPING",
  "MATCH", "MATCHED", "MATERIALIZED", "MAXVALUE", "MERGE", "METHOD",
  "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES",
  "NATIONAL", "NATURAL", "NCHAR", "NESTED", "NEW", "NEXT", "NFC", "NFD",
  "NFKC", "NFKD", "NO", "NONE", "NORMALIZE", "NORMALIZED", "NOT",
  "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P",
  "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "OLD", "OMIT",
  "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER",
  "ORDINALITY", "OTHERS", "OUT_P", "OUTER_P", "OVER", "OVERLAPS",
  "OVERLAY", "OVERRIDING", "OWNED", "OWNER", "PARALLEL", "PARAMETER",
  "PARSER", "PARTIAL", "PARTITION", "PASSING", "PASSWORD", "PATH",
  "PLACING", "PLAN", "PLANS", "POLICY", "POSITION", "PRECEDING",
  "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY", "PRIOR",
  "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROCEDURES", "PROGRAM",
  "PUBLICATION", "QUOTE", "QUOTES", "RANGE", "READ", "REAL", "REASSIGN",
  "RECHECK", "RECURSIVE", "REF", "REFERENCES", "REFERENCING", "REFRESH",
  "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE", "REPLACE",
  "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURN", "RETURNING",
  "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROLLUP", "ROUTINE",
  "ROUTINES", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCALAR", "SCHEMA",
  "SCHEMAS", "SCROLL", "SEARCH", "SECOND_P", "SECURITY", "SELECT",
  "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETS", "SETOF", "SHARE", "SHOW", "SIMILAR",
  "SIMPLE", "SKIP", "SMALLINT", "SNAPSHOT", "SOME", "SQL_P", "STABLE",
  "STANDALONE_P", "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT",
  "STORAGE", "STORED", "STRICT_P", "STRING", "STRIP_P", "SUBSCRIPTION",
  "SUBSTRING", "SUPPORT", "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE",
  "TABLES", "TABLESAMPLE", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY",
  "TEXT_P", "THEN", "TIES", "TIME", "TIMESTAMP", "TO", "TRAILING",
  "TRANSACTION", "TRANSFORM", "TREAT", "TRIGGER", "TRIM", "TRUE_P",
  "TRUNCATE", "TRUSTED", "TYPE_P", "TYPES_P", "UESCAPE", "UNBOUNDED",
  "UNCONDITIONAL", "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE",
  "UNKNOWN", "UNLISTEN", "UNLOGGED", "UNTIL", "UPDATE", "USER", "USING",
  "VACUUM", "VALID", "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES",
  "VARCHAR", "VARIADIC", "VARYING", "VERBOSE", "VERSION_P", "VIEW",
  "VIEWS", "VOLATILE", "WHEN", "WHERE", "WHITESPACE_P", "WINDOW", "WITH",
  "WITHIN", "WITHOUT", "WORK", "WRAPPER", "WRITE", "XML_P",
  "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS", "XMLFOREST",
  "XMLNAMESPACES", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "XMLTABLE", "YEAR_P", "YES_P", "ZONE", "NOT_LA", "NULLS_LA", "WITH_LA",
  "WITH_LA_UNIQUE", "WITHOUT_LA", "MODE_TYPE_NAME", "MODE_PLPGSQL_EXPR",
  "MODE_PLPGSQL_ASSIGN1", "MODE_PLPGSQL_ASSIGN2", "MODE_PLPGSQL_ASSIGN3",
  "'<'", "'>'", "'='", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS",
  "'['", "']'", "'('", "')'", "'.'", "json_table_column",
  "empty_json_unique", "';'", "','", "':'", "$accept", "parse_toplevel",
  "stmtmulti", "toplevel_stmt", "stmt", "CallStmt", "CreateRoleStmt",
  "opt_with", "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "DropRoleStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "CreateSchemaStmt", "OptSchemaName",
  "OptSchemaEltList", "schema_stmt", "VariableSetStmt", "set_rest",
  "generic_set", "set_rest_more", "var_name", "var_list", "var_value",
  "iso_level", "opt_boolean_or_string", "zone_value", "opt_encoding",
  "NonReservedWord_or_Sconst", "VariableResetStmt", "reset_rest",
  "generic_reset", "SetResetClause", "FunctionSetResetClause",
  "VariableShowStmt", "ConstraintsSetStmt", "constraints_set_list",
  "constraints_set_mode", "CheckPointStmt", "DiscardStmt",
  "AlterTableStmt", "alter_table_cmds", "partition_cmd",
  "index_partition_cmd", "alter_table_cmd", "alter_column_default",
  "opt_drop_behavior", "opt_collate_clause", "alter_using",
  "replica_identity", "reloptions", "opt_reloptions", "reloption_list",
  "reloption_elem", "alter_identity_column_option_list",
  "alter_identity_column_option", "PartitionBoundSpec",
  "hash_partbound_elem", "hash_partbound", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "copy_delimiter",
  "opt_using", "copy_generic_opt_list", "copy_generic_opt_elem",
  "copy_generic_opt_arg", "copy_generic_opt_arg_list",
  "copy_generic_opt_arg_list_item", "CreateStmt", "OptTemp",
  "OptTableElementList", "OptTypedTableElementList", "TableElementList",
  "TypedTableElementList", "TableElement", "TypedTableElement",
  "columnDef", "columnOptions", "column_compression",
  "opt_column_compression", "ColQualList", "ColConstraint",
  "ColConstraintElem", "opt_unique_null_treatment", "generated_when",
  "ConstraintAttr", "TableLikeClause", "TableLikeOptionList",
  "TableLikeOption", "TableConstraint", "ConstraintElem", "opt_no_inherit",
  "opt_column_list", "columnList", "columnElem", "opt_c_include",
  "key_match", "ExclusionConstraintList", "ExclusionConstraintElem",
  "OptWhereClause", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptPartitionSpec", "PartitionSpec",
  "part_params", "part_elem", "table_access_method_clause", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateStatsStmt", "stats_params", "stats_param", "AlterStatsStmt",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "OptParenthesizedSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "ImportForeignSchemaStmt",
  "import_qualification_type", "import_qualification",
  "CreateUserMappingStmt", "auth_ident", "DropUserMappingStmt",
  "AlterUserMappingStmt", "CreatePolicyStmt", "AlterPolicyStmt",
  "RowSecurityOptionalExpr", "RowSecurityOptionalWithCheck",
  "RowSecurityDefaultToRole", "RowSecurityOptionalToRole",
  "RowSecurityDefaultPermissive", "RowSecurityDefaultForCmd",
  "row_security_cmd", "CreateAmStmt", "am_type", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerReferencing", "TriggerTransitions", "TriggerTransition",
  "TransitionOldOrNew", "TransitionRowOrTable", "TransitionRelName",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "FUNCTION_or_PROCEDURE", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "CreateEventTrigStmt",
  "event_trigger_when_list", "event_trigger_when_item",
  "event_trigger_value_list", "AlterEventTrigStmt", "enable_trigger",
  "CreateAssertionStmt", "DefineStmt", "definition", "def_list",
  "def_elem", "def_arg", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "object_type_any_name", "object_type_name", "drop_type_name",
  "object_type_name_on_any_name", "any_name_list", "any_name", "attrs",
  "type_name_list", "TruncateStmt", "opt_restart_seqs", "CommentStmt",
  "comment_text", "SecLabelStmt", "opt_provider", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "parameter_name_list", "parameter_name", "privilege_target",
  "grantee_list", "grantee", "opt_grant_grant_option", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem_options", "index_elem", "opt_include",
  "index_including_params", "opt_collate", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "function_with_argtypes_list",
  "function_with_argtypes", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default", "aggr_arg",
  "aggr_args", "aggr_args_list", "aggregate_with_argtypes",
  "aggregate_with_argtypes_list", "opt_createfunc_opt_list",
  "createfunc_opt_list", "common_func_opt_item", "createfunc_opt_item",
  "func_as", "ReturnStmt", "opt_routine_body", "routine_body_stmt_list",
  "routine_body_stmt", "transform_type_list", "opt_definition",
  "table_func_column", "table_func_column_list", "AlterFunctionStmt",
  "alterfunc_opt_list", "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt",
  "RemoveOperStmt", "oper_argtypes", "any_operator",
  "operator_with_argtypes_list", "operator_with_argtypes", "DoStmt",
  "dostmt_opt_list", "dostmt_opt_item", "CreateCastStmt", "cast_context",
  "DropCastStmt", "opt_if_exists", "CreateTransformStmt",
  "transform_element_list", "DropTransformStmt", "ReindexStmt",
  "reindex_target_type", "reindex_target_multitable", "AlterTblSpcStmt",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectDependsStmt",
  "opt_no", "AlterObjectSchemaStmt", "AlterOperatorStmt",
  "operator_def_list", "operator_def_elem", "operator_def_arg",
  "AlterTypeStmt", "AlterOwnerStmt", "CreatePublicationStmt",
  "PublicationObjSpec", "pub_obj_list", "AlterPublicationStmt",
  "CreateSubscriptionStmt", "AlterSubscriptionStmt",
  "DropSubscriptionStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "NotifyStmt", "notify_payload", "ListenStmt", "UnlistenStmt",
  "TransactionStmt", "TransactionStmtLegacy", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "opt_transaction_chain", "ViewStmt",
  "opt_check_option", "LoadStmt", "CreatedbStmt", "createdb_opt_list",
  "createdb_opt_items", "createdb_opt_item", "createdb_opt_name",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "drop_option_list", "drop_option", "AlterCollationStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "AnalyzeStmt", "utility_option_list", "analyze_keyword",
  "utility_option_elem", "utility_option_name", "utility_option_arg",
  "opt_analyze", "opt_verbose", "opt_full", "opt_freeze", "opt_name_list",
  "vacuum_relation", "vacuum_relation_list", "opt_vacuum_relation_list",
  "ExplainStmt", "ExplainableStmt", "PrepareStmt", "prep_type_clause",
  "PreparableStmt", "ExecuteStmt", "execute_param_clause",
  "DeallocateStmt", "InsertStmt", "insert_target", "insert_rest",
  "override_kind", "insert_column_list", "insert_column_item",
  "opt_on_conflict", "opt_conf_expr", "returning_clause", "DeleteStmt",
  "using_clause", "LockStmt", "opt_lock", "lock_type", "opt_nowait",
  "opt_nowait_or_skip", "UpdateStmt", "set_clause_list", "set_clause",
  "set_target", "set_target_list", "MergeStmt", "merge_when_list",
  "merge_when_clause", "opt_merge_when_condition", "merge_update",
  "merge_delete", "merge_insert", "merge_values_clause",
  "DeclareCursorStmt", "cursor_name", "cursor_options", "opt_hold",
  "SelectStmt", "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "with_clause", "cte_list", "common_table_expr",
  "opt_materialized", "opt_search_clause", "opt_cycle_clause",
  "opt_with_clause", "into_clause", "OptTempTableName", "opt_table",
  "set_quantifier", "distinct_clause", "opt_all_clause",
  "opt_distinct_clause", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "limit_clause",
  "offset_clause", "select_limit_value", "select_offset_value",
  "select_fetch_first_value", "I_or_F_const", "row_or_rows",
  "first_or_next", "group_clause", "group_by_list", "group_by_item",
  "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "opt_alias_clause_for_join_using",
  "func_alias_clause", "join_type", "opt_outer", "join_qual",
  "relation_expr", "extended_relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "xmltable", "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "JsonType", "a_expr", "b_expr", "json_predicate_type_constraint_opt",
  "json_key_uniqueness_constraint_opt", "unique_keys", "c_expr",
  "func_application", "func_expr", "func_expr_windowless",
  "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "xml_passing_mech", "within_group_clause",
  "filter_clause", "window_clause", "window_definition_list",
  "window_definition", "over_clause", "window_specification",
  "opt_existing_window_name", "opt_partition_clause", "opt_frame_clause",
  "frame_extent", "frame_bound", "opt_window_exclusion_clause", "row",
  "explicit_row", "implicit_row", "sub_type", "all_Op", "MathOp",
  "qual_Op", "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "func_arg_list_opt", "type_list", "array_expr",
  "array_expr_list", "extract_list", "extract_arg", "unicode_normal_form",
  "overlay_list", "position_list", "substr_list", "trim_list", "in_expr",
  "case_expr", "when_clause_list", "when_clause", "case_default",
  "case_arg", "columnref", "indirection_el", "opt_slice_bound",
  "indirection", "opt_indirection", "opt_asymmetric", "json_func_expr",
  "json_parse_expr", "json_scalar_expr", "json_serialize_expr",
  "json_value_func_expr", "json_api_common_syntax", "json_context_item",
  "json_path_specification", "json_as_path_name_clause_opt",
  "json_table_path_name", "json_passing_clause_opt", "json_arguments",
  "json_argument", "json_value_expr", "json_format_clause_opt",
  "json_representation", "json_encoding_clause_opt", "json_encoding",
  "json_behavior_error", "json_behavior_null", "json_behavior_true",
  "json_behavior_false", "json_behavior_unknown", "json_behavior_empty",
  "json_behavior_empty_array", "json_behavior_empty_object",
  "json_behavior_default", "json_value_behavior",
  "json_value_on_behavior_clause_opt", "json_query_expr",
  "json_wrapper_clause_opt", "json_wrapper_behavior", "array_opt",
  "json_conditional_or_unconditional_opt", "json_quotes_clause_opt",
  "json_quotes_behavior", "json_on_scalar_string_opt",
  "json_query_behavior", "json_query_on_behavior_clause_opt", "json_table",
  "json_table_columns_clause", "json_table_column_definition_list",
  "json_table_column_definition",
  "json_table_ordinality_column_definition",
  "json_table_regular_column_definition",
  "json_table_exists_column_definition", "json_table_error_behavior",
  "json_table_error_clause_opt",
  "json_table_column_path_specification_clause_opt",
  "json_table_formatted_column_definition", "json_table_nested_columns",
  "path_opt", "json_table_plan_clause_opt", "json_table_specific_plan",
  "json_table_plan", "json_table_plan_simple",
  "json_table_plan_parent_child", "json_table_plan_outer",
  "json_table_plan_inner", "json_table_plan_sibling",
  "json_table_plan_union", "json_table_plan_cross",
  "json_table_plan_primary", "json_table_default_plan",
  "json_table_default_plan_choices", "json_table_default_plan_inner_outer",
  "json_table_default_plan_union_cross", "json_returning_clause_opt",
  "json_output_clause_opt", "json_exists_predicate",
  "json_exists_error_clause_opt", "json_exists_error_behavior",
  "json_value_constructor", "json_object_constructor", "json_object_args",
  "json_object_func_args", "json_object_constructor_args",
  "json_object_constructor_args_opt", "json_name_and_value_list",
  "json_name_and_value", "json_object_constructor_null_clause_opt",
  "json_array_constructor", "json_value_expr_list",
  "json_array_constructor_null_clause_opt", "json_aggregate_func",
  "json_object_aggregate_constructor", "json_array_aggregate_constructor",
  "json_array_aggregate_order_by_clause_opt", "opt_target_list",
  "target_list", "target_el", "qualified_name_list", "qualified_name",
  "name_list", "name", "attr_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "SignedIconst", "RoleId", "RoleSpec", "role_list",
  "PLpgSQL_Expr", "PLAssignStmt", "plassign_target", "plassign_equals",
  "ColId", "type_function_name", "NonReservedWord", "ColLabel",
  "BareColLabel", "unreserved_keyword", "col_name_keyword",
  "type_func_name_keyword", "reserved_keyword", "bare_label_keyword", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,    60,    62,    61,    43,
      45,    42,    47,    37,    94,   771,    91,    93,    40,    41,
      46,   772,   773,    59,    44,    58
};
#endif

#define YYPACT_NINF (-5910)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-3027)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
   10762,  1789, 20750, -5910, -5910,  1789, 70443, -5910, 80000,   -18,
     848,   774,   209, 20903, 80503, 90060,   262,   375, 10060,  1789,
   90060,  2869, 60886, 75976,   972, 90060,  1177,   982, 60886, 90060,
   90563,  1179,  1620,  1239, 91066, 81006, 74467,  1564, 90060,  1277,
    1724, 91569, 81509,  1478, 82012,   982, 56873,   141,  1520, 92072,
   90060,116132,  1724, 82515, 82515, 82515,  2149,  2117,  1597, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910,   -16, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910,  2358, -5910,  1423,
    2841,  1573,   863,  1624, -5910, -5910,  2163, 70443, 90060, 90060,
   90060,  1975, 90060,  1843, 90060,   988, 70443, 66419, 83018,  2073,
    1909, 52733, 92575, -5910, 70443, 90060, 63904, 70443, 90060, 90060,
   93078, 90060, 93581, 90060,  1342, 78491, 90060,  2028, 90060, 90060,
   64407, 94084,  2204,  1554,   294, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910,  1951,  2013, -5910,   296, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, 68934, 90060,
   20040,  1177,  2163, -5910,  2149, 90060,  2268, 90060,  2017, 94587,
   90060, -5910, 90060,  2111, 95090,  1002,  1467, 66419,  2074, 53255,
    2207, 90060, 90060, 66419, 95593, 96096, 96599, 90060, 90060, -5910,
   -5910,  2178, 90060, -5910,  2321, 66922,    89,  2330,  2484,  2396,
    1807, -5910, 83521, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, 69940,   375, -5910, -5910,  2340, 70946,  2403, -5910, -5910,
   97102,116621,  2184, -5910,  1039, 71449, 67425,  2557,  2160, 53777,
    2607, -5910, 71952, -5910, 67928, 72455, -5910, -5910, -5910, -5910,
   -5910, 97605, -5910, 98108,  2252,  2403, -5910,117110, 68431, -5910,
    2475, 98611, 99114, 99617,  2163,  2208,  1973,  1498, 46583, -5910,
   -5910, -5910,  2301, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910,   334,   290,   239,   232,   258, -5910, -5910,   243,
     252,   255,   334,  2744,  2744, -5910, 90060, -5910, -5910,   290,
     754,  2320,  2243,  2243,  2243,  2479,    16, -5910,  2243,  2402,
   -5910, -5910, -5910, -5910, 82012, -5910,  2257,  1177,  2266,  2748,
    2370, -5910, -5910, -5910, -5910, -5910, 68934,  2772,  2772, 90060,
   -5910, -5910,  2814,  2365,  2649,  2361, -5910, -5910, -5910,  2579,
    2585,  2613,   381,  1177,   246, -5910,  2727, -5910,  2620, 32121,
   32121,  1177, 84024,100120,   238, 69940,  1177, 84527,  2418,  1486,
    2627, -5910, -5910, -5910,   845, -5910,  2905,  2478,  2738,  2361,
    1554, 48619, -5910, -5910,  2503,  2013, 82012, -5910, -5910, -5910,
   68934,  2855, 34726, 90060,  2524, -5910,  2531,  2524, -5910, -5910,
    2567, -5910,  2567,  2567,  2542,  2542,  2695,  2570, -5910, -5910,
   -5910, -5910,   418,  2567,  2542, -5910,118088, -5910,  1976,  2027,
   -5910, -5910,  3045, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910,  2584, -5910,  1643, -5910,  2094, -5910, -5910, -5910, 32121,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910,  2608,  2611,  1573,
   -5910,  9733, 68934, 90060,  1876,  1876,  3082,  1876,  1730,  1974,
   -5910,  2935, -5910,  2975,  2938,  2945, 82012,  2658,   957, -5910,
    1732,  2669,  1855,  2637,  1885,  1133, -5910,   811, 90060,   247,
    2667, 85030,  6884,  2679,  2013,  2714, -5910, -5910, -5910, -5910,
    2812,   405, -5910, -5910, -5910, -5910,  3072,  3128,  4341,   231,
   85533, -5910, -5910, -5910, -5910, 90060, 90060, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910,  2764,   798, -5910, -5910,
    2763,  3139,  3015, 11452,   899,  3125,  2963,  1440, 11737,  3038,
    1891,  3191, 11052,  1543,  3195,  1998,  2332, 86036, 90060,  3158,
    3204,  7608,  1879,  1117,  3056,  1113,  3125,  3193,  3001,  1440,
    3209,  3465, 90060, -5910,  3117,  3246,   806, -5910,   179, -5910,
   24882, 34726, 56370, -5910,  2013,  1920, -5910, -5910, 59880, -5910,
    2904,  3066,    83, 70443,  2846, 90060, 90060, -5910,116132, 70443,
   -5910,  3079, 54299, 70443, -5910, 70443, -5910, -5910,  3211,116132,
   90060, 90060, -5910, 90060, -5910, -5910,  2851, -5910, -5910, -5910,
   -5910, -5910,  2243, 90060,  3311,116132,  3096,   165,  1940,  3349,
   90060,  3099,  1940,  2902,100623, -5910, -5910,  1940, -5910, -5910,
   -5910, 90060, 90060,  2864,  2409,  3089,   843,  1940,  3108,  3351,
    3352,  3112,  2952,  3114,  2531,  3317,  3090,  1138,   221,   964,
    1940,  2939,101126,101629, 90060,  2944, 90060,  2772, 70443,  2970,
   70443, 70443, 90060,  3253, 90060, -5910,  3084, -5910, -5910,  1200,
   -5910, -5910, -5910, -5910, -5910,  3269, -5910,   316,  3273,  2903,
    3276,  1856,  3278,   337, -5910, -5910,  2947, -5910,  3280,   348,
   -5910,  3281, -5910,  2906,102132, -5910,102635,103138,  3287,   354,
   -5910, 66419,  3289,   348,  3291,  2906,  3292,   348,  3297,  1114,
    3300, -5910,  1450,  3268,  3301,   337,  3303,  2205,  2906, -5910,
    3306,   362, -5910,  3307,   462, -5910,  3309,  3161, -5910, 34726,
   -5910,  3041, -5910,  1520,  2022,  1498,   290, -5910, 90060,   290,
   90060,   290, 90060,   290, 90060,   290, 90060, 90060, 90060,   290,
   -5910, -5910, -5910, 90060,  2949, 90060, -5910, 90060, -5910, -5910,
   -5910, 77485, 66419, 77988, -5910, 90060, -5910,   146,  1177, -5910,
   -5910,116132,  3435, 66419,  2772,  2042, -5910, 90060, 90060, -5910,
   -5910, -5910,  3229, 90060,  3312,  3313, 77485, 66419, -5910,103641,
   -5910, 69940,  3174,  2954, -5910, -5910, -5910, -5910, -5910,  2302,
    3482,   242,  3487, 34726,  2966,   242,   242,  2969,  3328, -5910,
   -5910, -5910,   298,  2972,  2974, -5910,   256,   256, -5910,  2977,
    2978, -5910,   261,  2979,  2981,  3504,  3506,   272,   274,  2985,
    2986,  2987,  2988,  2990,  2991,  2992,  2993,  2994,  2996,  2997,
    2999,   418,   242,  3002, 34726, -5910,  3003,   256,  3004,  3008,
    3009,  3511,  3010, -5910,  3533,  3012,   319,   335,  3014,  3016,
   -5910,  3248, -5910,   280,  3018,  3019,  3022,  3024,  3025,  3028,
    3029,  3030, 34726, 34726, 34726, -5910, 29511,  2013,  1177, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910,   297, -5910, 51167,
   -5910,  3057, -5910, -5910,  3237, -5910, -5910, 34726, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
    3393, -5910, -5910,   846, -5910,   300, -5910, -5910, -5910,  2013,
    3339,  3031, -5910, -5910,  1008,  3032, -5910,   438, -5910, -5910,
   -5910, -5910, -5910, -5910, 69437,  3523, -5910,   332,  1177,   179,
    2108,  3459, 58874, 59377, -5910, -5910,  3321, -5910, 90060, -5910,
   -5910,  2013,   187,  2055, -5910,  2301, 19563,  2075,  2524, 90060,
   90060,  3525, -5910,  3044, -5910, -5910, 34726, -5910, -5910, -5910,
    2744, -5910,  2567,  2567, -5910, -5910,  3536,  3135,  3137,  2744,
   -5910,  2744, -5910,  3051,  3053,  2744,  3141,  3142,  3144, -5910,
    3052,  3146,  2744, -5910, -5910, 61892,  2434, -5910,  3414,   347,
   -5910, -5910, -5910,  2078, -5910,  3058, -5910,  2531, -5910, -5910,
    1573,  1573, 34726,  1573,   934,  1717, 32642, 35247,  3422,  3293,
    1667,  1857,  3425, -5910,  3302,  1730,  1974, 82012, 90060, 82012,
  104144,  3198, 34726, -5910,  3535,  3160,  3165,  3222, 57879, -5910,
    3169,  3134,  3171,  3230,  3087,  3179,  3180,  3236, -5910,  3371,
   -5910, -5910,  3183,  3546,  3185,104647, -5910, -5910,  1415, -5910,
   -5910, -5910,  1415, -5910,  3110,  1627,  1049,  1109,  3188,   532,
     930,  3538, -5910,  1504, -5910, -5910,  3247, -5910, 11970, 90060,
    3474,  8358,  3326,   231,  3243, -5910, -5910, -5910,  3391,  3199,
   90060,  3202,  3344,   231,  1387,105150, -5910, -5910, 90060, -5910,
   -5910, -5910, -5910,  3245,  3517, 28010, -5910,  2090,  3207,  3184,
    3221, 90060, 73461,  2138,  3330,  3354,  1840,  2338,   591,  3274,
   90060,   301,  3358, 90060,  3133,  3223,  3225,  3469,  3140,   686,
    3570,  3143, -5910, -5910, -5910,  3541, -5910,   485,  1878,  3356,
   -5910,  3472,  3519,  9326,  3208,  3215,114176, -5910,  3241,  1142,
   54821, 90060, 90060,  3244,  3251,105653,  3245,  3559, 76479, 76479,
    3254,  3256, 47601,  3584,  1648,  3258, -5910, -5910, -5910,  1648,
    3260,  3261,106156,  3245,  3575, 90060,  3263,  3264, 90060,118088,
     231, -5910,  3648,   231,   231,  2064,  3649,  3272,   350,  3441,
     700,  1940,  3143,  2487, -5910,  3285,  3286,   358, -5910,  3399,
   90060,  3288,  3290,    91,  3369,  1177, -5910,  3380, -5910,  3295,
    3382,  3296,   856,  2864, -5910, -5910,  1475,  3310, 82012,  3405,
    3407,   301,   273,   839,  3143, -5910,  3304,  3305,  3140,  3140,
   90060, 90060, 90060, 90060, 90060,   345,  3696,  3697,  3308,   219,
    1147,  3213, -5910,  1648, 64910,  3315, -5910,  1648, 90060,   217,
    1084,  3143,  1952,  1991, -5910, -5910, -5910,  1554, -5910, 34726,
   34726, 34726,  3219, -5910,  2014, 19563,    68, -5910,   302, 13673,
    3217, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, 90060, 68934, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, 90060, -5910, 90060,  3527,
  116132,  3530,  3448,  3534,  3537,   231, 90060, 90060,  3539,  3545,
    3547,116132,  3548,  3550,  3551,  3452,  3318,   192,  3327,  3249,
    3731,  3622, 90060, 61892, -5910,  1415, -5910,116132,  3475,  3625,
   -5910, 90060,  3493,    71, -5910,  3664,  3319, -5910, -5910,    81,
   90060, 76982,  2864, -5910, -5910,  3633, 66419,  1051,  3635,  1177,
    3316,  3638,  3490,  1177, 66419,  3540, 90060, 90060, 90060, 90060,
     129, -5910, 64910,  3507, -5910, 90060,  3510,  2487,  3513,  3763,
      97,  2243,106659,  3634,107162,  3299, 90060,  3320,  3320,  3766,
  116132,   415,  3567, -5910, -5910,  2514, -5910,  3426, -5910, 70443,
   -5910, -5910, 70443, -5910, -5910,116132, 90060,  3323,116132,116132,
   -5910, -5910, 70443, 70443, -5910, 66419, 66419,  3653,   362,  3659,
    3353,  3661,  3355, 54821, 54821, -5910,   486, 70443, -5910, 66419,
   70443, -5910, 90060, -5910, 90060, -5910, -5910, -5910, -5910,116132,
  116132, -5910, 66419, 64910,  3666, 90060, 90060, -5910, 90060, 90060,
   -5910, 90060, 90060,  2119,107665,  1498, -5910, 90060, -5910, 90060,
   -5910, 90060, -5910, 90060, -5910, 90060, -5910, -5910, -5910, 90060,
   -5910, 90060,  2154, -5910, -5910,  2165,  1443, 90060, 90060,  1013,
   70443, 90060,  3529, 90060, 70443, 70443, 90060, 90060, 90060, 90060,
   90060,  3383,  3032,   -21, -5910,   289,   585, 82012,  3542, -5910,
   -5910,  2172,  2149,    20, 90060,  1401, -5910, -5910, -5910, -5910,
   77988, 75976,  3654,   423, 90060, -5910, -5910, 13937, 34726,  2013,
   31595, -5910, -5910, 19563,  3357, 34726, 34726,  3332,  2744,  2744,
   -5910,  1352, 34726, 34726, 34726, 28990, 34726, 34726, 34726, 34726,
   34726, 34726, 34726, 34726, 34726,  2744,  2744, 34726,  8069, 34726,
   54821, 34726, 40457, 25936, 34726, 34726, 30032,   279,  2977, 34726,
    3556, 41493, 34726,  2108,  3560, 34726,  2108,  8069,  3822,  3822,
    2500,  7077,  3322,  2013, -5910,  2744,   894, -5910,   338,116132,
   34726, 34726, 34726, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, 34726, -5910,
   61892, -5910, -5910, -5910, -5910, -5910, -5910,  3398, -5910, -5910,
   -5910, -5910, -5910, -5910,  4219, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, 90060, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, 30553, -5910, -5910, -5910, -5910,
    3333, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
    3626, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, 31074, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
    3334, -5910, -5910, 34726, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
    3400, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910,   853, 34726, 34726, 34726, 34726, 34726, 34726,
   34726, 34726, 34726, -5910, 34726,   478, -5910, -5910,  3657,  3393,
      55,   457,  3335,  3528, 86539, 32121,  3414, 24882, -5910,   264,
    3414, -5910, -5910, -5910, 90060,  3523, -5910, -5910,  3397, -5910,
   -5910, -5910, -5910, -5910,   310, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910,  3324, -5910, -5910, -5910, -5910,  3324, -5910,  3325,
    3650,  3652,  1114, 90060,  2486, 34726,  3398,   236, 90060, 34726,
    3333,  3626, 34726,  3334, 34726,  3400, -5910, 34726, -5910,  2176,
    2123, 34726,  2186,  3336, -5910, -5910,  3341,  3053,  3363,  3364,
    3342,  3345,  2744,   230,  3346,   220,   749,  3486,  2744,  3606,
    3350, -5910, 61892, -5910, 43529,  3401, -5910, -5910, -5910,  1724,
   90060, 90060, -5910,  3662, -5910,  3348, -5910, 14048,  3662, -5910,
   -5910, 40975,  3478,  3646,  3579, -5910, -5910, -5910,  3359, 19563,
   35768, 35768, -5910,  2291, 19563,  2298, -5910, -5910, -5910, -5910,
   -5910, -5910,  1398, -5910, 90060,  1241,  3422,  1857,  3421,  1254,
    3850,  3423, 90060, -5910, 49128,  2206, -5910, 66419, 90060, 90060,
    3576, -5910,  3831, -5910,118088, -5910,  3366, -5910,117599,113198,
   -5910, -5910,   731, -5910,  1066, 66419, -5910, 90060, 90060, 66419,
   90060, 90060, -5910, 66419,  3419, 90060, 90060, -5910, -5910, -5910,
   -5910, -5910, 60383,   652, 75976,  3512, 74970, -5910, -5910,  3372,
   90060,  3433,  3663,  3665,   111, -5910, -5910,108168, -5910,  3607,
   66419, 90060, 90060, 34726,  3609, 90060, 90060, -5910,   308,  3464,
    3471, -5910, 90060,  3476, 70443,  3392,116132, 70443, 55343, 70443,
   70443,  3748,116132, 90060, 90060,  1581, 82012,   251,  1124,  3143,
    3628, -5910,  1589, -5910, 66419, -5910, 90060,  3618, -5910, -5910,
   -5910, 87042,  3878,  3543, -5910, -5910, -5910,108671, -5910, -5910,
    3621, -5910,  2245, -5910, 66419, 66419, 90060,  9683,109174,  1697,
    3645, -5910, -5910,116132, -5910, 90060, 87545, 90060, 90060,  3686,
   90060, 78994,109677,110180,  1770,  1846,  3688, 90060, 79497,  3691,
   -5910,  3561, 90060, -5910, -5910, 62395, 66419, 90060,   888, 61892,
   -5910,  3675, -5910, 90060, -5910,   323, -5910, 90060,  5693,  3639,
   -5910, -5910,  3503,  3514, 90060,   259,  1141,  3143,  3819, 90060,
   90060,  3415,  2258, 66419, 90060, 61892, -5910,  3642,  1121, 66419,
   90060, 87042, -5910,  3644,  3522, -5910, 82012, -5910,  3424,  2243,
    2503,  2062,  3424, 66419, 90060, -5910,  3424, 90060,100120, -5910,
   66419,  1752, -5910, 66419, 90060, 87042, -5910,  3647,  3591, 66419,
   90060, 18506, -5910, -5910, -5910,   231, -5910, -5910, -5910, -5910,
   -5910, 90060, 90060,   231, 90060, 90060,   231,  1690, -5910, 66419,
   90060, -5910, -5910, -5910,  3557, 66419, 90060, 90060,   334, 90060,
   -5910, 90060, 66419,  3479, 90060, 90060, -5910, -5910, 90060,  8986,
   90060, 90060, 90060, 90060, 90060, 90060, 66419, 90060, -5910, -5910,
    1149,  1461,   104,  1287,  1672, 90060,  3764, 90060,110683, 66419,
   90060, 90060,  1177, 90060, 61892,  1960, -5910, -5910,  3564, -5910,
   66419,  1752, -5910,  9983, 90060, 90060, 90060,  3524,  3526,   393,
    3611, -5910, -5910, -5910,   834,   834,  3656, -5910, 34726, 34726,
   33163,  3437, -5910, -5910, 34726,  2904, -5910, -5910, -5910,   364,
    3931,   364,111186,   364,   364,  3749,  3508,  3516,   364,   364,
     364,  3734,   364,   364,   364, 90060,  3630, -5910, -5910,  3630,
     819, 34726,116132, 90060, -5910,  2286, -5910,  3455, -5910, -5910,
   61892, 90060,   211,  1192,  3823,  3679, 73964,  2368,  3812, 90060,
    3515, 90060,  3959,  3568,   -19, -5910,  2368, 90060, -5910,  1729,
   75976, -5910, -5910, -5910, -5910, -5910, -5910, -5910, 90060, -5910,
   -5910,  3826, 90060, 44038,  3667, -5910,  1177,  2864,  2864,  2864,
    2864,  3473,  2864, 90060,  3608,  3845,  2368,  3477,  3852, -5910,
    2487,  3853,  1053, 90060,  3707, 73964,  3552,  3531,  3722,  3975,
    2243,  1177,  3729,  3714, -5910, 58371, -5910,  2864,  3994, 28500,
    5521,  8859,  3718,  3785, -5910, -5910,  3732,   998, 90060,  3837,
    3839,  3862, -5910,   316, -5910,  3997,  1856,  3864,   337, -5910,
     348, -5910,  2906, -5910, 90060, -5910, 90060, 90060, 90060, 90060,
     354, -5910, -5910,   348,  2906,   348,  1114, -5910,  3795,   337,
    2906,  3643,  3867,   362, -5910,   462, -5910,  3735,  1114, -5910,
    3750,  2243, -5910, -5910, -5910, -5910, -5910, -5910, -5910,  2288,
   -5910, 90060, -5910,  3842,  3843,  3847,  3848,  3849,  3518,  3520,
    3566, 90060,  3532,  3518,   231,  3544,  3549, -5910,  3532,  3532,
    3518,  3032,  3032,  3518,  3520, 65413,  4020,  3869, -5910,  3615,
    3553,  3880,   840, -5910,   985,  1422,  3788, -5910, -5910, -5910,
   -5910,116132, -5910, 66419,  3578,  2772,  2772,   384,  3754,  3558,
   65413,  4002,  1114, -5910, 70443, 90060,116132, 70443,  3768, 70443,
   70443,116132, 90060, 90060,  2295, -5910,  1946, -5910,  1958, 34726,
     185, -5910, 15324,  2297, 34726,  3554,  3555, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910,  3574,  3888, -5910,  2303,  2312, 15839,
    1759,116132,  2129,  3701, -5910,  3587,   233,  3757,  3703,  3562,
   -5910,  5105,  3605,  3583,  3592, -5910, -5910,  3701,   325, -5910,
    5105,   352,  3701, 15979,  3701,  3703,  2323,  3593,  3595,  4957,
    6705,  3596, 16827,  3583,  3597,  3598,  3602, 40457, 40457, 29511,
    1228, -5910, 40457,  3603,  3762,  2344, 14866,  3610,  3612, 16996,
   33684, 34726, 33684, 33684, 17231,  3600,  3613, -5910,  3947, -5910,
    2352, 61892,  3759, 17512,  2356, -5910, 34726, 61892,  6832, 34726,
   -5910, 34726,  3614, -5910, -5910,  6642,  6642,  6642,  8069, -5910,
    3585, -5910, 40457, 40457, -5910,  3807, 29511, -5910, -5910,  3918,
   -5910, -5910,   227, -5910, -5910, -5910, -5910, -5910,  4050, -5910,
   -5910, -5910,  1759,  3815,  4409, 54821,  8177, 34726,   241, 34726,
    3333, 34726,  3690,  6642,  6642,  6642,   508,   508,   307,   307,
     307,  1863,   457, -5910, -5910, -5910,  3616,  3623,  3528,  3624,
   34726, -5910,  3658, 49637, -5910,  2556,  2574, 90060,  3282,  4646,
    6029, -5910, -5910, -5910,  3401,    68,  3401, -5910,  1554,  2744,
     894, 59880, -5910, -5910, -5910, -5910, -5910, -5910, 90060, 19563,
   -5910, -5910,  3871,  3629,  2372, -5910, -5910,  2744, -5910, -5910,
    2581,  2581,  3619, -5910,  3631, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910,  3620, -5910, -5910, -5910,  3632,  3636, 44547,  3961,
    3637, 43020, 88048,  3627,  2682, -5910, 88048, 88551, 88048, -5910,
    3651, -5910, 88048, -5910,  2013, 34726,  3967, -5910, -5910, -5910,
   34726, -5910, -5910,   553,  3655,  1322,   805,  2318,  2318,  2291,
    1055, -5910, -5910,  3692, -5910, 34726,  2419, -5910,  2458, -5910,
   -5910, -5910, -5910,  3032, -5910,  3903, -5910, -5910, -5910, 43529,
    3685,  3699,   727, 48110,  3866, -5910, 90060, 43529, -5910, 90060,
     385, -5910,  3660, -5910, -5910, -5910, -5910, -5910, -5910,113198,
    2094, -5910,117599, -5910,117599, -5910,  2094,  4109, -5910,113198,
    2146, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, 66419, 66419,  3870, 90060,  3868,  3874,
   34726,   984, 90060,  3668,  3669,  1720,  3968,  3670, -5910,  4025,
    1114, -5910, -5910,  3743, -5910, 19563, -5910, -5910, -5910, -5910,
   -5910, 66419, 90060, -5910, 69940, -5910, -5910,116132, -5910, -5910,
   90060, 90060, -5910, -5910, -5910,116132, -5910, -5910, -5910, 90060,
     167,  3745,  3747, 90060, -5910,  1474,  3399, 10269, 90060, 90060,
   90060,  3977, -5910, -5910, -5910, -5910,  3896, -5910,  4032, -5910,
  113198, -5910,  2906,   133,  3752,  3143,  3904, -5910,  4038,  4113,
   -5910,  3801,   282, -5910, -5910,  3810, -5910, -5910, -5910, -5910,
    4049,  1114,  4051,  1114, 90060, 90060, 90060, 90060,  3816, -5910,
   -5910, -5910, -5910,  3818,  3962, -5910, 61892, 61892, 61892,  2376,
   -5910, -5910,  1177, -5910, -5910, -5910, -5910, -5910, -5910,  4010,
   -5910,  2380, -5910,  1906, 90060, -5910, -5910, -5910, -5910, -5910,
    4058, 66419, 90060, 10736, 90060, 90060, 90060,  3914,  1999,  1256,
  116132, -5910,114665, -5910, -5910,  2386, -5910,  3705, 90060,  3780,
   66419,  3760, -5910, -5910, -5910,  4065,  4026,  2243, 76479,  3751,
    3751,  2085, -5910, -5910, -5910, -5910, -5910,  3978,  3900, -5910,
    1027,  3902, 66419,  3769, -5910, -5910, -5910, -5910,  4074,  3794,
   -5910, -5910,  3796,  1229,  3143,  2487, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910,  3821, -5910, -5910, -5910, -5910,
    1609,  1609, -5910, -5910, -5910,  1609,  1519,   454,  1253,  3143,
   -5910,  2143,  1091,  3798, -5910,  3799, -5910, -5910, -5910,  3979,
    3980,  3982,  3804,  3805,  3861,  3808,  3809,  3865, -5910,  3811,
    3872,  3813,  3873,  3814,  4125,  1114,116132,  3966,  1177,  3858,
    4103,  1114, -5910,  3824, -5910,  3827, -5910,  2393,  4216, -5910,
   90060, -5910,   295,  1392,  3143, -5910,  3829, -5910, 66419, 90060,
   -5910, -5910, -5910, 34726,  3738,  3746,  3753, 19563, 19563, 34726,
   -5910, -5910, 19563,  3737, -5910, -5910, -5910, -5910,116132, -5910,
   90060,  4053, -5910, -5910,   364, 90060, 90060, -5910, -5910, -5910,
   90060, -5910, -5910, -5910,  4056, -5910,   344,   344, -5910, -5910,
    4083,  7439,  3756,   327, -5910, 61892, 51689,  2452,   448,  1940,
   -5910, 69940, 90060, 69940, -5910,  1192,  3971, 90060, 90060, 90060,
    3758,  3755, -5910, -5910, -5910, -5910, 66419,   205, 66419,  2744,
   -5910, -5910,  3832, -5910, 90060,  2243,  4283,  4117,   170, -5910,
    4242,  3352,  1051,    90,   257,  2952,  4179,  2531, 34726,   401,
   -5910, -5910,  2013, 90060,  3531, -5910, -5910, -5910, -5910,  1177,
   -5910,  3765,  3761, -5910, 90060,  4122, 90060, 90060, 90060, 90060,
    3578,  3770, 90060,  3773,116132, 90060,  2614,  3140,  4259,  4142,
    2149,  3552,  3863,  4148, 82012,  3789,  2406, -5910, -5910,   998,
   -5910,  2414,   145, -5910,  1177, 69940,113687,  4135, -5910,   293,
    8859, -5910, -5910,   293,   896, 90060, -5910, -5910, -5910, -5910,
    4008,  2428, -5910,  4120, -5910, -5910,  2149, -5910,116132,  3782,
   -5910,  2422, -5910, -5910, -5910,   362,  3846,  1114,  3854,  1114,
   -5910, -5910, -5910, -5910, 90060, -5910, 90060, 64910, -5910, -5910,
   90060, -5910,  4157, -5910, -5910,  3929,  3930,  3933,  3935,  3936,
   90060,  3518, -5910,  3790, 90060, 90060, 66419,  1746, -5910, -5910,
    4014, -5910, -5910, 82012,  3940, -5910, -5910, -5910, -5910,  4170,
    4182, -5910, -5910, -5910,  1407, -5910, 90060, 90060, 66419, 77485,
     431, 66419, -5910,  4115,  4118,  4119,  4121,   231,  4123,  4124,
    4126,  4127,  4128, -5910, -5910, -5910,  3817, 17362, 34726, -5910,
    4193,116132, -5910,  7656, -5910, -5910, -5910, 34726, -5910, -5910,
    4129, -5910,  3889,  3889,  3703,  4178,  3825, -5910,  4047,  4052,
   34726,  3701,  4296,   949,116132,  1069, 34726, 34726, 34726, -5910,
   -5910,  4054,  4055, 34726,  1759,  1759,  2709,  3830,  3833,  1510,
   -5910, -5910, -5910, -5910,  3027, 34726, -5910, 34726, -5910, -5910,
   26463,  4351,  4351,  3835,116132, 40457, 40457, 40457, 40457,  1662,
    3004, 40457, 40457, 40457, 40457, 40457, 40457, 40457, 40457, 40457,
   40457,   561, -5910,  4059, 34726, 34726, 34205, -5910, -5910,116132,
    3836,  3600,  3841,  3851, 34726, -5910, -5910, -5910,  2423, 42002,
    3859, 61892, -5910, 34726, 14429,  2437,  3899, 17647,  2013,  7686,
    1177, 34726,  1181,  1296, 34726,  2463, 34726, -5910, -5910, -5910,
   -5910,  4201, -5910, -5910, -5910, -5910, -5910, -5910,  1759,  4090,
   -5910, -5910, 34726,  3875,  4421, 40457, 40457,  4844, -5910,  5265,
   34726, 29511, -5910,  3656, -5910, 26990,  3857, 34726,112695, -5910,
   -5910,   982,   982,   982,   982, -5910, 90060, 90060, 90060,  3967,
    3877,  3967,   179,  3882, -5910, -5910, -5910, -5910,  2149, -5910,
    3855, -5910, -5910, -5910, -5910, -5910, 34726, 88048, 88551, 88048,
   88048,  3879, 42511, 27500,  2682,  3883, 90060, -5910, -5910,  3885,
   43529,  4155,  4077, -5910, 43529,  4077,   223,  4077,  4169,  3970,
   50146, -5910, -5910,  3886, -5910,  4084, -5910, -5910,  2090, 19563,
    4344,  4225, -5910,  3892, -5910,  3655,  1934, -5910, -5910, -5910,
    1085, -5910,  3983, -5910, -5910, -5910,  3627, 36289,  4044, -5910,
   -5910, -5910,  3952,  2466, -5910, -5910,  4334,  4044, -5910,  2721,
   -5910,  2476, 49128,  3685, 34726,  2013,  2494,  2170, -5910, -5910,
  113198, -5910,  3974,  2906,  2906,  1762,  3518,  4256,  1762,  8226,
   -5910, -5910, 45056, 90060, 90060, -5910, 90060, 90060,  1970, 90060,
   -5910, 90060, -5910, -5910, -5910,  4390,  3963,  3964,  4191, -5910,
    2637, -5910, -5910, 66419, 90060, -5910, -5910, -5910,   460,  1410,
    3143, -5910,  3995, -5910, -5910,  4222, 90060, -5910,  4378,  4007,
   90060,  4284, 90060, 89054, -5910,  3971,  1970,  4027,  4262,  1894,
    3140,   350,  7600, -5910,  1926, -5910, -5910,  3993, -5910, 90060,
   -5910, 90060, -5910, -5910, -5910, -5910, -5910, -5910, -5910,  4060,
   -5910, -5910, -5910, -5910, 62395, -5910, -5910, 90060, -5910, 61892,
   51689, 61892, -5910, 90060, -5910,  1671,   463,  1460,  3143, -5910,
    4005, -5910,  4289,  4009,  4011,  4069,   216,   859,  4015,  4017,
    4073,  3934,  3938,  3941, -5910, 61892, 52211,  4096, 90060,  2906,
    3937,  3984, 90060,  4076,  3751, -5910,  3950, -5910, -5910,  3751,
     334,  1177, -5910, -5910,  1177,  2906,  1177, 90060, 90060, 90060,
   90060,   334, -5910, -5910, -5910,  4416,  4048, 90060, 90060, 90060,
   90060, -5910,  4012, -5910, -5910, -5910, 90060, 90060,  4308,   234,
    2219, 66419, 90060, 90060, 66419, 90060, 90060, 90060, 90060, 90060,
   90060, 90060,  4176, -5910,  4408,  4331,  2400,  4377,  4041, 90060,
   -5910, 90060,  1177, -5910,  3399, 90060, 90060, 90060, 90060, -5910,
   -5910, -5910, -5910, -5910,  3656, -5910,  3965,  4270,   364, -5910,
    4272,  4273,  4277,   364, -5910, -5910,  1940, -5910,   461, 90060,
   -5910,  2731, 90060, -5910, -5910, -5910,  3892,   485,  1878, -5910,
   -5910, -5910, -5910, -5910, -5910,  3973, 90060, 90060, 40457, -5910,
    2283,  1858,  1433, -5910,  4264, 90060,  3248, -5910, -5910, -5910,
    1028, 90060, -5910, -5910, -5910, -5910,  3976, -5910,    75,  3770,
   -5910,  4295, 73964,  2906, 66419, 66419,  2906, -5910,116132,  3981,
    3531, -5910,   269,  4064, -5910, 66419,  1051,111689,  3316,  4019,
    4200,  8320, 43529, 44038,  1609, -5910,  3985,  3986, -5910, -5910,
   90060,  3971, 64910,  2505,  2487,  4477,   121,  2208, -5910, 75473,
    4189,  3770,  4295, -5910,  3140,  4214,  4212, -5910,  2149, 90060,
    3578,  3531,  1177, 90060,  3433, 51689, -5910,  4516,  2623, -5910,
  113198, 34726, 34726, -5910,  3988, -5910,  3996,  8859, -5910,  4072,
    3998,  4483, 34726, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910,  4087,  4001, 90060, 90060,   998, 90060, -5910,  4004,  3864,
   -5910,  3864, -5910, 90060, -5910, 90060, -5910,  1114, -5910,  4134,
    1114, 90060, 90060, 90060, 90060, 90060, 90060,  3518,   231,  3549,
   -5910, -5910,  4352, 65413,  3869, -5910,  2511, 90060, -5910, -5910,
   -5910,  4423, -5910, -5910,   423,  4357,  1114, -5910,  1110,  1110,
    1110,  1110,  4314,  1110,  1110,  1110,  1110,  1110, -5910, 34726,
   19563, -5910,  4018, -5910, 19563,  4395, -5910,  4302, -5910, -5910,
    4021, -5910, -5910,  4249,  4251, -5910,  4022, 34726,  3701, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,  4023,  4247,
   19563,  4517, -5910, -5910,  4263,  4266, -5910, -5910,  3701,   229,
    4525,  1404,  4078, -5910, -5910, 34726, -5910, -5910, -5910, -5910,
    4257,  4036,  4039,  8849, 18084, -5910,  2512, 34726, -5910,   572,
     572,   572,   904,  4392, -5910,  3104,   572,   572,   572,   482,
     482,   313,   313,   313,  4351,   561, 18319, 18446, 18849,  4043,
   -5910, -5910, -5910,  3600, -5910, 36810,    86,  4511, 41493, -5910,
   -5910, -5910,  4091,  4092,  4057, -5910, 34726, 37331,  4046,118088,
    4255, -5910,  1853, 34726, 34726,  3200, -5910,  8913, 34726, -5910,
   -5910,  3200,   494, 34726,  1977,  2498, 34726, 34726,  5655,  8870,
    4068, -5910,  2520, 34726,  9221,  4258, -5910, 90060, 90060, 90060,
   90060, -5910, -5910, -5910,  4225,  1177,  4225,  1177,  4071, -5910,
    4497, -5910, -5910, -5910, -5910, 62898,  4070,  3759, 88048,  4075,
   90060,  2682, 43529, -5910, -5910,  2612, -5910, 43529,  4356, -5910,
   43529, 70443, -5910, 90060,  4079, 90060, -5910,  1876, 34726,  4099,
   54821, -5910, -5910, -5910, -5910,  4146, -5910,  4287, 19563, 32121,
   -5910,  2149,  1962, 90060,  2013,   884, -5910, 34726,  4086, 90060,
   -5910,  4044, 19563, -5910,  4137,  2522, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910,  4152, 75976,  4424, -5910, 34726,  2532, -5910,
    4130,  4524,   288,  2538,  2539,  1970, -5910,  2540, -5910,  1911,
    4401,   442, -5910,  1114, -5910,116132, 90060, 90060, 90060,  3087,
   -5910, -5910, 90060, 90060, 90060, 90060, -5910, -5910, 66419, 90060,
   -5910, 90060, -5910, -5910, -5910, -5910,   334,  2283,  4414,  4417,
    4316, -5910,   231, -5910,  2283,  4319,   334, 90060, -5910, -5910,
   -5910,  2809, -5910,116132,  1114,  1114, -5910, -5910, -5910, -5910,
   -5910,  4098, -5910,  4559,  4187, 90060, 90060, 90060, 90060, 90060,
   66419, 90060, 90060,  2744,  2744,116132,  4089, -5910,  2744,  2744,
    4095, -5910, 66419, 90060, 90060, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910,  4180, -5910, 34726,  4548,
   -5910, -5910, 89557, -5910, 34726, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, 66419, 90060,  4183, -5910,  4184,
   -5910,   814, -5910, -5910, 90060, 90060, 90060, 90060,  4469, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
    4470, 90060, -5910, -5910,  1177,  1177,116132,  1114,  1114, -5910,
   -5910, -5910,  4192, -5910, -5910,  4106,  4415,   364, -5910,   364,
     364,   364, -5910,  4111, -5910,  1940,  4510, -5910,  1970,  2203,
    4461, -5910, 34726, -5910,  2337,   904, -5910,  4522,  4605, -5910,
   -5910, -5910, -5910,  3479,  2243,  3479, -5910, -5910, 70443,  1757,
   -5910,  4443,   211, 61892,  4348, 73964,  2143,  2088,  4131,  4253,
   -5910,  2906,  2906,  4186, 90060,  4612, -5910, -5910, -5910, -5910,
   -5910, -5910, 66419,  3760, -5910,  4363,  1299,  4481, 90060, 44038,
   -5910,  3627, -5910, -5910, -5910,  1177, -5910, -5910,  4260,  3531,
   -5910,  1402, 90060,  4355, 73964,  3578,  2551, -5910, -5910, -5910,
    4172,  4599,  3552, -5910,  2143,  4189, -5910, -5910,  4577,  4230,
    4185,  4626, -5910,  4230,  4488,  4361,  4140, -5910,  3789, -5910,
   90060, -5910, 19563, 19563,  1177,118577,   293,116132,  4498, -5910,
   19563, 90060,   195,  4141,  4312, -5910,  4464,  1114,  2552, -5910,
    1114,  1114, -5910, 90060, -5910,  3518,  3518,  3518,  3518,  3518,
   -5910,  4369, -5910, -5910, -5910,  4458, -5910,  1114, 65413, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910,  1110, -5910, -5910, -5910,
   -5910, -5910, 19563, -5910, 90060, -5910, -5910, -5910, -5910, -5910,
   -5910,  3348,  4151, -5910,  4532, 90060,  4354, -5910, -5910,  4154,
   -5910, -5910,  4525, -5910, -5910, -5910, -5910,  1728,  4335, -5910,
   19563,  2279, -5910, -5910, -5910, 34726, -5910, 10366, 40457,  4507,
   -5910, 34726, 34726, 34726, -5910,  4158,  2554,  2576, -5910, -5910,
      86, -5910,  4511, -5910, -5910, -5910, 11571,  4217, 19563,  4278,
    4160,  4163,  3200,  3200,  8913,  3200, 34726, 34726,  3200,  3200,
   34726, -5910, -5910, -5910, 11968, -5910,  4634,  3656, -5910, -5910,
   -5910, -5910,  4099, -5910,  4099, -5910,  4305,  4167,  4364, -5910,
    2582,  4659, 39415,  4618, -5910, 90060,  2589, -5910, 34726,  4174,
   -5910, -5910, 43529,  2612,  4188,  2592, 90060,  2595,116132, 37852,
   19563, 90060,  3656,  4171, -5910, 90060,  3031, -5910,   727, -5910,
   -5910,  4614, 45056,  4571, 19151, 34726, -5910, -5910, -5910, -5910,
   65413,  4404, 65413,  1970, 12020,  4509, 45056, 55865, 90060, -5910,
   90060, -5910,  4360,  4509,  4509, -5910, -5910, -5910, -5910, -5910,
   -5910,  4194, -5910, -5910, -5910, -5910,  4274, -5910, -5910,  1153,
    3542, -5910,  2452, -5910,  4676,  4563,  4564, -5910, -5910, -5910,
   -5910, -5910, -5910,  4408, -5910, -5910, 51689, 66419, 90060, -5910,
    4281, -5910, -5910, -5910, -5910, -5910, -5910, 47092, 54821, -5910,
     216,  4196,  4198,   859, -5910, -5910, -5910, 90060, 12187,  4202,
   -5910, -5910, 12363,  1158,  3542, 90060, 90060,  4204,  4205,  4206,
     -23,  1659,  1983,  3518,  4557, 90060, -5910, -5910, -5910,  4408,
   -5910, -5910, 90060, -5910,   364, -5910, -5910, -5910, -5910, 61892,
   -5910,  2989,  4111,  1177, 70443,  4697,  4697, 12582,  4441, -5910,
   -5910,   796,  4271,  4478,  4271,  4215, 90060,  1028,  4218,  2598,
   -5910, 90060,  4213,  4353,  2272,  2272, 90060, 90060, 90060,  2602,
    2149,  2906,  3984,  1051,  4587, 73964,  4637,  3971,   407, -5910,
   90060,  4716, 90060,  3578,  3770, 90060,  4226, -5910, -5910, 75473,
    4446,  2452, 90060,  2614,  4189,  3552,  1428, 90060, -5910,   346,
   -5910,  2149, -5910, 90060, 82012, 45056,  4580, -5910,117599, -5910,
    2604, -5910, -5910, -5910,  4307, 20359,  3401,  4350,  4358,  4232,
    2139,  4592, 90060,   714, -5910, -5910, -5910, -5910, -5910, -5910,
   90060, -5910,   431, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   34726, -5910, -5910, -5910,   331, -5910, -5910, -5910, -5910, -5910,
    4459,  4235,  4463,  1510, -5910, 19225, -5910,  3468, 40457, 19563,
   19563, 19563, 34726, -5910, 34726, -5910, -5910, -5910, -5910,   107,
   -5910, -5910,  3200,  3200,  3200, -5910, 34726,   918, -5910, -5910,
    1614,  4655,112192,   155,  2315, -5910, -5910,  3651, 62898,  4244,
   -5910, 40457,  2615, -5910,  1456, 90060,  2617, -5910, 19563, 90060,
   -5910, -5910, 34726, -5910,  2626, -5910,  4246,    27,  4248, 25409,
    4241, -5910, -5910, -5910, -5910, -5910, 19563,  4245, -5910,  4742,
    1857, -5910, -5910,  4310, 90060,  2628, -5910,  1232,  2089,  4303,
   -5910, 19563,  1746,  1762,   530,  4524,  4265,  3479, -5910,  4268,
   -5910, -5910,  3140,  1503, 90060,  3479,  3479, -5910, 90060,  4362,
   -5910,  4591, -5910, -5910,  4320, -5910,  1186,  3542, 90060,116132,
   -5910,   225,  4617, -5910,116132,116132, -5910, -5910, -5910, 34726,
   -5910,  4367, -5910, -5910, -5910, 34726, 34726, 72958, -5910, -5910,
   90060, 90060, 90060, 90060, 90060, -5910,  1114, -5910, -5910,  2629,
   -5910, 46074, -5910, -5910,  3349,  1177,  3349,  2083, -5910, -5910,
    3349,  3349, -5910,  3401, -5910,  4697,   377, -5910, -5910,  4506,
    4275, 34726,  4595, -5910,  1369,  4495, -5910,  4276, -5910, 70443,
    4796, -5910, 61892,  3770,  4295, 90060, -5910, -5910, -5910, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,  2639,  3971,
    4640,  3531,  4185, -5910, 90060,  4317, -5910, 43529,  3971,  2149,
    2208, -5910,  4189,  3770,  4295, -5910, -5910,  4279,  4212,  3552,
    2614,  4426, -5910,  4427, -5910,  4740,  4505,  4743,  3578, -5910,
    3433,  2640, 90060, -5910, -5910,  8859,118577,116132, -5910, -5910,
   -5910,  4285,  4680,  4337,  4339, -5910, -5910, -5910,  2139, -5910,
    1793,  4679,  4346, -5910,  4368, 90060, -5910, -5910,  3971,  1114,
    4299, -5910,  4792, -5910, -5910,  2339, -5910,  4452, -5910,  4535,
   34726,  3468,  2641,  2648,  4372, -5910,  3600, 38373, 38373, 38373,
    4315,  4678,  4681, 90060, -5910,   342,  2650, -5910, -5910, -5910,
   -5910, -5910, -5910,115154,  4322, 50655, -5910, -5910, -5910,  4541,
    4323, -5910, -5910, 90060,   904,  4321, 39415, 61892,  2656, -5910,
  115643, -5910,  2659,  2666, -5910, 34726,  4328, 34726, -5910, 37852,
   90060,  4330,  3422,  2149, -5910,  3401, 45056, -5910,  4449,  4816,
    4596, -5910, -5910,  4685, -5910, -5910, 90060,  4271, 54821,  1503,
    3655,  2243,  4271,  4271, -5910, 90060,  4275, 34726, -5910,  4431,
   -5910, -5910,  2674,  1638,  4512,  4512,  2677,  2691, 12640, 90060,
    2698,  2722, -5910,  2724,  2744,  3520,  1983,  3520, -5910,  3518,
   -5910, -5910, 61892, -5910, 65916, -5910, -5910, -5910,  1177, -5910,
    1177,  4569, 90060, 57376,  1177,  1177, -5910, -5910, -5910, -5910,
    4662, -5910,  2487, -5910, 12704,  4434, -5910, -5910, -5910,   504,
   -5910,  4565,  4566, -5910,  4342, -5910,  2725, -5910,  2143,  4480,
    3971, -5910, -5910, 90060,  4835,  4836, -5910,  1305, 90060,  3627,
   -5910,  4185,  3578,  3552,  2143,  4189,  2452, 45565,  4230,  2614,
    4212, -5910, -5910,  4568, -5910,  4570, -5910,  4359,  4683, -5910,
    1753,   293, -5910, -5910, -5910,  1178,  4699,  4701, -5910, -5910,
   -5910,  3349, -5910,  2002,  4375,  4726, -5910, -5910, -5910, -5910,
   34726, 61892,  1728, -5910,  4462,  4737, 19563, -5910, -5910, -5910,
   39936,  4519,  1309, 15224,  4735, -5910,  4735,  4735, -5910,  4831,
    4838,  1251, -5910,  1177, -5910,112192,  4593,  1348,   945, 50655,
   -5910,  4376,   887, -5910, -5910, -5910, -5910,  4450,  4804,   254,
    4758, -5910,  2726, 41493, -5910, -5910, -5910, 90060,  4597,  1561,
    4871,  4549,  2733, 37852,  2734, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910, 49128, 34726,  4476,  4816, 65413,  2735,  3751,  4387,
    3655, -5910,  4478, -5910, -5910,  3542, -5910, 19563, 90060, 70443,
    4859, -5910, -5910, -5910, -5910, -5910, -5910, -5910,  3542,  4482,
   -5910, -5910, 72958, -5910, 90060, -5910, -5910,  2737, -5910, -5910,
   -5910, 90060,  4141, -5910,  4141, -5910, -5910, -5910,  2201,  4500,
   90060,  1307,  1307,  4799, -5910,  4457, -5910,  4396, -5910,  4920,
    4538, 90060, -5910, -5910,   216,  2149, 73964,  3971, -5910, -5910,
    2614,  4189,  3552, 34726,  2743, -5910,  4524,   288, -5910,  4212,
    4230, -5910, -5910, 45056,  4407,  3248,  4797, -5910, -5910, -5910,
    2663, 70443, 70443, 90060, -5910, -5910, -5910, 34726,  1028, -5910,
   -5910,  4633, -5910, -5910,  4911, -5910, -5910, -5910, -5910, -5910,
    1086, -5910, -5910, -5910, 90060, 90060, 90060,  4517, -5910, -5910,
    4619,  4129,  1177,  2709, -5910, -5910, -5910, -5910,  4418,  4419,
    4422,  4428, -5910, 50655, 50655, 50655, 50655, 50655, 50655, -5910,
   -5910,  3759, -5910, -5910, 40457, 40457,  4656, -5910, 40457,  1561,
   -5910, 90060, -5910,  4433, -5910, -5910,  2745, -5910,  1359, 19563,
     974,  4513,   530, -5910, -5910, -5910, -5910,  4495,  1970,  1970,
   -5910,  3542, -5910, 90060, -5910,  4440, -5910, -5910, -5910, 65916,
    4141, -5910, -5910, -5910, -5910,  4931, -5910,  1321, -5910, -5910,
   -5910, -5910, 90060,  3971,  4089,  4185, -5910,  4212,  3552,  2614,
   12779, -5910, 45565, 90060, 90060,  4230, -5910,  2746, 45056,  3531,
    4581, -5910,  2453, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
     936,  4435,  4437, -5910, -5910, 13506, 70443,  4823, 38894,  4598,
   -5910,  4663, -5910,  1275,  1318,  1786,  4497,  1069,  4619, -5910,
    1404, -5910,   451,  1420, -5910, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910,  4897,   904,   904, -5910,   904, -5910, -5910, 34726,
   -5910, -5910, -5910,  4689,  4582, -5910, -5910,   314, -5910,  1970,
   -5910, -5910, -5910, 34726, -5910, -5910,  2243,  2243,  3971, -5910,
   -5910,  4230,  2614,  4212,  4524, -5910, -5910, -5910, -5910, -5910,
    4683, -5910,  2747,  4230,  4346,  2153, -5910, -5910,  2175,  2611,
    4542,  4807, -5910,  4467, -5910, -5910, -5910, -5910, 90060, 90060,
   63401, 90060, -5910, -5910,  2709,  1510, -5910, -5910, 90060, 13635,
   -5910, 49128,  4694,   202, -5910,  1970,  2754, -5910, -5910, -5910,
   -5910,  4212,  4230, 90060,  3248, -5910, 45056,  3401,  4830, -5910,
    2453,  4579,  4586, 61389, -5910, -5910,  4984,   312,  4877, -5910,
    1404, -5910,  2760, -5910,  4466, -5910,  4526,   727,  4473, 90060,
   -5910, -5910,  4230, -5910, -5910,  3531, -5910, -5910,  1028, -5910,
    4520,  4521, -5910,  2766, -5910, -5910, -5910, -5910, 34726, 63401,
    1728, -5910, -5910,  4533, 34726,  2779, -5910,  4230, 70443,  4812,
    4829, -5910, 61389,   834,  4544, -5910,  4540,  2789,  1184,  3401,
    4486, 70443, 70443, -5910,  4487, 90060, -5910, -5910,   727, -5910,
   -5910, 61389, -5910, -5910,  1177, -5910,  4546,  2790,  4540, -5910,
   -5910
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
    1692,  1437,   644,  1525,  1524,  1437,     0,   262,     0,  1535,
       0,  1437,   426,  1095,     0,     0,     0,     0,   644,  1437,
       0,  1692,     0,     0,     0,     0,     0,  1705,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1437,     0,     0,
    1712,     0,     0,     0,     0,  1705,     0,  1537,     0,     0,
       0,     0,  1712,     0,     0,     0,     0,     0,     2,     9,
      10,    45,    80,    81,    38,    37,    98,    63,    24,    71,
     133,   132,   134,    50,    46,    88,    33,    35,    47,    51,
      73,    75,    40,    53,    64,   110,    72,    31,    70,    76,
      96,    58,    19,    20,    59,    21,    60,    22,    61,   106,
      82,    99,    43,    69,    30,    52,    78,    79,    12,    54,
      86,    18,    65,    66,    68,    91,    92,    93,   116,    94,
     128,    49,   125,   103,   104,   122,   105,   123,    16,   107,
      62,    23,   119,   118,   120,    89,    55,    90,    77,    97,
     117,    34,   121,    25,    26,    28,    29,    27,    67,    36,
      74,    39,    95,   124,   114,   109,   129,   127,    11,   135,
     111,    83,    14,    15,   100,    13,    32,    57,    17,    42,
      41,    56,    48,   131,    44,  1535,   102,   115,   101,    84,
     108,    87,   112,   130,   113,    85,   126,  1656,  1655,  1716,
    1659,  1691,     0,  1671,  1436,  1435,  1450,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   643,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1447,  2493,  2510,  2511,  2512,  2513,  2514,
    2515,  2516,  2517,  2518,  2519,  2520,  2521,  2522,  2523,  2524,
    2526,  2525,  2527,  2528,  2896,  2529,  2530,  2531,  2834,  2835,
    2897,  2836,  2837,  2532,  2533,  2534,  2535,  2536,  2537,  2538,
    2539,  2540,  2838,  2839,  2541,  2542,  2543,  2544,  2545,  2840,
    2898,  2546,  2547,  2548,  2549,  2550,  2551,  2899,  2552,  2553,
    2554,  2555,  2556,  2557,  2558,  2559,  2560,  2561,  2900,  2562,
    2563,  2564,  2901,  2565,  2566,  2567,  2568,  2569,  2570,  2841,
    2842,  2571,  2572,  2573,  2574,  2575,  2576,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,
    2590,  2591,  2592,  2593,  2594,  2595,  2596,  2597,  2598,  2599,
    2600,  2843,  2601,  2602,  2603,  2604,  2844,  2605,  2606,  2607,
    2608,  2845,  2609,  2610,  2611,  2612,  2902,  2903,  2613,  2614,
    2615,  2616,  2617,  2846,  2847,  2618,  2619,  2620,  2621,  2622,
    2623,  2624,  2904,  2625,  2626,  2627,  2628,  2629,  2630,  2631,
    2632,  2633,  2634,  2635,  2636,  2905,  2848,  2637,  2638,  2639,
    2640,  2849,  2850,  2851,  2641,  2906,  2907,  2642,  2908,  2852,
    2853,  2854,  2855,  2856,  2857,  2858,  2859,  2860,  2861,  2862,
    2644,  2645,  2643,  2646,  2647,  2648,  2649,  2650,  2863,  2909,
    2651,  2910,  2652,  2653,  2654,  2655,  2656,  2657,  2658,  2659,
    2660,  2661,  2662,  2663,  2664,  2665,  2666,  2667,  2668,  2669,
    2670,  2671,  2672,  2864,  2911,  2865,  2673,  2674,  2675,  2676,
    2677,  2678,  2679,  2680,  2866,  2867,  2681,  2682,  2683,  2912,
    2684,  2868,  2685,  2869,  2686,  2687,  2688,  2689,  2690,  2691,
    2692,  2693,  2694,  2695,  2696,  2870,  2913,  2697,  2914,  2871,
    2698,  2699,  2700,  2701,  2702,  2703,  2704,  2705,  2706,  2707,
    2708,  2709,  2710,  2711,  2872,  2712,  2873,  2715,  2713,  2714,
    2716,  2717,  2718,  2719,  2720,  2721,  2722,  2723,  2724,  2725,
    2726,  2874,  2727,  2728,  2729,  2730,  2731,  2732,  2733,  2734,
    2735,  2736,  2737,  2738,  2739,  2740,  2741,  2742,  2743,  2744,
    2745,  2915,  2746,  2747,  2748,  2749,  2750,  2875,  2751,  2752,
    2753,  2754,  2755,  2756,  2757,  2758,  2759,  2760,  2761,  2762,
    2763,  2764,  2765,  2766,  2767,  2876,  2768,  2769,  2916,  2770,
    2771,  2877,  2772,  2773,  2774,  2775,  2776,  2777,  2778,  2779,
    2780,  2781,  2782,  2783,  2784,  2785,  2786,  2878,  2787,  2788,
    2789,  2790,  2917,  2791,  2792,  2793,  2794,  2795,  2796,  2879,
    2880,  2797,  2798,  2881,  2799,  2882,  2800,  2801,  2802,  2803,
    2804,  2805,  2807,  2806,  2808,  2809,  2810,  2811,  2812,  2813,
    2814,  2815,  2816,  2817,  2818,  2883,  2884,  2819,  2918,  2820,
    2821,  2822,  2823,  2824,  2825,  2826,  2827,  2828,  2829,  2830,
    2885,  2886,  2887,  2888,  2889,  2890,  2891,  2892,  2893,  2894,
    2895,  2831,  2832,  2833,   137,     0,     0,  2460,  2494,  2495,
    2498,  2493,   398,   397,  1645,  2457,  2494,  1534,     0,  1514,
     644,     0,  1450,   425,  1692,     0,     0,     0,     0,     0,
       0,   860,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   185,     0,     0,     0,     0,   449,
     448,     0,     0,  1061,   454,     0,     0,     0,     0,     0,
     634,  1576,  2713,  1574,  1646,   263,   266,   267,   264,   265,
    2476,     0,  1207,  1208,  1210,     0,     0,  1220,   900,   901,
       0,     0,     0,   914,     0,     0,     0,   898,     0,     0,
       0,   920,     0,   917,     0,     0,   921,   918,   895,   919,
     902,     0,   894,     0,     0,  1220,   922,     0,     0,   896,
       0,     0,     0,     0,  1450,  1573,   455,  1692,     0,  1557,
    1558,  1559,  1535,  1547,  1560,  1552,  1554,  1553,  1555,  1556,
    1551,  2475,  2512,   990,   990,   990,   990,   987,   988,   990,
     990,   990,  2734,     0,     0,   969,     0,   971,  2477,   990,
     995,  2520,   526,   526,   526,     0,   994,   999,   526,     0,
    1418,  1459,  2459,  1704,     0,   970,  1417,  2797,  1563,     0,
       0,  1235,  1231,  1233,  1234,  1232,     0,  1064,  1064,  2753,
    1427,   247,  2765,  2879,  2797,   246,   241,   242,   215,  2516,
       0,     0,   994,     0,  1450,  1425,   966,  1711,  1709,     0,
    2444,  2539,  2556,  2654,   238,  2746,  2755,  2765,  2879,  2797,
    2830,   194,   204,   199,     0,   256,  2765,  2879,  2797,   252,
    1447,     0,  1672,  1822,  1821,  2453,     0,  1420,  1419,  1536,
       0,  1539,     0,  2729,  1676,  1679,  1541,  1677,  2496,  1900,
    1929,  1907,  1929,  1929,  1896,  1896,  2586,  1909,  1897,  1898,
    1934,  1954,     0,  1929,  1896,  1901,     0,  1899,  1937,  1937,
    1924,     3,  1879,  1880,  1881,  1882,  1910,  1911,  1883,  1916,
    1917,  1921,  1884,  1951,  1887,  1896,  2497,  1713,  1714,  2444,
       4,  2490,     5,  2276,  2489,     6,     7,  1668,     0,     0,
       1,  1692,     0,  1546,  1708,  1708,     0,  1708,     0,  1660,
    1668,  1663,  1667,     0,     0,     0,     0,     0,     0,  1421,
       0,     0,     0,   925,     0,  1462,  1046,     0,     0,     0,
       0,     0,  1304,     0,  1104,  1103,  2499,  2482,  2483,  2484,
       0,  2480,  2481,  2500,  2501,  2502,     0,  2624,  1304,     0,
       0,  2192,  2203,  2204,  2205,  2543,  2605,  2200,  2201,  2202,
    2194,  2195,  2196,  2197,  2198,  2199,     0,     0,  1202,  2193,
       0,  2624,     0,  1304,     0,   164,     0,   141,  1304,     0,
       0,  2624,     0,     0,  2624,     0,     0,     0,     0,     0,
    2624,     0,     0,     0,     0,     0,   164,  2659,     0,   141,
    2624,     0,     0,  1441,     0,     0,     0,  1443,  1446,  1433,
       0,  2273,     0,  2274,  2461,     0,  1528,  1522,  1531,  1527,
    1517,     0,  2453,     0,     0,     0,     0,   908,     0,     0,
     898,     0,     0,     0,   909,     0,   910,   911,     0,     0,
       0,     0,   907,     0,  1431,  1423,     0,  1565,  1567,  1566,
    1568,  1564,   526,     0,     0,     0,  2624,     0,   141,  1501,
       0,  2624,   141,     0,     0,   453,   452,   141,  2480,   451,
     450,  2543,  2605,     0,  1094,     0,  1177,   141,  2624,     0,
     187,  2624,   703,  2624,  1541,     0,   647,     0,   815,  2659,
     141,     0,     0,     0,     0,     0,     0,  1064,     0,     0,
       0,     0,     0,     0,     0,   633,   644,  1577,  1575,     0,
    1211,   240,   239,  1209,   912,  2624,  1136,   359,     0,     0,
    2624,  1482,  2624,   359,   929,   913,     0,   899,  2624,   359,
    1100,  2624,  2485,   174,     0,   897,  2543,  2605,  2624,   359,
    1204,     0,  2624,   359,  2624,   170,  2624,   359,  2624,   359,
    2624,   648,     0,     0,  2624,   359,  2624,  2659,   172,   916,
    2624,   359,   923,  2624,   359,  2455,  2624,     0,  1434,     0,
    1569,     0,  1549,  2883,     0,  1692,   990,   989,     0,   990,
       0,   990,     0,   990,     0,   990,     0,     0,     0,   990,
    2478,  2479,   972,     0,   996,     0,  1004,     0,  1003,  1002,
    1001,     0,     0,     0,  1005,     0,  1826,  1604,     0,  1415,
    1430,     0,     0,     0,  1064,     0,  1063,     0,     0,  1426,
     245,   243,     0,     0,     0,     0,     0,     0,  1432,     0,
    1424,     0,     0,     0,  2463,  2465,  2466,  2206,  2276,     0,
    2835,  2836,  2837,  2265,     0,  2838,  2839,  2840,  2898,  2095,
    2082,  2091,  2096,  2083,  2085,  2092,  2841,  2842,  2021,  2843,
    2844,  2473,  2845,  2846,  2847,  2849,  2850,  2851,  2852,  2853,
    2854,  2855,  2856,  2857,  2858,  2859,  2860,  2862,  2863,  2087,
    2089,  2864,  2865,  2867,     0,  2474,  2868,  2869,  2692,  2871,
    2872,  2874,  2875,  2093,  2877,  2878,  2879,  2880,  2881,  2882,
    2472,   493,  2094,  2884,  2886,  2887,  2888,  2889,  2891,  2892,
    2893,  2894,     0,     0,     0,  2450,     0,  2060,     0,  1888,
    1889,  1912,  1913,  1890,  1918,  1919,  1891,     0,  1892,  2449,
    1955,  2151,  2059,  2077,     0,  2065,  2066,     0,  2058,  2054,
    2127,  2284,  2285,  2286,  2281,  2282,  2283,  2280,  2413,  2414,
    2153,  2437,  2438,  1694,  2445,     0,  2055,  2462,  2464,  2266,
    1694,  2443,   207,   258,     0,   259,  2451,  2765,   195,   237,
     209,   236,   210,   208,     0,  2541,   196,     0,     0,   197,
       0,     0,     0,     0,   255,   253,     0,  1422,     0,  1824,
    1823,  2454,   934,     0,  1538,  1535,  2216,     0,  1678,     0,
       0,     0,  1928,  1915,  1923,  1922,     0,  1905,  1904,  1903,
       0,  1902,  1929,  1929,  1927,  1906,  1879,     0,     0,     0,
    1933,     0,  1931,  1875,  1871,     0,  1940,  1941,  1942,  1939,
    1952,  1938,     0,  1885,  1943,     0,  1896,  1893,  1779,     0,
    1658,  1657,     8,     0,  1543,  1545,  1520,  1541,  1706,  1707,
       0,     0,     0,     0,     0,     0,     0,     0,  1766,  1724,
    1725,  1727,  1763,  1767,  1775,     0,  1664,     0,     0,     0,
    1828,     0,     0,  1448,     0,     0,     0,     0,     0,  1135,
       0,     0,     0,     0,   926,     0,     0,     0,  1468,     0,
    1470,  1471,  1472,     0,     0,     0,  1473,  1474,  1462,   249,
    1481,  1478,  1461,  1463,  1476,     0,     0,     0,     0,     0,
       0,     0,  1493,     0,   178,   179,     0,   660,   644,     0,
    2624,     0,     0,     0,     0,  1145,  1152,  1303,     0,     0,
       0,     0,     0,     0,     0,     0,  1146,  1144,     0,  1147,
     251,  1157,  1184,  1187,     0,     0,  1102,  1105,     0,     0,
       0,     0,     0,  1294,     0,     0,     0,  1294,     0,     0,
       0,  1303,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   274,   276,   289,   354,     0,   625,     0,     0,     0,
     628,     0,  2624,  1304,     0,     0,     0,  1206,     0,     0,
       0,     0,     0,     0,     0,     0,  1187,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   139,   140,   145,     0,
       0,     0,     0,  1187,     0,     0,     0,     0,     0,     0,
       0,   611,   624,     0,     0,     0,     0,     0,   621,     0,
       0,   141,   279,   601,   607,     0,     0,     0,   710,   709,
       0,     0,     0,     0,     0,     0,  1391,     0,  1390,     0,
       0,     0,     0,     0,  1491,  1490,     0,     0,     0,     0,
       0,     0,  1294,     0,   268,   270,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   390,   391,     0,     0,     0,   145,     0,     0,  1294,
       0,   281,     0,     0,  1442,  1439,  1440,     0,  1445,     0,
       0,     0,     0,  2068,     0,  2220,  1716,  2218,  1120,  2272,
       0,  2503,  2919,  2920,  2921,  2922,  2923,  2924,  2925,  2926,
    2927,  2928,  2929,  2930,  2931,  2932,  2933,  2934,  2935,  2936,
    2937,  2938,  2939,  2940,  2941,  2942,  2943,  2944,  2945,  2946,
    2947,  2948,  2949,  2950,  2951,  2952,  2953,  2954,  2955,  2956,
    2957,  2958,  2959,  2960,  2961,  2962,  2963,  2964,  2965,  2966,
    2967,  2968,  2969,  2970,  2971,  2972,  2973,  2974,  2975,  2976,
    2977,  2978,  2979,  2980,  2981,  2982,  2983,  2984,  2985,  2986,
    2987,  2988,  2989,  2990,  2991,  2992,  2993,  2994,  2995,  2269,
    2268,  2458,  2504,  2505,  2506,  2507,  2275,     0,     0,   226,
     227,   225,  1529,   228,  1530,  1526,     0,  1512,     0,     0,
       0,     0,     0,     0,     0,     0,  2543,  2605,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   823,  1462,  1500,     0,     0,     0,
     653,     0,  2624,     0,   143,   861,     0,   813,   454,     0,
       0,     0,     0,  1367,   143,     0,     0,   181,     0,     0,
     707,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   814,     0,     0,   143,     0,  2624,   604,  2624,     0,
     526,   526,     0,     0,  1066,     0,     0,     0,     0,     0,
       0,     0,     0,  1650,  1649,  1652,  1651,     0,  1648,     0,
     357,   358,     0,  1194,  1219,     0,     0,     0,     0,     0,
     890,   915,     0,     0,  1188,     0,     0,  2624,   359,  2624,
       0,  2624,     0,     0,     0,  1196,   359,     0,  1190,     0,
       0,  1192,     0,  1393,     0,   906,   904,   903,   905,     0,
       0,   888,     0,     0,     0,     0,     0,   883,     0,     0,
     885,     0,     0,     0,     0,  1692,  1548,     0,   980,     0,
     984,     0,   975,     0,   981,     0,   976,   973,   974,     0,
     979,     0,     0,   527,   529,     0,     0,  2568,  2585,     0,
    2613,  2647,  2648,  2702,  2719,  2749,  2755,  2761,     0,  2791,
    2802,     0,  1010,  1041,  1000,   719,     0,     0,  1614,  1416,
    2225,     0,  1692,     0,     0,     0,  1227,  1228,   244,   216,
       0,     0,     0,  1043,  2753,  1429,   965,   644,     0,  2056,
       0,  2063,  2064,  2264,     0,     0,     0,     0,     0,     0,
    2062,     0,     0,     0,     0,  2405,     0,     0,  2421,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1977,     0,
       0,  2224,     0,     0,  2224,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1978,  1959,  1960,
    2060,  2216,     0,  2061,  2469,     0,  1951,  2508,  2206,     0,
    2203,  2204,  2205,  2996,  2997,  2998,  2999,  3000,  3001,  3002,
    3003,  3004,  3005,  3006,  3007,  3008,  3009,  3010,  3011,  3012,
       0,  3013,  3014,  3015,  3016,  3017,  3019,  3018,  3020,  3021,
    3022,  3023,  3024,  3025,  2279,  3027,  3028,  3029,  3030,  3031,
    3032,  3033,  3034,  3035,  3036,  3037,  3038,  3039,  3040,  3041,
    3042,  3043,  3044,  3045,  3046,  3047,  3048,  3049,  3050,  3051,
    3052,  3053,  3054,  3055,  3056,  3057,  3058,  3059,  3060,  3061,
    3062,  3063,  3064,  3065,  3066,  3067,  3068,  3069,  3070,  3071,
    3072,  3073,  3074,  3075,  3076,  3077,  3078,  3079,  3080,  3081,
    3082,  3083,  3084,  3085,  3086,  3087,  3088,  3089,  3090,  3091,
    3092,  3093,  3094,  3095,  3096,  3097,  3098,  3099,  3100,  3101,
    3102,  3103,  3104,  3105,  3106,  3107,  3108,  3109,  3110,  3111,
    3112,  3113,  3114,  3115,  3116,  3117,  3118,  3119,  3120,  3121,
    3122,  3123,  3124,  3125,  3126,  3127,  3128,  3129,  3130,  3131,
    3132,  3133,  3134,  3135,  3136,  3137,  3138,  3139,  3140,  3141,
    3142,  3143,  3144,  3145,  3146,  3147,  3148,  3149,  3150,  3151,
    3152,  3153,  3154,  3155,  3156,  3157,  3158,  3159,  3160,  3161,
    3162,  3163,  3164,  3165,  3166,  3167,  3168,  3169,  3170,  3171,
    3172,  3173,  3174,  3175,  3176,  3177,  3178,  3179,  3180,  3181,
    3182,  1992,  3183,  3184,  3185,  3186,  3187,  3188,  3189,  3190,
    3191,  3192,  3193,  3194,  3195,  3197,  3198,  3196,  3199,  3200,
    3201,  3202,  3203,  3204,  3205,  3206,  3207,  3208,  3209,  3210,
    3211,  3212,  3213,  3214,  3215,  3216,  3217,  3218,  3219,  3220,
    3221,  3222,  3223,  3224,  3225,  3226,  3227,  3228,  3229,  3230,
    3231,  3232,  3233,  3234,  3235,  3236,  3237,  3238,  3239,  3240,
    3241,  3242,  3243,  3244,  3245,  3246,  3247,  1994,  3248,  3249,
    3250,  3251,  3252,  3253,  3254,  3255,  3256,  3257,  3258,  3259,
    3260,  3261,  3262,  3263,  3264,  3265,  3266,  3267,  3268,  3269,
    3270,  3271,  3272,  3273,  3274,  3275,  3276,  3277,  3278,  3279,
    3280,  3281,  3282,  3283,  3284,  3285,  3288,  3286,  3287,  3289,
    3290,  3291,  3292,  3293,  3294,  3295,  3296,  3297,  3298,  3299,
    3300,  3301,  3302,  3303,  3304,  3305,  3306,  3307,  3308,  3309,
    3310,  3311,  3312,  3313,  3314,  3315,  3316,  3317,  3318,  3319,
    3320,  3321,  3322,  3323,  3324,  3325,  3326,  3327,  3328,  3329,
    3330,  3331,  3332,  3333,  3334,  3335,  3336,  3337,  3338,  3339,
    3340,  3341,  3342,  3343,  3344,  3345,  3347,  3346,  3348,  3349,
    3350,  3351,  3352,  3353,  3354,  3355,  3356,  3357,  3358,  3359,
    3360,  3361,  3362,  3363,  3364,  3365,  3366,  3367,  3368,  3369,
    3370,  3371,  3372,  3373,  3374,  3375,  3376,  3377,  3378,  3379,
    3380,  3381,  3382,  3383,  3384,  3385,  3386,  3387,  3388,  3389,
    3390,  3391,  3392,  3393,  3394,  3395,  3396,  3397,  3398,  3399,
    3401,  3400,  3402,  3403,  3404,  3405,  3406,  3407,  3408,  3409,
    3410,  3411,  3412,  3413,  3414,  3415,  3416,  3417,  3418,  3419,
    3420,  3421,  3422,  3423,  3424,  3425,  3426,  3427,  3428,  3429,
    3430,  3431,  3432,  3433,  3434,  3435,  3436,  3437,  3438,  3439,
    3440,  3441,  3442,     0,  2200,  2201,  2202,  2194,  2195,  2196,
    2197,  2198,  2199,  2210,     0,     0,  2448,  2509,     0,  2153,
       0,  1974,     0,  2161,     0,     0,  1779,     0,  2467,  2267,
    1779,   260,   261,   257,     0,     0,   212,   211,     0,   230,
     234,   235,   206,   233,     0,   229,   214,  2140,  2139,   213,
     205,   202,   200,   217,   219,   220,   203,   201,   254,     0,
       0,     0,   359,  1546,  1533,     0,     0,  2279,     0,  2214,
       0,     0,  2212,     0,     0,     0,  1776,     0,  1680,     0,
    1684,     0,     0,     0,  1926,  1925,  1876,  1872,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   927,     0,  1894,     0,  1844,  2491,  2492,  2277,  1712,
    1546,     0,  1542,  1675,  1674,  1717,  1718,  1086,  1673,  1746,
    1747,     0,     0,     0,     0,  1772,  1770,  1737,  1728,  1736,
       0,     0,  1734,     0,  1738,  1955,  1765,  1662,  1722,  1723,
    1726,  1661,     0,  1768,     0,  1617,  1766,  1727,  1601,     0,
    1579,     0,     0,  1829,     0,     0,  1449,     0,     0,     0,
    1115,  1117,     0,  1116,     0,  1119,     0,  1128,     0,     0,
    1114,  1133,     0,  1122,  1120,     0,  1489,     0,     0,     0,
       0,     0,  1469,     0,     0,     0,  2791,   248,  1472,  1477,
    1464,  1475,     0,     0,     0,     0,     0,  1045,  1044,     0,
       0,  1068,     0,     0,   493,  1496,   515,     0,   356,     0,
       0,     0,     0,     0,     0,     0,     0,   809,   806,     0,
       0,   805,     0,   658,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   683,     0,  1294,     0,   287,
       0,  1154,     0,  1153,     0,  1158,     0,     0,  1155,  1150,
    1151,  2755,  2765,  2797,   250,  1156,  1186,     0,  1185,  1181,
       0,  1097,     0,  1098,     0,     0,     0,     0,     0,  2597,
    2624,   295,   318,     0,  1293,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     340,     0,     0,   343,   342,     0,     0,     0,     0,     0,
     348,     0,   326,     0,   327,     0,   347,     0,     0,     0,
     626,   627,     0,     0,     0,  1294,     0,   283,     0,     0,
       0,     0,     0,     0,     0,     0,  1203,     0,   736,     0,
       0,  2755,  1182,     0,     0,  1376,     0,  1377,  1380,   526,
       0,   526,  1382,     0,     0,  1379,  1381,     0,     0,   167,
       0,   162,   166,     0,     0,  2755,  1183,     0,     0,     0,
       0,     0,   609,   610,   623,     0,   614,   615,   612,   616,
     617,     0,     0,     0,     0,     0,     0,     0,   608,     0,
       0,   705,   704,   708,     0,     0,     0,     0,     0,     0,
    1385,     0,     0,  1177,     0,     0,  1384,  1392,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1237,  1236,
       0,     0,     0,     0,  1304,     0,   851,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   169,   723,     0,   722,
       0,   163,   168,     0,     0,     0,     0,     0,     0,     0,
       0,   224,  1438,  1444,  1716,  1716,  1716,  2074,     0,     0,
       0,     0,  1715,  2270,  2273,  1517,  1523,  1516,  1515,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   404,   401,   402,   404,
       0,     0,     0,     0,   825,     0,   828,   831,  1460,   477,
       0,     0,   650,   683,     0,     0,   457,   176,     0,     0,
       0,     0,   738,     0,  1177,  1176,   138,   185,   187,   455,
       0,   186,   188,   190,   191,   192,   189,   193,     0,   702,
     706,     0,     0,     0,     0,   646,     0,     0,     0,     0,
       0,     0,     0,  1849,     0,     0,   161,     0,     0,   599,
     603,     0,     0,     0,     0,   457,   565,   370,  2624,     0,
     526,     0,  2624,     0,  1065,     0,   812,     0,     0,     0,
    1139,  1139,     0,     0,   752,   751,     0,     0,     0,     0,
       0,     0,  1647,   359,  1137,     0,  1483,     0,   359,   930,
     359,  1101,   175,  2486,     0,   892,     0,     0,     0,     0,
     359,  1205,   880,   359,   171,   359,   359,   649,     0,   359,
     173,     0,     0,   359,   924,   359,  2456,     0,   359,  1572,
    2624,   526,  1550,   977,   986,   985,   983,   982,   978,     0,
     997,     0,   525,     0,     0,     0,     0,     0,  1018,  1019,
       0,     0,  1015,  1020,     0,  1022,  1006,  1008,  1016,  1017,
    1023,  1012,  1011,  1024,  1025,     0,     0,  1043,   717,     0,
       0,     0,     0,  1611,     0,  1609,     0,  1827,  1613,  1602,
    1562,     0,  1561,     0,   592,  1064,  1064,     0,     0,   994,
       0,     0,   359,  1428,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2229,     0,  2230,     0,     0,
    2263,  2259,     0,     0,     0,     0,     0,  2233,  2236,  2237,
    2238,  2235,  2239,  2234,     0,     0,  2240,     0,     0,  2304,
    2051,     0,  2060,  2405,  2432,     0,  2436,  2442,  2403,     0,
    2292,  2220,  1955,  2418,     0,  2417,  2416,  2405,  2428,  2422,
       0,  2428,  2405,  2403,  2405,  2403,     0,     0,     0,     0,
       0,     0,  2220,  2223,     0,     0,  2875,     0,     0,     0,
       0,  2022,     0,     0,  2187,     0,  2220,     0,     0,     0,
       0,     0,     0,     0,  2216,  2255,     0,   491,     0,  2012,
       0,     0,     0,  2138,     0,  2135,     0,     0,     0,     0,
    2276,     0,     0,  2470,  1956,  1970,  1971,  1972,  1975,  2447,
       0,  2278,     0,     0,  1957,  1983,     0,  2256,  2008,     0,
    2013,  1998,  2044,  2241,  2242,  2243,  2244,  2015,     0,  1991,
    1996,  2000,  2051,     0,  1979,     0,  1976,     0,  2279,  2215,
       0,  2213,     0,  1967,  1968,  1969,  1961,  1962,  1963,  1964,
    1965,  1966,  1973,  2191,  2189,  2190,     0,     0,  2161,     0,
       0,  1995,     0,     0,  2076,  2616,  2654,     0,  1705,  1705,
    1705,  1693,  1703,  2446,  1844,  1716,  1844,  2452,     0,     0,
    1951,     0,  1825,   932,   933,   931,  1519,  1532,  1546,  2217,
    1540,  1682,     0,     0,     0,  1895,  1908,     0,  1935,  1936,
    1937,  1937,     0,  1877,     0,  1920,  1945,  1946,  1947,  1948,
    1949,  1950,     0,  1944,  1886,   928,  2852,  2861,     0,  2751,
    2895,     0,  1805,  1778,  1780,  1790,  1805,  1812,  1805,  2078,
    1842,  2079,  1805,  2080,  2453,     0,  1749,  2488,  1521,  1544,
       0,  1084,  1085,     0,  1089,  2875,  2751,     0,     0,     0,
       0,  1739,  1773,     0,  1764,     0,  2463,  1740,  2462,  1741,
    1744,  1745,  1735,  1774,  1615,     0,  1769,  1666,  1665,     0,
    1847,     0,     0,     0,  1593,  1581,     0,     0,  1830,     0,
    1779,  1619,     0,  2276,  1777,  1343,  1238,  1305,  1118,     0,
    1896,  1129,     0,  1113,     0,  1112,  1896,     0,  1130,     0,
    1896,  1344,  1239,  1306,  1345,  1240,  1307,  1346,  1480,  1241,
    1479,  1467,  1466,  1465,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   790,  2624,
     359,  1494,  1347,     0,  1242,   355,  1495,  1308,  1499,   808,
     807,     0,     0,  1309,     0,   659,   664,     0,   666,   667,
    2543,  2605,   668,   671,   672,     0,   674,   663,   662,     0,
       0,     0,     0,     0,   680,   685,     0,     0,     0,     0,
       0,     0,  1148,  1149,  1348,  1245,     0,  1310,     0,  1096,
       0,  1246,   177,     0,     0,   275,  2624,   297,     0,   475,
     790,     0,  1296,   294,   324,     0,   339,   334,   335,   333,
    2624,   359,  2624,   359,     0,     0,     0,     0,     0,   336,
     331,   332,   328,     0,     0,   341,  2515,  2587,  2766,     0,
     691,   693,     0,   698,   344,  1266,   366,   365,   364,     0,
     349,     0,   371,   374,     0,   346,   325,   323,   320,   290,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1198,     0,  1351,  1311,     0,  1333,     0,     0,     0,
       0,   730,  1354,  1252,  1314,     0,     0,   526,     0,   541,
     541,   526,  1365,  1253,   165,  1283,   154,     0,     0,   150,
       0,     0,     0,     0,   144,  1355,  1254,  1315,     0,     0,
    1356,  1255,     0,     0,   280,   602,   613,   618,  1260,   622,
     619,  1323,   620,  1363,  1256,     0,  1359,  1286,  1318,   585,
    1177,  1177,  1366,  1386,  1257,  1177,     0,  1294,     0,   269,
     271,     0,  1064,     0,  1258,     0,  1316,  1358,  1285,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1502,     0,
       0,     0,     0,     0,     0,   359,     0,     0,     0,  1296,
    2624,   359,  1357,     0,  1291,     0,  1331,     0,     0,   392,
       0,  1284,  1294,     0,   282,  1262,     0,  1325,     0,     0,
     222,   221,   223,     0,     0,     0,     0,  2221,  2222,     0,
    2219,  2069,  2272,     0,  1513,   954,   940,   953,     0,   936,
    2585,     0,   939,   941,     0,     0,     0,   942,   946,   947,
       0,   938,   935,   937,     0,   403,     0,     0,   747,   748,
       0,     0,     0,     0,   827,     0,     0,  1492,     0,   141,
     657,     0,     0,     0,   652,   682,   687,     0,     0,     0,
       0,   456,   460,   464,   465,   466,     0,     0,     0,     0,
     155,   142,     0,   869,     0,   526,     0,   740,  1177,  1369,
       0,   187,   180,     0,     0,   703,     0,  1541,     0,     0,
     580,   583,   582,     0,   370,   822,   820,   819,   821,   843,
     818,     0,  1848,  1850,     0,     0,     0,     0,     0,     0,
     592,   459,     0,     0,   529,     0,   568,     0,     0,     0,
       0,   565,     0,     0,     0,  2496,     0,   839,   811,     0,
    1107,     0,  1125,  1108,     0,     0,     0,     0,  1162,  1169,
    1138,  1163,  1140,  1169,     0,     0,   753,   757,   756,   760,
     758,     0,   754,   631,  1653,  1654,     0,  1195,     0,     0,
    1488,     0,  1486,   891,  1189,   359,     0,   359,     0,   359,
    1197,  1191,  1193,  1394,     0,   889,     0,     0,   882,   884,
       0,   886,     0,   998,   528,     0,     0,     0,     0,     0,
       0,  1014,   629,  1021,     0,     0,     0,  1036,  1031,  1033,
       0,  1037,   716,     0,     0,  1612,  1605,  1607,  1606,     0,
       0,  1603,  2226,   881,     0,   598,     0,     0,     0,     0,
    1043,     0,  1038,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1710,  2227,  2228,     0,     0,     0,  2260,
       0,     0,  2112,     0,  2084,  2086,  2098,     0,  2113,  2067,
       0,  2302,     0,     0,  2403,  2304,     0,  2431,     0,     0,
       0,  2405,     0,  2436,     0,  2408,     0,     0,     0,  2415,
    2419,     0,     0,     0,  2051,  2051,  2328,     0,     0,  2325,
    2114,  2088,  2090,  2099,     0,     0,  2207,     0,  2102,  2101,
       0,  2024,  2025,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2039,  2103,  2186,     0,     0,     0,  2105,  2104,     0,
       0,  2254,     0,     0,     0,  2110,   492,  2115,     0,     0,
       0,     0,  2121,     0,  2143,     0,     0,     0,  2057,  2217,
       0,     0,     0,     0,     0,     0,     0,  2046,  2047,  2048,
    2045,     0,  2014,  1999,  2017,  1993,  1997,  2001,  2051,     0,
    2019,  2016,     0,     0,  1987,     0,     0,  1985,  2009,  1981,
       0,     0,  2010,     0,  2075,     0,     0,     0,  2164,  2159,
    2160,  1705,  1705,  1705,  1705,  1702,     0,     0,     0,  1749,
       0,  1749,   198,     0,   231,   218,  1518,  1683,  1692,  1914,
       0,  1932,  1930,  1873,  1878,  1953,     0,  1805,  1812,  1805,
    1805,     0,     0,  1668,     0,  1790,     0,  1804,  1788,  1803,
       0,     0,  1818,  1816,     0,  1818,     0,  1818,     0,  1782,
       0,  1808,  1784,  1803,  1786,     0,  1834,  1792,  2454,  1843,
       0,  1762,  1719,     0,  2208,  1089,     0,  1721,  1743,  1742,
       0,  1732,     0,  1771,  1729,  1616,  1600,     0,  1598,  1585,
    1587,  1586,     0,     0,  1588,  2276,     0,  1598,  1580,     0,
    1624,     0,     0,  1847,     0,  1623,     0,  1896,  1110,  1111,
       0,  1134,     0,  1048,  1049,     0,  1047,     0,     0,     0,
     514,  1067,     0,     0,     0,   790,     0,     0,   518,     0,
    1497,     0,  1364,  1282,   661,     0,     0,     0,     0,   676,
     635,   677,   679,     0,     0,   678,   681,   684,  1294,     0,
     288,  1268,     0,  1329,  1142,     0,     0,  1099,     0,     0,
       0,     0,     0,     0,   474,   687,   319,     0,     0,     0,
       0,   379,     0,   299,   311,   377,   317,     0,   351,     0,
     322,     0,   315,   337,   329,   338,   330,   350,   352,     0,
     695,   696,   694,   690,     0,   697,   699,     0,   368,     0,
       0,     0,   345,     0,  1350,     0,  1294,     0,   284,  1264,
       0,  1327,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1332,     0,     0,     0,     0,   735,
       0,   732,     0,     0,   541,  1378,     0,  1375,  1373,   541,
       0,     0,   147,   146,     0,   153,     0,     0,     0,     0,
       0,     0,  1387,  1388,  1389,     0,     0,     0,     0,     0,
       0,   386,     0,   291,   293,   292,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   393,   361,     0,   846,     0,     0,     0,
     395,     0,     0,  1342,     0,     0,     0,     0,     0,  1349,
    1247,  2072,  2073,  2070,  1716,  2271,     0,     0,     0,   951,
       0,     0,     0,     0,   406,   407,   141,   405,   428,     0,
     790,     0,     0,   824,   829,   837,  2692,  2194,  2195,   835,
     830,   832,   834,   836,   833,     0,     0,     0,     0,   496,
       0,     0,     0,   483,     0,     0,   493,   476,   479,   480,
       0,     0,   653,   656,   654,   655,     0,   675,     0,   459,
     503,   555,     0,   157,     0,     0,   158,   156,     0,     0,
     370,   737,     0,   734,  1368,     0,   183,     0,   707,     0,
       0,     0,     0,     0,  1177,   645,     0,   842,   844,   816,
       0,   687,     0,     0,   604,     0,   526,  1573,   587,     0,
     557,   459,   555,   564,     0,     0,   572,   369,     0,     0,
     592,   370,     0,     0,  1068,     0,   838,     0,     0,  1106,
       0,     0,     0,  1159,  1164,  1160,     0,  1139,  1121,     0,
    1161,     0,     0,  1167,  1092,  1141,  1093,  1410,  1411,  1408,
    1409,     0,     0,     0,     0,     0,     0,  1644,     0,     0,
    1484,     0,   893,     0,   876,     0,   878,   359,   724,     0,
     359,     0,     0,     0,     0,     0,     0,  1013,     0,  1007,
    1009,  1034,     0,     0,  1043,  1040,     0,     0,  1610,  1608,
     590,     0,  1229,  1230,  1043,     0,   359,  1042,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2231,     0,
    2262,  2258,     0,  2081,  2232,  2307,  2303,  2052,  2050,  2049,
       0,  2404,  2430,     0,     0,  2433,     0,     0,  2405,  2402,
    2309,  2312,  2311,  2313,  2409,  2410,  2411,  2412,     0,     0,
    2293,  2295,  2425,  2424,     0,     0,  2423,  2420,  2405,  2335,
    2332,  2337,     0,  2288,  2289,     0,  2310,  2320,  2319,  2321,
       0,     0,     0,     0,     0,  2187,     0,     0,  2023,  2035,
    2036,  2037,  2247,     0,  2042,     0,  2032,  2033,  2034,  2026,
    2027,  2028,  2029,  2030,  2031,  2038,  2251,  2250,     0,     0,
    2107,  2108,  2109,  2253,  2116,     0,  2533,  2144,     0,  2120,
    2137,  2136,     0,     0,     0,  2123,     0,     0,  2133,     0,
    2188,  2471,  1958,     0,     0,  1984,  2257,  2002,     0,  2020,
    2018,  1980,  2207,     0,     0,     0,     0,     0,  1989,     0,
       0,  2184,     0,     0,     0,  2166,  2163,     0,     0,     0,
       0,  1696,  1695,  1701,  1762,  2069,  1762,     0,     0,  1874,
       0,  1789,  1785,  1787,  1793,     0,  2890,     0,  1794,  1801,
       0,  1781,     0,  1817,  1813,     0,  1814,     0,     0,  1815,
       0,     0,  1783,     0,  1801,     0,  1841,  1708,     0,  2155,
       0,  1720,  1087,  1088,  1730,     0,  1733,  2564,  1845,     0,
    1599,     0,     0,     0,  1590,  1596,  1578,     0,     0,     0,
    1620,  1598,  1621,  1131,     0,     0,  1123,  1054,  1055,  1058,
    1056,  1053,  1057,     0,     0,     0,   790,     0,     0,   536,
       0,  1081,  1081,     0,     0,   520,   577,     0,   793,     0,
       0,     0,   791,   359,  1243,     0,     0,     0,     0,   636,
    1362,  1244,     0,     0,     0,     0,  1143,  1297,     0,     0,
    1267,     0,   296,   473,   472,   477,     0,     0,   302,   312,
       0,   307,     0,  1295,     0,     0,     0,     0,   306,   309,
     381,     0,   378,     0,   359,   359,   353,   692,   367,   372,
     373,   376,  1302,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   870,   853,     0,     0,
     871,   872,     0,     0,     0,  1200,  1201,  1199,  1334,  1335,
    1340,  1337,  1336,  1339,  1341,  1338,     0,  1250,     0,     0,
     728,  1298,     0,  1370,     0,  1374,   151,   148,   149,   152,
    1299,  1280,  1261,  1324,   586,     0,     0,     0,  1259,     0,
    1317,     0,  1276,  1270,     0,     0,     0,     0,     0,  1361,
    1290,  1322,  1360,  1288,  1320,  1287,  1319,  1289,  1321,  1281,
       0,     0,  1852,   850,     0,     0,     0,   359,   359,   849,
     726,  1263,     0,  1326,  1272,     0,     0,     0,   943,     0,
       0,     0,   945,   411,   429,   141,     0,   746,   810,     0,
       0,   826,     0,   481,     0,   487,   494,     0,     0,   498,
     499,   497,   482,  1177,   526,  1177,   779,   780,     0,     0,
     800,     0,   651,     0,     0,   457,     0,   500,     0,     0,
     461,   160,   159,     0,     0,     0,   741,   745,   743,   742,
     744,   739,     0,   730,   187,  2624,     0,     0,     0,     0,
     584,   578,   581,  1383,   817,     0,  1851,   720,     0,   370,
     600,     0,     0,     0,   457,   592,     0,   462,   467,   468,
     477,     0,   565,   556,     0,   557,   566,   567,     0,   574,
    1458,     0,   593,   574,     0,     0,     0,   841,     0,   840,
       0,  1109,  1126,  1127,     0,     0,  1169,     0,     0,  1171,
    1166,     0,     0,   759,   762,   755,   638,   359,     0,  1487,
     359,   359,  1226,     0,   887,  1028,  1029,  1030,  1027,  1026,
     630,     0,  1032,   991,   718,     0,   591,   359,     0,   992,
     968,   960,   967,   956,   959,   961,     0,   963,   964,   958,
     955,   957,  2261,  2097,     0,  2305,  2053,  2287,  2435,  2434,
    2429,  2441,     0,  2406,     0,     0,  2298,  2427,  2426,     0,
    2333,  2334,  2332,  2331,  2329,  2338,  2339,  2350,     0,  2327,
    2318,     0,  2290,  2100,  2111,     0,  2186,  2217,     0,     0,
    2043,     0,     0,     0,  2106,  2885,     0,     0,  2148,  2149,
       0,  2145,  2146,  2141,  2142,  2122,     0,  2680,  2128,     0,
       0,     0,  2006,  2004,  2003,  1988,     0,     0,  1986,  1982,
       0,  2011,  2150,  2183,  2217,  2152,     0,  1716,  1700,  1699,
    1698,  1697,  2155,  2468,  2155,   232,  1687,     0,  2375,  1837,
       0,  1840,     0,     0,  1791,     0,     0,  1795,     0,     0,
    1797,  1799,     0,     0,     0,     0,     0,     0,  2457,     0,
    1761,     0,  1716,     0,  1731,     0,  1597,  1582,     0,  1583,
    1589,     0,     0,     0,     0,     0,  1625,  1618,  1124,  1132,
       0,     0,     0,   516,     0,   531,     0,     0,     0,  1074,
    1083,  1073,     0,   531,   531,   795,   794,   797,   792,   796,
    1498,     0,   669,   670,   673,  1269,     0,  1330,  1278,     0,
    1614,   298,   469,   305,     0,     0,     0,   300,   380,   382,
     301,   304,   308,   361,   321,   314,     0,     0,     0,  1265,
       0,  1328,  1274,  1301,  1352,  1248,  1312,     0,     0,   859,
       0,     0,     0,     0,  1353,  1249,  1313,     0,     0,     0,
    1372,  1371,     0,     0,  1614,     0,     0,     0,     0,     0,
       0,     0,     0,  1507,     0,     0,   360,   848,   847,   361,
     394,  1292,     0,  2071,     0,   944,   949,   950,   948,     0,
     400,   408,   411,     0,     0,  1217,  1217,     0,     0,   478,
     495,     0,   576,   535,   576,     0,     0,     0,     0,     0,
     688,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   733,   732,   182,     0,   457,     0,   687,     0,   845,
       0,     0,     0,   592,   459,     0,     0,  1570,   458,     0,
       0,   470,     0,   568,   557,   565,     0,     0,   589,     0,
    1451,     0,   595,     0,     0,     0,   789,  1165,     0,  1179,
       0,  1120,  1090,  1174,     0,  1692,  1844,     0,     0,     0,
       0,   772,     0,   642,  1218,  1485,   877,   879,   725,  1035,
       0,  1039,  1043,   962,  2306,  2308,  2440,  2407,  2294,  2296,
       0,  2291,  2439,  2330,  2316,  2342,  2343,  2344,  2345,  2346,
       0,     0,  2341,  2322,  2324,  2246,  2188,  2040,     0,  2249,
    2248,  2252,     0,  2117,     0,  2118,  2147,  2124,  2129,     0,
    2125,  2126,  2007,  2005,  1990,  2185,     0,  2170,  1670,  1669,
       0,  1690,     0,     0,  2366,  2373,  2374,  1842,     0,     0,
    1836,     0,     0,  1867,     0,     0,     0,  1802,  1820,     0,
    1798,  1796,     0,  1809,     0,  1811,  2563,  2847,  2748,     0,
    1748,  1750,  1753,  1755,  1754,  1756,  1752,  2154,  2156,     0,
    1727,  2209,  1846,     0,     0,     0,  1069,     0,     0,  1626,
    1627,  1622,  1036,     0,   359,  1081,     0,  1177,   537,  2692,
     538,  1080,  1082,  1086,     0,  1177,  1177,   665,     0,     0,
     277,     0,   303,   313,   363,   375,     0,  1614,     0,     0,
     857,   866,   866,   854,     0,     0,   873,  1251,   729,     0,
     540,     0,   272,  1277,  1271,     0,     0,     0,  1509,  1510,
       0,     0,     0,     0,     0,  1300,   359,  1273,   952,     0,
     431,   438,   412,   416,  1501,     0,  1501,     0,   413,   417,
    1501,  1501,   410,  1844,   427,  1217,     0,  1214,  1213,   524,
     606,     0,     0,   485,     0,   546,   484,     0,   801,     0,
       0,   686,     0,   459,   555,     0,   513,   504,   505,   506,
     507,   509,   508,   510,   511,   512,   502,   501,     0,   687,
     863,   370,  1458,   727,     0,     0,   700,     0,   687,     0,
    1573,   588,   557,   459,   555,   463,   477,     0,   572,   565,
     568,     0,   569,     0,   573,     0,     0,     0,   592,  1511,
    1068,     0,     0,   790,  1178,  1139,     0,     0,  1168,  1172,
    1173,     0,     0,     0,     0,  1221,   766,   767,   761,   763,
       0,   774,   778,   637,     0,     0,   641,   632,   687,   359,
    2297,  2299,     0,  2315,  2317,     0,  2326,     0,  2336,     0,
       0,  2041,     0,     0,  2131,  2130,  2165,     0,     0,     0,
       0,     0,     0,     0,  1681,  2673,     0,  2353,  2355,  2356,
    2358,  2357,  2359,     0,     0,     0,  2314,  2363,  2364,     0,
       0,  1835,  1838,     0,  1870,     0,     0,     0,     0,  1855,
       0,  1800,     0,     0,  1810,     0,     0,     0,  1757,     0,
       0,     0,  1766,     0,  1595,  1844,     0,  1592,     0,  1635,
       0,  1628,  1050,     0,  1051,  1075,     0,   576,     0,  1086,
    1089,   526,   576,   576,  1279,     0,   606,     0,   316,     0,
     285,  1275,     0,     0,   868,   868,     0,     0,     0,     0,
       0,     0,   388,     0,     0,  1503,     0,  1504,  1505,  1508,
     396,   409,     0,   436,     0,   434,   433,   435,     0,   424,
       0,     0,     0,     0,     0,     0,   399,  1212,  1216,  1215,
       0,   486,     0,   488,     0,     0,   532,   533,   534,     0,
     490,   542,   543,   798,     0,   803,     0,   689,     0,     0,
     687,   554,   711,     0,     0,     0,  1452,     0,     0,   579,
     721,  1458,   592,   565,     0,   557,   471,     0,   574,   568,
     572,   570,   571,     0,  1455,     0,   594,     0,  1077,   788,
       0,  1169,  1180,  1175,  1170,  1414,     0,     0,   764,   769,
     768,  1501,   773,     0,     0,     0,   640,   639,   715,   993,
       0,     0,  2347,  2349,     0,     0,  2245,  2134,  2119,  2132,
    2834,  2564,  2805,     0,  2182,  2171,  2182,  2182,  2162,     0,
       0,     0,  2371,     0,  2352,     0,     0,  2368,     0,     0,
    2380,     0,  2391,  2378,  2381,  2382,  2379,  2385,  2386,     0,
       0,  2351,     0,     0,  1868,  1869,  1853,     0,     0,  1857,
    1807,  1833,     0,     0,     0,  1751,  2157,  2158,  2487,  1584,
    1594,  1070,     0,     0,     0,  1635,     0,     0,   541,     0,
    1089,  1071,   535,   790,   790,  1614,   310,   362,     0,     0,
       0,   864,   867,   855,   856,   875,   874,   731,  1614,     0,
     384,   383,     0,   387,     0,   432,   441,     0,   439,   414,
     419,     0,   423,   421,   420,   415,   418,   523,     0,     0,
       0,     0,     0,     0,   544,     0,   545,     0,   802,     0,
       0,     0,   713,   862,     0,     0,   457,   687,  1453,  1571,
     568,   557,   565,     0,     0,   559,  1081,  1081,   444,   572,
     574,  1456,  1457,     0,     0,   493,     0,  1091,  1413,  1412,
    1692,     0,     0,     0,   775,   776,   771,     0,     0,  2300,
    2301,     0,  2340,  2323,     0,  2175,  2174,  2173,  2177,  2176,
       0,  2169,  2167,  2168,     0,     0,     0,  2295,  2354,  2360,
    2368,     0,     0,  2328,  2401,  2398,  2399,  2400,     0,  2394,
    2396,     0,  2376,     0,     0,     0,     0,     0,     0,  2365,
    1839,     0,  1856,  1859,     0,     0,     0,  1865,     0,  1858,
    1860,     0,  1819,     0,  1831,  1759,     0,  1758,  1844,  1634,
       0,     0,   359,   530,   790,   539,  1072,   546,   519,   517,
     278,  1614,   858,     0,   273,     0,   389,  1506,   437,     0,
     422,   605,   489,   575,   551,     0,   550,     0,   548,   547,
     799,   804,     0,   687,   852,  1458,   701,   572,   565,   568,
       0,   558,     0,  1083,  1083,   574,   442,     0,     0,   370,
       0,  1396,  1692,  1395,  1397,  1405,  1402,  1404,  1403,  1401,
       0,  1224,  1225,   765,   770,     0,     0,     0,     0,     0,
    2179,     0,  2180,     0,     0,     0,     0,  2408,  2368,  2367,
    2337,  2393,     0,     0,  2392,  2391,  2384,  2383,  2388,  2390,
    2389,  2387,     0,  1862,  1863,  1864,  1866,  1861,  1806,     0,
    1760,  1591,  1637,     0,     0,  1629,  1630,     0,  1052,   521,
     790,   286,   865,     0,   440,   549,   526,   526,   687,   712,
    1454,   574,   568,   572,  1081,   560,  1082,   562,   561,   446,
    1077,  1078,     0,   574,   778,     0,  1406,  1400,  1668,  1655,
       0,     0,   777,     0,  2348,  2172,  2178,  2181,     0,     0,
       0,     0,  2370,  2362,  2328,  2325,  2395,  2397,     0,     0,
    1632,     0,     0,     0,  1631,   522,     0,   553,   552,   714,
     445,   572,   574,  1083,   493,  1076,     0,  1844,     0,  1398,
    1692,     0,     0,   783,  1686,  1685,  2852,     0,     0,  1689,
    2337,  2361,     0,  1832,  1636,  1633,     0,     0,     0,     0,
    1638,   385,   574,   443,   563,   370,  1079,  1059,     0,  1399,
       0,     0,   785,     0,   781,   784,   786,   787,     0,     0,
    2350,  1854,  1642,     0,     0,     0,   447,   574,     0,     0,
       0,   749,     0,  1716,     0,  2369,     0,     0,     0,  1844,
       0,     0,     0,   782,     0,     0,  1639,  1643,     0,  1640,
    1060,   783,  1222,  1223,     0,  1688,     0,     0,     0,   750,
    1641
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5910, -5910, -5910,  4093,  -490, -5910, -5910,  -967, -1403,  3331,
   -1222, -5910, -5910, -5910,  1426, -5910, -5910, -5910, -5910,  4061,
   -5910,  1953, -2957, -5910, -5910,   154,  4013, -1404,   152,  3640,
    1601, -5910, -1045, -5910, -5910,  -640,     1, -5910,  4006,   527,
   -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,  -808,  2068,
   -5910,  2161,  1405,  3834, -3149, -5910, -5910, -1547, -3770, -5910,
     654, -5910,   680, -4894, -1046, -5910, -5910, -5910,  2054, -5910,
   -5910, -5910,  2003,  1194,  -389, -5910, -5910, -5910, -5910, -5910,
   -5910,  -858, -5910, -5910, -1183,     2,  -665, -2988, -4366, -5910,
   -5910,   506,  -430, -1533, -5910,   699, -5910, -4727, -5910,   -12,
   -2725, -2542, -5910, -5910, -5910,  -401, -1508,  1494, -5910,  -783,
   -1200,  1877, -2816, -1005, -5910,  -277, -3602, -1157,  -871,  -869,
   -1037, -4427, -4945, -5910, -5910, -1189, -3803, -5274, -5513, -4972,
   -4981,  1502, -5910,   -41,   507, -5910,     5, -3698, -3815,     7,
     480, -5910,    17,    21, -5910,   497,  -803,  -986, -1609, -5910,
    -915, -5910, -5910, -5910, -3497, -5910, -5910, -5910,   168, -5910,
   -5910, -5910, -5910,   546, -5910, -5910, -5910, -5910, -5910, -5910,
   -3222,  2029,  2031, -5910, -4208, -5910,  -970, -5910,   707, -3529,
    1429, -5910, -5910,  1188,  4080,   529, -5910, -5910, -5910, -5910,
   -5910, -5910, -1814, -5910, -5910, -5910, -5910,   -14,  -377, -5910,
   -5910, -5910, -5910, -5910, -5910, -5910,    22, -5910,  1151,   467,
   -5910, -5910,  -687, -5910, -5910, -5910, -5910, -5910, -5910, -1250,
   -5265, -1364, -1344, -5910, -3551, -5910, -5910, -5910,  -347, -5910,
   -5910, -5910, -5910, -5910,  -884, -5910,  1245, -4205, -5910, -5910,
     509, -5910, -5910, -5910, -5910, -5910, -1013,  -283,  3233, -5910,
    -542,  -774, -5910, -5910, -5910,  -281, -5910, -5910, -5910, -5910,
   -5910,  -521, -1292,  5095,  4456, -1127,   564,  -849,  -582, -5910,
   -5910, -5910, -2700, -5910, -5910, -4381, -5910,  5092,  2504,  1557,
      23, -5910,     0,   120,  3893, -5910,  1123, -1178, -3160,   468,
    -497, -5910, -5910, -5910, -3123, -5910, -5910, -5910, -5910, -4151,
      24, -5910,  -751, -5910, -4417, -5273, -4675, -4176, -1211, -5910,
   -5720, -4664, -5251, -4132, -5910,  2063, -5910, -5910,  -578,  -187,
    3216, -5910, -1492,  2404, -1455, -5910, -2626,   535,  1598,  3224,
   -3323,  -137,  3212, -3024, -5910,  -732,  1193, -5910,  -369, -3817,
   -5910, -5910, -5910, -2876,  -628, -5910, -5910,  2030,   794, -5910,
   -5910, -5910, -5910,  -661,  3189,  -195, -5910, -5910,  4432, -5910,
   -5050, -5910,  4400, -5910, -5910, -5910, -5910,  3113,  3119, -5910,
   -5910, -1474,  1358, -5910,  -834, -5910, -5910,  2179,   751, -5910,
   -5910, -5910, -5910,  1451,  -447, -5910, -5910, -5910, -5910, -5910,
   -5910, -5910,  -980, -1226, -5910, -5910, -5763, -5910, -5910, -5910,
   -5910, -5910,  2384,  -983,  -769,  4306,  1115,    31, -5472, -5910,
   -5910,  -896, -5910,  3641, -5910, -5910, -5910, -5910, -5910,   536,
     537, -5910, -5910, -5910, -5910, -3957, -5910, -5910, -5052, -5910,
   -5910,  2162, -5910, -5910,  1380,    13,  3360, -5910, -5910, -5910,
     -17, -5910, -5910, -1039,  2507, -5910, -2421, -5910,  -609, -5910,
   -5910, -1933,    32, -4410, -5910,    58, -5910, -5910, -5139, -1240,
     322, -5910, -5910, -4048,    61, -5910, -5910, -5910, -5910, -5153,
   -5910,    63, -5039,   905, -3381, -5910,     6, -5910,  -433,  -864,
   -5910, -5910, -5910, -3965,    33,   134, -5910, -5910,    40,   517,
     -52,   -31,   -27,    14,   143,  3767, -5910, -5910, -5910, -5762,
    3800, -5910,    11,  -893,  5152,  5154, -5910,  -894,  -160,   498,
    1718,  -713, -2631,  3709,  3708, -5910,  1706,  2521, -2495, -2490,
   -5910,  -865,  -840,  -645, -5910, -5910, -5910, -5910, -1477,  -712,
   -2654, -5910,  3713, -5910, -5910, -5910, -2401, -3420, -3345,  1745,
   -3321, -3235, -5910,   991,   976,  -895,   -93,    80, -1497,  -809,
    1854, -5910, -5910,  1756,  -363, -5910, -5910,  -361, -3324,   935,
   -5910, -4665, -2858,  1761, -1151,  -817, -5910,  -978, -5910,  -614,
    4860,  3777,  -846, -5910, -5910,  -812, 11563, -5910, -5910, -5910,
   12293, 12853, -5910, -5910, 14485, 15206, -5910,  -636, 15659, 10321,
    -790, -1956,    70, 15998, 18225, -1809,  1859, -3145,  1161,  2508,
     277, -5910, -2961, -1895, -5910, -5910, -5910,  -326,  1087,  -559,
   -5910, -4682, -4506, -5910,  2652, -1926, -5910,  -622,  1835,  -613,
   -5910, -5910, -5910, -3047, -5643, -3057,  2654, -5910, -5910, -5910,
    -163, -5910, 18593, -3297, -5910,  -771, -1028, -1624,  3155, -3101,
   -1931, -5910, -5910, -5910, -3152, -5910, -5910, -5910,  -509,  1860,
   -5910, -5910,  1992, -5910, -5910, -5910,  -998,  2227,  -767, -1199,
    1865, -5910, -5910, -5910, -5910, -5910, -1958, -5910, -5910,  -923,
      30, -5910, -5910,  -744, -1979,  1187,  -922, -5910, -5910, -3961,
   -5064, -5910, -5910, -5910, -5910, -5910, -5910, -5061,  -292, -1112,
   -5910, -5125, -5910,    34, -5910, -5835, -5910, -5910,  -738, -1175,
    1799, -1027, -5910,  -757, -5910, -5910, -5910, -5910, -5910, -4594,
   -5910, -5910, -5910, -5910, -5910,  -756, -5413, -5910, -5910, -5910,
   -5910, -5910, -5910, -3320, -5910, -5910, -1031, -1026, -3081, -3111,
   -5910, -1020, -5910, -5910, -5910, -5910, -5910, -5910, -5910, -5910,
   -1969,  1978, -5910, -5910,  1197, -1860, -5910, -5910, -5910,  4365,
    -831,  2686,  -822, 18343,  -714, 13775, -1297, -5910,   330, -5909,
     989,  6058,    37,  -135,   466,  -638,  2603,  2920, -5910, -5910,
    5479,  8222,  -617,  -691, -5910,    -6, 10899, 10722, -3738, -5910
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    57,    58,    59,    60,    61,    62,  1638,  3057,  2911,
    3880,  3881,    63,    64,  1634,    65,    66,    67,    68,  1548,
      69,  1109,  1887,  3071,    70,  2747,   852,   853,   854,  2612,
    2613,  3002,  2614,  2602,  1400,  1833,  1570,   826,   827,  1530,
    1571,    72,    73,  1394,  2593,    74,    75,    76,  1601,  1695,
    1602,  1603,  1542,  1933,  5032,  5878,  3670,  2866,  3928,  3671,
    3672,  4354,  4355,  4443,  5892,  5893,    77,  1711,  1712,    78,
      79,  3039,  3846,  4496,  5430,  5431,  5692,   665,  5055,  5056,
    5679,  5680,  5906,  6087,  6088,  3072,   696,  3923,  4580,  3871,
    5126,  3872,  5127,  3873,  5128,  4344,  4345,  3857,  4527,  4528,
    2088,  5068,  4529,  3874,  5087,  5726,  3875,  2766,  5921,  3106,
    2005,  2003,  5627,  5705,  4888,  4889,  4417,  5930,  5931,  5932,
    6238,  5089,  5132,  5133,  6124,  6125,  3926,  4586,  5139,  5488,
    5703,  3568,    81,  3899,  3900,    82,   759,  1909,  4025,   760,
    3109,   697,   761,  3073,    87,  3099,  5923,  3100,  1664,  2925,
    4509,  4003,    88,  1136,  4319,  5513,  5786,  5787,   750,    89,
    1895,    90,    91,  3052,  3864,    92,  2783,  3585,    93,    94,
    3604,  3605,  3606,    95,  4537,  5449,  1604,  3659,  3660,  3661,
    3662,  4375,    96,  1890,  3080,  3081,    97,    98,    99,  3210,
    3211,   100,  2988,   101,   102,   103,   104,  4411,  4990,  5103,
    3701,  3887,  4553,  5101,   105,  3850,  3074,  3127,  3961,  3962,
    5511,  5778,  5779,  5780,  5981,  6273,  5782,  5983,  6146,  5985,
    5078,  6423,  6424,  5763,  4308,  4902,   107,  5079,  5080,  5936,
     108,  2781,   109,   110,  1864,  3045,  3046,  4510,  3116,  3936,
    3937,  4566,  4567,   111,  3788,   112,  4966,  4967,   698,  5944,
    5884,  6073,   113,   114,  4970,  4971,   115,   116,   117,   118,
     119,   751,  1071,  1072,   753,  1191,  1192,  3540,  1153,   120,
    2622,   121,  3826,   122,  1262,  5191,   123,   785,  1207,  1208,
    3075,   125,   795,  3229,   797,  3195,  3196,  2021,  4007,  4008,
    4654,   126,   127,  3207,  3232,   128,  1535,  2757,  2758,  4883,
    3076,   699,  1247,  3113,  3563,  5615,  5339,  5616,  6135,  6342,
    5340,  5633,  3484,  4257,   130,   700,  1576,  2822,  1159,  1160,
    3120,  3941,  2727,  2728,  1734,  4607,  2730,  3943,  2731,  1509,
    2732,  1146,  1147,  3949,  3950,  3951,  3952,  4603,  4613,  4614,
    5505,  5771,  4610,  1883,  5499,  5500,   131,  1573,  2819,   132,
     133,   134,  1617,   996,  1169,  1170,   135,   712,   713,   136,
    5697,   137,  1149,   138,  5509,   139,   140,   817,   818,   141,
     142,  2836,  4357,   143,  1574,   144,   145,  3695,  3696,  4982,
     146,   147,   148,  2897,  2898,   149,   150,   151,   152,   153,
    6263,  6345,  6346,  6347,  4621,  6140,   154,  1239,   155,   156,
     157,   158,   196,  1037,  1038,  1039,   949,  3077,  5490,   160,
     161,  1531,  1532,  1533,  1534,  2752,   162,   163,   164,  3971,
    3972,   165,   166,   167,   168,  1867,   169,   170,  5670,   171,
     172,  1837,   173,   174,  1045,  1046,  1047,  1048,  1835,  3428,
     659,   871,  1425,  1431,  1474,  1475,  1476,   176,   763,   177,
    1242,  1076,   764,  1200,   179,   765,  2709,  3514,  4272,  4273,
    4274,  4277,  5323,  4860,   766,  3510,   182,  2028,  3216,  3219,
    3506,   767,  3520,  3521,  3522,  4281,   768,  5619,  5620,  6054,
    6315,  6316,  6374,  6410,   769,   787,  1139,  3131,   770,  1347,
     188,   189,   190,   929,   874,   875,  3433,  5571,  5814,   192,
    2586,  3411,   804,  1480,   917,   918,   919,   938,  3012,  2675,
    2676,  2700,  2701,  1489,  1490,  2688,  2692,  2693,  3497,  3490,
    2681,  4251,  5600,  5601,  5602,  5603,  5604,  5605,  4849,  2696,
    2697,  1492,  1493,  1494,  2705,   193,  2665,  3463,  3464,  3465,
    4227,  4228,  6202,  4242,  4238,  4834,  5300,  3466,   863,  1237,
    1501,  4842,  6204,  3467,  5289,  5290,  5580,  4246,  3476,  4268,
    3911,  3912,  3913,  3468,  5838,  5839,  6199,  6200,  5582,  5583,
    2733,  1454,   902,  1348,   903,  1467,  1349,  1441,   905,  1350,
    1351,  1352,   908,  1353,  1354,  1355,   911,  1433,  1356,  1357,
    1450,  1463,  1464,  1358,  1426,  5584,  3372,  4064,  4688,  1360,
    1361,  1362,  3470,  1363,  4778,  5260,  5246,  3334,  3335,  2609,
    4774,  4140,  4768,  2579,  2583,  5312,  5607,  5608,  3404,  4189,
    4805,  5277,  5810,  6004,  6005,  6161,  1364,  1365,  1366,  3396,
    2573,   999,  1367,  4512,  2575,  3325,  3303,  1737,  3304,  2031,
    2052,  3248,  3264,  3265,  3373,  3305,  3313,  3318,  3326,  3358,
    1368,  3250,  3251,  4050,  2054,  1369,  1043,  1740,  1044,  1469,
    3353,  1370,  1371,  1372,  1373,  1374,  3278,  3279,  4711,  5216,
    6020,  5531,  5790,  5791,  3280,  4061,  4686,  5205,  5524,  4727,
    4728,  4705,  4706,  4707,  5828,  5537,  5538,  4729,  4730,  4731,
    1375,  4721,  4722,  5224,  5222,  5227,  5228,  5798,  5540,  5541,
    3472,  5288,  5816,  5817,  5818,  5819,  5820,  5829,  5830,  6173,
    5821,  5822,  6013,  5574,  5575,  6021,  6295,  6023,  6024,  6025,
    6026,  6027,  6028,  6029,  5576,  6178,  6179,  6180,  4075,  3275,
    1376,  4708,  4709,  1377,  1378,  3284,  3285,  3286,  3287,  3288,
    3289,  4084,  1379,  3276,  4071,  1380,  1381,  1382,  4073,  1390,
    1391,  1384,  2022,   864,  5296,  1195,  1820,   801,  1385,  1386,
    1387,  1388,  1610,   970,  1162,  1163,   920,   922,   923,  2669,
     655,   647,   972,  3663,  2576,   656,   649,   650,  1825,  2577
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     648,    71,    80,  1832,   928,    83,   184,    84,  1383,  1228,
    1229,  1230,  1736,   175,   191,  1234,   997,    85,  1103,   962,
    1395,    86,   106,   124,   129,  2002,  1663,  1003,  2765,   939,
    1008,   159,   178,   185,   762,   191,   831,  1948,  1194,  3567,
     186,  1049,  1481,  1668,  1483,   916,  1826,  1495,   998,  2831,
    1446,  2860,  3507,  2729,  2938,  1728,   866,  1422,   180,   789,
     950,   181,  1716,   183,  1609,   789,  1466,  1248,  3870,  2049,
    4030,  1140,  1437,  1438,  2832,  1892,  3508,  3753,  2042,  4346,
    1409,  1006,  1445,  2823,  4011,  3270,  3274,  3277,  3094,  4266,
    4199,  1201,  4201,  3294,  1142,  1028,  1175,  3953,  1421,  3222,
    3291,  1427,  3533,  3535,  1514,  4578,  4325,  3006,  4418,  1452,
    1188,  3892,  3292,  2843,  4704,  3295,  4224,  3785,  4514,  3247,
    2729,  1865,  3901,  4851,   862,  1870,  4890,  4370,  4591,  4372,
    1874,  2899,  2899,  1834,  4565,  2899,  4616,  4925,  4280,  1070,
    1884,  1049,   653,   796,  1605,  5293,  4241,  4885,  1202,   704,
    3343,  2968,  2969,  1904,  1173,  5135,   832,  1177,   933,  3161,
     941,  2814,  4066,  5536,   942,  1185,  5539,  5125,  2661,  1627,
     232,  5492,  4279,  5086,  1644,  4950,  4080,  5146,  5305,  5613,
    5307,  4086,  5709,  4088,  1937,  3414,  4255,   825,  3889,  3416,
    5485,   648,  5453,   877,   859,   851,  3499,  1577,  5362,  1049,
     648,   973,  3426,  3502,  1662,  1402,  4286,  5640,   648,  5748,
     973,   648,  4087,  1694,  4089,  5134,  4169,  5341,  2964,  1877,
    4575,  2814,  5761,  1721,   973,  1488,  1491,  4170,  1142,  4866,
    1572,  4239, -2608,  4244,  1901,  5958,  1606,  4247,  2814, -2529,
    5484,   771,   771, -2649,   710,  2995,  1434,  1435, -1929,  3478,
     771,  5662, -2675,  1049,  4068, -2716,  2794,  1444, -2612,  1900,
    5946,  5251, -1896,   663,  4157,  4601,  2980, -1909,  1209,   771,
   -2461,  1572,  1544,  3310,  3860,  5824,  1572,  3091, -1934,  3351,
   -1954,   948,  2620,   644,  3351,  1421, -1924,  1213,  5193,  5194,
    5195,   705,  5197,  5198,  5199,  5200,  5201,  2834,  5096,  1857,
   -2496,  1033, -2497,   710, -2901,  1021,   710,  4348, -2460, -2496,
   -2496, -2497, -2497, -2901, -2901,  1049,   710,  5220,   710,   869,
    2109,  3829,  6406,  3832,  3833, -1937,  4104,  4048,  3837,  3838,
    3839,  2834,  3841,  3842,  3843,  2599,   645,  1606,   710,  2834,
    3579, -1937,  1862,   771,  4611,   771,  4081,  2026, -2372,  1129,
     710,  1821,  2626,  2834,  6187,  -141,  4321,  6154,  1399,  5672,
    5673,  -141,  2666,  5117,   710,  2962,  5338, -2192,  5793,  3037,
     710,  4413,  5507,  4081, -2192,  2834,  1914,  6265,  6270,  1930,
     936,   710,  5870,  4326,  2899,  2628,  5698,  1545,  3861, -2457,
    5147,  4544,  2975,  5804,  5097,  4963,  5883,  3103,  3055,  3676,
    1930,  4232,  5084,  5481,  1034,  5015,  6253,  6254,  2087,   777,
    5755,  1930,  6022,  3446,  3327, -2672,   777,  1930,  5756,  5918,
     777,  5122,  4349,  1826,  3104,  1930,  1728,  5846,  1983,   777,
    1544,  1142,   777,   778,  4233,   777,  3399,  3060,  2672,  1879,
     778,  3208,  3124,  5248,   778,  1121,  1121,  6130,  5123,  4837,
    6372,  6398,  2600,   778,  4338,  6365,   778,  1232,   657,   778,
     657,  3223,  5668,  5706,  3206,  3125,  1882,   777,  3779,  1035,
    2109,  2668,  4235,  2851,  1437,  1438,  5960,  2947,  3810,  6118,
    3092,  3066,  1122,  1122,  5098,  5669,  1404,  1442,  1443,  3447,
    2870,   778,  2603,  2034,  5880,  4104,   771,  2615,  2615,  6265,
    6270,  3096,  2626,  3780,  4502,  1445,  2948,  3393,  2852,  2595,
     658,  1979,   932,  1946,  3394,  3708,   998,   187,  1123,  4557,
    6444,  2109,  6407, -2211,  4964,  1930,  4158,   951,  4069,  6373,
   -2211,  1036,  4339,  1956,  2834,  2628,   963,  1452,   187,  5749,
    2834,  3209,  1097,  2834,   963,  1545,  4437,   963,  1107,  1930,
    1233,  6174,   890,  2626,  1946,  2063,  2621,  5249,  1257,  3061,
    1120,  4028,  2664,   981,  5348,  6430,   998,  1124,  1124,  3328,
     982,   983,   984,   927,  4104,  2102,  5919,  3566,  4562,  1826,
    2103,  4545,  1267,  3400,  5737,  4104,  2628,  2601,  -430, -3027,
   -3027, -3027,  1594,  1930,  2023,   706,  1986,  3862,  4237,  3056,
    5016,  5757,  3010,  5085,  4530,  2033,  6022,  3231,  3212,  1041,
    1460,  5805,  4159,  1042,  6383,  3231,  6255,   711,  6060,  2043,
    4082,  2046,  2589,  2844,  2771,  3105,  3677,  6265,  6270,  6101,
    5794,  3126,  2749,  3038,  4965,  6355,  5508,  4322,  2801,  1434,
    1435,  5594,  4514,  4326,  1142,  5917,  1546,  4082,  2808,  5124,
    4350,  4351,   973,  2941,  2663,  1882,   707,  3093,  2994,  3825,
    2981,  5099,  3352,  4602,  4612,  2642,  3249,  4175,  4985,   870,
    1080,   973,  6012,   971,  6408,  3580,  1444,   973,   191, -2672,
    2027,  4352,  1007,  5825,  5221,  6129,  1931,  1259,  3863,   973,
    2982,  2933,  3608,  1863,  2936,   708,  1029,   709,  4160,  2943,
    3684,  3004,  3005,  1134,  1081,   973,   928,  1931,   940,  2861,
     648,  1547,  6188,  1727,  2963,   916,  2639,  1432,  1931,   648,
     973,  2027,  1077,  2861,  1931,  1078,   648,  1079,   973,   648,
    6409,  2715,  1931,  5100,  6331,  2923,  4475,   664,  2926,  2927,
    3213,   916,   973,  2799,  3003,  1205,  5556, -2192,  2905,  1863,
    1607,  1608,   973,  1616,  4895,  3243, -2672,  3443,   783,   784,
    4494,  4495,   952,   954,  2597, -2608,   957,  4070, -2672,  3471,
   -1929,   191, -2529,  6330,  1821,  5142, -2649,   783,   784,  2878,
    5095,  1496,  2706,  2707,  1436, -2675,  1015,  1142, -2716,  1440,
    1041, -2612, -2461,  1025,  1042,  1142,  1142,  5953,  2956,  2957,
   -1934,  3179,  2064,  2922,  3473,  2877,  2644,  2645, -1924,  1206,
     973,  1211,  4993,  1215,  1041,  5523,  2976,  4995,  1042,  1219,
    6382,  5143, -2496,  5327, -2497,  2105, -2901,  1447,  2587,  1448,
   -2460,  2572,  1931,   648,   648,  1636,  1536,  4119,  3419,   973,
    6428,  2818,  3011,  1447,  6084,  1448,  6247,  1449,  3163,  3811,
    1932,  1607,  1608,   783,   784,  1863,  1931,  4514,  1637,  4083,
    6257,  4253,  2861,  1451,   973,  2667,   648,  1848,  6412,  -141,
    -141,  1939,  1844,  1041,  4432,  4433,  1849,  1042,  1850,  4434,
    4110,  3189,  1943,  6276,  1236,  4831,  6058,  3395,  1954,  4835,
     916,  6063,  6064,  3204,  2818,  4438,  1976,  4241,   941,   998,
    1931,  4912,   942, -2211,  4955,  3378,  4288,  4666,  4289,  6177,
    5349,  2818,  6220,   648,  1267,  1233,  1839,  4104,  1233,  4282,
    1222,  4105,  4106,  4107,  1628,  6224,   973,  5054,  5536,  4531,
    3025,  5539,    71,    80,  4556,  4563,    83,   184,    84,  4717,
    4718,  4563,  4732,  4575,   175,   191,  1236,  2862,    85,  5058,
    5865,  1537,    86,   106,   124,   129,  1529,  1946,  2845,  2886,
    4696,  2862,   159,   178,   185,  4653,  3214,  4875,  6102,  3048,
    4068,   186,  2846,  2772,  2847,  6333,  2567,  2568,  2569,  2570,
    2571,  2572,  4821,  4690,  4823,  4824,  6128,  3215,   943,   180,
    5700,  5407,   181,  3499,   183,  4015,  1979,  1398,  3065,  4260,
    5784,  1406,  5057,  4116,  4117,  4118,  4119,  4206,  3666,  1456,
    6122,   788,  4554,  6208,  1881,  5408,  1428,   788,  3449,  5956,
    1946,  4617,  1411,  4789,  3848,  1503,  1500,  2793,  3554,  2569,
    2570,  2571,  2572,   710,   648,   648,  1822,  2848,  4968,  1629,
    3283,  1551,   973,  3537,  6110,  6174,   951,   648,  6290,  3379,
    2773,  2668,   916,   648,  3380,   963,  2759,   648,  6381,   648,
    6121,   943,   963,   916,  4653,   963,  3667,  2584,  6321,   987,
     988,   989,   990,   991,   992,   993,   994,   995,   944,   916,
    4114,  4115,  4116,  4117,  4118,  4119,  2935,  1457, -3027, -3027,
   -3027,  4114,  4115,  4116,  4117,  4118,  4119,  1224,  6183,  6312,
    2862,   960,  2679, -1896,  3381,  1826,  5807,  2861,  5742,  4983,
    6313,  4618, -1745,  1725,   661,  1093,   710,  3555,  2863,  4283,
    1618,  2759,   648,  3957,   648,   648,  3190,  4109,  3107,  5166,
     945,  2591,  2863,  1538,  4489,  1902,  1518,  2761,  1705,  1460,
    4017,  2760,  5111,  1098,  1706,   799,   936,  2861,  2864,  1098,
    3069,   944,  1156,  6438,   660,  4270,  6175,  2762,  6256,  1903,
    4890,  1098,  2864,  1458,  2861,   973,  1459,  4969,  6032,   825,
    1686,  5645,  3047,  2865,  3769,  1539,  6248,  1930,  1246,  3668,
    3770,   187,  2902,   710,  5785,  2906, -1896,  2865,  3471,  6279,
    5321,  1267,  4271,   648,  4104,  3201,  3202,  1619,  4105,  4106,
    4107,  2767,  2761,  6184,  2955,  2592,  1700,  5076,  6138,  3919,
    1540,  1049,  4110,  3958,  2859,  2680,  4783,   194,  4700,   191,
    2774,  1630,  2762,  3473,  1519,  2965,   973,  1896,  2859,  2768,
    4511,  1084,  4701,  1087,  3070,   916,  1089,   973,  1267,  6400,
    1923,  4104,  4016,  1504,  4069,  4105,  4106,  4107,  3849,  1701,
    1114,   973,  2861,  1707,  1924,   973,  1118,  3382,  4444,  5736,
    3538,  6176,   195,  1631,  3165,  3539,  5535,   648,  6433,  5808,
    1897,  2863,  6280,  3532,   187,   927,  2861,  3244,  1520,  3246,
    1541,  4396,  1225,  6339,  1460,  3253,  1412,  5939,  4619,  3771,
   -1745,  3267,  3268,  3188,   928,  3627,  1726,  3193,  1632,  5409,
    5809,  2864,  3200,  3296,  1922,  3203,  1267,  3142,   648,  4104,
    5477,  1925,  3315,  4105,  4106,  4107,  2775,  5955,  3330,  6466,
    4608,  3154,  4422,  3609,  5701,  2763,  2865,   946,  1882,  5483,
    5952,  4784,  6404,  2103,  3160,  5333,   648,   648,   648,  5502,
     648,  4891,  1988,  5967,  1990,  2862,  1992,  5938,  1994,  5471,
    1996,  1997,  1998,   811,  3669,  3257,  3138,  2000,   710,  6380,
    4620,   648,  4261,  1413,  3140,  3455,  5536,  2859,  3813,  5539,
    6234,  6387,  6281,  5077,  3511,  1253,  3172,  5954, -1896,  3153,
    2585,  3599,  3155,   951,  1863,  2862,  3820,  4018,  3159,   963,
    2763,  1521,  4854,   963,  6139,   963,  4397,  1461,   973,  2769,
     946,  3685,  2862,  6177,  4109,  5190,   973,   973,  2624,  3191,
    6413,   803,  5322,  2814,  1926,  2861, -2377,   961,  1518,  3301,
    4111,  4112,  4113,  4114,  4115,  4116,  4117,  4118,  4119,  4108,
     648,  1094,  3192,  2861,  3064,  1708,  3198,  3199,  6314,  3349,
    6436,  6326,  1702,  2764,   812,    40,   940,  3959,   187,  2673,
    2674,  4109,  2678,   942,   942,  1522,   942,   998,  1915,  1822,
    1917,  1918,  3960,  1898,  4204,  6449,  1267,  3258,  1157,  4104,
    2996,  3772,  5863,  4105,  4106,  4107,   648,  1709,  3600,  6156,
     648,   648,    44,  2861,  1931,  3699,  1927,  5297,  5326,  4110,
    2862,  2938,  5301,  1523,  5837,  5303,   648,  1524,  4101,  4102,
     809,    35,   916,  4121,  6458,  6170,  1519,  5294,  2764,  6302,
    3610,  2809,  1710,  3773,  2862,   811,  2863,  4702,   836,  4109,
    4660,  5942,  6171,  5857,  6282,    48,  3242,  3686,  2884,  4703,
    5950,  5183,  1525,  2983,  3336,  3504,  4110,  3339,    49,  1965,
    4262,  5187,  3481,  4152,  4153,  3259,  2864,  5926,  3774,  1614,
    1615,  1703,  5639,  5751,  5450,  5071,  2863,  5661,  5472,  3415,
    1520,    50,  3700,  3471,  6194,  1526,  3471,  1527,  5752,   916,
    4855,  2865,  1899,  2863,  3512,   934,  6287,  1500,  4398,  1500,
    5988,    56,  1966,  5156, -1896,  5879,  2864,  5212,  1928,  6337,
    6338,  1826, -1896,  6235,  1436, -1896,  1465,   756,  3473,  3103,
   -1896,  3473,  3901,  2864,  4110,  5122,   812,  5219,  1033,  2810,
     916,  2865,  2859,  5827,  3471,  4430,  6327,    15,  1528,  1841,
    4399,  3260,  3471,  3183,  3261,   813,  3104,  3942,  2865, -1744,
    4725,  6175,  5123,  3482,  1853,  1529,  2682,  2777,  4514,  4440,
    1529,  1633,   935,   916,  5225,  6157,    40,  3505,  2778,  3473,
    6166,  3781,  2859,  2862,    20,  4400,  6408,  3473,  5741,  4700,
    2729,  2863,  3603,  3599,  2729,  1875,  1876,   814,   815,  2859,
    2885,  2862,  5811,  1521,  6358,  2984,  1033,  6236,  6172,  4109,
    6051,  6195,  5750,    44,  2683,  2863,  3782,  1946,  5113,  3724,
    1913,  2864,  1946,  4661,  6364,  5927,  5858,  4111,  4112,  4113,
    4114,  4115,  4116,  4117,  4118,  4119,  6237,  3552,   973,  5226,
    1017,  1034,  5116,  3612,  1529,  2864,  2865,  6359,  1529,  6414,
    1946,  2862,   187,   648,   648,   648,    48,  5908,  5072,  5910,
    1950,  1952,  6112,  5914,  5915,   936,  6176,  2748,  6061,    49,
    2865,  1018,  3262,  5812,  4111,  4112,  4113,  4114,  4115,  4116,
    4117,  4118,  4119,   837,  4511,  3716,  3141,  2859,  1456,  3151,
    3600,   788,    50,   788,  4110,   788,  5753,   816,  2959,  3724,
    3599,   788,  1220,  1221,  5928,  1967,  1035,  1075,  4477,  1034,
    4981,  2859,  3513,  3775,  -682,  3181,  2051,   813,  5048,  3184,
     998,   998,  5446,  5052,    40,  3134,  4914,  4743,  2753,  4744,
    2685,  5075,  2928,  4019, -2480,  4726,  2060, -1744,  -164,  3181,
    2754,  3613,  4111,  4112,  4113,  4114,  4115,  4116,  4117,  4118,
    4119, -1095,   973,  3185,  2863,  3776,  2779,  5465,  2755,   814,
     815,    44,  1484,  6116,   916,  1128,  1457,  3186,  1036,  -164,
    4435,  3475,  2863,  3717,  1035,   916,  4957,  1526,  4725,  1527,
    4100,  6196,  3181,  1594,  2864,  3263,  6197,  1822,    32,   838,
    3777,   916,  2686,  2100,  5291,  1665,  2109,  3600,  2780,  1198,
    3434,  5534,  2864,  3187,    48,  4898,  2109,  4700,  1446,  2865,
     973,   937,  3503,  2871,  1968,   810,  4020,    49,   973,   771,
      40,  6198,  2863,  4282,  1408,  1484,   973,  2865,  3718,  1129,
    1095,  1485,  1096,  3601,   833,  1478,  1036,  1666,  2626,  6246,
      50,   676,  1458,  5447,   916,  1459,  1412,   998,  4436,  1486,
    2859,   860,  2864,   648,  6136,  1636,   648,    44,  6216,   916,
      56,  2628,   916,   916, -1062,  3735,   648,   648,  2859,   973,
     973,  2628,  4877,  5966,  3603,  3602,  5959,  2865,  1637,  1260,
    6070,   648,  4745,   973,   648,  2682,  2929,  5590,  1557,  3719,
    2930,  5945,  4899,   916,   916,    40,   973,   973,   788,  4511,
      48,  1821,  4111,  4112,  4113,  4114,  4115,  4116,  4117,  4118,
    4119,  5069,  1486,    49,   678,  3798,  1130,  1267,  2859,  1863,
    4104,  1706,  4953,  1413,  4105,  4106,  4107,   940,   940,   191,
     940,  2756,    44,  2683,   648,  1253,    50,   194,   648,   648,
    3736,  1479,  5266,  3273,  2768,  5783,    35,  3975,  3739,  3625,
    1667,  3742,  1484,  4726,  6143,  5671,    56,  6071,  5522,  3008,
    3009,  5535,  1487,  1460,  5345,  6329,  3783,   788,  1080,  4900,
     680,  3228,   648,  4901,   648,    48,   191,  2908,   872,   648,
     648,  3603,   195,  4928,  1505,  5070,   648,   648,   648,   648,
     648,   648,   648,   648,   648,   648,   648,   648,   648,  2684,
    4954,   648,  1081,   648,  2729,   648,   648,   648,   648,   648,
     648,  3720,  6341,   648,  2729,   648,   648,  3778,  4929,   648,
    1077,  4695,  4898,  1078,  1882,  1079,  1506,  5452,  4712,  4713,
    1707,    56,  4852,   916,   648,   648,   648,  3217,  5346,  1486,
    3814,  3815,  3816,  3734,  4716,  4678,  3709,   930,  3710,  2685,
    6379,  3173,   648,  3174,  1822,  3175,  2938,  3176,  4337,  3177,
     931,  1507,  2815,  3178,  3711,  1142,  5476,  6119,  1204, -1715,
    3784,  4148,  4878,  1979,  5668, -1715,  1461,  5463,  3901,  4879,
    6120,  3759,  1131,  3644,  6137,   676,  4880,  2854,   947,  1487,
    3227,  2909,   689,  3562,   690,  2729,  2912,  5669,  3673,  3969,
    5622,  1462,  5624,  4639,  5979, -1095,  2928,  1510,  4853,  4899,
    2989,  2686,  5772,  5937,  4930,  3804,  3566,  3622,   693,  3820,
    1132,  1878,  4881,  1979,  3697,  4484,  1245,  5442,   948,  5444,
    4109,  1696,  2607,  3905,  3906,  3907,  3908,  1515,  3910,  3721,
    6416,  2899,  5970,  1646,  4882,  1511,  3645,  3722,  2834,  1512,
    3723,  2839,  5980,  2840,  5644, -1068, -1715,  6360,   678,  3646,
    2835,  4652,   194,  3938,  2944,  3750,  2851,  3751,  -597,  1649,
    2986,  3755,  5454,  1697,  2992,  2608,  4062,  1698,  4304,  1516,
    1423,  1133,  6361,  1134,  1513,  1647,  4900,  1135,  4820,   951,
    4901,  1650,   951,  4441,  2970,  2971,  2972,  2973,  4063,   648,
    5676,  2852,   963,   963,  2997,  4818, -1715,   195,  1699,  4002,
    4653, -1668,  5318,  4439,  1517,  4110,  2841,   963,  5987,   958,
     963,  5455,  3647,  3697, -1668,  4351,  4739,  4740,  4741,  4742,
   -1668,  5716,  4746,  4747,  4748,  4749,  4750,  4751,  4752,  4753,
    4754,  4755,  1473,  1651,  4442,  5066,  2998,  5949,   956,  6249,
    1671,  4393,   648,  4258,  4285,  4941,  4704,  3931,  4476,   771,
    2929,  1210,  1212,  1214,  2930,  3471,  1216,  1217,  1218,  3471,
     963,  1636,  5067,  2999,   963,   963,  1223,  5425, -1668,  5426,
    5427,  5428,  3068,  5859,    40,  5717,  3000,  1674,  5718,  3858,
    3085,  4891,  1672,  4394,  1637,  5719,  4794,  4795,  2989,  5916,
    3473,  3716,   979,  5911,  3473,  4891,  1973,   648,  5912,  5860,
    4587, -1668,  5434,  6144,  -141,  5364,  3001,   980,  3431,   233,
    5017,    44,  5369,  5720,  3876,   662,   788,  1673,  4395,  5789,
    1974,   788,   788,   754,  3893,  1652,   689,  3471,   690,  4515,
    3026,  3027,  3143,  3432,  5018,  5435,  6145,  1023,  2834,  5776,
    2892,   834,  5543,  1675,  4380,  1636,  3044,  5034,  5544,  2643,
    2842, -1668,  5913,  1639,    48,   694,  4381,  2916,  2650,  2989,
    2651, -1668,  3473,  5777,  2654,  6332,  1032,    49,  1637,  1827,
    5035,  2660,  1713,  5721,  1828,  1717,  6214,  4518,  5826,  3717,
    3087,  3088,  3089,  3090,  4700,  1676,  5722,  1653,  5668,  5535,
      50,  1654,  1677,  4044,  4026,  4027,  1678,  4001,  5723,  1040,
    2637,  6456,  5992,  6459,  1447,  4045,  1448,  2937,  5993,  6343,
      56,  5669,  4046,  4111,  4112,  4113,  4114,  4115,  4116,  4117,
    4118,  4119,   187,  6470,  1449,  2103,  2615,  1099,  1267,  1100,
   -1668,  4104,  6218,  6219,  3718,  4105,  4106,  4107,  4520,     3,
       4,  4200,  1656, -1668,  4515,  1649,   786,  5635,  5636, -1668,
    4516,  6050,   786,  5267,  4891,  1447,  1083,  1448,  4103,  1041,
    3164,    40,   788,  1042,  4517,  1085,  3168,  1650,  5882,   187,
    4131,  1985,   788,  5886,  5887,  1451,  1828,  1090,   648,   648,
     648,   648,   648,   648,   648,   648,   648,  1117,   648,  3877,
    1658,  2035,  4518,  1104,  4519,  3719,  1828, -1668,    44,   648,
    1126,   648,  3272, -2453,  2623,  4155,  -596, -1668,  1041,  1828,
    1227,   676,  1042,  3592,  1659,  1125,  1220,  1221,  1148,  1651,
    3589,  1127,  3593,  3594,  2636,  3329, -2454,  2670,  1144,  2637,
   -1668,  1041,  1828,  1227,  1661,  1042,  1041,  5291, -2461,   648,
    1042,    48,  1436,   648,  1465,   998,   648,  5438,   648,  4186,
    1155,   648,  4523,  4520,    49,   648,  4327,  3427,  1165,   788,
    4138,  1182,   788,   788,  1164,  6437,  4145,  3586,  3169,  4202,
    4211,  4212, -1668,  2637,  1679,  1041,  1822,    50,   648,  1042,
   -1668,  4521,  4356,  6319,   678, -1668,  1171,  3471,  3471,  4292,
   -1668, -1668,  3500,  3501,  1436,   648,  2662,    56,  4524, -1739,
   -1739,  4287,  6389,  3180,   648,   648,  6390,  5724,  3181,  3621,
    5725,  1652,  1680,  4874,  3182,  4525,  1681,  3720,  1436,  3181,
    2662,  3220,  3473,  3473,  1470,  3430,  3221,  4248, -1656,  5065,
    1979,   973,  4231,  1826,  4173,  3435,  4573,  1189,   916, -1668,
    2637,  4109,   916,   916,  5678,  3448,  3450,  3451,  2663,   973,
    6231,  1682,  3354,   973,  4624,  3524,  1199,   973,  1683,  4625,
    2637,  5971,  4522,  4940,  3878,    29,   973,  4523,  1226,  3515,
    4511,  5867, -1668,  1653,  3556,   771,  3559,  1654,  5118,  5872,
    5873,  6006,  6007,  1987,   973,  -455,  1989,   648,  1991,  6375,
    1993,  1227,  1995,  2937,  3619,  3715,  1999,   657,   648,  3620,
     916,   648,  4231,   648,   648,  1231,   916,  3691,  1235,  3553,
    4232,  1238,  3692,  4524,  1241,  3879,  4526,  3357,   973,  4330,
   -1743, -1743, -1668,  4931,  1142,  4938,  4110,  1243,  1656,  4922,
    4525,  4130, -1668,  4132,  4133,  3854, -1668,  3993,   973,   973,
    3855,  4231,  3181,  4233,  4043,  3721,  4052,   916,  2050,  2637,
      56,  2637,  4058,  3722,   788,  2729,  3723,  2637,  4234, -1742,
   -1742,  4059,   689,  4296,   690,    40,  2637,  1649,  1244,  1822,
     973,  4665,  4090,  1822,  4913,  3801,  1658,  2637,  4560,  1246,
    4232,  4235,  1250,  6296,  6297,  6298,  6299,  6300,  6301,  1650,
    1251,  1878,  5764,  4123,  1252,  4388,  3607,   973,  2637,  1822,
    1659,  4137,    44,   973,  6311,  4142,  2637,  -455,  1254,  4236,
    4143,  1253,  4532,  4233,  1255,  4891,  6212,   973,  1261,  4232,
    1661,  4209,     3,     4,   973,  4373,  2637,   973,  4234,  4378,
    4374,  4526,  4956,   973,  4379,  4404,  4293,  4294,  5298,  1256,
    4405,  1651,  4473,  1407,  4414,    48,  1263,  4405,  4419,  5150,
    3471,  4235,  4233,   973,  4625,  4596,  1410,  3471,    49,   973,
    4597,  3469,  3471,  4599,  4314,  3471,   973,  4234,  4600,  6162,
    6163,  4630,  4764,  1414,  6261,    29,  4631,  4765, -1668,  4236,
     973,    50,  1436,  1416,  2662,  3473,  4775,  1142,   756,  4503,
    4235,  4776,  3473,   973,   925,   926,  3707,  3473,  1822,  5852,
    3473,    56, -1407,  1415,   973,  3749, -1407,  4237,    15,  4191,
    4934,  4192,  4786, -1667,   645,  4862,  6126,  2637,  4236,  3129,
    4863,  3130,   648,   648,   648,  4868, -1667,  4193,   648,  4194,
    4869,  4445, -1667,  1652,  4111,  4112,  4113,  4114,  4115,  4116,
    4117,  4118,  4119,  4873,  1420,    20,  1041,  4867,  3539,  1470,
    1042,  1424,  1439,  1626,  5119,   648,   916,  5136,  1643,  3181,
    5184,  5236,  1432,  5682,  1822,  2027,  2637,  3255,  3256,  5273,
    4036,  5329,  4038,  4039,  2637,    40,  3539,  4237,  1429,  1430,
   -1667,  5335,  4409,  6417,  3297,  3298,  5336,  5342,  5343,  5344,
    1436,  5129,  3181,  3181,  3181,  1653,  4864,   648,  5299,  1654,
    5478,  5515,  1453,  5553,  4425,  5479,  4631,   934,  5554,  1447,
    5683,  1448,    44, -1667,  3342,  2937,  4237,  4033,  1440,  4584,
   -1716,  4585,  4550,  4893,  4894,  5555, -1716,  4897,  3942,   916,
    2637,  5577,  1455,   916,   951,  5684,  5578,   963,  5587,   963,
     963,  5593,  4672,  1979,  5595,  6460,  4570,  5711,  5476,  4570,
    1656,  5731,  5712,  5765,  5685,    48,  3181,  1470,  5766,  5686,
    1471,  1482,  3920, -1667,  5835,  2729,  5841,  3357,    49,  5836,
    2668,  1979,  1497, -1667,   935,  5844,  1549,  5855,  5901,  1498,
    4570,  5687,  5856,  5902,  3047,  5688,  1499,  1465,  5941,  5968,
    5997,    50,  4891,  2594,  5856,  4143,  1578,  5998,  1658,  6014,
    5689,  3462,  2637,  3525,  6015,  6036,  1502, -1716,  6040,  4564,
    6037,  6262,  3354,  1979,  4719,  6041,  4720,  1508,  6048,   973,
    2637,  3541,  1659,  6069,  4656,  3544,  6075,  1575,  3221,  3547,
    2108,  3221,   998,  2109,  3471,   916,  5059,   973,  5060,  1728,
    6076,  4533,  1661,  4535,   973,  3221,   187,  6079,   648,    32,
     916,   648,  2637,   648,   648,   916,  3572, -1716,  4543,  5239,
    4546,  5240, -2498,   648,  1142,  2626,  1142,   936,   648,  3473,
    1826,  6080, -3027,  6081,  6108,  6190,  2637,   928,  6082,  6109,
    4570,    40,  6205,  6207,  6213,   916,  6228,  2637,  2637,  3181,
    3614,  6229,  6251,  1580,  6310,  6340,  6385,  6252,  2628,  5849,
    5856,  6386, -2792,  6411,  5690,  1581,  4647,  2668,  2637,  6431,
    1098,  6126,  1616,  1620,  6037,  6441,  1621,  4891,    44, -1667,
    6442,   648,   648,   648,   928,  4605,   648,  1552,  6448,  3363,
    3364,  3365,  3366,  4863,   648,   648,   648,   648,  6457,  6469,
    4254,  1622,  3664,  2637,  6442,  1822,  1633,  1635,  1142,  4736,
     648,  1822,  4940,   648,  4814,   648,  4816,  5282,  5691,  5284,
    4836,    48,  4839,  1553,  1645,   757,   648,   648,  1648,  3693,
     648,  2708,  1670,  2711,    49,  3702,  5568,  3597,  5569,  1687,
    3469,  1688,  1704,  4763,  1714,  1715,  1718,  1723,  1724,  3712,
    1836,   648,  1838,   648,  1840,   648,  1098,    50,  1845,  3725,
    1856, -2792,  1851,  1859,  4932,  3730,  1861,  1866,  5361,  1869,
    4664,  1871,  1863,   937,   648,  1880, -3027,   758,  1885,  1886,
    -184, -3027,  1888,  1889,  1891,  3743,  1554,  3471,  1893,   928,
    6259,  3746,  1894,   645,  4802,   973,  1916,  1905,  3752,  4196,
    4197,  4198,  1912,  5163,  1920,  4891,  1929,  3471,   213,  5547,
    1934,  1935,  3767,  1936, -2792,  1938,  1941,  1942,  1945,  1969,
    1946,  3471,  3473,  1555,  1953,  3792,  1957, -2792,  1959,  1960,
    4770, -3027,   648, -2792,  1962,   648,  1098,  1964,  1970, -2792,
    1972,   928,  3473,  1975,  1978, -2792,  1981,  1982, -2792,   648,
    1984,  4909, -2792,  2032,   648,  2663,  3473,  2001,  1267,  2038,
    2047,  4104,  2048,  2040,  2041,  4105,  4106,  4107, -1900,   648,
    1582,  4980,  1556, -1907,  2055,  3737,  1583,  2056,  3740,  2057,
    2058, -2792,  2059,   648,  5040,    56,  2061,  2062,  2633,  2063,
   -1897,   648, -1898,  2065,  2066,  2067,  2068, -1901,  2069,  2070,
    2071,  2072,  2073,   916,  2074,  2075,   916,  2076,   916,  5053,
    2077,  2079,  2080,   916, -2792,  1558,  2081,  2082,  2083, -1899,
    2084,  1585,  2085,  2578,  2086,  2087,  2089,  2090,   973,   973,
    2091,  5792,  2092,  2093,   648,  2580,  2094,  2095,  2096,  2582,
    2584,  2598,  2610,  2640,   951,  2585,  2594,   963,  1560,   963,
     963,  2618,  2641,  2646,  2648,   973,  2649,  2652,   973,  2653,
    2658,   916,  2655,  2656, -2792,  2657,  3831,  2659, -2792,   916,
    5045,  2664,  2671,  1485, -2792,  1487,  2702,  2714,  1586,  3844,
    3471,  2717,  2704,  2716, -3027,  1587,  2718,  3853,  2719,  1588,
    2735,  2736,  2737,    35,   916,  2816,  2738,  2662,  1562,   187,
    2739,  2740,  2741,  2742,  2743,  2744,  2745,  1563,  2751,  2770,
    2776,  2796,  2800,  2782,  2802,  3473,  1564,  1589,  2803,  2807,
    2804,  3442,  3444,  2806,  2817,  2820,  3897,  3452,  2824,  2825,
    1822,  1822,  1822,  2826, -2792,  2849,  1566,  2837,  2853,  6415,
    2838,  2855,  2867,  2858,  2856,  1567,  2857,  3921,  2859,  2869,
    1568,  4009,  1590,  2873,  2879,   973,  2874,  2868,  2872,  3498,
    3498,  2880,  2883,  3471,   916,  2889,   916,  2893,  3673,  4023,
    4951, -3027,  2890,  4254,   973,  2903,  4009,  2904,  2907,  2910,
    5498,  2913,  2914,  2917,  2919,  2920, -3027,  2924,  2931,  1594,
    3976,   803,  3978,  2932,  3697,  2934,   973,  2949,  3473,  2567,
    2568,  2569,  2570,  2571,  2572,  1569,  2939,  2940,  2951,  2945,
    2953,  2946,  2960,  5180,  2961,  3469,  2952,  2954,  3469,  5801,
   -2792,   788,  2958,  2977,  2978,  2966,  2967,  2985,  3007,  2979,
    3019,  1691,  3014,  3021,  3022,  1592,  2990,  3023,  3035,  3036,
    3024,  3359,  3028,  3360, -2792,  1593, -2792, -2792,  3029,  3042,
    3030,  3032,  5834,  3033,  3034,  1594,  4110,  3041,  3040,  3043,
     916,  3050,  3051,  3054,   671,  3059,  3469,  1595,   645,  3361,
    3067,   645,  3078,  1667,  3469,  3082,  3083,  3095,  3086,  4034,
    3098,  3102,   973,  3101,  3122,  3111,  4041,   648, -2792,  3128,
    3144, -2792, -2792,   648,  3132, -2792,  3146,  2108,  3148,  3147,
    2109,  3149,   916,  3162,  3205,  3631,  2100,  3115,  3194,  1719,
    3331,  3230,  1597,  1598,  3337,  2109,  3218,  3350,  3249,   645,
    3418,  3377,  3471,  3397,  3423,  3403,  3424,   645,  3119,  1822,
     916,  3137,  2626,  3362,  3422,   973,  3341,   973,  3421, -3027,
    3254,  3356,  3375,  3402,  1720,  3436,  2668,  3437,  3438,  3439,
     973,  3440,   973,  2100,  3441,  3445,  1460,  3473,  3453,  3454,
    3492,   935,  3480,  3475,  3493,  2628,  3494,  3509,  3516,  3517,
    3529,  3528,   648,  3495,  5459,  3531,  3548,  3357,  3557,  3562,
    3560,  3564,  3571,  3565,  3576,  3581,  5091,  5092,  3363,  3364,
    3365,  3366,  3582,  4182,   788,  3367,  3368,  3584,   916,  3595,
    3587,  3369,   788,  3611,  3616,   788,  1404,  3618,  5175,  5176,
    5177,  5178,  5179,  5261,  1600,  3628,  3635,   788,  3648,   973,
     916,  3653,  3654,  3674,  3681,  3680,  3682,  3687,  3698,  3690,
    3705,  1408,  3706,  3728,  5309,  3729,  3745,  4154,  3708,  3787,
    3800,  3471,   916,  3812,  1882,  3808,  3821,  3809,   936,  3828,
    4590,  5129,  3834,  3856,  3835,  4217,  3840,  3845,  4223,  3868,
    3867,   973,  3836,  3882,  4111,  4112,  4113,  4114,  4115,  4116,
    4117,  4118,  4119,  3884,  5247,  2695,  3473,  3886,  3888,  3896,
     973,  3909,  3915, -3027,  3914,  3916,  4627,  3922, -3027,  3917,
    3918,  5792,  3929,  3930,  4594,  3903,  3927,  5368,  3925,  3933,
    3934,  3939,   973,  4800,  3954,   973,  3462,  3955,  5316,  3964,
     927,  3965,  3956,  3966,  3462,  3968,  3970,  3984,  3987,  3986,
    3992,  3990,   648,  3995,  3996,   916,  4010,  4312,  3997,  3998,
    3999,   648,  1979,  3231,  1976,  4000,  4012,  4014, -3027,  4021,
    4029,  4031,  3471,  4024,   648,  4057,  1943,  4037,   916,  4072,
     648,   648,   648,  3271,  3370,  4074,  4078,   648,  4004,  4005,
   -2184,  4013,  4136,  4054,  4055,  5869,  3371,  4139,  5432,   648,
    4151,   648,  1233,  1236,   648,  4156,  4076,  3473,   916,   648,
     648,   648,   648,  4056,  4171,   648,   648,   648,   648,   648,
     648,   648,   648,   648,   648,  2633,  4067,  3813,   648,   648,
     648,  4079,  4091,   916,  4092,  4096,  4098,  4099,   648,   928,
    4100,  4180,  4122,   648,  2637,  1822,  4207,   648,  4221,  4127,
    4187,  4128,  4135,  4150,  4181,   648,  4213,  4384,   648,  4215,
     648,  4183,  4185,  4250,  4316,  4317,  4263,  4208,  4214,  4245,
    2064,  4230,  4256,  4265,  4216,  4222,   648,  4267,  4290,   648,
     648,  4269,  4276,  4306,   648,   648,  4295,  4297,  4284,   648,
    4298,   648,  4309,   788,  4311,  4161,  4323,  4162,  4324,  5313,
    4334,  4335,  4336,  4340,  4341,  4342,  4302,  4303,  4307,  4343,
    4347,  4358,  4807,  4808,  4809,  4810,  4359,  4367,  4361,  4368,
     648, -3027,  4369,  4163,  1080,  4377,   648,  4254,  4383, -3026,
    4392,  4408,   191,  4406,   648,  4412,  4410,  4413,   648,  4421,
    4420,  4424,  4426,  4416,  4427,  4428,  4431,  4429,  3471,  4446,
    4447,  4448,  4449,  4254,  4450,  4451,  4452,  4453,  1081,  4454,
    4455,  4456,  4457,  4462,  4459,  4461,  4465,  4467,  4458,  4460,
    4469,   648,  3351,  2975,  4485,  4471,  1077,  4481,  4472,  1078,
    4478,  1079,  4499,  3473,  4479,  4482,  4488,  3362,   648,  4493,
    5359,  4536,  4483,  4548,   916,  4501,  4551,  4541,  4552,  4542,
    4555,  5443,  4559,  4572,  4569,  4570,   648,  4588,  4579,  4589,
    5410,  5411,  4582,  5413,  4592,  4593,  4609,  4595,  4623,  4626,
    4629,  5498,  4633, -3027,  4641,  4642,  4643,   973, -3026,  4644,
    4635,  4645,  4646,  4655,  4648,  4658,  2567,  2568,  2569,  2570,
    2571,  2572,  3363,  3364,  3365,  3366,  4657,  4659,  4668,  4164,
    4681,  4669,  4670,  2050,  4671,  4165,  4673,  4674,  4687,  4675,
    4676,  4677,  4060,  4693,  4692,  4697,  4685,  3471,  4694,  4723,
    4714,  4715,  4724,  3471,  4104,  4760,  1582,  5403,  1822,  4737,
    4761, -3026,  1583,  1822,   916,  1822,  4777, -2183,  4788,  4790,
    4762,  4832,  4819,  5567, -3026,  6303,  6304,  1584,  4769,  6306,
   -3026,  4803,  3473,  4833,  4487,  4840, -3026,  4846,  3473,  1822,
     916,  4841, -3026,  4847,  4792, -3026,  4815,  4825,  4203, -3026,
     788,  4817,  4828,  4830,  4845,  4848,  4859,  1585,  5610,  2108,
    4850,  4856,  2109,  4861,  4865,  4876,  4210,  4884,  4905,  4906,
    4907,  2108,  4254,  4908,  2109,  4916,  4915,  4918, -3026,  4919,
   -3026,  4921,  4926,  4927,  4943,   973,  4958,   187,   973,  4959,
    4960,  4946,  4961,  2989,  2626,  4962,  4972,  4996,  4973,  4974,
    4986, -3027,  4992,  4975,  5461,  4988,  2626,  4976,  5004,  4989,
    4977, -3026,  4651, -3027,  1586,  5005,  4259,  4259,  4994,  5014,
    5006,  1587,  5030,   187,  5011,  1588,  5031,  2628,  5033,  2938,
    4933,  3471,  5036,  5047,  5046,  5049,  5050,  4667,  4166,  2628,
    5051,  5062,  5073,  5088,  5083,  5102,  5109,  3469,  5108,  5094,
    4167,  3469,   648,  1589,  5114,  5121,  5131,  5137,  5138,  5148,
    5115, -3026,  5154,  5157,  5155, -3026,  3473,  5159,  5161,  5162,
    5173, -3026,  5158,  5167,  5188,  5181,  5186,  5196,   973,   973,
    5204,  5206,   916,  5895,  5208,  5897,  5209,  5203,  1590,   973,
    5207,  5210,  5213,  5214,  4640,  5215,   648,   648,  5217,  4172,
     645,  5218,  5223,  5231,   645,  5232,   973,  5229,  5233,  5238,
    5250,  4793,  5244, -2185,  5253,  5254,  3282,  3282,  5287,  3469,
    5259,  5586,  5302,  5311,  5314,  5276,  5255,  5315,  5328,   916,
    3311, -3026,  5586,  5330,   916,   648,   648,  5272,  5292,  3332,
    5286,  5332,  5338,  5295,  5325, -3027,   648,  5306,  5347,  5365,
   -3027,  5367,  5366,  6011,  5370,  5337,  5376, -3027,  5377,  5378,
    5399,  5397, -3027,  5390,  5405,  5406,  5414,  1591,  5140,  5393,
    5415,  1592,   645,  5422,  5728,  5423,  5905,  5433,  5424,  5429,
    5436,  1593,  5440,  5441,  5448,  3352, -2794,   973,  5451,  5457,
    5460,  1594,  5458,  5464,  5466,  5475,  5470,  5480,  5482,  5456,
   -3027,  5486,  5487,  1595,  5491,  5493,  6057,  5494,  5495,  5504,
    5489,  5510, -3027,   648,  5512,  3181,  5630, -3026,  5519,  5520,
    5526,  5527,  5530,  5532,  5548,  5542,  5552,   998,  5558,  5560,
    5559,   648,  5561,  5566,  5570,  5572,  5573,  5579,  2100,  5585,
    5611, -3026,  5589, -3026, -3026,  1596,  5614,  5617,  1597,  1598,
    5623,  5626,  6092,  6094,  5641,  5638,  5592,  2633,  5634,   648,
    5642,  5643,  5648,  5637,  5654,   187,  5655,  5651,  5674,  2633,
    5659,   648,  5665,  5666,  5667,  5696,  5072,  5702,  5681,  5646,
    1599,  5704,  5714,  5707,  5734, -2794,  5710,  3462, -3026,  5715,
    5735,  3462, -3026, -3026,  5739,  5744,  5746,  5762,  5767,   648,
    5773,  5775,   648,  5781,  5796,  5795,  5907,  5813,  5774,  5797,
     648,   648,  5833,   916,  5845,  5849,  5847,   648,   648,  5850,
    5851,  5853,   648,  5803,  5618,  5876,  5877,   648,  5883,  4910,
     648,   648,  5920,  5866,  5875,  5806,  5868,   648, -2794,  5889,
    5925,  5929,  5935,  5922,  5943,  5933,  5948,  5957,  5961,  5962,
    1600, -2794,  5963, -3027,  5964,  5965,  5975, -2794,  5974,   648,
    5982,  5843,  5976, -2794,  5977, -3027,   648,  5984,  2102, -2794,
    5991,   648, -2794,  5990,   648,   648, -2794,  5994,  5986,  3469,
    3469,  5995,   648,  5999,  6008,   788,  6009,  6030,  6052,  6010,
    6018,  6053,  6031,   648,  2108,  6033,  6043,  2109,  4188,  6086,
    6055,   648,  6056,  6068,  6091, -2794,  6100,  6072,  4547,  6097,
    6107,  6103,  6105,  6114,  6115,  5842,  6111,  6131,  6141,  6132,
    6142,   648,  6148,  6152,  5331,  6134,  6153,  6133,  6160,  2626,
    6164,  6230,   645,   645,  5890,  5891, -3027,  6165, -2794,   916,
    6155,  5317,  5319,  6147,  6186,  6182,  6169,  6189,  6185,  6201,
    6193,   901,   973,  6210,  6203, -3027,  6215,  5019,  6223,  6232,
    5022,  6102,  2628,  6225,  6101,  6240,  6241, -3027,  2567,  2568,
    2569,  2570,  2571,  2572,  6242,  6258,  6098,   916,  6260,  6277,
    2567,  2568,  2569,  2570,  2571,  2572,  6278,  6291, -2794,  6172,
    6317,  6305, -2794,  6292,   973,  6325,  6293,  6294, -2794,   916,
    5899,  6309,  6344,  5363,  6283,  6284,   973,  2108,  6323,  6350,
    2109,  6351,  6354,  5371,  2110,  2111,  2112,  6357,  6368,  6356,
    6370,  6371,   648,  6391,  6392,  6405,  6418,  1940,   648,  6420,
   -1954,  6451,  2625,  1944,  4796,  6393,  6421,  6429,  6432,   973,
    4282,  6434,  2626,  1955,  6446,  6439,  6440,  1958,  6452,  2627,
    6455,  1961,  6408,  1963,  6461,  5769,  6464,  6468, -2794,  1971,
    3890,  5104,  4205,  1684,  1472,  1977,   788,  3760,  1980,  3679,
     916,  1685,  1579,  4949,  4942,  2628,  6226,  4353,  2989,  3799,
   -3027,  4498,  3847,  5693,  6085, -3027,  6324,  2991,  5090,  5745,
    5894,  4939,  5439,  2617,  5727,  4300,   648,  6217,  3994,  5628,
    6320,  6106,  6104,  6335,  1142,  6239,  5061,  4305,  5468,  5141,
    5112,  5120,   648,  6066,  6042,   803,  6044,  1822,  5082,  3462,
    5063,  4947,  3865,  4558,  3866,  5733,  4371,  5107,  6062,  5462,
    4598,  5978,  5165,  1669,  6388, -3027,   973,  6467,  6453,  5708,
    4504,  6244,  3469,   648, -2794,   187,  5149,  5653,  3058,  3469,
    5885,  6074,  5656,   752,  3469,  2108,  1073,  3469,  2109,  4009,
     805,  5182,  2110,  2111,  2112,  5862,  2024,  4649, -2794,  6384,
   -2794, -2794,  3894,  3534,  3121,  5151,  5770,  4291,  5972,  3117,
    2625,  3133,  3150,  4615,  1143,  1183,  6035,  4468,  3225,   916,
    2626,   916,  2633,  2629,  3226,   645,  4978,  2627,  2630,  4415,
    6264,  5473,   645,  3797,  6419,  5168,  1417,   645,  5169,  6435,
     645,  5304, -2794,  2750,   998, -2794, -2794,  3824,  3479, -2794,
    2631,  2301,   973,  2628,  6086,  5320,  5861,  4870,  3016,  3491,
    2590,  6211,   839,  5652,   840,  5211,  2638,  2698,  4252,  2699,
    5650,  4264,  3489,  6206,  6045,  2703,  4225,  6059,  2632,  4822,
    5591,  5681,  4838,  4254,  4218,  5832,  5831,  6402,  4871,  4219,
    6192,  6307,  6034,  2647,  4689,   998,  5802,  4168,  6046,   648,
    4771,  3398,   648,  4184,  3401,   648,   648,   648,  6047,  3317,
    4178,  3823,  4049,  4176,  6286,  5528,  6149,  5695, -3027,  6288,
    2367,  5799,  4691,  6401,  6151,  6445,  5533,  4220,  6168,  6362,
     648,   648,  6367,  6181,   648,  2633,  6366,  6363,  2634,  4085,
    4698,  3413,  3477,     0,     0,  2108,     0,     0,  2109,     0,
       0,     0,     0,     0,  1468,     0,   648,  1142,     0,     0,
       0,     0,   648,     0,     0,     0,   648,     0,     0,     0,
    6150,  2629,   916,   648,     0,     0,  2630,     0,     0,     0,
    2626,     0,     0,     0,     0,     0,   648, -3027,     0,   648,
       0,     0,     0,     0,   973,     0,   973,     0,  2631,  2301,
     648,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2628,     0,     0,     0,     0,     0,  3462,
   -3027,     0,     0,     0,  3462,     0,  2632,  3462,     0,     0,
       0,  2635,     0,  2567,  2568,  2569,  2570,  2571,  2572,   788,
     916,   973,     0,     0,     0,     0,     0,     0,   187,   187,
       0,   648,     0,     0,     0,     0,  3469,     0,     0,     0,
       0,     0,     0,     0,     0,   788,     0,     0,  2367,     0,
    6443,     0,     0,     0,     0,     0,     0,     0,  5445,   788,
       0,     0,     0,  2633,     0,  4797,  2634,     0,     0,     0,
     788,     0,     0,  1822,     0,     0,  5384,     0,   648,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5394,   645,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5612,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0, -3027,     0,  2563,     0,  5894, -3027,     0,     0,     0,
       0,     0,     0,  2564,  2565,  2566,  2567,  2568,  2569,  2570,
    2571,  2572,     0,     0,     0,   646,  4093,     0,     0,   648,
       0,  4094,   916,     0,     0,     0,  1220,  1221,     0,     0,
    5732,     0,   798,     0,   800,     0,    71,    80,   806,  2635,
      83,   184,    84,   820,   828,   798, -3027,   835,   175,   191,
     828,   828,    85,   865,   648,   868,    86,   106,   124,   129,
       0,  5758,   924,   924,   924,     0,   159,   178,   185,     0,
       0,     0,   648,  6377,  6378,   186,   648,   928,   648,  6454,
       0,     0,  6376,     0,     0,     0,     0,     0,     0,  3944,
     648,     0,     0,   180,     0,     0,   181,     0,   183,     0,
       0,     0,   648,  2633,  5760,   648,     0,     0,     0,  3469,
    5412,  1154,     0,  1552,   788,     0,   648,     0,     0,     0,
       0,     0,     0,   648,     0,  5416,     0,     0,     0,  3469,
       0,     0,     0,     0,     0,     0,     0,  1154,     0,     0,
       0,  2563,  1142,  3469,     0,     0,     0,     0,     0,  1553,
       0,  2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,
       0,     0,   645,     0,     0,     0,     0,   788,   187,     0,
    4077,     0,     0,   916,     0,     0,     0,     0,   916,   916,
       0,     0,   645,   648,  4009,     0,     0,     0,     0,   648,
     648,   973,     0,  6447,     0,  2108,   645,     0,  2109, -3027,
       0,     0,     0,     0,     0,   973,   646,   953,   953,     0,
       0,   953,  1554,     0,     0,   964,  5474,   865,     0,     0,
    1000,     0,     0,   964,     0,   648,   964,     0,     0,   865,
    2626,   953,  6427,   648,   865,   998,  1822, -3027,   953,     0,
     865,     0,     0,     0,     0,     0,     0,   963,  1582,  1555,
       0,     0,     0,     0,  1583,     0,     0,     0,     0,     0,
       0,   648,     0,  2628,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6427,     0,     0,     0,     0,     0,     0,     0,     0,
     916,   916,     0,  3945,   963,     0,     0,     0,  1556,  1585,
    6427, -3027,  3469,     0,     0,     0,     0,     0,     0,  5951,
       0,     0,  3145,     0,  2567,  2568,  2569,  2570,  2571,  2572,
    3152,     0,     0,     0,   648,     0,  4009,     0,  4009,     0,
       0,   648,   648,   648,     0,  5270,     0,     0,     0,     0,
       0,  1558,     0,     0,     0,  3311,  3311,   916,     0,  3462,
    3311,     0,     0,     0,     0,   645,  1586,     0,     0,     0,
     648,  1822,     0,  1587,   916,     0,     0,  1588,     0,   648,
       0,   648,     0,   648,  1560,     0,     0,     0,     0,     0,
     648, -3027,     0,     0,     0,  3469, -3027,     0,     0,     0,
    3311,  3311,     0,     0,     0,  1589,     0,     0,     0,     0,
       0,   648,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6222,     0,     0,     0,     0,     0,     0,    35,
       0,     0,     0,  6049,  3946,     0,  1822,     0,   973,     0,
    1590,     0,  5631,  1563,  5632,     0, -3027,     0,   645,     0,
       0,     0,  1564,     0,     0,   788,     0,     0,  1843,     0,
    2817,   788,     0,     0,     0,   788,     0,     0,     0,  1852,
       0,     0,  1566,     0,     0,     0,     0,     0,     0,     0,
       0,  1567,     0,     0,     0,  1860,  1568,     0,     0,     0,
       0,   648,  5387,  5388,  6271,  6272,     0,  5391,  5392,     0,
       0,     0,     0,  2633,     0,  3947,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   187,     0,  1691,
       0,     0,     0,  1592,   648,  1822,     0,     0,     0,     0,
       0,     0,     0,  1593,   648,     0,     0,     0,     0,     0,
       0,  1569,     0,  1594,     0,  3948,     0,     0,   187,     0,
       0,     0,     0,     0,  3469,  1595,     0,     0,     0,     0,
       0,     0,   187,     0,     0,     0,     0,   648,     0, -2811,
       0,     0,     0,     0,     0,     0,     0,   648,     0,  5934,
       0,     0,     0,     0,     0,     0,     0,   648,     0,     0,
     973,     0,     0,     0,     0,     0,     0,  5759,     0, -3027,
    1597,  1598,     0,   648,     0,     0,     0,   645,     0,     0,
       0,     0,     0,     0,     0,   714,   973,     0,     0,     0,
       0,     0,     0,     0,   802,     0,     0,     0,     0,     0,
       0,     0,  1599,     0,     0,     0,     0,     0,     0,     0,
       0,  2030,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2100,   648,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   648, -2811,     0,
       0,     0,     0,  3469,     0,   648,   648,     0,  1052,     0,
       0,   648,     0,     0,   865,     0,   953,     0,   953,     0,
       0,   953,     0,     0,   191,  6245,     0,     0,  1000,     0,
       0, -3027,  1600,  1110,     0,   953,     0,     0,     0,     0,
       0,   953,     0,     0,  2567,  2568,  2569,  2570,  2571,  2572,
    6269, -2811,     0,     0,     0,     0,   645,     0,   648,   648,
       0,     0,   648,     0, -2811,   646,     0,     0,  6266,     0,
   -2811,  6267,     0,  6268,   964,     0, -2811,     0,  1000,     0,
    6349,   964, -2811,     0,   964, -2811,     0,     0,     0, -2811,
       0,     0,     0,   973,     0,     0,     0,     0,     0,     0,
     953,     0,     0,     0,  3469,  5896,     0,  5898,     0,     0,
       0,     0,     0,     0,     0,     0,   648,     0, -2811,     0,
       0,     0,   648,     0,  3462,     0,   187,     0,     0,     0,
       0,     0,     0,     0,  6462,  6463,     0,     0,     0,     0,
     648,     0,   648,     0,     0,     0,   191,     0,     0,     0,
       0, -2811,     0,   865,     0,     0,     0,   645,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1249,     0,
       0,     0,  6269,   648,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   648,  1389,  1389,
    6266,   865,   828,  6267,     0,  6268,   828,     0,     0,     0,
       0, -2811,     0,     0,     0, -2811,     0,     0,     0,     0,
     865, -2811,     0,     0,     0,   865,     0,     0,     0,     0,
       0,  1389,     0,     0,   648,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   788,     0,     0,     0,     0,
     187,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     648,     0,     0,     0,     0,     0,     0,  1822,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1389,   963,
       0, -2811,     0,     0,   191,     0,     0,     0,     0,     0,
    3469,     0,   865,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   648,   648,     0,   865,     0,     0,   648,     0,
    6269,     0,   648,     0,     0,     0,  1822,     0,     0,     0,
     865,     0,     0,     0,     0,   648,   648,     0,  6266,     0,
       0,  6267,     0,  6268,     0,  1822,  3425,     0,   803,   865,
       0,     0,     0,   645,   953,   953,     0,     0,     0,     0,
       0,   963,   963,     0,     0,     0,  2882,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -2811,     0,     0,
       0,     0,     0,     0,     0,     0,   828,   828,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6113,     0,     0,
       0, -2811,     0, -2811, -2811,     0,     0,     0,     0,  1389,
    1389,     0,  4009,     0,     0,     0,     0,     0,     0,  3469,
       0,     0,   646,     0,   953,  3469,     0,     0,   964,     0,
       0,  1000,   964,     0,   964,     0,     0,     0,     0,   953,
       0,     0,     0,     0,     0, -2811,     0,     0, -2811, -2811,
       0,     0, -2811,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   865,     0,     0,     0,     0,     0,     0,
     953,   953,   645,     0,     0,     0,     0,     0,   645,     0,
       0,  3282,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   865,   865,   865,     0,   953,  6353,   646,     0,   646,
     646,     0,     0,  3311,  3311,  3311,  3311,     0,     0,  3311,
    3311,  3311,  3311,  3311,  3311,  3311,  3311,  3311,  3311,     0,
       0,     0,   187,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   953,     0,   953,   953,  4767,  6227,     0,
       0,     0,  2108,     0,     0,  2109,     0,   187,     0, -3027,
   -3027, -3027,     0,  3469,     0,     0,     0,     0,     0,     0,
     788,     0,     0,     0,     0,     0,     0,     0,  1389,     0,
       0,     0,     0,  3311,  3311,     0,     0,  2626,     0,     0,
    6397,     0,     0,     0,  2627,     0,     0,     0,     0,     0,
    3020,     0,     0,     0,  2004,     0,  2004,     0,     0,     0,
     865,  3031,   798,     0,     0,  2108,   645,     0,  2109,  1074,
    2628,     0,  2110,  2111,  2112,     0,   865,  3049,     0,     0,
    4827,     0,  2039,     0,     0,   865,     0,     0,  2045,     0,
    2625,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2626,     0,  1389,     0,     0,     0,     0,  2627,     0,  6397,
       0,     0,     0,     0,     0,     0,     0,     0,  6450,  1141,
     714,     0,     0,     0,     0,     0,     0,     0,     0,  6348,
    3123,   963,   963,  2628,     0,     0,     0,  6322,     0,     0,
       0,     0,     0,  1389,     0,  3135,     0,     0,  1154,  3139,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6336,  6336,     0,
       0,  1389,  1389,  1389,     0,  1389,     0,     0,     0,  3158,
    1154,     0,     0,     0,     0,     0,     0,     0,  2629,     0,
       0,     0,  2108,  2630,     0,  2109,  1389,     0,     0,  2110,
    2111,  2112,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1240,     0,  2625,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2626,     0,     0,
       0,     0,     0,  6083,  2627,     0,     0,     0,     0,     0,
       0,  1258,     0,  2632,     0,     0,     0,   865,     0,  1392,
       0,  2629,  1401,  1141,  1403,     0,  2630,   187,     0,     0,
    2628,     0,     0,     0,     0,  1389,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2631,  2301,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1552,  6336,     0,     0,
    2633,     0,     0,     0,     0,     0,  2632,     0,     0,     0,
       0,  1389,     0,     0,     0,  1389,  1389,  3967,     0,  3344,
       0,     0,  3973,     0,  3974,     0,   865,   865,   865,  2713,
       0,  1389,  1553,     0,  3980,     0,     0,  3981,     0,  3982,
    3983,     0,     0,  3985,     0,     0,     0,  3988,  2367,  3989,
       0,     0,  3991,     0,   828,     0,     0,     0,     0,     0,
       0,     0,     0,  2633,     0,     0,  2634,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3311,     0,  2629,     0,
       0,     0,     0,  2630,     0,     0,     0,     0,     0,  2805,
       0,     0,     0,     0,   828,  1554,  2635,   953,     0,     0,
       0,     0,     0,     0,     0,  2631,  2301,     0,     0,     0,
     865,  2833,     0,     0,     0,     0,  4032,     0,     0,   865,
       0,     0,   953,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1555,  2632,     0,     0,     0,  2108,     0,     0,
    2109,     0,     0,     0,  2110,  2111,  2112,     0,     0,  1000,
       0,   865,     0,     0,   828,     0,  1141,  2901,  2901,  2635,
       0,  2901,  2625,     0,     0,     0,     0,     0,     0,     0,
       0,   828,  2626,     0,   865,  2367,     0,   865,     0,  2627,
       0,  1556,     0,     0,     0,     0,     0,     0,     0,     0,
    2633,     0,     0,  2634,     0,     0,     0,     0,  2563,   953,
       0,     0,     0,     0,     0,  2628,     0,     0, -3027, -3027,
   -3027,  2567,  2568,  2569,  2570,  2571,  2572,   865,     0,     0,
    1557,     0,     0,     0,  1558,     0,     0,     0,     0,   953,
     953,   953,   953,   865,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   865,     0,     0,
       0,     0,     0,     0,     0,     0,  1559,  1560,  1389,  1389,
    1389,  2563,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,
       0,     0,     0,     0,     0,     0,  2635,     0,     0,  4095,
       0,     0,     0,     0,     0,     0,     0,     0,  1561,     0,
       0,     0,    35,     0,     0,     0,     0,  1562,     0,     0,
       0,     0,     0,     0,     0,     0,  1563,     0,     0,     0,
       0,     0,     0,  2629,     0,  1564,  5252,     0,  2630,     0,
       0,     0,     0,  1565,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1566,  2029,     0,     0,     0,
    2631,  2301,     0,     0,  1567,     0,   865,     0,     0,  1568,
       0,     0,     0,     0,     0,     0,     0,   865,     0,  1141,
       0,     0,     0,     0,     0,   953,   953,     0,  2632,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2563,     0,
       0,   953,     0,     0,     0,     0,     0,     0,  2564,  2565,
    2566,  2567,  2568,  2569,  2570,  2571,  2572,     0,     0,   865,
    2901,     0,     0,     0,  1569,     0,  4146,     0,     0,     0,
    2367,     0,     0,     0,     0,   953,   953,   953,   953,     0,
       0,     0,  6425,     0,   865,  2633,     0,     0,  2634,     0,
       0,   865,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4310,     0,  2104,     0,   646,     0,
       0,   646,     0,     0,     0,  2106,     0,     0,     0,     0,
       0,   964,   964,     0,     0,     0,     0,     0,     0,     0,
       0,  6425,  1000,  1000,     0,     0,   964,     0,     0,   964,
       0,     0,     0,  2588,     0,     0,     0,     0,     0,  2108,
    6425,     0,  2109,     0,   953,   953,  2110,  2111,  2112,     0,
       0,   953,  1141,   865,     0,  2605,  2606,     0,     0,     0,
    1141,  1141,     0,     0,  2625,  4360,     0,  4362,     0,     0,
    2004,  2635,     0,     0,  2626,     0,     0,   953,     0,   964,
       0,  2627,  3197,   964,   964,     0,   865,   865,     0,   953,
       0,     0,     0,     0,     0,     0,   865,     0,     0,     0,
       0,     0,     0,   865,     0,     0,     0,  2628,     0,   798,
     798,     0,     0,  3233,     0,     0,     0,  1389,     0,  1389,
       0,     0,     0,     0,  1389,  1389,     0,     0,     0,     0,
       0,  1389,  1389,  1389,  1389,  1389,  1389,  1389,  1389,  1389,
    1389,  1389,  1389,  1389,     0,     0,  1389,     0,  1389,  1000,
    1389,  1389,  1389,  1389,  1389,  1389,     0,     0,  1389,     0,
    1389,  1389,     0,     0,  1389,     0,     0,     0,     0,     0,
       0,     0,     0,  2563,     0,     0,     0,     0,     0,  1389,
    1389,  1389,     0,  2564,  2565,  2566,  2567,  2568,  2569,  2570,
    2571,  2572,     0,     0,     0,     0,  3340,  1389,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4463,
       0,     0,     0,     0,     0,  4470,     0,     0,     0,     0,
       0,     0,     0,  1582,     0,  2629,     0,     0,  1649,  1583,
    2630,     0,     0,     0,     0,     0,  3588,   953,     0,     0,
       0,     0,  3596,     0,  1689,     0,     0,     0,     0,     0,
    1650,     0,  2631,  2301,     0,     0,  2108,     0,     0,  2109,
       0,     0,     0,  2110,  2111,  2112,     0,     0,     0,     0,
       0,     0,     0,     0,  1585,     0,  4343,     0,     0,     0,
    2632,  2625,     0,  3629,     0,     0,  2108,     0,     0,  2109,
       0,  2626,     0,  2110,  2111,  2112,     0,     0,  2627,     0,
       0,     0,  1651,  4933,     0,     0,     0,     0,     0,     0,
    2773,  2625,     0,     0,     0,  2942,     0,     0,     0,     0,
       0,  2626,  2367,  2950,  2628,     0,     0,     0,  2627,  1690,
       0,  1586,     0,     0,     0,     0,  3311,  2633,  1587,     0,
    2634,     0,  1588,     0,  1389,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2628,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1589,  4934,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3311,     0,     0,     0,  1652,     0,     0,  1389,     0,  4632,
       0,  4634,     0,  4636,     0,  1590,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2635,     0,     0,     0,     0,     0,     0,
       0,     0,  2629,     0,     0,     0,     0,  2630,     0,     0,
       0,     0,  1389,     0,     0,     0,  1653,     0,     0,     0,
    1654,     0,     0,     0,     0,     0,     0,     0,     0,  2631,
    2301,     0,  2629,     0,     0,     0,  2937,  2630,     0,     0,
    4935,     0,     0,     0,  1691,     0,     0,     0,  1592,     0,
       0,     0,  3852,     0,     0,     0,     0,  2632,  1593,  2631,
    2301,     0,     0,     0,     0,     0,     0,     0,  1594,     0,
       0,  1656,     0,     0,     0,     0,     0,     0,     0,     0,
    1595,     0,     0,     0,     0,     0,     0,  2632,     0,     0,
       0,     0,     0,     0,     0,  2563,     0,  3079,     0,  2367,
       0,  3084,     0,     0,     0,  2564,  2565,  2566,  2567,  2568,
    2569,  2570,  2571,  2572,  2633,     0,     0,  2634,  4500,  1658,
       0,     0,  1692,     0,     0,  1597,  1598,     0,     0,  2367,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1659,  2633,     0,     0,  2634,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1693,     0,     0,
       0,     0,     0,  1661,     0,  4936,     0,     0,  4937,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1389,  1389,  1389,  1389,  1389,  1389,  1389,
    1389,  1389,     0,  1389,     0,     0,  3311,     0,     0,     0,
    2635,     0,     0,   865,  1389,     0,  1389,     0,     0,     0,
       0,     0,     0,   865,     0,     0,     0,  1600,     0,  2108,
       0,  4022,  2109,     0,     0,     0,  2110,  2111,  2112,  3311,
    2635,     0,     0,     0,     0,     0,  4035,     0,     0,     0,
       0,  4040,   865,     0,  1389,     0,     0,   953,  1389,     0,
       0,  1389,     0,  1389,  2626,     0,  1389,     0,     0,  3266,
    1389,  2627,     0,     0,     0,     0,     0,     0,  2859,     0,
       0,  4065,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3474,     0,     0,     0,  2628,     0,   865,
     865,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1389,     0,  2563,     0,     0,     0,     0,     0,     0,  1389,
    1389,     0,  2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,
    2572,     0,     0,   865,     0,  4683,     0,  2108,     0,     0,
    2109,  3518,  2563,  3523,  2110,  2111,  2112,     0,     0,     0,
       0,     0,  2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,
    2572,     0,  2625,     0,     0,  4780,     0,     0,     0,     0,
       0,     0,  2626,     0,     0,     0,     0,     0,     0,  2627,
       0,     0,     0,   798,     0,   798,  2108,     0,     0,  2109,
       0,     0,     0,  2110,  2111,  2112,     0,     0,     0,     0,
       0,     0,  1389,     0,     0,  2628,     0,     0,     0,     0,
       0,  2625,     0,   646,     0,  2629,   964,  1000,   964,   964,
    2630,  2626,   953,   915,     0,   865,     0,     0,  2627,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2631,  2301,     0,     0,   828,     0,     0,     0,
       0,     0,     0,     0,  2628,     0,     0,  2833,     0,     0,
       0,     0,     0,     0,     0,  3632,   865,     0,     0,     0,
    2632,     0,  3643,     0,     0,     0,     0,     0,     0,     0,
    2108,   865,     0,  2109,     0,     0,     0,  2110,  2111,  2112,
       0,     0,     0,     0,  3311,     0,     0,     0,     0,     0,
       0,     0,     0,   865,     0,  2625,     0,     0,     0,     0,
       0,     0,  2367,     0,     0,  2626,     0,     0,     0,     0,
       0,     0,  2627,  2629,     0,   865,     0,  2633,  2630,     0,
       0,     0,     0,  1582,     0,     0,     0,   828,     0,  1583,
       0,     0,     0,     0,     0,     0,     0,     0,  2628,     0,
    2631,  2301,     0,     0,     0,     0,     0,     0,     0,     0,
     953,     0,     0,   953,     0,     0,     0,     0,     0,     0,
       0,     0,  2629,     0,     0,     0,     0,  2630,  2632,     0,
       0,     0,     0,     0,  1585,     0,     0,     0,     0,   865,
     865,     0,     0,     0,     0,     0,     0,  4315,     0,  2631,
    2301,     0,     0,     0,  3786,  4318,  3789,  3791,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2367,  5172,     0,  2635,  5174,     0,     0,  2632,     0,     0,
       0,     0,     0,     0,     0,  2633,     0,  1389,  1389,  1389,
       0,  1586,     0,  1389,     0,     0,     0,     0,  1587,     0,
    5189,   953,  1588,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   953,     0,  2629,     0,     0,  2367,
    1389,  2630,   953,     0,     0,     0,     0,     0,     0,     0,
    1589,     0,     0,     0,  2633,  2833,     0,  2634,     0,     0,
     865,  6191,     0,  2631,  2301,     0,  3891,     0,     0,   798,
    4401,     0,  4403,     0,     0,     0,     0,     0,     0,     0,
       0,   953,  3902,     0,     0,  1590,     0,     0,     0,     0,
       0,  2632,  3786,     0,     0,  2563,     0,     0,     0,     0,
       0,  2635,   953,     0,  3924,  2564,  2565,  2566,  2567,  2568,
    2569,  2570,  2571,  2572,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2367,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   953,     0,   953,     0,   953,  2633,     0,
    2635,  2634,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1691,     0,  4464,     0,  1592,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1593,     0,
    2004,     0,  3420,     0,     0,     0,     0,     0,  1594,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1595,     0,     0,  2563,     0,     0,     0,     0,  4486,     0,
       0,     0,     0,  2564,  2565,  2566,  2567,  2568,  2569,  2570,
    2571,  2572,  3311,  3311,     0,     0,  3311,     0,     0,     0,
       0,     0,     0,   646,   953,     0,   964,     0,   964,   964,
       0,   953,  2797,     0,  2635,  1597,  1598,     0,  1389,     0,
       0,     0,  2563,  1389,     0,     0,     0,  5350,     0,     0,
       0,     0,  2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,
    2572,     0,     0,     0,     0,  4886,     0,  2798,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5374,  5375,
       0,     0,     0,     0,  3629,     0,  1389,  1389,  1389,     0,
       0,  1389,     0,     0,     0,     0,     0,     0,     0,  1389,
    1389,  1389,  1389,     0,     0,     0,     0,     0,     0,     0,
    1141,     0,     0,     0,     0,  1389,     0,     0,  1389,     0,
    1389,     0,     0,     0,     0,     0,  2563,  1600,  4628,     0,
       0,  1389,  1389,     0,     0,  1389,  2564,  2565,  2566,  2567,
    2568,  2569,  2570,  2571,  2572,     0,     0,     0,     0,  5110,
       0,     0,     0,     0,  1000,     0,  1389,     0,  1389,  2108,
    1389,     0,  2109,     0,     0,     0,  2110,  2111,  2112,  1403,
       0,  5420,  5421,     0,     0,     0,     0,     0,     0,  1389,
    2108,     0,  4190,  2109,  2625,     0,   865,  2110,  2111,  2112,
       0,     0,     0,     0,  2626,     0,     0,  3944,     0,     0,
       0,  2627,     0,     0,     0,  2625,     0,   865,     0,     0,
       0,  4682,     0,     0,     0,  2626,     0,     0,     0,     0,
       0,  1552,  2627,  2108,     0,     0,  2109,  2628,     0,     0,
    2110,  2111,  2112,     0,  4699,     0,     0,   646,     0,     0,
    3474,  4229,     0,   915,     0,  4229,  4243,  4229,  2628,  1403,
       0,  4229,     0,     0,  1389,     0,     0,  1553,  2626,  1389,
       0,     0,     0,     0,  4738,  2627,     0,     0,     0,   915,
       0,     0,     0,  1403,  1389,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3474,  4759,
       0,  2628,  4275,     0,     0,  4278,  3474,     0,  3523,     0,
       0,  5514,     0,     0,  5516,  5517,     0,     0,     0,     0,
       0,  1582,     0,     0,     0,     0,     0,  1583,     0,     0,
    1554,  5521,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1689,     0,     0,     0,     0,     0,     0,  1389,
    3795,     0,     0,     0,     0,  2629,     0,     0,     0,     0,
    2630,     0,     0,     0,     0,     0,     0,  1555,     0,     0,
       0,     0,  1585,     0,     0,     0,  2629,     0,     0,   953,
     953,  2630,  2631,  2301,     0,     0,     0,  3827,     0,  3827,
       0,  3827,  3827,     0,     0,     0,  3827,  3827,  3827,     0,
    3827,  3827,  3827,  2631,  2301,     0,     0,     0,     0,     0,
    2632,  3945,     0,     0,     0,     0,  1556,     0,     0,  2629,
       0,     0,     0,     0,  2630,     0,     0,  1690,   915,  1586,
       0,  2632,     0,     0,     0,     0,  1587,     0,     0,     0,
    1588,     0,     0,     0,     0,     0, -3027, -3027,     0,     0,
       0,     0,  2367,     0,  3904,     0,     0,     0,     0,  1558,
       0,     0,     0,     0,     0,     0,     0,  2633,  1589,     0,
    2634,     0,     0,  2367,  2632,     0,     0,     0,     0,  3932,
       0,     0,     0,     0,     0,     0,     0,   865,  2633,     0,
       0,  2634,  1560,     0,     0,     0,     0,  2901,     0,     0,
       0,     0,     0,  1590,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0, -3027,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2633,     0,     0,     0,     0,     0,    35,     0,     0,
       0,  2108,  1562,     0,  2109,     0,     0,     0,  2110,  2111,
    2112,  1563,     0,     0,     0,     0,     0,     0,     0,     0,
    1564,     0,     0,  2635,     0,     0,  2625,     0,  2817,     0,
       0,     0,  1738,     0,     0,     0,  2626,     0,     0,     0,
    1566,     0,  1691,  2627,  2635,     0,  1592,     0,     0,  1567,
     915,     0,     0,     0,  1568,     0,  1593,     0,     0,     0,
       0,   915,  1389,     0,     0,     0,  1594,     0,  1389,  2628,
       0,     0,     0,  3947,     0,     0,     0,   915,  1595,   953,
       0,     0,     0,     0,     0,     0,     0,  2635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1569,
       0,     0,     0,  3948,     0,     0,   865,   865,   865,     0,
    3757,  1582,     0,  1597,  1598,  2563,     0,  1583,     0,     0,
       0,     0,     0,   865,     0,  2564,  2565,  2566,  2567,  2568,
    2569,  2570,  2571,  2572,     0,     0,  2563,  1389,  5234,     0,
       0,     0,     0,     0,     0,  3758,  2564,  2565,  2566,  2567,
    2568,  2569,  2570,  2571,  2572,  2004,   865,   865,     0,  5271,
       0,   865,  1585,     0,     0,     0,     0,     0,  5093,     0,
       0,     0,     0,   865,     0,     0,     0,  2629,     0,  2563,
       0,     0,  2630,     0,     0,     0,     0,     0,     0,  2564,
    2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,     0,     0,
       0,     0,     0,     0,  2631,  2301,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1600,     0,     0,  5864,  1586,
       0,     0,     0,   915,     0,     0,  1587,     0,     0,   953,
    1588,     0,  2632,     0,     0,     0,     0,     0,     0,  1141,
       0,     0,     0,  3197,  4650,     0,     0,     0,     0,     0,
       0,     0,   865,     0,     0,     0,     0,     0,  1589,     0,
       0,     0,     0,     0,     0,   865,     0,     0,   865,     0,
    5900,     0,     0,     0,  2367,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1389,     0,  2633,
       0,     0,  2634,  1590,     0,     0,  1389,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1389,
       0,     0,     0,     0,     0,  1389,  1389,  1389,     0,     0,
       0,     0,  1389,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1389,     0,  1389,     0,     0,  1389,
       0,     0,     0,     0,  1389,  1389,  1389,  1389,     0,     0,
    1389,  1389,  1389,  1389,  1389,  1389,  1389,  1389,  1389,  1389,
       0,     0,     0,  1389,  1389,  1389,     0,     0,     0,     0,
       0,     0,  1591,  1389,     0,     0,  1592,     0,  1389,     0,
       0,     0,  1389,  5989,     0,  2635,  1593,     0,     0,     0,
    1389,     0,     0,  1389,     0,  1389,  1594,     0,     0,     0,
       0,     0,  1141,     0,     0,     0,     0,     0,  1595,     0,
       0,  1389,     0,     0,  1389,  1389,     0,     0,     0,  1389,
    1389,     0,     0,     0,  1389,     0,  1389,  4806,     0,     0,
       0,     0,     0,     0,     0,   865,   865,   865,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2875,     0,     0,  1597,  1598,  1389,  4229,  4243,  4229,  4229,
       0,  1389,  4229,     0,     0,  4829,     0,     0,  1582,  3474,
       0,     0,     0,  3474,  1583,     0,     0,     0,     0,  4844,
    4376,     0,     0,     0,     0,  2876,     0,  2563,     0,     0,
    2734,     0,     0,  -136,     0,     0,     0,  2564,  2565,  2566,
    2567,  2568,  2569,  2570,  2571,  2572,  1389,     0,     0,     0,
    5275,     0,     0,     1,     0,     0,     0,     0,     0,  1585,
       0,  3523,     0,  1389,     2,  5351,     3,     4,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4423,     0,
       0,  4892,  2004,  2004,     5,     0,  2004,     0,     0,     0,
       0,     0,     0,     0,     6,  1600,     0,  2734,     0,     0,
       0,     0,     0,  5373,     0,     0,     7,     0,     8,     9,
       0,     0,     0,     0,     0,    10,  1586,    11,     0,     0,
       0,  2833,  4924,  1587,     0,  5389,     0,  1588,     0,     0,
      12,     0,    13,     0,     0,     0,     0,     0,   915,     0,
    4945,     0,     0,     0,     0,     0,  4466,     0,     0,    14,
       0,     0,    15,     0,     0,  1589,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,     0,    17,
       0,   915,     0,    18,     0,     0,     0,     0,     0,     0,
      19,     0,     0,     0,     0,     0,     0,     0,     0,    20,
    1590,    21,  3827,     0,     0,     0,  5419,     0,    22,     0,
       0,     0,     0,     0,  4497,  4497,     0,     0,     0,     0,
       0,     0,     0,     0,  4513,     0,    23,     0,     0,  1141,
       0,  1141,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    24,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5037,     0,
       0,  1738,  1738,  1738,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4568,     0,  1691,
       0,     0,     0,  1592,     0,     0,     0,     0,     0,     0,
       0,   953,     0,  1593,     0,     0,    25,    26,     0,     0,
       0,     0,    27,  1594,     0,   953,     0,  1389,     0,     0,
       0,     0,  4604,  1141,   865,  1595,    28,     0,  1582,     0,
    5081,     0,     0,     0,  1583,     0,     0,  5503,     0,     0,
       0,  2833,     0,     0,     0,    29,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   865,     0,     0,     0,
       0,  3474,  3902,     0,     0,     0,  6318,  3624,     0,  3786,
    1597,  1598,     0,     0,     0,     0,     0,     0,  5130,  1585,
       0,     0,   915,     0,     0,     0,     0,     0,   865,     0,
       0,     0,    30,   915,     0,     0,     0,     0,     0,     0,
    1389,  1389,  1599,   715,     0,     0,     0,    31,   716,   915,
       0,  1389,     0,    32,    33,     0,    34,     0,     0,     0,
       0,    35,  2004,   865,     0,     0,     0,    36,     0,     0,
      37,     0,     0,     0,     0,     0,  1586,    38,     0,     0,
     865,     0,     0,  1587,    39,    40,   717,  1588,     0,     0,
       0,     0,    41,     0,     0,     0,    42,     0,     0,   718,
       0,     0,   915,     0,     0,     0,    43,     0,     0,     0,
       0,     0,  1600,     0,     0,  1589,   719,   915,  1389,     0,
     915,   915,    44,     0,     0,     0,     0,     0,  4464,     0,
       0,     0,     0,     0,   720,     0,  1389,     0,     0,     0,
       0,     0,    45,     0,     0,     0,     0,     0,     0,     0,
    1590,   915,   915,     0,    46,     0,     0,     0,   721,     0,
      47,     0,     0,     0,  1389,    48,     0,     0,  4781,     0,
       0,   722,     0,     0,     0,     0,  1389,     0,    49,     0,
     723,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   724,     0,     0,     0,     0,     0,   725,
       0,    50,     0,     0,  1389,     0,   726,  1389,     0,     0,
       0,     0,     0,     0,     0,  1389,  1389,     0,     0,     0,
       0,    56,  1389,  1389,     0,   727,  -136,  1389,     0,  1691,
       0,     0,  1389,  1592,     0,  1389,  1389,     0,     0,     0,
       0,     0,  1389,  1593,     0,     0,   865,   865,   865,   865,
    1738,     0,     0,  1594,  1582,     0,     0,     0,     0,     0,
    1583,     0,     0,  1738,   646,  1595,  1738,  4229,     0,     0,
       0,  3474,     0,     0,     0,     0,  3474,     0,     0,  3474,
     646,     0,  3786,     0,  5308,   728,     0,  1389,     0,  1000,
       0,   915,     0,     0,     0,     0,     0,     0,  1389,     0,
       0,     0,  4275,     0,     0,  1585,  1389,  3802,  3523,     0,
    1597,  1598,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   798,     0,     0,  1389,     0,   729,     0,
       0,     0,   913,     0,     0,     0,  2108,     0,     0,  2109,
       0,   730,  3803,  2110,  2111,  2112,     0,     0,     0,     0,
       0,     0,     0,     0,   731,     0,     0,     0,     0,     0,
    2833,  2625,  1586,     0,   213,   732,     0,     0,   733,  1587,
       0,  2626,     0,  1588,     0,     0,  5372,     0,  2627,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   734,     0,  4513,   735,
       0,  1589,     0,   736,  2628,     0,   737,     0,     0,     0,
       0,     0,  1600,   738,     0,     0,   739,     0,     0,     0,
       0,     0,     0,     0,  4984,     0,     0,  1389,     0,     0,
       0,  5401,     0,  1389,     0,   740,  1590,     0,     0,  4997,
       0,     0,  4998,   741,  4999,     0,     0,     0,     0,   742,
       0,     0,   743,     0,     0,   953,   744,     0,     0,     0,
       0,     0,     0,     0,   745,     0,   746,     0,     0,  2030,
     953,   747,     0,     0,  2030,  2030,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   748,     0,     0,     0,     0,
    5039,     0,     0,     0,     0,     0,     0,     0,   749,     0,
       0,  1389,     0,     0,     0,     0,  3827,     0,     0,     0,
       0,  3827,     0,     0,     0,  1691,     0,   646,     0,  1592,
       0,     0,  2629,     0,  2833,     0,     0,  2630,     0,  1593,
       0,     0,     0,  2004,     0,     0,     0,     0,     0,  1594,
       0,     0,     0,     0,     0,     0,     0,     0,  3902,  2631,
    2301,  1595,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   953,     0,  3924,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2632,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5973,     0,   865,
       0,     0,     0,  4328,     0,     0,  1597,  1598,     0,     0,
     865,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5144,     0,     0,  4513,     0,     0,     0,     0,     0,  2367,
       0,     0,     0,     0,     0,     0,     0,     0,  4329,     0,
       0,     0,     0,     0,  2633,     0,     0,  2634,     0,     0,
       0,     0,     0,  6017,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6039,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1389,     0,     0,  1389,     0,     0,
    1389,  1389,  1389,     0,     0,     0,  5192,  5192,  5192,  5192,
       0,  5192,  5192,  5192,  5192,  5192,     0,     0,  1600,     0,
       0,     0,     0,     0,     0,  1389,  1389,     0,     0,  1389,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1582,  -136,     0,     0,     0,     0,  1583,     0,     0,
    2635,  1389,     0,     0,     0,     0,     0,  1389,     0,     0,
       0,  3474,     1,     0,     0,  5308,     0,     0,  1389,     0,
    5609,     0,     0,     2,     0,     3,     4,     0,     0,     0,
       0,  4892,     0,     0,  1389,     0,     0,     0,     0,  1738,
       0,     0,  1585,     5,     0,  4892,  1000,   953,     0,   953,
       0,     0,     0,     6,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     7,     0,     8,     9,     0,
       0,     0,     0,     0,    10,     0,    11,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    12,
       0,    13,     0,     0,     0,     0,   964,  1000,     0,  1586,
       0,     0,  2563,  5283,     0,  5285,  1587,     0,    14,     0,
    1588,    15,  2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,
    2572,     0,     0,     0,     0,  5546,    16,     0,    17,     0,
       0,     0,    18,     0,     0,     0,     0,     0,  1589,    19,
       0,     0,     0,   964,     0,     0,     0,     0,    20,     0,
      21,     0,     0,     0,     0,  5081,     0,    22,   965,   975,
     865,     0,     0,     0,     0,   865,   965,     0,   975,   965,
       0,     0,     0,  1590,  2833,    23,  3530,     0,     0,     0,
    2734,  3536,   975,     0,   865,     0,     0,     0,  5130,     0,
       0,  5747,    24,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   953,   865,  4892,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   915,  1389,
       0,     0,     0,     0,   915,    25,    26,     0,     0,     0,
       0,    27,  1691,     0,     0,     0,  1592,  1389,     0,     0,
       0,  1389,     0,  1389,     0,    28,  1593,     0,     0,     0,
       0,     0,   913,     0,     0,  1389,  1594,     0,     0,     0,
       0,  5823,     0,     0,    29,   915,     0,   646,  1595,     0,
    1389,     0,     0,     0,  5840,     0,     0,     0,   913,     0,
       0,  1389,     0,     0,     0,     0,     0,  1582,  1389,     0,
       0,     0,     0,  1583,     0,     0,     0,     0,     0,     0,
    1649,     0,  5417,  5418,     0,     0,     0,     0,     0,     0,
    4386,    30,     0,  1597,  1598,  3827,   974,  3827,  3827,  3827,
       0,     0,  1650,   865,     0,   974,    31,     0,     0,     0,
       0,     0,    32,    33,     0,    34,     0,     0,  1585,   974,
      35,     0,     0,     0,     0,  4387,    36,     0,  1389,    37,
       0,     0,     0,     0,  1389,  1389,    38,     0,     0,   953,
     953,   953,   953,    39,    40,     0,     0,     0,     0,     0,
       0,    41,     0,     0,  1651,    42,     0,     0,     0,     0,
       0,     0,     0,  5469,     0,    43,     0,     0,     0,     0,
    1389,     0,     0,     0,     0,  1586,     0,     0,   646,     0,
       0,    44,  1587,     0,     0,     0,  1588,     0,     0,     0,
       0,     0,     0,     0,     0,  1600,     0,     0,     0,     0,
       0,    45,  5497,   865,     0,     0,  3474,   913,     0,     0,
       0,     0,     0,    46,  1589,     0,     0,     0,     0,    47,
       0,     0,  1738,     0,    48,     0,     0,     0,     0,     0,
       0,   865,     0,     0,     0,     0,     0,    49,     0,     0,
       0,     0,     0,     0,  5192,     0,  1652,     0,     0,  1590,
       0,     0,     0,     0,   915,     0,     0,     0,     0,     0,
      50,     0,     0,    51,    52,    53,    54,    55,     0,  1389,
       0,     0,     0,     0,     0,     0,  1389,  1389,  1389,     0,
      56,     0,  2004,     0,     0,  -136,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3786,     0,     0,  1389,     0,     0,  1653,     0,
       0,     0,  1654,     0,  1389,     0,  1389,     0,  1389,  5609,
       0,     0,     0,     0,     0,  4892,     0,  2734,  1655,     0,
       0,  2734,  1592,     0,     0,  2004,     0,  1000,     0,     0,
       0,     0,  1593,     0,     0,     0,  1389,     0,     0,     0,
       0,     0,  1594,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1656,  1595,     0,     0,     0,     0,   913,
     975,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     913,  2004,  2004,     0,     0,     0,     0,     0,     0,   975,
       0,     0,     0,     0,     0,   975,   913,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1657,   975,     0,  1597,
    1598,  1658,   953,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   975,  4513,     0,  6127,     0,     0,     0,
       0,     0,     0,   915,     0,  1659,     0,   965,   975,     0,
       0,  1660,     0,     0,   965,     0,   975,   965,   915,     0,
       0,     0,     0,   915,     0,  1661,     0,     0,     0,  1389,
     975,     0,     0,     0,     0,     0,     0,     0,     0,  1389,
     975,     0,  3827,     0,     0,     0,     0,     0,     0,     0,
       0,  5694,     0,   915,  5823,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1389,     0,  1552,     0,  5840,     0,     0,     0,
       0,  1600,  1389,     0,     0,     0,     0,     0,     0,     0,
       0,  3523,  1389,     0,     0,     0,     0,     0,   975,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   964,     0,
    1553,     0,     0,     0,     0,     0,     0,   974,     0,     0,
       0,     0,   913,   953,     0,     0,     0,   975,     0,     0,
    2004,     0,     0,     0,     0,     0,   974,     0,     0,     0,
       0,  2108,   974,     0,  2109,     0,     0,     0,  2110,  2111,
    2112,     0,   975,     0,   974,  2833,     0,     0,     0,     0,
       0,     0,  1389,     0,     0,     0,  2625,     0,     0,     0,
     974,     0,  4892,  1554,   904,     0,  2626,     0,     0,     0,
     964,   964,  6274,  2627,     0,   974,  1389,     0,     0,     0,
       0,     0,     0,   974,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2004,  2004,  6285,     0,   974,     0,  2628,
    1555,     0,     0,     0,   975,     0,     0,   974,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1389,  1389,     0,     0,  1389,     0,     0,
    6308,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1556,
       0,     0,   953,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   974,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2604,     0,
       0,  6127,   953,   953,     0,     0,     0,  4892,  1557,  1141,
       0,     0,  1558,  5909,   974,     0,     0,     0,     0,     0,
       0,  2734,     0,     0,  3536,   646,  3536,  1389,     0,     0,
       0,  2734,     0,     0,  1824,     0,     0,  2629,     0,   974,
     975,     0,  2630,     0,  1623,  1560,     0,     0,     0,     0,
       0,   965,     0,     0,     0,   965,     0,   965,  1389,     0,
       0,     0,     0,     0,  2631,  2301,     0,     0,     0,  1552,
       0,     0,  1389,     0,     0,     0,     0,     0,     0,   915,
       0,     0,     0,     0,     0,     0,  1624,   915,     0,     0,
      35,     0,  2632,     0,     0,  1562,     0,     0,     0,   913,
       0,   974,     0,     0,  1563,  1553,     0,  6394,  6395,   646,
    6399,     0,  2734,  1564,     0,     0,     0,  5840,     0,     0,
    3523,  1625,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   953,  1566,  2367,  4892,     0,     0,     0,     0,
       0,     0,  1567,     0,     0,     0,     0,  1568,     0,  2633,
       0,     0,  2634,     0,     0,     0,     0,     0,  4275,     0,
       0,     0,     0,   975,     0,     0,   913,     0,  1554,     0,
       0,     0,     0,     0,     0,     0,     0,  1389,   646,     0,
       0,     0,   915,  1389,   915,     0,     0,   646,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     964,   964,  1569,     0,  6465,  1555,     0,   913,     0,     0,
       0,  1823,     0,     0,     0,     0,     0,   974,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,     0,
       0,     0,  1141,     0,     0,   975,  6089,     0,  6090,     0,
     913,     0,  6095,  6096,     0,  2635,     0,     0,  2108,   975,
       0,  2109,     0,   975,  1556,  2110,  2111,  2112,     0,     0,
       0,     0,     0,   715,     0,     0,     0,     0,  2784,     0,
       0,     0,     0,  2625,     0,     0,     0,     0,   915,     0,
       0,     0,     0,  2626,     0,     0,     0,     0,     0,     0,
    2627,     0,     0,  1557,     0,     0,     0,  1558,     0,     0,
    2108,     0,     0,  2109,     0,  1738,  2785,  2110,  2111,  2112,
       0,  1738,     0,     0,     0,     0,  2628,     0,     0,   718,
     915,     0,     0,     0,     0,  2625,     0,     0,     0,  1640,
    1560,     0,     0,     0,     0,  2626,   719,     0,     0,     0,
     974,  6167,  2627,     0,     0,     0,     0,  2563,  3536,     0,
       0,     0,     0,     0,  1057,     0,     0,  2564,  2565,  2566,
    2567,  2568,  2569,  2570,  2571,  2572,     0,     0,  2628,     0,
    5557,  1641,     0,     0,     0,    35,     0,     0,  2786,     0,
    1562,     0,     0,     0,     0,     0,     0,     0,     0,  1563,
       0,   722,     0,     0,     0,     0,   975,     0,  1564,     0,
     723,   974,     0,     0,   975,   975,  1642,     0,     0,     0,
       0,     0,   974,   724,     0,     0,   915,     0,  1566,  2787,
       0,     0,     0,     0,     0,     0,   974,  1567,     0,     0,
     974,   913,  1568,     0,  2629,     0,     0,     0,  3536,  2630,
       0,     0,   913,     0,     0,  1060,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1824,   913,     0,
     915,  2631,  2301,     0,     0,     0,     0,  2108,     0,     0,
    2109,     0,     0,     0,  2110,  2111,  2112,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2629,  1569,     0,  2632,
       0,  2630,  2625,     0,     0,     0,     0,     0,     0,     0,
    6289,     0,  2626,     0,     0,   728,     0,     0,     0,  2627,
       0,   913,     0,  2631,  2301,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   913,     0,     0,   913,
     913,  2367,     0,     0,     0,  2628,     0,     0,     0,     0,
       0,  2632,     0,   915,     0,     0,  2633,     0,  2788,  2634,
       0,     0,     0,     0,   904,     0,     0,  1141,     0,     0,
     913,   913,     0,     0,     0,     0,   915,     0,     0,     0,
       0,     0,     0,   974,     0,     0,     0,     0,     0,     0,
     904,   974,   974,  2367,   213,  2789,     0,     0,   733,     0,
       0,     0,     0,     0,     0,     0,   915,     0,  2633,     0,
       0,  2634,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   906,     0,  1064,     0,     0,  2790,
       0,   915,     0,     0,     0,     0,   737,     0,     0,     0,
       0,     0,     0,   738,  1823,     0,   739,     0,     0,     0,
       0,     0,  2635,  2108,     0,     0,  2109,     0,     0,     0,
    2110,  2111,  2112,  2629,     0,   740,     0,     0,  2630,     0,
       0,     0,     0,  1066,     0,     0,     0,     0,  2625,   742,
       0,     0,  1067,     0,     0,     0,   744,     0,  2626,     0,
    2631,  2301,     0,     0,  2791,  2627,     0,     0,     0,     0,
       0,  2792,     0,     0,  2635,     0,     0,     0,     0,     0,
     913,     0,     0,     0,     0,     0,   975,     0,  2632,     0,
       0,  2628,     0,     0,     0,     0,     0,     0,   749,     0,
       0,  6426,     0,     0,     0,  2588,     0,     0,     0,   904,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2563,     0,     0,     0,     0,     0,
    2367,     0,     0,     0,  2564,  2565,  2566,  2567,  2568,  2569,
    2570,  2571,  2572,     0,     0,  2633,     0,  5565,  2634,     0,
    6426,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2734,     0,     0,     0,     0,     0,     0,  6426,
       0,     0,  5283,     0,     0,     0,  2563,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2564,  2565,  2566,  2567,
    2568,  2569,  2570,  2571,  2572,     0,     0,     0,     0,  5625,
     975,     0,     0,     0,     0,     0,     0,     0,     0,  2629,
       0,     0,     0,     0,  2630,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1824,  2631,  2301,     0,     0,
       0,  2635,  2108,     0,     0,  2109,     0,     0,     0,  2110,
    2111,  2112,  3536,     0,     0,     0,     0,     0,   975,     0,
       0,     0,     0,   974,  2632,     0,   975,  2625,     0,     0,
       0,   904,     0,     0,   975,     0,     0,  2626,  3536,     0,
       0,     0,   904,     0,  2627,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   904,     0,
    2108,     0,     0,  2109,     0,     0,  2367,  2110,  2111,  2112,
    2628,     0,     0,     0,   965,   965,     0,   975,   975,     0,
       0,  2633,     0,     0,  2634,  2625,     0,     0,     0,   965,
       0,   975,   965,     0,     0,  2626,     0,     0,     0,     0,
       0,     0,  2627,  2563,   975,   975,     0,     0,     0,     0,
       0,     0,     0,  2564,  2565,  2566,  2567,  2568,  2569,  2570,
    2571,  2572,     0,     0,  2108,     0,  5658,  2109,  2628,     0,
       0,  2110,  2111,  2112,     0,     0,     0,   974,     0,     0,
       0,     0,   965,     0,     0,     0,   965,   965,     0,  2625,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2626,
       0,     0,     0,     0,     0,     0,  2627,     0,     0,     0,
       0,     0,  1823,     0,     0,     0,     0,  2635,     0,     0,
     915,     0,     0,     0,     0,     0,     0,     0,  2629,     0,
       0,     0,  2628,  2630,     0,   974,     0,     0,     0,  2108,
       0,     0,  2109,   974,     0,     0,  2110,  2111,  2112,     0,
       0,   974,     0,     0,   904,  2631,  2301,     0,     0,     0,
       0,     0,     0,     0,  2625,     0,     0,  3536,     0,     0,
       0,     0,  2734,     0,  2626,     0,     0,     0,     0,     0,
       0,  2627,     0,  2632,     0,     0,  2629,     0,     0,     0,
       0,  2630,     0,     0,   974,   974,     0,     0,     0,     0,
       0,     0,  1824,     0,     0,     0,     0,  2628,   974,     0,
       0,     0,     0,  2631,  2301,     0,     0,     0,     0,  2563,
       0,   974,   974,     0,     0,  2367,     0,     0,     0,  2564,
    2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,     0,     0,
    2633,  2632,  5660,  2634,     0,     0,     0,     0,     0,     0,
    2629,     0,     0,     0,   907,  2630,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2631,  2301,     0,
       0,     0,     0,  2367,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2633,     0,
       0,  2634,     0,     0,     0,  2632,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2629,     0,     0,     0,     0,
    2630,     0,     0,     0,     0,     0,  2635,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2367,     0,     0,
       0,   915,  2631,  2301,     0,     0,     0,     0,     0,     0,
       0,     0,  2633,     0,   906,  2634,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1823,
    2632,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     906,     0,     0,     0,  2635,   913,     0,     0,     0,   913,
     913,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   904,  2367,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2633,  2563,     0,
    2634,     0,     0,     0,     0,     0,     0,     0,  2564,  2565,
    2566,  2567,  2568,  2569,  2570,  2571,  2572,   913,  2635,     0,
       0,  5699,     0,   913,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   915,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   904,     0,
       0,     0,     0,     0,     0,     0,  2563,     0,     0,     0,
       0,     0,     0,     0,   913,     0,  2564,  2565,  2566,  2567,
    2568,  2569,  2570,  2571,  2572,   915,     0,     0,     0,  6077,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   904,
       0,     0,     0,  2635,     0,     0,     0,   915,     0,   906,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2563,     0,   904,     0,     0,     0,     0,     0,     0,     0,
    2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,     0,
       0,     0,     0,  6099,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   915,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2563,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2564,  2565,  2566,  2567,  2568,
    2569,  2570,  2571,  2572,     0,     0,     0,     0,  6334,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   906,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   906,   913,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5501,   906,   915,
       0,     0,     0,     0,  1824,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   904,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   904,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     904,     0,     0,     0,     0,     0,   913,     0,     0,   975,
     913,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   975,     0,     0,
       0,   975,     0,     0,     0,   975,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,     0,
       0,     0,     0,   904,     0,     0,     0,     0,     0,     0,
       0,     0,   975,     0,     0,     0,     0,     0,   904,     0,
       0,   904,   904,     0,     0,     0,     0,     0,     0,   965,
       0,   965,   965,     0,     0,     0,  2108,     0,     0,  2109,
       0,     0,     0,  2110,  2111,  2112,   975,     0,     0,     0,
     915,     0,   904,   904,   906,     0,     0,     0,     0,     0,
       0,  2625,   913,     0,     0,     0,   975,   975,     0,     0,
       0,  2626,     0,     0,     0,     0,     0,   913,  2627,     0,
       0,  1823,   913,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   907,     0,     0,  1824,   975,     0,
       0,  1824,     0,     0,  2628,     0,     0,     0,     0,     0,
       0,     0,   913,     0,     0,     0,     0,     0,  3536,     0,
     907,     0,     0,     0,     0,   975,     0,  1824,     0,     0,
       0,   975,     0,     0,     0,     0,   974,     0,     0,     0,
       0,     0,     0,     0,     0,   975,     0,     0,     0,     0,
       0,     0,   975,     0,   974,   975,     0,     0,   974,     0,
       0,   975,   974,     0,     0,  2108,     0,     0,  2109,     0,
       0,   974,  2110,  2111,  2112,     0,     0,     0,     0,     0,
       0,   975,     0,     0,     0,     0,     0,   975,     0,   974,
    2625,     0,   904,     0,   975,     0,     0,     0,     0,     0,
    2626,     0,     0,  2108,     0,     0,  2109,  2627,   975,     0,
    2110,  2111,  2112,     0,     0,     0,     0,     0,     0,     0,
       0,   975,  2629,   974,     0,     0,  1824,  2630,  2625,     0,
       0,     0,   975,  2628,     0,     0,     0,     0,  2626,     0,
    3536,     0,     0,   974,   974,  2627,     0,     0,     0,  2631,
    2301,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   907,
       0,  2628,     0,     0,  1823,   974,     0,  2632,  1823,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1824,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,   654,  1823,     0,     0,     0,   974,   703,
     654,     0,     0,     0,     0,   755,     0,   654,     0,  2367,
       0,   906,   974,   654,     0,   808,     0,     0,     0,   974,
       0,     0,   974,     0,  2633,     0,     0,  2634,   974,     0,
       0,     0,     0,     0,   876,   876,     0,     0,     0,     0,
       0,  2629,     0,     0,     0,     0,  2630,     0,   974,     0,
       0,     0,     0,     0,   974,     0,     0,     0,     0,     0,
     913,   974,     0,   913,     0,   913,     0,     0,  2631,  2301,
     913,     0,     0,     0,     0,   974,     0,     0,   906,  2629,
       0,   915,     0,     0,  2630,     0,   915,   915,   974,     0,
       0,     0,     0,  1823,     0,     0,  2632,     0,     0,   974,
       0,     0,     0,     0,     0,     0,  2631,  2301,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   913,   906,
    2635,   907,     0,     0,     0,     0,   913,     0,     0,     0,
       0,     0,   907,     0,  2632,     0,     0,   975,  2367,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   907,     0,
       0,   913,   906,  2633,     0,   975,  2634,     0,     0,  1823,
       0,     0,   975,     0,     0,     0,     0,     0,     0,   965,
     715,   965,   965,     0,     0,  3234,  2367,     0,     0,     0,
       0,     0,     0,     0,     0,   955,     0,     0,     0,   959,
       0,  2633,     0,     0,  2634,     0,     0,  1002,  5501,   915,
    1004,     0,     0,  1009,  1010,     0,  1013,     0,  1016,     0,
       0,  1022,     0,  1024,     0,     0,     0,     0,     0,     0,
       0,   913,  2563,   913,     0,     0,   718,  3235,     0,     0,
       0,     0,  2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,
    2572,     0,     0,   719,     0,  6352,     0,     0,     0,  2635,
       0,     0,     0,     0,     0,   915,     0,     0,     0,     0,
       0,  1057,     0,  1824,     0,     0,     0,     0,  2108,  1824,
       0,  2109,   915,     0,     0,  2110,  2111,  2112,     0,     0,
       0,     0,     0,     0,     0,  3236,     0,  2635,     0,     0,
       0,     0,     0,  2625,     0,     0,     0,  3481,   722,     0,
       0,     0,     0,  2626,   907,     0,     0,   723,     0,     0,
    2627,     0,     0,     0,   974,     0,     0,   913,     0,     0,
     724,     0,     0,     0,     0,     0,  3237,     0,     0,     0,
       0,     0,   974,     0,     0,     0,  2628,     0,     0,   974,
       0,     0,     0,   906,     0,     0,     0,     0,     0,     0,
       0,  2563,  1060,   975,   906,     0,     0,     0,     0,   913,
       0,  2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,
     906,     0,     0,     0,  6403,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   913,  3482,  2563,
    3238,     0,     0,     0,     0,     0,     0,     0,     0,  2564,
    2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,     0,     0,
    3013,     0,   728,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   906,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   906,     0,
    1823,   906,   906,     0,     0,     0,  1823,     0,     0,     0,
       0,     0,     0,     0,  2629,   913,     0,     0,     0,  2630,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   906,   906,     0,     0,     0,   913,     0,     0,
       0,  2631,  2301,     0,     0,     0,   975,   975,     0,     0,
       0,   213,  3239,     0,     0,   733,     0,   904,     0,   913,
       0,   904,   904,     0,     0,     0,     0,     0,     0,  2632,
       0,     0,     0,   975,     0,     0,   975,     0,     0,     0,
       0,     0,     0,  1064,     0,     0,  3240,     0,     0,     0,
     974,     0,     0,   737,     0,     0,     0,     0,     0,     0,
     738,     0,     0,   739,     0,     0,     0,     0,     0,     0,
       0,  2367,     0,     0,     0,     0,     0,     0,     0,   904,
       0,     0,   740,     0,     0,   904,  2633,     0,     0,  2634,
    1066,   907,     0,     0,     0,     0,   742,     0,     0,  1067,
       0,     0,   913,   744,     0,     0,     0,     0,  1824,  1824,
    1824,     0,     0,     0,     0,     0,     0,     0,  3241,     0,
       0,     0,     0,     0,     0,   913,   904,     0,     0,     0,
       0,     0,   906,   975,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   749,     0,     0,     0,     0,
       0,     0,   975,     0,     0,   913,     0,     0,   907,     0,
       0,     0,     0,     0,  1051,     0,     0,     0,     0,  2108,
       0,     0,  2109,     0,   975,  1088,  2110,  2111,  2112,  1092,
     913,     0,  2635,   974,   974,     0,  1105,  1106,     0,     0,
    1112,     0,  1115,  1116,  2625,     0,     0,     0,     0,   907,
       0,     0,     0,     0,  2626,     0,     0,  1138,     0,     0,
     974,  2627,     0,   974,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1151,     0,     0,     0,     0,
       0,     0,   907,     0,     0,     0,     0,  2628,     0,     0,
       0,     0,     0,     0,  3483,     0,  1179,     0,  1181,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1197,     0,
     975,     0,     0,     0,     0,     0,   909,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2563,  1823,  1823,  1823,     0,     0,
       0,   654,     0,     0,  2564,  2565,  2566,  2567,  2568,  2569,
    2570,  2571,  2572,     0,     0,     0,     0,  1824,     0,     0,
     974,     0,     0,   975,     0,   975,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   975,   974,
     975,     0,     0,     0,     0,   904,     0,     0,     0,     0,
       0,   913,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   974,     0,     0,     0,  2629,     0,     0,     0,     0,
    2630,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   876,     0,
    1738,     0,  2631,  2301,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   975,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   904,     0,
    2632,     0,   904,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   907,     0,     0,     0,     0,     0,     0,
       0,   913,     0,     0,   907,     0,     0,   974,     0,   975,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     907,     0,  2367,     0,     0,     0,     0,   913,   975,     0,
       0,     0,     0,  1543,     0,     0,     0,  2633,     0,     0,
    2634,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     975,     0,     0,   975,  1823,     0,     0,     0,     0,     0,
     974,     0,   974,     0,     0,     0,     0,  4772,     0,     0,
       0,     0,     0,   907,     0,   974,     0,   974,     0,     0,
       0,     0,     0,     0,   904,     0,     0,     0,   907,     0,
       0,   907,   907,     0,     0,     0,     0,     0,     0,   904,
       0,     0,     0,     0,   904,     0,     0,  1722,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   907,   907,     0,     0,     0,     0,     0,     0,
       0,  1842,     0,  2635,   904,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   974,     0,  1854,     0,  1855,     0,
       0,  4773,     0,     0,     0,     0,     0,     0,  1858,     0,
       0,     0,     0,  1824,     0,  1868,     0,     0,     0,   913,
       0,     0,     0,     0,     0,     0,  2108,     0,     0,  2109,
       0,     0,     0,  2110,  2111,  2112,   974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2625,     0,     0,     0,   974,     0,  1919,     0,  1921,
       0,  2626,     0,     0,     0,     0,   913,     0,  2627,     0,
       0,   913,     0,     0,     0,     0,     0,   974,     0,     0,
     974,     0,     0,     0,     0,  2563,     0,     0,     0,     0,
       0,     0,     0,     0,  2628,  2564,  2565,  2566,  2567,  2568,
    2569,  2570,  2571,  2572,     0,     0,     0,     0,     0,     0,
       0,     0,   907,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   654,     0,   654,     0,   654,     0,   654,
       0,   654,   654,   654,     0,     0,     0,     0,   654,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2025,     0,     0,     0,     0,     0,     0,   906,     0,     0,
       0,   906,   906,  2037,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4124,     0,     0,
    1823,     0,     0,  4125,     0,   975,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2629,     0,     0,     0,     0,  2630,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   906,
       0,     0,     0,     0,     0,   906,     0,     0,     0,  2631,
    2301,     0,   904,     0,     0,   904,  1824,   904,     0,     0,
     913,  1824,   904,  1824,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2632,     0,     0,
       0,     0,     0,     0,     0,     0,   906,  1824,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     904,     0,     0,     0,     0,     0,     0,     0,   904,  2367,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   975,  2633,     0,   975,  2634,     0,     0,
       0,     0,     0,   904,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   876,     0,   909,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,     0,     0,     0,   913,     0,     0,     0,
       0,     0,   909,     0,  2108,     0,     0,  2109,     0,     0,
       0,  2110,  2111,  2112,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   904,     0,   904,     0,   910,     0,  2625,
       0,     0,     0,     0,   913,     0,   975,   975,     0,  2626,
    4126,     0,     0,  1823,     0,     0,  2627,   975,  1823,     0,
    1823,     0,     0,     0,     0,     0,   913,     0,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,     0,
       0,     0,  2628,     0,  1823,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2795,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2108,   906,     0,  2109,     0,     0,
       0,  2110,  2111,  2112,     0,     0,     0,     0,     0,   904,
     974,     0,     0,   974,     0,     0,     0,   913,     0,  2625,
       0,     0,  4051,     0,     0,     0,     0,     0,     0,  2626,
       0,     0,  2563,     0,     0,   975,  2627,     0,     0,     0,
       0,   909,  2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,
    2572,   904,     0,     0,  6158,     0,  2887,     0,     0,     0,
       0,     0,  2628,     0,     0,     0,     0,     0,   906,     0,
       0,     0,   906,     0,     0,     0,     0,     0,     0,   904,
    2629,     0,     0,     0,     0,  2630,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   974,   974,     0,     0,  2631,  2301,     0,
       0,     0,     0,     0,   974,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   974,     0,     0,     0,  2632,     0,     0,   913,     0,
       0,     0,     0,     0,     0,     0,     0,   904,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   904,
       0,     0,     0,     0,   906,     0,     0,  2367,     0,     0,
    2629,     0,     0,     0,     0,  2630,     0,     0,     0,   906,
       0,   904,  2633,     0,   906,  2634,     0,     0,     0,     0,
       0,     0,     0,   909,     0,     0,     0,  2631,  2301,     0,
       0,     0,   974,     0,   909,     0,     0,     0,     0,     0,
    6159,     0,     0,     0,   906,     0,     0,     0,     0,     0,
     909,     0,     0,     0,     0,  2632,     0,   907,     0,     0,
       0,   907,   907,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3017,     0,     0,   904,     0,     0,  2367,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2635,   913,
       0,     0,  2633,     0,     0,  2634,     0,   904,     0,   907,
     975,     0,     0,     0,     0,   907,  3053,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   904,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   975,     0,     0,     0,   907,     0,     0,  3114,
       0,  3118,   904,     0,   975,     0,     0,   913,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     912,  3136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   909,   975,  2635,     0,
    2563,     0,     0,     0,     0,     0,     0,  3156,     0,  3157,
    2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,     0,
       0,     0,     0,     0,  3166,     0,  3167,     0,     0,     0,
       0,     0,   654,     0,   654,     0,   654,     0,   654,     0,
     654,     0,     0,     0,   654,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1824,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   974,     0,   913,
       0,     0,   906,     0,   975,   906,     0,   906,     0,     0,
    2563,     0,   906,     0,     0,     0,     0,     0,     0,     0,
    2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,  2108,
       0,     0,  2109,   904,     0,     0,  2110,  2111,  2112,   974,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   974,     0,     0,  2625,     0,     0,     0,     0,     0,
     906,     0,     0,     0,  2626,     0,     0,     0,   906,     0,
       0,  2627,     0,     0,     0,   907,     0,     0,     0,     0,
       0,     0,     0,     0,   974,     0,     0,     0,     0,     0,
     975,     0,     0,   906,     0,     0,     0,  2628,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   910,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   904,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   910,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   907,   904,
     913,     0,   907,     0,     0,   913,   913,     0,     0,     0,
       0,     0,  1823,   906,     0,   906,     0,     0,     0,  2108,
       0,     0,  2109,   909,     0,     0,  2110,  2111,  2112,     0,
       0,   974,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4060,  2625,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2626,     0,     0,     0,     0,     0,
       0,  2627,     0,     0,     0,  2629,     0,     0,     0,     0,
    2630,     0,     0,     0,     0,     0,     0,     0,     0,   914,
       0,     0,   975,     0,   975,     0,     0,  2628,     0,     0,
     909,     0,  2631,  2301,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   907,     0,     0,     0,     0,   906,
       0,     0,     0,     0,     0,     0,     0,   974,   913,   907,
    2632,     0,     0,     0,   907,     0,     0,     0,     0,   975,
       0,   909,   910,     0,     0,     0,     0,     0,     0,   965,
       0,   904,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   906,     0,     0,   907,     0,     0,     0,     0,     0,
       0,     0,  2367,     0,   909,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   913,     0,     0,  2633,     0,   906,
    2634,  1824,     0,     0,     0,     0,   965,     0,   904,     0,
       0,   913,     0,   904,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2629,     0,     0,     0,     0,
    2630,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2631,  2301,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   906,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   974,
    2632,   974,     0,     0,     0,     0,     0,     0,     0,   906,
       0,     0,     0,  2635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   906,     0,     0,   910,     0,     0,     0,     0,     0,
       0,     0,  2367,     0,     0,   910,   974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2633,     0,     0,
    2634,   910,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   909,     0,     0,  1823,     0,
       0,     0,     0,     0,     0,     0,   909,     0,     0,     0,
       0,     0,   904,     0,   906,  2563,     0,     0,     0,     0,
       0,  4074,   909,     0,     0,  2564,  2565,  2566,  2567,  2568,
    2569,  2570,  2571,  2572,     0,     0,     0,   906,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     912,     0,   907,  2635,     0,   907,     0,   907,     0,   975,
       0,     0,   907,     0,     0,     0,     0,   906,     0,     0,
       0,     0,     0,   975,     0,   909,   912,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     909,     0,   906,   909,   909,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1824,     0,     0,     0,     0,     0,
     907,     0,     0,     0,     0,     0,     0,   910,   907,     0,
       0,     0,     0,     0,   909,   909,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   904,     0,
       0,     0,     0,   907,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2563,     0,     0,     0,     0,
       0,     0,     0,  3526,  3527,  2564,  2565,  2566,  2567,  2568,
    2569,  2570,  2571,  2572,     0,     0,   904,     0,     0,     0,
       0,     0,  3542,  3543,     0,  3545,  3546,     0,     0,     0,
    3549,  3550,     0,     0,     0,     0,     0,     0,   904,     0,
       0,     0,     0,     0,     0,  3561,     0,     0,     0,     0,
       0,     0,  3570,   907,     0,   907,  3573,  3574,     0,     0,
    3577,  3578,     0,     0,     0,   912,     0,  3583,     0,  1824,
       0,     0,     0,     0,     0,     0,   974,     0,     0,  3598,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     974,  3615,     0,   906,     0,     0,  3617,     0,     0,     0,
       0,     0,     0,     0,   909,     0,     0,     0,     0,   904,
       0,  3623,     0,     0,     0,     0,     0,     0,     0,     0,
    3630,  1823,     0,  3634,     0,  3636,  3639,  3641,     0,     0,
       0,     0,  3649,  3652,  1824,     0,   975,     0,     0,     0,
       0,     0,  3665,     0,     0,     0,     0,     0,  3675,   907,
       0,     0,  3678,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3688,  3689,     0,     0,     0,  3694,
       0,     0,     0,     0,     0,  3703,  3704,     0,     0,     0,
       0,     0,     0,   906,     0,     0,     0,     0,     0,  3713,
       0,   907,  3714,     0,     0,     0,     0,     0,     0,  3726,
    3727,     0,     0,     0,     0,  3731,     0,     0,     0,   906,
       0,     0,     0,     0,     0,     0,     0,  3738,     0,   907,
    3741,     0,     0,  1824,   910,  3744,     0,   912,     0,   914,
     904,  3747,  3748,     0,     0,     0,     0,     0,   912,  3754,
       0,     0,     0,  3756,     0,     0,  1823,  3763,  3764,  3765,
    3766,     0,  3768,     0,   912,   914,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3793,  3794,     0,  3796,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3805,
    3806,  3807,     0,     0,     0,     0,     0,   907,   975,     0,
       0,   910,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   965,     0,     0,     0,     0,     0,     0,     0,   907,
       0,  1823,     0,   974,   975,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   907,   910,     0,     0,     0,  3859,     0,     0,     0,
       0,     0,     0,     0,  3883,     0,     0,  2108,     0,     0,
    2109,   906,     0,     0,  2110,  2111,  2112,     0,     0,     0,
       0,     0,     0,  3895,     0,   910,     0,     0,     0,     0,
       0,     0,  2625,   965,   965,     0,     0,     0,     0,     0,
       0,   904,  2626,     0,     0,     0,     0,     0,     0,  2627,
       0,     0,     0,     0,     0,     0,     0,     0,   906,     0,
    1823,     0,     0,   906,   914,     0,     0,     0,     0,     0,
     912,     0,     0,  3963,   907,  2628,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3977,     0,  3979,     0,     0,   907,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   904,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   975,     0,     0,     0,   974,     0,   907,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   974,   907,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2108,     0,     0,  2109,
       0,     0,     0,  2110,  2111,  2112,     0,     0,  4042,     0,
       0,     0,     0,  2629,     0,     0,     0,     0,  2630,     0,
       0,  2625,     0,     0,  4129,     0,     0,     0,     0,     0,
       0,  2626,     0,     0,     0,     0,   910,     0,  2627,     0,
    2631,  2301,     0,     0,     0,     0,   914,   910,     0,     0,
       0,   904,     0,     0,     0,     0,     0,   914,     0,     0,
       0,     0,   906,   910,  2628,     0,     0,     0,  2632,     0,
       0,     0,     0,   914,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1824,     0,     0,     0,     0,
    2367,     0,     0,     0,     0,     0,   910,     0,   974,     0,
       0,     0,     0,     0,     0,  2633,     0,     0,  2634,     0,
       0,   910,     0,   907,   910,   910,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4097,     0,
       0,     0,     0,     0,  1824,     0,     0,   912,     0,     0,
       0,     0,     0,   965,   965,   910,   910,     0,     0,     0,
       0,     0,     0,  1824,     0,     0,     0,     0,     0,     0,
       0,     0,  2629,     0,     0,     0,     0,  2630,   906,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   909,
       0,     0,   904,   909,   909,     0,     0,   904,   904,  2631,
    2301,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2635,     0,   907,   912,     0,   906,     0,     0,   914,
       0,  2108,     0,     0,  2109,     0,     0,  2632,  2110,  2111,
    2112,     0,     0,     0,     0,     0,     0,     0,   906,   907,
       0,     0,     0,     0,     0,     0,  2625,     0,     0,     0,
       0,   909,     0,     0,     0,   912,  2626,   909,     0,     0,
       0,     0,     0,  2627,     0,     0,     0,     0,     0,  2367,
       0,     0,  1823,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2633,     0,     0,  2634,   912,  2628,
       0,     0,     0,     0,     0,   910,     0,     0,   909,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   906,
     904,     0,     0,  2563,     0,     0,     0,  4301,     0,     0,
       0,  1823,     0,  2564,  2565,  2566,  2567,  2568,  2569,  2570,
    2571,  2572,     0,     0,     0,     0,     0,  4313,     0,     0,
    1823,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2108,     0,  4320,  2109,     0,     0,  4320,  2110,
    2111,  2112,     0,  4331,  4332,  4333,   904,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2625,     0,     0,
    2635,   907,     0,   904,     0,     0,     0,  2626,  4134,     0,
       0,     0,     0,     0,  2627,     0,     0,     0,     0,  4363,
    4364,  4365,  4366,     0,     0,     0,     0,  2629,     0,     0,
       0,     0,  2630,     0,     0,     0,     0,     0,     0,     0,
    2628,     0,     0,     0,     0,     0,     0,     0,   907,  4382,
     906,     0,     0,   907,  2631,  2301,     0,  4385,     0,  4389,
    4390,  4391,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2632,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   912,
       0,     0,  2563,     0,     0,     0,   914,     0,     0,     0,
     912,     0,  2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,
    2572,     0,  2108,     0,  2367,  2109,   912,   909,     0,  2110,
    2111,  2112,     0,     0,     0,     0,     0,     0,     0,  2633,
       0,     0,  2634,     0,     0,     0,     0,  2625,     0,     0,
    4141,     0,     0,     0,     0,     0,     0,  2626,  2629,     0,
       0,     0,     0,  2630,  2627,     0,     0,     0,     0,     0,
       0,     0,     0,   914,     0,  4474,     0,     0,     0,   912,
       0,     0,     0,     0,  4480,  2631,  2301,     0,     0,     0,
    2628,     0,     0,     0,   912,     0,     0,   912,   912,     0,
     909,   906,     0,     0,   909,     0,     0,     0,     0,     0,
    4490,  4491,     0,  2632,   914,  4492,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   912,   912,
       0,     0,   907,     0,     0,  2635,     0,  4534,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   914,     0,     0,
       0,     0,     0,     0,     0,  2367,     0,  2108,     0,     0,
    2109,     0,     0,     0,  2110,  2111,  2112,     0,     0,   906,
    2633,     0,     0,  2634,     0,     0,     0,     0,     0,     0,
       0,     0,  2625,     0,     0,  4779,     0,     0,     0,  4571,
       0,     0,  2626,     0,  4577,     0,     0,     0,     0,  2627,
    4583,     0,     0,     0,     0,     0,   909,     0,  2629,     0,
       0,     0,     0,  2630,     0,     0,     0,     0,     0,     0,
       0,   909,     0,     0,     0,  2628,   909,     0,     0,     0,
    4622,     0,     0,     0,     0,  2631,  2301,  2563,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2564,  2565,  2566,
    2567,  2568,  2569,  2570,  2571,  2572,   909,     0,   907,  4637,
       0,  4638,     0,  2632,     0,     0,  2635,     0,   912,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   906,     0,     0,     0,     0,   907,     0,     0,  4679,
       0,     0,  4663,     0,     0,  2367,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   907,     0,
    2633,     0,     0,  2634,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   914,     0,
       0,     0,     0,  2629,     0,     0,     0,     0,  2630,   914,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   914,     0,     0,  2563,     0,
    2631,  2301,     0,     0,     0,     0,     0,     0,  2564,  2565,
    2566,  2567,  2568,  2569,  2570,  2571,  2572,     0,     0,   907,
       0,     0,     0,     0,     0,     0,     0,     0,  2632,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2635,     0,   914,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     910,     0,     0,   914,   910,   910,   914,   914,     0,     0,
    2367,     0,   906,     0,     0,     0,     0,   906,   906,     0,
       0,     0,     0,     0,     0,  2633,     0,     0,  2634,     0,
       0,     0,     0,     0,     0,     0,     0,   914,   914,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   910,     0,     0,     0,     0,     0,   910,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     907,     0,     0,     0,   909,     0,     0,   909,  2563,   909,
       0,     0,     0,     0,   909,     0,     0,     0,  2564,  2565,
    2566,  2567,  2568,  2569,  2570,  2571,  2572,     0,     0,   910,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2635,     0,     0,     0,     0,     0,     0,     0,     0,
     906,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   909,     0,     0,     0,     0,     0,     0,     0,
     909,  4896,     0,     0,  4903,     0,  4904,     0,     0,     0,
       0,     0,     0,     0,  2108,     0,     0,  2109,     0,  4911,
       0,  2110,  2111,  2112,     0,   909,     0,   914,     0,     0,
       0,  4917,     0,     0,     0,  4920,   906,     0,     0,  2625,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2626,
       0,     0,     0,   906,  4944,     0,  2627,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4948,  2563,     0,     0,     0,     0,  4952,     0,
       0,   907,  2628,  2564,  2565,  2566,  2567,  2568,  2569,  2570,
    2571,  2572,     0,     0,     0,   909,     0,   909,     0,     0,
       0,     0,     0,  4987,     0,     0,     0,  4991,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5000,  5001,  5002,  5003,     0,     0,     0,     0,
       0,     0,  5007,  5008,  5009,  5010,     0,     0,     0,     0,
       0,  5012,  5013,     0,     0,     0,     0,  5020,  5021,   907,
    5023,  5024,  5025,  5026,  5027,  5028,  5029,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5038,     0,   910,     0,
    5041,  5042,  5043,  5044,     0,     0,     0,     0,     0,     0,
       0,  5235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   909,     0,     0,  4320,     0,     0,     0,     0,     0,
    2629,     0,     0,     0,     0,  2630,     0,     0,     0,     0,
       0,     0,  5064,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2631,  2301,     0,
       0,     0,     0,   909,     0,     0,     0,     0,     0,     0,
       0,   910,     0,     0,     0,   910,     0,     0,     0,  2108,
       0,     0,  2109,     0,     0,  2632,  2110,  2111,  2112,     0,
       0,   909,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   907,     0,     0,  2625,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2626,     0,     0,     0,  5145,     0,
       0,  2627,     0,     0,     0,     0,     0,  2367,     0,     0,
       0,     0,     0,   912,     0,     0,     0,   912,   912,     0,
       0,     0,  2633,     0,     0,  2634,     0,  2628,     0,     0,
       0,  4320,     0,     0,     0,     0,     0,     0,  5170,   909,
    5171,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   910,     0,     0,
       0,   909,  5185,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   910,     0,     0,   912,     0,   910,     0,     0,
       0,   912,     0,   909,     0,     0,  2108,     0,     0,  2109,
       0,     0,     0,  2110,  2111,  2112,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   910,     0,     0,
       0,  2625,     0,     0,     0,     0,     0,     0,  2635,     0,
       0,  2626,   912,     0,     0,     0,  5241,     0,  2627,     0,
       0,     0,   907,     0,     0,     0,     0,   907,   907,     0,
       0,     0,     0,     0,     0,  2629,     0,     0,     0,     0,
    2630,     0,     0,     0,  2628,     0,     0,     0,     0,     0,
       0,  1582,     0,     0,     0,     0,   909,  1583,     0,     0,
       0,     0,  2631,  2301,  1649,     0,     0,     0,     0,     0,
       0,   978,     0,     0,     0,     0,     0,     0,     0,   909,
       0,     0,     0,  1012,     0,     0,  1650,     0,     0,     0,
    2632,     0,     0,     0,  1031,     0,     0,     0,     0,     0,
       0,     0,  1585,     0,     0,     0,     0,     0,     0,   909,
    2563,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,     0,
       0,     0,  2367,     0,   909,     0,     0,  5242,  1651,     0,
     907,     0,     0,     0,     0,     0,     0,  2633,     0,     0,
    2634,     0,     0,     0,     0,     0,     0,     0,     0,  1586,
       0,     0,  2629,     0,     0,     0,  1587,  2630,     0,     0,
    1588,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2631,
    2301,     0,     0,     0,     0,     0,   907,     0,  1589,     0,
       0,  5352,  5353,  5354,     0,     0,     0,  5355,  5356,  5357,
    5358,     0,     0,   907,  5360,     0,     0,  2632,     0,     0,
       0,   912,     0,     0,     0,     0,     0,     0,     0,     0,
    1652,     0,     0,  1590,     0,     0,     0,     0,     0,     0,
       0,     0,   914,  2635,     0,     0,   914,   914,     0,     0,
    5379,  5380,  5381,  5382,  5383,   910,  5385,  5386,   910,  2367,
     910,     0,     0,     0,     0,   910,     0,     0,  5395,  5396,
       0,     0,     0,     0,  2633,     0,     0,  2634,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1653,     0,   912,   909,  1654,     0,   912,     0,
       0,  5404,     0,     0,   914,     0,     0,     0,     0,     0,
     914,     0,  1655,   910,     0,     0,  1592,     0,     0,     0,
       0,   910,     0,     0,     0,     0,  1593,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1594,     0,     0,     0,
       0,     0,     0,     0,     0,  2563,   910,  1656,  1595,     0,
       0,   914,     0,     0,     0,  2564,  2565,  2566,  2567,  2568,
    2569,  2570,  2571,  2572,     0,     0,     0,     0,     0,     0,
    2635,     0,     0,     0,     0,     0,     0,     0,     0,  2108,
       0,     0,  2109,     0,     0,   909,  2110,  2111,  2112,     0,
    3732,     0,     0,  1597,  1598,  1658,     0,     0,     0,     0,
     912,     0,     0,  5467,  2625,     0,     0,     0,     0,     0,
       0,   909,     0,     0,  2626,   912,   910,     0,   910,  1659,
     912,  2627,     0,     0,     0,  3733,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1661,
       0,     0,     0,     0,     0,     0,     0,  2628,     0,     0,
     912,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5518,     0,
       0,     0,  2563,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,
    2572,     0,     0,     0,     0,  1600,     0,     0,     0,  5525,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5529,     0,   910,     0,     0,     0,     0,     0,     0,  5243,
       0,     0,  1050,     0,     0,     0,     0,     0,  1082,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   909,   910,     0,     0,     0,     0,     0,
     914,     0,     0,     0,     0,  2629,     0,     0,     0,     0,
    2630,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   910,     0,  1359,  1359,     0,     0,     0,     0,
       0,     0,  2631,  2301,     0,     0,     0,     0,     0,     0,
     909,     0,     0,     0,     0,   909,     0,     0,     0,     0,
     654,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2632,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   914,     0,     0,     0,   914,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     910,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2367,     0,  1359,     0,     0,     0,     0,     0,
       0,     0,   910,  5647,     0,     0,     0,  2633,     0,     0,
    2634,  2108,     0,     0,  2109,     0,     0,     0,  2110,  2111,
    2112,     0,  5657,     0,   910,     0,     0,     0,     0,     0,
    5663,  5664,     0,     0,     0,  1396,  2625,     0,   912,     0,
    5675,   912,     0,   912,     0,     0,  2626,  5677,   912,     0,
       0,     0,     0,  2627,  1419,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   914,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2628,
       0,     0,  5729,  5730,   914,  2108,     0,     0,  2109,   914,
       0,     0,  2110,  2111,  2112,  5738,   912,  5740,     0,     0,
       0,     0,     0,  2635,   912,     0,     0,   910,     0,     0,
    2625,     0,  5754,     0,   909,  1735,  1739,     0,     0,   914,
    2626,     0,     0,     0,     0,     0,  1477,  2627,     0,   912,
     910,     0,     0,     0,     0,     0,     0,  4320,     0,     0,
       0,     0,     0,     0,     0,  5788,     0,     0,     0,     0,
       0,     0,     0,  2628,     0,     0,     0,     0,     0,     0,
     910,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1613,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   910,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2629,     0,   912,
       0,   912,  2630,     0,     0,  2563,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2564,  2565,  2566,  2567,  2568,
    2569,  2570,  2571,  2572,  2631,  2301,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5854,
     909,     0,     0,     0,     0,     0,  5800,     0,     0,     0,
       0,     0,  2632,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5874,     0,     0,     0,     0,     0,     0,
       0,  2629,     0,  5881,     0,     0,  2630,     0,   909,     0,
       0,     0,     0,     0,     0,     0,     0,  1873,     0,     0,
       0,     0,     0,     0,  2367,   912,     0,     0,  2631,  2301,
     909,     0,     0,     0,     0,     0,     0,     0,     0,  2633,
       0,     0,  2634,     0,     0,  1907,  1910,  1911,     0,     0,
       0,     0,     0,     0,     0,     0,  2632,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   912,     0,     0,
    5940,     0,     0,     0,     0,     0,   910,     0,  2053,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   912,     0,     0,  2367,     0,
       0,   909,     0,     0,     0,     0,     0,   914,     0,     0,
     914,     0,   914,  2633,     0,     0,  2634,   914,     0,  2078,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2635,     0,     0,     0,     0,
    4320,     0,     0,     0,     0,     0,     0,  2097,  2098,  2099,
       0,  2101,     0,  2108,  1396,     0,  2109,     0,     0,     0,
    2110,  2111,  2112,   912,     0,   914,   910,     0,     0,     0,
    2036,     0,  2581,   914,     0,     0,     0,     0,  2625,  1396,
    5529,     0,     0,     0,     0,   912,     0,     0,  2626,     0,
       0,     0,   910,     0,     0,  2627,     0,     0,   914,     0,
       0,     0,     0,     0,     0,     0,     0,   912,     0,  2635,
       0,     0,  5618,     0,     0,     0,     0,     0,     0,     0,
       0,  2628,   909,     0,     0,     0,     0,     0,     0,     0,
    6065,     0,     0,     0,     0,     0,     0,  2563,     0,     0,
       0,     0,     0,     0,  6078,     0,     0,  2564,  2565,  2566,
    2567,  2568,  2569,  2570,  2571,  2572,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   914,     0,
     914,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2677,     0,     0,
     912,  2689,  2694,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6117,     0,     0,     0,     0,     0,     0,
       0,  2563,     0,   912,     0,     0,     0,     0,     0,     0,
       0,  2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,
       0,     0,     0,     0,   910,     0,     0,     0,     0,  2629,
       0,  2619,     0,   912,  2630,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   914,     0,  2631,  2301,   912,     0,
       0,     0,     0,   909,  5529,     0,     0,     0,     0,     0,
       0,   910,     0,     0,     0,     0,   910,     0,     0,     0,
       0,     0,     0,     0,  2632,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   914,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2710,     0,  6221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   914,     0,  2367,     0,     0,     0,
       0,   909,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2633,     0,     0,  2634,  6233,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6243,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   914,     0,  2827,     0,     0,     0,     0,     0,
       0,     0,     0,  2850,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   914,     0,     0,     0,     0,   912,
       0,     0,  2574,     0,  1735,  1735,  1735,     0,  5529,  5529,
    5529,  5529,  5529,  5529,     0,  2888,   914,  2635,     0,     0,
       0,  2900,  2900,     0,     0,  2900,     0,     0,     0,     0,
       0,     0,     0,   909,     0,   910,     0,     0,  2918,     0,
       0,  2921,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6328,     0,  2574,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   912,
       0,     0,     0,     0,     0,     0,     0,  2974,     0,   914,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2993,     0,   715,     0,   912,     0,     0,  1053,  2563,
       0,     0,   914,     0,     0,     0,     0,     0,     0,  2564,
    2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   914,     0,     0,     0,  1054,     0,     0,     0,
       0,   910,     0,     0,     0,     0,     0,     0,     0,   718,
    1055,     0,     0,     0,     0,     0,     0,   914,     0,     0,
       0,     0,  1056,     0,   909,     0,   719,     0,     0,   909,
     909,     0,     0,     0,     0,     0,     0,     0,     0,   910,
       0,     0,     0,     0,  1057,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3015,   910,     0,     0,     0,     0,     0,     0,  1058,     0,
       0,  3018,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   722,     0,     0,     0,     0,     0,     0,     0,     0,
     723,     0,     0,     0,     0,     0,     0,   912,     0,     0,
       0,     0,     0,   724,     0,     0,     0,     0,     0,  1059,
       0,     0,     0,  3062,  2900,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   910,     0,     0,  1060,     0,     0,  3097,     0,
       0,     0,   909,     0,   912,  3110,     0,     0,     0,   912,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3252,     0,     0,  1061,     0,     0,     0,     0,   914,  3269,
    3269,  3269,  3269,  3281,  3290,  3269,  3293,  3269,  3269,     0,
       0,     0,  3299,     0,  3300,   728,  3302,     0,   909,  3316,
    3319,  3324,     0,     0,     0,     0,     0,  3333,     0,     0,
    3338,     0,     0,     0,     0,   909,     0,  3171,  2574,     0,
       0,     0,  2574,     0,     0,  3345,  3346,  3347,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1062,     0,
       0,     0,     0,  3348,     0,     0,     0,     0,     0,     0,
    1396,  1396,     0,   910,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   731,     0,     0,  3224,   914,     1,
       0,     0,     0,     0,   213,  1063,     0,     0,   733,     0,
       2,     0,     3,     4,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   914,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1064,     0,     0,  1065,
       6,     0,     0,   736,     0,     0,   737,     0,     0,     0,
       0,     0,     7,   738,     8,     9,   739,     0,   912,     0,
       0,    10,     0,    11,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   740,    12,     0,    13,     0,
       0,     0,     0,  1066,     0,     0,     0,     0,     0,   742,
       0,     0,  1067,     0,     0,    14,   744,     0,    15,     0,
       0,     0,     0,     0,  1068,     0,   746,     0,     0,     0,
       0,  1069,     0,    16,     0,    17,     0,     0,     0,    18,
    3355,     0,     0,     0,     0,     0,  5768,     0,     0,     0,
       0,     0,     0,     0,   910,    20,     0,    21,   749,     0,
       0,     0,     0,     0,    22,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    23,     0,     0,     0,   914,     0,     0,     0,
       0,     0,     0,  3374,     0,     0,     0,     0,     0,    24,
       0,     0,     0,     0,   912,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   910,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   914,     0,     0,     0,     0,   914,     0,
       0,     0,   912,     0,     0,     0,     0,     0,  3376,     0,
       0,     0,    25,    26,     0,     0,     0,     0,    27,     0,
       0,     0,     0,     0,   912,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2574,     0,     0,     0,
       0,    29,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2574,     0,     0,     0,  3312,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2574,  2574,  2574,     0,  2574,   912,     0,     0,    30,     0,
       0,     0,     0,     0,   910,     0,     0,     0,     0,     0,
       0,     0,     0,    31,     0,     0,     0,     0,     0,    32,
      33,     0,    34,     0,     0,     0,     0,    35,     0,     0,
    4612,     0,     0,    36,     0,     0,    37,     0,     0,     0,
       0,     0,     0,    38,     0,     0,     0,     0,     0,     0,
      39,    40,     0,     0,     0,     0,     0,     0,    41,     0,
       0,     0,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    43,     0,     0,     0,     0,   914,   197,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    44,  3383,
    3384,  3385,  3386,  3387,  3388,  3389,  3390,  3391,     0,  3392,
       0,     0,     0,     0,     0,     0,     0,     0,    45,     0,
    1359,     0,  1735,     0,     0,     0,   912,     0,     0,     0,
      46,     0,     0,     0,     0,     0,    47,     0,     0,   198,
       0,    48,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    49,     0,   199,     0,     0,     0,
    3348,     0,     0,     0,  3355,   910,     0,  3374,     0,  3376,
     910,   910,  3429,     0,   200,     0,     0,    50,     0,     0,
     201,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    56,   202,     0,
       0,     0,  -136,     0,     0,     0,     0,     0,     0,     0,
       0,   203,     0,   914,     0,     0,     0,     0,     0,     0,
     204,     0,     0,     0,     0,  2098,  2099,     0,     0,     0,
       0,     0,     0,   205,     0,     0,   666,  3412,     0,   206,
       0,     0,     0,     0,     0,     0,   207,  3417,     0,     0,
       0,   914,     0,     0,   667,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,     0,     0,     0,     0,
       0,     0,     0,   914,     0,     0,  1477,   912,     0,   668,
       0,     0,     0,   910,     0,     0,     0,     0,     0,     0,
       0,     0,   669,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   209,     0,     0,     0,     0,  3575,  -861,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1477,  1477,   210,     0,   670,     0,     0,
       0,     0,     0,   671,     0,     0,     0,     0,     0,   910,
       0,     0,     0,     0,   914,   912,     0,     0,     0,     0,
       0,   672,     0,     0,     0,     0,   910,  1396,     0,     0,
       0,     0,     0,     0,   673,     0,     0,     0,   211,     0,
       0,     0,     0,   674,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   675,     0,     0,     0,
       0,     0,     0,     0,   212,   676,     0,     0,     0,   677,
       0,     0,     0,     0,   213,   214,     0,     0,   215,     0,
       0,     0,     0,     0,     0,     0,     0,     0, -1062,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   216,     0,     0,   217,
       0,     0,     0,   218,     0,     0,   219,     0,     0,     0,
       0,     0,     0,   220,     0,     0,   221,     0,     0,     0,
       0,     0,     0,     0,     0,   914,     0,   912,   678,     0,
       0,     0,     0,     0,     0,   222,     0,     0,  -597,     0,
       0,     0,     0,   223,  2574,     0,     0,     0,   224,   225,
    3633,     0,   226,     0,     0,     0,   227,     0,     0,     0,
       0,     0,     0,     0,     0,  3655,   228,     0,     0,     0,
       0,   229,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   679,     0,     0,   680,   230,     0,  3683,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   231,     0,
       0,     0,     0,  3817,  3818,  1735,     0,   681,     0,  3822,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   682,     0,     0,     0,     0,     0,     0,     0,  -455,
       0,     0,     0,     0,     0,     0,  3851,     0,     0,     0,
    2574,     0,     0,     0,     0,     0,     0,     0,     0,   683,
       0,     0,  2574,     0,     0,     0,     0,  2574,     0,   684,
       0,     0,     0,     0,     0,     0,  -455,     0,     0,   685,
       0,     0,     0,  3761,  3762,     0,   914,     0,   912,     0,
       0,     0,     0,   912,   912,     0,     0,     0,   686,     0,
       0,     0,     0,     0,     0,     0,   687,     0,     0,     0,
       0,     0,  -455,     0,     0,   688,   689,     0,   690,   691,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   692,     0,     0,     0,     0,     0,
       0,     0,   693,     0,     0,   694,     0,     0,   695,     0,
       0,     0,     0,     0,   914,     0,     0,     0,     0,     0,
       0,  -455,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3885,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   912,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4047,     0,     0,     0,     0,  4053,
       0,     0,   912,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   914,     0,     0,   912,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2101,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3324,     0,  3324,  3324,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4144,     0,     0,  4147,     0,  4149,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4174,     0,  4177,     0,  4179,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   914,     0,     0,
       0,     0,   914,   914,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4249,     0,     0,     0,     0,  2677,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2694,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4195,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   914,     0,     0,     0,     0,
       0,  1477,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4299,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   914,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   914,     0,
       0,     0,     0,     0,     0,  2574,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2574,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2574,     0,     0,     0,     0,     0,
       0,     0,     0,  2574,     0,     0,  2574,     0,     0,     0,
       0,     0,  2574,  2574,     0,  2574,     0,     0,     0,     0,
    3312,  3312,     0,  4120,     0,  3312,     0,     0,     0,  2574,
       0,     0,  2574,     0,     0,     0,     0,  2574,     0,     0,
       0,     0,     0,     0,     0,     0,  2574,     0,     0,     0,
       0,  2574,     0,     0,     0,     0,     0,     0,  2574,  2574,
    2574,  2574,     0,     0,     0,  3312,  3312,     0,  2574,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2574,     0,  2574,
       0,     0,     0,     0,     0,     0,  2574,  2574,  2574,  2574,
    2574,  2574,  2574,  2574,  2574,  2574,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2574,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1735,     0,
       0,  4407,     0,     0,  1735,     0,     0,     0,     0,     0,
       0,  2900,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4561,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2574,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4538,  4539,  4540,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4549,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4574,  4576,     0,     0,     0,  4581,     0,     0,     0,     0,
       0,     0,     0,  4680,     0,     0,     0,     0,     0,     0,
       0,     0,  4684,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3269,     0,     0,     0,     0,
       0,  4710,  3269,  3269,     0,     0,     0,     0,  3290,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4733,     0,  4734,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4756,
    4757,  4758,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3333,  4662,
       0,     0,  1396,     0,     0,     0,  4782,     0,     0,  4785,
       0,  4787,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4791,     0,     0,
       0,     0,     0,     0,     0,  4798,  4799,     0,     0,     0,
    2574,  2574,  4804,     0,     0,  2574,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3269,     0,     0,  2574,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4858,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4872,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4811,
    4812,  4813,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2574,     0,     0,     0,     0,     0,  2574,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4120,  4120,     0,     0,  3312,  3312,
    3312,  3312,     0,     0,  3312,  3312,  3312,  3312,  3312,  3312,
    3312,  3312,  3312,  3312,  4120,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2574,     0,     0,
    2574,     0,  2574,     0,     0,  4120,  4120,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2574,  3312,  3312,
    2574,     0,  2574,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5152,  5153,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5160,     0,     0,
       0,     0,  2574,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5074,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2574,     0,     0,     0,     0,     0,     0,     0,
    5106,     0,     0,     0,  5202,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2677,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3110,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5230,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5237,     0,     0,     0,     0,  5164,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3171,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5256,  5258,     0,     0,     0,     0,     0,  5262,  5263,
       0,     0,     0,  5264,     0,     0,     0,     0,  5265,     0,
       0,  5268,  5269,     0,     0,     0,     0,     0,  5274,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5310,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1359,     0,     0,     0,     0,     0,
       0,     0,  5324,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3312,  5334,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5278,  5279,  5280,  5281,  2574,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5398,     0,     0,     0,     0,     0,  5402,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2574,     0,     0,     0,  2574,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5437,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2574,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2574,  2574,     0,     0,
       0,     0,  4120,  4120,  4120,  4120,     0,     0,     0,  4120,
    4120,  4120,  4120,  4120,  4120,  4120,  4120,  4120,  4120,  2574,
    2574,  2574,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2574,     0,     0,  2574,     0,
    2574,     0,     0,     0,  2574,     0,     0,  4120,  4120,     0,
       0,  2574,  2574,     0,     0,     0,     0,  2574,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2574,     0,     0,     0,     0,     0,     0,     0,     0,
    5545,     0,     0,     0,     0,  2574,  5549,  5550,  5551,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5562,  5563,  5496,     0,  5564,     0,     0,     0,     0,
       0,     0,     0,     0,  5506,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5588,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5606,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5621,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4120,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2574,  2574,     0,     0,     0,
       0,     0,     0,  2574,     0,  3269,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3333,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5713,  2574,     0,     0,     0,  1396,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5743,     0,
       0,     0,     0,  2574,  2101,     0,     0,     0,     0,     0,
    2574,  3312,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2574,
       0,  2574,     0,     0,     0,  2574,  2574,  2574,  2574,     0,
       0,  2574,  2574,     0,     0,     0,     0,  2574,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5888,  3312,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2574,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2574,     0,     0,
       0,     0,     0,     0,     0,     0,  5924,  2574,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5871,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2574,     0,     0,     0,  2574,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5996,     0,     0,     0,     0,
    2574,     0,  6003,  6003,  6003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5606,     0,     0,  5947,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6067,     0,     0,  5969,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2574,     0,
    4120,  3312,  2574,  2574,  2574,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2574,  2574,  2574,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3312,     0,     0,  4120,     0,     0,
       0,  2574,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2574,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2574,  3269,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6003,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5606,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6209,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6250,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6275,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4120,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4120,     0,  3312,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2574,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6003,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2574,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6369,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2574,
       0,     0,     0,     0,     0,     0,  2574,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1735,     0,     0,     0,     0,     0,     0,
    2574,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3312,  3312,     0,
       0,  3312,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2574,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2574,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2574,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   234,     0,  1264,   710,     0,
    1265,  1266,  1267,   771,  1268,     0,  4120,  4120,     0,  4120,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,  1729,   244,   245,   246,     0,     0,     0,     0,  1269,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1270,   260,  1271,  1272,     0,
     263,   264,   265,   266,   267,   268,   269,  1273,  1274,   270,
     271,  1275,  1276,   274,     0,   275,   276,   277,   278,  1277,
       0,  1278,  2574,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,  1279,  1280,  1281,  1282,
    1283,  1284,  1285,   303,   304,   305,   306,   307,   308,  1286,
    1287,   311,  1288,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,  1730,     0,   324,
     325,   886,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,  1289,
     342,   343,   344,   345,  1290,  1291,   347,     0,   348,   349,
     350,  1292,   352,     0,   353,     0,   354,   355,   356,     0,
     357,   358,   359,   360,   361,     0,   362,  1293,     0,  1294,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,   388,   389,   390,  1295,
    1296,     0,  1297,     0,   394,   395,   396,   397,   398,  1298,
    1299,  1300,  1301,  1302,  1303,  1304,  1305,  1306,   408,  1307,
     410,   411,   412,   413,   414,   415,   416,     0,     0,   417,
    1308,   419,   420,   421,     0,   422,   423,   424,  1309,  1310,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,  1311,   444,
    1312,   446,   447,   448,   449,   450,   451,   452,   453,   454,
    1313,   456,  1314,   457,   458,   459,   460,  1315,  1316,   462,
    1317,   464,   465,   466,     0,   467,   468,   469,     0,     0,
    1318,   471,   472,     0,     0,   473,   474,   475,   476,   477,
     478,  1319,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,  1320,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,  1321,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,   535,   536,  1322,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,   551,   552,
    1323,   553,   554,   555,   556,   557,   558,   559,   560,  1324,
     562,     0,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,  1325,   578,     0,   579,
     580,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,  1326,  1327,     0,     0,   591,   592,  1328,   594,  1329,
    1330,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,  1331,   605,   606,   607,   608,   609,  1332,     0,   610,
     611,   612,   613,   614,   615,  1333,  1731,   617,   618,   619,
     620,   621,   622,     0,     0,   623,     0,     0,   624,   625,
     626,   627,   628,   629,   630,  1334,  1335,  1336,  1337,   635,
    1338,  1339,  1340,  1341,   640,   641,   642,   643,  1342,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1343,  1344,  1732,     0,     0,     0,     0,     0,     0,
    1346,  1733,   234,     0,  1264,   710,     0,  1265,  1266,  1267,
     771,  1268,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1269,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1270,   260,  1271,  1272,     0,   263,   264,   265,
     266,   267,   268,   269,  1273,  1274,   270,   271,  1275,  1276,
     274,     0,   275,   276,   277,   278,  1277,     0,  1278,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,  1279,  1280,  1281,  1282,  1283,  1284,  1285,
     303,   304,   305,   306,   307,   308,  1286,  1287,   311,  1288,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   886,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,  1289,   342,   343,   344,
     345,  1290,  1291,   347,     0,   348,   349,   350,  1292,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,  1293,     0,  1294,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,     0,   384,
     385,   386,   387,   388,   389,   390,  1295,  1296,     0,  1297,
       0,   394,   395,   396,   397,   398,  1298,  1299,  1300,  1301,
    1302,  1303,  1304,  1305,  1306,   408,  1307,   410,   411,   412,
     413,   414,   415,   416,     0,     0,   417,  1308,   419,   420,
     421,     0,   422,   423,   424,  1309,  1310,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,  1311,   444,  1312,   446,   447,
     448,   449,   450,   451,   452,   453,   454,  1313,   456,  1314,
     457,   458,   459,   460,  1315,  1316,   462,  1317,   464,   465,
     466,     0,   467,   468,   469,     0,     0,  1318,   471,   472,
       0,     0,   473,   474,   475,   476,   477,   478,  1319,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,  1320,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,  1321,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,   535,   536,
    1322,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,    40,   548,   549,   550,   551,   552,  1323,   553,   554,
     555,   556,   557,   558,   559,   560,  1324,   562,     0,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,  1325,   578,     0,   579,   580,    44,   581,
     582,   583,   584,   585,   586,   587,     0,   588,  1326,  1327,
       0,     0,   591,   592,  1328,   594,  1329,  1330,   596,   597,
     598,   599,   600,   601,   602,   603,   604,     0,  1331,   605,
     606,   607,   608,   609,  1332,     0,   610,   611,   612,   613,
     614,  1203,  1333,     0,   617,   618,   619,   620,   621,   622,
       0,     0,   623,     0,    49,   624,   625,   626,   627,   628,
     629,   630,  1334,  1335,  1336,  1337,   635,  1338,  1339,  1340,
    1341,   640,   641,   642,   643,  1342,     0,    50,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1343,  1344,
       0,     0,     0,     0,     0,     0,     0,  1346,  5848,   234,
       0,  1264,   710,     0,  1265,  1266,  1267,   771,  1268,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1269,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1270,
     260,  1271,  1272,     0,   263,   264,   265,   266,   267,   268,
     269,  1273,  1274,   270,   271,  1275,  1276,   274,     0,   275,
     276,   277,   278,  1277,     0,  1278,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
    1279,  1280,  1281,  1282,  1283,  1284,  1285,   303,   304,   305,
     306,   307,   308,  1286,  1287,   311,  1288,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   886,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,  1289,   342,   343,   344,   345,  1290,  1291,
     347,     0,   348,   349,   350,  1292,   352,     0,   353,     0,
     354,   355,   356,     0,   357,   358,   359,   360,   361,     0,
     362,  1293,     0,  1294,   365,   366,     0,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
     388,   389,   390,  1295,  1296,     0,  1297,     0,   394,   395,
     396,   397,   398,  1298,  1299,  1300,  1301,  1302,  1303,  1304,
    1305,  1306,   408,  1307,   410,   411,   412,   413,   414,   415,
     416,     0,     0,   417,  1308,   419,   420,   421,     0,   422,
     423,   424,  1309,  1310,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,  1311,   444,  1312,   446,   447,   448,   449,   450,
     451,   452,   453,   454,  1313,   456,  1314,   457,   458,   459,
     460,  1315,  1316,   462,  1317,   464,   465,   466,     0,   467,
     468,   469,     0,     0,  1318,   471,   472,     0,     0,   473,
     474,   475,   476,   477,   478,  1319,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,  1320,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,  1321,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,   535,   536,  1322,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,   551,   552,  1323,   553,   554,   555,   556,   557,
     558,   559,   560,  1324,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
    1325,   578,     0,   579,   580,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,  1326,  1327,     0,     0,   591,
     592,  1328,   594,  1329,  1330,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,  1331,   605,   606,   607,   608,
     609,  1332,     0,   610,   611,   612,   613,   614,   615,  1333,
       0,   617,   618,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   629,   630,  1334,
    1335,  1336,  1337,   635,  1338,  1339,  1340,  1341,   640,   641,
     642,   643,  1342,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1343,  1344,     0,     0,     0,
       0,     0,     0,     0,  1346,  3314,   234,     0,  1264,   710,
       0,  1265,  1266,  1267,   771,  1268,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1269,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1270,   260,  1271,  1272,
       0,   263,   264,   265,   266,   267,   268,   269,  1273,  1274,
     270,   271,  1275,  1276,   274,     0,   275,   276,   277,   278,
    1277,     0,  1278,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,  1279,  1280,  1281,
    1282,  1283,  1284,  1285,   303,   304,   305,   306,   307,   308,
    1286,  1287,   311,  1288,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   886,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
    1289,   342,   343,   344,   345,  1290,  1291,   347,     0,   348,
     349,   350,  1292,   352,     0,   353,     0,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,  1293,     0,
    1294,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,   385,   386,   387,   388,   389,   390,
    1295,  1296,     0,  1297,     0,   394,   395,   396,   397,   398,
    1298,  1299,  1300,  1301,  1302,  1303,  1304,  1305,  1306,   408,
    1307,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,  1308,   419,   420,   421,     0,   422,   423,   424,  1309,
    1310,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,  1311,
     444,  1312,   446,   447,   448,   449,   450,   451,   452,   453,
     454,  1313,   456,  1314,   457,   458,   459,   460,  1315,  1316,
     462,  1317,   464,   465,   466,     0,   467,   468,   469,     0,
       0,  1318,   471,   472,     0,     0,   473,   474,   475,   476,
     477,   478,  1319,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,  1320,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,  1321,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,   535,   536,  1322,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,  1323,   553,   554,   555,   556,   557,   558,   559,   560,
    1324,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,  1325,   578,     0,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,  1326,  1327,     0,     0,   591,   592,  1328,   594,
    1329,  1330,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,  1331,   605,   606,   607,   608,   609,  1332,     0,
     610,   611,   612,   613,   614,   615,  1333,     0,   617,   618,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,  1334,  1335,  1336,  1337,
     635,  1338,  1339,  1340,  1341,   640,   641,   642,   643,  1342,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1343,  1344,     0,     0,     0,     0,     0,     0,
       0,  1346,  4735,   234,     0,  1264,   710,     0,  1265,  1266,
    1267,   771,  1268,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1269,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1270,   260,  1271,  1272,     0,   263,   264,
     265,   266,   267,   268,   269,  1273,  1274,   270,   271,  1275,
    1276,   274,     0,   275,   276,   277,   278,  1277,     0,  1278,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,  1279,  1280,  1281,  1282,  1283,  1284,
    1285,   303,   304,   305,   306,   307,   308,  1286,  1287,   311,
    1288,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   886,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,  1289,   342,   343,
     344,   345,  1290,  1291,   347,     0,   348,   349,   350,  1292,
     352,     0,   353,     0,   354,   355,   356,     0,   357,   358,
     359,   360,   361,     0,   362,  1293,     0,  1294,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,   388,   389,   390,  1295,  1296,     0,
    1297,     0,   394,   395,   396,   397,   398,  1298,  1299,  1300,
    1301,  1302,  1303,  1304,  1305,  1306,   408,  1307,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,  1308,   419,
     420,   421,     0,   422,   423,   424,  1309,  1310,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,  1311,   444,  1312,   446,
     447,   448,   449,   450,   451,   452,   453,   454,  1313,   456,
    1314,   457,   458,   459,   460,  1315,  1316,   462,  1317,   464,
     465,   466,     0,   467,   468,   469,     0,     0,  1318,   471,
     472,     0,     0,   473,   474,   475,   476,   477,   478,  1319,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,  1320,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,  1321,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,   535,
     536,  1322,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,   551,   552,  1323,   553,
     554,   555,   556,   557,   558,   559,   560,  1324,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,  1325,   578,     0,   579,   580,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,  1326,
    1327,     0,     0,   591,   592,  1328,   594,  1329,  1330,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,  1331,
     605,   606,   607,   608,   609,  1332,     0,   610,   611,   612,
     613,   614,   615,  1333,     0,   617,   618,   619,   620,   621,
     622,     0,     0,   623,     0,     0,   624,   625,   626,   627,
     628,   629,   630,  1334,  1335,  1336,  1337,   635,  1338,  1339,
    1340,  1341,   640,   641,   642,   643,  1342,     0,     0,     0,
       0,     0,     0,   651,     0,     0,     0,     0,     0,  1343,
    1344,     0,     0,     0,     0,     0,     0,     0,  1346,  4801,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,  4226,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
   -1805,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,   353,     0,   354,   355,     0,     0, -1805,   358,
     359,   360,   361,     0,   362,   363,     0,   364,   365,   366,
       0,   367,   368,   369,   370,   371,     0,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384, -1805,   386,   387,   388,   389,   390,   391,   392,     0,
     393,     0,   394,     0,     0,   397, -1805,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,   418, -1805,
     420,     0,     0,   422,   423,   424,     0,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443, -1805,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,   460,     0,   461,   462,   463,   464,
     465,   466,     0,   467,   468,   469,     0,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,   477,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530, -1805,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,   551,   552,     0,   553,
     554,   555,   556,   557,     0,   559,   560,   561,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,     0,   579,   580,     0,
     581,     0,   583,   584,   585,   586,   587,     0,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,     0,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,     0,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   616,     0,   617,     0,   619,   620,   621,
     622,     0,     0,   623,     0,     0,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,     0,     0,     0,     0,
       0,     0,     0,   878,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1470,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,     0,   879,   260,   880,   881,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   882,
     883,   274,     0,   275,   276,   277,   278,     0,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,     0,     0,     0,   302,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   884,   885,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   886,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,     0,   342,   343,
     344,   345,     0,     0,   347,     0,   348,   349,   350,   887,
     352,     0,   353,     0,   354,   355,   356,     0,   357,   358,
     359,   360,   361,     0,   362,     0,     0,     0,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,  2720,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,  2721,   387,   388,   389,   390,   888,   889,     0,
     890,     0,   394,   395,   396,   397,   398,   891,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,     0,   419,
     420,   421,     0,   422,   423,   424,     0,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   892,   444,   893,   446,
     447,   448,   449,   450,   451,   452,   453,     0,     0,   456,
       0,   457,   458,   459,   460,     0,     0,   462,   894,   464,
     465,   466,     0,   467,   468,   469,     0,     0,   470,   471,
     472,     0,     0,   473,   474,  2723,   476,   477,   478,     0,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,     0,   495,     0,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   895,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,   535,
     536,     0,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,   551,   552,     0,   553,
     554,  2724,   556,   557,   558,   559,   560,   897,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,     0,   578,     0,   579,   580,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   898,
     899,     0,     0,   591,   592,     0,   594,     0,     0,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,     0,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,   900,  2725,   617,   618,   619,   620,   621,
     622,     0,     0,   623,     0,     0,   624,   625,   626,   627,
     628,   629,     0,   878,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   641,   642,   643,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,  2821,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,     0,   879,   260,   880,   881,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   882,
     883,   274,     0,   275,   276,   277,   278,     0,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,     0,     0,     0,   302,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   884,   885,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   886,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,     0,   342,   343,
     344,   345,     0,     0,   347,     0,   348,   349,   350,   887,
     352,     0,   353,     0,   354,   355,   356,     0,   357,   358,
     359,   360,   361,     0,   362,     0,     0,     0,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,  2720,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,  2721,   387,   388,   389,   390,   888,   889,     0,
     890,     0,   394,   395,   396,   397,   398,   891,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,     0,   419,
     420,   421,     0,   422,   423,   424,     0,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   892,   444,   893,   446,
     447,   448,   449,   450,   451,   452,   453,     0,     0,   456,
       0,   457,   458,   459,   460,     0,     0,   462,   894,   464,
     465,   466,     0,   467,   468,   469,     0,     0,   470,   471,
     472,     0,     0,   473,   474,  2723,   476,   477,   478,     0,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,     0,   495,     0,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   895,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,   535,
     536,     0,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,   551,   552,     0,   553,
     554,  2724,   556,   557,   558,   559,   560,   897,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,     0,   578,     0,   579,   580,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   898,
     899,     0,     0,   591,   592,     0,   594,     0,     0,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,     0,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,   900,  2725,   617,   618,   619,   620,   621,
     622,     0,     0,   623,     0,     0,   624,   625,   626,   627,
     628,   629,     0,   234,     0,  1264,   710,     0,  1265,  1266,
    1267,   771,  1268,   641,   642,   643,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1269,     0,  3940,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1270,   260,  1271,  1272,     0,   263,   264,
     265,   266,   267,   268,   269,  1273,  1274,   270,   271,  1275,
    1276,   274,     0,   275,   276,   277,   278,  1277,     0,  1278,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,  1279,  1280,  1281,  1282,  1283,  1284,
    1285,   303,   304,   305,   306,   307,   308,  1286,  1287,   311,
    1288,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   886,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,  1289,   342,   343,
     344,   345,  1290,  1291,   347,     0,   348,   349,   350,  1292,
     352,     0,   353,     0,   354,   355,   356,     0,   357,   358,
     359,   360,   361,     0,   362,  1293,     0,  1294,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,   388,   389,   390,  1295,  1296,     0,
    1297,     0,   394,   395,   396,   397,   398,  1298,  1299,  1300,
    1301,  1302,  1303,  1304,  1305,  1306,   408,  1307,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,  1308,   419,
     420,   421,     0,   422,   423,   424,  1309,  1310,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,  1311,   444,  1312,   446,
     447,   448,   449,   450,   451,   452,   453,   454,  1313,   456,
    1314,   457,   458,   459,   460,  1315,  1316,   462,  1317,   464,
     465,   466,     0,   467,   468,   469,     0,     0,  1318,   471,
     472,     0,     0,   473,   474,   475,   476,   477,   478,  1319,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,  1320,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,  1321,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,  3271,   529,   530,   531,   532,   533,   534,   535,
     536,  1322,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,    40,   548,   549,   550,   551,   552,  1323,   553,
     554,   555,   556,   557,   558,   559,   560,  1324,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,  1325,   578,     0,   579,   580,    44,
     581,   582,   583,   584,   585,   586,   587,     0,   588,  1326,
    1327,     0,     0,   591,   592,  1328,   594,  1329,  1330,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,  1331,
     605,   606,   607,   608,   609,  1332,     0,   610,   611,   612,
     613,   614,  1203,  1333,     0,   617,   618,   619,   620,   621,
     622,     0,     0,   623,     0,    49,   624,   625,   626,   627,
     628,   629,   630,  1334,  1335,  1336,  1337,   635,  1338,  1339,
    1340,  1341,   640,   641,   642,   643,  1342,     0,    50,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1343,
    1344,     0,     0,     0,   234,     0,  1264,   710,  1346,  1265,
    1266,  1267,   771,  1268,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1269,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1270,   260,  1271,  1272,     0,   263,
     264,   265,   266,   267,   268,   269,  1273,  1274,   270,   271,
    1275,  1276,   274,     0,   275,   276,   277,   278,  1277,     0,
    1278,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,  1279,  1280,  1281,  1282,  1283,
    1284,  1285,   303,   304,   305,   306,   307,   308,  1286,  1287,
     311,  1288,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     886,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,  1289,   342,
     343,   344,   345,  1290,  1291,   347,     0,   348,   349,   350,
    1292,   352,     0,   353,     0,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,  1293,     0,  1294,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
       0,   384,   385,   386,   387,   388,   389,   390,  1295,  1296,
       0,  1297,     0,   394,   395,   396,   397,   398,  1298,  1299,
    1300,  1301,  1302,  1303,  1304,  1305,  1306,   408,  1307,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,  1308,
     419,   420,   421,     0,   422,   423,   424,  1309,  1310,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,  1311,   444,  1312,
     446,   447,   448,   449,   450,   451,   452,   453,   454,  1313,
     456,  1314,   457,   458,   459,   460,  1315,  1316,   462,  1317,
     464,   465,   466,     0,   467,   468,   469,     0,     0,  1318,
     471,   472,     0,     0,   473,   474,   475,   476,   477,   478,
    1319,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,  1320,   495,   496,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,  1321,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
     535,   536,  1322,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,    40,   548,   549,   550,   551,   552,  1323,
     553,   554,   555,   556,   557,   558,   559,   560,  1324,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,  1325,   578,     0,   579,   580,
      44,   581,   582,   583,   584,   585,   586,   587,     0,   588,
    1326,  1327,     0,     0,   591,   592,  1328,   594,  1329,  1330,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
    1331,   605,   606,   607,   608,   609,  1332,     0,   610,   611,
     612,   613,   614,  1203,  1333,     0,   617,   618,   619,   620,
     621,   622,     0,     0,   623,     0,    49,   624,   625,   626,
     627,   628,   629,   630,  1334,  1335,  1336,  1337,   635,  1338,
    1339,  1340,  1341,   640,   641,   642,   643,  1342,     0,    50,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1343,  1344,     0,     0,     0,   234,     0,  1264,   710,  1346,
    1265,  1266,  1267,   771,  1268,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,  1269,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1270,   260,  1271,  1272,  3320,
     263,   264,   265,   266,   267,   268,   269,  1273,  1274,   270,
     271,  1275,  1276,   274,     0,   275,   276,   277,   278,  1277,
       0,  1278,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,  1279,  1280,  1281,  1282,
    1283,  1284,  1285,   303,   304,   305,   306,   307,   308,  1286,
    1287,   311,  1288,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   886,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,  1289,
     342,   343,   344,   345,  1290,  1291,   347,     0,   348,   349,
     350,  1292,   352,     0,   353,     0,   354,   355,   356,  3321,
     357,   358,   359,   360,   361,     0,   362,  1293,     0,  1294,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,   388,   389,   390,  1295,
    1296,     0,  1297,     0,   394,   395,   396,   397,   398,  1298,
    1299,  1300,  1301,  1302,  1303,  1304,  1305,  1306,   408,  1307,
     410,   411,   412,   413,   414,   415,   416,     0,  3322,   417,
    1308,   419,   420,   421,     0,   422,   423,   424,  1309,  1310,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,  1311,   444,
    1312,   446,   447,   448,   449,   450,   451,   452,   453,   454,
    1313,   456,  1314,   457,   458,   459,   460,  1315,  1316,   462,
    1317,   464,   465,   466,     0,   467,   468,   469,     0,     0,
    1318,   471,   472,     0,     0,   473,   474,   475,   476,   477,
     478,  1319,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,  1320,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,  1321,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,   535,   536,  1322,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,   551,   552,
    1323,   553,   554,   555,   556,   557,   558,   559,   560,  1324,
     562,     0,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,  1325,   578,     0,   579,
     580,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,  1326,  1327,     0,  3323,   591,   592,  1328,   594,  1329,
    1330,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,  1331,   605,   606,   607,   608,   609,  1332,     0,   610,
     611,   612,   613,   614,   615,  1333,     0,   617,   618,   619,
     620,   621,   622,     0,     0,   623,     0,     0,   624,   625,
     626,   627,   628,   629,   630,  1334,  1335,  1336,  1337,   635,
    1338,  1339,  1340,  1341,   640,   641,   642,   643,  1342,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1343,  1344,     0,     0,     0,   234,     0,  1264,   710,
    1346,  1265,  1266,  1267,   771,  1268,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243, -2214,   244,   245,   246,     0,     0,     0, -2214,
    1269,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1270,   260,  1271,  1272,
       0,   263,   264,   265,   266,   267,   268,   269,  1273,  1274,
     270,   271,  1275,  1276,   274,     0,   275,   276,   277,   278,
    1277,     0,  1278,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,  1279,  1280,  1281,
    1282,  1283,  1284,  1285,   303,   304,   305,   306,   307,   308,
    1286,  1287,   311,  1288,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   886,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
    1289,   342,   343,   344,   345,  1290,  1291,   347,     0,   348,
     349,   350,  1292,   352,     0,   353,     0,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,  1293,     0,
    1294,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,   385,   386,   387,   388,   389,   390,
    1295,  1296,     0,  1297,     0,   394,   395,   396,   397,   398,
    1298,  1299,  1300,  1301,  1302,  1303,  1304,  1305,  1306,   408,
    1307,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,  1308,   419,   420,   421,     0,   422,   423,   424,  1309,
    1310,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,  1311,
     444,  1312,   446,   447,   448,   449,   450,   451,   452,   453,
     454,  1313,   456,  1314,   457,   458,   459,   460,  1315,  1316,
     462,  1317,   464,   465,   466,     0,   467,   468,   469,     0,
       0,  1318,   471,   472,     0,     0,   473,   474,   475,   476,
     477,   478,  1319,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,  1320,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,  1321,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,   535,   536,  1322,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,  1323,   553,   554,   555,   556,   557,   558,   559,   560,
    1324,   562, -2214,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,  1325,   578,     0,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,  1326,  1327,     0,     0,   591,   592,  1328,   594,
    1329,  1330,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,  1331,   605,   606,   607,   608,   609,  1332,     0,
     610,   611,   612,   613,   614,   615,  1333,     0,   617,   618,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,  1334,  1335,  1336,  1337,
     635,  1338,  1339,  1340,  1341,   640,   641,   642,   643,  1342,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1343,  1344,     0,     0,     0,   234,     0,  1264,
     710,  1346,  1265,  1266,  1267,   771,  1268,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243, -2212,   244,   245,   246,     0,     0,     0,
   -2212,  1269,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1270,   260,  1271,
    1272,     0,   263,   264,   265,   266,   267,   268,   269,  1273,
    1274,   270,   271,  1275,  1276,   274,     0,   275,   276,   277,
     278,  1277,     0,  1278,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,  1279,  1280,
    1281,  1282,  1283,  1284,  1285,   303,   304,   305,   306,   307,
     308,  1286,  1287,   311,  1288,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   886,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   337,   338,   339,
     340,  1289,   342,   343,   344,   345,  1290,  1291,   347,     0,
     348,   349,   350,  1292,   352,     0,   353,     0,   354,   355,
     356,     0,   357,   358,   359,   360,   361,     0,   362,  1293,
       0,  1294,   365,   366,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,   388,   389,
     390,  1295,  1296,     0,  1297,     0,   394,   395,   396,   397,
     398,  1298,  1299,  1300,  1301,  1302,  1303,  1304,  1305,  1306,
     408,  1307,   410,   411,   412,   413,   414,   415,   416,     0,
       0,   417,  1308,   419,   420,   421,     0,   422,   423,   424,
    1309,  1310,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
    1311,   444,  1312,   446,   447,   448,   449,   450,   451,   452,
     453,   454,  1313,   456,  1314,   457,   458,   459,   460,  1315,
    1316,   462,  1317,   464,   465,   466,     0,   467,   468,   469,
       0,     0,  1318,   471,   472,     0,     0,   473,   474,   475,
     476,   477,   478,  1319,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,  1320,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,  1321,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,   535,   536,  1322,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
     551,   552,  1323,   553,   554,   555,   556,   557,   558,   559,
     560,  1324,   562, -2212,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,  1325,   578,
       0,   579,   580,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,  1326,  1327,     0,     0,   591,   592,  1328,
     594,  1329,  1330,   596,   597,   598,   599,   600,   601,   602,
     603,   604,     0,  1331,   605,   606,   607,   608,   609,  1332,
       0,   610,   611,   612,   613,   614,   615,  1333,     0,   617,
     618,   619,   620,   621,   622,     0,     0,   623,     0,     0,
     624,   625,   626,   627,   628,   629,   630,  1334,  1335,  1336,
    1337,   635,  1338,  1339,  1340,  1341,   640,   641,   642,   643,
    1342,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1343,  1344,     0,     0,     0,   234,     0,
    1264,   710,  1346,  1265,  1266,  1267,   771,  1268,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1269,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1270,   260,
    1271,  1272,     0,   263,   264,   265,   266,   267,   268,   269,
    1273,  1274,   270,   271,  1275,  1276,   274,     0,   275,   276,
     277,   278,  1277,     0,  1278,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,  1279,
    1280,  1281,  1282,  1283,  1284,  1285,   303,   304,   305,   306,
     307,   308,  1286,  1287,   311,  1288,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   886,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,  1289,   342,   343,   344,   345,  1290,  1291,   347,
       0,   348,   349,   350,  1292,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
    1293,     0,  1294,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,   385,   386,   387,   388,
     389,   390,  1295,  1296,     0,  1297,     0,   394,   395,   396,
     397,   398,  1298,  1299,  1300,  1301,  1302,  1303,  1304,  1305,
    1306,   408,  1307,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,  1308,   419,   420,   421,     0,   422,   423,
     424,  1309,  1310,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,  1311,   444,  1312,   446,   447,   448,   449,   450,   451,
     452,   453,   454,  1313,   456,  1314,   457,   458,   459,   460,
    1315,  1316,   462,  1317,   464,   465,   466,     0,   467,   468,
     469,     0,     0,  1318,   471,   472,     0,     0,   473,   474,
     475,   476,   477,   478,  1319,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
    1320,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,  1321,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,   535,   536,  1322,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,  1323,   553,   554,   555,   556,   557,   558,
     559,   560,  1324,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,  1325,
     578,     0,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,  1326,  1327,     0,     0,   591,   592,
    1328,   594,  1329,  1330,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,  1331,   605,   606,   607,   608,   609,
    1332,     0,   610,   611,   612,   613,   614,   615,  1333,     0,
     617,   618,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,  1334,  1335,
    1336,  1337,   635,  1338,  1339,  1340,  1341,   640,   641,   642,
     643,  1342,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1343,  1344,     0,     0,     0,     0,
       0,  2050,  3245,  1346,   234,     0,  1264,   710,     0,  1265,
    1266,  1267,   771,  1268,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1269,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1270,   260,  1271,  1272,     0,   263,
     264,   265,   266,   267,   268,   269,  1273,  1274,   270,   271,
    1275,  1276,   274,     0,   275,   276,   277,   278,  1277,     0,
    1278,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,  1279,  1280,  1281,  1282,  1283,
    1284,  1285,   303,   304,   305,   306,   307,   308,  1286,  1287,
     311,  1288,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     886,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,  1289,   342,
     343,   344,   345,  1290,  1291,   347,     0,   348,   349,   350,
    1292,   352,     0,   353,     0,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,  1293,     0,  1294,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
       0,   384,   385,   386,   387,   388,   389,   390,  1295,  1296,
       0,  1297,     0,   394,   395,   396,   397,   398,  1298,  1299,
    1300,  1301,  1302,  1303,  1304,  1305,  1306,   408,  1307,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,  1308,
     419,   420,   421,     0,   422,   423,   424,  1309,  1310,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,  1311,   444,  1312,
     446,   447,   448,   449,   450,   451,   452,   453,   454,  1313,
     456,  1314,   457,   458,   459,   460,  1315,  1316,   462,  1317,
     464,   465,   466,     0,   467,   468,   469,     0,     0,  1318,
     471,   472,     0,     0,   473,   474,   475,   476,   477,   478,
    1319,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,  1320,   495,   496,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,  1321,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
     535,   536,  1322,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,   551,   552,  1323,
     553,   554,   555,   556,   557,   558,   559,   560,  1324,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,  1325,   578,     0,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
    1326,  1327,     0,     0,   591,   592,  1328,   594,  1329,  1330,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
    1331,   605,   606,   607,   608,   609,  1332,     0,   610,   611,
     612,   613,   614,   615,  1333,     0,   617,   618,   619,   620,
     621,   622,     0,     0,   623,     0,     0,   624,   625,   626,
     627,   628,   629,   630,  1334,  1335,  1336,  1337,   635,  1338,
    1339,  1340,  1341,   640,   641,   642,   643,  1342,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1343,  1344,  1345,     0,     0,   234,     0,  1264,   710,  1346,
    1265,  1266,  1267,   771,  1268,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,  2687,   244,   245,   246,     0,     0,     0,     0,  1269,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1270,   260,  1271,  1272,     0,
     263,   264,   265,   266,   267,   268,   269,  1273,  1274,   270,
     271,  1275,  1276,   274,     0,   275,   276,   277,   278,  1277,
       0,  1278,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,  1279,  1280,  1281,  1282,
    1283,  1284,  1285,   303,   304,   305,   306,   307,   308,  1286,
    1287,   311,  1288,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   886,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,  1289,
     342,   343,   344,   345,  1290,  1291,   347,     0,   348,   349,
     350,  1292,   352,     0,   353,     0,   354,   355,   356,     0,
     357,   358,   359,   360,   361,     0,   362,  1293,     0,  1294,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,   388,   389,   390,  1295,
    1296,     0,  1297,     0,   394,   395,   396,   397,   398,  1298,
    1299,  1300,  1301,  1302,  1303,  1304,  1305,  1306,   408,  1307,
     410,   411,   412,   413,   414,   415,   416,     0,     0,   417,
    1308,   419,   420,   421,     0,   422,   423,   424,  1309,  1310,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,  1311,   444,
    1312,   446,   447,   448,   449,   450,   451,   452,   453,   454,
    1313,   456,  1314,   457,   458,   459,   460,  1315,  1316,   462,
    1317,   464,   465,   466,     0,   467,   468,   469,     0,     0,
    1318,   471,   472,     0,     0,   473,   474,   475,   476,   477,
     478,  1319,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,  1320,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,  1321,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,   535,   536,  1322,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,   551,   552,
    1323,   553,   554,   555,   556,   557,   558,   559,   560,  1324,
     562,     0,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,  1325,   578,     0,   579,
     580,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,  1326,  1327,     0,     0,   591,   592,  1328,   594,  1329,
    1330,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,  1331,   605,   606,   607,   608,   609,  1332,     0,   610,
     611,   612,   613,   614,   615,  1333,     0,   617,   618,   619,
     620,   621,   622,     0,     0,   623,     0,     0,   624,   625,
     626,   627,   628,   629,   630,  1334,  1335,  1336,  1337,   635,
    1338,  1339,  1340,  1341,   640,   641,   642,   643,  1342,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1343,  1344,     0,     0,     0,   234,     0,  1264,   710,
    1346,  1265,  1266,  1267,   771,  1268,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1269,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1270,   260,  1271,  1272,
       0,   263,   264,   265,   266,   267,   268,   269,  1273,  1274,
     270,   271,  1275,  1276,   274,     0,   275,   276,   277,   278,
    1277,     0,  1278,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,  1279,  1280,  1281,
    1282,  1283,  1284,  1285,   303,   304,   305,   306,   307,   308,
    1286,  1287,   311,  1288,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   886,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
    1289,   342,   343,   344,   345,  1290,  1291,   347,     0,   348,
     349,   350,  1292,   352,     0,   353,     0,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,  1293,     0,
    1294,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,   385,   386,   387,   388,   389,   390,
    1295,  1296,     0,  1297,     0,   394,   395,   396,   397,   398,
    1298,  1299,  1300,  1301,  1302,  1303,  1304,  1305,  1306,   408,
    1307,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,  1308,   419,   420,   421,     0,   422,   423,   424,  1309,
    1310,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,  1311,
     444,  1312,   446,   447,   448,   449,   450,   451,   452,   453,
     454,  1313,   456,  1314,   457,   458,   459,   460,  1315,  1316,
     462,  1317,   464,   465,   466,     0,   467,   468,   469,     0,
       0,  1318,   471,   472,     0,     0,   473,   474,   475,   476,
     477,   478,  1319,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,  1320,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,  1321,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,   535,   536,  1322,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,  1323,   553,   554,   555,   556,   557,   558,   559,   560,
    1324,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,  1325,   578,     0,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,  1326,  1327,     0,     0,   591,   592,  1328,   594,
    1329,  1330,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,  1331,   605,   606,   607,   608,   609,  1332,     0,
     610,   611,   612,   613,   614,   615,  1333,  3819,   617,   618,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,  1334,  1335,  1336,  1337,
     635,  1338,  1339,  1340,  1341,   640,   641,   642,   643,  1342,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1343,  1344,     0,     0,     0,   234,     0,  1264,
     710,  1346,  1265,  1266,  1267,   771,  1268,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,  1269,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1270,   260,  1271,
    1272,     0,   263,   264,   265,   266,   267,   268,   269,  1273,
    1274,   270,   271,  1275,  1276,   274,     0,   275,   276,   277,
     278,  1277,     0,  1278,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,  1279,  1280,
    1281,  1282,  1283,  1284,  1285,   303,   304,   305,   306,   307,
     308,  1286,  1287,   311,  1288,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   886,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   337,   338,   339,
     340,  1289,   342,   343,   344,   345,  1290,  1291,   347,     0,
     348,   349,   350,  1292,   352,     0,   353,     0,   354,   355,
     356,  3321,   357,   358,   359,   360,   361,     0,   362,  1293,
       0,  1294,   365,   366,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,   388,   389,
     390,  1295,  1296,     0,  1297,     0,   394,   395,   396,   397,
     398,  1298,  1299,  1300,  1301,  1302,  1303,  1304,  1305,  1306,
     408,  1307,   410,   411,   412,   413,   414,   415,   416,     0,
       0,   417,  1308,   419,   420,   421,     0,   422,   423,   424,
    1309,  1310,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
    1311,   444,  1312,   446,   447,   448,   449,   450,   451,   452,
     453,   454,  1313,   456,  1314,   457,   458,   459,   460,  1315,
    1316,   462,  1317,   464,   465,   466,     0,   467,   468,   469,
       0,     0,  1318,   471,   472,     0,     0,   473,   474,   475,
     476,   477,   478,  1319,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,  1320,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,  1321,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,   535,   536,  1322,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
     551,   552,  1323,   553,   554,   555,   556,   557,   558,   559,
     560,  1324,   562,     0,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,  1325,   578,
       0,   579,   580,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,  1326,  1327,     0,     0,   591,   592,  1328,
     594,  1329,  1330,   596,   597,   598,   599,   600,   601,   602,
     603,   604,     0,  1331,   605,   606,   607,   608,   609,  1332,
       0,   610,   611,   612,   613,   614,   615,  1333,     0,   617,
     618,   619,   620,   621,   622,     0,     0,   623,     0,     0,
     624,   625,   626,   627,   628,   629,   630,  1334,  1335,  1336,
    1337,   635,  1338,  1339,  1340,  1341,   640,   641,   642,   643,
    1342,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1343,  1344,     0,     0,     0,   234,     0,
    1264,   710,  1346,  1265,  1266,  1267,   771,  1268,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1269,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1270,   260,
    1271,  1272,     0,   263,   264,   265,   266,   267,   268,   269,
    1273,  1274,   270,   271,  1275,  1276,   274,     0,   275,   276,
     277,   278,  1277,     0,  1278,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,  1279,
    1280,  1281,  1282,  1283,  1284,  1285,   303,   304,   305,   306,
     307,   308,  1286,  1287,   311,  1288,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   886,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,  1289,   342,   343,   344,   345,  1290,  1291,   347,
       0,   348,   349,   350,  1292,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
    1293,     0,  1294,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,   385,   386,   387,   388,
     389,   390,  1295,  1296,     0,  1297,     0,   394,   395,   396,
     397,   398,  1298,  1299,  1300,  1301,  1302,  1303,  1304,  1305,
    1306,   408,  1307,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,  1308,   419,   420,   421,     0,   422,   423,
     424,  1309,  1310,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,  1311,   444,  1312,   446,   447,   448,   449,   450,   451,
     452,   453,   454,  1313,   456,  1314,   457,   458,   459,   460,
    1315,  1316,   462,  1317,   464,   465,   466,     0,   467,   468,
     469,     0,     0,  1318,   471,   472,     0,     0,   473,   474,
     475,   476,   477,   478,  1319,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
    1320,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,  1321,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,   535,   536,  1322,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,  1323,   553,   554,   555,   556,   557,   558,
     559,   560,  1324,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,  1325,
     578,     0,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,  1326,  1327,  3377,     0,   591,   592,
    1328,   594,  1329,  1330,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,  1331,   605,   606,   607,   608,   609,
    1332,     0,   610,   611,   612,   613,   614,   615,  1333,     0,
     617,   618,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,  1334,  1335,
    1336,  1337,   635,  1338,  1339,  1340,  1341,   640,   641,   642,
     643,  1342,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1343,  1344,     0,     0,     0,   234,
       0,  1264,   710,  1346,  1265,  1266,  1267,   771,  1268,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1269,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1270,
     260,  1271,  1272,     0,   263,   264,   265,   266,   267,   268,
     269,  1273,  1274,   270,   271,  1275,  1276,   274,     0,   275,
     276,   277,   278,  1277,     0,  1278,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
    1279,  1280,  1281,  1282,  1283,  1284,  1285,   303,   304,   305,
     306,   307,   308,  1286,  1287,   311,  1288,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   886,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,  1289,   342,   343,   344,   345,  1290,  1291,
     347,     0,   348,   349,   350,  1292,   352,     0,   353,     0,
     354,   355,   356,     0,   357,   358,   359,   360,   361,     0,
     362,  1293,     0,  1294,   365,   366,     0,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
     388,   389,   390,  1295,  1296,     0,  1297,     0,   394,   395,
     396,   397,   398,  1298,  1299,  1300,  1301,  1302,  1303,  1304,
    1305,  1306,   408,  1307,   410,   411,   412,   413,   414,   415,
     416,     0,     0,   417,  1308,   419,   420,   421,     0,   422,
     423,   424,  1309,  1310,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,  1311,   444,  1312,   446,   447,   448,   449,   450,
     451,   452,   453,   454,  1313,   456,  1314,   457,   458,   459,
     460,  1315,  1316,   462,  1317,   464,   465,   466,     0,   467,
     468,   469,     0,     0,  1318,   471,   472,     0,     0,   473,
     474,   475,   476,   477,   478,  1319,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,  1320,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,  1321,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,   535,   536,  1322,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,   551,   552,  1323,   553,   554,   555,   556,   557,
     558,   559,   560,  1324,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
    1325,   578,     0,   579,   580,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,  1326,  1327,     0,     0,   591,
     592,  1328,   594,  1329,  1330,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,  1331,   605,   606,   607,   608,
     609,  1332,     0,   610,   611,   612,   613,   614,   615,  1333,
       0,   617,   618,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   629,   630,  1334,
    1335,  1336,  1337,   635,  1338,  1339,  1340,  1341,   640,   641,
     642,   643,  1342,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1343,  1344,     0,     0,     0,
     234,     0,  1264,   710,  1346,  1265,  1266,  1267,   771,  1268,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1269,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1270,   260,  1271,  1272,     0,   263,   264,   265,   266,   267,
     268,   269,  1273,  1274,   270,   271,  1275,  1276,   274,     0,
     275,   276,   277,   278,  1277,     0,  1278,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,  1279,  1280,  1281,  1282,  1283,  1284,  1285,   303,   304,
     305,   306,   307,   308,  1286,  1287,   311,  1288,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   886,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,  1289,   342,   343,   344,   345,  1290,
    1291,   347,     0,   348,   349,   350,  1292,   352,     0,   353,
       0,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,  1293,     0,  1294,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,   385,   386,
     387,   388,   389,   390,  1295,  1296,     0,  1297,     0,   394,
     395,   396,   397,   398,  1298,  1299,  1300,  1301,  1302,  1303,
    1304,  1305,  1306,   408,  1307,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,  1308,   419,   420,   421,     0,
     422,   423,   424,  1309,  1310,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,  1311,   444,  1312,   446,   447,   448,   449,
     450,   451,   452,   453,   454,  1313,   456,  1314,   457,   458,
     459,   460,  1315,  1316,   462,  1317,   464,   465,   466,     0,
     467,   468,   469,     0,     0,  1318,   471,   472,     0,     0,
     473,   474,   475,   476,   477,   478,  1319,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,  1320,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
    1321,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,   535,   536,  1322,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,   551,   552,  1323,   553,   554,   555,   556,
     557,   558,   559,   560,  1324,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,  1325,   578,     0,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,  1326,  1327,     0,     0,
     591,   592,  1328,   594,  1329,  1330,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,  1331,   605,   606,   607,
     608,   609,  1332,     0,   610,   611,   612,   613,   614,   615,
    1333,     0,   617,   618,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   629,   630,
    1334,  1335,  1336,  1337,   635,  1338,  1339,  1340,  1341,   640,
     641,   642,   643,  1342,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2690,  2691,     0,     0,
       0,   234,     0,  3496,   710,  1346,  1265,  1266,  1267,   771,
    1268,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,  1269,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1270,   260,  1271,  1272,     0,   263,   264,   265,   266,
     267,   268,   269,  1273,  1274,   270,   271,  1275,  1276,   274,
       0,   275,   276,   277,   278,  1277,     0,  1278,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,  1279,  1280,  1281,  1282,  1283,  1284,  1285,   303,
     304,   305,   306,   307,   308,  1286,  1287,   311,  1288,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   886,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,  1289,   342,   343,   344,   345,
    1290,  1291,   347,     0,   348,   349,   350,  1292,   352,     0,
     353,     0,   354,   355,   356,     0,   357,   358,   359,   360,
     361,     0,   362,  1293,     0,  1294,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,   388,   389,   390,  1295,  1296,     0,  1297,     0,
     394,   395,   396,   397,   398,  1298,  1299,  1300,  1301,  1302,
    1303,  1304,  1305,  1306,   408,  1307,   410,   411,   412,   413,
     414,   415,   416,     0,     0,   417,  1308,   419,   420,   421,
       0,   422,   423,   424,  1309,  1310,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,  1311,   444,  1312,   446,   447,   448,
     449,   450,   451,   452,   453,   454,  1313,   456,  1314,   457,
     458,   459,   460,  1315,  1316,   462,  1317,   464,   465,   466,
       0,   467,   468,   469,     0,     0,  1318,   471,   472,     0,
       0,   473,   474,   475,   476,   477,   478,  1319,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,  1320,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,  1321,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,   535,   536,  1322,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,   551,   552,  1323,   553,   554,   555,
     556,   557,   558,   559,   560,  1324,   562,     0,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,  1325,   578,     0,   579,   580,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,  1326,  1327,     0,
       0,   591,   592,  1328,   594,  1329,  1330,   596,   597,   598,
     599,   600,   601,   602,   603,   604,     0,  1331,   605,   606,
     607,   608,   609,  1332,     0,   610,   611,   612,   613,   614,
     615,  1333,     0,   617,   618,   619,   620,   621,   622,     0,
       0,   623,     0,     0,   624,   625,   626,   627,   628,   629,
     630,  1334,  1335,  1336,  1337,   635,  1338,  1339,  1340,  1341,
     640,   641,   642,   643,  1342,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1343,  1344,     0,
       0,     0,   234,     0,  1264,   710,  1346,  1265,  1266,  1267,
     771,  1268,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1269,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1270,   260,  1271,  1272,     0,   263,   264,   265,
     266,   267,   268,   269,  1273,  1274,   270,   271,  1275,  1276,
     274,     0,   275,   276,   277,   278,  1277,     0,  1278,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,  4857,  1279,  1280,  1281,  1282,  1283,  1284,  1285,
     303,   304,   305,   306,   307,   308,  1286,  1287,   311,  1288,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   886,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,  1289,   342,   343,   344,
     345,  1290,  1291,   347,     0,   348,   349,   350,  1292,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,  1293,     0,  1294,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,     0,   384,
     385,   386,   387,   388,   389,   390,  1295,  1296,     0,  1297,
       0,   394,   395,   396,   397,   398,  1298,  1299,  1300,  1301,
    1302,  1303,  1304,  1305,  1306,   408,  1307,   410,   411,   412,
     413,   414,   415,   416,     0,     0,   417,  1308,   419,   420,
     421,     0,   422,   423,   424,  1309,  1310,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,  1311,   444,  1312,   446,   447,
     448,   449,   450,   451,   452,   453,   454,  1313,   456,  1314,
     457,   458,   459,   460,  1315,  1316,   462,  1317,   464,   465,
     466,     0,   467,   468,   469,     0,     0,  1318,   471,   472,
       0,     0,   473,   474,   475,   476,   477,   478,  1319,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,  1320,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,  1321,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,   535,   536,
    1322,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,   551,   552,  1323,   553,   554,
     555,   556,   557,   558,   559,   560,  1324,   562,     0,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,  1325,   578,     0,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,  1326,  1327,
       0,     0,   591,   592,  1328,   594,  1329,  1330,   596,   597,
     598,   599,   600,   601,   602,   603,   604,     0,  1331,   605,
     606,   607,   608,   609,  1332,     0,   610,   611,   612,   613,
     614,   615,  1333,     0,   617,   618,   619,   620,   621,   622,
       0,     0,   623,     0,     0,   624,   625,   626,   627,   628,
     629,   630,  1334,  1335,  1336,  1337,   635,  1338,  1339,  1340,
    1341,   640,   641,   642,   643,  1342,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1343,  1344,
       0,     0,     0,   234,     0,  1264,   710,  1346,  1265,  1266,
    1267,   771,  1268,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1269,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1270,   260,  1271,  1272,     0,   263,   264,
     265,   266,   267,   268,   269,  1273,  1274,   270,   271,  1275,
    1276,   274,     0,   275,   276,   277,   278,  1277,     0,  1278,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,  1279,  1280,  1281,  1282,  1283,  1284,
    1285,   303,   304,   305,   306,   307,   308,  1286,  1287,   311,
    1288,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   886,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,  1289,   342,   343,
     344,   345,  1290,  1291,   347,     0,   348,   349,   350,  1292,
     352,     0,   353,     0,   354,   355,   356,     0,   357,   358,
     359,   360,   361,     0,   362,  1293,     0,  1294,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,   388,   389,   390,  1295,  1296,     0,
    1297,     0,   394,   395,   396,   397,   398,  1298,  1299,  1300,
    1301,  1302,  1303,  1304,  1305,  1306,   408,  1307,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,  1308,   419,
     420,   421,     0,   422,   423,   424,  1309,  1310,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,  1311,   444,  1312,   446,
     447,   448,   449,   450,   451,   452,   453,   454,  1313,   456,
    1314,   457,   458,   459,   460,  1315,  1316,   462,  1317,   464,
     465,   466,     0,   467,   468,   469,     0,     0,  1318,   471,
     472,     0,     0,   473,   474,   475,   476,   477,   478,  1319,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,  1320,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,  1321,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,   535,
     536,  1322,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,   551,   552,  1323,   553,
     554,   555,   556,   557,   558,   559,   560,  1324,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,  1325,   578,     0,   579,   580,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,  1326,
    1327,     0,     0,   591,   592,  1328,   594,  1329,  1330,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,  1331,
     605,   606,   607,   608,   609,  1332,     0,   610,   611,   612,
     613,   614,   615,  1333,     0,   617,   618,   619,   620,   621,
     622,     0,     0,   623,     0,     0,   624,   625,   626,   627,
     628,   629,  5245,  1334,  1335,  1336,  1337,   635,  1338,  1339,
    1340,  1341,   640,   641,   642,   643,  1342,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1343,
    1344,     0,     0,     0,   234,     0,  1264,   710,  1346,  1265,
    1266,  1267,   771,  1268,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1269,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1270,   260,  1271,  1272,     0,   263,
     264,   265,   266,   267,   268,   269,  1273,  1274,   270,   271,
    1275,  1276,   274,     0,   275,   276,   277,   278,  1277,     0,
    1278,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,  1279,  1280,  1281,  1282,  1283,
    1284,  1285,   303,   304,   305,   306,   307,   308,  1286,  1287,
     311,  1288,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     886,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,  1289,   342,
     343,   344,   345,  1290,  1291,   347,     0,   348,   349,   350,
    1292,   352,     0,   353,     0,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,  1293,     0,  1294,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
       0,   384,   385,   386,   387,   388,   389,   390,  1295,  1296,
       0,  1297,     0,   394,   395,   396,   397,   398,  1298,  1299,
    1300,  1301,  1302,  1303,  1304,  1305,  1306,   408,  1307,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,  1308,
     419,   420,   421,     0,   422,   423,   424,  1309,  1310,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,  1311,   444,  1312,
     446,   447,   448,   449,   450,   451,   452,  5257,   454,  1313,
     456,  1314,   457,   458,   459,   460,  1315,  1316,   462,  1317,
     464,   465,   466,     0,   467,   468,   469,     0,     0,  1318,
     471,   472,     0,     0,   473,   474,   475,   476,   477,   478,
    1319,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,  1320,   495,   496,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,  1321,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
     535,   536,  1322,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,   551,   552,  1323,
     553,   554,   555,   556,   557,   558,   559,   560,  1324,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,  1325,   578,     0,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
    1326,  1327,     0,     0,   591,   592,  1328,   594,  1329,  1330,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
    1331,   605,   606,   607,   608,   609,  1332,     0,   610,   611,
     612,   613,   614,   615,  1333,     0,   617,   618,   619,   620,
     621,   622,     0,     0,   623,     0,     0,   624,   625,   626,
     627,   628,   629,   630,  1334,  1335,  1336,  1337,   635,  1338,
    1339,  1340,  1341,   640,   641,   642,   643,  1342,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1343,  1344,     0,     0,     0,   234,     0,  1264,   710,  1346,
    1265,  1266,  1267,   771,  1268,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,  1269,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1270,   260,  1271,  1272,     0,
     263,   264,   265,   266,   267,   268,   269,  1273,  1274,   270,
     271,  1275,  1276,   274,     0,   275,   276,   277,   278,  1277,
       0,  1278,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,  5596,   301,  1279,  1280,  1281,  1282,
    1283,  1284,  1285,   303,   304,   305,   306,   307,   308,  1286,
    1287,   311,  1288,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   886,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,  1289,
     342,   343,   344,   345,  1290,  1291,   347,     0,   348,   349,
     350,  1292,   352,     0,   353,     0,   354,   355,   356,     0,
     357,   358,   359,   360,   361,     0,   362,  1293,     0,  5597,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,   388,   389,   390,  1295,
    1296,     0,  1297,     0,   394,   395,   396,   397,   398,  1298,
    1299,  1300,  1301,  1302,  1303,  1304,  1305,  1306,   408,  1307,
     410,   411,   412,   413,   414,   415,   416,     0,     0,   417,
    1308,   419,   420,   421,     0,   422,   423,   424,  1309,  1310,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,  1311,   444,
    1312,   446,   447,   448,   449,   450,   451,   452,   453,   454,
    1313,   456,  1314,   457,   458,   459,   460,  1315,  1316,   462,
    1317,   464,   465,   466,     0,   467,   468,   469,     0,     0,
    1318,   471,   472,     0,     0,   473,   474,   475,   476,   477,
     478,  1319,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,  1320,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,  1321,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
    5598,   535,   536,  1322,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,   551,   552,
    1323,   553,   554,   555,   556,   557,   558,   559,   560,  1324,
     562,     0,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,  1325,   578,     0,   579,
     580,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,  1326,  1327,     0,     0,   591,   592,  1328,   594,  1329,
    1330,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,  1331,   605,   606,   607,   608,   609,  1332,     0,   610,
     611,   612,   613,   614,   615,  1333,     0,   617,   618,   619,
     620,   621,   622,     0,     0,   623,     0,     0,   624,   625,
     626,   627,   628,   629,   630,  1334,  1335,  1336,  1337,   635,
    1338,  1339,  1340,  1341,   640,   641,   642,   643,  1342,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1343,  1344,     0,     0,     0,   234,     0,  1264,   710,
    5599,  1265,  1266,  1267,   771,  1268,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1269,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,  6000,  1270,   260,  1271,  1272,
       0,   263,   264,   265,   266,   267,   268,   269,  1273,  1274,
     270,   271,  1275,  1276,   274,     0,   275,   276,   277,   278,
    1277,     0,  1278,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,  6001,  1279,  1280,  1281,
    1282,  1283,  1284,  1285,   303,   304,   305,   306,   307,   308,
    1286,  1287,   311,  1288,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   886,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
    1289,   342,   343,   344,   345,  1290,  1291,   347,     0,   348,
     349,   350,  1292,   352,     0,   353,     0,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,  1293,     0,
    1294,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,   385,   386,   387,   388,   389,   390,
    1295,  1296,     0,  1297,     0,   394,   395,   396,   397,   398,
    1298,  1299,  1300,  1301,  1302,  1303,  1304,  1305,  1306,   408,
    1307,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,  1308,   419,   420,   421,     0,   422,   423,   424,  1309,
    1310,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,  1311,
     444,  1312,   446,   447,   448,   449,   450,   451,   452,   453,
     454,  1313,   456,  1314,   457,   458,   459,   460,  1315,  1316,
     462,  1317,   464,   465,   466,     0,   467,   468,   469,     0,
       0,  1318,   471,   472,     0,     0,   473,   474,   475,   476,
     477,   478,  1319,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,  1320,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,  1321,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,   535,   536,  1322,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,  1323,   553,   554,   555,   556,   557,   558,   559,   560,
    1324,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,  1325,   578,     0,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,  1326,  1327,     0,     0,   591,   592,  1328,   594,
    1329,  1330,   596,   597,   598,   599,   600,  6002,   602,   603,
     604,     0,  1331,   605,   606,   607,   608,   609,  1332,     0,
     610,   611,   612,   613,   614,   615,  1333,     0,   617,   618,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,  1334,  1335,  1336,  1337,
     635,  1338,  1339,  1340,  1341,   640,   641,   642,   643,  1342,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1343,  1344,     0,     0,     0,   234,     0,  1264,
     710,  1346,  1265,  1266,  1267,   771,  1268,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,  1269,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1270,   260,  1271,
    1272,     0,   263,   264,   265,   266,   267,   268,   269,  1273,
    1274,   270,   271,  1275,  1276,   274,     0,   275,   276,   277,
     278,  1277,     0,  1278,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,  6001,  1279,  1280,
    1281,  1282,  1283,  1284,  1285,   303,   304,   305,   306,   307,
     308,  1286,  1287,   311,  1288,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   886,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   337,   338,   339,
     340,  1289,   342,   343,   344,   345,  1290,  1291,   347,     0,
     348,   349,   350,  1292,   352,     0,   353,     0,   354,   355,
     356,     0,   357,   358,   359,   360,   361,     0,   362,  1293,
       0,  1294,   365,   366,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,   388,   389,
     390,  1295,  1296,     0,  1297,     0,   394,   395,   396,   397,
     398,  1298,  1299,  1300,  1301,  1302,  1303,  1304,  1305,  1306,
     408,  1307,   410,   411,   412,   413,   414,   415,   416,     0,
       0,   417,  1308,   419,   420,   421,     0,   422,   423,   424,
    1309,  1310,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
    1311,   444,  1312,   446,   447,   448,   449,   450,   451,   452,
     453,   454,  1313,   456,  1314,   457,   458,   459,   460,  1315,
    1316,   462,  1317,   464,   465,   466,     0,   467,   468,   469,
       0,     0,  1318,   471,   472,     0,     0,   473,   474,   475,
     476,   477,   478,  1319,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,  1320,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,  1321,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,   535,   536,  1322,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
     551,   552,  1323,   553,   554,   555,   556,   557,   558,   559,
     560,  1324,   562,     0,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,  1325,   578,
       0,   579,   580,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,  1326,  1327,     0,     0,   591,   592,  1328,
     594,  1329,  1330,   596,   597,   598,   599,   600,  6002,   602,
     603,   604,     0,  1331,   605,   606,   607,   608,   609,  1332,
       0,   610,   611,   612,   613,   614,   615,  1333,     0,   617,
     618,   619,   620,   621,   622,     0,     0,   623,     0,     0,
     624,   625,   626,   627,   628,   629,   630,  1334,  1335,  1336,
    1337,   635,  1338,  1339,  1340,  1341,   640,   641,   642,   643,
    1342,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1343,  1344,     0,     0,     0,   234,     0,
    1264,   710,  1346,  1265,  1266,  1267,   771,  1268,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1269,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1270,   260,
    1271,  1272,     0,   263,   264,   265,   266,   267,   268,   269,
    1273,  1274,   270,   271,  1275,  1276,   274,     0,   275,   276,
     277,   278,  1277,     0,  1278,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,  1279,
    1280,  1281,  1282,  1283,  1284,  1285,   303,   304,   305,   306,
     307,   308,  1286,  1287,   311,  5581,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   886,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,  1289,   342,   343,   344,   345,  1290,  1291,   347,
       0,   348,   349,   350,  1292,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
    1293,     0,  1294,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,   385,   386,   387,   388,
     389,   390,  1295,  1296,     0,  1297,     0,   394,   395,   396,
     397,   398,  1298,  1299,  1300,  1301,  1302,  1303,  1304,  1305,
    1306,   408,  1307,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,  1308,   419,   420,   421,     0,   422,   423,
     424,  1309,  1310,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,  1311,   444,  1312,   446,   447,   448,   449,   450,   451,
     452,   453,   454,  1313,   456,     0,   457,   458,   459,   460,
    1315,  1316,   462,  1317,   464,   465,   466,     0,   467,   468,
     469,     0,     0,  1318,   471,   472,     0,     0,   473,   474,
     475,   476,   477,   478,  1319,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
    1320,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,  1321,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,   535,   536,  3306,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,  1323,   553,   554,   555,   556,   557,   558,
     559,   560,  1324,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,  1325,
     578,     0,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,  1326,  1327,     0,     0,   591,   592,
    1328,   594,  1329,  1330,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,     0,   605,   606,   607,   608,   609,
    1332,     0,   610,   611,   612,   613,   614,   615,  1333,     0,
     617,   618,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,  1334,  1335,
    1336,  1337,   635,  1338,  1339,  1340,  1341,   640,   641,   642,
     643,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3307,  3308,     0,     0,     0,   234,
       0,  1264,   710,  3309,  1265,  1266,  1267,   771,  1268,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1269,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257, -3027,  1270,
     260,  1271,  1272,     0,   263,   264,   265,   266,   267,   268,
     269,  1273,  1274,   270,   271,  1275,  1276,   274,     0,   275,
     276,   277,   278,  1277,     0,  1278,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,  6001,
    1279,  1280,  1281,  1282,  1283,  1284,  1285,   303,   304,   305,
     306,   307,   308,  1286,  1287,   311,  1288,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   886,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,  1289,   342,   343,   344,   345,  1290,  1291,
     347,     0,   348,   349,   350,  1292,   352,     0,   353,     0,
     354,   355,   356,     0,   357,   358,   359,   360,   361,     0,
     362,  1293,     0,  1294,   365,   366,     0,   367,   368,   369,
     370,   371, -3027,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
     388,   389,   390,  1295,  1296,     0,  1297,     0,   394,     0,
       0,   397,   398,  1298,  1299,  1300,  1301,  1302,  1303,  1304,
    1305,  1306,   408,  1307,   410,   411,   412,   413,   414,   415,
     416,     0,     0,   417,  1308,   419,   420, -3027,     0,   422,
     423,   424,  1309,  1310,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,  1311,   444,  1312,   446,   447,   448,   449,   450,
     451,   452,   453,   454,  1313,   456,  1314,   457,   458,     0,
     460,  1315,  1316,   462,  1317,   464,   465,   466,     0,   467,
     468,   469,     0,     0,  1318,   471,   472,     0,     0,   473,
     474,   475,   476,   477,   478,  1319,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,  1320,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,  1321,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,   535,   536,  1322,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,   551,   552,  1323,   553,   554,   555,   556,   557,
   -3027,   559,   560,  1324,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
    1325,   578,     0,   579,   580,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,  1326,  1327,     0,     0,   591,
     592,  1328,   594,  1329,  1330,   596,   597,   598,   599,   600,
    6002,   602,   603,   604,     0,  1331,   605,   606,   607,   608,
     609,  1332,     0,   610,   611,   612,   613,   614,   615,  1333,
       0,   617,   618,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   629,   630,  1334,
    1335,  1336,  1337,   635,  1338,  1339,  1340,  1341,   640,   641,
     642,   643, -3027,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1343,  1344,     0,     0,     0,
     234,     0,  1264,   710,  1346,  1265,  1266,  1267,   771,  1268,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1269,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1270,   260,  1271,  1272,     0,   263,   264,   265,   266,   267,
     268,   269,  1273,  1274,   270,   271,  1275,  1276,   274,     0,
     275,   276,   277,   278,  1277,     0,  1278,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,  1279,  1280,  1281,  1282,  1283,  1284,  1285,   303,   304,
     305,   306,   307,   308,  1286,  1287,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   886,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,  1289,   342,   343,   344,   345,  1290,
    1291,   347,     0,   348,   349,   350,  1292,   352,     0,   353,
       0,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,  1293,     0,  1294,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,   385,   386,
     387,   388,   389,   390,  1295,  1296,     0,  1297,     0,   394,
     395,   396,   397,   398,  1298,  1299,  1300,  1301,  1302,  1303,
    1304,  1305,  1306,   408,  1307,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,  1308,   419,   420,   421,     0,
     422,   423,   424,  1309,  1310,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,  1311,   444,  1312,   446,   447,   448,   449,
     450,   451,   452,   453,   454,  1313,   456,     0,   457,   458,
     459,   460,  1315,  1316,   462,  1317,   464,   465,   466,     0,
     467,   468,   469,     0,     0,  1318,   471,   472,     0,     0,
     473,   474,   475,   476,   477,   478,  1319,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,  1320,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
    1321,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,   535,   536,  3306,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,   551,   552,  1323,   553,   554,   555,   556,
     557,   558,   559,   560,  1324,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,  1325,   578,     0,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,  1326,  1327,     0,     0,
     591,   592,  1328,   594,  1329,  1330,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   605,   606,   607,
     608,   609,  1332,     0,   610,   611,   612,   613,   614,   615,
    1333,     0,   617,   618,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   629,   630,
    1334,  1335,  1336,  1337,   635,  1338,  1339,  1340,  1341,   640,
     641,   642,   643,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3307,  3308,   234,     0,
    1264,   710,     0,  1265,  1266,  3309,   771,  1268,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1269,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1270,   260,
    1271,  1272,     0,   263,   264,   265,   266,   267,   268,   269,
    1273,  1274,   270,   271,  1275,  1276,   274,     0,   275,   276,
     277,   278,  1277,     0,  1278,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,  1279,
    1280,  1281,  1282,  1283,  1284,  1285,   303,   304,   305,   306,
     307,   308,  1286,  1287,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   886,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,  1289,   342,   343,   344,   345,  1290,  1291,   347,
       0,   348,   349,   350,  1292,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
    1293,     0,  1294,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,   385,   386,   387,   388,
     389,   390,  1295,  1296,     0,  1297,     0,   394,   395,   396,
     397,   398,  1298,  1299,  1300,  1301,  1302,  1303,  1304,  1305,
    1306,   408,  1307,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,  1308,   419,   420,   421,     0,   422,   423,
     424,  1309,  1310,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,  1311,   444,  1312,   446,   447,   448,   449,   450,   451,
     452,   453,   454,  1313,   456,     0,   457,   458,   459,   460,
    1315,  1316,   462,  1317,   464,   465,   466,     0,   467,   468,
     469,     0,     0,   470,   471,   472,     0,     0,   473,   474,
     475,   476,   477,   478,  1319,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
    1320,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,  1321,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,   535,   536,  3485,  3486,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,  1323,   553,   554,   555,   556,   557,   558,
     559,   560,  1324,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,  1325,
     578,     0,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,  1326,  1327,     0,     0,   591,   592,
    1328,   594,  1329,  1330,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,     0,   605,   606,   607,   608,   609,
    1332,     0,   610,   611,   612,   613,   614,   615,  1333,     0,
     617,   618,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,  1334,  1335,
    1336,  1337,   635,  1338,  1339,  1340,  1341,   640,   641,   642,
     643,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3487,  3488,   234,     0,  1264,   710,
       0,  1265,  1266,  3309,   771,  1268,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1269,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1270,   260,  1271,  1272,
       0,   263,   264,   265,   266,   267,   268,   269,  1273,  1274,
     270,   271,  1275,  1276,   274,     0,   275,   276,   277,   278,
    1277,     0,  1278,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,  1279,  1280,  1281,
    1282,  1283,  1284,  1285,   303,   304,   305,   306,   307,   308,
    1286,  1287,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   886,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
    1289,   342,   343,   344,   345,  1290,  1291,   347,     0,   348,
     349,   350,  1292,   352,     0,   353,     0,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,  1293,     0,
    1294,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,   385,   386,   387,   388,   389,   390,
    1295,  1296,     0,  1297,     0,   394,   395,   396,   397,   398,
    1298,  1299,  1300,  1301,  1302,  1303,  1304,  1305,  1306,   408,
    1307,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,  1308,   419,   420,   421,     0,   422,   423,   424,  1309,
    1310,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,  1311,
     444,  1312,   446,   447,   448,   449,   450,   451,   452,   453,
     454,  1313,   456,     0,   457,   458,   459,   460,  1315,  1316,
     462,  1317,   464,   465,   466,     0,   467,   468,   469,     0,
       0,   470,   471,   472,     0,     0,   473,   474,   475,   476,
     477,   478,  1319,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,  1320,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,  1321,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,   535,   536,  3306,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,  1323,   553,   554,   555,   556,   557,   558,   559,   560,
    1324,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,  1325,   578,     0,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,  1326,  1327,     0,     0,   591,   592,  1328,   594,
    1329,  1330,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,     0,   605,   606,   607,   608,   609,  1332,     0,
     610,   611,   612,   613,   614,   615,  1333,     0,   617,   618,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,  1334,  1335,  1336,  1337,
     635,  1338,  1339,  1340,  1341,   640,   641,   642,   643,     0,
       0,     0,     0,     0,     0,   234,     0,  1264,   710,     0,
    1265,  1266,     0,   771,  1268,     0,     0,     0,     0,     0,
       0,  3309,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,  1269,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1270,   260,  1271,  1272,     0,
     263,  4766,   265,   266,   267,   268,   269,  1273,  1274,   270,
     271,  1275,  1276,   274,     0,   275,   276,   277,   278,  1277,
       0,  1278,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,  1279,  1280,  1281,  1282,
    1283,  1284,  1285,   303,   304,   305,   306,   307,   308,  1286,
    1287,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   886,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,  1289,
     342,   343,   344,   345,  1290,  1291,   347,     0,   348,   349,
     350,  1292,   352,     0,   353,     0,   354,   355,   356,     0,
     357,   358,   359,   360,   361,     0,   362,  1293,     0,  1294,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,   388,   389,   390,  1295,
    1296,     0,  1297,     0,   394,   395,   396,   397,   398,  1298,
    1299,  1300,  1301,  1302,  1303,  1304,  1305,  1306,   408,  1307,
     410,   411,   412,   413,   414,   415,   416,     0,     0,   417,
    1308,   419,   420,   421,     0,   422,   423,   424,  1309,  1310,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,  1311,   444,
    1312,   446,   447,   448,   449,   450,   451,   452,   453,   454,
    1313,   456,     0,   457,   458,   459,   460,  1315,  1316,   462,
    1317,   464,   465,   466,     0,   467,   468,   469,     0,     0,
     470,   471,   472,     0,     0,   473,   474,   475,   476,   477,
     478,  1319,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,  1320,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,  1321,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,   535,   536,  3306,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,   551,   552,
    1323,   553,   554,   555,   556,   557,   558,   559,   560,  1324,
     562,     0,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,  1325,   578,     0,   579,
     580,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,  1326,  1327,     0,     0,   591,   592,  1328,   594,  1329,
    1330,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,     0,   605,   606,   607,   608,   609,  1332,     0,   610,
     611,   612,   613,   614,   615,  1333,     0,   617,   618,   619,
     620,   621,   622,     0,     0,   623,     0,     0,   624,   625,
     626,   627,   628,   629,   630,  1334,  1335,  1336,  1337,   635,
    1338,  1339,  1340,  1341,   640,   641,   642,   643,     0,     0,
       0,     0,     0,     0,   234,     0,  1264,   710,     0,  1265,
    1266,     0,   771,  1268,     0,     0,     0,     0,     0,     0,
    3309,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1269,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1270,   260,  1271,  1272,     0,   263,
     264,   265,   266,   267,   268,   269,  1273,  1274,   270,   271,
    1275,  1276,   274,     0,   275,   276,   277,   278,  1277,     0,
    1278,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,  1279,  1280,  1281,  1282,  1283,
    1284,  1285,   303,   304,   305,   306,   307,   308,  1286,  1287,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     886,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,  1289,   342,
     343,   344,   345,  1290,  1291,   347,     0,   348,   349,   350,
    1292,   352,     0,   353,     0,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,  1293,     0,  1294,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
       0,   384,   385,   386,   387,   388,   389,   390,  1295,  1296,
       0,  1297,     0,   394,   395,   396,   397,   398,  1298,  1299,
    1300,  1301,  1302,  1303,  1304,  1305,  1306,   408,  1307,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,  1308,
     419,   420,   421,     0,   422,   423,   424,  1309,  1310,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,  1311,   444,  1312,
     446,   447,   448,   449,   450,   451,   452,   453,   454,  1313,
     456,     0,   457,   458,   459,   460,  1315,  1316,   462,  1317,
     464,   465,   466,     0,   467,   468,   469,     0,     0,   470,
     471,   472,     0,     0,   473,   474,   475,   476,   477,   478,
    1319,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,  1320,   495,   496,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,  1321,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
     535,   536,  3306,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,   551,   552,  1323,
     553,   554,   555,   556,   557,   558,   559,   560,  1324,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,  1325,   578,     0,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
    1326,  1327,     0,     0,   591,   592,  1328,   594,  1329,  1330,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
       0,   605,   606,   607,   608,   609,  1332,     0,   610,   611,
     612,   613,   614,   615,  1333,     0,   617,   618,   619,   620,
     621,   622,     0,     0,   623,     0,     0,   624,   625,   626,
     627,   628,   629,   630,  1334,  1335,  1336,  1337,  4826,  1338,
    1339,  1340,  1341,   640,   641,   642,   643,     0,     0,     0,
       0,     0,     0,   234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3309,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,  1274,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,  1277,     0,  1278,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,  1279,  1280,  1281,  1282,  1283,  1284,
    1285,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,  1290,     0,   347,     0,   348,   349,   350,   351,
     352,     0,   353,     0,   354,   355,   356,     0,   357,   358,
     359,   360,   361,     0,   362,  1293,     0,   364,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,     0,   394,   395,   396,   397,   398,  3456,  1299,  1300,
    1301,  1302,  1303,  1304,  1305,  1306,  3457,  1307,   410,   411,
     412,   413,   414,   415,   416,  3458,     0,   417,  1308,   419,
     420,   421,     0,   422,   423,   424,  1309,  1310,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,  1313,   456,
       0,   457,   458,   459,   460,     0,  1316,   462,   463,   464,
     465,   466,     0,   467,   468,   469,     0,   861,   470,   471,
     472,     0,     0,   473,   474,   475,   476,   477,   478,  1319,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,  1320,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,   535,
     536,   537,  3459,   539,   540,   541,   542,   543,   544,   545,
     546,   547,    40,   548,   549,   550,   551,   552,  1323,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,  1325,   578,     0,   579,   580,    44,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   589,
     590,     0,     0,   591,   592,  1328,   594,  1329,     0,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,     0,
     605,   606,   607,   608,   609,  1332,     0,   610,   611,   612,
     613,   614,  1203,   616,     0,   617,   618,   619,   620,   621,
     622,     0,     0,   623,     0,    49,   624,   625,   626,   627,
     628,   629,   630,  1334,  1335,  1336,  1337,   635,  1338,  1339,
    1340,  1341,  3460,   641,   642,   643,     0,     0,    50,     0,
       0,     0,   234,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3461,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,  1274,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,  1277,     0,  1278,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,  1279,  1280,  1281,  1282,  1283,  1284,  1285,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,  1290,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,  1293,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,     0,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
       0,   394,   395,   396,   397,   398,  3456,  1299,  1300,  1301,
    1302,  1303,  1304,  1305,  1306,  3457,  1307,   410,   411,   412,
     413,   414,   415,   416,  3458,     0,   417,  1308,   419,   420,
     421,     0,   422,   423,   424,  1309,  1310,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,  1313,   456,     0,
     457,   458,   459,   460,     0,  1316,   462,   463,   464,   465,
     466,     0,   467,   468,   469,     0,   861,   470,   471,   472,
       0,     0,   473,   474,   475,   476,   477,   478,  1319,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,  1320,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,   535,   536,
     537,  3459,   539,   540,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,   551,   552,  1323,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,     0,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,  1325,   578,     0,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   590,
       0,     0,   591,   592,  1328,   594,  1329,     0,   596,   597,
     598,   599,   600,   601,   602,   603,   604,     0,     0,   605,
     606,   607,   608,   609,  1332,     0,   610,   611,   612,   613,
     614,   615,   616,     0,   617,   618,   619,   620,   621,   622,
       0,     0,   623,     0,     0,   624,   625,   626,   627,   628,
     629,   630,  1334,  1335,  1336,  1337,   635,  1338,  1339,  1340,
    1341,  3460,   641,   642,   643,     0,     0,     0,     0,     0,
       0,   234,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3461,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,  1274,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,  1277,     0,  1278,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,  1279,  1280,  1281,  1282,  1283,  1284,  1285,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
    1290,     0,   347,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,   356,     0,   357,   358,   359,   360,
     361,     0,   362,  1293,     0,   364,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,     0,
     394,   395,   396,   397,   398,  3456,  1299,  1300,  1301,  1302,
    1303,  1304,  1305,  1306,   408,  1307,   410,   411,   412,   413,
     414,   415,   416,     0,     0,   417,  1308,   419,   420,   421,
       0,   422,   423,   424,  1309,  1310,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,  1313,   456,     0,   457,
     458,   459,   460,     0,  1316,   462,   463,   464,   465,   466,
       0,   467,   468,   469,     0,     0,   470,   471,   472,     0,
       0,   473,   474,   475,   476,   477,   478,  1319,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,  1320,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,   551,   552,  1323,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,     0,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,  1325,   578,     0,   579,   580,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,     0,
       0,   591,   592,  1328,   594,  1329,     0,   596,   597,   598,
     599,   600,   601,   602,   603,   604,     0,     0,   605,   606,
     607,   608,   609,  1332,     0,   610,   611,   612,   613,   614,
     615,   616,     0,   617,   618,   619,   620,   621,   622,     0,
       0,   623,     0,     0,   624,   625,   626,   627,   628,   629,
     630,  1334,  1335,  1336,  1337,   635,  1338,  1339,  1340,  1341,
     640,   641,   642,   643,     0,     0,     0,     0,     0,     0,
     234,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3898,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,  1274,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,  1277,     0,  1278,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,  1279,  1280,  1281,  1282,  1283,  1284,  1285,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,  1290,
       0,   347,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,  1293,     0,   364,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,     0,   394,
     395,   396,   397,   398,  3456,  1299,  1300,  1301,  1302,  1303,
    1304,  1305,  1306,  3457,  1307,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,  1308,   419,   420,   421,     0,
     422,   423,   424,  1309,  1310,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,  1313,   456,     0,   457,   458,
     459,   460,     0,  1316,   462,   463,   464,   465,   466,     0,
     467,   468,   469,     0,     0,   470,   471,   472,     0,     0,
     473,   474,   475,   476,   477,   478,  1319,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,  1320,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,   535,   536,   537,  3459,
     539,   540,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,   551,   552,  1323,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,  1325,   578,     0,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   590,     0,     0,
     591,   592,  1328,   594,  1329,     0,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   605,   606,   607,
     608,   609,  1332,     0,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   629,   630,
    1334,  1335,  1336,  1337,   635,  1338,  1339,  1340,  1341,  3460,
     641,   642,   643,     0,     0,     0,     0,     0,     0,   234,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    56,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,  1274,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,  1277,     0,  1278,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
    1279,  1280,  1281,  1282,  1283,  1284,  1285,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,   341,   342,   343,   344,   345,  1290,     0,
     347,     0,   348,   349,   350,   351,   352,     0,   353,     0,
     354,   355,   356,     0,   357,   358,   359,   360,   361,     0,
     362,  1293,     0,   364,   365,   366,     0,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,     0,   394,   395,
     396,   397,   398,  3456,  1299,  1300,  1301,  1302,  1303,  1304,
    1305,  1306,   408,  1307,   410,   411,   412,   413,   414,   415,
     416,     0,     0,   417,  1308,   419,   420,   421,     0,   422,
     423,   424,  1309,  1310,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,  1313,   456,     0,   457,   458,   459,
     460,     0,  1316,   462,   463,   464,   465,   466,     0,   467,
     468,   469,     0,     0,   470,   471,   472,     0,     0,   473,
     474,   475,   476,   477,   478,  1319,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,  1320,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,   551,   552,  1323,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
    1325,   578,     0,   579,   580,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   589,   590,     0,     0,   591,
     592,  1328,   594,  1329,     0,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,     0,   605,   606,   607,   608,
     609,  1332,     0,   610,   611,   612,   613,   614,   615,   616,
       0,   617,   618,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   629,   630,  1334,
    1335,  1336,  1337,   635,  1338,  1339,  1340,  1341,   640,   641,
     642,   643,     0,     0,     0,     0,     0,     0,   234,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4887,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,  1274,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,  1277,     0,  1278,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,  1279,
    1280,  1281,  1282,  1283,  1284,  1285,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,  1290,     0,   347,
       0,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
    1293,     0,   364,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,     0,   394,   395,   396,
     397,   398,  3456,  1299,  1300,  1301,  1302,  1303,  1304,  1305,
    1306,   408,  1307,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,  1308,   419,   420,   421,     0,   422,   423,
     424,  1309,  1310,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,  1313,   456,     0,   457,   458,   459,   460,
       0,  1316,   462,   463,   464,   465,   466,     0,   467,   468,
     469,     0,     0,   470,   471,   472,     0,     0,   473,   474,
     475,   476,   477,   478,  1319,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
    1320,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,  1323,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,  1325,
     578,     0,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,   590,     0,     0,   591,   592,
    1328,   594,  1329,     0,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,     0,   605,   606,   607,   608,   609,
    1332,     0,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,  1334,  1335,
    1336,  1337,   635,  1338,  1339,  1340,  1341,   640,   641,   642,
     643,     0,     0,     0,     0,     0,     0,   966,     0,  1606,
     710,     0,     0,     0,     0,   771,     0,     0,     0,     0,
       0,     0,     0,  6123,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,     0,     0,
       0,   302,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,  1829,   347,     0,
     348,   349,   350,   351,   352,     0,   353,     0,   354,   355,
     356,     0,   357,   358,   359,   360,   361,     0,   362,   363,
       0,   364,   365,   366,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,     0,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
       0,   417,   418,   419,   420,   421,     0,   422,   423,   424,
       0,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,     0,   457,   458,   459,   460,     0,
     461,   462,   463,   464,   465,   466,     0,   467,   468,   469,
    1830,     0,   470,   471,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,     0,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
       0,   579,   580,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,  1831,   596,   597,   598,   599,   600,   601,   602,
     603,   604,     0,     0,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,     0,   617,
     618,   619,   620,   621,   622,     0,     0,   623,     0,     0,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
       0,     0,     0,     0,     0,     0,   966,     0,     0,     0,
       0,     0,     0,  1607,  1608,  5903,     0,     0,     0,     0,
       0,     0,  5904,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     3,     4,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,     0,     0,     0,
     302,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,     0,
     364,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,     0,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,     0,   422,   423,   424,     0,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,     0,   457,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,     0,   467,   468,   469,     0,
       0,   470,   471,   472,     0,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,    40,   548,   549,   550,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,     0,
     579,   580,    44,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,     0,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,  1203,   616,     0,   617,   618,
     619,   620,   621,   622,     0,     0,   623,     0,    49,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,     0,
       0,    50,     0,     0,     0,   234,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    56,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,     0,     0,     0,   302,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,   353,     0,   354,   355,   356,     0,
     357,   358,   359,   360,   361,     0,   362,   363,     0,   364,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,     0,   417,
     418,   419,   420,   421,     0,   422,   423,   424,     0,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,     0,   457,   458,   459,   460,     0,   461,   462,
     463,   464,   465,   466,     0,   467,   468,   469,     0,     0,
     470,   471,   472,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,   551,   552,
       0,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,     0,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,     0,   579,
     580,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
       0,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,     0,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,   619,
     620,   621,   622,     0,     0,   623,     0,     0,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,     0,     0,
       0,     0,     0,     0,   651,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5649,   235,   236,   237,   238,   239,   240,   241,   242,   243,
    2894,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,  2895,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,     0,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   355,     0,     0,     0,
     358,   359,   360,   361,     0,   362,   363,     0,   364,   365,
     366,     0,   367,   368,   369,   370,   371,     0,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
       0,   384,     0,   386,   387,   388,   389,   390,   391,   392,
       0,   393,     0,   394,     0,     0,   397,     0,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,   418,
       0,   420,     0,     0,   422,   423,   424,     0,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,     0,   457,   458,     0,   460,     0,   461,   462,   463,
     464,   465,   466,     0,   467,   468,   469,     0,   861,   470,
     471,   472,     0,     0,   473,   474,   475,     0,   477,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,   551,   552,     0,
     553,   554,   555,   556,   557,     0,   559,   560,   561,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,     0,   579,   580,
    2896,   581,     0,   583,   584,   585,   586,   587,     0,   588,
     589,   590,     0,     0,   591,   592,   593,   594,   595,     0,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
       0,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,   615,   616,     0,   617,     0,   619,   620,
     621,   622,     0,     0,   623,     0,     0,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,     0,     0,     0,
       0,     0,     0,   651,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1863,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,   353,     0,   354,   355,     0,     0,     0,   358,
     359,   360,   361,     0,   362,   363,     0,   364,   365,   366,
       0,   367,   368,   369,   370,   371,     0,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384,     0,   386,   387,   388,   389,   390,   391,   392,     0,
     393,     0,   394,     0,     0,   397,     0,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,   418,     0,
     420,     0,     0,   422,   423,   424,     0,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,     0,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,   460,     0,   461,   462,   463,   464,
     465,   466,     0,   467,   468,   469,     0,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,   477,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,     0,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,    40,   548,   549,   550,   551,   552,     0,   553,
     554,   555,   556,   557,     0,   559,   560,   561,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,     0,   579,   580,    44,
     581,     0,   583,   584,   585,   586,   587,     0,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,     0,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,     0,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,  1203,   616,     0,   617,     0,   619,   620,   621,
     622,     0,     0,   623,     0,    49,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,     0,     0,    50,     0,
       0,     0,   651,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    56,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,     0,   384,
       0,   386,   387,   388,   389,   390,   391,   392,     0,   393,
       0,   394,     0,     0,   397,     0,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,     0,   417,   418,     0,   420,
       0,     0,   422,   423,   424,     0,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,     0,
     457,   458,     0,   460,     0,   461,   462,   463,   464,   465,
     466,     0,   467,   468,   469,     0,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,   477,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,     0,   529,   530,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,   551,   552,     0,   553,   554,
     555,   556,   557,     0,   559,   560,   561,   562,     0,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,     0,   579,   580,     0,   581,
       0,   583,   584,   585,   586,   587,     0,   588,   589,   590,
       0,     0,   591,   592,   593,   594,   595,     0,   596,   597,
     598,   599,   600,   601,   602,   603,   604,     0,     0,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,   615,   616,     0,   617,     0,   619,   620,   621,   622,
       0,     0,   623,     0,     0,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,     0,     0,     0,     0,     0,
       0,   651,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1418,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,     0,     0,     0,   358,   359,   360,
     361,     0,   362,   363,     0,   364,   365,   366,     0,   367,
     368,   369,   370,   371,     0,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,     0,   384,     0,
     386,   387,   388,   389,   390,   391,   392,     0,   393,     0,
     394,     0,     0,   397,     0,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,     0,   417,   418,     0,   420,     0,
       0,   422,   423,   424,     0,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,     0,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,   460,     0,   461,   462,   463,   464,   465,   466,
       0,   467,   468,   469,     0,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,   477,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
       0,   529,   530,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,   551,   552,     0,   553,   554,   555,
     556,   557,     0,   559,   560,   561,   562,     0,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,     0,   579,   580,     0,   581,     0,
     583,   584,   585,   586,   587,     0,   588,   589,   590,     0,
       0,   591,   592,   593,   594,   595,     0,   596,   597,   598,
     599,   600,   601,   602,   603,   604,     0,     0,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,     0,   617,     0,   619,   620,   621,   622,     0,
       0,   623,     0,     0,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,     0,     0,     0,     0,     0,     0,
     651,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3519,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,     0,     0,     0,   358,   359,   360,   361,
       0,   362,   363,     0,   364,   365,   366,     0,   367,   368,
     369,   370,   371,     0,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,     0,   386,
     387,   388,   389,   390,   391,   392,     0,   393,     0,   394,
       0,     0,   397,     0,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,   418,     0,   420,     0,     0,
     422,   423,   424,     0,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,     0,   457,   458,
       0,   460,     0,   461,   462,   463,   464,   465,   466,     0,
     467,   468,   469,     0,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,   477,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,     0,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,   551,   552,     0,   553,   554,   555,   556,
     557,     0,   559,   560,   561,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,     0,   579,   580,     0,   581,     0,   583,
     584,   585,   586,   587,     0,   588,   589,   590,     0,     0,
     591,   592,   593,   594,   595,     0,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,   615,
     616,     0,   617,     0,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,     0,     0,     0,     0,     0,     0,   651,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4188,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,   353,     0,
     354,   355,     0,     0,     0,   358,   359,   360,   361,     0,
     362,   363,     0,   364,   365,   366,     0,   367,   368,   369,
     370,   371,     0,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,     0,   384,     0,   386,   387,
     388,   389,   390,   391,   392,     0,   393,     0,   394,     0,
       0,   397,     0,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,     0,   417,   418,     0,   420,     0,     0,   422,
     423,   424,     0,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,     0,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
     460,     0,   461,   462,   463,   464,   465,   466,     0,   467,
     468,   469,     0,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,   477,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,   551,   552,     0,   553,   554,   555,   556,   557,
       0,   559,   560,   561,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,     0,   579,   580,     0,   581,     0,   583,   584,
     585,   586,   587,     0,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,     0,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,     0,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
       0,   617,     0,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,     0,     0,     0,     0,     0,     0,   651,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4843,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
       0,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     355,     0,     0,     0,   358,   359,   360,   361,     0,   362,
     363,     0,   364,   365,   366,     0,   367,   368,   369,   370,
     371,     0,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,     0,   386,   387,   388,
     389,   390,   391,   392,     0,   393,     0,   394,     0,     0,
     397,     0,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,   418,     0,   420,     0,     0,   422,   423,
     424,     0,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,     0,   457,   458,     0,   460,
       0,   461,   462,   463,   464,   465,   466,     0,   467,   468,
     469,     0,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,   477,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
       0,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,     0,   553,   554,   555,   556,   557,     0,
     559,   560,   561,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,     0,   579,   580,     0,   581,     0,   583,   584,   585,
     586,   587,     0,   588,   589,   590,     0,     0,   591,   592,
     593,   594,   595,     0,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,     0,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,     0,
     617,     0,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2107,     0,     0,     0,     0,     0,     0,  2108,     0,     0,
    2109,     0,     0,  6019,  2110,  2111,  2112,  2113,  2114,  2115,
    2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,
    2126,  2127,  2128,  2129,     0,  2130,  2131,  2132,  2133,  2134,
    2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,
    2145,  2146,  2147,  2148,  2149,  2150,  2151,  2152,  2153,  2154,
    2155,  2156,  2157,  2158,  2159,  2160,     0,     0,  2161,  2162,
    2163,  2164,  2165,  2166,  2167,  2168,  2169,  2170,  2171,  2172,
    2173,  2174,  2175,  2176,  2177,  2178,  2179,  2180,  2181,  2182,
    2183,  2184,  2185,  2186,  2187,  2188,     0,  2189,  2190,  2191,
    2192,  2193,  2194,  2195,  2196,  2197,  2198,  2199,  2200,  2201,
    2202,  2203,     0,  2204,  2205,  2206,  2207,  2208,  2209,  2210,
    2211,  2212,  2213,  2214,  2215,  2216,  2217,  2218,  2219,  2220,
    2221,  2222,  2223,  2224,  2225,  2226,  2227,  2228,  2229,  2230,
    2231,  2232,  2233,  2234,  2235,  2236,  2237,  2238,  2239,     0,
    2240,  2241,  2242,  2243,  2244,  2245,  2246,  2247,  2248,  2249,
    2250,  2251,     0,     0,  2252,  2253,  2254,  2255,     0,  2256,
    2257,  2258,  2259,  2260,     0,  2261,  2262,  2263,  2264,  2265,
       0,  2266,  2267,     0,  2268,  2269,  2270,     0,  2271,  2272,
       0,  2273,  2274,  2275,  2276,  2277,  2278,  2279,  2280,  2281,
    2282,  2283,  2284,  2285,  2286,  2287,  2288,  2289,  2290,  2291,
    2292,  2293,  2294,  2295,  2296,  2297,     0,  2298,     0,  2299,
    2300,  2301,  2302,  2303,  2304,  2305,  2306,  2307,  2308,  2309,
    2310,  2311,  2312,  2313,  2314,  2315,  2316,  2317,  2318,  2319,
    2320,  2321,  2322,  2323,  2324,  2325,  2326,  2327,  2328,     0,
    2329,  2330,  2331,  2332,  2333,  2334,  2335,  2336,  2337,  2338,
    2339,  2340,  2341,  2342,  2343,  2344,     0,  2345,  2346,     0,
    2347,  2348,  2349,  2350,  2351,  2352,  2353,  2354,  2355,  2356,
    2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,  2365,  2366,
    2367,  2368,  2369,  2370,  2371,  2372,  2373,  2374,  2375,     0,
    2376,  2377,  2378,     0,  2379,  2380,  2381,  2382,  2383,     0,
    2384,  2385,  2386,  2387,     0,     0,  2388,  2389,  2390,  2391,
    2392,  2393,  2394,  2395,  2396,  2397,  2398,  2399,  2400,  2401,
    2402,  2403,  2404,  2405,     0,  2406,  2407,  2408,  2409,  2410,
    2411,  2412,  2413,  2414,  2415,  2416,  2417,  2418,  2419,  2420,
    2421,  2422,  2423,  2424,  2425,  2426,  2427,  2428,  2429,  2430,
    2431,  2432,  2433,  2434,  2435,  2436,  2437,  2438,  2439,     0,
    2440,  2441,  2442,  2443,  2444,  2445,  2446,  2447,  2448,  2449,
    2450,  2451,  2452,  2453,  2454,  2455,  2456,     0,  2457,  2458,
    2459,  2460,  2461,  2462,  2463,  2464,  2465,  2466,  2467,  2468,
    2469,  2470,  2471,  2472,  2473,  2474,  2475,  2476,  2477,  2478,
    2479,  2480,  2481,  2482,  2483,  2484,  2485,  2486,  2487,  2488,
    2489,  2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,  2498,
    2499,  2500,  2501,  2502,  2503,  2504,  2505,  2506,     0,  2507,
    2508,  2509,  2510,  2511,  2512,  2513,  2514,  2515,  2516,  2517,
    2518,  2519,  2520,  2521,  2522,     0,  2523,  2524,  2525,  2526,
    2527,  2528,  2529,  2530,  2531,  2532,  2533,  2534,  2535,  2536,
    2537,  2538,     0,  2539,  2540,  2541,  2542,  2543,  2544,     0,
    2545,     0,     0,     0,     0,  2546,  2547,  2548,  2549,  2550,
    2551,  2552,  2553,  2554,  2555,  2556,  2557,  2558,  2559,  2560,
       0,  2561,  2562,  2563,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2564,  2565,  2566,  2567,  2568,  2569,  2570,
    2571,  2572,   878,     0,  1606,   710,     0,     0,     0,   981,
     771,     0,     0,     0,     0,     0,   982,   983,   984,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  1742,   244,
     245,   246,  1743,  1744,  1745,  1746,  1747,  1748,  1749,   247,
     248,   249,  1750,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   879,   260,   880,   881,  1751,   263,   264,   265,
     266,   267,   268,   269,  1752,  1753,   270,   271,   882,   883,
     274,  1754,   275,   276,   277,   278,     0,  1755,   280,  1756,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,  1757,   292,   293,   294,   295,   296,   297,  1758,   298,
     299,   300,   301,  1759,  1760,  1761,   302,  1762,  1763,  1764,
     303,   304,   305,   306,   307,   308,   884,   885,   311,  1765,
     312,  1766,   313,   314,   315,   316,   317,   318,   319,  1767,
     320,   321,   322,   323,  1768,  1769,   324,   325,   886,   327,
     328,  1770,   329,   330,   331,   332,  1771,   333,   334,   335,
     336,  1772,   337,   338,   339,   340,     0,   342,   343,   344,
     345,     0,  1773,   347,  1774,   348,   349,   350,   887,   352,
    1775,   353,  1776,   354,   355,   356,  1777,   357,   358,   359,
     360,   361,  1778,   362,     0,  1779,     0,   365,   366,  1780,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
    1781,   377,   378,   379,   380,   381,   382,   383,  1782,   384,
     385,     0,   387,   388,   389,   390,   888,   889,  1783,   890,
    1784,   394,   395,   396,   397,   398,   891,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   410,   411,   412,
     413,   414,   415,   416,  1785,  1786,   417,     0,   419,   420,
     421,  1787,   422,   423,   424,  1788,  1789,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   892,   444,   893,   446,   447,
     448,   449,   450,   451,   452,   453,  4505,     0,   456,  1790,
     457,   458,   459,   460,  1791,     0,   462,   894,   464,   465,
     466,  1792,   467,   468,   469,  1793,  1794,  4506,   471,   472,
    1795,  1796,   473,   474,     0,   476,   477,   478,     0,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
    1797,   491,   492,   493,     0,   495,     0,   497,   498,   499,
    1798,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   895,   512,   513,   514,   515,  1799,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,  1800,   529,   530,   531,   532,   533,   534,   535,   536,
       0,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,  1801,   548,   549,   550,   551,   552,  1802,   553,   554,
    2724,   556,   557,   558,   559,   560,   897,   562,  1803,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,     0,   578,  1804,   579,   580,  1805,   581,
     582,   583,   584,   585,   586,   587,  1806,   588,   898,   899,
    1807,  1808,   591,   592,     0,   594,     0,  1809,   596,   597,
     598,   599,   600,   601,   602,   603,   604,  1810,  1811,   605,
     606,   607,   608,   609,  1812,  1813,   610,   611,   612,   613,
     614,     0,   900,  1814,   617,   618,   619,   620,   621,   622,
    1815,  1816,   623,  1817,  1818,   624,   625,   626,   627,   628,
     629,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   641,   642,   643,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   987,   988,   989,  4507,  4508,
     992,   993,   994,   995,   878,     0,  1606,   710,     0,     0,
       0,   981,   771,     0,     0,     0,     0,     0,   982,   983,
     984,   235,   236,   237,   238,   239,   240,   241,   242,   243,
    1742,   244,   245,   246,  1743,  1744,  1745,  1746,  1747,  1748,
    1749,   247,   248,   249,  1750,   250,   251,   252,   253,   254,
     255,   256,   257,     0,   879,   260,   880,   881,  1751,   263,
     264,   265,   266,   267,   268,   269,  1752,  1753,   270,   271,
     882,   883,   274,  1754,   275,   276,   277,   278,     0,  1755,
     280,  1756,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,  1757,   292,   293,   294,   295,   296,   297,
    1758,   298,   299,   300,   301,  1759,  1760,  1761,   302,  1762,
    1763,  1764,   303,   304,   305,   306,   307,   308,   884,   885,
     311,  1765,   312,  1766,   313,   314,   315,   316,   317,   318,
     319,  1767,   320,   321,   322,   323,  1768,  1769,   324,   325,
     886,   327,   328,  1770,   329,   330,   331,   332,  1771,   333,
     334,   335,   336,  1772,   337,   338,   339,   340,     0,   342,
     343,   344,   345,     0,  1773,   347,  1774,   348,   349,   350,
     887,   352,  1775,   353,  1776,   354,   355,   356,  1777,   357,
     358,   359,   360,   361,  1778,   362,     0,  1779,     0,   365,
     366,  1780,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,  1781,   377,   378,   379,   380,   381,   382,   383,
    1782,   384,   385,     0,   387,   388,   389,   390,   888,   889,
    1783,   890,  1784,   394,   395,   396,   397,   398,   891,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   410,
     411,   412,   413,   414,   415,   416,  1785,  1786,   417,     0,
     419,   420,   421,  1787,   422,   423,   424,  1788,  1789,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   892,   444,   893,
     446,   447,   448,   449,   450,   451,   452,   453,  4979,     0,
     456,  1790,   457,   458,   459,   460,  1791,     0,   462,   894,
     464,   465,   466,  1792,   467,   468,   469,  1793,  1794,  4506,
     471,   472,  1795,  1796,   473,   474,     0,   476,   477,   478,
       0,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,  1797,   491,   492,   493,     0,   495,     0,   497,
     498,   499,  1798,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   895,   512,   513,   514,   515,  1799,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,  1800,   529,   530,   531,   532,   533,   534,
     535,   536,     0,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,  1801,   548,   549,   550,   551,   552,  1802,
     553,   554,  2724,   556,   557,   558,   559,   560,   897,   562,
    1803,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,     0,   578,  1804,   579,   580,
    1805,   581,   582,   583,   584,   585,   586,   587,  1806,   588,
     898,   899,  1807,  1808,   591,   592,     0,   594,     0,  1809,
     596,   597,   598,   599,   600,   601,   602,   603,   604,  1810,
    1811,   605,   606,   607,   608,   609,  1812,  1813,   610,   611,
     612,   613,   614,     0,   900,  1814,   617,   618,   619,   620,
     621,   622,  1815,  1816,   623,  1817,  1818,   624,   625,   626,
     627,   628,   629,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   641,   642,   643,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   987,   988,   989,
    4507,  4508,   992,   993,   994,   995,   651,     0,     0,     0,
       0,     0,     0,   981,     0,     0,     0,     0,     0,     0,
     982,   983,   984,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   985,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   986,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,     0,
       0,     0,   358,   359,   360,   361,     0,   362,   363,     0,
     364,   365,   366,     0,   367,   368,   369,   370,   371,     0,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,     0,   386,   387,   388,   389,   390,
     391,   392,     0,   393,     0,   394,     0,     0,   397,     0,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,   418,     0,   420,     0,     0,   422,   423,   424,     0,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,     0,   457,   458,     0,   460,     0,   461,
     462,   463,   464,   465,   466,     0,   467,   468,   469,     0,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
     477,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,     0,   553,   554,   555,   556,   557,     0,   559,   560,
     561,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,     0,
     579,   580,     0,   581,     0,   583,   584,   585,   586,   587,
       0,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,     0,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,   615,   616,     0,   617,     0,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   987,
     988,   989,   990,   991,   992,   993,   994,   995,   651,     0,
       0,     0,     0,     0,     0,   981,     0,     0,     0,     0,
       0,     0,   982,   983,   984,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,  1101,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,  1102,
       0,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     355,     0,     0,     0,   358,   359,   360,   361,     0,   362,
     363,     0,   364,   365,   366,     0,   367,   368,   369,   370,
     371,     0,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,     0,   386,   387,   388,
     389,   390,   391,   392,     0,   393,     0,   394,     0,     0,
     397,     0,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,   418,     0,   420,     0,     0,   422,   423,
     424,     0,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,     0,   457,   458,     0,   460,
       0,   461,   462,   463,   464,   465,   466,     0,   467,   468,
     469,     0,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,   477,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
       0,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,     0,   553,   554,   555,   556,   557,     0,
     559,   560,   561,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,     0,   579,   580,     0,   581,     0,   583,   584,   585,
     586,   587,     0,   588,   589,   590,     0,     0,   591,   592,
     593,   594,   595,     0,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,     0,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,     0,
     617,     0,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   987,   988,   989,   990,   991,   992,   993,   994,   995,
     651,     0,     0,     0,     0,     0,     0,   981,     0,     0,
       0,     0,     0,     0,   982,   983,   984,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,  1166,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,  1167,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,     0,     0,     0,   358,   359,   360,   361,
       0,   362,   363,     0,   364,   365,   366,     0,   367,   368,
     369,   370,  1168,     0,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,     0,   386,
     387,   388,   389,   390,   391,   392,     0,   393,     0,   394,
       0,     0,   397,     0,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,   418,     0,   420,     0,     0,
     422,   423,   424,     0,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,     0,   457,   458,
       0,   460,     0,   461,   462,   463,   464,   465,   466,     0,
     467,   468,   469,     0,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,   477,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,     0,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,   551,   552,     0,   553,   554,   555,   556,
     557,     0,   559,   560,   561,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,     0,   579,   580,     0,   581,     0,   583,
     584,   585,   586,   587,     0,   588,   589,   590,     0,     0,
     591,   592,   593,   594,   595,     0,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,   615,
     616,     0,   617,     0,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   987,   988,   989,   990,   991,   992,   993,
     994,   995,   651,     0,     0,     0,     0,     0,     0,   981,
       0,     0,     0,     0,     0,     0,   982,   983,   984,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,  1846,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,  1847,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,     0,   384,
       0,   386,   387,   388,   389,   390,   391,   392,     0,   393,
       0,   394,     0,     0,   397,     0,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,     0,   417,   418,     0,   420,
       0,     0,   422,   423,   424,     0,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,     0,
     457,   458,     0,   460,     0,   461,   462,   463,   464,   465,
     466,     0,   467,   468,   469,     0,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,   477,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,     0,   529,   530,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,   551,   552,     0,   553,   554,
     555,   556,   557,     0,   559,   560,   561,   562,     0,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,     0,   579,   580,     0,   581,
       0,   583,   584,   585,   586,   587,     0,   588,   589,   590,
       0,     0,   591,   592,   593,   594,   595,     0,   596,   597,
     598,   599,   600,   601,   602,   603,   604,     0,     0,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,   615,   616,     0,   617,     0,   619,   620,   621,   622,
       0,     0,   623,     0,     0,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   987,   988,   989,   990,   991,
     992,   993,   994,   995,   651,     0,     0,     0,     0,     0,
       0,   981,     0,     0,     0,     0,     0,     0,   982,   983,
     984,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,     0,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   355,     0,     0,     0,
     358,   359,   360,   361,     0,   362,   363,     0,   364,   365,
     366,     0,   367,   368,   369,   370,   371,     0,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
       0,   384,     0,   386,   387,   388,   389,   390,   391,   392,
       0,   393,     0,   394,     0,     0,   397,     0,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,   418,
       0,   420,     0,     0,   422,   423,   424,     0,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,     0,   457,   458,     0,   460,     0,   461,   462,   463,
     464,   465,   466,     0,   467,   468,   469,     0,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,   477,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,   551,   552,     0,
     553,   554,   555,   556,   557,     0,   559,   560,   561,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,     0,   579,   580,
       0,   581,     0,   583,   584,   585,   586,   587,     0,   588,
     589,   590,     0,     0,   591,   592,   593,   594,   595,     0,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
       0,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,   615,   616,     0,   617,     0,   619,   620,
     621,   622,     0,     0,   623,     0,     0,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   651,     0,     0,     0,
       0,     0,     0,   981,     0,     0,     0,     0,     0,     0,
     982,   983,   984,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,  3590,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,  3591,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,     0,
       0,     0,   358,   359,   360,   361,     0,   362,   363,     0,
     364,   365,   366,     0,   367,   368,   369,   370,   371,     0,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,     0,   386,   387,   388,   389,   390,
     391,   392,     0,   393,     0,   394,     0,     0,   397,     0,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,   418,     0,   420,     0,     0,   422,   423,   424,     0,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,     0,   457,   458,     0,   460,     0,   461,
     462,   463,   464,   465,   466,     0,   467,   468,   469,     0,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
     477,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,     0,   553,   554,   555,   556,   557,     0,   559,   560,
     561,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,     0,
     579,   580,     0,   581,     0,   583,   584,   585,   586,   587,
       0,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,     0,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,   615,   616,     0,   617,     0,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   987,
     988,   989,   990,   991,   992,   993,   994,   995,   651,     0,
       0,     0,     0,     0,     0,   981,     0,     0,     0,     0,
       0,     0,   982,   983,   984,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
       0,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     355,     0,     0,     0,   358,   359,   360,   361,     0,   362,
     363,     0,   364,   365,   366,     0,   367,   368,   369,   370,
     371,     0,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,     0,   386,   387,   388,
     389,   390,   391,   392,     0,   393,     0,   394,     0,     0,
     397,     0,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,   418,     0,   420,     0,     0,   422,   423,
     424,     0,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,     0,   457,   458,     0,   460,
       0,   461,   462,   463,   464,   465,   466,     0,   467,   468,
     469,     0,     0,  5629,   471,   472,     0,     0,   473,   474,
     475,     0,   477,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
       0,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,     0,   553,   554,   555,   556,   557,     0,
     559,   560,   561,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,     0,   579,   580,     0,   581,     0,   583,   584,   585,
     586,   587,     0,   588,   589,   590,     0,     0,   591,   592,
     593,   594,   595,     0,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,     0,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,     0,
     617,     0,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,     0,     0,  1741,     0,     0,     0,     0,     0,     0,
       0,   987,   988,   989,   990,   991,   992,   993,   994,   995,
     235,   236,   237,   238,   239,   240,   241,   242,   243,  1742,
     244,   245,   246,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
     247,   248,   249,  1750,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,  1751,   263,   264,
     265,   266,   267,   268,   269,  1752,  1753,   270,   271,   272,
     273,   274,  1754,   275,   276,   277,   278,   279,  1755,   280,
    1756,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,  1757,   292,   293,   294,   295,   296,   297,  1758,
     298,   299,   300,   301,  1759,  1760,  1761,   302,  1762,  1763,
    1764,   303,   304,   305,   306,   307,   308,   309,   310,   311,
    1765,   312,  1766,   313,   314,   315,   316,   317,   318,   319,
    1767,   320,   321,   322,   323,  1768,  1769,   324,   325,   326,
     327,   328,  1770,   329,   330,   331,   332,  1771,   333,   334,
     335,   336,  1772,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,  1773,   347,  1774,   348,   349,   350,   351,
     352,  1775,   353,  1776,   354,   355,   356,  1777,   357,   358,
     359,   360,   361,  1778,   362,   363,  1779,   364,   365,   366,
    1780,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,  1781,   377,   378,   379,   380,   381,   382,   383,  1782,
     384,   385,   386,   387,   388,   389,   390,   391,   392,  1783,
     393,  1784,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,  1785,  1786,   417,   418,   419,
     420,   421,  1787,   422,   423,   424,  1788,  1789,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
    1790,   457,   458,   459,   460,  1791,   461,   462,   463,   464,
     465,   466,  1792,   467,   468,   469,  1793,  1794,   470,   471,
     472,  1795,  1796,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,  1797,   491,   492,   493,   494,   495,   496,   497,   498,
     499,  1798,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,  1799,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,  1800,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,  1801,   548,   549,   550,   551,   552,  1802,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,  1803,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,  1804,   579,   580,  1805,
     581,   582,   583,   584,   585,   586,   587,  1806,   588,   589,
     590,  1807,  1808,   591,   592,   593,   594,   595,  1809,   596,
     597,   598,   599,   600,   601,   602,   603,   604,  1810,  1811,
     605,   606,   607,   608,   609,  1812,  1813,   610,   611,   612,
     613,   614,   615,   616,  1814,   617,   618,   619,   620,   621,
     622,  1815,  1816,   623,  1817,  1818,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   651,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1819,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,     0,
       0,     0,   358,   359,   360,   361,     0,   362,   363,     0,
     364,   365,   366,     0,   367,   368,   369,   370,   371,     0,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,     0,   386,   387,   388,   389,   390,
     391,   392,     0,   393,     0,   394,     0,     0,   397,     0,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,   418,     0,   420,     0,     0,   422,   423,   424,     0,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,     0,   457,   458,     0,   460,     0,   461,
     462,   463,   464,   465,   466,     0,   467,   468,   469,     0,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
     477,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,     0,   553,   554,   555,   556,   557,     0,   559,   560,
     561,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,     0,
     579,   580,     0,   581,     0,   583,   584,   585,   586,   587,
       0,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,     0,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,   615,   616,     0,   617,     0,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   651,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   867,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,   353,     0,
     354,   355,     0,     0,     0,   358,   359,   360,   361,     0,
     362,   363,     0,   364,   365,   366,     0,   367,   368,   369,
     370,   371,     0,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,     0,   384,     0,   386,   387,
     388,   389,   390,   391,   392,     0,   393,     0,   394,     0,
       0,   397,     0,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,     0,   417,   418,     0,   420,     0,     0,   422,
     423,   424,     0,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,     0,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
     460,     0,   461,   462,   463,   464,   465,   466,     0,   467,
     468,   469,     0,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,   477,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,   551,   552,     0,   553,   554,   555,   556,   557,
       0,   559,   560,   561,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,     0,   579,   580,     0,   581,     0,   583,   584,
     585,   586,   587,     0,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,     0,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,     0,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
       0,   617,     0,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   878,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6093,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   879,   260,   880,   881,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   882,   883,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   884,   885,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   886,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   342,   343,   344,
     345,     0,     0,   347,     0,   348,   349,   350,   887,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,     0,     0,     0,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
    2720,   377,   378,   379,   380,   381,   382,   383,     0,   384,
     385,  2721,   387,   388,   389,   390,   888,   889,     0,   890,
       0,   394,   395,   396,   397,   398,   891,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   410,   411,   412,
     413,   414,   415,   416,     0,     0,   417,     0,   419,   420,
     421,     0,   422,   423,   424,     0,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   892,   444,   893,   446,   447,
     448,   449,   450,   451,   452,   453,     0,     0,   456,     0,
     457,   458,   459,   460,     0,     0,   462,   894,   464,   465,
     466,     0,   467,   468,   469,     0,     0,   470,   471,   472,
       0,  2722,   473,   474,  2723,   476,   477,   478,     0,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,     0,   495,     0,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   895,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,   535,   536,
       0,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,   551,   552,     0,   553,   554,
    2724,   556,   557,   558,   559,   560,   897,   562,     0,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,     0,   578,     0,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   898,   899,
       0,     0,   591,   592,     0,   594,     0,     0,   596,   597,
     598,   599,   600,   601,   602,   603,   604,     0,     0,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,   900,  2725,   617,   618,   619,   620,   621,   622,
       0,     0,   623,     0,     0,   624,   625,   626,   627,   628,
     629,     0,     0,     0,  3935,     0,     0,     0,     0,     0,
       0,     0,   641,   642,   643,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
    2726,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,     0,   879,   260,   880,   881,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     882,   883,   274,     0,   275,   276,   277,   278,     0,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,     0,     0,     0,   302,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   884,   885,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     886,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   342,
     343,   344,   345,     0,     0,   347,     0,   348,   349,   350,
     887,   352,     0,   353,     0,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,     0,     0,     0,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,  2720,   377,   378,   379,   380,   381,   382,   383,
       0,   384,   385,  2721,   387,   388,   389,   390,   888,   889,
       0,   890,     0,   394,   395,   396,   397,   398,   891,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,     0,
     419,   420,   421,     0,   422,   423,   424,     0,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   892,   444,   893,
     446,   447,   448,   449,   450,   451,   452,   453,     0,     0,
     456,     0,   457,   458,   459,   460,     0,     0,   462,   894,
     464,   465,   466,     0,   467,   468,   469,     0,     0,   470,
     471,   472,     0,  2722,   473,   474,  2723,   476,   477,   478,
       0,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,     0,   495,     0,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   895,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
     535,   536,     0,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,   551,   552,     0,
     553,   554,  2724,   556,   557,   558,   559,   560,   897,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,     0,   578,     0,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     898,   899,     0,     0,   591,   592,     0,   594,     0,     0,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
       0,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,   900,  2725,   617,   618,   619,   620,
     621,   622,     0,     0,   623,     0,     0,   624,   625,   626,
     627,   628,   629,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   641,   642,   643,   966,     0,  1606,
     710,     0,     0,     0,     0,   771,     0,     0,     0,     0,
       0,     0,  2726,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,     0,     0,
       0,   302,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,  2611,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,  1829,   347,     0,
     348,   349,   350,   351,   352,     0,   353,     0,   354,   355,
     356,     0,   357,   358,   359,   360,   361,     0,   362,   363,
       0,   364,   365,   366,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,     0,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
       0,   417,   418,   419,   420,   421,     0,   422,   423,   424,
       0,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,     0,   457,   458,   459,   460,     0,
     461,   462,   463,   464,   465,   466,     0,   467,   468,   469,
    1830,     0,   470,   471,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,     0,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
       0,   579,   580,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,  1831,   596,   597,   598,   599,   600,   601,   602,
     603,   604,     0,     0,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,     0,   617,
     618,   619,   620,   621,   622,     0,     0,   623,     0,     0,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     966,     0,  1606,   710,     0,     0,     0,     0,   771,     0,
       0,     0,     0,  1607,  1608,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,     0,     0,     0,   302,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,  2616,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
    1829,   347,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,     0,   364,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,     0,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,   418,   419,   420,   421,     0,
     422,   423,   424,     0,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,     0,   457,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,     0,
     467,   468,   469,  1830,     0,   470,   471,   472,     0,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,   551,   552,     0,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,     0,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   590,     0,     0,
     591,   592,   593,   594,   595,  1831,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   966,     0,  1606,   710,     0,     0,     0,
       0,   771,     0,     0,     0,     0,  1607,  1608,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,     0,     0,     0,   302,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,  1829,   347,     0,   348,   349,   350,   351,
     352,     0,   353,     0,   354,   355,   356,     0,   357,   358,
     359,   360,   361,     0,   362,   363,     0,   364,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,   418,   419,
     420,   421,     0,   422,   423,   424,     0,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
       0,   457,   458,   459,   460,     0,   461,   462,   463,   464,
     465,   466,     0,   467,   468,   469,  1830,     0,   470,   471,
     472,     0,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,   551,   552,     0,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,     0,   579,   580,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,  1831,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,     0,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   616,     0,   617,   618,   619,   620,   621,
     622,     0,     0,   623,     0,     0,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   966,     0,     0,   710,
       0,     0,     0,     0,   771,     0,     0,     0,     0,  1607,
    1608,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,     0,     0,     0,
     302,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,  3551,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,  1829,   347,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,     0,
     364,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,     0,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,     0,   422,   423,   424,     0,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,     0,   457,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,     0,   467,   468,   469,  1830,
       0,   470,   471,   472,     0,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,     0,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,  1831,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,     0,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   651,
       0,     0,     0,     0,     0,     0,     0,   771,     0,     0,
       0,     0,   783,   784,     0,     0,   235,   236,   772,   238,
     239,   240,   241,   242,   243,   773,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   774,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,     0,   348,   349,   775,   351,   352,     0,   353,     0,
     354,   776,     0,   777,     0,   358,   359,   360,   361,     0,
     362,   363,     0,   364,   365,   366,     0,   367,   368,   369,
     370,   371,     0,   373,   374,   375,   376,   778,   377,   378,
     379,   380,   381,   382,   383,     0,   384,     0,   386,   387,
     388,   389,   390,   391,   392,     0,   393,     0,   394,     0,
       0,   397,     0,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     779,     0,     0,   417,   418,     0,   420,     0,     0,   422,
     423,   424,     0,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,     0,   445,   446,   447,   780,   449,   450,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
     460,     0,   461,   462,   463,   464,   465,   466,     0,   467,
     468,   469,     0,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,   477,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,     0,   781,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   782,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,   551,   552,     0,   553,   554,   555,   556,   557,
       0,   559,   560,   561,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,     0,   579,   580,     0,   581,     0,   583,   584,
     585,   586,   587,     0,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,     0,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,     0,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
       0,   617,     0,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,  1741,     0,  6422,   710,     0,     0,     0,     0,
     771,     0,     0,     0,     0,   783,   784,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  1742,   244,
     245,   246,  1743,  1744,  1745,  1746,  1747,  1748,  1749,   247,
     248,   249,  1750,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,  1751,   263,   264,   265,
     266,   267,   268,   269,  1752,  1753,   270,   271,   272,   273,
     274,  1754,   275,   276,   277,   278,   279,  1755,   280,  1756,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,  1757,   292,   293,   294,   295,   296,   297,  1758,   298,
     299,   300,   301,  1759,  1760,  1761,   302,  1762,  1763,  1764,
     303,   304,   305,   306,   307,   308,   309,   310,   311,  1765,
     312,  1766,   313,   314,   315,   316,   317,   318,   319,  1767,
     320,   321,   322,   323,  1768,  1769,   324,   325,   326,   327,
     328,  1770,   329,   330,   331,   332,  1771,   333,   334,   335,
     336,  1772,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,  1773,   347,  1774,   348,   349,   350,   351,   352,
    1775,   353,  1776,   354,   355,   356,  1777,   357,   358,   359,
     360,   361,  1778,   362,   363,  1779,   364,   365,   366,  1780,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
    1781,   377,   378,   379,   380,   381,   382,   383,  1782,   384,
     385,   386,   387,   388,   389,   390,   391,   392,  1783,   393,
    1784,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,  1785,  1786,   417,   418,   419,   420,
     421,  1787,   422,   423,   424,  1788,  1789,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,  1790,
     457,   458,   459,   460,  1791,   461,   462,   463,   464,   465,
     466,  1792,   467,   468,   469,  1793,  1794,   470,   471,   472,
    1795,  1796,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
    1797,   491,   492,   493,   494,   495,   496,   497,   498,   499,
    1798,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,  1799,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,  1800,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,  1801,   548,   549,   550,   551,   552,  1802,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,  1803,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,  1804,   579,   580,  1805,   581,
     582,   583,   584,   585,   586,   587,  1806,   588,   589,   590,
    1807,  1808,   591,   592,   593,   594,   595,  1809,   596,   597,
     598,   599,   600,   601,   602,   603,   604,  1810,  1811,   605,
     606,   607,   608,   609,  1812,  1813,   610,   611,   612,   613,
     614,   615,   616,  1814,   617,   618,   619,   620,   621,   622,
    1815,  1816,   623,  1817,  1818,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,  1741,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,  1742,   244,   245,   246,  1743,  1744,  1745,  1746,  1747,
    1748,  1749,   247,   248,   249,  1750,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,  1751,
     263,   264,   265,   266,   267,   268,   269,  1752,  1753,   270,
     271,   272,   273,   274,  1754,   275,   276,   277,   278,   279,
    1755,   280,  1756,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,  1757,   292,   293,   294,   295,   296,
     297,  1758,   298,   299,   300,   301,  1759,  1760,  1761,   302,
    1762,  1763,  1764,   303,   304,   305,   306,   307,   308,   309,
     310,   311,  1765,   312,  1766,   313,   314,   315,   316,   317,
     318,   319,  1767,   320,   321,   322,   323,  1768,  1769,   324,
     325,   326,   327,   328,  1770,   329,   330,   331,   332,  1771,
     333,   334,   335,   336,  1772,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,  1773,   347,  1774,   348,   349,
     350,   351,   352,  1775,   353,  1776,   354,   355,   356,  1777,
     357,   358,   359,   360,   361,  1778,   362,   363,  1779,   364,
     365,   366,  1780,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,  1781,   377,   378,   379,   380,   381,   382,
     383,  1782,   384,   385,   386,   387,   388,   389,   390,   391,
     392,  1783,   393,  1784,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,  1785,  1786,   417,
     418,   419,   420,   421,  1787,   422,   423,   424,  1788,  1789,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,  1790,   457,   458,   459,   460,  1791,   461,   462,
     463,   464,   465,   466,  1792,   467,   468,   469,  1793,  1794,
     470,   471,   472,  1795,  1796,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,  1797,   491,   492,   493,   494,   495,   496,
     497,   498,   499,  1798,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
    1799,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,  1800,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,  1801,   548,   549,   550,   551,   552,
    1802,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,  1803,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,  1804,   579,
     580,  1805,   581,   582,   583,   584,   585,   586,   587,  1806,
     588,   589,   590,  1807,  1808,   591,   592,   593,   594,   595,
    1809,   596,   597,   598,   599,   600,   601,   602,   603,   604,
    1810,  1811,   605,   606,   607,   608,   609,  1812,  1813,   610,
     611,   612,   613,   614,   615,   616,  1814,   617,   618,   619,
     620,   621,   622,  1815,  1816,   623,  1817,  1818,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,  1741,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
    3656,   241,   242,   243,  1742,   244,   245,   246,  1743,  1744,
    1745,  1746,  1747,  1748,  1749,   247,   248,   249,  1750,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,  1751,   263,   264,   265,   266,   267,   268,   269,
    1752,  1753,   270,   271,   272,   273,   274,  1754,   275,   276,
     277,   278,   279,  1755,   280,  1756,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,  1757,   292,   293,
     294,   295,   296,   297,  1758,   298,   299,   300,   301,  1759,
    1760,  1761,   302,  1762,  1763,  1764,   303,   304,   305,   306,
     307,   308,   309,   310,   311,  1765,   312,  1766,   313,   314,
     315,   316,   317,   318,   319,  1767,   320,   321,   322,   323,
    1768,  1769,   324,   325,   326,  3657,   328,  1770,   329,   330,
     331,   332,  1771,   333,   334,   335,   336,  1772,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,  1773,   347,
    1774,   348,   349,   350,   351,   352,  1775,   353,  1776,   354,
     355,   356,  1777,   357,   358,   359,   360,   361,  1778,   362,
     363,  1779,   364,   365,   366,  1780,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,  1781,   377,   378,   379,
     380,   381,   382,   383,  1782,   384,   385,   386,   387,   388,
     389,   390,   391,   392,  1783,   393,  1784,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
    1785,  1786,   417,   418,   419,   420,   421,  1787,   422,   423,
     424,  1788,  1789,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,  1790,   457,   458,   459,   460,
    1791,   461,   462,   463,   464,   465,   466,  1792,   467,   468,
     469,  1793,  1794,   470,   471,   472,  1795,  1796,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,  1797,   491,   492,   493,
     494,   495,   496,   497,   498,   499,  1798,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,  1799,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,  1800,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,  1801,   548,   549,
     550,   551,   552,  1802,  3658,   554,   555,   556,   557,   558,
     559,   560,   561,   562,  1803,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,  1804,   579,   580,  1805,   581,   582,   583,   584,   585,
     586,   587,  1806,   588,   589,   590,  1807,  1808,   591,   592,
     593,   594,   595,  1809,   596,   597,   598,   599,   600,   601,
     602,   603,   604,  1810,  1811,   605,   606,   607,   608,   609,
    1812,  1813,   610,   611,   612,   613,   614,   615,   616,  1814,
     617,   618,   619,   620,   621,   622,  1815,  1816,   623,  1817,
    1818,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   234,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,  1274,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,  1277,     0,  1278,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,  1279,  1280,  1281,  1282,  1283,  1284,  1285,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
    1290,     0,   347,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,   356,     0,   357,   358,   359,   360,
     361,     0,   362,  1293,     0,   364,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,     0,
     394,   395,   396,   397,   398,  3456,  1299,  1300,  1301,  1302,
    1303,  1304,  1305,  1306,   408,  1307,   410,   411,   412,   413,
     414,   415,   416,     0,     0,   417,  1308,   419,   420,   421,
       0,   422,   423,   424,  1309,  1310,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,  1313,   456,     0,   457,
     458,   459,   460,     0,  1316,   462,   463,   464,   465,   466,
       0,   467,   468,   469,     0,     0,   470,   471,   472,     0,
       0,   473,   474,   475,   476,   477,   478,  1319,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,  1320,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,   551,   552,  1323,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,     0,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,  1325,   578,     0,   579,   580,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,     0,
       0,   591,   592,  1328,   594,  1329,     0,   596,   597,   598,
     599,   600,   601,   602,   603,   604,     0,     0,   605,   606,
     607,   608,   609,  1332,     0,   610,   611,   612,   613,   614,
     615,   616,     0,   617,   618,   619,   620,   621,   622,     0,
       0,   623,     0,     0,   624,   625,   626,   627,   628,   629,
     630,  1334,  1335,  1336,  1337,   635,  1338,  1339,  1340,  1341,
     640,   641,   642,   643,   234,     0,  1264,   710,     0,  1265,
    1266,     0,   771,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1270,   260,  1271,  1272,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
    1275,  1276,   274,     0,   275,   276,   277,   278,   279,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,     0,     0,     0,   302,     0,
       0,     0,   303,   304,   305,   306,   307,   308,  1286,  1287,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     886,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,  1291,   347,     0,   348,   349,   350,
    1292,   352,     0,   353,     0,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,     0,   364,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
       0,   384,   385,   386,   387,   388,   389,   390,  1295,  1296,
       0,  1297,     0,   394,   395,   396,   397,   398,  6396,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,     0,   422,   423,   424,     0,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,  1311,   444,  1312,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,     0,   457,   458,   459,   460,  1315,   461,   462,  1317,
     464,   465,   466,     0,   467,   468,   469,     0,     0,   470,
     471,   472,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,  1321,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,   551,   552,     0,
     553,   554,   555,   556,   557,   558,   559,   560,  1324,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,     0,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
    1326,  1327,     0,     0,   591,   592,   593,   594,   595,  1330,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
       0,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,   615,  1333,     0,   617,   618,   619,   620,
     621,   622,     0,     0,   623,     0,     0,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   966,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,  1005,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,     0,     0,
     967,   302,     0,     0,   968,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,   353,     0,   354,   355,
     356,     0,   357,   358,   359,   360,   361,     0,   362,   363,
       0,   364,   365,   366,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,     0,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
       0,   417,   418,   419,   420,   421,     0,   422,   423,   424,
       0,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,     0,   457,   458,   459,   460,     0,
     461,   462,   463,   464,   465,   466,     0,   467,   468,   469,
       0,     0,   470,   471,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
     551,   552,   969,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,     0,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
       0,   579,   580,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,   596,   597,   598,   599,   600,   601,   602,
     603,   604,     0,     0,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,     0,   617,
     618,   619,   620,   621,   622,     0,     0,   623,     0,     0,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     966,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,  1026,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,     0,     0,   967,   302,     0,     0,   968,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,     0,   364,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,     0,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,   418,   419,   420,   421,     0,
     422,   423,   424,     0,     0,   425,   426,   427,   428,  1027,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,     0,   457,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,     0,
     467,   468,   469,     0,     0,   470,   471,   472,     0,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,   551,   552,   969,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,     0,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   590,     0,     0,
     591,   592,   593,   594,   595,     0,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   966,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,     0,     0,   967,   302,     0,     0,
     968,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,   353,     0,   354,   355,   356,     0,   357,   358,
     359,   360,   361,     0,   362,   363,     0,   364,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,   418,   419,
     420,   421,     0,   422,   423,   424,     0,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
       0,   457,   458,   459,   460,     0,   461,   462,   463,   464,
     465,   466,     0,   467,   468,   469,     0,     0,   470,   471,
     472,     0,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,   551,   552,   969,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,     0,   579,   580,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,     0,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,     0,
     605,   606,   607,   608,   609,  2987,     0,   610,   611,   612,
     613,   614,   615,   616,     0,   617,   618,   619,   620,   621,
     622,     0,     0,   623,     0,     0,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   966,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,     0,     0,   967,
     302,     0,     0,   968,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,  4006,
     364,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,     0,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,     0,   422,   423,   424,     0,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,     0,   457,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,     0,   467,   468,   469,     0,
       0,   470,   471,   472,     0,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,   969,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,     0,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,     0,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   966,
       0,     0,   710,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
       0,     0,     0,   302,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,  1829,
     347,     0,   348,   349,   350,   351,   352,     0,   353,     0,
     354,   355,   356,     0,   357,   358,   359,   360,   361,     0,
     362,   363,     0,   364,   365,   366,     0,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,     0,   422,
     423,   424,     0,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,     0,   457,   458,   459,
     460,     0,   461,   462,   463,   464,   465,   466,     0,   467,
     468,   469,  1830,     0,   470,   471,   472,     0,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,   551,   552,     0,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,     0,   579,   580,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,  1831,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,     0,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
       0,   617,   618,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   966,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,   967,   302,     0,     0,   968,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,     0,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
       0,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,     0,   417,   418,   419,   420,
     421,     0,   422,   423,   424,     0,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,     0,
     457,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,     0,   467,   468,   469,     0,     0,   470,   471,   472,
       0,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,   551,   552,   969,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,     0,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,     0,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   590,
       0,     0,   591,   592,   593,   594,   595,     0,   596,   597,
     598,   599,   600,   601,   602,   603,   604,     0,     0,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,   615,   616,     0,   617,   618,   619,   620,   621,   622,
       0,     0,   623,     0,     0,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   966,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,     0,     0,   967,   302,
       0,     0,   968,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,   353,     0,   354,   355,   356,     0,
     357,   358,   359,   360,   361,     0,   362,   363,     0,   364,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,     0,   417,
     418,   419,   420,   421,     0,   422,   423,   424,     0,     0,
     425,   426,   427,   428,  1119,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,     0,   457,   458,   459,   460,     0,   461,   462,
     463,   464,   465,   466,     0,   467,   468,   469,     0,     0,
     470,   471,   472,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,   551,   552,
     969,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,     0,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,     0,   579,
     580,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
       0,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,     0,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,   619,
     620,   621,   622,     0,     0,   623,     0,     0,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   966,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,   967,   302,     0,     0,   968,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
       0,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,     0,   364,   365,   366,     0,   367,   368,   369,   370,
    1161,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,     0,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,   418,   419,   420,   421,     0,   422,   423,
     424,     0,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,     0,   457,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,     0,   467,   468,
     469,     0,     0,   470,   471,   472,     0,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,   969,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,     0,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,   590,     0,     0,   591,   592,
     593,   594,   595,     0,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,     0,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   966,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,   967,   302,     0,     0,   968,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,   356,     0,   357,   358,   359,   360,
     361,     0,   362,   363,     0,   364,   365,   366,     0,   367,
     368,   369,   370,  1174,   372,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,     0,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
       0,   422,   423,   424,     0,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,     0,   457,
     458,   459,   460,     0,   461,   462,   463,   464,   465,   466,
       0,   467,   468,   469,     0,     0,   470,   471,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,   551,   552,   969,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,     0,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,     0,   579,   580,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,     0,
       0,   591,   592,   593,   594,   595,     0,   596,   597,   598,
     599,   600,   601,   602,   603,   604,     0,     0,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,     0,   617,   618,   619,   620,   621,   622,     0,
       0,   623,     0,     0,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   966,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,     0,     0,   967,   302,     0,
       0,   968,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,     0,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,     0,   364,   365,
     366,     0,   367,   368,   369,   370,  1186,   372,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
       0,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,     0,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,     0,   422,   423,   424,     0,     0,   425,
     426,   427,   428,  1187,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,     0,   457,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,     0,   467,   468,   469,     0,     0,   470,
     471,   472,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,   551,   552,   969,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,     0,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     589,   590,     0,     0,   591,   592,   593,   594,   595,     0,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
       0,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,   615,   616,     0,   617,   618,   619,   620,
     621,   622,     0,     0,   623,     0,     0,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   966,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     3,     4,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,     0,     0,
       0,   302,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,   353,     0,   354,   355,
     356,     0,   357,   358,   359,   360,   361,     0,   362,   363,
       0,   364,   365,   366,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,     0,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
       0,   417,   418,   419,   420,   421,     0,   422,   423,   424,
       0,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,     0,   457,   458,   459,   460,     0,
     461,   462,   463,   464,   465,   466,     0,   467,   468,   469,
       0,     0,   470,   471,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,     0,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
       0,   579,   580,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,   596,   597,   598,   599,   600,   601,   602,
     603,   604,     0,     0,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,     0,   617,
     618,   619,   620,   621,   622,     0,     0,   623,     0,     0,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     966,     0,     0,   710,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,     0,     0,     0,   302,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,  2596,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,     0,   364,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,     0,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,   418,   419,   420,   421,     0,
     422,   423,   424,     0,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,     0,   457,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,     0,
     467,   468,   469,     0,     0,   470,   471,   472,     0,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,   551,   552,     0,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,     0,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   590,     0,     0,
     591,   592,   593,   594,   595,     0,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   966,     0,     0,   710,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,     0,     0,     0,   302,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,   353,     0,   354,   355,   356,     0,   357,   358,
     359,   360,   361,     0,   362,   363,     0,   364,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,   418,   419,
     420,   421,     0,   422,   423,   424,     0,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
       0,   457,   458,   459,   460,     0,   461,   462,   463,   464,
     465,   466,     0,   467,   468,   469,     0,     0,   470,   471,
     472,     0,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,   551,   552,     0,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,     0,   579,   580,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,     0,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,     0,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   616,     0,   617,   618,   619,   620,   621,
     622,     0,     0,   623,     0,     0,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   234,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,     0,     0,     0,
     302,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,     0,
     364,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,     0,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,     0,   422,   423,   424,     0,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,     0,   457,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,     0,   467,   468,   469,     0,
       0,   470,   471,   472,     0,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,     0,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,     0,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   234,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
       0,     0,     0,   302,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,   353,     0,
     354,   355,   356,     0,   357,   358,   359,   360,   361,     0,
     362,   363,     0,   364,   365,   366,     0,   367,   368,   369,
     370,  1145,   372,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,     0,   422,
     423,   424,     0,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,     0,   457,   458,   459,
     460,     0,   461,   462,   463,   464,   465,   466,     0,   467,
     468,   469,     0,     0,   470,   471,   472,     0,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,   551,   552,     0,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,     0,   579,   580,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,     0,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,     0,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
       0,   617,   618,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   234,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1158,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,     0,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
       0,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,     0,   417,   418,   419,   420,
     421,     0,   422,   423,   424,     0,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,     0,
     457,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,     0,   467,   468,   469,     0,     0,   470,   471,   472,
       0,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,     0,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,     0,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   590,
       0,     0,   591,   592,   593,   594,   595,     0,   596,   597,
     598,   599,   600,   601,   602,   603,   604,     0,     0,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,   615,   616,     0,   617,   618,   619,   620,   621,   622,
       0,     0,   623,     0,     0,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   234,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,     0,     0,     0,   302,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,   353,     0,   354,   355,   356,     0,
     357,   358,   359,   360,   361,     0,   362,   363,     0,   364,
     365,   366,     0,   367,   368,   369,   370,  1172,   372,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,     0,   417,
     418,   419,   420,   421,     0,   422,   423,   424,     0,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,     0,   457,   458,   459,   460,     0,   461,   462,
     463,   464,   465,   466,     0,   467,   468,   469,     0,     0,
     470,   471,   472,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,   551,   552,
       0,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,     0,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,     0,   579,
     580,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
       0,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,     0,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,   619,
     620,   621,   622,     0,     0,   623,     0,     0,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   234,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,     0,   302,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
       0,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,     0,   364,   365,   366,     0,   367,   368,   369,   370,
    1176,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,     0,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,   418,   419,   420,   421,     0,   422,   423,
     424,     0,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,     0,   457,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,     0,   467,   468,
     469,     0,     0,   470,   471,   472,     0,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,     0,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,     0,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,   590,     0,     0,   591,   592,
     593,   594,   595,     0,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,     0,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   966,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,     0,   302,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,   356,     0,   357,   358,   359,   360,
     361,     0,   362,   363,     0,   364,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,     0,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
       0,   422,   423,   424,     0,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,     0,   457,
     458,   459,   460,     0,   461,   462,   463,   464,   465,   466,
       0,   467,   468,   469,     0,     0,   470,   471,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,     0,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,     0,   579,   580,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,     0,
       0,   591,   592,   593,   594,   595,     0,   596,   597,   598,
     599,   600,   601,   602,   603,   604,     0,     0,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,     0,   617,   618,   619,   620,   621,   622,     0,
       0,   623,     0,     0,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   651,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,  2759,   275,   276,   277,   278,   279,     0,
       0,  2828,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,  2760,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,  2829,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,     0,   348,   349,   350,
     351,   352,     0,   353,  2762,   354,   355,     0,     0,     0,
     358,   359,   360,   361,     0,   362,   363,     0,   364,   365,
     366,     0,   367,   368,   369,   370,  2830,     0,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
       0,   384,     0,   386,   387,   388,   389,   390,   391,   392,
       0,   393,     0,   394,     0,     0,   397,     0,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,   418,
       0,   420,     0,     0,   422,   423,   424,     0,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,     0,   457,   458,     0,   460,     0,   461,   462,   463,
     464,   465,   466,     0,   467,   468,   469,     0,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,   477,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,   499,  2763,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,   551,   552,     0,
     553,   554,   555,   556,   557,     0,   559,   560,   561,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,     0,   579,   580,
       0,   581,     0,   583,   584,   585,   586,   587,     0,   588,
     589,   590,     0,     0,   591,   592,   593,   594,   595,     0,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
    2764,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,   615,   616,     0,   617,     0,   619,   620,
     621,   622,     0,     0,   623,     0,     0,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   651,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,  2759,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,  2760,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,  2829,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,   353,  2762,   354,   355,
       0,     0,     0,   358,   359,   360,   361,     0,   362,   363,
       0,   364,   365,   366,     0,   367,   368,   369,   370,   371,
       0,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,     0,   384,     0,   386,   387,   388,   389,
     390,   391,   392,     0,   393,     0,   394,     0,     0,   397,
       0,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
       0,   417,   418,     0,   420,  3869,     0,   422,   423,   424,
       0,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,     0,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,   460,     0,
     461,   462,   463,   464,   465,   466,     0,   467,   468,   469,
       0,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,   477,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,   499,  2763,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,     0,   529,   530,     0,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
     551,   552,     0,   553,   554,   555,   556,   557,     0,   559,
     560,   561,   562,     0,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
       0,   579,   580,     0,   581,     0,   583,   584,   585,   586,
     587,     0,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,   596,   597,   598,   599,   600,   601,   602,
     603,   604,     0,  2764,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,     0,   617,
       0,   619,   620,   621,   622,     0,     0,   623,     0,     0,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     651,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   829,   242,   243,   790,   244,   791,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   792,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,     0,     0,     0,   358,   359,   360,   361,
     830,   362,   363,     0,   364,   365,   366,     0,   367,   368,
     369,   370,   371,     0,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,     0,   386,
     387,   388,   389,   390,   391,   392,     0,   393,     0,   394,
       0,     0,   397,     0,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,   418,     0,   420,     0,     0,
     422,   423,   424,     0,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,     0,   457,   458,
       0,   460,     0,   461,   462,   463,   464,   465,   466,     0,
     467,   468,   469,     0,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,   477,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   793,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,     0,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   794,
     548,   549,   550,   551,   552,     0,   553,   554,   555,   556,
     557,     0,   559,   560,   561,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,     0,   579,   580,     0,   581,     0,   583,
     584,   585,   586,   587,     0,   588,   589,   590,     0,     0,
     591,   592,   593,   594,   595,     0,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,   615,
     616,     0,   617,     0,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   651,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   790,
     244,   791,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,   792,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,   353,     0,   354,   355,     0,     0,     0,   358,
     359,   360,   361,  3558,   362,   363,     0,   364,   365,   366,
       0,   367,   368,   369,   370,   371,     0,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384,     0,   386,   387,   388,   389,   390,   391,   392,     0,
     393,     0,   394,     0,     0,   397,     0,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,   418,     0,
     420,     0,     0,   422,   423,   424,     0,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,     0,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,   460,     0,   461,   462,   463,   464,
     465,   466,     0,   467,   468,   469,     0,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,   477,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   793,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,     0,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   794,   548,   549,   550,   551,   552,     0,   553,
     554,   555,   556,   557,     0,   559,   560,   561,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,     0,   579,   580,     0,
     581,     0,   583,   584,   585,   586,   587,     0,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,     0,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,     0,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   616,     0,   617,     0,   619,   620,   621,
     622,     0,     0,   623,     0,     0,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   651,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,  2759,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,  2760,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,  2829,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,     0,   348,
     349,   350,   351,   352,     0,   353,  2762,   354,   355,     0,
       0,     0,   358,   359,   360,   361,     0,   362,   363,     0,
     364,   365,   366,     0,   367,   368,   369,   370,   371,     0,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,     0,   386,   387,   388,   389,   390,
     391,   392,     0,   393,     0,   394,     0,     0,   397,     0,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,   418,     0,   420,     0,     0,   422,   423,   424,     0,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,     0,   457,   458,     0,   460,     0,   461,
     462,   463,   464,   465,   466,     0,   467,   468,   469,     0,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
     477,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,  2763,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,     0,   553,   554,   555,   556,   557,     0,   559,   560,
     561,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,     0,
     579,   580,     0,   581,     0,   583,   584,   585,   586,   587,
       0,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,  2764,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,   615,   616,     0,   617,     0,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   651,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   790,   244,   791,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,   792,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,   353,     0,
     354,   355,     0,     0,     0,   358,   359,   360,   361,     0,
     362,   363,     0,   364,   365,   366,     0,   367,   368,   369,
     370,   371,     0,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,     0,   384,     0,   386,   387,
     388,   389,   390,   391,   392,     0,   393,     0,   394,     0,
       0,   397,     0,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,     0,   417,   418,     0,   420,     0,     0,   422,
     423,   424,     0,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,     0,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
     460,     0,   461,   462,   463,   464,   465,   466,     0,   467,
     468,   469,     0,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,   477,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   793,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   794,   548,
     549,   550,   551,   552,     0,   553,   554,   555,   556,   557,
       0,   559,   560,   561,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,     0,   579,   580,     0,   581,     0,   583,   584,
     585,   586,   587,     0,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,     0,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,     0,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
       0,   617,     0,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   651,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  2894,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,  2895,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,     0,   384,
       0,   386,   387,   388,   389,   390,   391,   392,     0,   393,
       0,   394,     0,     0,   397,     0,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,     0,   417,   418,     0,   420,
       0,     0,   422,   423,   424,     0,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,     0,
     457,   458,     0,   460,     0,   461,   462,   463,   464,   465,
     466,     0,   467,   468,   469,     0,   861,   470,   471,   472,
       0,     0,   473,   474,   475,     0,   477,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,     0,   529,   530,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,   551,   552,     0,   553,   554,
     555,   556,   557,     0,   559,   560,   561,   562,     0,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,     0,   579,   580,  2896,   581,
       0,   583,   584,   585,   586,   587,     0,   588,   589,   590,
       0,     0,   591,   592,   593,   594,   595,     0,   596,   597,
     598,   599,   600,   601,   602,   603,   604,     0,     0,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,   615,   616,     0,   617,     0,   619,   620,   621,   622,
       0,     0,   623,     0,     0,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   651,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,  3063,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,  2895,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,   353,     0,   354,   355,     0,     0,
       0,   358,   359,   360,   361,     0,   362,   363,     0,   364,
     365,   366,     0,   367,   368,   369,   370,   371,     0,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,     0,   384,     0,   386,   387,   388,   389,   390,   391,
     392,     0,   393,     0,   394,     0,     0,   397,     0,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,     0,   417,
     418,     0,   420,     0,     0,   422,   423,   424,     0,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,     0,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,   460,     0,   461,   462,
     463,   464,   465,   466,     0,   467,   468,   469,     0,   861,
     470,   471,   472,     0,     0,   473,   474,   475,     0,   477,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,     0,   529,   530,     0,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,   551,   552,
       0,   553,   554,   555,   556,   557,     0,   559,   560,   561,
     562,     0,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,     0,   579,
     580,  2896,   581,     0,   583,   584,   585,   586,   587,     0,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
       0,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,     0,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,     0,   617,     0,   619,
     620,   621,   622,     0,     0,   623,     0,     0,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   651,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,  2006,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,  2007,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,  2008,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
       0,   348,   349,   350,   351,   352,     0,   353,  2009,   354,
     355,     0,     0,     0,  2010,   359,   360,   361,     0,   362,
     363,     0,   364,   365,   366,     0,   367,   368,   369,   370,
     371,     0,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,     0,   386,   387,   388,
     389,   390,   391,   392,     0,   393,     0,   394,     0,     0,
     397,     0,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,  2011,  2012,   416,
       0,     0,   417,   418,     0,   420,     0,     0,   422,   423,
     424,     0,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,     0,   457,   458,     0,   460,
       0,   461,   462,   463,   464,   465,   466,     0,   467,   468,
     469,     0,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,   477,     0,   479,   480,   481,   482,   483,  2013,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,     0,   500,   501,   502,
    2014,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
       0,   532,   533,   534,  2015,   536,   537,   538,   539,   540,
     541,  2016,   543,   544,   545,   546,   547,     0,  2017,   549,
     550,   551,   552,     0,   553,   554,   555,   556,   557,     0,
     559,   560,   561,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,     0,   579,   580,  2018,   581,     0,  2019,   584,   585,
     586,   587,     0,   588,   589,   590,     0,     0,   591,   592,
     593,   594,   595,     0,   596,   597,  2020,   599,   600,   601,
     602,   603,   604,     0,     0,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,     0,
     617,     0,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   651,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   791,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,   792,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,     0,     0,     0,   358,   359,   360,
     361,     0,   362,   363,     0,   364,   365,   366,     0,   367,
     368,   369,   370,   371,     0,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,     0,   384,     0,
     386,   387,   388,   389,   390,   391,   392,     0,   393,     0,
     394,     0,     0,   397,     0,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,     0,   417,   418,     0,   420,     0,
       0,   422,   423,   424,     0,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,     0,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,   460,     0,   461,   462,   463,   464,   465,   466,
       0,   467,   468,   469,     0,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,   477,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   793,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
       0,   529,   530,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     794,   548,   549,   550,   551,   552,     0,   553,   554,   555,
     556,   557,     0,   559,   560,   561,   562,     0,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,     0,   579,   580,     0,   581,     0,
     583,   584,   585,   586,   587,     0,   588,   589,   590,     0,
       0,   591,   592,   593,   594,   595,     0,   596,   597,   598,
     599,   600,   601,   602,   603,   604,     0,     0,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,     0,   617,     0,   619,   620,   621,   622,     0,
       0,   623,     0,     0,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   651,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
    1019,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,     0,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   355,     0,     0,     0,
     358,   359,   360,   361,     0,   362,   363,     0,   364,   365,
     366,     0,   367,   368,   369,   370,  1020,     0,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
       0,   384,     0,   386,   387,   388,   389,   390,   391,   392,
       0,   393,     0,   394,     0,     0,   397,     0,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,   418,
       0,   420,     0,     0,   422,   423,   424,     0,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,     0,   457,   458,     0,   460,     0,   461,   462,   463,
     464,   465,   466,     0,   467,   468,   469,     0,   861,   470,
     471,   472,     0,     0,   473,   474,   475,     0,   477,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,   551,   552,     0,
     553,   554,   555,   556,   557,     0,   559,   560,   561,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,     0,   579,   580,
       0,   581,     0,   583,   584,   585,   586,   587,     0,   588,
     589,   590,     0,     0,   591,   592,   593,   594,   595,     0,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
       0,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,   615,   616,     0,   617,     0,   619,   620,
     621,   622,     0,     0,   623,     0,     0,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   651,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,  3637,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,   353,     0,   354,   355,
       0,     0,     0,   358,   359,   360,   361,     0,   362,   363,
       0,   364,   365,   366,     0,   367,   368,   369,   370,   371,
       0,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,     0,   384,     0,   386,   387,   388,   389,
     390,   391,   392,     0,   393,     0,   394,     0,     0,   397,
       0,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
       0,   417,   418,     0,   420,     0,     0,   422,   423,   424,
       0,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,     0,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,   460,     0,
     461,   462,   463,   464,   465,   466,     0,   467,   468,   469,
       0,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,   477,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,     0,   529,   530,     0,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
     551,   552,     0,   553,   554,   555,   556,   557,     0,   559,
     560,   561,   562,     0,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
       0,   579,   580,     0,   581,     0,   583,   584,   585,   586,
     587,     0,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,   596,   597,   598,   599,   600,   601,   602,
     603,   604,     0,     0,   605,   606,   607,   608,   609,  3638,
       0,   610,   611,   612,   613,   614,   615,   616,     0,   617,
       0,   619,   620,   621,   622,     0,     0,   623,     0,     0,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     651,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,  3650,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,     0,     0,     0,   358,   359,   360,   361,
       0,   362,   363,     0,   364,   365,   366,     0,   367,   368,
     369,   370,   371,     0,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,     0,   386,
     387,   388,   389,   390,   391,   392,     0,   393,     0,   394,
       0,     0,   397,     0,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,   418,     0,   420,     0,     0,
     422,   423,   424,     0,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,     0,   457,   458,
       0,   460,     0,   461,   462,   463,   464,   465,   466,     0,
     467,   468,   469,     0,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,   477,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,     0,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,   551,   552,     0,   553,   554,   555,   556,
     557,     0,   559,   560,   561,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,     0,   579,   580,     0,   581,     0,   583,
     584,   585,   586,   587,     0,   588,   589,   590,     0,     0,
     591,   592,   593,   594,   595,     0,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   605,   606,   607,
     608,   609,  3651,     0,   610,   611,   612,   613,   614,   615,
     616,     0,   617,     0,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   651,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   652,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,   353,     0,   354,   355,     0,     0,     0,   358,
     359,   360,   361,     0,   362,   363,     0,   364,   365,   366,
       0,   367,   368,   369,   370,   371,     0,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384,     0,   386,   387,   388,   389,   390,   391,   392,     0,
     393,     0,   394,     0,     0,   397,     0,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,   418,     0,
     420,     0,     0,   422,   423,   424,     0,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,     0,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,   460,     0,   461,   462,   463,   464,
     465,   466,     0,   467,   468,   469,     0,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,   477,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,     0,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,   551,   552,     0,   553,
     554,   555,   556,   557,     0,   559,   560,   561,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,     0,   579,   580,     0,
     581,     0,   583,   584,   585,   586,   587,     0,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,     0,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,     0,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   616,     0,   617,     0,   619,   620,   621,
     622,     0,     0,   623,     0,     0,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   651,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   701,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,     0,
       0,     0,   358,   359,   360,   361,     0,   362,   363,     0,
     364,   365,   366,     0,   367,   368,   369,   370,   371,     0,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,     0,   386,   387,   388,   389,   390,
     391,   392,     0,   393,     0,   394,     0,     0,   397,     0,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,   418,     0,   420,     0,     0,   422,   423,   424,     0,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,     0,   457,   458,     0,   460,     0,   461,
     462,   463,   464,   465,   466,     0,   467,   468,   469,     0,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
     477,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   702,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,     0,   553,   554,   555,   556,   557,     0,   559,   560,
     561,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,     0,
     579,   580,     0,   581,     0,   583,   584,   585,   586,   587,
       0,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,     0,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,   615,   616,     0,   617,     0,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   651,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   821,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,   353,     0,
     354,   355,     0,     0,     0,   358,   359,   360,   361,     0,
     362,   363,     0,   364,   365,   366,     0,   367,   368,   369,
     370,   371,     0,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,     0,   384,     0,   386,   387,
     388,   389,   390,   391,   392,     0,   393,     0,   394,     0,
       0,   397,     0,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,     0,   417,   418,     0,   420,     0,     0,   422,
     423,   424,     0,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,     0,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
     460,     0,   461,   462,   463,   464,   465,   466,     0,   467,
     468,   469,     0,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,   477,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,   551,   822,     0,   553,   554,   555,   556,   557,
       0,   559,   560,   561,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,     0,   579,   580,     0,   581,     0,   583,   584,
     585,   586,   587,     0,   588,   823,   590,     0,     0,   824,
     592,   593,   594,   595,     0,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,     0,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
       0,   617,     0,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   651,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   855,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,     0,   384,
       0,   386,   387,   388,   389,   390,   391,   392,     0,   393,
       0,   394,     0,     0,   397,     0,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,     0,   417,   418,     0,   420,
       0,     0,   422,   423,   424,     0,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,     0,
     457,   458,     0,   460,     0,   461,   462,   463,   464,   465,
     466,     0,   467,   468,   469,     0,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,   477,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,     0,   529,   530,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,   551,   856,     0,   553,   554,
     555,   556,   557,     0,   559,   560,   561,   562,     0,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,     0,   579,   580,     0,   581,
       0,   583,   584,   585,   586,   587,     0,   588,   857,   590,
       0,     0,   858,   592,   593,   594,   595,     0,   596,   597,
     598,   599,   600,   601,   602,   603,   604,     0,     0,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,   615,   616,     0,   617,     0,   619,   620,   621,   622,
       0,     0,   623,     0,     0,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   651,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,   353,     0,   354,   355,     0,     0,
       0,   358,   359,   360,   361,     0,   362,   363,     0,   364,
     365,   366,     0,   367,   368,   369,   370,   371,     0,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,     0,   384,     0,   386,   387,   388,   389,   390,   391,
     392,     0,   393,     0,   394,     0,     0,   397,     0,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,     0,   417,
     418,     0,   420,     0,     0,   422,   423,   424,     0,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,     0,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,   460,     0,   461,   462,
     463,   464,   465,   466,     0,   467,   468,   469,     0,   861,
     470,   471,   472,     0,     0,   473,   474,   475,     0,   477,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,     0,   529,   530,     0,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,   551,   552,
       0,   553,   554,   555,   556,   557,     0,   559,   560,   561,
     562,     0,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,     0,   579,
     580,     0,   581,     0,   583,   584,   585,   586,   587,     0,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
       0,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,     0,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,     0,   617,     0,   619,
     620,   621,   622,     0,     0,   623,     0,     0,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   651,     0,
       0,     0,     0,     0,     0,     0,     0,   921,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
       0,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     355,     0,     0,     0,   358,   359,   360,   361,     0,   362,
     363,     0,   364,   365,   366,     0,   367,   368,   369,   370,
     371,     0,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,     0,   386,   387,   388,
     389,   390,   391,   392,     0,   393,     0,   394,     0,     0,
     397,     0,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,   418,     0,   420,     0,     0,   422,   423,
     424,     0,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,     0,   457,   458,     0,   460,
       0,   461,   462,   463,   464,   465,   466,     0,   467,   468,
     469,     0,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,   477,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
       0,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,     0,   553,   554,   555,   556,   557,     0,
     559,   560,   561,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,     0,   579,   580,     0,   581,     0,   583,   584,   585,
     586,   587,     0,   588,   589,   590,     0,     0,   591,   592,
     593,   594,   595,     0,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,     0,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,     0,
     617,     0,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   651,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   976,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,     0,     0,     0,   358,   359,   360,
     361,     0,   362,   363,     0,   364,   365,   366,     0,   367,
     368,   369,   370,   977,     0,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,     0,   384,     0,
     386,   387,   388,   389,   390,   391,   392,     0,   393,     0,
     394,     0,     0,   397,     0,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,     0,   417,   418,     0,   420,     0,
       0,   422,   423,   424,     0,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,     0,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,   460,     0,   461,   462,   463,   464,   465,   466,
       0,   467,   468,   469,     0,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,   477,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
       0,   529,   530,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,   551,   552,     0,   553,   554,   555,
     556,   557,     0,   559,   560,   561,   562,     0,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,     0,   579,   580,     0,   581,     0,
     583,   584,   585,   586,   587,     0,   588,   589,   590,     0,
       0,   591,   592,   593,   594,   595,     0,   596,   597,   598,
     599,   600,   601,   602,   603,   604,     0,     0,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,     0,   617,     0,   619,   620,   621,   622,     0,
       0,   623,     0,     0,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   651,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
    1137,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,     0,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   355,     0,     0,     0,
     358,   359,   360,   361,     0,   362,   363,     0,   364,   365,
     366,     0,   367,   368,   369,   370,   371,     0,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
       0,   384,     0,   386,   387,   388,   389,   390,   391,   392,
       0,   393,     0,   394,     0,     0,   397,     0,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,   418,
       0,   420,     0,     0,   422,   423,   424,     0,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,     0,   457,   458,     0,   460,     0,   461,   462,   463,
     464,   465,   466,     0,   467,   468,   469,     0,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,   477,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,   551,   552,     0,
     553,   554,   555,   556,   557,     0,   559,   560,   561,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,     0,   579,   580,
       0,   581,     0,   583,   584,   585,   586,   587,     0,   588,
     589,   590,     0,     0,   591,   592,   593,   594,   595,     0,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
       0,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,   615,   616,     0,   617,     0,   619,   620,
     621,   622,     0,     0,   623,     0,     0,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   651,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,  1393,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,   353,     0,   354,   355,
       0,     0,     0,   358,   359,   360,   361,     0,   362,   363,
       0,   364,   365,   366,     0,   367,   368,   369,   370,   371,
       0,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,     0,   384,     0,   386,   387,   388,   389,
     390,   391,   392,     0,   393,     0,   394,     0,     0,   397,
       0,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
       0,   417,   418,     0,   420,     0,     0,   422,   423,   424,
       0,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,     0,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,   460,     0,
     461,   462,   463,   464,   465,   466,     0,   467,   468,   469,
       0,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,   477,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,     0,   529,   530,     0,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
     551,   552,     0,   553,   554,   555,   556,   557,     0,   559,
     560,   561,   562,     0,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
       0,   579,   580,     0,   581,     0,   583,   584,   585,   586,
     587,     0,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,   596,   597,   598,   599,   600,   601,   602,
     603,   604,     0,     0,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,     0,   617,
       0,   619,   620,   621,   622,     0,     0,   623,     0,     0,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     651,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,  1404,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   841,   271,   272,   273,  1405,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,     0,     0,     0,   358,   359,   360,   361,
       0,   362,   363,     0,   364,   365,   366,     0,   367,   368,
     369,   370,   371,     0,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,     0,   386,
     387,   388,   389,   390,   391,   392,     0,   393,     0,   394,
       0,     0,   397,     0,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,   418,     0,   420,     0,     0,
     422,   423,   424,     0,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   844,   443,     0,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,     0,   457,   458,
       0,   460,     0,   461,   462,   463,   464,   465,   466,     0,
     467,   468,   469,     0,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,   477,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,     0,   845,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   846,   543,   544,   545,   546,   547,     0,
     548,   549,   550,   551,  1397,     0,   553,   554,   555,   556,
     557,     0,   559,   560,   561,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,     0,   579,   580,     0,   581,     0,   583,
     584,   585,   586,   587,     0,   588,   848,   590,     0,     0,
     849,   592,   593,   594,   595,     0,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,   615,
     616,     0,   617,     0,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   850,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   651,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,   353,     0,   354,   355,     0,     0,     0,   358,
     359,   360,   361,     0,   362,   363,     0,   364,   365,   366,
       0,   367,   368,   369,   370,  1550,     0,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384,     0,   386,   387,   388,   389,   390,   391,   392,     0,
     393,     0,   394,     0,     0,   397,     0,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,   418,     0,
     420,     0,     0,   422,   423,   424,     0,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,     0,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,   460,     0,   461,   462,   463,   464,
     465,   466,     0,   467,   468,   469,     0,   861,   470,   471,
     472,     0,     0,   473,   474,   475,     0,   477,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,     0,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,   551,   552,     0,   553,
     554,   555,   556,   557,     0,   559,   560,   561,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,     0,   579,   580,     0,
     581,     0,   583,   584,   585,   586,   587,     0,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,     0,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,     0,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   616,     0,   617,     0,   619,   620,   621,
     622,     0,     0,   623,     0,     0,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   651,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,  1611,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,     0,
       0,     0,   358,   359,   360,   361,     0,   362,   363,     0,
     364,   365,   366,     0,   367,   368,   369,   370,  1612,     0,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,     0,   386,   387,   388,   389,   390,
     391,   392,     0,   393,     0,   394,     0,     0,   397,     0,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,   418,     0,   420,     0,     0,   422,   423,   424,     0,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,     0,   457,   458,     0,   460,     0,   461,
     462,   463,   464,   465,   466,     0,   467,   468,   469,     0,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
     477,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,     0,   553,   554,   555,   556,   557,     0,   559,   560,
     561,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,     0,
     579,   580,     0,   581,     0,   583,   584,   585,   586,   587,
       0,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,     0,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,   615,   616,     0,   617,     0,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   651,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   821,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,   353,     0,
     354,   355,     0,     0,     0,   358,   359,   360,   361,     0,
     362,   363,     0,   364,   365,   366,     0,   367,   368,   369,
     370,   371,     0,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,     0,   384,     0,   386,   387,
     388,   389,   390,   391,   392,     0,   393,     0,   394,     0,
       0,   397,     0,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,     0,   417,   418,     0,   420,     0,     0,   422,
     423,   424,     0,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,     0,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
     460,     0,   461,   462,   463,   464,   465,   466,     0,   467,
     468,   469,     0,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,   477,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,   551,   552,     0,   553,   554,   555,   556,   557,
       0,   559,   560,   561,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,     0,   579,   580,     0,   581,     0,   583,   584,
     585,   586,   587,     0,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,     0,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,     0,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
       0,   617,     0,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   651,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,  3405,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,     0,   384,
       0,   386,   387,   388,   389,   390,   391,   392,     0,   393,
       0,   394,     0,     0,   397,     0,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,     0,   417,   418,     0,   420,
       0,     0,   422,   423,  3406,     0,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,     0,
     457,   458,     0,   460,     0,   461,   462,   463,   464,   465,
     466,     0,   467,   468,   469,     0,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,   477,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,     0,   529,   530,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,   551,   552,     0,   553,   554,
     555,   556,   557,     0,   559,   560,   561,   562,     0,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,     0,   579,   580,  3407,   581,
       0,   583,  3408,   585,  3409,   587,     0,   588,   589,   590,
       0,     0,   591,   592,   593,   594,   595,     0,   596,   597,
     598,   599,   600,   601,   602,   603,   604,     0,     0,   605,
     606,  3410,   608,   609,     0,     0,   610,   611,   612,   613,
     614,   615,   616,     0,   617,     0,   619,   620,   621,   622,
       0,     0,   623,     0,     0,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   651,     0,     0,   710,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,   353,     0,   354,   355,     0,     0,
       0,   358,   359,   360,   361,     0,   362,   363,     0,   364,
     365,   366,     0,   367,   368,   369,   370,   371,     0,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,     0,   384,     0,   386,   387,   388,   389,   390,   391,
     392,     0,   393,     0,   394,     0,     0,   397,     0,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,     0,   417,
     418,     0,   420,     0,     0,   422,   423,   424,     0,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,     0,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,   460,     0,   461,   462,
     463,   464,   465,   466,     0,   467,   468,   469,     0,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,   477,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,     0,   529,   530,     0,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,   551,   552,
       0,   553,   554,   555,   556,   557,     0,   559,   560,   561,
     562,     0,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,     0,   579,
     580,     0,   581,     0,   583,   584,   585,   586,   587,     0,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
       0,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,     0,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,     0,   617,     0,   619,
     620,   621,   622,     0,     0,   623,     0,     0,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   651,     0,
       0,     0,     0,     0,     0,     0,   771,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
       0,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     355,     0,     0,     0,   358,   359,   360,   361,     0,   362,
     363,     0,   364,   365,   366,     0,   367,   368,   369,   370,
     371,     0,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,     0,   386,   387,   388,
     389,   390,   391,   392,     0,   393,     0,   394,     0,     0,
     397,     0,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,   418,     0,   420,     0,     0,   422,   423,
     424,     0,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,     0,   457,   458,     0,   460,
       0,   461,   462,   463,   464,   465,   466,     0,   467,   468,
     469,     0,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,   477,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
       0,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,     0,   553,   554,   555,   556,   557,     0,
     559,   560,   561,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,     0,   579,   580,     0,   581,     0,   583,   584,   585,
     586,   587,     0,   588,   589,   590,     0,     0,   591,   592,
     593,   594,   595,     0,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,     0,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,     0,
     617,     0,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   651,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,  4226,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,     0,     0,     0,   358,   359,   360,
     361,     0,   362,   363,     0,   364,   365,   366,     0,   367,
     368,   369,   370,   371,     0,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,     0,   384,     0,
     386,   387,   388,   389,   390,   391,   392,     0,   393,     0,
     394,     0,     0,   397,     0,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,     0,   417,   418,     0,   420,     0,
       0,   422,   423,   424,     0,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,     0,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,   460,     0,   461,   462,   463,   464,   465,   466,
       0,   467,   468,   469,     0,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,   477,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
       0,   529,   530,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,   551,   552,     0,   553,   554,   555,
     556,   557,     0,   559,   560,   561,   562,     0,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,     0,   579,   580,     0,   581,     0,
     583,   584,   585,   586,   587,     0,   588,   589,   590,     0,
       0,   591,   592,   593,   594,   595,     0,   596,   597,   598,
     599,   600,   601,   602,   603,   604,     0,     0,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,     0,   617,     0,   619,   620,   621,   622,     0,
       0,   623,     0,     0,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   651,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,  4240,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,     0,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   355,     0,     0,     0,
     358,   359,   360,   361,     0,   362,   363,     0,   364,   365,
     366,     0,   367,   368,   369,   370,   371,     0,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
       0,   384,     0,   386,   387,   388,   389,   390,   391,   392,
       0,   393,     0,   394,     0,     0,   397,     0,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,   418,
       0,   420,     0,     0,   422,   423,   424,     0,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,     0,   457,   458,     0,   460,     0,   461,   462,   463,
     464,   465,   466,     0,   467,   468,   469,     0,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,   477,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,   551,   552,     0,
     553,   554,   555,   556,   557,     0,   559,   560,   561,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,     0,   579,   580,
       0,   581,     0,   583,   584,   585,   586,   587,     0,   588,
     589,   590,     0,     0,   591,   592,   593,   594,   595,     0,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
       0,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,   615,   616,     0,   617,     0,   619,   620,
     621,   622,     0,     0,   623,     0,     0,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   651,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,  4923,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,   353,     0,   354,   355,
       0,     0,     0,   358,   359,   360,   361,     0,   362,   363,
       0,   364,   365,   366,     0,   367,   368,   369,   370,   371,
       0,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,     0,   384,     0,   386,   387,   388,   389,
     390,   391,   392,     0,   393,     0,   394,     0,     0,   397,
       0,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
       0,   417,   418,     0,   420,     0,     0,   422,   423,   424,
       0,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,     0,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,   460,     0,
     461,   462,   463,   464,   465,   466,     0,   467,   468,   469,
       0,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,   477,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,     0,   529,   530,     0,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
     551,   552,     0,   553,   554,   555,   556,   557,     0,   559,
     560,   561,   562,     0,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
       0,   579,   580,     0,   581,     0,   583,   584,   585,   586,
     587,     0,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,   596,   597,   598,   599,   600,   601,   602,
     603,   604,     0,     0,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,     0,   617,
       0,   619,   620,   621,   622,     0,     0,   623,     0,     0,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     651,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,  5400,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,     0,     0,     0,   358,   359,   360,   361,
       0,   362,   363,     0,   364,   365,   366,     0,   367,   368,
     369,   370,   371,     0,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,     0,   386,
     387,   388,   389,   390,   391,   392,     0,   393,     0,   394,
       0,     0,   397,     0,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,   418,     0,   420,     0,     0,
     422,   423,   424,     0,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,     0,   457,   458,
       0,   460,     0,   461,   462,   463,   464,   465,   466,     0,
     467,   468,   469,     0,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,   477,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,     0,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,   551,   552,     0,   553,   554,   555,   556,
     557,     0,   559,   560,   561,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,     0,   579,   580,     0,   581,     0,   583,
     584,   585,   586,   587,     0,   588,   589,   590,     0,     0,
     591,   592,   593,   594,   595,     0,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,   615,
     616,     0,   617,     0,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   651,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,   353,     0,   354,   355,     0,     0,     0,   358,
     359,   360,   361,     0,   362,   363,     0,   364,   365,   366,
       0,   367,   368,   369,   370,   371,     0,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384,     0,   386,   387,   388,   389,   390,   391,   392,     0,
     393,     0,   394,     0,     0,   397,     0,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,   418,     0,
     420,     0,     0,   422,   423,   424,     0,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,     0,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,   460,     0,   461,   462,   463,   464,
     465,   466,     0,   467,   468,   469,     0,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,   477,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,     0,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,   551,   552,     0,   553,
     554,   555,   556,   557,     0,   559,   560,   561,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,     0,   579,   580,     0,
     581,     0,   583,   584,   585,   586,   587,     0,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,     0,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,     0,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   616,     0,   617,     0,   619,   620,   621,
     622,     0,     0,   623,     0,     0,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   651,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,     0,
       0,     0,   358,   359,   360,   361,     0,   362,   363,     0,
     364,   365,   366,     0,   367,   368,   369,   370,   371,     0,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,     0,   386,   387,   388,   389,   390,
     391,   392,     0,   393,     0,   394,     0,     0,   397,     0,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,   418,     0,   420,     0,     0,   422,   423,   424,     0,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,     0,   457,   458,     0,   460,     0,   461,
     462,   463,   464,   465,   466,     0,   467,   468,   469,     0,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
     477,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,     0,   553,   554,   555,   556,   557,     0,   559,   560,
     561,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,     0,
     579,   580,     0,   581,     0,   583,   584,   585,   586,   587,
       0,   588,   589,   590,     0,     0,   807,   592,   593,   594,
     595,     0,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,     0,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,   615,   616,     0,   617,     0,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   651,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,   353,     0,
     354,   355,     0,     0,     0,   358,   359,   360,   361,     0,
     362,   363,     0,   364,   365,   366,     0,   367,   368,   369,
     370,   371,     0,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,     0,   384,     0,   386,   387,
     388,   389,   390,   391,   392,     0,   393,     0,   394,     0,
       0,   397,     0,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,     0,   417,   418,     0,   420,     0,     0,   422,
     423,   424,     0,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,     0,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
     460,     0,   461,   462,   463,   464,   465,   466,     0,   467,
     468,   469,     0,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,   477,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     819,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,   551,   552,     0,   553,   554,   555,   556,   557,
       0,   559,   560,   561,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,     0,   579,   580,     0,   581,     0,   583,   584,
     585,   586,   587,     0,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,     0,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,     0,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
       0,   617,     0,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   651,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   841,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   842,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,     0,   384,
       0,   386,   387,   388,   389,   390,   391,   392,     0,   393,
       0,   394,     0,     0,   397,     0,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,     0,   417,   418,     0,   420,
       0,     0,   422,   423,   843,     0,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   844,   443,     0,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,     0,
     457,   458,     0,   460,     0,   461,   462,   463,   464,   465,
     466,     0,   467,   468,   469,     0,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,   477,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,     0,   529,   530,     0,   845,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   846,   543,   544,   545,   546,
     547,     0,   548,   549,   550,   551,   847,     0,   553,   554,
     555,   556,   557,     0,   559,   560,   561,   562,     0,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,     0,   579,   580,     0,   581,
       0,   583,   584,   585,   586,   587,     0,   588,   848,   590,
       0,     0,   849,   592,   593,   594,   595,     0,   596,   597,
     598,   599,   600,   601,   602,   603,   604,     0,     0,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,   615,   616,     0,   617,     0,   619,   620,   621,   622,
       0,     0,   623,     0,     0,   624,   625,   626,   627,   628,
     850,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   651,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,   353,     0,   354,   355,     0,     0,
       0,   358,   359,   360,   361,     0,   362,   363,     0,   364,
     365,   366,     0,   367,   368,   369,   370,   371,     0,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,     0,   384,     0,   386,   387,   388,   389,   390,   391,
     392,     0,   393,     0,   394,     0,     0,   397,     0,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,     0,   417,
     418,     0,   420,     0,     0,   422,   423,   424,     0,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,     0,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,   460,     0,   461,   462,
     463,   464,   465,   466,     0,   467,   468,   469,     0,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,   477,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   873,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,     0,   529,   530,     0,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,   551,   552,
       0,   553,   554,   555,   556,   557,     0,   559,   560,   561,
     562,     0,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,     0,   579,
     580,     0,   581,     0,   583,   584,   585,   586,   587,     0,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
       0,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,     0,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,     0,   617,     0,   619,
     620,   621,   622,     0,     0,   623,     0,     0,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   651,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
       0,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     355,     0,     0,     0,   358,   359,   360,   361,     0,   362,
     363,     0,   364,   365,   366,     0,   367,   368,   369,   370,
    1001,     0,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,     0,   386,   387,   388,
     389,   390,   391,   392,     0,   393,     0,   394,     0,     0,
     397,     0,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,   418,     0,   420,     0,     0,   422,   423,
     424,     0,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,     0,   457,   458,     0,   460,
       0,   461,   462,   463,   464,   465,   466,     0,   467,   468,
     469,     0,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,   477,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
       0,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,     0,   553,   554,   555,   556,   557,     0,
     559,   560,   561,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,     0,   579,   580,     0,   581,     0,   583,   584,   585,
     586,   587,     0,   588,   589,   590,     0,     0,   591,   592,
     593,   594,   595,     0,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,     0,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,     0,
     617,     0,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   651,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,     0,     0,     0,   358,   359,   360,
     361,     0,   362,   363,     0,   364,   365,   366,     0,   367,
     368,   369,   370,  1011,     0,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,     0,   384,     0,
     386,   387,   388,   389,   390,   391,   392,     0,   393,     0,
     394,     0,     0,   397,     0,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,     0,   417,   418,     0,   420,     0,
       0,   422,   423,   424,     0,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,     0,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,   460,     0,   461,   462,   463,   464,   465,   466,
       0,   467,   468,   469,     0,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,   477,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
       0,   529,   530,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,   551,   552,     0,   553,   554,   555,
     556,   557,     0,   559,   560,   561,   562,     0,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,     0,   579,   580,     0,   581,     0,
     583,   584,   585,   586,   587,     0,   588,   589,   590,     0,
       0,   591,   592,   593,   594,   595,     0,   596,   597,   598,
     599,   600,   601,   602,   603,   604,     0,     0,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,     0,   617,     0,   619,   620,   621,   622,     0,
       0,   623,     0,     0,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   651,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,     0,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   355,     0,     0,     0,
     358,   359,   360,   361,     0,   362,   363,     0,   364,   365,
     366,     0,   367,   368,   369,   370,  1014,     0,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
       0,   384,     0,   386,   387,   388,   389,   390,   391,   392,
       0,   393,     0,   394,     0,     0,   397,     0,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,   418,
       0,   420,     0,     0,   422,   423,   424,     0,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,     0,   457,   458,     0,   460,     0,   461,   462,   463,
     464,   465,   466,     0,   467,   468,   469,     0,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,   477,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,   551,   552,     0,
     553,   554,   555,   556,   557,     0,   559,   560,   561,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,     0,   579,   580,
       0,   581,     0,   583,   584,   585,   586,   587,     0,   588,
     589,   590,     0,     0,   591,   592,   593,   594,   595,     0,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
       0,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,   615,   616,     0,   617,     0,   619,   620,
     621,   622,     0,     0,   623,     0,     0,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   651,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,   353,     0,   354,   355,
       0,     0,     0,   358,   359,   360,   361,     0,   362,   363,
       0,   364,   365,   366,     0,   367,   368,   369,   370,  1030,
       0,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,     0,   384,     0,   386,   387,   388,   389,
     390,   391,   392,     0,   393,     0,   394,     0,     0,   397,
       0,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
       0,   417,   418,     0,   420,     0,     0,   422,   423,   424,
       0,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,     0,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,   460,     0,
     461,   462,   463,   464,   465,   466,     0,   467,   468,   469,
       0,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,   477,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,     0,   529,   530,     0,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
     551,   552,     0,   553,   554,   555,   556,   557,     0,   559,
     560,   561,   562,     0,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
       0,   579,   580,     0,   581,     0,   583,   584,   585,   586,
     587,     0,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,   596,   597,   598,   599,   600,   601,   602,
     603,   604,     0,     0,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,     0,   617,
       0,   619,   620,   621,   622,     0,     0,   623,     0,     0,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     651,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,     0,     0,     0,   358,   359,   360,   361,
       0,   362,   363,     0,   364,   365,   366,     0,   367,   368,
     369,   370,  1086,     0,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,     0,   386,
     387,   388,   389,   390,   391,   392,     0,   393,     0,   394,
       0,     0,   397,     0,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,   418,     0,   420,     0,     0,
     422,   423,   424,     0,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,     0,   457,   458,
       0,   460,     0,   461,   462,   463,   464,   465,   466,     0,
     467,   468,   469,     0,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,   477,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,     0,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,   551,   552,     0,   553,   554,   555,   556,
     557,     0,   559,   560,   561,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,     0,   579,   580,     0,   581,     0,   583,
     584,   585,   586,   587,     0,   588,   589,   590,     0,     0,
     591,   592,   593,   594,   595,     0,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,   615,
     616,     0,   617,     0,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   651,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,   353,     0,   354,   355,     0,     0,     0,   358,
     359,   360,   361,     0,   362,   363,     0,   364,   365,   366,
       0,   367,   368,   369,   370,  1091,     0,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384,     0,   386,   387,   388,   389,   390,   391,   392,     0,
     393,     0,   394,     0,     0,   397,     0,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,   418,     0,
     420,     0,     0,   422,   423,   424,     0,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,     0,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,   460,     0,   461,   462,   463,   464,
     465,   466,     0,   467,   468,   469,     0,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,   477,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,     0,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,   551,   552,     0,   553,
     554,   555,   556,   557,     0,   559,   560,   561,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,     0,   579,   580,     0,
     581,     0,   583,   584,   585,   586,   587,     0,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,     0,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,     0,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   616,     0,   617,     0,   619,   620,   621,
     622,     0,     0,   623,     0,     0,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   651,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,     0,
       0,     0,   358,   359,   360,   361,     0,   362,   363,     0,
     364,   365,   366,     0,   367,   368,   369,   370,  1108,     0,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,     0,   386,   387,   388,   389,   390,
     391,   392,     0,   393,     0,   394,     0,     0,   397,     0,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,   418,     0,   420,     0,     0,   422,   423,   424,     0,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,     0,   457,   458,     0,   460,     0,   461,
     462,   463,   464,   465,   466,     0,   467,   468,   469,     0,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
     477,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,     0,   553,   554,   555,   556,   557,     0,   559,   560,
     561,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,     0,
     579,   580,     0,   581,     0,   583,   584,   585,   586,   587,
       0,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,     0,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,   615,   616,     0,   617,     0,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   651,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,   353,     0,
     354,   355,     0,     0,     0,   358,   359,   360,   361,     0,
     362,   363,     0,   364,   365,   366,     0,   367,   368,   369,
     370,  1111,     0,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,     0,   384,     0,   386,   387,
     388,   389,   390,   391,   392,     0,   393,     0,   394,     0,
       0,   397,     0,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,     0,   417,   418,     0,   420,     0,     0,   422,
     423,   424,     0,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,     0,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
     460,     0,   461,   462,   463,   464,   465,   466,     0,   467,
     468,   469,     0,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,   477,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,   551,   552,     0,   553,   554,   555,   556,   557,
       0,   559,   560,   561,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,     0,   579,   580,     0,   581,     0,   583,   584,
     585,   586,   587,     0,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,     0,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,     0,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
       0,   617,     0,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   651,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1113,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,     0,   384,
       0,   386,   387,   388,   389,   390,   391,   392,     0,   393,
       0,   394,     0,     0,   397,     0,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,     0,   417,   418,     0,   420,
       0,     0,   422,   423,   424,     0,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,     0,
     457,   458,     0,   460,     0,   461,   462,   463,   464,   465,
     466,     0,   467,   468,   469,     0,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,   477,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,     0,   529,   530,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,   551,   552,     0,   553,   554,
     555,   556,   557,     0,   559,   560,   561,   562,     0,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,     0,   579,   580,     0,   581,
       0,   583,   584,   585,   586,   587,     0,   588,   589,   590,
       0,     0,   591,   592,   593,   594,   595,     0,   596,   597,
     598,   599,   600,   601,   602,   603,   604,     0,     0,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,   615,   616,     0,   617,     0,   619,   620,   621,   622,
       0,     0,   623,     0,     0,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   651,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,   353,     0,   354,   355,     0,     0,
       0,   358,   359,   360,   361,     0,   362,   363,     0,   364,
     365,   366,     0,   367,   368,   369,   370,  1150,     0,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,     0,   384,     0,   386,   387,   388,   389,   390,   391,
     392,     0,   393,     0,   394,     0,     0,   397,     0,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,     0,   417,
     418,     0,   420,     0,     0,   422,   423,   424,     0,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,     0,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,   460,     0,   461,   462,
     463,   464,   465,   466,     0,   467,   468,   469,     0,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,   477,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,     0,   529,   530,     0,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,   551,   552,
       0,   553,   554,   555,   556,   557,     0,   559,   560,   561,
     562,     0,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,     0,   579,
     580,     0,   581,     0,   583,   584,   585,   586,   587,     0,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
       0,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,     0,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,     0,   617,     0,   619,
     620,   621,   622,     0,     0,   623,     0,     0,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   651,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
       0,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     355,     0,     0,     0,   358,   359,   360,   361,     0,   362,
     363,     0,   364,   365,   366,     0,   367,   368,   369,   370,
    1178,     0,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,     0,   386,   387,   388,
     389,   390,   391,   392,     0,   393,     0,   394,     0,     0,
     397,     0,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,   418,     0,   420,     0,     0,   422,   423,
     424,     0,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,     0,   457,   458,     0,   460,
       0,   461,   462,   463,   464,   465,   466,     0,   467,   468,
     469,     0,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,   477,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
       0,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,     0,   553,   554,   555,   556,   557,     0,
     559,   560,   561,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,     0,   579,   580,     0,   581,     0,   583,   584,   585,
     586,   587,     0,   588,   589,   590,     0,     0,   591,   592,
     593,   594,   595,     0,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,     0,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,     0,
     617,     0,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   651,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,     0,     0,     0,   358,   359,   360,
     361,     0,   362,   363,     0,   364,   365,   366,     0,   367,
     368,   369,   370,  1180,     0,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,     0,   384,     0,
     386,   387,   388,   389,   390,   391,   392,     0,   393,     0,
     394,     0,     0,   397,     0,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,     0,   417,   418,     0,   420,     0,
       0,   422,   423,   424,     0,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,     0,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,   460,     0,   461,   462,   463,   464,   465,   466,
       0,   467,   468,   469,     0,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,   477,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
       0,   529,   530,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,   551,   552,     0,   553,   554,   555,
     556,   557,     0,   559,   560,   561,   562,     0,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,     0,   579,   580,     0,   581,     0,
     583,   584,   585,   586,   587,     0,   588,   589,   590,     0,
       0,   591,   592,   593,   594,   595,     0,   596,   597,   598,
     599,   600,   601,   602,   603,   604,     0,     0,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,     0,   617,     0,   619,   620,   621,   622,     0,
       0,   623,     0,     0,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   651,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,     0,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   355,     0,     0,     0,
     358,   359,   360,   361,     0,   362,   363,     0,   364,   365,
     366,     0,   367,   368,   369,   370,  1190,     0,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
       0,   384,     0,   386,   387,   388,   389,   390,   391,   392,
       0,   393,     0,   394,     0,     0,   397,     0,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,   418,
       0,   420,     0,     0,   422,   423,   424,     0,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,     0,   457,   458,     0,   460,     0,   461,   462,   463,
     464,   465,   466,     0,   467,   468,   469,     0,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,   477,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,   551,   552,     0,
     553,   554,   555,   556,   557,     0,   559,   560,   561,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,     0,   579,   580,
       0,   581,     0,   583,   584,   585,   586,   587,     0,   588,
     589,   590,     0,     0,   591,   592,   593,   594,   595,     0,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
       0,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,   615,   616,     0,   617,     0,   619,   620,
     621,   622,     0,     0,   623,     0,     0,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   651,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,   353,     0,   354,   355,
       0,     0,     0,   358,   359,   360,   361,     0,   362,   363,
       0,   364,   365,   366,     0,   367,   368,   369,   370,  1193,
       0,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,     0,   384,     0,   386,   387,   388,   389,
     390,   391,   392,     0,   393,     0,   394,     0,     0,   397,
       0,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
       0,   417,   418,     0,   420,     0,     0,   422,   423,   424,
       0,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,     0,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,   460,     0,
     461,   462,   463,   464,   465,   466,     0,   467,   468,   469,
       0,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,   477,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,     0,   529,   530,     0,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
     551,   552,     0,   553,   554,   555,   556,   557,     0,   559,
     560,   561,   562,     0,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
       0,   579,   580,     0,   581,     0,   583,   584,   585,   586,
     587,     0,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,   596,   597,   598,   599,   600,   601,   602,
     603,   604,     0,     0,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,     0,   617,
       0,   619,   620,   621,   622,     0,     0,   623,     0,     0,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     651,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,     0,     0,     0,   358,   359,   360,   361,
       0,   362,   363,     0,   364,   365,   366,     0,   367,   368,
     369,   370,  1196,     0,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,     0,   386,
     387,   388,   389,   390,   391,   392,     0,   393,     0,   394,
       0,     0,   397,     0,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,   418,     0,   420,     0,     0,
     422,   423,   424,     0,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,     0,   457,   458,
       0,   460,     0,   461,   462,   463,   464,   465,   466,     0,
     467,   468,   469,     0,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,   477,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,     0,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,   551,   552,     0,   553,   554,   555,   556,
     557,     0,   559,   560,   561,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,     0,   579,   580,     0,   581,     0,   583,
     584,   585,   586,   587,     0,   588,   589,   590,     0,     0,
     591,   592,   593,   594,   595,     0,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,   615,
     616,     0,   617,     0,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   651,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   841,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,   353,     0,   354,   355,     0,     0,     0,   358,
     359,   360,   361,     0,   362,   363,     0,   364,   365,   366,
       0,   367,   368,   369,   370,   371,     0,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384,     0,   386,   387,   388,   389,   390,   391,   392,     0,
     393,     0,   394,     0,     0,   397,     0,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,   418,     0,
     420,     0,     0,   422,   423,   424,     0,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   844,   443,     0,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,   460,     0,   461,   462,   463,   464,
     465,   466,     0,   467,   468,   469,     0,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,   477,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,     0,   845,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   846,   543,   544,   545,
     546,   547,     0,   548,   549,   550,   551,  1397,     0,   553,
     554,   555,   556,   557,     0,   559,   560,   561,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,     0,   579,   580,     0,
     581,     0,   583,   584,   585,   586,   587,     0,   588,   848,
     590,     0,     0,   849,   592,   593,   594,   595,     0,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,     0,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   616,     0,   617,     0,   619,   620,   621,
     622,     0,     0,   623,     0,     0,   624,   625,   626,   627,
     628,   850,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   651,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,     0,
       0,     0,   358,   359,   360,   361,     0,   362,   363,     0,
     364,   365,   366,     0,   367,   368,   369,   370,  1872,     0,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,     0,   386,   387,   388,   389,   390,
     391,   392,     0,   393,     0,   394,     0,     0,   397,     0,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,   418,     0,   420,     0,     0,   422,   423,   424,     0,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,     0,   457,   458,     0,   460,     0,   461,
     462,   463,   464,   465,   466,     0,   467,   468,   469,     0,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
     477,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,     0,   553,   554,   555,   556,   557,     0,   559,   560,
     561,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,     0,
     579,   580,     0,   581,     0,   583,   584,   585,   586,   587,
       0,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,     0,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,   615,   616,     0,   617,     0,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   651,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,   353,     0,
     354,   355,     0,     0,     0,   358,   359,   360,   361,     0,
     362,   363,     0,   364,   365,   366,     0,   367,   368,   369,
     370,  1906,     0,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,     0,   384,     0,   386,   387,
     388,   389,   390,   391,   392,     0,   393,     0,   394,     0,
       0,   397,     0,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,     0,   417,   418,     0,   420,     0,     0,   422,
     423,   424,     0,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,     0,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
     460,     0,   461,   462,   463,   464,   465,   466,     0,   467,
     468,   469,     0,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,   477,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,   551,   552,     0,   553,   554,   555,   556,   557,
       0,   559,   560,   561,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,     0,   579,   580,     0,   581,     0,   583,   584,
     585,   586,   587,     0,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,     0,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,     0,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
       0,   617,     0,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   651,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1908,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,     0,   384,
       0,   386,   387,   388,   389,   390,   391,   392,     0,   393,
       0,   394,     0,     0,   397,     0,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,     0,   417,   418,     0,   420,
       0,     0,   422,   423,   424,     0,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,     0,
     457,   458,     0,   460,     0,   461,   462,   463,   464,   465,
     466,     0,   467,   468,   469,     0,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,   477,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,     0,   529,   530,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,   551,   552,     0,   553,   554,
     555,   556,   557,     0,   559,   560,   561,   562,     0,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,     0,   579,   580,     0,   581,
       0,   583,   584,   585,   586,   587,     0,   588,   589,   590,
       0,     0,   591,   592,   593,   594,   595,     0,   596,   597,
     598,   599,   600,   601,   602,   603,   604,     0,     0,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,   615,   616,     0,   617,     0,   619,   620,   621,   622,
       0,     0,   623,     0,     0,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   651,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,   353,     0,   354,   355,     0,     0,
       0,   358,   359,   360,   361,     0,   362,   363,     0,   364,
     365,   366,     0,   367,   368,   369,   370,  1947,     0,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,     0,   384,     0,   386,   387,   388,   389,   390,   391,
     392,     0,   393,     0,   394,     0,     0,   397,     0,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,     0,   417,
     418,     0,   420,     0,     0,   422,   423,   424,     0,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,     0,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,   460,     0,   461,   462,
     463,   464,   465,   466,     0,   467,   468,   469,     0,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,   477,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,     0,   529,   530,     0,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,   551,   552,
       0,   553,   554,   555,   556,   557,     0,   559,   560,   561,
     562,     0,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,     0,   579,
     580,     0,   581,     0,   583,   584,   585,   586,   587,     0,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
       0,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,     0,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,     0,   617,     0,   619,
     620,   621,   622,     0,     0,   623,     0,     0,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   651,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
       0,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     355,     0,     0,     0,   358,   359,   360,   361,     0,   362,
     363,     0,   364,   365,   366,     0,   367,   368,   369,   370,
    1949,     0,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,     0,   386,   387,   388,
     389,   390,   391,   392,     0,   393,     0,   394,     0,     0,
     397,     0,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,   418,     0,   420,     0,     0,   422,   423,
     424,     0,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,     0,   457,   458,     0,   460,
       0,   461,   462,   463,   464,   465,   466,     0,   467,   468,
     469,     0,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,   477,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
       0,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,     0,   553,   554,   555,   556,   557,     0,
     559,   560,   561,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,     0,   579,   580,     0,   581,     0,   583,   584,   585,
     586,   587,     0,   588,   589,   590,     0,     0,   591,   592,
     593,   594,   595,     0,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,     0,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,     0,
     617,     0,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   651,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,     0,     0,     0,   358,   359,   360,
     361,     0,   362,   363,     0,   364,   365,   366,     0,   367,
     368,   369,   370,  1951,     0,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,     0,   384,     0,
     386,   387,   388,   389,   390,   391,   392,     0,   393,     0,
     394,     0,     0,   397,     0,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,     0,   417,   418,     0,   420,     0,
       0,   422,   423,   424,     0,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,     0,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,   460,     0,   461,   462,   463,   464,   465,   466,
       0,   467,   468,   469,     0,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,   477,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
       0,   529,   530,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,   551,   552,     0,   553,   554,   555,
     556,   557,     0,   559,   560,   561,   562,     0,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,     0,   579,   580,     0,   581,     0,
     583,   584,   585,   586,   587,     0,   588,   589,   590,     0,
       0,   591,   592,   593,   594,   595,     0,   596,   597,   598,
     599,   600,   601,   602,   603,   604,     0,     0,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,     0,   617,     0,   619,   620,   621,   622,     0,
       0,   623,     0,     0,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   651,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,     0,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   355,     0,     0,     0,
     358,   359,   360,   361,     0,   362,   363,     0,   364,   365,
     366,     0,   367,   368,   369,   370,   371,     0,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
       0,   384,     0,   386,   387,   388,   389,   390,   391,   392,
       0,   393,     0,   394,     0,     0,   397,     0,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,   418,
       0,   420,     0,     0,   422,   423,   424,     0,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,     0,   457,   458,     0,   460,     0,   461,   462,   463,
     464,   465,   466,     0,   467,   468,   469,     0,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,   477,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,     0,   532,   533,   534,
     535,   536,   537,   538,   539,  2044,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,   551,   552,     0,
     553,   554,   555,   556,   557,     0,   559,   560,   561,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,     0,   579,   580,
       0,   581,     0,   583,   584,   585,   586,   587,     0,   588,
     589,   590,     0,     0,   591,   592,   593,   594,   595,     0,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
       0,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,   615,   616,     0,   617,     0,   619,   620,
     621,   622,     0,     0,   623,     0,     0,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   651,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,  2712,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,   353,     0,   354,   355,
       0,     0,     0,   358,   359,   360,   361,     0,   362,   363,
       0,   364,   365,   366,     0,   367,   368,   369,   370,   371,
       0,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,     0,   384,     0,   386,   387,   388,   389,
     390,   391,   392,     0,   393,     0,   394,     0,     0,   397,
       0,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
       0,   417,   418,     0,   420,     0,     0,   422,   423,   424,
       0,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,     0,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,   460,     0,
     461,   462,   463,   464,   465,   466,     0,   467,   468,   469,
       0,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,   477,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,     0,   529,   530,     0,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
     551,   552,     0,     0,   554,   555,   556,   557,     0,   559,
     560,   561,   562,     0,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
       0,   579,   580,     0,   581,     0,   583,   584,   585,   586,
     587,     0,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,   596,   597,   598,   599,   600,   601,   602,
     603,   604,     0,     0,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,     0,   617,
       0,   619,   620,   621,   622,     0,     0,   623,     0,     0,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     651,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   841,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,     0,     0,     0,   358,   359,   360,   361,
       0,   362,   363,     0,   364,   365,   366,     0,   367,   368,
     369,   370,   371,     0,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,     0,   386,
     387,   388,   389,   390,   391,   392,     0,   393,     0,   394,
       0,     0,   397,     0,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,   418,     0,   420,     0,     0,
     422,   423,   424,     0,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   844,   443,     0,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,     0,   457,   458,
       0,   460,     0,   461,   462,   463,   464,   465,   466,     0,
     467,   468,   469,     0,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,   477,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,     0,   845,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   846,   543,   544,   545,   546,   547,     0,
     548,   549,   550,   551,  1397,     0,   553,   554,   555,   556,
     557,     0,   559,   560,   561,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,     0,   579,   580,     0,   581,     0,  2746,
     584,   585,   586,   587,     0,   588,   848,   590,     0,     0,
     849,   592,   593,   594,   595,     0,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,   615,
     616,     0,   617,     0,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   850,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   651,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   841,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,   353,     0,   354,   355,     0,     0,     0,   358,
     359,   360,   361,     0,   362,   363,     0,   364,   365,   366,
       0,   367,   368,   369,   370,   371,     0,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384,     0,   386,   387,   388,   389,   390,   391,   392,     0,
     393,     0,   394,     0,     0,   397,     0,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,   418,     0,
     420,     0,     0,   422,   423,   424,     0,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   844,   443,     0,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,   460,     0,   461,   462,   463,   464,
     465,   466,     0,   467,   468,   469,     0,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,   477,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,     0,   845,   533,   534,   535,
     536,   537,   538,   539,   540,   541,  2811,   543,   544,   545,
     546,   547,     0,   548,   549,   550,   551,  2812,     0,   553,
     554,   555,   556,   557,     0,   559,   560,   561,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,     0,   579,   580,     0,
     581,     0,   583,   584,   585,   586,   587,     0,   588,   848,
     590,     0,     0,  2813,   592,   593,   594,   595,     0,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,     0,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   616,     0,   617,     0,   619,   620,   621,
     622,     0,     0,   623,     0,     0,   624,   625,   626,   627,
     628,   850,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   651,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     841,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,     0,
       0,     0,   358,   359,   360,   361,     0,   362,   363,     0,
     364,   365,   366,     0,   367,   368,   369,   370,   371,     0,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,     0,   386,   387,   388,   389,   390,
     391,   392,     0,   393,     0,   394,     0,     0,   397,     0,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,   418,     0,   420,     0,     0,   422,   423,   424,     0,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   844,   443,
       0,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,     0,   457,   458,     0,   460,     0,   461,
     462,   463,   464,   465,   466,     0,   467,   468,   469,     0,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
     477,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,     0,   845,
     533,   534,   535,   536,   537,   538,   539,   540,   541,  2891,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
    2812,     0,   553,   554,   555,   556,   557,     0,   559,   560,
     561,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,     0,
     579,   580,     0,   581,     0,   583,   584,   585,   586,   587,
       0,   588,   848,   590,     0,     0,  2813,   592,   593,   594,
     595,     0,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,     0,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,   615,   616,     0,   617,     0,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   850,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   651,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   841,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,   353,     0,
     354,   355,     0,     0,     0,   358,   359,   360,   361,     0,
     362,   363,     0,   364,   365,   366,     0,   367,   368,   369,
     370,   371,     0,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,     0,   384,     0,   386,   387,
     388,   389,   390,   391,   392,     0,   393,     0,   394,     0,
       0,   397,     0,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,     0,   417,   418,     0,   420,     0,     0,   422,
     423,   424,     0,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   844,   443,     0,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
     460,     0,   461,   462,   463,   464,   465,   466,     0,   467,
     468,   469,     0,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,   477,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,     0,   845,   533,   534,   535,   536,   537,   538,   539,
     540,   541,  2915,   543,   544,   545,   546,   547,     0,   548,
     549,   550,   551,  2812,     0,   553,   554,   555,   556,   557,
       0,   559,   560,   561,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,     0,   579,   580,     0,   581,     0,   583,   584,
     585,   586,   587,     0,   588,   848,   590,     0,     0,  2813,
     592,   593,   594,   595,     0,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,     0,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
       0,   617,     0,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   850,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   651,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  3108,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,     0,   384,
       0,   386,   387,   388,   389,   390,   391,   392,     0,   393,
       0,   394,     0,     0,   397,     0,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,     0,   417,   418,     0,   420,
       0,     0,   422,   423,   424,     0,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,     0,
     457,   458,     0,   460,     0,   461,   462,   463,   464,   465,
     466,     0,   467,   468,   469,     0,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,   477,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,     0,   529,   530,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,   551,   552,     0,   553,   554,
     555,   556,   557,     0,   559,   560,   561,   562,     0,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,     0,   579,   580,     0,   581,
       0,   583,   584,   585,   586,   587,     0,   588,   589,   590,
       0,     0,   591,   592,   593,   594,   595,     0,   596,   597,
     598,   599,   600,   601,   602,   603,   604,     0,     0,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,   615,   616,     0,   617,     0,   619,   620,   621,   622,
       0,     0,   623,     0,     0,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   651,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,   353,     0,   354,   355,     0,     0,
       0,   358,   359,   360,   361,     0,   362,   363,     0,   364,
     365,   366,     0,   367,   368,   369,   370,  3112,     0,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,     0,   384,     0,   386,   387,   388,   389,   390,   391,
     392,     0,   393,     0,   394,     0,     0,   397,     0,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,     0,   417,
     418,     0,   420,     0,     0,   422,   423,   424,     0,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,     0,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,   460,     0,   461,   462,
     463,   464,   465,   466,     0,   467,   468,   469,     0,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,   477,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,     0,   529,   530,     0,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,   551,   552,
       0,   553,   554,   555,   556,   557,     0,   559,   560,   561,
     562,     0,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,     0,   579,
     580,     0,   581,     0,   583,   584,   585,   586,   587,     0,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
       0,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,     0,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,     0,   617,     0,   619,
     620,   621,   622,     0,     0,   623,     0,     0,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   651,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
       0,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     355,     0,     0,     0,   358,   359,   360,   361,     0,   362,
     363,     0,   364,   365,   366,     0,   367,   368,   369,   370,
    3170,     0,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,     0,   386,   387,   388,
     389,   390,   391,   392,     0,   393,     0,   394,     0,     0,
     397,     0,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,   418,     0,   420,     0,     0,   422,   423,
     424,     0,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,     0,   457,   458,     0,   460,
       0,   461,   462,   463,   464,   465,   466,     0,   467,   468,
     469,     0,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,   477,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
       0,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,     0,   553,   554,   555,   556,   557,     0,
     559,   560,   561,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,     0,   579,   580,     0,   581,     0,   583,   584,   585,
     586,   587,     0,   588,   589,   590,     0,     0,   591,   592,
     593,   594,   595,     0,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,     0,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,     0,
     617,     0,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   651,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,     0,     0,     0,   358,   359,   360,
     361,     0,   362,   363,     0,   364,   365,   366,     0,   367,
     368,   369,   370,  3569,     0,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,     0,   384,     0,
     386,   387,   388,   389,   390,   391,   392,     0,   393,     0,
     394,     0,     0,   397,     0,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,     0,   417,   418,     0,   420,     0,
       0,   422,   423,   424,     0,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,     0,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,   460,     0,   461,   462,   463,   464,   465,   466,
       0,   467,   468,   469,     0,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,   477,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,   494,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
       0,   529,   530,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,   551,   552,     0,   553,   554,   555,
     556,   557,     0,   559,   560,   561,   562,     0,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,     0,   579,   580,     0,   581,     0,
     583,   584,   585,   586,   587,     0,   588,   589,   590,     0,
       0,   591,   592,   593,   594,   595,     0,   596,   597,   598,
     599,   600,   601,   602,   603,   604,     0,     0,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,     0,   617,     0,   619,   620,   621,   622,     0,
       0,   623,     0,     0,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   651,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   841,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,     0,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   355,     0,     0,     0,
     358,   359,   360,   361,     0,   362,   363,     0,   364,   365,
     366,     0,   367,   368,   369,   370,   371,     0,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
       0,   384,     0,   386,   387,   388,   389,   390,   391,   392,
       0,   393,     0,   394,     0,     0,   397,     0,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,   418,
       0,   420,     0,     0,   422,   423,   424,     0,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   844,   443,     0,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,     0,   457,   458,     0,   460,     0,   461,   462,   463,
     464,   465,   466,     0,   467,   468,   469,     0,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,   477,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,   494,   495,   496,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,     0,   845,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   846,   543,   544,
     545,   546,   547,     0,   548,   549,   550,   551,  2812,     0,
     553,   554,   555,   556,   557,     0,   559,   560,   561,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,     0,   579,   580,
       0,   581,     0,   583,   584,   585,   586,   587,     0,   588,
     848,   590,     0,     0,  2813,   592,   593,   594,   595,     0,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
       0,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,   615,   616,     0,   617,     0,   619,   620,
     621,   622,     0,     0,   623,     0,     0,   624,   625,   626,
     627,   628,   850,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   651,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,   353,     0,   354,   355,
       0,     0,     0,   358,   359,   360,   361,     0,   362,   363,
       0,   364,   365,   366,     0,   367,   368,   369,   370,  3626,
       0,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,     0,   384,     0,   386,   387,   388,   389,
     390,   391,   392,     0,   393,     0,   394,     0,     0,   397,
       0,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
       0,   417,   418,     0,   420,     0,     0,   422,   423,   424,
       0,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,     0,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,   460,     0,
     461,   462,   463,   464,   465,   466,     0,   467,   468,   469,
       0,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,   477,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,   494,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,     0,   529,   530,     0,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
     551,   552,     0,   553,   554,   555,   556,   557,     0,   559,
     560,   561,   562,     0,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
       0,   579,   580,     0,   581,     0,   583,   584,   585,   586,
     587,     0,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,   596,   597,   598,   599,   600,   601,   602,
     603,   604,     0,     0,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,     0,   617,
       0,   619,   620,   621,   622,     0,     0,   623,     0,     0,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     651,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,     0,     0,     0,   358,   359,   360,   361,
       0,   362,   363,     0,   364,   365,   366,     0,   367,   368,
     369,   370,  3640,     0,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,     0,   386,
     387,   388,   389,   390,   391,   392,     0,   393,     0,   394,
       0,     0,   397,     0,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,   418,     0,   420,     0,     0,
     422,   423,   424,     0,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,     0,   457,   458,
       0,   460,     0,   461,   462,   463,   464,   465,   466,     0,
     467,   468,   469,     0,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,   477,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,   494,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,     0,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,   551,   552,     0,   553,   554,   555,   556,
     557,     0,   559,   560,   561,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,     0,   579,   580,     0,   581,     0,   583,
     584,   585,   586,   587,     0,   588,   589,   590,     0,     0,
     591,   592,   593,   594,   595,     0,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,   615,
     616,     0,   617,     0,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   651,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,   353,     0,   354,   355,     0,     0,     0,   358,
     359,   360,   361,     0,   362,   363,     0,   364,   365,   366,
       0,   367,   368,   369,   370,  3642,     0,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384,     0,   386,   387,   388,   389,   390,   391,   392,     0,
     393,     0,   394,     0,     0,   397,     0,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,   418,     0,
     420,     0,     0,   422,   423,   424,     0,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,     0,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,   460,     0,   461,   462,   463,   464,
     465,   466,     0,   467,   468,   469,     0,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,   477,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,   494,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,     0,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,   551,   552,     0,   553,
     554,   555,   556,   557,     0,   559,   560,   561,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,     0,   579,   580,     0,
     581,     0,   583,   584,   585,   586,   587,     0,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,     0,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,     0,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   616,     0,   617,     0,   619,   620,   621,
     622,     0,     0,   623,     0,     0,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   651,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,     0,
       0,     0,   358,   359,   360,   361,     0,   362,   363,     0,
     364,   365,   366,     0,   367,   368,   369,   370,  3790,     0,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,     0,   386,   387,   388,   389,   390,
     391,   392,     0,   393,     0,   394,     0,     0,   397,     0,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,   418,     0,   420,     0,     0,   422,   423,   424,     0,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,     0,   457,   458,     0,   460,     0,   461,
     462,   463,   464,   465,   466,     0,   467,   468,   469,     0,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
     477,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,   494,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,     0,   553,   554,   555,   556,   557,     0,   559,   560,
     561,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,     0,
     579,   580,     0,   581,     0,   583,   584,   585,   586,   587,
       0,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,     0,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,   615,   616,     0,   617,     0,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   651,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,  3830,   326,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,   353,     0,
     354,   355,     0,     0,     0,   358,   359,   360,   361,     0,
     362,   363,     0,   364,   365,   366,     0,   367,   368,   369,
     370,   371,     0,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,     0,   384,     0,   386,   387,
     388,   389,   390,   391,   392,     0,   393,     0,   394,     0,
       0,   397,     0,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,     0,   417,   418,     0,   420,     0,     0,   422,
     423,   424,     0,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,     0,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
     460,     0,   461,   462,   463,   464,   465,   466,     0,   467,
     468,   469,     0,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,   477,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,   494,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,   551,   552,     0,   553,   554,   555,   556,   557,
       0,   559,   560,   561,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,     0,   579,   580,     0,   581,     0,   583,   584,
     585,   586,   587,     0,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,     0,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,     0,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
       0,   617,     0,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   651,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  5105,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,     0,   384,
       0,   386,   387,   388,   389,   390,   391,   392,     0,   393,
       0,   394,     0,     0,   397,     0,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,     0,   417,   418,     0,   420,
       0,     0,   422,   423,   424,     0,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,     0,
     457,   458,     0,   460,     0,   461,   462,   463,   464,   465,
     466,     0,   467,   468,   469,     0,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,   477,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,   494,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,     0,   529,   530,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,   551,   552,     0,   553,   554,
     555,   556,   557,     0,   559,   560,   561,   562,     0,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,     0,   579,   580,     0,   581,
       0,   583,   584,   585,   586,   587,     0,   588,   589,   590,
       0,     0,   591,   592,   593,   594,   595,     0,   596,   597,
     598,   599,   600,   601,   602,   603,   604,     0,     0,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,   615,   616,     0,   617,     0,   619,   620,   621,   622,
       0,     0,   623,     0,     0,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   651,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,   353,     0,   354,   355,     0,     0,
       0,   358,   359,   360,   361,     0,   362,   363,     0,   364,
     365,   366,     0,   367,   368,   369,   370,   371,     0,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,     0,   384,     0,   386,   387,   388,   389,   390,   391,
     392,     0,   393,     0,   394,     0,     0,   397,     0,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,     0,   417,
     418,     0,   420,     0,     0,   422,   423,   424,     0,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,     0,
     445,  5815,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,   460,     0,   461,   462,
     463,   464,   465,   466,     0,   467,   468,   469,     0,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,   477,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,   494,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,     0,   529,   530,     0,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,   551,   552,
       0,   553,   554,   555,   556,   557,     0,   559,   560,   561,
     562,     0,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,     0,   579,
     580,     0,   581,     0,   583,   584,   585,   586,   587,     0,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
       0,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,     0,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,     0,   617,     0,   619,
     620,   621,   622,     0,     0,   623,     0,     0,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   651,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
       0,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     355,     0,     0,     0,   358,   359,   360,   361,     0,   362,
     363,     0,   364,     0,   366,     0,   367,   368,   369,   370,
     371,     0,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,     0,   386,   387,   388,
     389,   390,   391,   392,     0,   393,     0,   394,     0,     0,
     397,     0,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,   418,     0,   420,     0,     0,   422,   423,
     424,     0,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,     0,   457,   458,     0,   460,
       0,   461,   462,   463,   464,   465,   466,     0,   467,   468,
     469,     0,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,   477,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   488,   489,   490,     0,   491,   492,   493,
     494,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,     0,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
       0,   532,   533,   534,   535,   536,   537,     0,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,     0,   553,   554,   555,   556,   557,     0,
     559,   560,   561,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,     0,   579,   580,     0,   581,     0,   583,   584,   585,
     586,   587,     0,   588,   589,   590,     0,     0,   591,   592,
     593,   594,   595,     0,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,     0,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,     0,
     617,     0,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   878,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
       0,   879,   260,   880,   881,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   882,   883,   274,
       0,   275,   276,   277,   278,     0,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,     0,   302,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   884,   885,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   886,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,     0,   342,   343,   344,   345,
       0,     0,   347,     0,   348,   349,   350,   887,   352,     0,
     353,     0,   354,   355,   356,     0,   357,   358,   359,   360,
     361,     0,   362,     0,     0,     0,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,  2720,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
    2721,   387,   388,   389,   390,   888,   889,     0,   890,     0,
     394,   395,   396,   397,   398,   891,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   410,   411,   412,   413,
     414,   415,   416,     0,     0,   417,     0,   419,   420,   421,
       0,   422,   423,   424,     0,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   892,   444,   893,   446,   447,   448,
     449,   450,   451,   452,   453,     0,     0,   456,     0,   457,
     458,   459,   460,     0,     0,   462,   894,   464,   465,   466,
       0,   467,   468,   469,     0,     0,   470,   471,   472,     0,
       0,   473,   474,  2723,   476,   477,   478,     0,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,     0,   495,     0,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   895,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,   535,   536,     0,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,   551,   552,     0,   553,   554,  2724,
     556,   557,   558,   559,   560,   897,   562,     0,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,     0,   578,     0,   579,   580,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   898,   899,     0,
       0,   591,   592,     0,   594,     0,     0,   596,   597,   598,
     599,   600,   601,   602,   603,   604,     0,     0,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,   900,  2725,   617,   618,   619,   620,   621,   622,     0,
       0,   623,     0,     0,   624,   625,   626,   627,   628,   629,
     878,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   641,   642,   643,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,     0,
     879,   260,   880,   881,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   882,   883,   274,     0,
     275,   276,   277,   278,     0,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,     0,     0,     0,   302,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   884,   885,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   886,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   342,   343,   344,   345,     0,
       0,   347,     0,   348,   349,   350,   887,   352,     0,   353,
       0,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,     0,     0,     0,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,   385,     0,
     387,   388,   389,   390,   888,   889,     0,   890,     0,   394,
     395,   396,   397,   398,   891,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,     0,   419,   420,   421,     0,
     422,   423,   424,     0,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   892,   444,   893,   446,   447,   448,   449,
     450,   451,   452,   453,     0,     0,   456,     0,   457,   458,
     459,   460,  2807,     0,   462,   894,   464,   465,   466,     0,
     467,   468,   469,     0,     0,   470,   471,   472,     0,     0,
     473,   474,     0,   476,   477,   478,     0,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,     0,   495,     0,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     895,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,   535,   536,     0,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,   551,   552,     0,   553,   554,  2724,   556,
     557,   558,   559,   560,   897,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,     0,   578,     0,   579,   580,  4606,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   898,   899,     0,     0,
     591,   592,     0,   594,     0,     0,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
     900,     0,   617,   618,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   629,   878,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     641,   642,   643,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,     0,   879,
     260,   880,   881,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   882,   883,   274,     0,   275,
     276,   277,   278,     0,     0,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
       0,     0,     0,   302,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   884,   885,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   886,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,     0,   342,   343,   344,   345,     0,     0,
     347,     0,   348,   349,   350,   887,   352,     0,   353,     0,
     354,   355,   356,     0,   357,   358,   359,   360,   361,     0,
     362,     0,     0,     0,   365,   366,     0,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,     0,   387,
     388,   389,   390,   888,   889,     0,   890,     0,   394,   395,
     396,   397,   398,   891,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   410,   411,   412,   413,   414,   415,
     416,     0,     0,   417,     0,   419,   420,   421,     0,   422,
     423,   424,     0,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   892,   444,   893,   446,   447,   448,   449,   450,
     451,   452,   453,  2881,     0,   456,     0,   457,   458,   459,
     460,     0,     0,   462,   894,   464,   465,   466,     0,   467,
     468,   469,     0,     0,   470,   471,   472,     0,     0,   473,
     474,     0,   476,   477,   478,     0,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   491,   492,
     493,     0,   495,     0,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   895,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,   535,   536,     0,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,     0,   548,
     549,   550,   551,   552,     0,   553,   554,   896,   556,   557,
     558,   559,   560,   897,   562,     0,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
       0,   578,     0,   579,   580,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   898,   899,     0,     0,   591,
     592,     0,   594,     0,     0,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,     0,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,   900,
       0,   617,   618,   619,   620,   621,   622,     0,     0,   623,
       0,     0,   624,   625,   626,   627,   628,   629,   878,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   641,
     642,   643,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,     0,   879,   260,
     880,   881,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   882,   883,   274,     0,   275,   276,
     277,   278,     0,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,     0,   302,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   884,   885,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   886,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   342,   343,   344,   345,     0,     0,   347,
       0,   348,   349,   350,   887,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
       0,     0,     0,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,     0,   384,   385,     0,   387,   388,
     389,   390,   888,   889,     0,   890,     0,   394,   395,   396,
     397,   398,   891,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   410,   411,   412,   413,   414,   415,   416,
       0,     0,   417,     0,   419,   420,   421,     0,   422,   423,
     424,     0,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   892,   444,   893,   446,   447,   448,   449,   450,   451,
     452,   453,  4402,     0,   456,     0,   457,   458,   459,   460,
       0,     0,   462,   894,   464,   465,   466,     0,   467,   468,
     469,     0,     0,   470,   471,   472,     0,     0,   473,   474,
       0,   476,   477,   478,     0,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,   491,   492,   493,
       0,   495,     0,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   895,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,   535,   536,     0,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,     0,   548,   549,
     550,   551,   552,     0,   553,   554,   896,   556,   557,   558,
     559,   560,   897,   562,     0,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,     0,
     578,     0,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   898,   899,     0,     0,   591,   592,
       0,   594,     0,     0,   596,   597,   598,   599,   600,   601,
     602,   603,   604,     0,     0,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,   900,     0,
     617,   618,   619,   620,   621,   622,     0,     0,   623,     0,
       0,   624,   625,   626,   627,   628,   629,   878,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   641,   642,
     643,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,     0,   879,   260,   880,
     881,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   882,   883,   274,     0,   275,   276,   277,
     278,     0,     0,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,     0,     0,
       0,   302,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   884,   885,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   886,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   337,   338,   339,
     340,     0,   342,   343,   344,   345,     0,     0,   347,     0,
     348,   349,   350,   887,   352,  6016,   353,     0,   354,   355,
     356,     0,   357,   358,   359,   360,   361,     0,   362,     0,
       0,     0,   365,   366,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,     0,   387,   388,   389,
     390,   888,   889,     0,   890,     0,   394,   395,   396,   397,
     398,   891,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   410,   411,   412,   413,   414,   415,   416,     0,
       0,   417,     0,   419,   420,   421,     0,   422,   423,   424,
       0,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     892,   444,   893,   446,   447,   448,   449,   450,   451,   452,
     453,     0,     0,   456,     0,   457,   458,   459,   460,     0,
       0,   462,   894,   464,   465,   466,     0,   467,   468,   469,
       0,     0,   470,   471,   472,     0,     0,   473,   474,     0,
     476,   477,   478,     0,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,   491,   492,   493,     0,
     495,     0,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   895,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,   535,   536,     0,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,     0,   548,   549,   550,
     551,   552,     0,   553,   554,   896,   556,   557,   558,   559,
     560,   897,   562,     0,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,     0,   578,
       0,   579,   580,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   898,   899,     0,     0,   591,   592,     0,
     594,     0,     0,   596,   597,   598,   599,   600,   601,   602,
     603,   604,     0,     0,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,   900,     0,   617,
     618,   619,   620,   621,   622,     0,     0,   623,     0,     0,
     624,   625,   626,   627,   628,   629,   878,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   641,   642,   643,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,     0,   879,   260,   880,   881,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   882,   883,   274,     0,   275,   276,   277,   278,
       0,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,     0,     0,     0,
     302,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     884,   885,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   886,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   342,   343,   344,   345,     0,     0,   347,     0,   348,
     349,   350,   887,   352,  6038,   353,     0,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,     0,     0,
       0,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,     0,   384,   385,     0,   387,   388,   389,   390,
     888,   889,     0,   890,     0,   394,   395,   396,   397,   398,
     891,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   410,   411,   412,   413,   414,   415,   416,     0,     0,
     417,     0,   419,   420,   421,     0,   422,   423,   424,     0,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   892,
     444,   893,   446,   447,   448,   449,   450,   451,   452,   453,
       0,     0,   456,     0,   457,   458,   459,   460,     0,     0,
     462,   894,   464,   465,   466,     0,   467,   468,   469,     0,
       0,   470,   471,   472,     0,     0,   473,   474,     0,   476,
     477,   478,     0,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,   491,   492,   493,     0,   495,
       0,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   895,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,   535,   536,     0,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   548,   549,   550,   551,
     552,     0,   553,   554,   896,   556,   557,   558,   559,   560,
     897,   562,     0,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,     0,   578,     0,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   898,   899,     0,     0,   591,   592,     0,   594,
       0,     0,   596,   597,   598,   599,   600,   601,   602,   603,
     604,     0,     0,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,   900,     0,   617,   618,
     619,   620,   621,   622,     0,     0,   623,     0,     0,   624,
     625,   626,   627,   628,   629,   878,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   641,   642,   643,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,     0,   879,   260,   880,   881,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   882,   883,   274,     0,   275,   276,   277,   278,     0,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,     0,     0,     0,   302,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   884,
     885,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   886,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,     0,
     342,   343,   344,   345,     0,     0,   347,     0,   348,   349,
     350,   887,   352,     0,   353,     0,   354,   355,   356,     0,
     357,   358,   359,   360,   361,     0,   362,     0,     0,     0,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,     0,   387,   388,   389,   390,   888,
     889,     0,   890,     0,   394,   395,   396,   397,   398,   891,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     410,   411,   412,   413,   414,   415,   416,     0,     0,   417,
       0,   419,   420,   421,     0,   422,   423,   424,     0,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   892,   444,
     893,   446,   447,   448,   449,   450,   451,   452,   453,     0,
       0,   456,     0,   457,   458,   459,   460,     0,     0,   462,
     894,   464,   465,   466,     0,   467,   468,   469,     0,     0,
     470,   471,   472,     0,     0,   473,   474,     0,   476,   477,
     478,     0,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,   491,   492,   493,     0,   495,     0,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   895,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,   535,   536,     0,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,     0,   548,   549,   550,   551,   552,
       0,   553,   554,   896,   556,   557,   558,   559,   560,   897,
     562,     0,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,     0,   578,     0,   579,
     580,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   898,   899,     0,     0,   591,   592,     0,   594,     0,
       0,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,     0,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,   900,     0,   617,   618,   619,
     620,   621,   622,     0,     0,   623,     0,     0,   624,   625,
     626,   627,   628,   629,   878,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   641,   642,   643,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,     0,   879,   260,   880,   881,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     882,   883,   274,     0,   275,   276,   277,   278,     0,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,     0,     0,     0,   302,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   884,   885,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     886,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   342,
     343,   344,   345,     0,     0,   347,     0,   348,   349,   350,
     887,   352,     0,   353,     0,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,     0,     0,     0,   365,
     366,     0,   367,   368,   369,   370,  1152,   372,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
       0,   384,   385,     0,   387,   388,   389,   390,   888,   889,
       0,   890,     0,   394,   395,   396,   397,   398,   891,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   410,
     411,   412,   413,   414,   415,   416,     0,     0,   417,     0,
     419,   420,   421,     0,   422,   423,   424,     0,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   892,   444,   893,
     446,   447,   448,   449,   450,   451,   452,   453,     0,     0,
     456,     0,   457,   458,   459,   460,     0,     0,   462,   894,
     464,   465,   466,     0,   467,   468,   469,     0,     0,   470,
     471,   472,     0,     0,   473,   474,     0,   476,   477,   478,
       0,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   491,   492,   493,     0,   495,     0,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   895,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
     535,   536,     0,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,     0,   548,   549,   550,   551,   552,     0,
     553,   554,   896,   556,   557,   558,   559,   560,   897,   562,
       0,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,     0,   578,     0,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     898,   899,     0,     0,   591,   592,     0,   594,     0,     0,
     596,   597,   598,   599,   600,   601,   602,   603,   604,     0,
       0,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,   900,     0,   617,   618,   619,   620,
     621,   622,     0,     0,   623,     0,     0,   624,   625,   626,
     627,   628,   629,   878,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   641,   642,   643,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,     0,   879,   260,   880,   881,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   882,
     883,   274,     0,   275,   276,   277,   278,     0,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,     0,     0,     0,   302,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   884,   885,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   886,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,     0,   342,   343,
     344,   345,     0,     0,   347,     0,   348,   349,   350,   887,
     352,     0,   353,     0,   354,   355,   356,     0,   357,   358,
     359,   360,   361,     0,   362,     0,     0,     0,   365,   366,
       0,   367,   368,   369,   370,  1184,   372,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,     0,   387,   388,   389,   390,   888,   889,     0,
     890,     0,   394,   395,   396,   397,   398,   891,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   410,   411,
     412,   413,   414,   415,   416,     0,     0,   417,     0,   419,
     420,   421,     0,   422,   423,   424,     0,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   892,   444,   893,   446,
     447,   448,   449,   450,   451,   452,   453,     0,     0,   456,
       0,   457,   458,   459,   460,     0,     0,   462,   894,   464,
     465,   466,     0,   467,   468,   469,     0,     0,   470,   471,
     472,     0,     0,   473,   474,     0,   476,   477,   478,     0,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,   491,   492,   493,     0,   495,     0,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   895,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,   535,
     536,     0,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,     0,   548,   549,   550,   551,   552,     0,   553,
     554,   896,   556,   557,   558,   559,   560,   897,   562,     0,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,     0,   578,     0,   579,   580,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   898,
     899,     0,     0,   591,   592,     0,   594,     0,     0,   596,
     597,   598,   599,   600,   601,   602,   603,   604,     0,     0,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,   900,     0,   617,   618,   619,   620,   621,
     622,     0,     0,   623,     0,     0,   624,   625,   626,   627,
     628,   629,   878,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   641,   642,   643,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   879,   260,   880,   881,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   882,   883,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   884,   885,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   886,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   342,   343,   344,
     345,     0,     0,   347,     0,   348,   349,   350,   887,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,     0,     0,     0,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,     0,   384,
     385,     0,   387,   388,   389,   390,   888,   889,     0,   890,
       0,   394,   395,   396,   397,   398,   891,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   410,   411,   412,
     413,   414,   415,   416,     0,     0,   417,     0,   419,   420,
     421,     0,   422,   423,   424,     0,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   892,   444,   893,   446,   447,
     448,   449,   450,   451,   452,   453,     0,     0,   456,     0,
     457,   458,   459,   460,     0,     0,   462,   894,   464,   465,
     466,     0,   467,   468,   469,     0,     0,   470,   471,   472,
       0,     0,   473,   474,     0,   476,   477,   478,     0,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,   491,   492,   493,     0,   495,     0,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   895,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,   535,   536,
       0,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,     0,   548,   549,   550,   551,   552,     0,   553,   554,
    2724,   556,   557,   558,   559,   560,   897,   562,     0,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,     0,   578,     0,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   898,   899,
       0,     0,   591,   592,     0,   594,     0,     0,   596,   597,
     598,   599,   600,   601,   602,   603,   604,     0,     0,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,   900,     0,   617,   618,   619,   620,   621,   622,
       0,     0,   623,     0,     0,   624,   625,   626,   627,   628,
     629,   878,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   641,   642,   643,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
       0,   879,   260,   880,   881,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   882,   883,   274,
       0,   275,   276,   277,   278,     0,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,     0,   302,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   884,   885,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   886,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,     0,   342,   343,   344,   345,
       0,     0,   347,     0,   348,   349,   350,   887,   352,     0,
     353,     0,   354,   355,   356,     0,   357,   358,   359,   360,
     361,     0,   362,     0,     0,     0,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
       0,   387,   388,   389,   390,   888,   889,     0,   890,     0,
     394,   395,   396,   397,   398,   891,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   410,   411,   412,   413,
     414,   415,   416,     0,     0,   417,     0,   419,   420,   421,
       0,   422,   423,   424,     0,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   892,   444,   893,   446,   447,   448,
     449,   450,   451,   452,   453,     0,     0,   456,     0,   457,
     458,   459,   460,     0,     0,   462,   894,   464,   465,   466,
       0,   467,   468,   469,     0,     0,   470,   471,   472,     0,
       0,   473,   474,     0,   476,   477,   478,     0,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
     491,   492,   493,     0,   495,     0,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   895,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,   535,   536,     0,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
       0,   548,   549,   550,   551,   552,     0,   553,   554,     0,
     556,   557,   558,   559,   560,   897,   562,     0,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,     0,   578,     0,   579,   580,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   898,   899,     0,
       0,   591,   592,     0,   594,     0,     0,   596,   597,   598,
     599,   600,   601,   602,   603,   604,     0,     0,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,   900,     0,   617,   618,   619,   620,   621,   622,     0,
       0,   623,     0,     0,   624,   625,   626,   627,   628,   629,
     878,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   641,   642,   643,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,     0,
       0,   260,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,     0,     0,   274,     0,
     275,   276,   277,   278,     0,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,     0,     0,     0,   302,     0,     0,     0,   303,   304,
     305,   306,   307,   308,     0,     0,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   342,   343,   344,   345,     0,
       0,   347,     0,   348,   349,   350,     0,   352,     0,   353,
       0,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,     0,     0,     0,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,     0,   384,   385,     0,
     387,   388,   389,   390,     0,     0,     0,     0,     0,   394,
     395,   396,   397,   398,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   410,   411,   412,   413,   414,
     415,   416,     0,     0,   417,     0,   419,   420,   421,     0,
     422,   423,   424,     0,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   444,     0,   446,   447,   448,   449,
     450,   451,   452,   453,     0,     0,   456,     0,   457,   458,
     459,   460,     0,     0,   462,     0,   464,   465,   466,     0,
     467,   468,   469,     0,     0,   470,   471,   472,     0,     0,
     473,   474,     0,   476,   477,   478,     0,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,   491,
     492,   493,     0,   495,     0,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
       0,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,   535,   536,     0,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,     0,
     548,   549,   550,   551,   552,     0,   553,   554,     0,   556,
     557,   558,   559,   560,     0,   562,     0,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,     0,   578,     0,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,     0,     0,     0,     0,
     591,   592,     0,   594,     0,     0,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,     0,   617,   618,   619,   620,   621,   622,     0,     0,
     623,     0,     0,   624,   625,   626,   627,   628,   629,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     641,   642,   643
};

static const yytype_int16 yycheck[] =
{
       6,     0,     0,  1048,    56,     0,     0,     0,   839,   792,
     793,   794,  1040,     0,     0,   798,   211,     0,   679,   206,
     842,     0,     0,     0,     0,  1225,  1012,   214,  1536,   189,
     217,     0,     0,     0,    21,    21,    36,  1164,   752,  2764,
       0,   658,   935,  1013,   937,    51,  1044,   941,   211,  1582,
     896,  1598,  2706,  1508,  1663,  1038,    45,   866,     0,    22,
     197,     0,  1029,     0,   979,    28,   915,   818,  3056,  1268,
    3230,   711,   884,   885,  1582,  1114,  2707,  2953,  1256,  3630,
     849,   216,   894,  1575,  3207,  2064,  2065,  2066,  1902,  3509,
    3414,   756,  3416,  2072,   711,   230,   734,  3121,   865,  2032,
    2069,   872,  2728,  2729,   953,  3920,  3603,  1731,  3710,   899,
     748,  3068,  2070,  1587,  4075,  2073,  3461,  2975,  3856,  2050,
    1575,  1088,  3083,  4255,    44,  1092,  4302,  3656,  3931,  3658,
    1097,  1628,  1629,  1048,  3904,  1632,  3953,  4345,  3519,   660,
    1107,   758,     8,    23,   978,  4827,  3467,  4298,   757,    15,
    2106,  1698,  1699,  1120,   732,  4582,    36,   735,   175,  1973,
     191,  1565,  3273,  5227,   191,   747,  5227,  4577,  1465,  1003,
       2,  5143,  3517,  4539,  1008,  4380,  3287,  4594,  4843,  5318,
    4845,  3292,  5447,  3294,  1151,  2586,  3483,    35,  3064,  2590,
    5135,   197,  5086,    50,    42,    41,  2691,   964,  4925,   816,
     206,   207,  2623,  2693,  1012,   845,  3529,  5360,   214,  5483,
     216,   217,  3293,  1021,  3295,  4581,  3368,  4892,  1692,  1103,
    3918,  1625,  5495,  1031,   230,   938,   938,  3372,   845,  4277,
     962,  3466,     0,  3468,  1118,  5748,     5,  3472,  1642,     0,
    5134,    11,    11,     0,     6,  1719,   882,   883,     6,  2670,
      11,  5404,     0,   870,    21,     0,  1548,   893,     0,    38,
    5732,  4767,     6,    54,    37,   120,    47,     6,    29,    11,
       6,  1003,    25,  2082,    63,   120,  1008,   148,     6,    43,
       6,    35,    95,     6,    43,  1052,     6,    29,  4669,  4670,
    4671,    29,  4673,  4674,  4675,  4676,  4677,    80,    29,  1082,
       6,   122,     6,     6,     6,   225,     6,    25,     6,    15,
      16,    15,    16,    15,    16,   932,     6,    88,     6,   178,
      13,  3021,   120,  3023,  3024,     6,    13,   142,  3028,  3029,
    3030,    80,  3032,  3033,  3034,     3,     6,     5,     6,    80,
      32,     6,   177,    11,    51,    11,    21,   201,     6,    92,
       6,  1042,    45,    80,   100,     5,   189,  6000,   120,  5411,
    5412,    11,    15,  4571,     6,    92,    78,    29,    37,   177,
       6,   201,   177,    21,    36,    80,  1127,  6140,  6140,    63,
     312,     6,  5633,  3605,  1881,    78,  5436,   140,   177,   306,
    4595,   186,    47,   286,   125,   179,   171,   300,   327,    76,
      63,   178,   327,  5130,   225,   171,  6126,  6127,   297,   177,
      64,    63,  5825,   193,   135,   177,   177,    63,    72,    42,
     177,   300,   140,  1421,   327,    63,  1409,   400,  1199,   177,
      25,  1048,   177,   201,   211,   177,   381,   356,  1477,  1104,
     201,   152,    27,   357,   201,   356,   356,  5960,   327,   226,
     136,  6360,   120,   201,   321,  6290,   201,   441,   476,   201,
     476,   441,   485,  5444,   485,    50,   485,   177,   364,   290,
      13,  1469,   249,   172,  1286,  1287,  5750,   386,    85,  5951,
     351,  1884,   393,   393,   215,   508,    48,    69,    70,   269,
       5,   201,  1407,  1244,  5647,    13,    11,  1412,  1413,  6262,
    6262,  1904,    45,   399,   177,  1317,   415,    29,   207,    71,
     528,   534,   528,   534,    36,   534,   679,     0,   429,   429,
    6429,    13,   320,    29,   308,    63,   299,   197,   295,   215,
      36,   352,   399,  1171,    80,    78,   206,  1327,    21,  5484,
      80,   252,   677,    80,   214,   140,    92,   217,   683,    63,
     534,   100,   220,    45,   534,   528,   369,   471,   177,   478,
     695,   177,   177,    10,   122,  6400,   729,   478,   478,   290,
      17,    18,    19,    56,    13,  1346,   199,   466,   177,  1577,
    1347,   376,    10,   528,   177,    13,    78,   255,   127,    17,
      18,    19,   310,    63,  1232,   333,  1205,   386,   375,   528,
     366,   255,   534,   528,   156,  1243,  6019,   184,    23,   526,
     390,   504,   385,   530,  6334,   184,  6129,   242,  5869,  1257,
     295,  1261,  1389,    32,    92,   528,   303,  6390,  6390,   125,
     299,   216,  1528,   441,   418,  6278,   441,   470,  1553,  1275,
    1276,  5306,  4380,  3865,  1261,  5695,   399,   295,  1563,   528,
     368,   369,   658,   295,  1466,   485,   394,   528,   441,   295,
     441,   392,   426,   518,   371,  1436,   481,   426,  4406,   528,
     664,   677,   330,   207,   472,   367,  1312,   683,   664,   441,
     534,   399,   216,   528,   455,  5959,   370,   441,   477,   695,
     471,  1658,   441,   528,  1661,   433,   230,   435,   471,  1669,
     441,  1729,  1730,   446,   664,   711,   758,   370,   191,    23,
     716,   464,   458,   534,   441,   721,  1430,   475,   370,   725,
     726,   534,   664,    23,   370,   664,   732,   664,   734,   735,
     528,  1502,   370,   464,  6247,  1650,   441,   528,  1653,  1654,
     155,   747,   748,  1551,  1727,   762,  5252,   409,  1632,   528,
     519,   520,   758,   528,  4305,  2047,   518,   527,   519,   520,
     416,   417,   198,   199,  1404,   533,   202,   534,   530,  2664,
     528,   757,   533,  6245,  1465,  4590,   533,   519,   520,  1613,
    4550,   941,  1495,  1495,   528,   533,   222,  1404,   533,   528,
     526,   533,   528,   229,   530,  1412,  1413,  5742,  1682,  1683,
     528,  2001,   528,  1649,  2664,  1613,  1442,  1443,   528,   772,
     816,   774,  4414,   776,   526,  5196,   471,  4419,   530,   782,
    6333,  4591,   528,  4871,   528,   528,   528,   508,   528,   510,
     528,   524,   370,   839,   840,   485,    25,   524,   528,   845,
     528,  1573,  1736,   508,  5896,   510,  6120,   528,  1975,   456,
     534,   519,   520,   519,   520,   528,   370,  4595,   508,   534,
    6133,   308,    23,   528,   870,   518,   872,  1062,  6381,   519,
     520,   534,  1059,   526,  3750,  3751,  1063,   530,  1065,  3755,
     308,  2008,   534,  6148,   804,  4230,  5867,   409,   534,  4234,
     896,  5872,  5873,  2020,  1626,   441,   534,  4218,   929,  1062,
     370,   441,   929,   409,   441,    52,  3532,  4030,  3534,   458,
     468,  1643,  6065,   919,    10,   534,  1053,    13,   534,   534,
     786,    17,    18,    19,    25,  6078,   932,   466,  5992,   481,
    1845,  5992,   931,   931,  3891,   534,   931,   931,   931,  4084,
    4085,   534,  4094,  4641,   931,   931,   866,   261,   931,  4500,
    5625,   140,   931,   931,   931,   931,   955,   534,   367,  1620,
    4071,   261,   931,   931,   931,   534,   381,  4290,   464,  1865,
      21,   931,   381,   441,   383,  6249,   519,   520,   521,   522,
     523,   524,  4217,  4064,  4219,  4220,  5958,   402,   125,   931,
     194,   177,   931,  3488,   931,   155,   534,   843,  1882,  3489,
     286,   847,  4499,   521,   522,   523,   524,  3428,   120,   115,
    5955,    22,  3888,  6052,   171,   201,   873,    28,   269,  5746,
     534,   125,   177,  4168,   205,    68,   946,  1548,   376,   521,
     522,   523,   524,     6,  1040,  1041,  1042,   446,   179,   140,
    2068,   961,  1048,   312,  5938,   100,   716,  1053,  6173,   196,
     120,  2049,  1058,  1059,   201,   725,    72,  1063,  6332,  1065,
    5954,   125,   732,  1069,   534,   735,   178,   221,  6221,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   215,  1085,
     519,   520,   521,   522,   523,   524,   386,   193,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   343,   211,   125,
     261,   113,   168,    37,   251,  2103,   188,    23,  5474,  4406,
     136,   215,   307,   307,   340,   113,     6,   465,   432,  3520,
     322,    72,  1128,   125,  1130,  1131,   113,   223,  1911,  4626,
     267,   123,   432,   322,  3834,   171,     3,   153,    25,   390,
     155,    92,  4562,   677,    31,   173,   312,    23,   462,   683,
      99,   215,   113,  6418,   306,   428,   211,   173,  6130,   195,
    5336,   695,   462,   269,    23,  1171,   272,   308,  5833,  1017,
    1018,  5376,  1863,   487,    25,   364,  6121,    63,    87,   291,
      31,   664,  1629,     6,   470,  1632,   120,   487,  3083,   103,
     306,    10,   465,  1199,    13,  2017,  2018,   399,    17,    18,
      19,    92,   153,   316,   348,   197,    89,   179,    30,   156,
     399,  1828,   308,   215,   528,   281,    35,   443,   149,  1205,
     290,   322,   173,  3083,    91,   386,  1232,    89,   528,   120,
    3856,   667,   163,   669,   183,  1241,   672,  1243,    10,  6364,
      40,    13,   402,   286,   295,    17,    18,    19,   429,   132,
     686,  1257,    23,   140,    54,  1261,   692,   404,   167,  5467,
     529,   316,   488,   364,  1978,   534,  5227,  1273,  6407,   351,
     132,   432,   186,  2728,   757,   758,    23,  2048,   145,  2050,
     469,    25,   528,  6255,   390,  2056,   441,  5714,   392,   140,
     485,  2062,  2063,  2007,  1346,  2828,   490,  2011,   399,   485,
     382,   462,  2016,  2074,  1136,  2019,    10,  1945,  1314,    13,
    5125,   111,  2083,    17,    18,    19,   386,  5744,  2089,  6458,
    3946,  1959,   295,  2797,   528,   341,   487,   464,   485,  5132,
    5740,    35,  6371,  2100,  1972,  4886,  1342,  1343,  1344,  5156,
    1346,  4302,  1208,  5760,  1210,   261,  1212,  5713,  1214,  5119,
    1216,  1217,  1218,   114,   466,     3,  1938,  1223,     6,  6331,
     464,  1367,   307,   518,  1942,  2662,  6430,   528,   534,  6430,
      63,  6343,   286,   345,   120,   530,  1985,  5743,   312,  1957,
     534,   189,  1960,  1053,   528,   261,  3010,   402,  1970,  1059,
     341,   258,   307,  1063,   216,  1065,   140,   503,  1404,   290,
     464,  2875,   261,   458,   223,   295,  1412,  1413,  1425,   396,
    6382,   429,   528,  2817,   214,    23,   529,   429,     3,  2080,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   201,
    1436,   429,  2010,    23,  1881,   322,  2014,  2015,   464,  2130,
    6412,   120,   325,   459,   205,   392,   929,   449,   931,  1480,
    1481,   223,  1483,  1480,  1481,   322,  1483,  1620,  1128,  1465,
    1130,  1131,   464,   325,  3420,  6437,    10,   115,   429,    13,
     386,   322,  5623,    17,    18,    19,  1482,   364,   286,   170,
    1486,  1487,   429,    23,   370,   364,   286,  4832,  4869,   308,
     261,  3100,  4837,   360,    38,  4840,  1502,   364,  3307,  3308,
     321,   368,  1508,  3312,   320,   157,    91,  4828,   459,  6191,
     386,   124,   399,   364,   261,   114,   432,   448,   241,   223,
     113,  5729,   174,   291,   438,   472,  2047,   386,   386,   460,
    5738,  4654,   399,   386,  2093,   294,   308,  2096,   485,    89,
     485,  4664,    39,  3352,  3353,   193,   462,   178,   399,   985,
     986,   434,   399,   125,  5083,   122,   432,   399,   156,  2587,
     145,   508,   441,  3458,     3,   432,  3461,   434,   140,  1575,
     485,   487,   434,   432,   320,   152,  6170,  1497,   322,  1499,
    5788,   528,   132,  4607,   518,   399,   462,  4698,   388,  6253,
    6254,  2589,   526,   286,   528,   529,   530,    99,  3458,   300,
     534,  3461,  4563,   462,   308,   300,   205,  4718,   122,   222,
    1616,   487,   528,  5574,  3509,   386,   295,   119,   485,  1055,
     364,   269,  3517,   180,   272,   386,   327,  3119,   487,   307,
     120,   211,   327,   130,  1070,  1634,   238,   133,  5376,   386,
    1639,   201,   219,  1649,   240,   336,   392,   406,   144,  3509,
     399,   364,   528,   261,   156,   399,   472,  3517,  5473,   149,
    3115,   432,   470,   189,  3119,  1101,  1102,   428,   429,   528,
     528,   261,    58,   258,   399,   528,   122,   370,   330,   223,
    5856,   120,  5485,   429,   286,   432,   399,   534,  4564,  2911,
    1126,   462,   534,   286,  6288,   326,   464,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   399,  2752,  1714,   305,
     368,   225,  4570,   124,  1713,   462,   487,   399,  1717,  6383,
     534,   261,  1205,  1729,  1730,  1731,   472,  5684,   295,  5686,
    1166,  1167,  5940,  5690,  5691,   312,   316,   322,  5870,   485,
     487,   399,   390,   129,   516,   517,   518,   519,   520,   521,
     522,   523,   524,    29,  4380,     3,  1943,   528,   115,  1954,
     286,   772,   508,   774,   308,   776,   338,   528,  1688,  2991,
     189,   782,   783,   784,   405,   325,   290,   662,   386,   225,
    4406,   528,   528,   322,   310,   534,  1269,   386,  4488,   346,
    1953,  1954,    35,  4493,   392,  1932,   386,   135,   171,   137,
     402,  4526,   112,   381,   364,   295,  1289,   485,   368,   534,
     183,   222,   516,   517,   518,   519,   520,   521,   522,   523,
     524,    92,  1828,   380,   432,   364,   322,   528,   201,   428,
     429,   429,   165,   528,  1840,    28,   193,   394,   352,   399,
     321,   482,   432,    91,   290,  1851,   386,   432,   120,   434,
     528,   290,   534,   310,   462,   503,   295,  1863,   360,   135,
     399,  1867,   464,  1346,  4825,   322,    13,   286,   364,   754,
    2641,   143,   462,   430,   472,   122,    13,   149,  2724,   487,
    1886,   458,  2704,     5,   434,   265,   464,   485,  1894,    11,
     392,   330,   432,   534,   408,   165,  1902,   487,   146,    92,
     433,   171,   435,   322,   340,    29,   352,   364,    45,  6117,
     508,   182,   269,   156,  1920,   272,   441,  2080,   399,   252,
     528,   443,   462,  1929,   171,   485,  1932,   429,  6060,  1935,
     528,    78,  1938,  1939,   205,  2921,  1942,  1943,   528,  1945,
    1946,    78,   180,  5758,   470,   364,  5749,   487,   508,   834,
     312,  1957,   290,  1959,  1960,   238,   266,  5302,   286,   207,
     270,  5731,   209,  1969,  1970,   392,  1972,  1973,   979,  4595,
     472,  2662,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   123,   252,   485,   255,    25,   179,    10,   528,   528,
      13,    31,   321,   518,    17,    18,    19,  1480,  1481,  1985,
    1483,   374,   429,   286,  2010,   530,   508,   443,  2014,  2015,
    2925,   135,    35,  2065,   120,  5512,   368,  3144,  2933,  2827,
     477,  2936,   165,   295,  5981,   366,   528,   389,  5188,    15,
      16,  5992,   302,   390,   123,  6243,   364,  1048,  2032,   286,
     311,  2041,  2048,   290,  2050,   472,  2032,   399,   528,  2055,
    2056,   470,   488,   159,   322,   197,  2062,  2063,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,   352,
     399,  2077,  2032,  2079,  3529,  2081,  2082,  2083,  2084,  2085,
    2086,   329,  6258,  2089,  3539,  2091,  2092,  2971,   194,  2095,
    2032,  4070,   122,  2032,   485,  2032,   364,  5085,  4077,  4078,
     140,   528,   168,  2109,  2110,  2111,  2112,  2027,   197,   252,
    3004,  3005,  3006,  2921,  4083,  4046,  2899,     0,  2901,   402,
    6328,  1987,  2128,  1989,  2130,  1991,  3735,  1993,  3620,  1995,
     533,   399,  1568,  1999,  2901,  2752,  5124,  5952,   758,   165,
    2974,  3340,   380,   534,   485,   171,   503,  5104,  5109,   387,
    5953,  2959,   345,   383,  5971,   182,   394,  1593,   534,   302,
    2040,  1634,   433,   466,   435,  3620,  1639,   508,  2859,  3136,
    5330,   528,  5332,  3987,   381,   446,   112,   322,   244,   209,
    1714,   464,  5506,  5712,   290,  2993,   466,  2825,   459,  3813,
     383,   462,   430,   534,  2885,  3819,   816,  5073,    35,  5075,
     223,   322,    94,  3087,  3088,  3089,  3090,   322,  3092,   457,
    6386,  3708,  5763,   322,   452,   360,   446,   465,    80,   364,
     468,   381,   429,   383,  5373,   528,   252,   441,   255,   383,
      92,   485,   443,  3117,  1670,  2949,   172,  2951,   265,    38,
    1713,  2955,   154,   364,  1717,   137,   487,   368,   528,   364,
     870,   444,   466,   446,   399,   364,   286,   450,  4216,  1929,
     290,    60,  1932,   120,  1700,  1701,  1702,  1703,   509,  2275,
    5419,   207,  1942,  1943,   322,  4208,   302,   488,   399,  3194,
     534,   152,   320,  3757,   399,   308,   446,  1957,  5785,   446,
    1960,   203,   446,  2984,   165,   369,  4105,  4106,  4107,  4108,
     171,    29,  4111,  4112,  4113,  4114,  4115,  4116,  4117,  4118,
    4119,  4120,   932,   112,   171,    32,   364,  5737,   343,  6122,
     322,   322,  2328,     5,  3523,   399,  6287,  3110,  3802,    11,
     266,   774,   775,   776,   270,  4230,   779,   780,   781,  4234,
    2010,   485,    59,   352,  2014,  2015,   789,  5047,   219,  5049,
    5050,  5051,  1886,   264,   392,    83,   365,    25,    86,  3050,
    1894,  5322,   364,   364,   508,    93,  4175,  4176,  1902,  5693,
    4230,     3,   299,   290,  4234,  5336,   171,  2383,   295,   290,
    3927,   252,   179,   381,   528,  4927,   395,   478,   265,     5,
     171,   429,  4934,   121,    26,    11,  1407,   399,   399,  5522,
     195,  1412,  1413,    19,  3069,   204,   433,  4302,   435,    72,
    1846,  1847,  1946,   290,   195,   212,   414,   389,    80,   280,
    1626,    37,   143,    91,   518,   485,  1862,    27,   149,  1440,
      92,   302,   349,  1007,   472,   462,   530,  1643,  1449,  1973,
    1451,   312,  4302,   304,  1455,  6248,   242,   485,   508,   529,
      50,  1462,  1026,   181,   534,  1029,  6058,   120,   143,    91,
    1896,  1897,  1898,  1899,   149,   133,   194,   266,   485,  6430,
     508,   270,   140,   527,  3225,  3226,   144,  3191,   206,   528,
     534,  6446,   143,  6448,   508,   527,   510,   286,   149,  6259,
     528,   508,   534,   516,   517,   518,   519,   520,   521,   522,
     523,   524,  1985,  6468,   528,  3272,  3421,   433,    10,   435,
     152,    13,  6063,  6064,   146,    17,    18,    19,   181,    33,
      34,  3415,   321,   165,    72,    38,    22,  5343,  5344,   171,
      78,  5855,    28,    35,  5495,   508,   268,   510,  3309,   526,
    1976,   392,  1553,   530,    92,   528,  1982,    60,  5649,  2032,
    3321,   529,  1563,  5654,  5655,   528,   534,   446,  2564,  2565,
    2566,  2567,  2568,  2569,  2570,  2571,  2572,   389,  2574,   201,
     369,   529,   120,   366,   122,   207,   534,   219,   429,  2585,
      96,  2587,  2065,   521,   529,  3356,   265,   458,   526,   534,
     528,   182,   530,  2788,   393,   265,  1607,  1608,   195,   112,
    2787,   205,  2789,  2790,   529,  2088,   521,   529,   268,   534,
     252,   526,   534,   528,   413,   530,   526,  5578,   528,  2625,
     530,   472,   528,  2629,   530,  2788,  2632,   290,  2634,  3400,
     446,  2637,   295,   181,   485,  2641,  3606,  2624,   478,  1650,
    3331,   389,  1653,  1654,    87,  6415,  3337,  2784,   529,  3418,
    3440,  3441,   152,   534,   322,   526,  2662,   508,  2664,   530,
     302,   209,  3632,  6214,   255,   165,    59,  4562,  4563,   523,
     312,   171,   381,   382,   528,  2681,   530,   528,   341,   381,
     382,  3530,   529,   529,  2690,  2691,   533,   415,   534,  2824,
     418,   204,   360,   523,   529,   358,   364,   329,   528,   534,
     530,   529,  4562,  4563,   529,   529,   534,  3474,   533,  4518,
     534,  2717,   100,  3711,  3375,   529,  3916,   242,  2724,   219,
     534,   223,  2728,  2729,  5424,  2655,  2656,  2657,  3540,  2735,
     529,   399,  2168,  2739,   306,   529,   528,  2743,   406,   311,
     534,  5765,   290,  4352,   376,   292,  2752,   295,   428,  2709,
    5376,  5627,   252,   266,  2754,    11,  2756,   270,  4572,  5635,
    5636,  5808,  5809,  1206,  2770,   356,  1209,  2773,  1211,  6320,
    1213,   528,  1215,   286,   529,  2910,  1219,   476,  2784,   534,
    2786,  2787,   100,  2789,  2790,   306,  2792,   529,   386,  2752,
     178,   534,   534,   341,   528,   427,   459,  2280,  2804,  3607,
     381,   382,   302,  4350,  3421,  4352,   308,    59,   321,  4342,
     358,  3320,   312,  3322,  3323,   529,   458,   529,  2824,  2825,
     534,   100,   534,   211,   529,   457,   529,  2833,   526,   534,
     528,   534,   529,   465,  1845,  4290,   468,   534,   226,   381,
     382,   529,   433,  3557,   435,   392,   534,    38,   478,  2855,
    2856,  4029,   529,  2859,  4328,  2990,   369,   534,  3897,    87,
     178,   249,    48,  6183,  6184,  6185,  6186,  6187,  6188,    60,
     505,   462,  5498,   529,   225,  3683,  2796,  2883,   534,  2885,
     393,   529,   429,  2889,  6208,   529,   534,   478,   309,   277,
     534,   530,  3859,   211,   309,  5856,  6056,  2903,   171,   178,
     413,   529,    33,    34,  2910,   529,   534,  2913,   226,   529,
     534,   459,  4386,  2919,   534,   529,  3554,  3555,   306,   306,
     534,   112,   529,   505,  3707,   472,   306,   534,  3711,   306,
    4825,   249,   211,  2939,   311,   529,   309,  4832,   485,  2945,
     534,  2664,  4837,   529,  3584,  4840,  2952,   226,   534,  6006,
    6007,   529,   529,    48,   291,   292,   534,   534,   458,   277,
    2966,   508,   528,   225,   530,  4825,   529,  3584,    99,  3853,
     249,   534,  4832,  2979,    54,    55,  2896,  4837,  2984,  5610,
    4840,   528,   529,   505,  2990,  2948,   533,   375,   119,   433,
     181,   435,   529,   152,  2664,   529,  5957,   534,   277,   485,
     534,   487,  3008,  3009,  3010,   529,   165,   433,  3014,   435,
     534,  3762,   171,   204,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   529,   521,   156,   526,   306,   534,   529,
     530,   176,   337,  1003,   529,  3041,  3042,  4584,  1008,   534,
     529,   529,   475,    54,  3050,   534,   534,  2058,  2059,   529,
    3237,   529,  3239,  3240,   534,   392,   534,   375,   534,   528,
     219,   529,  3700,  6387,  2075,  2076,   534,   529,   529,   529,
     528,  4579,   534,   534,   534,   266,  4275,  3083,   466,   270,
     529,   529,    37,   529,  3722,   534,   534,   152,   534,   508,
     101,   510,   429,   252,  2105,   286,   375,  3234,   528,   485,
     165,   487,  3885,  4303,  4304,   529,   171,  4307,  4600,  3115,
     534,   529,   528,  3119,  2784,   126,   534,  2787,   529,  2789,
    2790,   529,  4037,   534,   529,  6449,   534,   529,  6116,   534,
     321,   529,   534,   529,   145,   472,   534,   529,   534,   150,
     529,    59,  3102,   302,   529,  4600,   529,  2630,   485,   534,
    4148,   534,   177,   312,   219,   529,   489,   529,   529,   221,
     534,   172,   534,   534,  3855,   176,   221,   530,   529,   529,
     529,   508,  6133,   534,   534,   534,   364,   529,   369,   529,
     191,  2664,   534,  2717,   534,   529,   528,   252,   529,  3903,
     534,   528,  2628,   534,   485,   529,   487,   528,  5852,  3205,
     534,  2735,   393,   529,  4013,  2739,   529,   528,   534,  2743,
      10,   534,  3375,    13,  5109,  3221,   485,  3223,   487,  4202,
     529,  3861,   413,  3863,  3230,   534,  2709,   529,  3234,   360,
    3236,  3237,   534,  3239,  3240,  3241,  2770,   302,  3876,   135,
    3878,   137,   528,  3249,  3861,    45,  3863,   312,  3254,  5109,
    4248,   529,    52,   529,   529,   529,   534,  3309,   534,   534,
     534,   392,   529,   529,   529,  3271,   529,   534,   534,   534,
    2804,   534,   529,   201,   529,   529,   529,   534,    78,   534,
     534,   534,     0,   529,   295,   157,  4000,  4285,   534,   529,
    2824,  6252,   528,   530,   534,   529,   157,  6258,   429,   458,
     534,  3307,  3308,  3309,  3356,  3945,  3312,    62,   529,   282,
     283,   284,   285,   534,  3320,  3321,  3322,  3323,   529,   529,
    3483,   306,  2856,   534,   534,  3331,   201,   364,  3945,  4100,
    3336,  3337,  4941,  3339,  4199,  3341,  4201,  4814,   349,  4816,
    4235,   472,  4237,    98,   306,   476,  3352,  3353,   157,  2883,
    3356,  1497,   157,  1499,   485,  2889,  5282,  2793,  5284,   201,
    3083,   157,   306,  4134,   171,   364,   157,   250,   122,  2903,
     466,  3377,   306,  3379,   528,  3381,  2910,   508,   299,  2913,
     529,    99,   171,    72,  4351,  2919,   290,    38,  4921,   290,
    4028,   489,   528,   458,  3400,   306,   196,   528,   290,    48,
      48,   201,   290,   451,   290,  2939,   161,  5302,    91,  3461,
    6135,  2945,   322,  3083,  4185,  3421,   446,   478,  2952,  3408,
    3409,  3410,   478,  4623,   171,  6386,   157,  5322,   344,  5238,
     157,   528,  2966,   157,   152,   157,   489,   157,   157,   171,
     534,  5336,  5302,   198,   157,  2979,   157,   165,   157,   157,
    4141,   251,  3458,   171,   157,  3461,  2990,   157,   157,   177,
     157,  3513,  5322,   157,   157,   183,   157,   306,   186,  3475,
     429,  4320,   190,    38,  3480,  4287,  5336,   528,    10,   250,
     306,    13,   528,   171,   171,    17,    18,    19,     6,  3495,
      25,  4406,   247,     6,   528,  2931,    31,   528,  2934,   171,
     528,   219,   528,  3509,  4474,   528,   528,   528,   308,   528,
       6,  3517,     6,   528,   528,   528,   528,     6,   528,   528,
     528,   528,   528,  3529,   528,   528,  3532,   528,  3534,  4496,
     528,   528,   528,  3539,   252,   290,   528,   528,   528,     6,
     528,    76,   528,   486,   528,   297,   528,   528,  3554,  3555,
     528,  5530,   528,   528,  3560,   318,   528,   528,   528,   166,
     221,    38,   103,    38,  3234,   534,   534,  3237,   323,  3239,
    3240,   250,   528,    37,   439,  3581,   439,   526,  3584,   526,
     528,  3587,   441,   441,   302,   441,  3022,   441,   306,  3595,
    4484,   177,   534,   171,   312,   302,   171,   399,   133,  3035,
    5495,   441,   300,    68,   404,   140,   441,  3043,   386,   144,
     441,   477,   441,   368,  3620,   370,   386,   530,   373,  3102,
     441,   441,   386,   252,   441,    79,   441,   382,   518,   441,
      92,   157,   306,   386,   391,  5495,   391,   172,   247,   295,
     441,  2652,  2653,   441,   399,   128,  3082,  2658,   441,   465,
    3656,  3657,  3658,   432,   372,   381,   411,   327,   300,  6384,
     306,   528,    92,   194,   441,   420,   441,  3103,   528,   128,
     425,  3205,   207,   201,   466,  3681,   157,   534,   322,  2690,
    2691,   466,   441,  5578,  3690,   441,  3692,   128,  4379,  3223,
    4381,   223,   441,  3856,  3700,   441,  3230,   441,   114,   441,
    5155,   441,   441,   128,   441,   441,   506,    59,    59,   310,
    3146,   429,  3148,   441,  4405,   274,  3722,   348,  5578,   519,
     520,   521,   522,   523,   524,   480,   441,   441,   348,   441,
     348,   441,   327,  4648,   327,  3458,   441,   441,  3461,  5548,
     458,  2752,   432,    47,    47,   441,   441,   534,   529,   441,
     223,   286,   535,   223,   306,   290,   441,   223,   306,   441,
     223,   135,   223,   137,   482,   300,   484,   485,   223,    38,
     223,   223,  5581,   223,   223,   310,   308,   528,   451,   157,
    3786,   306,   157,   290,   120,   466,  3509,   322,  3458,   163,
     157,  3461,   157,   477,  3517,   157,   306,   290,   258,  3235,
     290,    38,  3808,   290,    38,   171,  3242,  3813,   526,   242,
     157,   529,   530,  3819,   388,   533,   157,    10,   157,   466,
      13,   466,  3828,   157,   441,  2836,  3309,   528,   299,   364,
     274,   177,   367,   368,   274,    13,   294,   439,   481,  3509,
     443,   441,  5737,   186,   194,   317,   194,  3517,   528,  3855,
    3856,   528,    45,   227,   529,  3861,   534,  3863,   534,    52,
     528,   528,   528,   528,   399,   529,  4864,   526,   505,   505,
    3876,   529,  3878,  3356,   529,   529,   390,  5737,   272,   529,
     402,   219,   534,   482,   238,    78,   307,   466,    38,   466,
      59,   315,  3898,   534,  5094,   529,   477,  3380,   386,   466,
     528,   238,   295,   238,   295,   441,  4544,  4545,   282,   283,
     284,   285,   441,  3396,  2925,   289,   290,   441,  3924,   171,
     528,   295,  2933,   295,   306,  2936,    48,   306,  4642,  4643,
    4644,  4645,  4646,  4779,   469,   290,   250,  2948,   250,  3945,
    3946,   250,   381,   268,   441,   306,   432,   128,   306,   534,
     306,   408,   430,   306,  4847,   364,   399,   150,   534,   195,
     396,  5856,  3968,   352,   485,   441,   529,   441,   312,    38,
    3930,  5479,   223,   518,   466,  3458,   242,   347,  3461,   300,
     157,  3987,   466,   171,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   478,  4765,  1487,  5856,    38,   430,   173,
    4006,   528,   157,   196,   396,   528,  3966,   300,   201,   157,
     157,  5990,   290,    38,  3934,   348,   485,  4932,   466,   290,
     306,    27,  4028,  4183,   306,  4031,  3509,   242,  4859,   192,
    3513,   192,   300,   171,  3517,    38,   172,   242,   171,   396,
     290,   306,  4048,   201,   201,  4051,    26,  3581,   201,   201,
     201,  4057,   534,   184,   534,   489,   441,   177,   251,   271,
     306,    59,  5957,   485,  4070,   177,   534,   299,  4074,   312,
    4076,  4077,  4078,   372,   448,   372,   471,  4083,   534,   530,
     318,   528,   135,   529,   529,  5632,   460,   328,  5055,  4095,
     505,  4097,   534,  4013,  4100,   177,   534,  5957,  4104,  4105,
    4106,  4107,  4108,   529,   289,  4111,  4112,  4113,  4114,  4115,
    4116,  4117,  4118,  4119,  4120,   308,   529,   534,  4124,  4125,
    4126,   529,   529,  4129,   529,   529,   529,   529,  4134,  4181,
     528,   441,   529,  4139,   534,  4141,   265,  4143,   177,   529,
     482,   529,   529,   529,   528,  4151,   527,  3681,  4154,   529,
    4156,   528,   528,   186,  3590,  3591,   464,   528,   527,   508,
     528,   534,   507,   260,   528,   528,  4172,   482,    59,  4175,
    4176,   472,   306,   205,  4180,  4181,   306,   309,   518,  4185,
     306,  4187,   157,  3194,   441,   135,   441,   137,   441,  4850,
     213,   295,   160,   441,   290,   157,   528,   528,   528,    86,
     399,   391,  4191,  4192,  4193,  4194,   157,   391,   157,   391,
    4216,   404,   250,   163,  4208,   205,  4222,  4380,   160,     0,
     306,   441,  4208,   518,  4230,   160,   466,   201,  4234,   329,
     252,   329,   463,   482,   160,   441,   415,   441,  6133,   441,
     441,   262,   262,  4406,   262,   441,   441,   386,  4208,   441,
     441,   386,   441,   128,   441,   441,   290,   399,   386,   386,
     157,  4267,    43,    47,   527,   441,  4208,   529,   441,  4208,
     441,  4208,   189,  6133,  3808,   529,   223,   227,  4284,   223,
    4918,   310,   529,   451,  4290,   529,     3,   529,   171,   534,
      48,  5074,   113,   171,   529,   534,  4302,    38,   528,   157,
    5014,  5015,   529,  5017,   441,   157,   171,   518,   300,   189,
     528,  5766,   466,   506,   157,   386,   386,  4323,    99,   386,
     466,   386,   386,   309,   534,   155,   519,   520,   521,   522,
     523,   524,   282,   283,   284,   285,   396,   155,   223,   289,
     147,   223,   223,   526,   223,   295,   223,   223,   459,   223,
     223,   223,   174,   306,   529,    59,   227,  6252,   306,   529,
     306,   306,   529,  6258,    13,   529,    25,  5005,  4374,   534,
     529,   152,    31,  4379,  4380,  4381,   477,   318,   177,   289,
     529,   226,   527,  5277,   165,  6194,  6195,    46,   529,  6198,
     171,   534,  6252,   316,  3830,   226,   177,   313,  6258,  4405,
    4406,   431,   183,    59,   529,   186,   529,   528,  3419,   190,
    3421,   529,   529,   528,   528,   190,   372,    76,  5312,    10,
     528,   438,    13,   471,    90,   451,  3437,   171,    38,   466,
     466,    10,  4595,   242,    13,   213,   441,    59,   219,   432,
     221,   157,   415,   181,   451,  4451,   441,  3930,  4454,   160,
     441,   391,   441,  3987,    45,   386,   441,  4420,   441,   386,
     364,    52,   386,   529,  5102,   528,    45,   529,  4431,   485,
     529,   252,  4006,    52,   133,    59,  3487,  3488,   528,   171,
     432,   140,   306,  3966,   472,   144,    78,    78,   157,  6098,
     113,  6386,   451,   223,   529,   223,   223,  4031,   448,    78,
     223,   528,   238,   208,   528,   441,   306,  4230,   489,   528,
     460,  4234,  4518,   172,   529,    38,   327,   303,   306,     3,
     534,   302,   534,   451,   528,   306,  6386,    44,   441,   528,
     396,   312,   534,   529,   177,   183,   113,   223,  4544,  4545,
     145,   239,  4548,  5670,   295,  5672,   295,   529,   207,  4555,
     529,   529,   529,   306,  3990,    38,  4562,  4563,   295,   150,
    4230,   295,    37,   306,  4234,   529,  4572,   489,   529,   177,
      59,   150,   529,   318,   483,   483,  2068,  2069,    81,  4302,
     534,  5295,   226,   484,   438,   327,   529,   300,   451,  4595,
    2082,   372,  5306,   441,  4600,  4601,  4602,   529,   528,  2091,
     529,   177,    78,   528,   518,   196,  4612,   528,   207,   195,
     201,   295,   195,  5813,   295,   485,   518,   196,    59,   432,
      72,   441,   201,   534,   441,   441,   157,   286,  4588,   534,
     160,   290,  4302,   441,  5456,   529,  5681,   127,   223,   528,
     179,   300,   120,    38,   201,   426,     0,  4653,   300,   396,
      38,   310,   466,   290,   173,   300,   396,   485,    59,   528,
     251,    84,   432,   322,    38,   177,  5866,   306,   528,   171,
     485,   359,   251,  4679,   210,   534,  5337,   458,   309,   221,
     529,   149,   328,   529,   177,   350,   528,  4850,   471,   529,
     412,  4697,   529,    59,   389,   528,   332,    38,  4181,    81,
     529,   482,   528,   484,   485,   364,    92,   136,   367,   368,
     306,   202,  5912,  5913,    38,   441,   528,   308,   358,  4725,
     157,   157,   441,   529,   528,  4208,   528,  5388,   171,   308,
     528,  4737,   528,   528,   528,    38,   295,   466,  5429,  5377,
     399,   263,   529,   528,   157,    99,   528,  4230,   529,   396,
     113,  4234,   533,   534,    38,   529,   310,   177,   451,  4765,
     410,   529,  4768,   171,   529,   306,  5681,   112,   410,   306,
    4776,  4777,   528,  4779,   528,   534,   528,  4783,  4784,   534,
      38,   471,  4788,  5554,   481,   194,   466,  4793,   171,  4323,
    4796,  4797,   286,   528,   432,  5566,   528,  4803,   152,   432,
     205,   306,     6,   528,   164,   529,   489,   528,   382,   382,
     469,   165,    72,   404,   309,    72,   136,   171,   533,  4825,
     141,  5592,   485,   177,   485,   404,  4832,   481,  5599,   183,
      38,  4837,   186,   534,  4840,  4841,   190,   385,   470,  4562,
    4563,   306,  4848,   471,   529,  3856,   168,   306,   399,   168,
     528,    35,   529,  4859,    10,   534,   528,    13,   528,  5904,
     264,  4867,   177,   432,   295,   219,   432,   355,  3879,   207,
     528,   306,   306,    38,    38,  5589,   396,   309,   179,   309,
     179,  4887,   156,   421,  4884,   202,   149,   528,   153,    45,
      59,  6091,  4562,  4563,  5665,  5666,    52,    59,   252,  4905,
     381,  4861,  4862,   528,   100,   529,   313,   149,   458,    38,
     313,    51,  4918,   437,   365,   506,   529,  4451,    59,   419,
    4454,   464,    78,   441,   125,   529,     6,   506,   519,   520,
     521,   522,   523,   524,   396,   528,  5922,  4943,   141,   306,
     519,   520,   521,   522,   523,   524,    35,   529,   302,   330,
     437,   295,   306,   534,  4960,    24,   534,   529,   312,  4965,
    5674,   528,   381,  4926,  6164,  6165,  4972,    10,   528,   534,
      13,   534,   149,  4936,    17,    18,    19,   314,    81,   381,
     291,   399,  4988,   441,   177,   291,   156,  1153,  4994,   410,
       6,   179,    35,  1159,   150,   528,   410,   120,   472,  5005,
     534,   528,    45,  1169,   471,   485,   485,  1173,   179,    52,
     466,  1177,   472,  1179,   528,  5505,   529,   471,   372,  1185,
    3067,  4555,  3421,  1017,   931,  1191,  4037,  2959,  1194,  2868,
    5036,  1018,   971,  4379,  4354,    78,  6082,  3632,  4572,  2985,
     196,  3847,  3039,  5432,  5902,   201,  6229,  1716,  4542,  5479,
    5667,  4352,  5064,  1413,  5455,  3561,  5062,  6062,  3181,  5336,
    6217,  5932,  5931,  6252,  5681,  6102,  4502,  3565,  5109,  4589,
    4563,  4574,  5078,  5876,  5845,   429,  5847,  5083,  4532,  4562,
    4516,  4374,  3053,  3895,  3053,  5462,  3657,  4558,  5871,  5103,
    3939,  5778,  4625,  1013,  6344,   251,  5102,  6461,  6442,  5446,
    3855,  6114,  4825,  5109,   458,  4588,  4597,  5390,  1875,  4832,
    5652,  5885,  5393,    18,  4837,    10,   660,  4840,    13,  4653,
      28,  4653,    17,    18,    19,  5622,  1233,  4004,   482,  6340,
     484,   485,  3069,  2729,  1918,  4600,  5505,  3539,  5766,  1915,
      35,  1929,  1953,  3950,   712,   745,  5837,  3789,  2035,  5155,
      45,  5157,   308,   196,  2035,  4825,  4405,    52,   201,  3708,
    6140,  5121,  4832,  2984,  6390,  4629,   860,  4837,  4631,  6409,
    4840,  4841,   526,  1532,  5337,   529,   530,  3015,  2671,   533,
     223,   224,  5188,    78,  6229,  4863,  5619,  4282,  1828,  2681,
    1390,  6055,    40,  5388,    40,  4697,  1429,  1489,  3480,  1490,
    5387,  3495,  2681,  6043,  5849,  1492,  3461,  5868,   251,  4218,
    5303,  5902,  4236,  5376,  3458,  5578,  5577,  6368,  4283,  3458,
    6037,  6199,  5836,  1446,  4063,  5388,  5552,  3368,  5850,  5235,
    4143,  2579,  5238,  3398,  2580,  5241,  5242,  5243,  5851,  2084,
    3380,  3014,  3250,  3378,  6167,  5215,  5990,  5434,   404,  6171,
     293,  5543,  4065,  6365,  5992,  6430,  5222,  3458,  6015,  6286,
    5266,  5267,  6293,  6019,  5270,   308,  6292,  6287,   311,  3291,
    4073,  2585,  2669,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    -1,    -1,   919,    -1,  5292,  5904,    -1,    -1,
      -1,    -1,  5298,    -1,    -1,    -1,  5302,    -1,    -1,    -1,
    5991,   196,  5308,  5309,    -1,    -1,   201,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,  5322,    52,    -1,  5325,
      -1,    -1,    -1,    -1,  5330,    -1,  5332,    -1,   223,   224,
    5336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,  4832,
     506,    -1,    -1,    -1,  4837,    -1,   251,  4840,    -1,    -1,
      -1,   404,    -1,   519,   520,   521,   522,   523,   524,  4380,
    5376,  5377,    -1,    -1,    -1,    -1,    -1,    -1,  4861,  4862,
      -1,  5387,    -1,    -1,    -1,    -1,  5109,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4406,    -1,    -1,   293,    -1,
    6428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5078,  4420,
      -1,    -1,    -1,   308,    -1,   150,   311,    -1,    -1,    -1,
    4431,    -1,    -1,  5429,    -1,    -1,  4960,    -1,  5434,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4972,  5109,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5315,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   196,    -1,   506,    -1,  6082,   201,    -1,    -1,    -1,
      -1,    -1,    -1,   516,   517,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,    -1,     6,   529,    -1,    -1,  5495,
      -1,   534,  5498,    -1,    -1,    -1,  4507,  4508,    -1,    -1,
    5460,    -1,    23,    -1,    25,    -1,  5505,  5505,    29,   404,
    5505,  5505,  5505,    34,    35,    36,   251,    38,  5505,  5505,
      41,    42,  5505,    44,  5530,    46,  5505,  5505,  5505,  5505,
      -1,  5491,    53,    54,    55,    -1,  5505,  5505,  5505,    -1,
      -1,    -1,  5548,  6326,  6327,  5505,  5552,  5599,  5554,  6443,
      -1,    -1,  6323,    -1,    -1,    -1,    -1,    -1,    -1,    38,
    5566,    -1,    -1,  5505,    -1,    -1,  5505,    -1,  5505,    -1,
      -1,    -1,  5578,   308,  5494,  5581,    -1,    -1,    -1,  5302,
    5016,   721,    -1,    62,  4595,    -1,  5592,    -1,    -1,    -1,
      -1,    -1,    -1,  5599,    -1,  5031,    -1,    -1,    -1,  5322,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   747,    -1,    -1,
      -1,   506,  6229,  5336,    -1,    -1,    -1,    -1,    -1,    98,
      -1,   516,   517,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,  5302,    -1,    -1,    -1,    -1,  4648,  5121,    -1,
     535,    -1,    -1,  5649,    -1,    -1,    -1,    -1,  5654,  5655,
      -1,    -1,  5322,  5659,  5188,    -1,    -1,    -1,    -1,  5665,
    5666,  5667,    -1,  6434,    -1,    10,  5336,    -1,    13,   404,
      -1,    -1,    -1,    -1,    -1,  5681,   197,   198,   199,    -1,
      -1,   202,   161,    -1,    -1,   206,  5122,   208,    -1,    -1,
     211,    -1,    -1,   214,    -1,  5701,   217,    -1,    -1,   220,
      45,   222,  6393,  5709,   225,  5868,  5712,    52,   229,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,  5387,    25,   198,
      -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,    -1,
      -1,  5737,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5766,  5767,    -1,   242,  5434,    -1,    -1,    -1,   247,    76,
    6461,   506,  5495,    -1,    -1,    -1,    -1,    -1,    -1,  5739,
      -1,    -1,  1948,    -1,   519,   520,   521,   522,   523,   524,
    1956,    -1,    -1,    -1,  5800,    -1,  5330,    -1,  5332,    -1,
      -1,  5807,  5808,  5809,    -1,   150,    -1,    -1,    -1,    -1,
      -1,   290,    -1,    -1,    -1,  3307,  3308,  5823,    -1,  5302,
    3312,    -1,    -1,    -1,    -1,  5495,   133,    -1,    -1,    -1,
    5836,  5837,    -1,   140,  5840,    -1,    -1,   144,    -1,  5845,
      -1,  5847,    -1,  5849,   323,    -1,    -1,    -1,    -1,    -1,
    5856,   196,    -1,    -1,    -1,  5578,   201,    -1,    -1,    -1,
    3352,  3353,    -1,    -1,    -1,   172,    -1,    -1,    -1,    -1,
      -1,  5877,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6069,    -1,    -1,    -1,    -1,    -1,    -1,   368,
      -1,    -1,    -1,  5853,   373,    -1,  5902,    -1,  5904,    -1,
     207,    -1,  5338,   382,  5340,    -1,   251,    -1,  5578,    -1,
      -1,    -1,   391,    -1,    -1,  4926,    -1,    -1,  1058,    -1,
     399,  4932,    -1,    -1,    -1,  4936,    -1,    -1,    -1,  1069,
      -1,    -1,   411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   420,    -1,    -1,    -1,  1085,   425,    -1,    -1,    -1,
      -1,  5957,  4963,  4964,  6141,  6142,    -1,  4968,  4969,    -1,
      -1,    -1,    -1,   308,    -1,   444,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5460,    -1,   286,
      -1,    -1,    -1,   290,  5990,  5991,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   300,  6000,    -1,    -1,    -1,    -1,    -1,
      -1,   480,    -1,   310,    -1,   484,    -1,    -1,  5491,    -1,
      -1,    -1,    -1,    -1,  5737,   322,    -1,    -1,    -1,    -1,
      -1,    -1,  5505,    -1,    -1,    -1,    -1,  6033,    -1,     0,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6043,    -1,  5709,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6053,    -1,    -1,
    6056,    -1,    -1,    -1,    -1,    -1,    -1,  5493,    -1,   404,
     367,   368,    -1,  6069,    -1,    -1,    -1,  5737,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    17,  6082,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5599,  6123,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6133,    99,    -1,
      -1,    -1,    -1,  5856,    -1,  6141,  6142,    -1,   659,    -1,
      -1,  6147,    -1,    -1,   665,    -1,   667,    -1,   669,    -1,
      -1,   672,    -1,    -1,  6140,  6115,    -1,    -1,   679,    -1,
      -1,   506,   469,   684,    -1,   686,    -1,    -1,    -1,    -1,
      -1,   692,    -1,    -1,   519,   520,   521,   522,   523,   524,
    6140,   152,    -1,    -1,    -1,    -1,  5856,    -1,  6194,  6195,
      -1,    -1,  6198,    -1,   165,   716,    -1,    -1,  6140,    -1,
     171,  6140,    -1,  6140,   725,    -1,   177,    -1,   729,    -1,
    6262,   732,   183,    -1,   735,   186,    -1,    -1,    -1,   190,
      -1,    -1,    -1,  6229,    -1,    -1,    -1,    -1,    -1,    -1,
     751,    -1,    -1,    -1,  5957,  5671,    -1,  5673,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6252,    -1,   219,    -1,
      -1,    -1,  6258,    -1,  5737,    -1,  5739,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6451,  6452,    -1,    -1,    -1,    -1,
    6276,    -1,  6278,    -1,    -1,    -1,  6262,    -1,    -1,    -1,
      -1,   252,    -1,   804,    -1,    -1,    -1,  5957,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   819,    -1,
      -1,    -1,  6262,  6309,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6323,   839,   840,
    6262,   842,   843,  6262,    -1,  6262,   847,    -1,    -1,    -1,
      -1,   302,    -1,    -1,    -1,   306,    -1,    -1,    -1,    -1,
     861,   312,    -1,    -1,    -1,   866,    -1,    -1,    -1,    -1,
      -1,   872,    -1,    -1,  6360,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5376,    -1,    -1,    -1,    -1,
    5853,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6386,    -1,    -1,    -1,    -1,    -1,    -1,  6393,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   919,  6069,
      -1,   372,    -1,    -1,  6390,    -1,    -1,    -1,    -1,    -1,
    6133,    -1,   933,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6428,  6429,    -1,   946,    -1,    -1,  6434,    -1,
    6390,    -1,  6438,    -1,    -1,    -1,  6442,    -1,    -1,    -1,
     961,    -1,    -1,    -1,    -1,  6451,  6452,    -1,  6390,    -1,
      -1,  6390,    -1,  6390,    -1,  6461,  2622,    -1,   429,   980,
      -1,    -1,    -1,  6133,   985,   986,    -1,    -1,    -1,    -1,
      -1,  6141,  6142,    -1,    -1,    -1,  1616,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   458,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1017,  1018,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5943,    -1,    -1,
      -1,   482,    -1,   484,   485,    -1,    -1,    -1,    -1,  1040,
    1041,    -1,  6056,    -1,    -1,    -1,    -1,    -1,    -1,  6252,
      -1,    -1,  1053,    -1,  1055,  6258,    -1,    -1,  1059,    -1,
      -1,  1062,  1063,    -1,  1065,    -1,    -1,    -1,    -1,  1070,
      -1,    -1,    -1,    -1,    -1,   526,    -1,    -1,   529,   530,
      -1,    -1,   533,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1094,    -1,    -1,    -1,    -1,    -1,    -1,
    1101,  1102,  6252,    -1,    -1,    -1,    -1,    -1,  6258,    -1,
      -1,  4083,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1122,  1123,  1124,    -1,  1126,  6276,  1128,    -1,  1130,
    1131,    -1,    -1,  4105,  4106,  4107,  4108,    -1,    -1,  4111,
    4112,  4113,  4114,  4115,  4116,  4117,  4118,  4119,  4120,    -1,
      -1,    -1,  6115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1164,    -1,  1166,  1167,  4139,  6084,    -1,
      -1,    -1,    10,    -1,    -1,    13,    -1,  6140,    -1,    17,
      18,    19,    -1,  6386,    -1,    -1,    -1,    -1,    -1,    -1,
    5681,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1199,    -1,
      -1,    -1,    -1,  4175,  4176,    -1,    -1,    45,    -1,    -1,
    6360,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,
    1840,    -1,    -1,    -1,  1225,    -1,  1227,    -1,    -1,    -1,
    1231,  1851,  1233,    -1,    -1,    10,  6386,    -1,    13,   661,
      78,    -1,    17,    18,    19,    -1,  1247,  1867,    -1,    -1,
    4222,    -1,  1253,    -1,    -1,  1256,    -1,    -1,  1259,    -1,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      45,    -1,  1273,    -1,    -1,    -1,    -1,    52,    -1,  6429,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6438,   711,
     712,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6262,
    1920,  6451,  6452,    78,    -1,    -1,    -1,  6223,    -1,    -1,
      -1,    -1,    -1,  1314,    -1,  1935,    -1,    -1,  1938,  1939,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6253,  6254,    -1,
      -1,  1342,  1343,  1344,    -1,  1346,    -1,    -1,    -1,  1969,
    1970,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,
      -1,    -1,    10,   201,    -1,    13,  1367,    -1,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   807,    -1,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,
      -1,    -1,    -1,  5894,    52,    -1,    -1,    -1,    -1,    -1,
      -1,   833,    -1,   251,    -1,    -1,    -1,  1418,    -1,   841,
      -1,   196,   844,   845,   846,    -1,   201,  6390,    -1,    -1,
      78,    -1,    -1,    -1,    -1,  1436,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,   224,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    62,  6383,    -1,    -1,
     308,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,  1482,    -1,    -1,    -1,  1486,  1487,  3133,    -1,  2109,
      -1,    -1,  3138,    -1,  3140,    -1,  1497,  1498,  1499,  1500,
      -1,  1502,    98,    -1,  3150,    -1,    -1,  3153,    -1,  3155,
    3156,    -1,    -1,  3159,    -1,    -1,    -1,  3163,   293,  3165,
      -1,    -1,  3168,    -1,  1525,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   308,    -1,    -1,   311,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4518,    -1,   196,    -1,
      -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,    -1,  1560,
      -1,    -1,    -1,    -1,  1565,   161,   404,  1568,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   223,   224,    -1,    -1,    -1,
    1581,  1582,    -1,    -1,    -1,    -1,  3232,    -1,    -1,  1590,
      -1,    -1,  1593,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   198,   251,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,  1620,
      -1,  1622,    -1,    -1,  1625,    -1,  1048,  1628,  1629,   404,
      -1,  1632,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1642,    45,    -1,  1645,   293,    -1,  1648,    -1,    52,
      -1,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     308,    -1,    -1,   311,    -1,    -1,    -1,    -1,   506,  1670,
      -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,   516,   517,
     518,   519,   520,   521,   522,   523,   524,  1688,    -1,    -1,
     286,    -1,    -1,    -1,   290,    -1,    -1,    -1,    -1,  1700,
    1701,  1702,  1703,  1704,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1718,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   322,   323,  1729,  1730,
    1731,   506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   516,   517,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,    -1,   534,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   364,    -1,
      -1,    -1,   368,    -1,    -1,    -1,    -1,   373,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   382,    -1,    -1,    -1,
      -1,    -1,    -1,   196,    -1,   391,  4768,    -1,   201,    -1,
      -1,    -1,    -1,   399,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   411,  1238,    -1,    -1,    -1,
     223,   224,    -1,    -1,   420,    -1,  1827,    -1,    -1,   425,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1838,    -1,  1261,
      -1,    -1,    -1,    -1,    -1,  1846,  1847,    -1,   251,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   506,    -1,
      -1,  1862,    -1,    -1,    -1,    -1,    -1,    -1,   516,   517,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,  1880,
    1881,    -1,    -1,    -1,   480,    -1,   534,    -1,    -1,    -1,
     293,    -1,    -1,    -1,    -1,  1896,  1897,  1898,  1899,    -1,
      -1,    -1,  6393,    -1,  1905,   308,    -1,    -1,   311,    -1,
      -1,  1912,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3570,    -1,  1348,    -1,  1929,    -1,
      -1,  1932,    -1,    -1,    -1,  1357,    -1,    -1,    -1,    -1,
      -1,  1942,  1943,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6442,  1953,  1954,    -1,    -1,  1957,    -1,    -1,  1960,
      -1,    -1,    -1,  1385,    -1,    -1,    -1,    -1,    -1,    10,
    6461,    -1,    13,    -1,  1975,  1976,    17,    18,    19,    -1,
      -1,  1982,  1404,  1984,    -1,  1407,  1408,    -1,    -1,    -1,
    1412,  1413,    -1,    -1,    35,  3641,    -1,  3643,    -1,    -1,
    2001,   404,    -1,    -1,    45,    -1,    -1,  2008,    -1,  2010,
      -1,    52,  2013,  2014,  2015,    -1,  2017,  2018,    -1,  2020,
      -1,    -1,    -1,    -1,    -1,    -1,  2027,    -1,    -1,    -1,
      -1,    -1,    -1,  2034,    -1,    -1,    -1,    78,    -1,  2040,
    2041,    -1,    -1,  2044,    -1,    -1,    -1,  2048,    -1,  2050,
      -1,    -1,    -1,    -1,  2055,  2056,    -1,    -1,    -1,    -1,
      -1,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,  2070,
    2071,  2072,  2073,  2074,    -1,    -1,  2077,    -1,  2079,  2080,
    2081,  2082,  2083,  2084,  2085,  2086,    -1,    -1,  2089,    -1,
    2091,  2092,    -1,    -1,  2095,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   506,    -1,    -1,    -1,    -1,    -1,  2110,
    2111,  2112,    -1,   516,   517,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,    -1,    -1,   529,  2128,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3785,
      -1,    -1,    -1,    -1,    -1,  3791,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    25,    -1,   196,    -1,    -1,    38,    31,
     201,    -1,    -1,    -1,    -1,    -1,  2786,  2168,    -1,    -1,
      -1,    -1,  2792,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      60,    -1,   223,   224,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    76,    -1,    86,    -1,    -1,    -1,
     251,    35,    -1,  2833,    -1,    -1,    10,    -1,    -1,    13,
      -1,    45,    -1,    17,    18,    19,    -1,    -1,    52,    -1,
      -1,    -1,   112,   113,    -1,    -1,    -1,    -1,    -1,    -1,
     120,    35,    -1,    -1,    -1,  1667,    -1,    -1,    -1,    -1,
      -1,    45,   293,  1675,    78,    -1,    -1,    -1,    52,   131,
      -1,   133,    -1,    -1,    -1,    -1,  5238,   308,   140,    -1,
     311,    -1,   144,    -1,  2275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5292,    -1,    -1,    -1,   204,    -1,    -1,  2328,    -1,  3975,
      -1,  3977,    -1,  3979,    -1,   207,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   404,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   196,    -1,    -1,    -1,    -1,   201,    -1,    -1,
      -1,    -1,  2383,    -1,    -1,    -1,   266,    -1,    -1,    -1,
     270,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,
     224,    -1,   196,    -1,    -1,    -1,   286,   201,    -1,    -1,
     290,    -1,    -1,    -1,   286,    -1,    -1,    -1,   290,    -1,
      -1,    -1,  3042,    -1,    -1,    -1,    -1,   251,   300,   223,
     224,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,
      -1,   321,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     322,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   506,    -1,  1889,    -1,   293,
      -1,  1893,    -1,    -1,    -1,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   308,    -1,    -1,   311,   529,   369,
      -1,    -1,   364,    -1,    -1,   367,   368,    -1,    -1,   293,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   393,   308,    -1,    -1,   311,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   399,    -1,    -1,
      -1,    -1,    -1,   413,    -1,   415,    -1,    -1,   418,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2564,  2565,  2566,  2567,  2568,  2569,  2570,
    2571,  2572,    -1,  2574,    -1,    -1,  5548,    -1,    -1,    -1,
     404,    -1,    -1,  2584,  2585,    -1,  2587,    -1,    -1,    -1,
      -1,    -1,    -1,  2594,    -1,    -1,    -1,   469,    -1,    10,
      -1,  3221,    13,    -1,    -1,    -1,    17,    18,    19,  5581,
     404,    -1,    -1,    -1,    -1,    -1,  3236,    -1,    -1,    -1,
      -1,  3241,  2623,    -1,  2625,    -1,    -1,  2628,  2629,    -1,
      -1,  2632,    -1,  2634,    45,    -1,  2637,    -1,    -1,  2061,
    2641,    52,    -1,    -1,    -1,    -1,    -1,    -1,   528,    -1,
      -1,  3271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2664,    -1,    -1,    -1,    78,    -1,  2670,
    2671,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2681,    -1,   506,    -1,    -1,    -1,    -1,    -1,    -1,  2690,
    2691,    -1,   516,   517,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,  2704,    -1,   529,    -1,    10,    -1,    -1,
      13,  2712,   506,  2714,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,   516,   517,   518,   519,   520,   521,   522,   523,
     524,    -1,    35,    -1,    -1,   529,    -1,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,
      -1,    -1,    -1,  2754,    -1,  2756,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,  2773,    -1,    -1,    78,    -1,    -1,    -1,    -1,
      -1,    35,    -1,  2784,    -1,   196,  2787,  2788,  2789,  2790,
     201,    45,  2793,    51,    -1,  2796,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   223,   224,    -1,    -1,  2817,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    -1,    -1,  2828,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2836,  2837,    -1,    -1,    -1,
     251,    -1,  2843,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      10,  2852,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,  5836,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2874,    -1,    35,    -1,    -1,    -1,    -1,
      -1,    -1,   293,    -1,    -1,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    52,   196,    -1,  2896,    -1,   308,   201,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    -1,  2908,    -1,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,
     223,   224,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2931,    -1,    -1,  2934,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   196,    -1,    -1,    -1,    -1,   201,   251,    -1,
      -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,    -1,  2960,
    2961,    -1,    -1,    -1,    -1,    -1,    -1,  3587,    -1,   223,
     224,    -1,    -1,    -1,  2975,  3595,  2977,  2978,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     293,  4637,    -1,   404,  4640,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   308,    -1,  3008,  3009,  3010,
      -1,   133,    -1,  3014,    -1,    -1,    -1,    -1,   140,    -1,
    4666,  3022,   144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3035,    -1,   196,    -1,    -1,   293,
    3041,   201,  3043,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,    -1,    -1,    -1,   308,  3056,    -1,   311,    -1,    -1,
    3061,  6033,    -1,   223,   224,    -1,  3067,    -1,    -1,  3070,
    3690,    -1,  3692,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3082,  3083,    -1,    -1,   207,    -1,    -1,    -1,    -1,
      -1,   251,  3093,    -1,    -1,   506,    -1,    -1,    -1,    -1,
      -1,   404,  3103,    -1,  3105,   516,   517,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   293,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3144,    -1,  3146,    -1,  3148,   308,    -1,
     404,   311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   286,    -1,  3786,    -1,   290,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   300,    -1,
    3181,    -1,  2604,    -1,    -1,    -1,    -1,    -1,   310,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     322,    -1,    -1,   506,    -1,    -1,    -1,    -1,  3828,    -1,
      -1,    -1,    -1,   516,   517,   518,   519,   520,   521,   522,
     523,   524,  6194,  6195,    -1,    -1,  6198,    -1,    -1,    -1,
      -1,    -1,    -1,  3234,  3235,    -1,  3237,    -1,  3239,  3240,
      -1,  3242,   364,    -1,   404,   367,   368,    -1,  3249,    -1,
      -1,    -1,   506,  3254,    -1,    -1,    -1,  4903,    -1,    -1,
      -1,    -1,   516,   517,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,    -1,    -1,   529,    -1,   399,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4944,  4945,
      -1,    -1,    -1,    -1,  3924,    -1,  3307,  3308,  3309,    -1,
      -1,  3312,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3320,
    3321,  3322,  3323,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2752,    -1,    -1,    -1,    -1,  3336,    -1,    -1,  3339,    -1,
    3341,    -1,    -1,    -1,    -1,    -1,   506,   469,  3968,    -1,
      -1,  3352,  3353,    -1,    -1,  3356,   516,   517,   518,   519,
     520,   521,   522,   523,   524,    -1,    -1,    -1,    -1,   529,
      -1,    -1,    -1,    -1,  3375,    -1,  3377,    -1,  3379,    10,
    3381,    -1,    13,    -1,    -1,    -1,    17,    18,    19,  2811,
      -1,  5037,  5038,    -1,    -1,    -1,    -1,    -1,    -1,  3400,
      10,    -1,  3403,    13,    35,    -1,  3407,    17,    18,    19,
      -1,    -1,    -1,    -1,    45,    -1,    -1,    38,    -1,    -1,
      -1,    52,    -1,    -1,    -1,    35,    -1,  3428,    -1,    -1,
      -1,  4051,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,
      -1,    62,    52,    10,    -1,    -1,    13,    78,    -1,    -1,
      17,    18,    19,    -1,  4074,    -1,    -1,  3458,    -1,    -1,
    3461,  3462,    -1,   721,    -1,  3466,  3467,  3468,    78,  2891,
      -1,  3472,    -1,    -1,  3475,    -1,    -1,    98,    45,  3480,
      -1,    -1,    -1,    -1,  4104,    52,    -1,    -1,    -1,   747,
      -1,    -1,    -1,  2915,  3495,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3509,  4129,
      -1,    78,  3513,    -1,    -1,  3516,  3517,    -1,  3519,    -1,
      -1,  5167,    -1,    -1,  5170,  5171,    -1,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    -1,    -1,    -1,    31,    -1,    -1,
     161,  5187,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,  3560,
    2982,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,
     201,    -1,    -1,    -1,    -1,    -1,    -1,   198,    -1,    -1,
      -1,    -1,    76,    -1,    -1,    -1,   196,    -1,    -1,  3590,
    3591,   201,   223,   224,    -1,    -1,    -1,  3019,    -1,  3021,
      -1,  3023,  3024,    -1,    -1,    -1,  3028,  3029,  3030,    -1,
    3032,  3033,  3034,   223,   224,    -1,    -1,    -1,    -1,    -1,
     251,   242,    -1,    -1,    -1,    -1,   247,    -1,    -1,   196,
      -1,    -1,    -1,    -1,   201,    -1,    -1,   131,   896,   133,
      -1,   251,    -1,    -1,    -1,    -1,   140,    -1,    -1,    -1,
     144,    -1,    -1,    -1,    -1,    -1,   223,   224,    -1,    -1,
      -1,    -1,   293,    -1,  3086,    -1,    -1,    -1,    -1,   290,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,   172,    -1,
     311,    -1,    -1,   293,   251,    -1,    -1,    -1,    -1,  3111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3698,   308,    -1,
      -1,   311,   323,    -1,    -1,    -1,    -1,  3708,    -1,    -1,
      -1,    -1,    -1,   207,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   293,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   308,    -1,    -1,    -1,    -1,    -1,   368,    -1,    -1,
      -1,    10,   373,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,   382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     391,    -1,    -1,   404,    -1,    -1,    35,    -1,   399,    -1,
      -1,    -1,  1040,    -1,    -1,    -1,    45,    -1,    -1,    -1,
     411,    -1,   286,    52,   404,    -1,   290,    -1,    -1,   420,
    1058,    -1,    -1,    -1,   425,    -1,   300,    -1,    -1,    -1,
      -1,  1069,  3813,    -1,    -1,    -1,   310,    -1,  3819,    78,
      -1,    -1,    -1,   444,    -1,    -1,    -1,  1085,   322,  3830,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   480,
      -1,    -1,    -1,   484,    -1,    -1,  3867,  3868,  3869,    -1,
     364,    25,    -1,   367,   368,   506,    -1,    31,    -1,    -1,
      -1,    -1,    -1,  3884,    -1,   516,   517,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,   506,  3898,   529,    -1,
      -1,    -1,    -1,    -1,    -1,   399,   516,   517,   518,   519,
     520,   521,   522,   523,   524,  3916,  3917,  3918,    -1,   529,
      -1,  3922,    76,    -1,    -1,    -1,    -1,    -1,  4548,    -1,
      -1,    -1,    -1,  3934,    -1,    -1,    -1,   196,    -1,   506,
      -1,    -1,   201,    -1,    -1,    -1,    -1,    -1,    -1,   516,
     517,   518,   519,   520,   521,   522,   523,   524,    -1,    -1,
      -1,    -1,    -1,    -1,   223,   224,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   469,    -1,    -1,  5624,   133,
      -1,    -1,    -1,  1241,    -1,    -1,   140,    -1,    -1,  3990,
     144,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,  3421,
      -1,    -1,    -1,  4004,  4005,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4013,    -1,    -1,    -1,    -1,    -1,   172,    -1,
      -1,    -1,    -1,    -1,    -1,  4026,    -1,    -1,  4029,    -1,
    5676,    -1,    -1,    -1,   293,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4048,    -1,   308,
      -1,    -1,   311,   207,    -1,    -1,  4057,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4070,
      -1,    -1,    -1,    -1,    -1,  4076,  4077,  4078,    -1,    -1,
      -1,    -1,  4083,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4095,    -1,  4097,    -1,    -1,  4100,
      -1,    -1,    -1,    -1,  4105,  4106,  4107,  4108,    -1,    -1,
    4111,  4112,  4113,  4114,  4115,  4116,  4117,  4118,  4119,  4120,
      -1,    -1,    -1,  4124,  4125,  4126,    -1,    -1,    -1,    -1,
      -1,    -1,   286,  4134,    -1,    -1,   290,    -1,  4139,    -1,
      -1,    -1,  4143,  5789,    -1,   404,   300,    -1,    -1,    -1,
    4151,    -1,    -1,  4154,    -1,  4156,   310,    -1,    -1,    -1,
      -1,    -1,  3584,    -1,    -1,    -1,    -1,    -1,   322,    -1,
      -1,  4172,    -1,    -1,  4175,  4176,    -1,    -1,    -1,  4180,
    4181,    -1,    -1,    -1,  4185,    -1,  4187,  4188,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4196,  4197,  4198,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     364,    -1,    -1,   367,   368,  4216,  4217,  4218,  4219,  4220,
      -1,  4222,  4223,    -1,    -1,  4226,    -1,    -1,    25,  4230,
      -1,    -1,    -1,  4234,    31,    -1,    -1,    -1,    -1,  4240,
    3662,    -1,    -1,    -1,    -1,   399,    -1,   506,    -1,    -1,
    1508,    -1,    -1,     0,    -1,    -1,    -1,   516,   517,   518,
     519,   520,   521,   522,   523,   524,  4267,    -1,    -1,    -1,
     529,    -1,    -1,    20,    -1,    -1,    -1,    -1,    -1,    76,
      -1,  4282,    -1,  4284,    31,  4905,    33,    34,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3720,    -1,
      -1,  4302,  4303,  4304,    51,    -1,  4307,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    61,   469,    -1,  1575,    -1,    -1,
      -1,    -1,    -1,  4943,    -1,    -1,    73,    -1,    75,    76,
      -1,    -1,    -1,    -1,    -1,    82,   133,    84,    -1,    -1,
      -1,  4342,  4343,   140,    -1,  4965,    -1,   144,    -1,    -1,
      97,    -1,    99,    -1,    -1,    -1,    -1,    -1,  1616,    -1,
    4361,    -1,    -1,    -1,    -1,    -1,  3788,    -1,    -1,   116,
      -1,    -1,   119,    -1,    -1,   172,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,   136,
      -1,  1649,    -1,   140,    -1,    -1,    -1,    -1,    -1,    -1,
     147,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   156,
     207,   158,  3834,    -1,    -1,    -1,  5036,    -1,   165,    -1,
      -1,    -1,    -1,    -1,  3846,  3847,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3856,    -1,   183,    -1,    -1,  3861,
      -1,  3863,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   200,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4469,    -1,
      -1,  1729,  1730,  1731,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3909,    -1,   286,
      -1,    -1,    -1,   290,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4502,    -1,   300,    -1,    -1,   253,   254,    -1,    -1,
      -1,    -1,   259,   310,    -1,  4516,    -1,  4518,    -1,    -1,
      -1,    -1,  3944,  3945,  4525,   322,   273,    -1,    25,    -1,
    4531,    -1,    -1,    -1,    31,    -1,    -1,  5157,    -1,    -1,
      -1,  4542,    -1,    -1,    -1,   292,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4557,    -1,    -1,    -1,
      -1,  4562,  4563,    -1,    -1,    -1,  6212,   364,    -1,  4570,
     367,   368,    -1,    -1,    -1,    -1,    -1,    -1,  4579,    76,
      -1,    -1,  1840,    -1,    -1,    -1,    -1,    -1,  4589,    -1,
      -1,    -1,   339,  1851,    -1,    -1,    -1,    -1,    -1,    -1,
    4601,  4602,   399,    23,    -1,    -1,    -1,   354,    28,  1867,
      -1,  4612,    -1,   360,   361,    -1,   363,    -1,    -1,    -1,
      -1,   368,  4623,  4624,    -1,    -1,    -1,   374,    -1,    -1,
     377,    -1,    -1,    -1,    -1,    -1,   133,   384,    -1,    -1,
    4641,    -1,    -1,   140,   391,   392,    66,   144,    -1,    -1,
      -1,    -1,   399,    -1,    -1,    -1,   403,    -1,    -1,    79,
      -1,    -1,  1920,    -1,    -1,    -1,   413,    -1,    -1,    -1,
      -1,    -1,   469,    -1,    -1,   172,    96,  1935,  4679,    -1,
    1938,  1939,   429,    -1,    -1,    -1,    -1,    -1,  5308,    -1,
      -1,    -1,    -1,    -1,   114,    -1,  4697,    -1,    -1,    -1,
      -1,    -1,   449,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     207,  1969,  1970,    -1,   461,    -1,    -1,    -1,   138,    -1,
     467,    -1,    -1,    -1,  4725,   472,    -1,    -1,  4150,    -1,
      -1,   151,    -1,    -1,    -1,    -1,  4737,    -1,   485,    -1,
     160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,   179,
      -1,   508,    -1,    -1,  4765,    -1,   186,  4768,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4776,  4777,    -1,    -1,    -1,
      -1,   528,  4783,  4784,    -1,   205,   533,  4788,    -1,   286,
      -1,    -1,  4793,   290,    -1,  4796,  4797,    -1,    -1,    -1,
      -1,    -1,  4803,   300,    -1,    -1,  4807,  4808,  4809,  4810,
    2068,    -1,    -1,   310,    25,    -1,    -1,    -1,    -1,    -1,
      31,    -1,    -1,  2081,  4825,   322,  2084,  4828,    -1,    -1,
      -1,  4832,    -1,    -1,    -1,    -1,  4837,    -1,    -1,  4840,
    4841,    -1,  4843,    -1,  4845,   265,    -1,  4848,    -1,  4850,
      -1,  2109,    -1,    -1,    -1,    -1,    -1,    -1,  4859,    -1,
      -1,    -1,  4863,    -1,    -1,    76,  4867,   364,  4869,    -1,
     367,   368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4884,    -1,    -1,  4887,    -1,   308,    -1,
      -1,    -1,    51,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,   321,   399,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   334,    -1,    -1,    -1,    -1,    -1,
    4921,    35,   133,    -1,   344,   345,    -1,    -1,   348,   140,
      -1,    45,    -1,   144,    -1,    -1,  4937,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   376,    -1,  4380,   379,
      -1,   172,    -1,   383,    78,    -1,   386,    -1,    -1,    -1,
      -1,    -1,   469,   393,    -1,    -1,   396,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4406,    -1,    -1,  4988,    -1,    -1,
      -1,  4992,    -1,  4994,    -1,   415,   207,    -1,    -1,  4421,
      -1,    -1,  4424,   423,  4426,    -1,    -1,    -1,    -1,   429,
      -1,    -1,   432,    -1,    -1,  5016,   436,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   444,    -1,   446,    -1,    -1,  5649,
    5031,   451,    -1,    -1,  5654,  5655,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   465,    -1,    -1,    -1,    -1,
    4472,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,    -1,
      -1,  5062,    -1,    -1,    -1,    -1,  4488,    -1,    -1,    -1,
      -1,  4493,    -1,    -1,    -1,   286,    -1,  5078,    -1,   290,
      -1,    -1,   196,    -1,  5085,    -1,    -1,   201,    -1,   300,
      -1,    -1,    -1,  5094,    -1,    -1,    -1,    -1,    -1,   310,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5109,   223,
     224,   322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5122,    -1,  5124,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5767,    -1,  5150,
      -1,    -1,    -1,   364,    -1,    -1,   367,   368,    -1,    -1,
    5161,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4592,    -1,    -1,  4595,    -1,    -1,    -1,    -1,    -1,   293,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   399,    -1,
      -1,    -1,    -1,    -1,   308,    -1,    -1,   311,    -1,    -1,
      -1,    -1,    -1,  5823,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5840,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5235,    -1,    -1,  5238,    -1,    -1,
    5241,  5242,  5243,    -1,    -1,    -1,  4668,  4669,  4670,  4671,
      -1,  4673,  4674,  4675,  4676,  4677,    -1,    -1,   469,    -1,
      -1,    -1,    -1,    -1,    -1,  5266,  5267,    -1,    -1,  5270,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    25,     0,    -1,    -1,    -1,    -1,    31,    -1,    -1,
     404,  5292,    -1,    -1,    -1,    -1,    -1,  5298,    -1,    -1,
      -1,  5302,    20,    -1,    -1,  5306,    -1,    -1,  5309,    -1,
    5311,    -1,    -1,    31,    -1,    33,    34,    -1,    -1,    -1,
      -1,  5322,    -1,    -1,  5325,    -1,    -1,    -1,    -1,  2587,
      -1,    -1,    76,    51,    -1,  5336,  5337,  5338,    -1,  5340,
      -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    -1,    75,    76,    -1,
      -1,    -1,    -1,    -1,    82,    -1,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,
      -1,    99,    -1,    -1,    -1,    -1,  5387,  5388,    -1,   133,
      -1,    -1,   506,  4815,    -1,  4817,   140,    -1,   116,    -1,
     144,   119,   516,   517,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,    -1,    -1,   529,   134,    -1,   136,    -1,
      -1,    -1,   140,    -1,    -1,    -1,    -1,    -1,   172,   147,
      -1,    -1,    -1,  5434,    -1,    -1,    -1,    -1,   156,    -1,
     158,    -1,    -1,    -1,    -1,  5446,    -1,   165,   206,   207,
    5451,    -1,    -1,    -1,    -1,  5456,   214,    -1,   216,   217,
      -1,    -1,    -1,   207,  5465,   183,  2724,    -1,    -1,    -1,
    2728,  2729,   230,    -1,  5475,    -1,    -1,    -1,  5479,    -1,
      -1,  5482,   200,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5493,  5494,  5495,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2786,  5530,
      -1,    -1,    -1,    -1,  2792,   253,   254,    -1,    -1,    -1,
      -1,   259,   286,    -1,    -1,    -1,   290,  5548,    -1,    -1,
      -1,  5552,    -1,  5554,    -1,   273,   300,    -1,    -1,    -1,
      -1,    -1,   721,    -1,    -1,  5566,   310,    -1,    -1,    -1,
      -1,  5572,    -1,    -1,   292,  2833,    -1,  5578,   322,    -1,
    5581,    -1,    -1,    -1,  5585,    -1,    -1,    -1,   747,    -1,
      -1,  5592,    -1,    -1,    -1,    -1,    -1,    25,  5599,    -1,
      -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      38,    -1,  5034,  5035,    -1,    -1,    -1,    -1,    -1,    -1,
     364,   339,    -1,   367,   368,  5047,   207,  5049,  5050,  5051,
      -1,    -1,    60,  5634,    -1,   216,   354,    -1,    -1,    -1,
      -1,    -1,   360,   361,    -1,   363,    -1,    -1,    76,   230,
     368,    -1,    -1,    -1,    -1,   399,   374,    -1,  5659,   377,
      -1,    -1,    -1,    -1,  5665,  5666,   384,    -1,    -1,  5670,
    5671,  5672,  5673,   391,   392,    -1,    -1,    -1,    -1,    -1,
      -1,   399,    -1,    -1,   112,   403,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5115,    -1,   413,    -1,    -1,    -1,    -1,
    5701,    -1,    -1,    -1,    -1,   133,    -1,    -1,  5709,    -1,
      -1,   429,   140,    -1,    -1,    -1,   144,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   469,    -1,    -1,    -1,    -1,
      -1,   449,  5154,  5734,    -1,    -1,  5737,   896,    -1,    -1,
      -1,    -1,    -1,   461,   172,    -1,    -1,    -1,    -1,   467,
      -1,    -1,  3010,    -1,   472,    -1,    -1,    -1,    -1,    -1,
      -1,  5762,    -1,    -1,    -1,    -1,    -1,   485,    -1,    -1,
      -1,    -1,    -1,    -1,  5196,    -1,   204,    -1,    -1,   207,
      -1,    -1,    -1,    -1,  3042,    -1,    -1,    -1,    -1,    -1,
     508,    -1,    -1,   511,   512,   513,   514,   515,    -1,  5800,
      -1,    -1,    -1,    -1,    -1,    -1,  5807,  5808,  5809,    -1,
     528,    -1,  5813,    -1,    -1,   533,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5833,    -1,    -1,  5836,    -1,    -1,   266,    -1,
      -1,    -1,   270,    -1,  5845,    -1,  5847,    -1,  5849,  5850,
      -1,    -1,    -1,    -1,    -1,  5856,    -1,  3115,   286,    -1,
      -1,  3119,   290,    -1,    -1,  5866,    -1,  5868,    -1,    -1,
      -1,    -1,   300,    -1,    -1,    -1,  5877,    -1,    -1,    -1,
      -1,    -1,   310,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   321,   322,    -1,    -1,    -1,    -1,  1058,
     658,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1069,  5912,  5913,    -1,    -1,    -1,    -1,    -1,    -1,   677,
      -1,    -1,    -1,    -1,    -1,   683,  1085,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   364,   695,    -1,   367,
     368,   369,  5943,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   711,  5376,    -1,  5957,    -1,    -1,    -1,
      -1,    -1,    -1,  3221,    -1,   393,    -1,   725,   726,    -1,
      -1,   399,    -1,    -1,   732,    -1,   734,   735,  3236,    -1,
      -1,    -1,    -1,  3241,    -1,   413,    -1,    -1,    -1,  5990,
     748,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6000,
     758,    -1,  5424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5433,    -1,  3271,  6015,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6033,    -1,    62,    -1,  6037,    -1,    -1,    -1,
      -1,   469,  6043,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6052,  6053,    -1,    -1,    -1,    -1,    -1,   816,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6069,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,   658,    -1,    -1,
      -1,    -1,  1241,  6084,    -1,    -1,    -1,   845,    -1,    -1,
    6091,    -1,    -1,    -1,    -1,    -1,   677,    -1,    -1,    -1,
      -1,    10,   683,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,   870,    -1,   695,  6116,    -1,    -1,    -1,    -1,
      -1,    -1,  6123,    -1,    -1,    -1,    35,    -1,    -1,    -1,
     711,    -1,  6133,   161,    51,    -1,    45,    -1,    -1,    -1,
    6141,  6142,  6143,    52,    -1,   726,  6147,    -1,    -1,    -1,
      -1,    -1,    -1,   734,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6164,  6165,  6166,    -1,   748,    -1,    78,
     198,    -1,    -1,    -1,   932,    -1,    -1,   758,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6194,  6195,    -1,    -1,  6198,    -1,    -1,
    6201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   247,
      -1,    -1,  6223,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   816,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1407,    -1,
      -1,  6252,  6253,  6254,    -1,    -1,    -1,  6258,   286,  5681,
      -1,    -1,   290,  5685,   845,    -1,    -1,    -1,    -1,    -1,
      -1,  3529,    -1,    -1,  3532,  6276,  3534,  6278,    -1,    -1,
      -1,  3539,    -1,    -1,  1042,    -1,    -1,   196,    -1,   870,
    1048,    -1,   201,    -1,   322,   323,    -1,    -1,    -1,    -1,
      -1,  1059,    -1,    -1,    -1,  1063,    -1,  1065,  6309,    -1,
      -1,    -1,    -1,    -1,   223,   224,    -1,    -1,    -1,    62,
      -1,    -1,  6323,    -1,    -1,    -1,    -1,    -1,    -1,  3587,
      -1,    -1,    -1,    -1,    -1,    -1,   364,  3595,    -1,    -1,
     368,    -1,   251,    -1,    -1,   373,    -1,    -1,    -1,  1508,
      -1,   932,    -1,    -1,   382,    98,    -1,  6358,  6359,  6360,
    6361,    -1,  3620,   391,    -1,    -1,    -1,  6368,    -1,    -1,
    6371,   399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6383,   411,   293,  6386,    -1,    -1,    -1,    -1,
      -1,    -1,   420,    -1,    -1,    -1,    -1,   425,    -1,   308,
      -1,    -1,   311,    -1,    -1,    -1,    -1,    -1,  6409,    -1,
      -1,    -1,    -1,  1171,    -1,    -1,  1575,    -1,   161,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6428,  6429,    -1,
      -1,    -1,  3690,  6434,  3692,    -1,    -1,  6438,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6451,  6452,   480,    -1,  6455,   198,    -1,  1616,    -1,    -1,
      -1,  1042,    -1,    -1,    -1,    -1,    -1,  1048,    -1,    -1,
      -1,    -1,    -1,    -1,  1232,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5904,    -1,    -1,  1243,  5908,    -1,  5910,    -1,
    1649,    -1,  5914,  5915,    -1,   404,    -1,    -1,    10,  1257,
      -1,    13,    -1,  1261,   247,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    23,    -1,    -1,    -1,    -1,    28,    -1,
      -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,  3786,    -1,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    -1,    -1,   286,    -1,    -1,    -1,   290,    -1,    -1,
      10,    -1,    -1,    13,    -1,  3813,    66,    17,    18,    19,
      -1,  3819,    -1,    -1,    -1,    -1,    78,    -1,    -1,    79,
    3828,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,   322,
     323,    -1,    -1,    -1,    -1,    45,    96,    -1,    -1,    -1,
    1171,  6013,    52,    -1,    -1,    -1,    -1,   506,  3856,    -1,
      -1,    -1,    -1,    -1,   114,    -1,    -1,   516,   517,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,    78,    -1,
     529,   364,    -1,    -1,    -1,   368,    -1,    -1,   138,    -1,
     373,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   382,
      -1,   151,    -1,    -1,    -1,    -1,  1404,    -1,   391,    -1,
     160,  1232,    -1,    -1,  1412,  1413,   399,    -1,    -1,    -1,
      -1,    -1,  1243,   173,    -1,    -1,  3924,    -1,   411,   179,
      -1,    -1,    -1,    -1,    -1,    -1,  1257,   420,    -1,    -1,
    1261,  1840,   425,    -1,   196,    -1,    -1,    -1,  3946,   201,
      -1,    -1,  1851,    -1,    -1,   205,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1465,  1867,    -1,
    3968,   223,   224,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   196,   480,    -1,   251,
      -1,   201,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6172,    -1,    45,    -1,    -1,   265,    -1,    -1,    -1,    52,
      -1,  1920,    -1,   223,   224,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1935,    -1,    -1,  1938,
    1939,   293,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,
      -1,   251,    -1,  4051,    -1,    -1,   308,    -1,   308,   311,
      -1,    -1,    -1,    -1,   721,    -1,    -1,  6229,    -1,    -1,
    1969,  1970,    -1,    -1,    -1,    -1,  4074,    -1,    -1,    -1,
      -1,    -1,    -1,  1404,    -1,    -1,    -1,    -1,    -1,    -1,
     747,  1412,  1413,   293,   344,   345,    -1,    -1,   348,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4104,    -1,   308,    -1,
      -1,   311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    -1,   376,    -1,    -1,   379,
      -1,  4129,    -1,    -1,    -1,    -1,   386,    -1,    -1,    -1,
      -1,    -1,    -1,   393,  1465,    -1,   396,    -1,    -1,    -1,
      -1,    -1,   404,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,   196,    -1,   415,    -1,    -1,   201,    -1,
      -1,    -1,    -1,   423,    -1,    -1,    -1,    -1,    35,   429,
      -1,    -1,   432,    -1,    -1,    -1,   436,    -1,    45,    -1,
     223,   224,    -1,    -1,   444,    52,    -1,    -1,    -1,    -1,
      -1,   451,    -1,    -1,   404,    -1,    -1,    -1,    -1,    -1,
    2109,    -1,    -1,    -1,    -1,    -1,  1714,    -1,   251,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,   478,    -1,
      -1,  6393,    -1,    -1,    -1,  6397,    -1,    -1,    -1,   896,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   506,    -1,    -1,    -1,    -1,    -1,
     293,    -1,    -1,    -1,   516,   517,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   308,    -1,   529,   311,    -1,
    6442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4290,    -1,    -1,    -1,    -1,    -1,    -1,  6461,
      -1,    -1,  6464,    -1,    -1,    -1,   506,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   516,   517,   518,   519,
     520,   521,   522,   523,   524,    -1,    -1,    -1,    -1,   529,
    1828,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,
      -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1863,   223,   224,    -1,    -1,
      -1,   404,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,  4380,    -1,    -1,    -1,    -1,    -1,  1886,    -1,
      -1,    -1,    -1,  1714,   251,    -1,  1894,    35,    -1,    -1,
      -1,  1058,    -1,    -1,  1902,    -1,    -1,    45,  4406,    -1,
      -1,    -1,  1069,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1085,    -1,
      10,    -1,    -1,    13,    -1,    -1,   293,    17,    18,    19,
      78,    -1,    -1,    -1,  1942,  1943,    -1,  1945,  1946,    -1,
      -1,   308,    -1,    -1,   311,    35,    -1,    -1,    -1,  1957,
      -1,  1959,  1960,    -1,    -1,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    52,   506,  1972,  1973,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   516,   517,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,    10,    -1,   529,    13,    78,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,  1828,    -1,    -1,
      -1,    -1,  2010,    -1,    -1,    -1,  2014,  2015,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,
      -1,    -1,  1863,    -1,    -1,    -1,    -1,   404,    -1,    -1,
    4548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,
      -1,    -1,    78,   201,    -1,  1886,    -1,    -1,    -1,    10,
      -1,    -1,    13,  1894,    -1,    -1,    17,    18,    19,    -1,
      -1,  1902,    -1,    -1,  1241,   223,   224,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    35,    -1,    -1,  4595,    -1,    -1,
      -1,    -1,  4600,    -1,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,   251,    -1,    -1,   196,    -1,    -1,    -1,
      -1,   201,    -1,    -1,  1945,  1946,    -1,    -1,    -1,    -1,
      -1,    -1,  2130,    -1,    -1,    -1,    -1,    78,  1959,    -1,
      -1,    -1,    -1,   223,   224,    -1,    -1,    -1,    -1,   506,
      -1,  1972,  1973,    -1,    -1,   293,    -1,    -1,    -1,   516,
     517,   518,   519,   520,   521,   522,   523,   524,    -1,    -1,
     308,   251,   529,   311,    -1,    -1,    -1,    -1,    -1,    -1,
     196,    -1,    -1,    -1,    51,   201,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,   224,    -1,
      -1,    -1,    -1,   293,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,
      -1,   311,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,
     201,    -1,    -1,    -1,    -1,    -1,   404,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   293,    -1,    -1,
      -1,  4779,   223,   224,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   308,    -1,   721,   311,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2130,
     251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     747,    -1,    -1,    -1,   404,  2724,    -1,    -1,    -1,  2728,
    2729,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1508,   293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,   506,    -1,
     311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   516,   517,
     518,   519,   520,   521,   522,   523,   524,  2786,   404,    -1,
      -1,   529,    -1,  2792,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4905,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1575,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   506,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2833,    -1,   516,   517,   518,   519,
     520,   521,   522,   523,   524,  4943,    -1,    -1,    -1,   529,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1616,
      -1,    -1,    -1,   404,    -1,    -1,    -1,  4965,    -1,   896,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     506,    -1,  1649,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     516,   517,   518,   519,   520,   521,   522,   523,   524,    -1,
      -1,    -1,    -1,   529,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5036,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   506,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   516,   517,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,    -1,    -1,   529,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1058,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1069,  3042,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5155,  1085,  5157,
      -1,    -1,    -1,    -1,  2662,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1840,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1851,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1867,    -1,    -1,    -1,    -1,    -1,  3115,    -1,    -1,  2717,
    3119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2735,    -1,    -1,
      -1,  2739,    -1,    -1,    -1,  2743,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2752,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1920,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2770,    -1,    -1,    -1,    -1,    -1,  1935,    -1,
      -1,  1938,  1939,    -1,    -1,    -1,    -1,    -1,    -1,  2787,
      -1,  2789,  2790,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,  2804,    -1,    -1,    -1,
    5308,    -1,  1969,  1970,  1241,    -1,    -1,    -1,    -1,    -1,
      -1,    35,  3221,    -1,    -1,    -1,  2824,  2825,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    -1,    -1,  3236,    52,    -1,
      -1,  2662,  3241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   721,    -1,    -1,  2855,  2856,    -1,
      -1,  2859,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3271,    -1,    -1,    -1,    -1,    -1,  5376,    -1,
     747,    -1,    -1,    -1,    -1,  2883,    -1,  2885,    -1,    -1,
      -1,  2889,    -1,    -1,    -1,    -1,  2717,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2903,    -1,    -1,    -1,    -1,
      -1,    -1,  2910,    -1,  2735,  2913,    -1,    -1,  2739,    -1,
      -1,  2919,  2743,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,  2752,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,  2939,    -1,    -1,    -1,    -1,    -1,  2945,    -1,  2770,
      35,    -1,  2109,    -1,  2952,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    10,    -1,    -1,    13,    52,  2966,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2979,   196,  2804,    -1,    -1,  2984,   201,    35,    -1,
      -1,    -1,  2990,    78,    -1,    -1,    -1,    -1,    45,    -1,
    5498,    -1,    -1,  2824,  2825,    52,    -1,    -1,    -1,   223,
     224,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   896,
      -1,    78,    -1,    -1,  2855,  2856,    -1,   251,  2859,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3050,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2883,     8,  2885,    -1,    -1,    -1,  2889,    14,
      15,    -1,    -1,    -1,    -1,    20,    -1,    22,    -1,   293,
      -1,  1508,  2903,    28,    -1,    30,    -1,    -1,    -1,  2910,
      -1,    -1,  2913,    -1,   308,    -1,    -1,   311,  2919,    -1,
      -1,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      -1,   196,    -1,    -1,    -1,    -1,   201,    -1,  2939,    -1,
      -1,    -1,    -1,    -1,  2945,    -1,    -1,    -1,    -1,    -1,
    3529,  2952,    -1,  3532,    -1,  3534,    -1,    -1,   223,   224,
    3539,    -1,    -1,    -1,    -1,  2966,    -1,    -1,  1575,   196,
      -1,  5649,    -1,    -1,   201,    -1,  5654,  5655,  2979,    -1,
      -1,    -1,    -1,  2984,    -1,    -1,   251,    -1,    -1,  2990,
      -1,    -1,    -1,    -1,    -1,    -1,   223,   224,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3587,  1616,
     404,  1058,    -1,    -1,    -1,    -1,  3595,    -1,    -1,    -1,
      -1,    -1,  1069,    -1,   251,    -1,    -1,  3205,   293,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1085,    -1,
      -1,  3620,  1649,   308,    -1,  3223,   311,    -1,    -1,  3050,
      -1,    -1,  3230,    -1,    -1,    -1,    -1,    -1,    -1,  3237,
      23,  3239,  3240,    -1,    -1,    28,   293,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   200,    -1,    -1,    -1,   204,
      -1,   308,    -1,    -1,   311,    -1,    -1,   212,  5766,  5767,
     215,    -1,    -1,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3690,   506,  3692,    -1,    -1,    79,    80,    -1,    -1,
      -1,    -1,   516,   517,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,    96,    -1,   529,    -1,    -1,    -1,   404,
      -1,    -1,    -1,    -1,    -1,  5823,    -1,    -1,    -1,    -1,
      -1,   114,    -1,  3331,    -1,    -1,    -1,    -1,    10,  3337,
      -1,    13,  5840,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   138,    -1,   404,    -1,    -1,
      -1,    -1,    -1,    35,    -1,    -1,    -1,    39,   151,    -1,
      -1,    -1,    -1,    45,  1241,    -1,    -1,   160,    -1,    -1,
      52,    -1,    -1,    -1,  3205,    -1,    -1,  3786,    -1,    -1,
     173,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,    -1,
      -1,    -1,  3223,    -1,    -1,    -1,    78,    -1,    -1,  3230,
      -1,    -1,    -1,  1840,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   506,   205,  3421,  1851,    -1,    -1,    -1,    -1,  3828,
      -1,   516,   517,   518,   519,   520,   521,   522,   523,   524,
    1867,    -1,    -1,    -1,   529,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3856,   130,   506,
     243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   516,
     517,   518,   519,   520,   521,   522,   523,   524,    -1,    -1,
     527,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1920,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1935,    -1,
    3331,  1938,  1939,    -1,    -1,    -1,  3337,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   196,  3924,    -1,    -1,    -1,   201,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1969,  1970,    -1,    -1,    -1,  3946,    -1,    -1,
      -1,   223,   224,    -1,    -1,    -1,  3554,  3555,    -1,    -1,
      -1,   344,   345,    -1,    -1,   348,    -1,  2724,    -1,  3968,
      -1,  2728,  2729,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,  3581,    -1,    -1,  3584,    -1,    -1,    -1,
      -1,    -1,    -1,   376,    -1,    -1,   379,    -1,    -1,    -1,
    3421,    -1,    -1,   386,    -1,    -1,    -1,    -1,    -1,    -1,
     393,    -1,    -1,   396,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2786,
      -1,    -1,   415,    -1,    -1,  2792,   308,    -1,    -1,   311,
     423,  1508,    -1,    -1,    -1,    -1,   429,    -1,    -1,   432,
      -1,    -1,  4051,   436,    -1,    -1,    -1,    -1,  3656,  3657,
    3658,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   451,    -1,
      -1,    -1,    -1,    -1,    -1,  4074,  2833,    -1,    -1,    -1,
      -1,    -1,  2109,  3681,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   478,    -1,    -1,    -1,    -1,
      -1,    -1,  3700,    -1,    -1,  4104,    -1,    -1,  1575,    -1,
      -1,    -1,    -1,    -1,   659,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,  3722,   670,    17,    18,    19,   674,
    4129,    -1,   404,  3554,  3555,    -1,   681,   682,    -1,    -1,
     685,    -1,   687,   688,    35,    -1,    -1,    -1,    -1,  1616,
      -1,    -1,    -1,    -1,    45,    -1,    -1,   702,    -1,    -1,
    3581,    52,    -1,  3584,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   720,    -1,    -1,    -1,    -1,
      -1,    -1,  1649,    -1,    -1,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    -1,    -1,   466,    -1,   741,    -1,   743,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   753,    -1,
    3808,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   506,  3656,  3657,  3658,    -1,    -1,
      -1,   786,    -1,    -1,   516,   517,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,    -1,    -1,  3855,    -1,    -1,
    3681,    -1,    -1,  3861,    -1,  3863,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3876,  3700,
    3878,    -1,    -1,    -1,    -1,  3042,    -1,    -1,    -1,    -1,
      -1,  4290,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3722,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,
     201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   873,    -1,
    6428,    -1,   223,   224,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3945,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3115,    -1,
     251,    -1,  3119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1840,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4380,    -1,    -1,  1851,    -1,    -1,  3808,    -1,  3987,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1867,    -1,   293,    -1,    -1,    -1,    -1,  4406,  4006,    -1,
      -1,    -1,    -1,   958,    -1,    -1,    -1,   308,    -1,    -1,
     311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4028,    -1,    -1,  4031,  3855,    -1,    -1,    -1,    -1,    -1,
    3861,    -1,  3863,    -1,    -1,    -1,    -1,   338,    -1,    -1,
      -1,    -1,    -1,  1920,    -1,  3876,    -1,  3878,    -1,    -1,
      -1,    -1,    -1,    -1,  3221,    -1,    -1,    -1,  1935,    -1,
      -1,  1938,  1939,    -1,    -1,    -1,    -1,    -1,    -1,  3236,
      -1,    -1,    -1,    -1,  3241,    -1,    -1,  1032,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1969,  1970,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1056,    -1,   404,  3271,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3945,    -1,  1071,    -1,  1073,    -1,
      -1,   422,    -1,    -1,    -1,    -1,    -1,    -1,  1083,    -1,
      -1,    -1,    -1,  4141,    -1,  1090,    -1,    -1,    -1,  4548,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,  3987,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    -1,    -1,  4006,    -1,  1132,    -1,  1134,
      -1,    45,    -1,    -1,    -1,    -1,  4595,    -1,    52,    -1,
      -1,  4600,    -1,    -1,    -1,    -1,    -1,  4028,    -1,    -1,
    4031,    -1,    -1,    -1,    -1,   506,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,   516,   517,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2109,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1208,    -1,  1210,    -1,  1212,    -1,  1214,
      -1,  1216,  1217,  1218,    -1,    -1,    -1,    -1,  1223,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1235,    -1,    -1,    -1,    -1,    -1,    -1,  2724,    -1,    -1,
      -1,  2728,  2729,  1248,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   171,    -1,    -1,
    4141,    -1,    -1,   177,    -1,  4323,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   196,    -1,    -1,    -1,    -1,   201,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2786,
      -1,    -1,    -1,    -1,    -1,  2792,    -1,    -1,    -1,   223,
     224,    -1,  3529,    -1,    -1,  3532,  4374,  3534,    -1,    -1,
    4779,  4379,  3539,  4381,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2833,  4405,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3587,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3595,   293,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4451,   308,    -1,  4454,   311,    -1,    -1,
      -1,    -1,    -1,  3620,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1429,    -1,   721,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4323,    -1,    -1,    -1,  4905,    -1,    -1,    -1,
      -1,    -1,   747,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3690,    -1,  3692,    -1,    51,    -1,    35,
      -1,    -1,    -1,    -1,  4943,    -1,  4544,  4545,    -1,    45,
     404,    -1,    -1,  4374,    -1,    -1,    52,  4555,  4379,    -1,
    4381,    -1,    -1,    -1,    -1,    -1,  4965,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4572,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    -1,  4405,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1549,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    10,  3042,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,  3786,
    4451,    -1,    -1,  4454,    -1,    -1,    -1,  5036,    -1,    35,
      -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    -1,   506,    -1,    -1,  4653,    52,    -1,    -1,    -1,
      -1,   896,   516,   517,   518,   519,   520,   521,   522,   523,
     524,  3828,    -1,    -1,   170,    -1,  1621,    -1,    -1,    -1,
      -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,  3115,    -1,
      -1,    -1,  3119,    -1,    -1,    -1,    -1,    -1,    -1,  3856,
     196,    -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4544,  4545,    -1,    -1,   223,   224,    -1,
      -1,    -1,    -1,    -1,  4555,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4572,    -1,    -1,    -1,   251,    -1,    -1,  5157,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3924,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3946,
      -1,    -1,    -1,    -1,  3221,    -1,    -1,   293,    -1,    -1,
     196,    -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,  3236,
      -1,  3968,   308,    -1,  3241,   311,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1058,    -1,    -1,    -1,   223,   224,    -1,
      -1,    -1,  4653,    -1,  1069,    -1,    -1,    -1,    -1,    -1,
     336,    -1,    -1,    -1,  3271,    -1,    -1,    -1,    -1,    -1,
    1085,    -1,    -1,    -1,    -1,   251,    -1,  2724,    -1,    -1,
      -1,  2728,  2729,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1836,    -1,    -1,  4051,    -1,    -1,   293,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,  5308,
      -1,    -1,   308,    -1,    -1,   311,    -1,  4074,    -1,  2786,
    4918,    -1,    -1,    -1,    -1,  2792,  1871,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4960,    -1,    -1,    -1,  2833,    -1,    -1,  1914,
      -1,  1916,  4129,    -1,  4972,    -1,    -1,  5376,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,  1936,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1241,  5005,   404,    -1,
     506,    -1,    -1,    -1,    -1,    -1,    -1,  1962,    -1,  1964,
     516,   517,   518,   519,   520,   521,   522,   523,   524,    -1,
      -1,    -1,    -1,    -1,  1979,    -1,  1981,    -1,    -1,    -1,
      -1,    -1,  1987,    -1,  1989,    -1,  1991,    -1,  1993,    -1,
    1995,    -1,    -1,    -1,  1999,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5083,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4918,    -1,  5498,
      -1,    -1,  3529,    -1,  5102,  3532,    -1,  3534,    -1,    -1,
     506,    -1,  3539,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     516,   517,   518,   519,   520,   521,   522,   523,   524,    10,
      -1,    -1,    13,  4290,    -1,    -1,    17,    18,    19,  4960,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4972,    -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,
    3587,    -1,    -1,    -1,    45,    -1,    -1,    -1,  3595,    -1,
      -1,    52,    -1,    -1,    -1,  3042,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5005,    -1,    -1,    -1,    -1,    -1,
    5188,    -1,    -1,  3620,    -1,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   721,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4380,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   747,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3115,  4406,
    5649,    -1,  3119,    -1,    -1,  5654,  5655,    -1,    -1,    -1,
      -1,    -1,  5083,  3690,    -1,  3692,    -1,    -1,    -1,    10,
      -1,    -1,    13,  1508,    -1,    -1,    17,    18,    19,    -1,
      -1,  5102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   174,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,
     201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,  5330,    -1,  5332,    -1,    -1,    78,    -1,    -1,
    1575,    -1,   223,   224,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3221,    -1,    -1,    -1,    -1,  3786,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5188,  5767,  3236,
     251,    -1,    -1,    -1,  3241,    -1,    -1,    -1,    -1,  5377,
      -1,  1616,   896,    -1,    -1,    -1,    -1,    -1,    -1,  5387,
      -1,  4548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3828,    -1,    -1,  3271,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   293,    -1,  1649,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5823,    -1,    -1,   308,    -1,  3856,
     311,  5429,    -1,    -1,    -1,    -1,  5434,    -1,  4595,    -1,
      -1,  5840,    -1,  4600,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,
     201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   223,   224,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3924,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5330,
     251,  5332,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3946,
      -1,    -1,    -1,   404,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3968,    -1,    -1,  1058,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   293,    -1,    -1,  1069,  5377,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,
     311,  1085,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1840,    -1,    -1,  5429,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1851,    -1,    -1,    -1,
      -1,    -1,  4779,    -1,  4051,   506,    -1,    -1,    -1,    -1,
      -1,   372,  1867,    -1,    -1,   516,   517,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,    -1,  4074,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     721,    -1,  3529,   404,    -1,  3532,    -1,  3534,    -1,  5667,
      -1,    -1,  3539,    -1,    -1,    -1,    -1,  4104,    -1,    -1,
      -1,    -1,    -1,  5681,    -1,  1920,   747,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1935,    -1,  4129,  1938,  1939,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5712,    -1,    -1,    -1,    -1,    -1,
    3587,    -1,    -1,    -1,    -1,    -1,    -1,  1241,  3595,    -1,
      -1,    -1,    -1,    -1,  1969,  1970,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4905,    -1,
      -1,    -1,    -1,  3620,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   506,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2718,  2719,   516,   517,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,  4943,    -1,    -1,    -1,
      -1,    -1,  2737,  2738,    -1,  2740,  2741,    -1,    -1,    -1,
    2745,  2746,    -1,    -1,    -1,    -1,    -1,    -1,  4965,    -1,
      -1,    -1,    -1,    -1,    -1,  2760,    -1,    -1,    -1,    -1,
      -1,    -1,  2767,  3690,    -1,  3692,  2771,  2772,    -1,    -1,
    2775,  2776,    -1,    -1,    -1,   896,    -1,  2782,    -1,  5837,
      -1,    -1,    -1,    -1,    -1,    -1,  5667,    -1,    -1,  2794,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5681,  2806,    -1,  4290,    -1,    -1,  2811,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2109,    -1,    -1,    -1,    -1,  5036,
      -1,  2826,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2835,  5712,    -1,  2838,    -1,  2840,  2841,  2842,    -1,    -1,
      -1,    -1,  2847,  2848,  5902,    -1,  5904,    -1,    -1,    -1,
      -1,    -1,  2857,    -1,    -1,    -1,    -1,    -1,  2863,  3786,
      -1,    -1,  2867,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2879,  2880,    -1,    -1,    -1,  2884,
      -1,    -1,    -1,    -1,    -1,  2890,  2891,    -1,    -1,    -1,
      -1,    -1,    -1,  4380,    -1,    -1,    -1,    -1,    -1,  2904,
      -1,  3828,  2907,    -1,    -1,    -1,    -1,    -1,    -1,  2914,
    2915,    -1,    -1,    -1,    -1,  2920,    -1,    -1,    -1,  4406,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2932,    -1,  3856,
    2935,    -1,    -1,  5991,  1508,  2940,    -1,  1058,    -1,   721,
    5157,  2946,  2947,    -1,    -1,    -1,    -1,    -1,  1069,  2954,
      -1,    -1,    -1,  2958,    -1,    -1,  5837,  2962,  2963,  2964,
    2965,    -1,  2967,    -1,  1085,   747,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2980,  2981,    -1,  2983,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2994,
    2995,  2996,    -1,    -1,    -1,    -1,    -1,  3924,  6056,    -1,
      -1,  1575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6069,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3946,
      -1,  5902,    -1,  5904,  6082,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3968,  1616,    -1,    -1,    -1,  3051,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3059,    -1,    -1,    10,    -1,    -1,
      13,  4548,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,  3078,    -1,  1649,    -1,    -1,    -1,    -1,
      -1,    -1,    35,  6141,  6142,    -1,    -1,    -1,    -1,    -1,
      -1,  5308,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4595,    -1,
    5991,    -1,    -1,  4600,   896,    -1,    -1,    -1,    -1,    -1,
    1241,    -1,    -1,  3128,  4051,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3147,    -1,  3149,    -1,    -1,  4074,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5376,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6229,    -1,    -1,    -1,  6056,    -1,  4104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6082,  4129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,  3243,    -1,
      -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,   201,    -1,
      -1,    35,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    -1,  1840,    -1,    52,    -1,
     223,   224,    -1,    -1,    -1,    -1,  1058,  1851,    -1,    -1,
      -1,  5498,    -1,    -1,    -1,    -1,    -1,  1069,    -1,    -1,
      -1,    -1,  4779,  1867,    78,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,  1085,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6393,    -1,    -1,    -1,    -1,
     293,    -1,    -1,    -1,    -1,    -1,  1920,    -1,  6229,    -1,
      -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,   311,    -1,
      -1,  1935,    -1,  4290,  1938,  1939,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   331,    -1,
      -1,    -1,    -1,    -1,  6442,    -1,    -1,  1508,    -1,    -1,
      -1,    -1,    -1,  6451,  6452,  1969,  1970,    -1,    -1,    -1,
      -1,    -1,    -1,  6461,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   196,    -1,    -1,    -1,    -1,   201,  4905,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2724,
      -1,    -1,  5649,  2728,  2729,    -1,    -1,  5654,  5655,   223,
     224,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   404,    -1,  4380,  1575,    -1,  4943,    -1,    -1,  1241,
      -1,    10,    -1,    -1,    13,    -1,    -1,   251,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4965,  4406,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      -1,  2786,    -1,    -1,    -1,  1616,    45,  2792,    -1,    -1,
      -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,   293,
      -1,    -1,  6393,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   308,    -1,    -1,   311,  1649,    78,
      -1,    -1,    -1,    -1,    -1,  2109,    -1,    -1,  2833,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5036,
    5767,    -1,    -1,   506,    -1,    -1,    -1,  3562,    -1,    -1,
      -1,  6442,    -1,   516,   517,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,    -1,    -1,    -1,  3582,    -1,    -1,
    6461,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    -1,  3599,    13,    -1,    -1,  3603,    17,
      18,    19,    -1,  3608,  3609,  3610,  5823,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,
     404,  4548,    -1,  5840,    -1,    -1,    -1,    45,   177,    -1,
      -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,  3644,
    3645,  3646,  3647,    -1,    -1,    -1,    -1,   196,    -1,    -1,
      -1,    -1,   201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4595,  3674,
    5157,    -1,    -1,  4600,   223,   224,    -1,  3682,    -1,  3684,
    3685,  3686,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1840,
      -1,    -1,   506,    -1,    -1,    -1,  1508,    -1,    -1,    -1,
    1851,    -1,   516,   517,   518,   519,   520,   521,   522,   523,
     524,    -1,    10,    -1,   293,    13,  1867,  3042,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,
      -1,    -1,   311,    -1,    -1,    -1,    -1,    35,    -1,    -1,
      38,    -1,    -1,    -1,    -1,    -1,    -1,    45,   196,    -1,
      -1,    -1,    -1,   201,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1575,    -1,  3800,    -1,    -1,    -1,  1920,
      -1,    -1,    -1,    -1,  3809,   223,   224,    -1,    -1,    -1,
      78,    -1,    -1,    -1,  1935,    -1,    -1,  1938,  1939,    -1,
    3115,  5308,    -1,    -1,  3119,    -1,    -1,    -1,    -1,    -1,
    3835,  3836,    -1,   251,  1616,  3840,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1969,  1970,
      -1,    -1,  4779,    -1,    -1,   404,    -1,  3862,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1649,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   293,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,  5376,
     308,    -1,    -1,   311,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    35,    -1,    -1,    38,    -1,    -1,    -1,  3914,
      -1,    -1,    45,    -1,  3919,    -1,    -1,    -1,    -1,    52,
    3925,    -1,    -1,    -1,    -1,    -1,  3221,    -1,   196,    -1,
      -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3236,    -1,    -1,    -1,    78,  3241,    -1,    -1,    -1,
    3955,    -1,    -1,    -1,    -1,   223,   224,   506,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   516,   517,   518,
     519,   520,   521,   522,   523,   524,  3271,    -1,  4905,  3984,
      -1,  3986,    -1,   251,    -1,    -1,   404,    -1,  2109,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5498,    -1,    -1,    -1,    -1,  4943,    -1,    -1,   437,
      -1,    -1,  4027,    -1,    -1,   293,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4965,    -1,
     308,    -1,    -1,   311,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1840,    -1,
      -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,   201,  1851,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1867,    -1,    -1,   506,    -1,
     223,   224,    -1,    -1,    -1,    -1,    -1,    -1,   516,   517,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,  5036,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,  1920,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2724,    -1,    -1,  1935,  2728,  2729,  1938,  1939,    -1,    -1,
     293,    -1,  5649,    -1,    -1,    -1,    -1,  5654,  5655,    -1,
      -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,   311,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1969,  1970,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2786,    -1,    -1,    -1,    -1,    -1,  2792,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5157,    -1,    -1,    -1,  3529,    -1,    -1,  3532,   506,  3534,
      -1,    -1,    -1,    -1,  3539,    -1,    -1,    -1,   516,   517,
     518,   519,   520,   521,   522,   523,   524,    -1,    -1,  2833,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   404,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5767,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3587,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3595,  4306,    -1,    -1,  4309,    -1,  4311,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,  4324,
      -1,    17,    18,    19,    -1,  3620,    -1,  2109,    -1,    -1,
      -1,  4336,    -1,    -1,    -1,  4340,  5823,    -1,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    -1,    -1,  5840,  4359,    -1,    52,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4377,   506,    -1,    -1,    -1,    -1,  4383,    -1,
      -1,  5308,    78,   516,   517,   518,   519,   520,   521,   522,
     523,   524,    -1,    -1,    -1,  3690,    -1,  3692,    -1,    -1,
      -1,    -1,    -1,  4408,    -1,    -1,    -1,  4412,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4427,  4428,  4429,  4430,    -1,    -1,    -1,    -1,
      -1,    -1,  4437,  4438,  4439,  4440,    -1,    -1,    -1,    -1,
      -1,  4446,  4447,    -1,    -1,    -1,    -1,  4452,  4453,  5376,
    4455,  4456,  4457,  4458,  4459,  4460,  4461,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4471,    -1,  3042,    -1,
    4475,  4476,  4477,  4478,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3786,    -1,    -1,  4499,    -1,    -1,    -1,    -1,    -1,
     196,    -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,
      -1,    -1,  4517,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,   224,    -1,
      -1,    -1,    -1,  3828,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3115,    -1,    -1,    -1,  3119,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,   251,    17,    18,    19,    -1,
      -1,  3856,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5498,    -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,  4593,    -1,
      -1,    52,    -1,    -1,    -1,    -1,    -1,   293,    -1,    -1,
      -1,    -1,    -1,  2724,    -1,    -1,    -1,  2728,  2729,    -1,
      -1,    -1,   308,    -1,    -1,   311,    -1,    78,    -1,    -1,
      -1,  4626,    -1,    -1,    -1,    -1,    -1,    -1,  4633,  3924,
    4635,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3221,    -1,    -1,
      -1,  3946,  4657,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3236,    -1,    -1,  2786,    -1,  3241,    -1,    -1,
      -1,  2792,    -1,  3968,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3271,    -1,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,
      -1,    45,  2833,    -1,    -1,    -1,   177,    -1,    52,    -1,
      -1,    -1,  5649,    -1,    -1,    -1,    -1,  5654,  5655,    -1,
      -1,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,
     201,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    -1,    -1,  4051,    31,    -1,    -1,
      -1,    -1,   223,   224,    38,    -1,    -1,    -1,    -1,    -1,
      -1,   208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4074,
      -1,    -1,    -1,   220,    -1,    -1,    60,    -1,    -1,    -1,
     251,    -1,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,  4104,
     506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     516,   517,   518,   519,   520,   521,   522,   523,   524,    -1,
      -1,    -1,   293,    -1,  4129,    -1,    -1,   171,   112,    -1,
    5767,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,
     311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,
      -1,    -1,   196,    -1,    -1,    -1,   140,   201,    -1,    -1,
     144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,
     224,    -1,    -1,    -1,    -1,    -1,  5823,    -1,   172,    -1,
      -1,  4906,  4907,  4908,    -1,    -1,    -1,  4912,  4913,  4914,
    4915,    -1,    -1,  5840,  4919,    -1,    -1,   251,    -1,    -1,
      -1,  3042,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     204,    -1,    -1,   207,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2724,   404,    -1,    -1,  2728,  2729,    -1,    -1,
    4955,  4956,  4957,  4958,  4959,  3529,  4961,  4962,  3532,   293,
    3534,    -1,    -1,    -1,    -1,  3539,    -1,    -1,  4973,  4974,
      -1,    -1,    -1,    -1,   308,    -1,    -1,   311,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   266,    -1,  3115,  4290,   270,    -1,  3119,    -1,
      -1,  5006,    -1,    -1,  2786,    -1,    -1,    -1,    -1,    -1,
    2792,    -1,   286,  3587,    -1,    -1,   290,    -1,    -1,    -1,
      -1,  3595,    -1,    -1,    -1,    -1,   300,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   506,  3620,   321,   322,    -1,
      -1,  2833,    -1,    -1,    -1,   516,   517,   518,   519,   520,
     521,   522,   523,   524,    -1,    -1,    -1,    -1,    -1,    -1,
     404,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,  4380,    17,    18,    19,    -1,
     364,    -1,    -1,   367,   368,   369,    -1,    -1,    -1,    -1,
    3221,    -1,    -1,  5108,    35,    -1,    -1,    -1,    -1,    -1,
      -1,  4406,    -1,    -1,    45,  3236,  3690,    -1,  3692,   393,
    3241,    52,    -1,    -1,    -1,   399,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   413,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,
    3271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5173,    -1,
      -1,    -1,   506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   516,   517,   518,   519,   520,   521,   522,   523,
     524,    -1,    -1,    -1,    -1,   469,    -1,    -1,    -1,  5204,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5215,    -1,  3786,    -1,    -1,    -1,    -1,    -1,    -1,   150,
      -1,    -1,   659,    -1,    -1,    -1,    -1,    -1,   665,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4548,  3828,    -1,    -1,    -1,    -1,    -1,
    3042,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,
     201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3856,    -1,   839,   840,    -1,    -1,    -1,    -1,
      -1,    -1,   223,   224,    -1,    -1,    -1,    -1,    -1,    -1,
    4595,    -1,    -1,    -1,    -1,  4600,    -1,    -1,    -1,    -1,
    5315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3115,    -1,    -1,    -1,  3119,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3924,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   293,    -1,   919,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3946,  5378,    -1,    -1,    -1,   308,    -1,    -1,
     311,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,  5397,    -1,  3968,    -1,    -1,    -1,    -1,    -1,
    5405,  5406,    -1,    -1,    -1,   842,    35,    -1,  3529,    -1,
    5415,  3532,    -1,  3534,    -1,    -1,    45,  5422,  3539,    -1,
      -1,    -1,    -1,    52,   861,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3221,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      -1,    -1,  5457,  5458,  3236,    10,    -1,    -1,    13,  3241,
      -1,    -1,    17,    18,    19,  5470,  3587,  5472,    -1,    -1,
      -1,    -1,    -1,   404,  3595,    -1,    -1,  4051,    -1,    -1,
      35,    -1,  5487,    -1,  4779,  1040,  1041,    -1,    -1,  3271,
      45,    -1,    -1,    -1,    -1,    -1,   933,    52,    -1,  3620,
    4074,    -1,    -1,    -1,    -1,    -1,    -1,  5512,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5520,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,
    4104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   980,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4129,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,  3690,
      -1,  3692,   201,    -1,    -1,   506,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   223,   224,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5614,
    4905,    -1,    -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5638,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   196,    -1,  5648,    -1,    -1,   201,    -1,  4943,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1094,    -1,    -1,
      -1,    -1,    -1,    -1,   293,  3786,    -1,    -1,   223,   224,
    4965,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,
      -1,    -1,   311,    -1,    -1,  1122,  1123,  1124,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3828,    -1,    -1,
    5715,    -1,    -1,    -1,    -1,    -1,  4290,    -1,  1273,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3856,    -1,    -1,   293,    -1,
      -1,  5036,    -1,    -1,    -1,    -1,    -1,  3529,    -1,    -1,
    3532,    -1,  3534,   308,    -1,    -1,   311,  3539,    -1,  1314,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   404,    -1,    -1,    -1,    -1,
    5785,    -1,    -1,    -1,    -1,    -1,    -1,  1342,  1343,  1344,
      -1,  1346,    -1,    10,  1231,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,  3924,    -1,  3587,  4380,    -1,    -1,    -1,
    1247,    -1,  1367,  3595,    -1,    -1,    -1,    -1,    35,  1256,
    5825,    -1,    -1,    -1,    -1,  3946,    -1,    -1,    45,    -1,
      -1,    -1,  4406,    -1,    -1,    52,    -1,    -1,  3620,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3968,    -1,   404,
      -1,    -1,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,  5157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5875,    -1,    -1,    -1,    -1,    -1,    -1,   506,    -1,    -1,
      -1,    -1,    -1,    -1,  5889,    -1,    -1,   516,   517,   518,
     519,   520,   521,   522,   523,   524,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3690,    -1,
    3692,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1482,    -1,    -1,
    4051,  1486,  1487,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5948,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   506,    -1,  4074,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   516,   517,   518,   519,   520,   521,   522,   523,   524,
      -1,    -1,    -1,    -1,  4548,    -1,    -1,    -1,    -1,   196,
      -1,  1418,    -1,  4104,   201,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3786,    -1,   223,   224,  4129,    -1,
      -1,    -1,    -1,  5308,  6019,    -1,    -1,    -1,    -1,    -1,
      -1,  4595,    -1,    -1,    -1,    -1,  4600,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3828,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1498,    -1,  6068,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3856,    -1,   293,    -1,    -1,    -1,
      -1,  5376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   308,    -1,    -1,   311,  6100,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3924,    -1,  1581,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1590,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3946,    -1,    -1,    -1,    -1,  4290,
      -1,    -1,  1359,    -1,  1729,  1730,  1731,    -1,  6183,  6184,
    6185,  6186,  6187,  6188,    -1,  1622,  3968,   404,    -1,    -1,
      -1,  1628,  1629,    -1,    -1,  1632,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5498,    -1,  4779,    -1,    -1,  1645,    -1,
      -1,  1648,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6242,    -1,  1426,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4380,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1704,    -1,  4051,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1718,    -1,    23,    -1,  4406,    -1,    -1,    28,   506,
      -1,    -1,  4074,    -1,    -1,    -1,    -1,    -1,    -1,   516,
     517,   518,   519,   520,   521,   522,   523,   524,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4104,    -1,    -1,    -1,    66,    -1,    -1,    -1,
      -1,  4905,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,  4129,    -1,    -1,
      -1,    -1,    92,    -1,  5649,    -1,    96,    -1,    -1,  5654,
    5655,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4943,
      -1,    -1,    -1,    -1,   114,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1827,  4965,    -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,
      -1,  1838,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     160,    -1,    -1,    -1,    -1,    -1,    -1,  4548,    -1,    -1,
      -1,    -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,   179,
      -1,    -1,    -1,  1880,  1881,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5036,    -1,    -1,   205,    -1,    -1,  1905,    -1,
      -1,    -1,  5767,    -1,  4595,  1912,    -1,    -1,    -1,  4600,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2055,    -1,    -1,   243,    -1,    -1,    -1,    -1,  4290,  2064,
    2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,    -1,
      -1,    -1,  2077,    -1,  2079,   265,  2081,    -1,  5823,  2084,
    2085,  2086,    -1,    -1,    -1,    -1,    -1,  2092,    -1,    -1,
    2095,    -1,    -1,    -1,    -1,  5840,    -1,  1984,  1735,    -1,
      -1,    -1,  1739,    -1,    -1,  2110,  2111,  2112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,
      -1,    -1,    -1,  2128,    -1,    -1,    -1,    -1,    -1,    -1,
    2017,  2018,    -1,  5157,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   334,    -1,    -1,  2034,  4380,    20,
      -1,    -1,    -1,    -1,   344,   345,    -1,    -1,   348,    -1,
      31,    -1,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4406,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   376,    -1,    -1,   379,
      61,    -1,    -1,   383,    -1,    -1,   386,    -1,    -1,    -1,
      -1,    -1,    73,   393,    75,    76,   396,    -1,  4779,    -1,
      -1,    82,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   415,    97,    -1,    99,    -1,
      -1,    -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,   429,
      -1,    -1,   432,    -1,    -1,   116,   436,    -1,   119,    -1,
      -1,    -1,    -1,    -1,   444,    -1,   446,    -1,    -1,    -1,
      -1,   451,    -1,   134,    -1,   136,    -1,    -1,    -1,   140,
    2275,    -1,    -1,    -1,    -1,    -1,   147,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5308,   156,    -1,   158,   478,    -1,
      -1,    -1,    -1,    -1,   165,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   183,    -1,    -1,    -1,  4548,    -1,    -1,    -1,
      -1,    -1,    -1,  2328,    -1,    -1,    -1,    -1,    -1,   200,
      -1,    -1,    -1,    -1,  4905,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4595,    -1,    -1,    -1,    -1,  4600,    -1,
      -1,    -1,  4943,    -1,    -1,    -1,    -1,    -1,  2383,    -1,
      -1,    -1,   253,   254,    -1,    -1,    -1,    -1,   259,    -1,
      -1,    -1,    -1,    -1,  4965,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2053,    -1,    -1,    -1,
      -1,   292,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2078,    -1,    -1,    -1,  2082,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2097,  2098,  2099,    -1,  2101,  5036,    -1,    -1,   339,    -1,
      -1,    -1,    -1,    -1,  5498,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   354,    -1,    -1,    -1,    -1,    -1,   360,
     361,    -1,   363,    -1,    -1,    -1,    -1,   368,    -1,    -1,
     371,    -1,    -1,   374,    -1,    -1,   377,    -1,    -1,    -1,
      -1,    -1,    -1,   384,    -1,    -1,    -1,    -1,    -1,    -1,
     391,   392,    -1,    -1,    -1,    -1,    -1,    -1,   399,    -1,
      -1,    -1,   403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   413,    -1,    -1,    -1,    -1,  4779,    28,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   429,  2564,
    2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,    -1,  2574,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   449,    -1,
    2585,    -1,  2587,    -1,    -1,    -1,  5157,    -1,    -1,    -1,
     461,    -1,    -1,    -1,    -1,    -1,   467,    -1,    -1,    79,
      -1,   472,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   485,    -1,    96,    -1,    -1,    -1,
    2625,    -1,    -1,    -1,  2629,  5649,    -1,  2632,    -1,  2634,
    5654,  5655,  2637,    -1,   114,    -1,    -1,   508,    -1,    -1,
     120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   528,   138,    -1,
      -1,    -1,   533,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   151,    -1,  4905,    -1,    -1,    -1,    -1,    -1,    -1,
     160,    -1,    -1,    -1,    -1,  2690,  2691,    -1,    -1,    -1,
      -1,    -1,    -1,   173,    -1,    -1,    23,  2584,    -1,   179,
      -1,    -1,    -1,    -1,    -1,    -1,   186,  2594,    -1,    -1,
      -1,  4943,    -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4965,    -1,    -1,  2623,  5308,    -1,    66,
      -1,    -1,    -1,  5767,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   243,    -1,    -1,    -1,    -1,  2773,    96,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2670,  2671,   265,    -1,   114,    -1,    -1,
      -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,  5823,
      -1,    -1,    -1,    -1,  5036,  5376,    -1,    -1,    -1,    -1,
      -1,   138,    -1,    -1,    -1,    -1,  5840,  2704,    -1,    -1,
      -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,   308,    -1,
      -1,    -1,    -1,   160,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   173,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   334,   182,    -1,    -1,    -1,   186,
      -1,    -1,    -1,    -1,   344,   345,    -1,    -1,   348,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   376,    -1,    -1,   379,
      -1,    -1,    -1,   383,    -1,    -1,   386,    -1,    -1,    -1,
      -1,    -1,    -1,   393,    -1,    -1,   396,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5157,    -1,  5498,   255,    -1,
      -1,    -1,    -1,    -1,    -1,   415,    -1,    -1,   265,    -1,
      -1,    -1,    -1,   423,  2581,    -1,    -1,    -1,   428,   429,
    2837,    -1,   432,    -1,    -1,    -1,   436,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2852,   446,    -1,    -1,    -1,
      -1,   451,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   308,    -1,    -1,   311,   465,    -1,  2874,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,    -1,
      -1,    -1,    -1,  3008,  3009,  3010,    -1,   334,    -1,  3014,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   356,
      -1,    -1,    -1,    -1,    -1,    -1,  3041,    -1,    -1,    -1,
    2677,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   376,
      -1,    -1,  2689,    -1,    -1,    -1,    -1,  2694,    -1,   386,
      -1,    -1,    -1,    -1,    -1,    -1,   393,    -1,    -1,   396,
      -1,    -1,    -1,  2960,  2961,    -1,  5308,    -1,  5649,    -1,
      -1,    -1,    -1,  5654,  5655,    -1,    -1,    -1,   415,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,
      -1,    -1,   429,    -1,    -1,   432,   433,    -1,   435,   436,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   451,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   459,    -1,    -1,   462,    -1,    -1,   465,    -1,
      -1,    -1,    -1,    -1,  5376,    -1,    -1,    -1,    -1,    -1,
      -1,   478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3061,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5767,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3249,    -1,    -1,    -1,    -1,  3254,
      -1,    -1,  5823,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5498,    -1,    -1,  5840,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3309,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3320,    -1,  3322,  3323,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3336,    -1,    -1,  3339,    -1,  3341,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3377,    -1,  3379,    -1,  3381,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5649,    -1,    -1,
      -1,    -1,  5654,  5655,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3475,    -1,    -1,    -1,    -1,  3480,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5767,    -1,    -1,    -1,    -1,
      -1,  3428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3560,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5823,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5840,    -1,
      -1,    -1,    -1,    -1,    -1,  3252,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3281,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3290,    -1,    -1,  3293,    -1,    -1,    -1,
      -1,    -1,  3299,  3300,    -1,  3302,    -1,    -1,    -1,    -1,
    3307,  3308,    -1,  3310,    -1,  3312,    -1,    -1,    -1,  3316,
      -1,    -1,  3319,    -1,    -1,    -1,    -1,  3324,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3333,    -1,    -1,    -1,
      -1,  3338,    -1,    -1,    -1,    -1,    -1,    -1,  3345,  3346,
    3347,  3348,    -1,    -1,    -1,  3352,  3353,    -1,  3355,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3374,    -1,  3376,
      -1,    -1,    -1,    -1,    -1,    -1,  3383,  3384,  3385,  3386,
    3387,  3388,  3389,  3390,  3391,  3392,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3429,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3813,    -1,
      -1,  3698,    -1,    -1,  3819,    -1,    -1,    -1,    -1,    -1,
      -1,  3708,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3898,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3575,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3867,  3868,  3869,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3884,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3917,  3918,    -1,    -1,    -1,  3922,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4048,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4057,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4070,    -1,    -1,    -1,    -1,
      -1,  4076,  4077,  4078,    -1,    -1,    -1,    -1,  4083,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4095,    -1,  4097,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4124,
    4125,  4126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4143,  4026,
      -1,    -1,  4029,    -1,    -1,    -1,  4151,    -1,    -1,  4154,
      -1,  4156,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4172,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4180,  4181,    -1,    -1,    -1,
    3817,  3818,  4187,    -1,    -1,  3822,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4216,    -1,    -1,  3851,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4267,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4284,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4196,
    4197,  4198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4047,    -1,    -1,    -1,    -1,    -1,  4053,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4101,  4102,    -1,    -1,  4105,  4106,
    4107,  4108,    -1,    -1,  4111,  4112,  4113,  4114,  4115,  4116,
    4117,  4118,  4119,  4120,  4121,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4144,    -1,    -1,
    4147,    -1,  4149,    -1,    -1,  4152,  4153,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4174,  4175,  4176,
    4177,    -1,  4179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4601,  4602,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4612,    -1,    -1,
      -1,    -1,  4249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4525,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4299,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4557,    -1,    -1,    -1,  4679,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4697,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4589,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4725,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4737,    -1,    -1,    -1,    -1,  4624,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4641,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4776,  4777,    -1,    -1,    -1,    -1,    -1,  4783,  4784,
      -1,    -1,    -1,  4788,    -1,    -1,    -1,    -1,  4793,    -1,
      -1,  4796,  4797,    -1,    -1,    -1,    -1,    -1,  4803,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4848,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4859,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4867,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4518,  4887,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4807,  4808,  4809,  4810,  4561,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4988,    -1,    -1,    -1,    -1,    -1,  4994,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4680,    -1,    -1,    -1,  4684,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5062,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4710,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4733,  4734,    -1,    -1,
      -1,    -1,  4739,  4740,  4741,  4742,    -1,    -1,    -1,  4746,
    4747,  4748,  4749,  4750,  4751,  4752,  4753,  4754,  4755,  4756,
    4757,  4758,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4782,    -1,    -1,  4785,    -1,
    4787,    -1,    -1,    -1,  4791,    -1,    -1,  4794,  4795,    -1,
      -1,  4798,  4799,    -1,    -1,    -1,    -1,  4804,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4858,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5235,    -1,    -1,    -1,    -1,  4872,  5241,  5242,  5243,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5266,  5267,  5150,    -1,  5270,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5161,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5298,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5309,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5325,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5065,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5152,  5153,    -1,    -1,    -1,
      -1,    -1,    -1,  5160,    -1,  5530,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5552,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5451,  5202,    -1,    -1,    -1,  5456,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5475,    -1,
      -1,    -1,    -1,  5230,  5599,    -1,    -1,    -1,    -1,    -1,
    5237,  5238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5256,
      -1,  5258,    -1,    -1,    -1,  5262,  5263,  5264,  5265,    -1,
      -1,  5268,  5269,    -1,    -1,    -1,    -1,  5274,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5659,  5292,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5310,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5324,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5701,  5334,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5634,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5398,    -1,    -1,    -1,  5402,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5800,    -1,    -1,    -1,    -1,
    5437,    -1,  5807,  5808,  5809,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5849,    -1,    -1,  5734,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5877,    -1,    -1,  5762,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5545,    -1,
    5547,  5548,  5549,  5550,  5551,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5562,  5563,  5564,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5581,    -1,    -1,  5584,    -1,    -1,
      -1,  5588,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5606,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5621,  5990,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6000,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6043,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6053,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6123,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6147,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5801,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5834,    -1,  5836,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5888,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6278,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5924,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6309,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5996,
      -1,    -1,    -1,    -1,    -1,    -1,  6003,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6428,    -1,    -1,    -1,    -1,    -1,    -1,
    6067,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6194,  6195,    -1,
      -1,  6198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6250,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6275,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,     5,     6,    -1,
       8,     9,    10,    11,    12,    -1,  6303,  6304,    -1,  6306,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,  6369,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,    -1,    -1,
     308,   309,   310,    -1,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,    -1,    -1,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   519,   520,   521,    -1,    -1,    -1,    -1,    -1,    -1,
     528,   529,     3,    -1,     5,     6,    -1,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,    -1,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,    -1,    -1,   308,   309,   310,
      -1,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
      -1,    -1,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,   465,    -1,   467,   468,   469,   470,
     471,   472,   473,    -1,   475,   476,   477,   478,   479,   480,
      -1,    -1,   483,    -1,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,    -1,   508,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   519,   520,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   528,   529,     3,
      -1,     5,     6,    -1,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,    -1,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
      -1,   475,   476,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   519,   520,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   528,   529,     3,    -1,     5,     6,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,   459,   460,   461,   462,   463,   464,   465,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,   476,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   519,   520,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   528,   529,     3,    -1,     5,     6,    -1,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,    -1,   308,   309,
     310,    -1,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,   428,    -1,
     430,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,    -1,   475,   476,   477,   478,   479,
     480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,   519,
     520,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   528,   529,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,   249,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,    -1,   294,    -1,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,    -1,   308,   309,
     310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,   472,   473,    -1,   475,    -1,   477,   478,   479,
     480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   529,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    -1,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,    -1,   158,   159,
     160,   161,    -1,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,    -1,   249,
     250,   251,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,    -1,   289,
      -1,   291,   292,   293,   294,    -1,    -1,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,    -1,   308,   309,
     310,    -1,    -1,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,    -1,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,    -1,   425,    -1,   427,   428,    -1,
     430,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,    -1,   446,    -1,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,
     490,   491,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   503,   504,   505,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,   529,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    -1,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,    -1,   158,   159,
     160,   161,    -1,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,    -1,   249,
     250,   251,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,    -1,   289,
      -1,   291,   292,   293,   294,    -1,    -1,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,    -1,   308,   309,
     310,    -1,    -1,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,    -1,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,    -1,   425,    -1,   427,   428,    -1,
     430,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,    -1,   446,    -1,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,
     490,   491,    -1,     3,    -1,     5,     6,    -1,     8,     9,
      10,    11,    12,   503,   504,   505,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,   529,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,    -1,   308,   309,
     310,    -1,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,    -1,   475,   476,   477,   478,   479,
     480,    -1,    -1,   483,    -1,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,    -1,   508,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   519,
     520,    -1,    -1,    -1,     3,    -1,     5,     6,   528,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,    -1,   308,
     309,   310,    -1,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,    -1,   475,   476,   477,   478,
     479,   480,    -1,    -1,   483,    -1,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,    -1,   508,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     519,   520,    -1,    -1,    -1,     3,    -1,     5,     6,   528,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,   177,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,    -1,    -1,
     308,   309,   310,    -1,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,    -1,   475,   476,   477,
     478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   519,   520,    -1,    -1,    -1,     3,    -1,     5,     6,
     528,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    -1,    -1,    -1,    36,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,   459,   460,   461,   462,   463,   464,   465,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,   476,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   519,   520,    -1,    -1,    -1,     3,    -1,     5,
       6,   528,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      36,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
      -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,    -1,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,   428,    -1,   430,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,   440,    -1,    -1,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,    -1,   475,
     476,   477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   519,   520,    -1,    -1,    -1,     3,    -1,
       5,     6,   528,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,   459,   460,   461,   462,   463,   464,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,   476,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   519,   520,    -1,    -1,    -1,    -1,
      -1,   526,   527,   528,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,    -1,   308,
     309,   310,    -1,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,   427,   428,
      -1,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,    -1,   475,   476,   477,   478,
     479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     519,   520,   521,    -1,    -1,     3,    -1,     5,     6,   528,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,    -1,    -1,
     308,   309,   310,    -1,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,    -1,    -1,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,    -1,   475,   476,   477,
     478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   519,   520,    -1,    -1,    -1,     3,    -1,     5,     6,
     528,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,   459,   460,   461,   462,   463,   464,   465,    -1,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   519,   520,    -1,    -1,    -1,     3,    -1,     5,
       6,   528,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,   177,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
      -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,    -1,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,   428,    -1,   430,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,   440,    -1,    -1,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,    -1,   475,
     476,   477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   519,   520,    -1,    -1,    -1,     3,    -1,
       5,     6,   528,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,   441,    -1,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,   459,   460,   461,   462,   463,   464,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,   476,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   519,   520,    -1,    -1,    -1,     3,
      -1,     5,     6,   528,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,    -1,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
      -1,   475,   476,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   519,   520,    -1,    -1,    -1,
       3,    -1,     5,     6,   528,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,   427,   428,    -1,   430,   431,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,    -1,    -1,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,   459,   460,   461,   462,
     463,   464,   465,    -1,   467,   468,   469,   470,   471,   472,
     473,    -1,   475,   476,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   519,   520,    -1,    -1,
      -1,     3,    -1,     5,     6,   528,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,    -1,    -1,   308,   309,   310,    -1,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,   427,   428,    -1,   430,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,    -1,
      -1,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,    -1,   475,   476,   477,   478,   479,   480,    -1,
      -1,   483,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   519,   520,    -1,
      -1,    -1,     3,    -1,     5,     6,   528,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,    -1,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,    -1,    -1,   308,   309,   310,
      -1,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,    -1,   427,   428,    -1,   430,
     431,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
      -1,    -1,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,   465,    -1,   467,   468,   469,   470,
     471,   472,   473,    -1,   475,   476,   477,   478,   479,   480,
      -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   519,   520,
      -1,    -1,    -1,     3,    -1,     5,     6,   528,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,    -1,   308,   309,
     310,    -1,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,   428,    -1,
     430,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,    -1,   475,   476,   477,   478,   479,
     480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   519,
     520,    -1,    -1,    -1,     3,    -1,     5,     6,   528,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,    -1,   308,
     309,   310,    -1,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,   427,   428,
      -1,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,    -1,   475,   476,   477,   478,
     479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     519,   520,    -1,    -1,    -1,     3,    -1,     5,     6,   528,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,    -1,    -1,
     308,   309,   310,    -1,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,    -1,    -1,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,    -1,   475,   476,   477,
     478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   519,   520,    -1,    -1,    -1,     3,    -1,     5,     6,
     528,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,   459,   460,   461,   462,   463,   464,   465,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,   476,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   519,   520,    -1,    -1,    -1,     3,    -1,     5,
       6,   528,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
      -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,    -1,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,   428,    -1,   430,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,   440,    -1,    -1,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,    -1,   475,
     476,   477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   519,   520,    -1,    -1,    -1,     3,    -1,
       5,     6,   528,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,    -1,   460,   461,   462,   463,   464,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,   476,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   519,   520,    -1,    -1,    -1,     3,
      -1,     5,     6,   528,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,    -1,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
      -1,   475,   476,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   519,   520,    -1,    -1,    -1,
       3,    -1,     5,     6,   528,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,   427,   428,    -1,   430,   431,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,    -1,    -1,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,    -1,   460,   461,   462,
     463,   464,   465,    -1,   467,   468,   469,   470,   471,   472,
     473,    -1,   475,   476,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   519,   520,     3,    -1,
       5,     6,    -1,     8,     9,   528,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,    -1,   460,   461,   462,   463,   464,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,   476,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   519,   520,     3,    -1,     5,     6,
      -1,     8,     9,   528,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,    -1,   460,   461,   462,   463,   464,   465,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,   476,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,     5,     6,    -1,
       8,     9,    -1,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,   528,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,    -1,    -1,
     308,   309,   310,    -1,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,    -1,    -1,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,    -1,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,    -1,   475,   476,   477,
     478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,     5,     6,    -1,     8,
       9,    -1,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
     528,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,    -1,   308,
     309,   310,    -1,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,   427,   428,
      -1,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
      -1,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,    -1,   475,   476,   477,   478,
     479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   528,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,    -1,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,   307,   308,   309,
     310,    -1,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,    -1,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,    -1,   475,   476,   477,   478,   479,
     480,    -1,    -1,   483,    -1,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,    -1,   508,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   528,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,    -1,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,    -1,   307,   308,   309,   310,
      -1,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,    -1,   427,   428,    -1,   430,
     431,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
      -1,    -1,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,    -1,   460,
     461,   462,   463,   464,   465,    -1,   467,   468,   469,   470,
     471,   472,   473,    -1,   475,   476,   477,   478,   479,   480,
      -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   528,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,    -1,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,    -1,    -1,   308,   309,   310,    -1,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,   427,   428,    -1,   430,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,    -1,
      -1,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,    -1,    -1,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,    -1,   475,   476,   477,   478,   479,   480,    -1,
      -1,   483,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   528,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,    -1,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,   427,   428,    -1,   430,   431,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,    -1,    -1,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,    -1,   460,   461,   462,
     463,   464,   465,    -1,   467,   468,   469,   470,   471,   472,
     473,    -1,   475,   476,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   528,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,    -1,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,    -1,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,    -1,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
      -1,   475,   476,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   528,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
      -1,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,    -1,   460,   461,   462,   463,   464,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,   476,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,     5,
       6,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   528,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,    -1,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
     306,    -1,   308,   309,   310,    -1,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,    -1,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,   428,    -1,   430,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,   440,    -1,    -1,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,    -1,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,   472,   473,    -1,   475,
     476,   477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,   519,   520,   521,    -1,    -1,    -1,    -1,
      -1,    -1,   528,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    33,    34,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,    -1,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,   476,
     477,   478,   479,   480,    -1,    -1,   483,    -1,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,    -1,
      -1,   508,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   528,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,    -1,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,    -1,    -1,
     308,   309,   310,    -1,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,    -1,    -1,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,   472,   473,    -1,   475,   476,   477,
     478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     528,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,   107,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,    -1,   294,    -1,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,   307,   308,
     309,   310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,    -1,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,   427,   428,
     429,   430,    -1,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,   472,   473,    -1,   475,    -1,   477,   478,
     479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   528,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,    -1,   294,    -1,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,    -1,   308,   309,
     310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,   428,   429,
     430,    -1,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,   472,   473,    -1,   475,    -1,   477,   478,   479,
     480,    -1,    -1,   483,    -1,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,    -1,   508,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   528,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,    -1,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,    -1,   294,    -1,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,    -1,    -1,   308,   309,   310,
      -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,    -1,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,    -1,   427,   428,    -1,   430,
      -1,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
      -1,    -1,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,   473,    -1,   475,    -1,   477,   478,   479,   480,
      -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   528,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,    -1,   294,    -1,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,    -1,    -1,   308,   309,   310,    -1,
      -1,   313,   314,   315,    -1,   317,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,    -1,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,    -1,
      -1,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,    -1,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
     472,   473,    -1,   475,    -1,   477,   478,   479,   480,    -1,
      -1,   483,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   528,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
      -1,    -1,   225,    -1,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
      -1,   294,    -1,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,
     313,   314,   315,    -1,   317,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,    -1,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,   427,   428,    -1,   430,    -1,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,    -1,    -1,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,   472,
     473,    -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   528,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,    -1,
     294,    -1,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,
     314,   315,    -1,   317,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,   472,   473,
      -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   528,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,
     225,    -1,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,    -1,   294,
      -1,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,    -1,   317,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,    -1,   430,    -1,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,    -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,   528,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    -1,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    -1,    -1,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,    -1,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
      -1,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,    -1,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,    -1,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,    -1,   476,   477,   478,   479,   480,   481,    -1,
     483,    -1,    -1,    -1,    -1,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
      -1,   504,   505,   506,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   516,   517,   518,   519,   520,   521,   522,
     523,   524,     3,    -1,     5,     6,    -1,    -1,    -1,    10,
      11,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,    -1,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,    -1,   336,    -1,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
      -1,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,    -1,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   503,   504,   505,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   516,   517,   518,   519,   520,
     521,   522,   523,   524,     3,    -1,     5,     6,    -1,    -1,
      -1,    10,    11,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,    -1,   158,
     159,   160,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,    -1,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,    -1,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,    -1,   336,    -1,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,    -1,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,    -1,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   503,   504,   505,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   516,   517,   518,
     519,   520,   521,   522,   523,   524,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,    -1,   294,    -1,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,    -1,
     317,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,    -1,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,    -1,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,    -1,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   516,
     517,   518,   519,   520,   521,   522,   523,   524,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,
     225,    -1,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,    -1,   294,
      -1,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,    -1,   317,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,    -1,   430,    -1,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,    -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   516,   517,   518,   519,   520,   521,   522,   523,   524,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
      -1,    -1,   225,    -1,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
      -1,   294,    -1,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,
     313,   314,   315,    -1,   317,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,    -1,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,   427,   428,    -1,   430,    -1,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,    -1,    -1,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,   472,
     473,    -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   516,   517,   518,   519,   520,   521,   522,
     523,   524,     3,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,    -1,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,    -1,   294,    -1,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,    -1,    -1,   308,   309,   310,
      -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,    -1,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,    -1,   427,   428,    -1,   430,
      -1,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
      -1,    -1,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,   473,    -1,   475,    -1,   477,   478,   479,   480,
      -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   516,   517,   518,   519,   520,
     521,   522,   523,   524,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,    -1,   294,    -1,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,    -1,   308,
     309,   310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,    -1,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,   427,   428,
      -1,   430,    -1,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,   472,   473,    -1,   475,    -1,   477,   478,
     479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   516,   517,   518,
     519,   520,   521,   522,   523,   524,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,    -1,   294,    -1,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,    -1,
     317,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,    -1,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,    -1,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,    -1,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   516,
     517,   518,   519,   520,   521,   522,   523,   524,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,
     225,    -1,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,    -1,   294,
      -1,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,    -1,   317,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,    -1,   430,    -1,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,    -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   516,   517,   518,   519,   520,   521,   522,   523,   524,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   521,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,    -1,   294,    -1,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,    -1,
     317,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,    -1,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,    -1,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,    -1,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   521,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,    -1,
     294,    -1,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,
     314,   315,    -1,   317,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,   472,   473,
      -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   521,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,   239,   240,
     241,   242,   243,   244,    -1,    -1,   247,    -1,   249,   250,
     251,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,    -1,
     291,   292,   293,   294,    -1,    -1,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,    -1,    -1,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,    -1,   338,   339,   340,
      -1,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
      -1,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,    -1,   425,    -1,   427,   428,    -1,   430,
     431,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
      -1,    -1,   443,   444,    -1,   446,    -1,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,   473,   474,   475,   476,   477,   478,   479,   480,
      -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   503,   504,   505,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
     521,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    -1,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,   160,   161,    -1,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,    -1,    -1,    -1,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,   223,   224,   225,   226,   227,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,    -1,
     249,   250,   251,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,    -1,
     289,    -1,   291,   292,   293,   294,    -1,    -1,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,    -1,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,    -1,   336,    -1,   338,
     339,   340,    -1,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,    -1,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,    -1,   425,    -1,   427,   428,
      -1,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,    -1,   446,    -1,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,   476,   477,   478,
     479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,
     489,   490,   491,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   503,   504,   505,     3,    -1,     5,
       6,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,   521,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,    -1,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
     306,    -1,   308,   309,   310,    -1,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,    -1,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,   428,    -1,   430,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,   440,    -1,    -1,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,    -1,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,   472,   473,    -1,   475,
     476,   477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
       3,    -1,     5,     6,    -1,    -1,    -1,    -1,    11,    -1,
      -1,    -1,    -1,   519,   520,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,    -1,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,   306,    -1,   308,   309,   310,    -1,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,   427,   428,    -1,   430,   431,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,    -1,    -1,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,   472,
     473,    -1,   475,   476,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,     3,    -1,     5,     6,    -1,    -1,    -1,
      -1,    11,    -1,    -1,    -1,    -1,   519,   520,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,    -1,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,   306,    -1,   308,   309,
     310,    -1,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,   428,    -1,
     430,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,   472,   473,    -1,   475,   476,   477,   478,   479,
     480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,     3,    -1,    -1,     6,
      -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,   519,
     520,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,    -1,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,   306,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,   476,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    11,    -1,    -1,
      -1,    -1,   519,   520,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,   177,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,    -1,
     294,    -1,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,
     314,   315,    -1,   317,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,   472,   473,
      -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,
      11,    -1,    -1,    -1,    -1,   519,   520,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,    -1,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,    -1,    -1,   308,   309,   310,    -1,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,   427,   428,    -1,   430,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,    -1,
      -1,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,    -1,    -1,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,    -1,   475,   476,   477,   478,   479,   480,    -1,
      -1,   483,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,     3,    -1,     5,     6,    -1,     8,
       9,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,    -1,   308,
     309,   310,    -1,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,   427,   428,
      -1,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,   472,   473,    -1,   475,   476,   477,   478,
     479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
     106,   107,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,    -1,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
      -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,    -1,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,   428,    -1,   430,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,   440,    -1,    -1,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,    -1,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,   472,   473,    -1,   475,
     476,   477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,    -1,    -1,   106,   107,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,    -1,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,   427,   428,    -1,   430,   431,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,    -1,    -1,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,   472,
     473,    -1,   475,   476,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,    -1,    -1,   106,   107,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,    -1,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,    -1,   308,   309,
     310,    -1,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,   428,    -1,
     430,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,    -1,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,    -1,   475,   476,   477,   478,   479,
     480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,   106,
     107,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,    -1,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,   476,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,     3,
      -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,    -1,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,   306,    -1,   308,   309,   310,    -1,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,    -1,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,   472,   473,
      -1,   475,   476,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,   106,   107,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,    -1,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,    -1,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,    -1,    -1,   308,   309,   310,
      -1,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,    -1,   427,   428,    -1,   430,
     431,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
      -1,    -1,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,   473,    -1,   475,   476,   477,   478,   479,   480,
      -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,   106,   107,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,    -1,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,    -1,    -1,
     308,   309,   310,    -1,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,    -1,    -1,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,   472,   473,    -1,   475,   476,   477,
     478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,   106,   107,    -1,    -1,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
      -1,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,   476,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,   106,   107,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,    -1,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,    -1,    -1,   308,   309,   310,    -1,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,   427,   428,    -1,   430,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,    -1,
      -1,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,    -1,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
     472,   473,    -1,   475,   476,   477,   478,   479,   480,    -1,
      -1,   483,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,    -1,    -1,   106,   107,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,    -1,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,    -1,   308,
     309,   310,    -1,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,   427,   428,
      -1,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,   472,   473,    -1,   475,   476,   477,   478,
     479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    33,    34,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,    -1,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
      -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,    -1,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,   428,    -1,   430,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,   440,    -1,    -1,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,    -1,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,   472,   473,    -1,   475,
     476,   477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
       3,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,    -1,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,   427,   428,    -1,   430,   431,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,    -1,    -1,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,   472,
     473,    -1,   475,   476,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,     3,    -1,    -1,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,    -1,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,    -1,   308,   309,
     310,    -1,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,   428,    -1,
     430,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,   472,   473,    -1,   475,   476,   477,   478,   479,
     480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,    -1,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,   476,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,    -1,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,    -1,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,   472,   473,
      -1,   475,   476,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,    -1,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,    -1,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,    -1,    -1,   308,   309,   310,
      -1,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,    -1,   427,   428,    -1,   430,
     431,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
      -1,    -1,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,   473,    -1,   475,   476,   477,   478,   479,   480,
      -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,    -1,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,    -1,    -1,
     308,   309,   310,    -1,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,    -1,    -1,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,   472,   473,    -1,   475,   476,   477,
     478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
      -1,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,   476,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,    -1,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,    -1,    -1,   308,   309,   310,    -1,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,   427,   428,    -1,   430,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,    -1,
      -1,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,    -1,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
     472,   473,    -1,   475,   476,   477,   478,   479,   480,    -1,
      -1,   483,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    -1,
      -1,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,    -1,   294,    -1,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,    -1,   308,
     309,   310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,    -1,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,   427,   428,
      -1,   430,    -1,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,   472,   473,    -1,   475,    -1,   477,   478,
     479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,   248,    -1,   250,   251,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,    -1,   294,    -1,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
      -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,   315,
      -1,   317,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,    -1,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,    -1,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,    -1,   438,   439,   440,    -1,    -1,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,   472,   473,    -1,   475,
      -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    99,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
     183,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
      -1,    -1,   225,    -1,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
      -1,   294,    -1,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,
     313,   314,   315,    -1,   317,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,    -1,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,   427,   428,    -1,   430,    -1,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,    -1,    -1,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,   472,
     473,    -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,   183,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,    -1,   294,    -1,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,    -1,   308,   309,
     310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,   472,   473,    -1,   475,    -1,   477,   478,   479,
     480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,    -1,   294,    -1,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,    -1,
     317,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,    -1,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,    -1,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,    -1,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,    -1,
     294,    -1,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,
     314,   315,    -1,   317,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,   472,   473,
      -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,    -1,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,    -1,   294,    -1,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,    -1,   307,   308,   309,   310,
      -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,    -1,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,    -1,   427,   428,   429,   430,
      -1,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
      -1,    -1,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,   473,    -1,   475,    -1,   477,   478,   479,   480,
      -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,    -1,   294,    -1,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,    -1,   307,
     308,   309,   310,    -1,    -1,   313,   314,   315,    -1,   317,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,    -1,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,   429,   430,    -1,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,    -1,    -1,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,   472,   473,    -1,   475,    -1,   477,
     478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,   173,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,
     225,    -1,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,    -1,   294,
      -1,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,    -1,   317,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,   429,   430,    -1,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,    -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,    -1,   294,    -1,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,    -1,    -1,   308,   309,   310,    -1,
      -1,   313,   314,   315,    -1,   317,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,    -1,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,    -1,
      -1,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,    -1,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
     472,   473,    -1,   475,    -1,   477,   478,   479,   480,    -1,
      -1,   483,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,    -1,   294,    -1,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,   307,   308,
     309,   310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,    -1,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,   427,   428,
      -1,   430,    -1,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,   472,   473,    -1,   475,    -1,   477,   478,
     479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,    -1,   294,    -1,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
      -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,   315,
      -1,   317,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,    -1,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,    -1,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,    -1,   438,   439,   440,    -1,    -1,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,    -1,    -1,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,    -1,   475,
      -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
      -1,    -1,   225,    -1,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
      -1,   294,    -1,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,
     313,   314,   315,    -1,   317,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,    -1,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,   427,   428,    -1,   430,    -1,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,    -1,    -1,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,    -1,   460,   461,   462,
     463,   464,   465,    -1,   467,   468,   469,   470,   471,   472,
     473,    -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,    -1,   294,    -1,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,    -1,   308,   309,
     310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,   472,   473,    -1,   475,    -1,   477,   478,   479,
     480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,    -1,   294,    -1,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,    -1,
     317,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,    -1,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,    -1,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,    -1,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,    -1,
     294,    -1,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,
     314,   315,    -1,   317,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,   472,   473,
      -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,    -1,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,    -1,   294,    -1,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,    -1,    -1,   308,   309,   310,
      -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,    -1,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,    -1,   427,   428,    -1,   430,
      -1,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
      -1,    -1,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,   473,    -1,   475,    -1,   477,   478,   479,   480,
      -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,    -1,   294,    -1,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,    -1,   307,
     308,   309,   310,    -1,    -1,   313,   314,   315,    -1,   317,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,    -1,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,    -1,    -1,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,   472,   473,    -1,   475,    -1,   477,
     478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,
     225,    -1,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,    -1,   294,
      -1,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,    -1,   317,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,    -1,   430,    -1,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,    -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,    -1,   294,    -1,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,    -1,    -1,   308,   309,   310,    -1,
      -1,   313,   314,   315,    -1,   317,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,    -1,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,    -1,
      -1,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,    -1,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
     472,   473,    -1,   475,    -1,   477,   478,   479,   480,    -1,
      -1,   483,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,    -1,   294,    -1,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,    -1,   308,
     309,   310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,    -1,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,   427,   428,
      -1,   430,    -1,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,   472,   473,    -1,   475,    -1,   477,   478,
     479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,    -1,   294,    -1,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
      -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,   315,
      -1,   317,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,    -1,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,    -1,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,    -1,   438,   439,   440,    -1,    -1,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,    -1,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,   472,   473,    -1,   475,
      -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
      -1,    -1,   225,    -1,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
      -1,   294,    -1,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,
     313,   314,   315,    -1,   317,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,    -1,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,   427,   428,    -1,   430,    -1,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,    -1,    -1,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,   472,
     473,    -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,    -1,   294,    -1,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,   307,   308,   309,
     310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,   472,   473,    -1,   475,    -1,   477,   478,   479,
     480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,    -1,   294,    -1,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,    -1,
     317,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,    -1,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,    -1,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,    -1,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,    -1,
     294,    -1,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,
     314,   315,    -1,   317,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,   472,   473,
      -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,    -1,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,    -1,   294,    -1,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,    -1,    -1,   308,   309,   310,
      -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,    -1,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,    -1,   427,   428,   429,   430,
      -1,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
      -1,    -1,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,   473,    -1,   475,    -1,   477,   478,   479,   480,
      -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,     3,    -1,    -1,     6,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,    -1,   294,    -1,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,    -1,    -1,
     308,   309,   310,    -1,    -1,   313,   314,   315,    -1,   317,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,    -1,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,    -1,    -1,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,   472,   473,    -1,   475,    -1,   477,
     478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,
     225,    -1,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,    -1,   294,
      -1,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,    -1,   317,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,    -1,   430,    -1,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,    -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,    -1,   294,    -1,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,    -1,    -1,   308,   309,   310,    -1,
      -1,   313,   314,   315,    -1,   317,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,    -1,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,    -1,
      -1,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,    -1,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
     472,   473,    -1,   475,    -1,   477,   478,   479,   480,    -1,
      -1,   483,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    38,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,    -1,   294,    -1,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,    -1,   308,
     309,   310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,    -1,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,   427,   428,
      -1,   430,    -1,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,   472,   473,    -1,   475,    -1,   477,   478,
     479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,    -1,   294,    -1,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
      -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,   315,
      -1,   317,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,    -1,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,    -1,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,    -1,   438,   439,   440,    -1,    -1,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,    -1,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,   472,   473,    -1,   475,
      -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
      -1,    -1,   225,    -1,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
      -1,   294,    -1,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,
     313,   314,   315,    -1,   317,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,    -1,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,   427,   428,    -1,   430,    -1,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,    -1,    -1,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,   472,
     473,    -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,    -1,   294,    -1,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,    -1,   308,   309,
     310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,   472,   473,    -1,   475,    -1,   477,   478,   479,
     480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,    -1,   294,    -1,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,    -1,
     317,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,    -1,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,    -1,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,    -1,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,    -1,
     294,    -1,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,
     314,   315,    -1,   317,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,   472,   473,
      -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,    -1,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,    -1,   294,    -1,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,    -1,    -1,   308,   309,   310,
      -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,    -1,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,    -1,   427,   428,    -1,   430,
      -1,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
      -1,    -1,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,   473,    -1,   475,    -1,   477,   478,   479,   480,
      -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,    -1,   294,    -1,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,    -1,    -1,
     308,   309,   310,    -1,    -1,   313,   314,   315,    -1,   317,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,    -1,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,    -1,    -1,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,   472,   473,    -1,   475,    -1,   477,
     478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,
     225,    -1,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,    -1,   294,
      -1,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,    -1,   317,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,    -1,   430,    -1,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,    -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,    -1,   294,    -1,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,    -1,    -1,   308,   309,   310,    -1,
      -1,   313,   314,   315,    -1,   317,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,    -1,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,    -1,
      -1,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,    -1,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
     472,   473,    -1,   475,    -1,   477,   478,   479,   480,    -1,
      -1,   483,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,    -1,   294,    -1,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,    -1,   308,
     309,   310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,    -1,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,   427,   428,
      -1,   430,    -1,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,   472,   473,    -1,   475,    -1,   477,   478,
     479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,    -1,   294,    -1,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
      -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,   315,
      -1,   317,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,    -1,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,    -1,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,    -1,   438,   439,   440,    -1,    -1,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,    -1,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,   472,   473,    -1,   475,
      -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
      -1,    -1,   225,    -1,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
      -1,   294,    -1,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,
     313,   314,   315,    -1,   317,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,    -1,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,   427,   428,    -1,   430,    -1,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,    -1,    -1,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,   472,
     473,    -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,    -1,   294,    -1,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,    -1,   308,   309,
     310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,   472,   473,    -1,   475,    -1,   477,   478,   479,
     480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,    -1,   294,    -1,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,    -1,
     317,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,    -1,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,    -1,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,    -1,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,    -1,
     294,    -1,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,
     314,   315,    -1,   317,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,   472,   473,
      -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,    -1,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,    -1,   294,    -1,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,    -1,    -1,   308,   309,   310,
      -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,    -1,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,    -1,   427,   428,    -1,   430,
      -1,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
      -1,    -1,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,   473,    -1,   475,    -1,   477,   478,   479,   480,
      -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,    -1,   294,    -1,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,    -1,    -1,
     308,   309,   310,    -1,    -1,   313,   314,   315,    -1,   317,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,    -1,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,    -1,    -1,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,   472,   473,    -1,   475,    -1,   477,
     478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,
     225,    -1,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,    -1,   294,
      -1,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,    -1,   317,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,    -1,   430,    -1,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,    -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,    -1,   294,    -1,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,    -1,    -1,   308,   309,   310,    -1,
      -1,   313,   314,   315,    -1,   317,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,    -1,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,    -1,
      -1,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,    -1,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
     472,   473,    -1,   475,    -1,   477,   478,   479,   480,    -1,
      -1,   483,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,    -1,   294,    -1,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,    -1,   308,
     309,   310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,    -1,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,   427,   428,
      -1,   430,    -1,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,   472,   473,    -1,   475,    -1,   477,   478,
     479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,    -1,   294,    -1,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
      -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,   315,
      -1,   317,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,    -1,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,    -1,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,    -1,   438,   439,   440,    -1,    -1,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,    -1,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,   472,   473,    -1,   475,
      -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
      -1,    -1,   225,    -1,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
      -1,   294,    -1,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,
     313,   314,   315,    -1,   317,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,    -1,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,   427,   428,    -1,   430,    -1,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,    -1,    -1,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,   472,
     473,    -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,    -1,   294,    -1,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,    -1,   308,   309,
     310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,   472,   473,    -1,   475,    -1,   477,   478,   479,
     480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,    -1,   294,    -1,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,    -1,
     317,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,    -1,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,    -1,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,    -1,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,    -1,
     294,    -1,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,
     314,   315,    -1,   317,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,   472,   473,
      -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,    -1,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,    -1,   294,    -1,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,    -1,    -1,   308,   309,   310,
      -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,    -1,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,    -1,   427,   428,    -1,   430,
      -1,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
      -1,    -1,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,   473,    -1,   475,    -1,   477,   478,   479,   480,
      -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,    -1,   294,    -1,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,    -1,    -1,
     308,   309,   310,    -1,    -1,   313,   314,   315,    -1,   317,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,    -1,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,    -1,    -1,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,   472,   473,    -1,   475,    -1,   477,
     478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,
     225,    -1,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,    -1,   294,
      -1,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,    -1,   317,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,    -1,   430,    -1,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,    -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,    -1,   294,    -1,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,    -1,    -1,   308,   309,   310,    -1,
      -1,   313,   314,   315,    -1,   317,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,    -1,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,    -1,
      -1,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,    -1,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
     472,   473,    -1,   475,    -1,   477,   478,   479,   480,    -1,
      -1,   483,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,    -1,   294,    -1,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,    -1,   308,
     309,   310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,    -1,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,   427,   428,
      -1,   430,    -1,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,   472,   473,    -1,   475,    -1,   477,   478,
     479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,    -1,   294,    -1,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
      -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,   315,
      -1,   317,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,    -1,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,    -1,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,    -1,   438,   439,   440,    -1,    -1,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,    -1,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,   472,   473,    -1,   475,
      -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
      -1,    -1,   225,    -1,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
      -1,   294,    -1,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,
     313,   314,   315,    -1,   317,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,    -1,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,   427,   428,    -1,   430,    -1,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,    -1,    -1,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,   472,
     473,    -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,    -1,   294,    -1,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,    -1,   308,   309,
     310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,   472,   473,    -1,   475,    -1,   477,   478,   479,
     480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,    -1,   294,    -1,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,    -1,
     317,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,    -1,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,    -1,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,    -1,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,    -1,
     294,    -1,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,
     314,   315,    -1,   317,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,   472,   473,
      -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,    -1,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,    -1,   294,    -1,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,    -1,    -1,   308,   309,   310,
      -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,    -1,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,    -1,   427,   428,    -1,   430,
      -1,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
      -1,    -1,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,   473,    -1,   475,    -1,   477,   478,   479,   480,
      -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,    -1,   294,    -1,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,    -1,    -1,
     308,   309,   310,    -1,    -1,   313,   314,   315,    -1,   317,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,    -1,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,    -1,    -1,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,   472,   473,    -1,   475,    -1,   477,
     478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,
     225,    -1,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,    -1,   294,
      -1,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,    -1,   317,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,    -1,   430,    -1,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,    -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,    -1,   294,    -1,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,    -1,    -1,   308,   309,   310,    -1,
      -1,   313,   314,   315,    -1,   317,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,    -1,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,    -1,
      -1,   443,   444,   445,   446,   447,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,    -1,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
     472,   473,    -1,   475,    -1,   477,   478,   479,   480,    -1,
      -1,   483,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,    -1,   294,    -1,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,    -1,   308,
     309,   310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,    -1,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,   427,   428,
      -1,   430,    -1,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,   445,   446,   447,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,   472,   473,    -1,   475,    -1,   477,   478,
     479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,    -1,   294,    -1,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
      -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,   315,
      -1,   317,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,    -1,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,    -1,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,    -1,   438,   439,   440,    -1,    -1,   443,   444,   445,
     446,   447,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,    -1,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,   472,   473,    -1,   475,
      -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
      -1,    -1,   225,    -1,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
      -1,   294,    -1,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,
     313,   314,   315,    -1,   317,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,    -1,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,   427,   428,    -1,   430,    -1,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,    -1,    -1,
     443,   444,   445,   446,   447,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,   472,
     473,    -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,    -1,   294,    -1,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,    -1,   308,   309,
     310,    -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,   445,   446,   447,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,   472,   473,    -1,   475,    -1,   477,   478,   479,
     480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,    -1,   294,    -1,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,   315,    -1,
     317,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,    -1,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,   428,    -1,   430,    -1,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,   473,    -1,   475,    -1,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,    -1,
     294,    -1,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,
     314,   315,    -1,   317,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,   472,   473,
      -1,   475,    -1,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,    -1,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,    -1,   294,    -1,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,    -1,    -1,   308,   309,   310,
      -1,    -1,   313,   314,   315,    -1,   317,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
      -1,   332,   333,   334,   335,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,    -1,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,    -1,   427,   428,    -1,   430,
      -1,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
      -1,    -1,   443,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,   473,    -1,   475,    -1,   477,   478,   479,   480,
      -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,    -1,   294,    -1,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,    -1,    -1,
     308,   309,   310,    -1,    -1,   313,   314,   315,    -1,   317,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,    -1,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,    -1,    -1,   443,   444,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,   472,   473,    -1,   475,    -1,   477,
     478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,
     225,    -1,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,    -1,   294,
      -1,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
     315,    -1,   317,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,    -1,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,   428,    -1,   430,    -1,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,   472,   473,    -1,
     475,    -1,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,    -1,   158,   159,   160,   161,
      -1,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,    -1,   249,   250,   251,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,    -1,   289,    -1,   291,
     292,   293,   294,    -1,    -1,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,    -1,    -1,   308,   309,   310,    -1,
      -1,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,    -1,   338,   339,   340,    -1,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,    -1,   425,    -1,   427,   428,    -1,   430,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,    -1,
      -1,   443,   444,    -1,   446,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,    -1,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,   476,   477,   478,   479,   480,    -1,
      -1,   483,    -1,    -1,   486,   487,   488,   489,   490,   491,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   503,   504,   505,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    -1,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,   160,   161,    -1,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,    -1,    -1,    -1,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,   211,    -1,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
     223,   224,   225,   226,   227,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,    -1,   249,   250,   251,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,    -1,   291,   292,
     293,   294,   295,    -1,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,
     313,   314,    -1,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,    -1,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,    -1,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,    -1,   425,    -1,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,    -1,    -1,
     443,   444,    -1,   446,    -1,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
     473,    -1,   475,   476,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     503,   504,   505,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    -1,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,    -1,   158,   159,   160,   161,    -1,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,    -1,    -1,    -1,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,    -1,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,   223,
     224,   225,   226,   227,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,    -1,   249,   250,   251,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,    -1,   291,   292,   293,
     294,    -1,    -1,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,
     314,    -1,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,    -1,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
      -1,   425,    -1,   427,   428,    -1,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,    -1,   443,
     444,    -1,   446,    -1,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,    -1,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,   468,   469,   470,   471,    -1,   473,
      -1,   475,   476,   477,   478,   479,   480,    -1,    -1,   483,
      -1,    -1,   486,   487,   488,   489,   490,   491,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   503,
     504,   505,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    -1,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    -1,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,    -1,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
      -1,    -1,    -1,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,   211,    -1,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,   223,   224,
     225,   226,   227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,    -1,   249,   250,   251,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,    -1,   291,   292,   293,   294,
      -1,    -1,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,    -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,
      -1,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
      -1,   336,    -1,   338,   339,   340,    -1,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,    -1,
     425,    -1,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,    -1,   438,   439,   440,    -1,    -1,   443,   444,
      -1,   446,    -1,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,   473,    -1,
     475,   476,   477,   478,   479,   480,    -1,    -1,   483,    -1,
      -1,   486,   487,   488,   489,   490,   491,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   503,   504,
     505,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,    -1,    -1,   164,    -1,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,    -1,
      -1,    -1,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,    -1,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,    -1,   249,   250,   251,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,    -1,   289,    -1,   291,   292,   293,   294,    -1,
      -1,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
      -1,    -1,   308,   309,   310,    -1,    -1,   313,   314,    -1,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,    -1,   332,   333,   334,    -1,
     336,    -1,   338,   339,   340,    -1,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,    -1,   425,
      -1,   427,   428,    -1,   430,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,   440,    -1,    -1,   443,   444,    -1,
     446,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,    -1,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,   468,   469,   470,   471,    -1,   473,    -1,   475,
     476,   477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,
     486,   487,   488,   489,   490,   491,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   503,   504,   505,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      -1,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,   160,   161,    -1,    -1,   164,    -1,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,    -1,    -1,
      -1,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,    -1,   210,   211,    -1,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,   223,   224,   225,   226,
     227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   238,   239,   240,   241,   242,   243,   244,    -1,    -1,
     247,    -1,   249,   250,   251,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,    -1,   289,    -1,   291,   292,   293,   294,    -1,    -1,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,    -1,
      -1,   308,   309,   310,    -1,    -1,   313,   314,    -1,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,   333,   334,    -1,   336,
      -1,   338,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,    -1,   425,    -1,
     427,   428,    -1,   430,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,   440,    -1,    -1,   443,   444,    -1,   446,
      -1,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,    -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,   473,    -1,   475,   476,
     477,   478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,
     487,   488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   503,   504,   505,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    -1,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,    -1,
     158,   159,   160,   161,    -1,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,    -1,    -1,    -1,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,    -1,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,   223,   224,   225,   226,   227,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
      -1,   249,   250,   251,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
      -1,   289,    -1,   291,   292,   293,   294,    -1,    -1,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,    -1,    -1,
     308,   309,   310,    -1,    -1,   313,   314,    -1,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,    -1,   336,    -1,
     338,   339,   340,    -1,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,    -1,   425,    -1,   427,
     428,    -1,   430,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,   440,    -1,    -1,   443,   444,    -1,   446,    -1,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,    -1,   473,    -1,   475,   476,   477,
     478,   479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,
     488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   503,   504,   505,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    -1,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,   160,   161,    -1,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,    -1,    -1,    -1,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
      -1,   210,   211,    -1,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,   223,   224,   225,   226,   227,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,    -1,
     249,   250,   251,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,    -1,
     289,    -1,   291,   292,   293,   294,    -1,    -1,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,    -1,    -1,   308,
     309,   310,    -1,    -1,   313,   314,    -1,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,    -1,   332,   333,   334,    -1,   336,    -1,   338,
     339,   340,    -1,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,    -1,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,    -1,   425,    -1,   427,   428,
      -1,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,   440,    -1,    -1,   443,   444,    -1,   446,    -1,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,    -1,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,   473,    -1,   475,   476,   477,   478,
     479,   480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,
     489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   503,   504,   505,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    -1,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,    -1,   158,   159,
     160,   161,    -1,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,    -1,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,    -1,   249,
     250,   251,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,    -1,   289,
      -1,   291,   292,   293,   294,    -1,    -1,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,    -1,    -1,   308,   309,
     310,    -1,    -1,   313,   314,    -1,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,    -1,   338,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,    -1,   425,    -1,   427,   428,    -1,
     430,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,    -1,   443,   444,    -1,   446,    -1,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,    -1,   473,    -1,   475,   476,   477,   478,   479,
     480,    -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,
     490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   503,   504,   505,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,    -1,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,   239,   240,
     241,   242,   243,   244,    -1,    -1,   247,    -1,   249,   250,
     251,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,    -1,
     291,   292,   293,   294,    -1,    -1,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,    -1,    -1,   308,   309,   310,
      -1,    -1,   313,   314,    -1,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,    -1,   338,   339,   340,
      -1,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
      -1,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,    -1,   425,    -1,   427,   428,    -1,   430,
     431,   432,   433,   434,   435,   436,    -1,   438,   439,   440,
      -1,    -1,   443,   444,    -1,   446,    -1,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,   473,    -1,   475,   476,   477,   478,   479,   480,
      -1,    -1,   483,    -1,    -1,   486,   487,   488,   489,   490,
     491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   503,   504,   505,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,    -1,   158,   159,   160,   161,
      -1,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
      -1,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,    -1,   249,   250,   251,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,    -1,   289,    -1,   291,
     292,   293,   294,    -1,    -1,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,    -1,    -1,   308,   309,   310,    -1,
      -1,   313,   314,    -1,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,    -1,   338,   339,   340,    -1,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,    -1,   399,   400,    -1,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,    -1,   425,    -1,   427,   428,    -1,   430,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,   440,    -1,
      -1,   443,   444,    -1,   446,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,    -1,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,   473,    -1,   475,   476,   477,   478,   479,   480,    -1,
      -1,   483,    -1,    -1,   486,   487,   488,   489,   490,   491,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   503,   504,   505,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      -1,    54,    -1,    -1,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    -1,    71,    -1,
      73,    74,    75,    76,    -1,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,    -1,    -1,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,   160,   161,    -1,
      -1,   164,    -1,   166,   167,   168,    -1,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,    -1,    -1,    -1,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,    -1,   210,   211,    -1,
     213,   214,   215,   216,    -1,    -1,    -1,    -1,    -1,   222,
     223,   224,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,    -1,   249,   250,   251,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,    -1,   291,   292,
     293,   294,    -1,    -1,   297,    -1,   299,   300,   301,    -1,
     303,   304,   305,    -1,    -1,   308,   309,   310,    -1,    -1,
     313,   314,    -1,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,    -1,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,    -1,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,    -1,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,    -1,   425,    -1,   427,   428,    -1,   430,   431,   432,
     433,   434,   435,   436,    -1,   438,    -1,    -1,    -1,    -1,
     443,   444,    -1,   446,    -1,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,    -1,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,    -1,   475,   476,   477,   478,   479,   480,    -1,    -1,
     483,    -1,    -1,   486,   487,   488,   489,   490,   491,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     503,   504,   505
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    20,    31,    33,    34,    51,    61,    73,    75,    76,
      82,    84,    97,    99,   116,   119,   134,   136,   140,   147,
     156,   158,   165,   183,   200,   253,   254,   259,   273,   292,
     339,   354,   360,   361,   363,   368,   374,   377,   384,   391,
     392,   399,   403,   413,   429,   449,   461,   467,   472,   485,
     508,   511,   512,   513,   514,   515,   528,   537,   538,   539,
     540,   541,   542,   548,   549,   551,   552,   553,   554,   556,
     560,   572,   577,   578,   581,   582,   583,   602,   605,   606,
     621,   668,   671,   672,   675,   678,   679,   680,   688,   695,
     697,   698,   701,   704,   705,   709,   718,   722,   723,   724,
     727,   729,   730,   731,   732,   740,   742,   762,   766,   768,
     769,   779,   781,   788,   789,   792,   793,   794,   795,   796,
     805,   807,   809,   812,   816,   817,   827,   828,   831,   836,
     850,   882,   885,   886,   887,   892,   895,   897,   899,   901,
     902,   905,   906,   909,   911,   912,   916,   917,   918,   921,
     922,   923,   924,   925,   932,   934,   935,   936,   937,   943,
     945,   946,   952,   953,   954,   957,   958,   959,   960,   962,
     963,   965,   966,   968,   969,   971,   983,   985,   988,   990,
     991,  1000,  1002,  1007,  1012,  1020,  1024,  1025,  1026,  1027,
    1028,  1029,  1035,  1071,   443,   488,   938,    28,    79,    96,
     114,   120,   138,   151,   160,   173,   179,   186,   205,   243,
     265,   308,   334,   344,   345,   348,   376,   379,   383,   386,
     393,   396,   415,   423,   428,   429,   432,   436,   446,   451,
     465,   478,   694,   938,     3,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    30,    31,    32,    40,    41,    42,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    58,    59,    60,    61,    62,    63,    64,
      67,    68,    69,    70,    71,    73,    74,    75,    76,    77,
      79,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    93,    94,    95,    96,    97,    98,   100,   101,
     102,   103,   107,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   121,   123,   124,   125,   126,   127,   128,   129,
     131,   132,   133,   134,   137,   138,   139,   140,   141,   143,
     144,   145,   146,   148,   149,   150,   151,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   164,   166,   167,
     168,   169,   170,   172,   174,   175,   176,   178,   179,   180,
     181,   182,   184,   185,   187,   188,   189,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   202,   203,   204,
     205,   206,   207,   208,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   220,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   247,   248,   249,
     250,   251,   253,   254,   255,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   291,   292,   293,
     294,   296,   297,   298,   299,   300,   301,   303,   304,   305,
     308,   309,   310,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   393,   394,
     395,   396,   397,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   427,
     428,   430,   431,   432,   433,   434,   435,   436,   438,   439,
     440,   443,   444,   445,   446,   447,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   460,   461,   462,   463,   464,
     467,   468,   469,   470,   471,   472,   473,   475,   476,   477,
     478,   479,   480,   483,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,  1136,  1294,  1306,  1307,  1311,  1312,
    1313,     3,    29,  1021,  1291,  1306,  1311,   476,   528,   976,
     306,   340,   938,    54,   528,   613,    23,    41,    66,    79,
     114,   120,   138,   151,   160,   173,   182,   186,   255,   308,
     311,   334,   348,   376,   386,   396,   415,   423,   432,   433,
     435,   436,   451,   459,   462,   465,   622,   677,   784,   837,
     851,    29,   339,  1291,  1021,    29,   333,   394,   433,   435,
       6,   242,   893,   894,  1297,    23,    28,    66,    79,    96,
     114,   138,   151,   160,   173,   179,   186,   205,   265,   308,
     321,   334,   345,   348,   376,   379,   383,   386,   393,   396,
     415,   423,   429,   432,   436,   444,   446,   451,   465,   478,
     694,   797,   799,   800,   938,  1291,    99,   476,   528,   672,
     675,   678,   971,   984,   988,   991,  1000,  1007,  1012,  1020,
    1024,    11,    22,    29,    49,   168,   175,   177,   201,   244,
     281,   342,   362,   519,   520,   813,   814,  1021,  1296,  1298,
      29,    31,    99,   358,   392,   818,   819,   820,  1306,   173,
    1306,  1293,  1297,   429,  1038,   813,  1306,   443,  1291,   321,
     265,   114,   205,   386,   428,   429,   528,   903,   904,   384,
    1306,    29,   397,   439,   443,   564,   573,   574,  1306,    26,
     183,   818,   819,   340,   938,  1306,   241,    29,   135,  1040,
    1041,    67,    93,   255,   275,   376,   386,   397,   439,   443,
     491,   561,   562,   563,   564,    29,   397,   439,   443,   564,
     443,   307,  1083,  1084,  1289,  1306,  1038,   521,  1306,   178,
     528,   977,   528,   356,  1030,  1031,  1291,  1030,     3,    53,
      55,    56,    69,    70,   117,   118,   139,   169,   217,   218,
     220,   227,   276,   278,   298,   353,   401,   407,   439,   440,
     473,  1106,  1108,  1110,  1112,  1114,  1116,  1117,  1118,  1120,
    1121,  1122,  1124,  1125,  1129,  1307,  1311,  1040,  1041,  1042,
    1302,    12,  1303,  1304,  1306,  1303,  1303,  1025,  1026,  1029,
       0,   533,   528,   976,   152,   219,   312,   458,  1043,  1044,
    1025,  1027,  1028,   125,   215,   267,   464,   534,    35,   942,
     867,  1294,   802,  1306,   802,  1291,   343,   802,   446,  1291,
     113,   429,   855,  1294,  1306,  1313,     3,   106,   110,   398,
    1299,  1300,  1308,  1311,  1312,  1313,    29,   195,  1289,   299,
     478,    10,    17,    18,    19,    74,   164,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   889,   891,  1166,  1167,
    1306,   195,  1291,   855,  1291,    29,  1299,  1300,   855,  1291,
    1291,   195,  1289,  1291,   195,   802,  1291,   368,   399,    29,
     195,  1083,  1291,   389,  1291,   802,    29,   262,  1299,  1300,
     195,  1289,   242,   122,   225,   290,   352,   939,   940,   941,
     528,   526,   530,  1192,  1194,   970,   971,   972,   973,  1308,
    1289,  1291,  1306,    28,    66,    80,    92,   114,   138,   179,
     205,   243,   308,   345,   376,   379,   423,   432,   444,   451,
     797,   798,   799,   800,  1297,   942,   987,   991,  1000,  1007,
    1012,  1024,  1289,   268,   802,   528,   195,   802,  1291,   802,
     446,   195,  1291,   113,   429,   433,   435,  1299,  1300,   433,
     435,    74,   164,   889,   366,  1291,  1291,  1299,   195,   557,
    1306,   195,  1291,   195,   802,  1291,  1291,   389,   802,   262,
    1299,   356,   393,   429,   478,   265,    96,   205,    28,    92,
     179,   345,   383,   444,   446,   450,   689,    29,  1291,  1022,
     571,  1297,  1308,   894,   268,   195,   867,   868,   195,   898,
     195,  1291,   195,   804,  1106,   446,   113,   429,   195,   854,
     855,   195,  1300,  1301,    87,   478,    74,   164,   195,   890,
     891,    59,   195,   854,   195,  1301,   195,   854,   195,  1291,
     195,  1291,   389,   898,   195,   804,   195,   262,  1301,   242,
     195,   801,   802,   195,  1290,  1291,   195,  1291,   942,   528,
     989,   622,   984,   472,   970,   976,  1298,   814,   815,    29,
     815,  1298,   815,    29,   815,  1298,   815,   815,   815,  1298,
    1296,  1296,  1021,   815,   343,   528,   428,   528,   645,   645,
     645,   306,   441,   534,   645,   386,  1083,  1085,   534,   933,
    1297,   528,   986,    59,   478,   970,    87,   838,   838,  1306,
      48,   505,   225,   530,   309,   309,   306,   177,  1297,   441,
     942,   171,   810,   306,     5,     8,     9,    10,    12,    37,
      53,    55,    56,    65,    66,    69,    70,    77,    79,   104,
     105,   106,   107,   108,   109,   110,   117,   118,   120,   157,
     162,   163,   169,   185,   187,   217,   218,   220,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   237,   248,   256,
     257,   276,   278,   288,   290,   295,   296,   298,   308,   319,
     335,   353,   381,   398,   407,   424,   439,   440,   445,   447,
     448,   459,   465,   473,   493,   494,   495,   496,   498,   499,
     500,   501,   506,   519,   520,   521,   528,  1025,  1109,  1112,
    1115,  1116,  1117,  1119,  1120,  1121,  1124,  1125,  1129,  1130,
    1135,  1136,  1137,  1139,  1162,  1163,  1164,  1168,  1186,  1191,
    1197,  1198,  1199,  1200,  1201,  1226,  1266,  1269,  1270,  1278,
    1281,  1282,  1283,  1286,  1287,  1294,  1295,  1296,  1297,  1306,
    1285,  1286,  1297,    29,   579,  1288,  1289,   397,   561,   120,
     570,  1297,   571,  1297,    48,    71,   561,   505,   408,   940,
     309,   177,   441,   518,    48,   505,   225,   941,   528,  1289,
     521,  1194,  1085,   970,   176,   978,  1130,  1171,  1030,   534,
     528,   979,   475,  1123,  1123,  1123,   528,  1111,  1111,   337,
     528,  1113,    69,    70,  1123,  1111,  1108,   508,   510,   528,
    1126,   528,  1126,    37,  1107,   528,   115,   193,   269,   272,
     390,   503,   528,  1127,  1128,   530,   803,  1111,  1285,  1195,
     529,   529,   539,   970,   980,   981,   982,  1289,    29,   135,
    1039,  1039,    59,  1039,   165,   171,   252,   302,  1047,  1049,
    1050,  1065,  1067,  1068,  1069,  1043,  1044,   177,   221,   221,
    1083,  1086,   528,    68,   286,   322,   364,   399,   528,   865,
     322,   360,   364,   399,   803,   322,   364,   399,     3,    91,
     145,   258,   322,   360,   364,   399,   432,   434,   485,   572,
     575,   947,   948,   949,   950,   832,    25,   140,   322,   364,
     399,   469,   588,  1291,    25,   140,   399,   464,   555,   489,
     195,  1083,    62,    98,   161,   198,   247,   286,   290,   322,
     323,   364,   373,   382,   391,   399,   411,   420,   425,   480,
     572,   576,   871,   883,   910,   528,   852,  1194,   364,   555,
     201,   157,    25,    31,    46,    76,   133,   140,   144,   172,
     207,   286,   290,   300,   310,   322,   364,   367,   368,   399,
     469,   584,   586,   587,   712,   910,     5,   519,   520,   686,
    1298,    29,   195,  1289,   802,   802,   528,   888,   322,   399,
     530,   157,   306,   322,   364,   399,   883,   910,    25,   140,
     322,   364,   399,   201,   550,   364,   485,   508,   543,   550,
     322,   364,   399,   883,   910,   306,   322,   364,   157,    38,
      60,   112,   204,   266,   270,   286,   321,   364,   369,   393,
     399,   413,   584,   683,   684,   322,   364,   477,   712,   720,
     157,   322,   364,   399,    25,    91,   133,   140,   144,   322,
     360,   364,   399,   406,   574,   562,   564,   201,   157,    46,
     131,   286,   364,   399,   584,   585,   322,   364,   368,   399,
      89,   132,   325,   434,   306,    25,    31,   140,   322,   364,
     399,   603,   604,   550,   171,   364,   543,   550,   157,   364,
     399,   584,  1291,   250,   122,   307,   490,   534,   939,    29,
     135,   474,   521,   529,   860,  1130,  1172,  1173,  1307,  1130,
    1193,     3,    29,    33,    34,    35,    36,    37,    38,    39,
      43,    57,    65,    66,    72,    78,    80,    92,    99,   104,
     105,   106,   108,   109,   110,   120,   122,   130,   135,   136,
     142,   147,   152,   163,   165,   171,   173,   177,   183,   186,
     190,   201,   209,   219,   221,   245,   246,   252,   256,   257,
     290,   295,   302,   306,   307,   311,   312,   331,   341,   358,
     372,   392,   398,   409,   426,   429,   437,   441,   442,   448,
     458,   459,   465,   466,   474,   481,   482,   484,   485,   521,
    1292,  1309,  1311,  1312,  1313,  1314,  1192,   529,   534,   163,
     306,   448,   568,   571,   686,   974,   466,   967,   306,   867,
     528,   802,  1291,  1106,   855,   299,    74,   164,   891,   855,
     855,   171,  1106,   802,  1291,  1291,   529,   645,  1291,    72,
    1106,   290,   177,   528,   770,   543,    38,   961,  1291,   290,
     543,   489,   195,  1289,   543,   802,   802,   770,   462,   622,
     306,   171,   485,   879,   543,   290,    48,   558,   290,   451,
     719,   290,   979,    91,   322,   696,    89,   132,   325,   434,
      38,   770,   171,   195,   543,   478,   195,  1289,   195,   673,
    1289,  1289,   478,   802,   838,  1294,   446,  1294,  1294,  1291,
     171,  1291,   694,    40,    54,   111,   214,   286,   388,   157,
      63,   370,   534,   589,   157,   528,   157,   543,   157,   534,
     589,   489,   157,   534,   589,   157,   534,   195,   801,   195,
     802,   195,   802,   157,   534,   589,  1301,   157,   589,   157,
     157,   589,   157,   589,   157,    89,   132,   325,   434,   171,
     157,   589,   157,   171,   195,   157,   534,   589,   157,   534,
     589,   157,   306,  1171,   429,   529,   984,   815,  1021,   815,
    1021,   815,  1021,   815,  1021,   815,  1021,  1021,  1021,   815,
    1021,   528,   646,   647,  1306,   646,    29,   114,   138,   173,
     179,   242,   243,   324,   345,   379,   386,   393,   429,   432,
     451,   823,  1288,  1301,   820,  1291,   201,   534,  1003,  1297,
    1106,  1175,    38,  1301,   838,   529,  1289,  1291,   250,  1306,
     171,   171,   823,  1301,   384,  1306,   571,   306,   528,  1195,
     526,  1025,  1176,  1130,  1190,   528,   528,   171,   528,   528,
    1025,   528,   528,   528,   528,   528,   528,   528,   528,   528,
     528,   528,   528,   528,   528,   528,   528,   528,  1130,   528,
     528,   528,   528,   528,   528,   528,   528,   297,   636,   528,
     528,   528,   528,   528,   528,   528,   528,  1130,  1130,  1130,
    1025,  1130,  1171,  1194,  1297,   528,  1297,     3,    10,    13,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   167,   168,   169,   170,   172,   173,   174,   175,
     176,   178,   179,   180,   181,   182,   184,   185,   187,   188,
     189,   191,   192,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   220,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   270,   271,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   303,   304,   305,   307,
     308,   309,   310,   311,   313,   314,   315,   316,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   476,
     477,   478,   479,   480,   481,   483,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   504,   505,   506,   516,   517,   518,   519,   520,   521,
     522,   523,   524,  1166,  1168,  1170,  1310,  1315,   486,  1149,
     318,  1130,   166,  1150,   221,   534,  1036,   528,  1297,  1194,
    1036,   123,   197,   580,   534,    71,   120,   571,    38,     3,
     120,   255,   569,   686,  1125,  1297,  1297,    94,   137,  1145,
     103,   120,   565,   566,   568,   686,   120,   565,   250,  1289,
      95,   369,   806,   529,   976,    35,    45,    52,    78,   196,
     201,   223,   251,   308,   311,   404,   529,   534,  1031,  1290,
      38,   528,  1171,  1296,  1123,  1123,    37,  1107,   439,   439,
    1296,  1296,   526,   526,  1296,   441,   441,   441,   528,   441,
    1296,  1292,   530,  1111,   177,  1072,    15,   518,  1192,  1305,
     529,   534,   979,  1027,  1027,  1045,  1046,  1130,  1027,   168,
     281,  1056,   238,   286,   352,   402,   464,    29,  1051,  1130,
     519,   520,  1052,  1053,  1130,  1135,  1065,  1066,  1050,  1049,
    1047,  1048,   171,  1068,   300,  1070,  1047,  1065,  1086,   992,
    1289,  1086,    38,  1306,   399,  1171,    68,   441,   441,   386,
     201,   212,   312,   315,   401,   474,   521,   858,   859,   860,
     862,   864,   866,  1106,  1307,   441,   477,   441,   386,   441,
     441,   386,   252,   441,    79,   441,   432,   561,   322,   947,
     949,   518,   951,   171,   183,   201,   374,   833,   834,    72,
      92,   153,   173,   341,   459,   642,   643,    92,   120,   290,
     441,    92,   441,   120,   290,   386,    92,   133,   144,   322,
     364,   767,   386,   702,    28,    66,   138,   179,   308,   345,
     379,   444,   451,   797,   798,  1291,   157,   364,   399,   584,
     306,   686,   391,   247,   441,  1306,   441,   295,   686,   124,
     222,   386,   397,   443,   563,   802,   370,   399,   871,   884,
     128,   529,   853,   858,   441,   465,   432,  1289,    80,   153,
     195,   629,   642,  1306,    80,    92,   907,   327,   306,   381,
     383,   446,    92,   907,    32,   367,   381,   383,   446,   381,
    1289,   172,   207,   300,   802,   528,   441,   441,   194,   528,
     593,    23,   261,   432,   462,   487,   593,    92,   534,   128,
       5,     5,   322,   201,   157,   364,   399,   584,   910,   466,
     466,   287,  1106,   441,   386,   528,   889,  1291,  1289,   441,
     441,   386,   884,   128,    29,   107,   429,   919,   920,  1084,
    1289,  1306,   920,   441,   441,   770,   920,   114,   399,   575,
     441,   545,   575,   441,   441,   386,   884,   128,  1289,   441,
     441,  1289,  1108,   686,    59,   685,   686,   686,   112,   266,
     270,    59,   441,   543,   274,   386,   543,   286,   684,   441,
     441,   295,  1297,   712,   802,   441,   441,   386,   415,   348,
    1297,   348,   441,   348,   441,   348,   770,   770,   432,  1083,
     327,   327,    92,   441,   907,   386,   441,   441,   593,   593,
     802,   802,   802,   802,  1289,    47,   471,    47,    47,   441,
      47,   441,   471,   386,   528,   534,   575,   465,   728,  1300,
     441,   545,   575,  1289,   441,   907,   386,   322,   364,   352,
     365,   395,   567,   939,  1172,  1172,  1173,   529,    15,    16,
     534,  1043,  1044,   527,   535,  1289,   972,  1291,  1289,   223,
    1106,   223,   306,   223,   223,   686,   802,   802,   223,   223,
     223,  1106,   223,   223,   223,   306,   441,   177,   441,   607,
     451,   528,    38,   157,   802,   771,   772,  1309,   947,  1106,
     306,   157,   699,  1291,   290,   327,   528,   544,   784,   466,
     356,   478,  1289,    29,   920,   770,   544,   157,  1300,    99,
     183,   559,   621,   679,   742,   816,   836,   943,   157,  1297,
     720,   721,   157,   306,  1297,  1300,   258,   802,   802,   802,
     802,   148,   351,   528,   728,   290,   544,  1289,   290,   681,
     683,   290,    38,   300,   327,   528,   645,   645,   195,   676,
    1289,   171,   195,   839,  1291,   528,   774,   865,  1291,   528,
     856,   856,    38,  1106,    27,    50,   216,   743,   242,   485,
     487,  1023,   388,   868,   867,  1106,  1291,   528,   804,  1106,
     854,   855,  1301,  1300,   157,   589,   157,   466,   157,   466,
     890,   891,   589,   854,  1301,   854,  1291,  1291,  1106,   804,
    1301,   728,   157,   801,   802,  1290,  1291,  1291,   802,   529,
     195,  1289,   984,  1021,  1021,  1021,  1021,  1021,  1021,   646,
     529,   534,   529,   180,   346,   380,   394,   430,  1290,   801,
     113,   396,   854,  1290,   299,   821,   822,  1306,   854,   854,
    1290,  1288,  1288,  1290,   801,   441,   485,   829,   152,   252,
     725,   726,    23,   155,   381,   402,  1004,  1083,   294,  1005,
     529,   534,   987,   441,  1289,   903,   904,   819,   818,   819,
     177,   184,   830,  1306,    28,    80,   138,   179,   243,   345,
     379,   451,   797,   798,  1171,   527,  1171,  1176,  1177,   481,
    1187,  1188,  1130,  1171,   528,  1296,  1296,     3,   115,   193,
     269,   272,   390,   503,  1178,  1179,  1297,  1171,  1171,  1130,
    1210,   372,  1025,  1026,  1210,  1265,  1279,  1210,  1202,  1203,
    1210,  1130,  1135,  1172,  1271,  1272,  1273,  1274,  1275,  1276,
    1130,  1276,  1202,  1130,  1210,  1202,  1171,  1296,  1296,  1130,
    1130,   889,  1130,  1172,  1174,  1181,   381,   519,   520,   528,
    1131,  1135,  1168,  1182,   529,  1171,  1130,  1174,  1183,  1130,
      57,   177,   246,   442,  1130,  1171,  1184,   135,   290,  1025,
    1171,   274,  1135,  1130,  1143,  1144,  1145,   274,  1130,  1145,
     529,   534,  1296,  1127,  1106,  1130,  1130,  1130,  1130,  1309,
     439,    43,   426,  1196,   802,  1130,   528,  1025,  1185,   135,
     137,   163,   227,   282,   283,   284,   285,   289,   290,   295,
     448,   460,  1132,  1180,  1130,   528,  1130,   441,    52,   196,
     201,   251,   404,  1130,  1130,  1130,  1130,  1130,  1130,  1130,
    1130,  1130,  1130,    29,    36,   409,  1165,   186,  1150,   381,
     528,  1162,   528,   317,  1154,   182,   255,   429,   433,   435,
     462,  1037,  1289,  1287,  1072,  1172,  1072,  1289,   443,   528,
    1297,   534,   529,   194,   194,   589,   982,   971,   975,  1130,
     529,   265,   290,  1032,  1171,   529,   529,   526,   505,   505,
     529,   529,  1296,   527,  1296,   529,   193,   269,  1128,   269,
    1128,  1128,  1296,   272,   529,  1292,   227,   236,   245,   382,
     502,   528,  1025,  1073,  1074,  1075,  1083,  1089,  1099,  1136,
    1138,  1139,  1236,  1281,  1306,   482,  1094,  1302,   982,   980,
     534,    39,   130,   466,   848,   381,   382,   519,   520,  1053,
    1055,  1135,   402,   238,   307,   534,     5,  1054,  1296,  1054,
     381,   382,  1055,  1288,   294,   406,  1006,  1066,  1048,   466,
    1001,   120,   320,   528,   993,  1024,    38,   466,  1306,   528,
    1008,  1009,  1010,  1306,   529,  1300,  1291,  1291,   315,    59,
    1307,   529,   860,   862,   859,   862,  1307,   312,   529,   534,
     803,  1300,  1291,  1291,  1300,  1291,  1291,  1300,   477,  1291,
    1291,   120,   568,  1298,   376,   465,   818,   386,   183,   818,
     528,  1291,   466,   840,   238,   238,   466,   636,   667,   195,
    1291,   295,  1300,  1291,  1291,  1130,   295,  1291,  1291,    32,
     367,   441,   441,  1291,   441,   703,   867,   528,  1106,   855,
      74,   164,   891,   855,   855,   171,  1106,   802,  1291,   189,
     286,   322,   364,   470,   706,   707,   708,  1083,   441,   907,
     386,   295,   124,   222,  1300,  1291,   306,  1291,   306,   529,
     534,  1299,  1301,  1291,   364,   584,   195,   629,   290,  1106,
    1291,  1296,  1306,  1289,  1291,   250,  1291,    29,   465,  1291,
     195,  1291,   195,  1306,   383,   446,   383,   446,   250,  1291,
      29,   465,  1291,   250,   381,  1289,    25,   140,   399,   713,
     714,   715,   716,  1309,  1300,  1291,   120,   178,   291,   466,
     592,   595,   596,  1309,   268,  1291,    76,   303,  1291,   587,
     306,   441,   432,  1289,   441,   907,   386,   128,  1291,  1291,
     534,   529,   534,  1300,  1291,   913,   914,  1309,   306,   364,
     441,   736,  1300,  1291,  1291,   306,   430,  1083,   534,   645,
     645,  1194,  1300,  1291,  1291,  1299,     3,    91,   146,   207,
     329,   457,   465,   468,   546,  1300,  1291,  1291,   306,   364,
    1300,  1291,   364,   399,   584,   683,   686,   802,  1291,   686,
     802,  1291,   686,  1300,  1291,   399,  1300,  1291,  1291,  1298,
    1290,  1290,  1300,   879,  1291,  1290,  1291,   364,   399,   584,
     585,  1289,  1289,  1291,  1291,  1291,  1291,  1300,  1291,    25,
      31,   140,   322,   364,   399,   322,   364,   399,   770,   364,
     399,   364,   399,   364,   910,  1098,  1306,   195,   780,  1306,
     195,  1306,  1300,  1291,  1291,  1297,  1291,   913,    25,   604,
     396,  1299,   364,   399,   584,  1291,  1291,  1291,   441,   441,
      85,   456,   352,   534,  1043,  1043,  1043,  1130,  1130,   474,
    1173,   529,  1130,  1193,   967,   295,   808,  1297,    38,   808,
     138,   802,   808,   808,   223,   466,   466,   808,   808,   808,
     242,   808,   808,   808,   802,   347,   608,   608,   205,   429,
     741,  1130,  1106,   802,   529,   534,   518,   633,  1309,  1291,
      63,   177,   386,   477,   700,   707,   708,   157,   300,   251,
     623,   625,   627,   629,   639,   642,    26,   201,   376,   427,
     546,   547,   171,  1291,   478,  1289,    38,   737,   430,   879,
     557,  1306,   558,   622,   851,  1291,   173,   802,   528,   669,
     670,  1138,  1306,   348,  1297,   770,   770,   770,   770,   528,
     770,  1096,  1097,  1098,   396,   157,   528,   157,   157,   156,
    1024,   802,   300,   623,  1306,   466,   662,   485,   594,   290,
      38,   645,  1297,   290,   306,     3,   775,   776,   770,    27,
     529,   857,   858,   863,    38,   242,   373,   444,   484,   869,
     870,   871,   872,   869,   306,   242,   300,   125,   215,   449,
     464,   744,   745,  1291,   192,   192,   171,   589,    38,   543,
     172,   955,   956,   589,   589,   801,   802,  1291,   802,  1291,
     589,   589,   589,   589,   242,   589,   396,   171,   589,   589,
     306,   589,   290,   529,   647,   201,   201,   201,   201,   201,
     489,  1290,   686,   687,   534,   530,   186,   824,   825,  1300,
      26,   830,   441,   528,   177,   155,   402,   155,   402,   381,
     464,   271,  1106,  1300,   485,   674,   838,   838,   177,   306,
     824,    59,   589,   867,   802,  1106,   855,   299,   855,   855,
    1106,   802,  1291,   529,   527,   527,   534,  1130,   142,  1188,
    1189,    38,   529,  1130,   529,   529,   529,   177,   529,   529,
     174,  1211,   487,   509,  1133,  1106,  1265,   529,    21,   295,
     534,  1280,   312,  1284,   372,  1264,   534,   535,   471,   529,
    1265,    21,   295,   534,  1277,  1277,  1265,  1264,  1265,  1264,
     529,   529,   529,   529,   534,   534,   529,   331,   529,   529,
     528,  1131,  1131,  1171,    13,    17,    18,    19,   201,   223,
     308,   516,   517,   518,   519,   520,   521,   522,   523,   524,
    1168,  1131,   529,   529,   171,   177,   404,   529,   529,    38,
    1184,  1171,  1184,  1184,   177,   529,   135,   529,  1309,   328,
    1147,    38,   529,   534,  1130,  1309,   534,  1130,  1195,  1130,
     529,   505,  1131,  1131,   150,  1171,   177,    37,   299,   385,
     471,   135,   137,   163,   289,   295,   448,   460,  1132,  1180,
    1133,   289,   150,   889,  1130,   426,  1196,  1130,  1185,  1130,
     441,   528,  1025,   528,  1154,   528,  1171,   482,   528,  1155,
    1306,   433,   435,   433,   435,  1289,  1038,  1038,  1038,  1094,
    1043,  1094,   940,  1296,  1127,   566,   982,   265,   528,   529,
    1296,  1126,  1126,   527,   527,   529,   528,  1025,  1089,  1099,
    1236,   177,   528,  1025,  1074,  1075,    38,  1076,  1077,  1306,
     534,   100,   178,   211,   226,   249,   277,   375,  1080,  1077,
      38,  1076,  1079,  1306,  1077,   508,  1093,  1077,  1194,  1130,
     186,  1057,  1046,   308,  1166,  1169,   507,   849,     5,  1296,
    1055,   307,   485,   464,  1052,   260,  1073,   482,  1095,   472,
     428,   465,   994,   995,   996,  1306,   306,   997,  1306,  1074,
    1010,  1011,   534,  1072,   518,  1195,   866,   803,   862,   862,
      59,   864,   523,  1301,  1301,   306,  1290,   309,   306,  1130,
     643,  1291,   528,   528,   528,   667,   205,   528,   760,   157,
     589,   441,  1300,  1291,   571,  1106,   802,   802,  1106,   690,
    1291,   189,   470,   441,   441,   690,   706,   712,   364,   399,
     584,  1291,  1291,  1291,   213,   295,   160,   858,   321,   399,
     441,   290,   157,    86,   631,   632,   760,   399,    25,   140,
     368,   369,   399,   588,   597,   598,   712,   908,   391,   157,
     589,   157,   589,  1291,  1291,  1291,  1291,   391,   391,   250,
     715,   716,   715,   529,   534,   717,  1297,   205,   529,   534,
     518,   530,  1291,   160,  1300,  1291,   364,   399,   584,  1291,
    1291,  1291,   306,   322,   364,   399,    25,   140,   322,   364,
     399,  1106,   287,  1106,   529,   534,   518,  1289,   441,  1301,
     466,   733,   160,   201,   645,   919,   482,   652,   652,   645,
     252,   329,   295,  1297,   329,  1301,   463,   160,   441,   441,
     386,   415,   879,   879,   879,   321,   399,    92,   441,   907,
     386,   120,   171,   599,   167,   838,   441,   441,   262,   262,
     262,   441,   441,   386,   441,   441,   386,   441,   386,   441,
     386,   441,   128,   589,  1106,   290,  1297,   399,   908,   157,
     589,   441,   441,   529,  1291,   441,   907,   386,   441,  1300,
    1291,   529,   529,   529,  1173,   527,  1106,   802,   223,   808,
    1291,  1291,  1291,   223,   416,   417,   609,  1297,   609,   189,
     529,   529,   177,   770,   772,   287,   308,   519,   520,   686,
     773,   862,  1169,  1297,  1314,    72,    78,    92,   120,   122,
     181,   209,   290,   295,   341,   358,   459,   634,   635,   638,
     156,   481,   543,   571,  1291,   571,   310,   710,  1289,  1289,
    1289,   529,   534,  1301,   186,   376,  1301,  1296,   451,  1289,
     645,     3,   171,   738,   879,    48,   558,   429,   719,   113,
     979,  1130,   177,   534,  1290,   594,   777,   778,  1297,   529,
     534,  1291,   171,   646,  1289,   673,  1289,  1291,   674,   528,
     624,  1289,   529,  1291,   485,   487,   663,   593,    38,   157,
    1024,   662,   441,   157,  1083,   518,   529,   534,   744,   529,
     534,   120,   518,   873,  1297,   571,   429,   861,   862,   171,
     878,    51,   371,   874,   875,   872,   875,   125,   215,   392,
     464,   930,  1291,   300,   306,   311,   189,  1024,  1106,   528,
     529,   534,   589,   466,   589,   466,   589,  1291,  1291,   728,
     802,   157,   386,   386,   386,   386,   386,  1290,   534,   822,
    1306,  1300,   485,   534,   826,   309,  1085,   396,   155,   155,
     113,   286,  1289,  1291,  1301,   823,   830,  1300,   223,   223,
     223,   223,   686,   223,   223,   223,   223,   223,  1176,   437,
    1130,   147,  1106,   529,  1130,   227,  1212,   459,  1134,  1134,
    1264,  1211,   529,   306,   306,  1210,  1265,    59,  1280,  1106,
     149,   163,   448,   460,  1215,  1217,  1218,  1219,  1267,  1268,
    1130,  1204,  1210,  1210,   306,   306,  1276,  1133,  1133,   485,
     487,  1227,  1228,   529,   529,   120,   295,  1215,  1216,  1223,
    1224,  1225,  1180,  1130,  1130,   529,  1171,   534,  1106,  1131,
    1131,  1131,  1131,   135,   137,   290,  1131,  1131,  1131,  1131,
    1131,  1131,  1131,  1131,  1131,  1131,  1130,  1130,  1130,  1106,
     529,   529,   529,  1171,   529,   534,    59,  1135,  1148,   529,
    1309,  1144,   338,   422,  1146,   529,   534,   477,  1140,    38,
     529,  1297,  1130,    35,    35,  1130,   529,  1130,   177,  1133,
     289,  1130,   529,   150,  1131,  1131,   150,   150,  1130,  1130,
    1044,   529,  1171,   534,  1130,  1156,  1306,  1038,  1038,  1038,
    1038,  1289,  1289,  1289,  1057,   529,  1057,   529,   987,   527,
    1202,  1077,  1079,  1077,  1077,   528,   497,  1135,   529,  1306,
     528,  1074,   226,   316,  1081,  1074,  1081,   226,  1080,  1081,
     226,   431,  1087,   528,  1306,   528,   313,    59,   190,  1064,
     528,   849,   168,   244,   307,   485,   438,   103,  1130,   372,
     999,   471,   529,   534,  1195,    90,   999,   306,   529,   534,
    1009,  1095,  1130,   529,   523,   866,   451,   180,   380,   387,
     394,   430,   452,   835,   171,   835,   529,   528,   650,   651,
     843,  1138,  1306,   646,   646,   760,  1291,   646,   122,   209,
     286,   290,   761,  1291,  1291,    38,   466,   466,   242,   803,
    1300,  1291,   441,   907,   386,   441,   213,  1291,    59,   432,
    1291,   157,   629,   120,  1306,   710,   415,   181,   159,   194,
     290,   593,   543,   113,   181,   290,   415,   418,   593,   631,
     684,   399,   598,   451,  1291,  1306,   391,   714,  1291,   596,
     773,  1309,  1291,   321,   399,   441,   907,   386,   441,   160,
     441,   441,   386,   179,   308,   418,   782,   783,   179,   308,
     790,   791,   441,   441,   386,   529,   529,   529,   914,   287,
     686,   862,   915,  1169,  1297,  1314,   364,  1291,   528,   485,
     734,  1291,   386,   652,   528,   652,  1298,  1297,  1297,  1297,
    1291,  1291,  1291,  1291,  1298,    59,   432,  1291,  1291,  1291,
    1291,   472,  1291,  1291,   171,   171,   366,   171,   195,  1300,
    1291,  1291,  1300,  1291,  1291,  1291,  1291,  1291,  1291,  1291,
     306,    78,   590,   157,    27,    50,   451,  1306,  1291,  1297,
     712,  1291,  1291,  1291,  1291,  1043,   529,   223,   808,   223,
     223,   223,   808,   543,   466,   614,   615,   690,   760,   485,
     487,   802,   528,   802,  1291,  1131,    32,    59,   637,   123,
     197,   122,   295,   238,  1289,   636,   179,   345,   756,   763,
     764,  1306,   699,   528,   327,   528,   624,   640,   208,   657,
     627,  1301,  1301,  1106,   528,   594,    29,   125,   215,   392,
     464,   739,   441,   735,  1300,   195,  1289,   721,   489,   306,
     529,  1073,   670,   879,   529,   534,  1098,   710,   728,   529,
     681,    38,   300,   327,   528,   989,   626,   628,   630,   642,
    1306,   327,   658,   659,   624,   657,   593,   303,   306,   664,
    1024,   676,   674,   594,  1297,  1291,   840,   773,     3,   776,
     306,   863,  1130,  1130,   534,   528,   869,   451,   534,    44,
    1130,   441,   528,   646,  1289,   745,   690,   529,   955,   956,
    1291,  1291,   589,   396,   589,  1290,  1290,  1290,  1290,  1290,
     686,   183,   825,   830,   529,  1291,   113,   830,   177,   589,
     295,   811,  1297,   811,   811,   811,   223,   811,   811,   811,
     811,   811,  1130,   529,   145,  1213,   239,   529,   295,   295,
     529,  1045,  1265,   529,   306,    38,  1205,   295,   295,  1265,
      88,   455,  1230,    37,  1229,   240,   305,  1231,  1232,   489,
    1130,   306,   529,   529,   529,   177,   529,  1130,   177,   135,
     137,   177,   171,   150,   529,   492,  1142,  1171,   357,   471,
      59,  1148,  1135,   483,   483,   529,  1130,   286,  1130,   534,
    1141,  1108,  1130,  1130,  1130,  1130,    35,    35,  1130,  1130,
     150,   529,   529,   529,  1130,   529,   327,  1157,  1289,  1289,
    1289,  1289,  1064,  1297,  1064,  1297,   529,    81,  1237,  1090,
    1091,  1138,   528,  1147,  1076,   528,  1290,  1074,   306,   466,
    1082,  1074,   226,  1074,  1294,  1097,   528,  1097,  1306,  1039,
    1130,   484,  1151,   889,   438,   300,  1286,  1024,   320,  1024,
     996,   306,   528,   998,  1130,   518,  1010,   999,   451,   529,
     441,   818,   177,   760,  1130,   529,   534,   485,    78,   842,
     846,   842,   529,   529,   529,   123,   197,   207,   122,   468,
     589,  1106,  1291,  1291,  1291,  1291,  1291,  1291,  1291,  1301,
    1291,   629,   633,  1298,   637,   195,   195,   295,   686,   637,
     295,  1298,  1306,  1106,   589,   589,   518,    59,   432,  1291,
    1291,  1291,  1291,  1291,  1300,  1291,  1291,  1296,  1296,  1106,
     534,  1296,  1296,   534,  1300,  1291,  1291,   441,  1130,    72,
     107,  1306,  1130,  1301,  1291,   441,   441,   177,   201,   485,
    1290,  1290,   802,  1290,   157,   160,   802,  1297,  1297,  1106,
     589,   589,   441,   529,   223,   808,   808,   808,   808,   528,
     610,   611,   543,   127,   179,   212,   179,  1130,   290,   635,
     120,    38,   879,   645,   879,  1294,    35,   156,   201,   711,
     715,   300,   623,   599,   154,   203,   528,   396,   466,   646,
      38,  1301,   733,   558,   290,   528,   173,  1291,   669,  1297,
     396,   594,   156,  1024,   802,   300,   623,   674,   529,   534,
     485,   633,    59,   662,   599,   658,    84,   432,   665,   485,
     944,    38,   665,   177,   306,   528,  1289,  1297,   860,   880,
     881,  1307,   875,  1106,   171,   876,  1289,   177,   441,   900,
     359,   746,   210,   691,   589,   529,   589,   589,  1291,   309,
     221,   589,   824,   811,  1214,  1291,   529,   149,  1206,  1291,
     328,  1207,   529,  1229,   143,  1215,  1216,  1221,  1222,  1223,
    1234,  1235,   350,   143,   149,  1130,   529,  1131,   177,  1130,
    1130,  1130,   528,   529,   534,   529,  1148,   529,   471,   412,
     529,   529,  1130,  1130,  1130,   529,    59,  1043,  1151,  1151,
     389,  1033,   528,   332,  1249,  1250,  1260,   529,   534,    38,
    1092,   120,  1104,  1105,  1131,    81,  1290,   529,  1130,   528,
    1074,  1082,   528,   529,  1097,   529,   102,   187,   378,   528,
    1058,  1059,  1060,  1061,  1062,  1063,  1130,  1152,  1153,  1306,
    1043,   529,  1021,   994,    92,   841,   843,   136,   481,  1013,
    1014,  1130,   824,   306,   824,   529,   202,   648,   651,   308,
     889,   802,   802,   847,   358,   648,   648,   529,   441,   399,
    1005,    38,   157,   157,   590,   773,  1301,  1291,   441,   528,
     855,   889,   891,   783,   528,   528,   791,  1291,   529,   528,
     529,   399,  1005,  1291,  1291,   528,   528,   528,   485,   508,
     964,   366,   964,   964,   171,  1291,   590,  1291,   808,   616,
     617,  1309,    54,   101,   126,   145,   150,   172,   176,   191,
     295,   349,   612,   610,  1297,   855,    38,   896,   896,   529,
     194,   528,   466,   666,   263,   649,   666,   528,   764,   756,
     528,   529,   534,  1289,   529,   396,    29,    83,    86,    93,
     121,   181,   194,   206,   415,   418,   641,   641,  1288,  1291,
    1291,   529,  1024,   734,   157,   113,   710,   177,  1291,    38,
    1291,   674,   624,  1289,   529,   628,   310,  1306,   663,   658,
     662,   125,   140,   338,  1291,    64,    72,   255,  1024,   802,
    1083,   841,   177,   759,   862,   529,   534,   451,   147,   540,
     874,   877,  1094,   410,   410,   529,   280,   304,   747,   748,
     749,   171,   752,   690,   286,   470,   692,   693,  1291,   830,
    1208,  1209,  1210,    37,   299,   306,   529,   306,  1233,  1224,
     171,  1131,  1143,  1171,   286,   504,  1171,   188,   351,   382,
    1158,    58,   129,   112,  1034,   279,  1238,  1239,  1240,  1241,
    1242,  1246,  1247,  1306,   120,   528,   143,  1215,  1220,  1243,
    1244,  1093,  1090,   528,  1131,   529,   534,    38,  1100,  1101,
    1306,   529,  1290,  1171,   529,   528,   400,   528,   529,   534,
     534,    38,  1048,   471,  1291,   529,   534,   291,   464,   264,
     290,  1014,   826,   835,   589,   842,   528,   879,   528,   593,
     848,  1289,   879,   879,  1291,   432,   194,   466,   591,   399,
    1005,  1291,  1175,   171,   786,   786,  1175,  1175,  1130,   432,
    1171,  1171,   600,   601,  1308,   801,   802,   801,   802,  1290,
     589,   529,   534,   521,   528,   568,   618,   686,   961,  1297,
     961,   290,   295,   349,   961,   961,  1094,   896,    42,   199,
     286,   644,   528,   682,  1130,   205,   178,   326,   405,   306,
     653,   654,   655,   529,  1294,     6,   765,   715,   624,   657,
    1291,   529,   710,   164,   785,   594,   944,  1289,   489,  1073,
     710,  1024,   989,   658,   624,   657,   633,   528,   664,   662,
     663,   382,   382,    72,   309,    72,   674,   840,   529,  1289,
     760,   869,   880,  1106,   533,   136,   485,   485,   748,   381,
     429,   750,   141,   753,   481,   755,   470,   690,   710,   589,
     534,    38,   143,   149,   385,   306,  1130,   529,   529,   471,
      52,   103,   454,  1130,  1159,  1160,  1159,  1159,   529,   168,
     168,   646,   330,  1248,   529,   534,   171,  1106,   528,   528,
    1206,  1251,  1252,  1253,  1254,  1255,  1256,  1257,  1258,  1259,
     306,   529,  1097,   534,  1105,  1309,   529,   534,   171,  1106,
     529,   529,  1171,   528,  1171,  1059,  1153,  1155,  1066,  1024,
    1094,   843,   399,    35,  1015,   264,   177,   646,   666,   889,
     848,   849,   645,   666,   666,  1291,   682,  1130,   432,   529,
     312,   389,   355,   787,   787,   529,   529,   529,  1291,   529,
     529,   529,   534,  1296,   964,   617,   568,   619,   620,  1297,
    1297,   295,   646,   521,   646,  1297,  1297,   207,   683,   529,
     432,   125,   464,   306,   655,   306,   654,   528,   529,   534,
     599,   396,   710,   802,    38,    38,   528,  1291,   944,   674,
     662,   599,   658,   528,   660,   661,  1138,  1306,   665,   663,
     664,   309,   309,   528,   202,   844,   171,   875,    30,   216,
     931,   179,   179,   961,   381,   414,   754,   528,   156,  1209,
    1309,  1234,   421,   149,  1160,   381,   170,   336,   170,   336,
     153,  1161,  1161,  1161,    59,    59,   399,  1297,  1239,   313,
     157,   174,   330,  1245,   100,   211,   316,   458,  1261,  1262,
    1263,  1251,   529,   211,   316,   458,   100,   100,   458,   149,
     529,  1135,  1101,   313,     3,   120,   290,   295,   330,  1102,
    1103,    38,  1078,   365,  1088,   529,  1058,   529,  1008,  1130,
     437,  1015,   824,   529,   652,   529,   849,   649,   760,   760,
    1005,  1291,   855,    59,  1005,   441,   600,   802,   529,   534,
     646,   529,   419,  1291,    63,   286,   370,   399,   656,   656,
     529,     6,   396,  1291,   782,  1024,   710,   663,   658,   662,
    1130,   529,   534,   846,   846,   664,   665,   841,   528,   636,
     141,   291,   528,   926,   928,   932,   991,  1000,  1007,  1024,
    1035,   855,   855,   751,  1306,  1130,   756,   306,    35,   103,
     186,   286,   438,   646,   646,  1306,  1205,  1245,  1212,  1297,
    1227,   529,   534,   534,   529,  1252,  1259,  1259,  1259,  1259,
    1259,  1259,  1147,  1131,  1131,   295,  1131,  1103,  1306,   528,
     529,  1094,   125,   136,   464,  1016,  1017,   437,   589,   760,
     653,  1005,   802,   528,   620,    24,   120,   295,  1291,   710,
     944,   664,   662,   663,   529,   661,   802,   847,   847,   665,
     529,   843,   845,   594,   381,   927,   928,   929,  1025,  1026,
     534,   534,   529,  1294,   149,  1160,   381,   314,   399,   399,
     441,   466,  1237,  1267,  1245,  1231,  1263,  1262,    81,  1130,
     291,   399,   136,   215,  1018,   760,  1171,   645,   645,   710,
     665,   663,   664,   846,   844,   529,   534,   665,   755,   529,
     533,   441,   177,   528,  1306,  1306,   227,  1294,  1295,  1306,
    1227,  1225,  1100,   529,  1008,   291,   120,   320,   472,   528,
    1019,   529,   664,   665,   847,   636,   843,  1094,   156,   929,
     410,   410,     5,   757,   758,  1296,  1297,  1309,   528,   120,
    1231,   529,   472,   994,   528,   995,   665,   594,   756,   485,
     485,   529,   534,  1172,  1295,  1235,   471,  1171,   529,   665,
    1294,   179,   179,   758,  1043,   466,  1019,   529,   320,  1019,
    1094,   528,   855,   855,   529,  1306,   994,   757,   471,   529,
    1019
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   536,   537,   537,   537,   537,   537,   537,   538,   538,
     539,   539,   540,   540,   540,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   540,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   540,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   540,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   540,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   540,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   540,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   540,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   540,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   540,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   540,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   540,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   540,   540,   540,   541,   542,   543,
     543,   543,   544,   544,   545,   545,   546,   546,   546,   546,
     546,   546,   546,   546,   546,   547,   547,   547,   547,   547,
     547,   548,   549,   549,   550,   550,   551,   551,   551,   551,
     552,   552,   552,   552,   552,   552,   553,   554,   555,   555,
     556,   556,   556,   556,   557,   557,   558,   558,   559,   559,
     559,   559,   559,   559,   560,   560,   560,   561,   561,   561,
     562,   562,   562,   562,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   563,   564,   564,   565,   565,   566,
     566,   567,   567,   567,   567,   568,   568,   568,   568,   569,
     569,   569,   569,   569,   569,   569,   570,   570,   570,   571,
     571,   572,   573,   573,   573,   573,   574,   574,   575,   575,
     576,   576,   577,   577,   577,   577,   577,   578,   579,   579,
     580,   580,   581,   582,   582,   582,   582,   582,   583,   583,
     583,   583,   583,   583,   583,   583,   583,   583,   583,   583,
     583,   583,   583,   583,   583,   583,   583,   583,   583,   584,
     584,   585,   585,   585,   586,   587,   587,   587,   587,   587,
     587,   587,   587,   587,   587,   587,   587,   587,   587,   587,
     587,   587,   587,   587,   587,   587,   587,   587,   587,   587,
     587,   587,   587,   587,   587,   587,   587,   587,   587,   587,
     587,   587,   587,   587,   587,   587,   587,   587,   587,   587,
     587,   587,   587,   587,   587,   587,   587,   587,   587,   587,
     587,   587,   587,   587,   587,   588,   588,   589,   589,   589,
     590,   590,   591,   591,   592,   592,   592,   592,   593,   594,
     594,   595,   595,   596,   596,   596,   596,   597,   597,   598,
     598,   598,   598,   599,   599,   599,   599,   600,   601,   601,
     602,   603,   603,   604,   604,   604,   604,   605,   605,   606,
     606,   607,   607,   608,   608,   609,   609,   609,   610,   610,
     611,   611,   612,   612,   612,   612,   612,   612,   612,   612,
     612,   612,   612,   612,   612,   613,   613,   614,   614,   615,
     615,   616,   616,   617,   618,   618,   618,   618,   618,   619,
     619,   620,   621,   621,   621,   621,   621,   621,   622,   622,
     622,   622,   622,   622,   622,   622,   623,   623,   624,   624,
     625,   625,   626,   626,   627,   627,   627,   628,   628,   629,
     630,   630,   631,   631,   632,   632,   633,   633,   634,   634,
     634,   634,   635,   635,   635,   635,   635,   635,   635,   635,
     635,   636,   636,   636,   637,   637,   638,   638,   638,   638,
     639,   640,   640,   640,   641,   641,   641,   641,   641,   641,
     641,   641,   641,   641,   642,   642,   643,   643,   643,   643,
     643,   643,   643,   644,   644,   645,   645,   646,   646,   647,
     648,   648,   649,   649,   649,   649,   650,   650,   651,   651,
     652,   652,   653,   653,   653,   653,   653,   654,   655,   656,
     656,   656,   656,   656,   657,   657,   658,   658,   659,   660,
     660,   661,   661,   661,   662,   662,   663,   663,   663,   664,
     664,   664,   664,   665,   665,   666,   666,   667,   668,   668,
     669,   669,   670,   670,   670,   671,   671,   672,   672,   673,
     674,   674,   674,   675,   675,   676,   677,   677,   678,   679,
     679,   680,   680,   681,   681,   682,   682,   683,   683,   684,
     684,   684,   684,   684,   684,   684,   684,   684,   684,   684,
     684,   684,   684,   685,   685,   686,   686,   686,   686,   687,
     687,   688,   688,   689,   689,   690,   690,   691,   691,   692,
     692,   693,   693,   694,   694,   695,   696,   696,   697,   697,
     698,   698,   699,   699,   700,   700,   700,   700,   701,   702,
     702,   703,   704,   704,   704,   704,   704,   704,   704,   704,
     704,   704,   704,   704,   704,   705,   706,   706,   706,   706,
     707,   707,   708,   708,   709,   709,   710,   710,   711,   711,
     712,   713,   713,   714,   714,   714,   714,   715,   716,   717,
     718,   718,   719,   719,   720,   720,   721,   721,   722,   722,
     722,   723,   723,   723,   723,   724,   725,   725,   726,   726,
     727,   727,   728,   728,   729,   729,   730,   731,   732,   733,
     733,   734,   734,   735,   735,   736,   736,   737,   737,   738,
     738,   739,   739,   739,   739,   739,   740,   741,   741,   742,
     742,   743,   743,   743,   744,   744,   745,   745,   745,   745,
     745,   746,   746,   747,   747,   748,   749,   749,   750,   750,
     751,   752,   752,   753,   753,   754,   754,   755,   755,   756,
     756,   757,   757,   757,   758,   758,   758,   758,   759,   759,
     760,   760,   761,   761,   761,   761,   761,   761,   762,   762,
     763,   763,   764,   765,   765,   766,   767,   767,   767,   767,
     768,   769,   769,   769,   769,   769,   769,   769,   769,   769,
     769,   769,   769,   769,   769,   769,   769,   770,   771,   771,
     772,   772,   773,   773,   773,   773,   773,   773,   774,   775,
     775,   776,   777,   777,   778,   778,   779,   779,   779,   779,
     780,   780,   781,   782,   782,   783,   783,   783,   783,   783,
     784,   784,   785,   785,   786,   786,   786,   787,   787,   788,
     789,   789,   790,   790,   791,   791,   792,   792,   793,   793,
     794,   795,   796,   796,   796,   796,   796,   796,   796,   796,
     796,   796,   796,   796,   797,   797,   797,   797,   797,   797,
     797,   797,   797,   797,   797,   797,   797,   798,   798,   798,
     798,   798,   799,   799,   799,   799,   799,   799,   799,   799,
     800,   800,   800,   801,   801,   802,   802,   803,   803,   804,
     804,   805,   806,   806,   806,   807,   807,   807,   807,   807,
     807,   807,   807,   807,   807,   807,   807,   807,   807,   807,
     807,   807,   807,   808,   808,   809,   809,   809,   809,   809,
     809,   809,   809,   809,   809,   810,   810,   811,   811,   812,
     812,   813,   813,   813,   813,   813,   813,   813,   813,   813,
     813,   813,   813,   813,   813,   813,   813,   814,   814,   815,
     815,   816,   817,   817,   818,   818,   818,   818,   818,   819,
     819,   820,   820,   820,   820,   820,   821,   821,   822,   822,
     823,   823,   823,   823,   823,   823,   823,   823,   823,   823,
     823,   823,   823,   823,   823,   823,   823,   823,   823,   823,
     823,   824,   824,   825,   825,   826,   826,   827,   828,   828,
     829,   829,   830,   830,   831,   832,   832,   833,   833,   833,
     834,   834,   834,   835,   835,   835,   835,   835,   835,   836,
     836,   837,   837,   838,   838,   839,   839,   840,   840,   841,
     841,   842,   842,   843,   843,   843,   844,   844,   845,   845,
     846,   846,   847,   847,   848,   848,   848,   849,   849,   849,
     850,   850,   850,   850,   851,   851,   852,   852,   853,   853,
     854,   854,   855,   855,   855,   855,   856,   856,   857,   857,
     858,   858,   858,   858,   858,   859,   859,   859,   859,   859,
     860,   861,   862,   862,   862,   863,   863,   863,   864,   865,
     865,   865,   865,   866,   866,   867,   868,   868,   869,   869,
     870,   870,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   872,
     872,   872,   872,   872,   873,   873,   874,   875,   875,   875,
     876,   876,   877,   877,   878,   878,   879,   879,   880,   881,
     881,   882,   882,   882,   883,   883,   884,   884,   885,   885,
     885,   885,   885,   885,   886,   886,   887,   887,   888,   888,
     888,   888,   889,   889,   890,   890,   891,   892,   893,   893,
     894,   894,   895,   895,   895,   896,   896,   896,   897,   898,
     898,   899,   900,   900,   900,   900,   901,   902,   902,   902,
     902,   903,   903,   904,   904,   904,   905,   905,   906,   906,
     906,   906,   906,   906,   906,   906,   906,   906,   906,   906,
     906,   906,   906,   906,   906,   906,   906,   906,   906,   906,
     906,   906,   906,   906,   906,   906,   906,   906,   906,   906,
     906,   906,   906,   906,   906,   906,   906,   906,   906,   906,
     906,   906,   906,   906,   906,   906,   906,   906,   906,   906,
     906,   906,   906,   907,   907,   908,   908,   909,   909,   909,
     909,   909,   909,   910,   910,   911,   911,   911,   911,   911,
     911,   911,   911,   911,   911,   911,   911,   911,   911,   911,
     911,   911,   911,   911,   911,   911,   911,   911,   911,   911,
     911,   911,   912,   913,   913,   914,   914,   915,   915,   915,
     915,   915,   916,   917,   917,   917,   917,   917,   917,   917,
     917,   917,   917,   917,   917,   917,   917,   917,   917,   917,
     917,   917,   917,   917,   917,   917,   917,   918,   918,   918,
     919,   919,   919,   919,   919,   919,   919,   920,   920,   921,
     921,   921,   921,   922,   923,   923,   923,   923,   923,   923,
     923,   923,   923,   924,   924,   925,   926,   926,   926,   927,
     927,   928,   928,   928,   928,   928,   929,   929,   930,   930,
     930,   930,   931,   931,   931,   932,   933,   933,   934,   935,
     935,   936,   936,   936,   936,   936,   936,   936,   936,   936,
     936,   936,   936,   937,   937,   938,   938,   938,   939,   939,
     939,   939,   939,   940,   940,   940,   941,   941,   942,   942,
     942,   943,   943,   943,   943,   944,   944,   944,   944,   945,
     946,   947,   947,   948,   948,   949,   949,   949,   950,   950,
     950,   950,   950,   950,   950,   951,   951,   952,   952,   952,
     952,   953,   954,   954,   954,   954,   955,   955,   956,   957,
     958,   958,   959,   960,   960,   960,   960,   960,   960,   960,
     961,   961,   962,   963,   963,   963,   963,   963,   963,   964,
     964,   965,   966,   966,   966,   966,   967,   967,   968,   968,
     969,   969,   970,   970,   971,   971,   972,   973,   973,   974,
     974,   974,   975,   975,   976,   976,   977,   977,   978,   978,
     979,   979,   980,   981,   981,   982,   982,   983,   983,   983,
     983,   984,   984,   984,   984,   984,   984,   984,   984,   984,
     984,   985,   986,   986,   987,   987,   987,   987,   987,   988,
     988,   988,   989,   989,   990,   990,   990,   990,   991,   992,
     992,   993,   993,   993,   993,   993,   994,   994,   995,   995,
     996,   997,   997,   997,   998,   998,   998,   999,   999,  1000,
    1001,  1001,  1002,  1003,  1003,  1004,  1004,  1004,  1004,  1004,
    1004,  1004,  1004,  1005,  1005,  1006,  1006,  1006,  1007,  1008,
    1008,  1009,  1009,  1010,  1011,  1011,  1012,  1013,  1013,  1014,
    1014,  1014,  1014,  1014,  1015,  1015,  1016,  1017,  1018,  1018,
    1018,  1018,  1018,  1019,  1020,  1021,  1022,  1022,  1022,  1022,
    1022,  1022,  1023,  1023,  1023,  1024,  1024,  1025,  1025,  1026,
    1026,  1026,  1026,  1026,  1026,  1026,  1026,  1027,  1027,  1028,
    1028,  1028,  1028,  1028,  1028,  1028,  1029,  1029,  1029,  1030,
    1030,  1031,  1032,  1032,  1032,  1033,  1033,  1033,  1034,  1034,
    1034,  1035,  1035,  1036,  1036,  1037,  1037,  1037,  1037,  1037,
    1037,  1037,  1037,  1037,  1038,  1038,  1039,  1039,  1039,  1040,
    1040,  1041,  1041,  1042,  1042,  1043,  1043,  1044,  1045,  1045,
    1046,  1046,  1047,  1047,  1047,  1047,  1048,  1048,  1049,  1049,
    1049,  1049,  1049,  1049,  1050,  1050,  1051,  1051,  1052,  1053,
    1053,  1053,  1054,  1054,  1055,  1055,  1056,  1056,  1057,  1057,
    1058,  1058,  1059,  1059,  1059,  1059,  1059,  1060,  1061,  1062,
    1063,  1064,  1064,  1065,  1065,  1066,  1066,  1067,  1067,  1068,
    1069,  1069,  1069,  1069,  1070,  1070,  1071,  1071,  1072,  1072,
    1073,  1073,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1075,  1075,  1075,  1075,  1075,  1075,
    1076,  1076,  1076,  1076,  1077,  1077,  1078,  1078,  1079,  1079,
    1079,  1079,  1079,  1080,  1080,  1080,  1080,  1081,  1081,  1082,
    1082,  1083,  1083,  1084,  1084,  1084,  1085,  1085,  1086,  1086,
    1086,  1087,  1088,  1088,  1089,  1089,  1090,  1091,  1091,  1092,
    1092,  1093,  1093,  1094,  1094,  1095,  1095,  1095,  1096,  1096,
    1097,  1097,  1098,  1099,  1099,  1100,  1100,  1101,  1101,  1101,
    1102,  1102,  1103,  1103,  1103,  1103,  1103,  1104,  1104,  1105,
    1105,  1106,  1106,  1106,  1106,  1106,  1106,  1107,  1107,  1107,
    1108,  1108,  1108,  1108,  1108,  1108,  1108,  1108,  1109,  1109,
    1109,  1109,  1109,  1110,  1110,  1111,  1111,  1112,  1112,  1112,
    1112,  1112,  1112,  1112,  1112,  1112,  1112,  1112,  1113,  1113,
    1114,  1114,  1115,  1115,  1116,  1117,  1118,  1118,  1119,  1119,
    1120,  1121,  1122,  1122,  1122,  1122,  1122,  1122,  1123,  1123,
    1124,  1124,  1124,  1124,  1125,  1126,  1126,  1126,  1127,  1127,
    1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,
    1127,  1127,  1128,  1128,  1129,  1130,  1130,  1130,  1130,  1130,
    1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,
    1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,
    1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,
    1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,
    1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,
    1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,
    1130,  1130,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,
    1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,
    1131,  1131,  1131,  1131,  1132,  1132,  1132,  1132,  1132,  1133,
    1133,  1133,  1134,  1134,  1135,  1135,  1135,  1135,  1135,  1135,
    1135,  1135,  1135,  1135,  1135,  1135,  1135,  1135,  1136,  1136,
    1136,  1136,  1136,  1136,  1136,  1137,  1137,  1137,  1138,  1138,
    1138,  1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,
    1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,
    1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,
    1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,
    1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,  1140,  1140,
    1141,  1141,  1141,  1141,  1142,  1143,  1143,  1144,  1144,  1145,
    1145,  1146,  1146,  1146,  1147,  1147,  1147,  1147,  1148,  1148,
    1149,  1149,  1150,  1150,  1151,  1151,  1152,  1152,  1153,  1154,
    1154,  1154,  1155,  1156,  1156,  1157,  1157,  1158,  1158,  1158,
    1158,  1159,  1159,  1160,  1160,  1160,  1160,  1160,  1161,  1161,
    1161,  1161,  1161,  1162,  1162,  1162,  1163,  1163,  1164,  1165,
    1165,  1165,  1166,  1166,  1167,  1167,  1167,  1167,  1167,  1167,
    1167,  1167,  1167,  1167,  1167,  1167,  1168,  1168,  1169,  1169,
    1170,  1170,  1170,  1170,  1170,  1170,  1171,  1171,  1172,  1172,
    1173,  1173,  1173,  1174,  1174,  1175,  1175,  1176,  1176,  1176,
    1177,  1177,  1178,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1180,  1180,  1180,  1180,  1181,  1181,  1182,  1183,  1183,
    1183,  1183,  1183,  1184,  1184,  1184,  1185,  1185,  1186,  1187,
    1187,  1188,  1189,  1189,  1190,  1190,  1191,  1191,  1192,  1192,
    1192,  1192,  1193,  1193,  1194,  1194,  1195,  1195,  1196,  1196,
    1197,  1197,  1197,  1197,  1197,  1197,  1197,  1198,  1199,  1200,
    1201,  1202,  1203,  1204,  1205,  1205,  1206,  1207,  1207,  1208,
    1208,  1209,  1210,  1211,  1211,  1212,  1213,  1213,  1214,  1215,
    1216,  1217,  1218,  1219,  1220,  1221,  1221,  1222,  1223,  1224,
    1224,  1224,  1225,  1225,  1225,  1225,  1226,  1227,  1227,  1228,
    1228,  1229,  1229,  1230,  1230,  1230,  1231,  1231,  1232,  1232,
    1233,  1233,  1234,  1234,  1234,  1234,  1234,  1235,  1235,  1235,
    1235,  1236,  1237,  1238,  1238,  1239,  1239,  1239,  1239,  1239,
    1240,  1241,  1242,  1243,  1243,  1244,  1244,  1245,  1245,  1246,
    1247,  1248,  1248,  1249,  1249,  1249,  1250,  1251,  1251,  1251,
    1252,  1253,  1253,  1254,  1255,  1256,  1256,  1257,  1257,  1258,
    1258,  1259,  1259,  1260,  1261,  1261,  1261,  1261,  1262,  1262,
    1263,  1263,  1264,  1264,  1265,  1265,  1266,  1267,  1267,  1268,
    1268,  1268,  1268,  1269,  1269,  1270,  1271,  1271,  1272,  1273,
    1274,  1274,  1275,  1275,  1276,  1276,  1277,  1277,  1277,  1278,
    1278,  1278,  1279,  1279,  1280,  1280,  1280,  1281,  1281,  1282,
    1283,  1284,  1284,  1285,  1285,  1286,  1286,  1287,  1287,  1287,
    1287,  1288,  1288,  1289,  1289,  1290,  1290,  1291,  1292,  1293,
    1294,  1294,  1295,  1295,  1295,  1295,  1295,  1295,  1295,  1295,
    1295,  1295,  1295,  1295,  1295,  1296,  1297,  1298,  1298,  1298,
    1299,  1300,  1300,  1300,  1300,  1301,  1301,  1302,  1303,  1304,
    1304,  1305,  1305,  1306,  1306,  1306,  1307,  1307,  1307,  1308,
    1308,  1308,  1308,  1309,  1309,  1309,  1309,  1309,  1310,  1310,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,  1311,
    1311,  1311,  1311,  1311,  1312,  1312,  1312,  1312,  1312,  1312,
    1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,
    1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,
    1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,
    1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,
    1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,
    1312,  1312,  1312,  1312,  1312,  1312,  1313,  1313,  1313,  1313,
    1313,  1313,  1313,  1313,  1313,  1313,  1313,  1313,  1313,  1313,
    1313,  1313,  1313,  1313,  1313,  1313,  1313,  1313,  1313,  1314,
    1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,
    1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,
    1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,
    1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,
    1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,
    1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,
    1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,  1314,
    1314,  1314,  1314,  1314,  1314,  1314,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,  1315,
    1315,  1315,  1315
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     2,     2,     2,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     5,     1,
       1,     0,     2,     0,     2,     0,     2,     2,     3,     3,
       1,     3,     3,     2,     1,     1,     2,     2,     2,     3,
       3,     5,     5,     5,     0,     3,     5,     5,     5,     5,
       3,     5,     3,     5,     3,     5,     5,     6,     1,     1,
       6,     4,     9,     7,     1,     0,     2,     0,     1,     1,
       1,     1,     1,     1,     2,     3,     3,     2,     5,     1,
       3,     3,     3,     3,     1,     3,     3,     2,     2,     2,
       2,     3,     3,     3,     3,     1,     3,     1,     3,     1,
       1,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     3,     5,     1,     1,     1,     1,     1,     0,     1,
       1,     2,     1,     2,     3,     2,     1,     1,     2,     1,
       2,     1,     2,     3,     4,     3,     2,     4,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     2,     4,     6,
       4,     6,    10,    13,     4,     6,     4,    10,    13,     4,
       6,     4,     6,     5,     7,    11,    14,     5,     7,     1,
       3,     4,     4,     4,     3,     2,     5,     3,     6,     4,
       6,     6,     5,     7,     6,     6,     5,     5,     6,     5,
       9,     4,     5,     7,     6,     4,     8,     4,     2,     4,
       3,     6,     4,     3,     3,     3,     2,     2,     3,     4,
       4,     3,     3,     3,     3,     3,     3,     4,     4,     3,
       2,     3,     2,     2,     3,     4,     3,     2,     2,     3,
       4,     4,     4,     5,     1,     3,     2,     1,     1,     0,
       2,     0,     2,     0,     1,     1,     1,     3,     3,     2,
       0,     1,     3,     3,     1,     5,     3,     1,     2,     1,
       3,     2,     3,     6,     6,    10,     1,     2,     1,     3,
       4,     1,     3,     4,     6,     4,     8,     2,     2,    11,
       9,     1,     1,     1,     0,     1,     1,     1,     1,     3,
       2,     0,     1,     1,     3,     3,     1,     1,     3,     3,
       3,     3,     4,     3,     2,     1,     0,     3,     0,     1,
       0,     1,     3,     2,     1,     1,     1,     3,     0,     1,
       3,     1,    13,    16,    12,    15,    14,    17,     1,     1,
       2,     2,     2,     2,     1,     0,     1,     0,     3,     0,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     5,
       2,     4,     2,     2,     1,     0,     2,     0,     3,     1,
       1,     2,     2,     1,     4,     4,     5,     2,     5,     7,
       5,     2,     3,     0,     1,     2,     1,     2,     2,     2,
       3,     3,     3,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     5,     9,     3,     9,
       4,    10,    11,     2,     0,     3,     0,     1,     3,     1,
       4,     0,     2,     2,     2,     0,     1,     3,     3,     6,
       4,     0,     1,     1,     2,     2,     0,     3,     3,     2,
       1,     1,     3,     3,     4,     0,     1,     0,     6,     1,
       3,     3,     3,     5,     2,     0,     2,     2,     0,     3,
       4,     4,     0,     2,     0,     4,     0,     3,     8,    11,
       1,     3,     1,     1,     3,     6,     8,     7,    10,     6,
       2,     3,     0,     8,    11,     5,     1,     0,     6,     5,
       8,     4,     6,     1,     0,     3,     0,     1,     2,     2,
       2,     1,     2,     3,     2,     2,     2,     2,     3,     3,
       3,     1,     3,     1,     0,     1,     2,     2,     1,     1,
       3,     6,    10,     1,     0,     1,     2,     2,     0,     2,
       2,     1,     0,     1,     0,     7,     2,     0,     3,     5,
       5,     8,     2,     0,     2,     2,     2,     1,     5,     2,
       0,     2,     6,     6,     6,    10,     6,     6,     6,     9,
       9,     6,     6,     9,     6,     7,     2,     2,     2,     2,
       1,     2,     1,     0,     7,     6,     4,     0,     1,     3,
       4,     1,     3,     1,     2,     2,     2,     2,     1,     1,
      10,    13,     2,     0,     2,     2,     1,     0,     5,     4,
       4,    11,    14,    12,    15,    11,     2,     1,     4,     0,
       8,    11,     1,     1,     7,     9,     8,    10,     8,     4,
       0,     5,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     1,     1,     1,     1,     1,     8,     1,     1,    17,
      21,     1,     1,     2,     1,     3,     1,     1,     1,     3,
       1,     2,     0,     1,     2,     4,     1,     1,     1,     1,
       1,     3,     0,     1,     0,     1,     1,     4,     0,     1,
       1,     1,     3,     0,     1,     1,     1,     1,     2,     0,
       0,     2,     2,     1,     2,     2,     2,     2,    11,    13,
       1,     3,     5,     1,     3,     5,     1,     2,     2,     1,
       8,     6,     5,     4,     4,     3,     7,     8,     6,     6,
       6,     6,     6,     4,     7,     5,     8,     3,     1,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       3,     3,     1,     0,     1,     3,     7,     9,     9,     8,
       3,     0,    13,     1,     3,     5,     5,     3,     6,     2,
       1,     0,     2,     0,     2,     4,     0,     1,     0,     6,
       8,     8,     1,     3,     5,     5,     7,     9,     7,     9,
       5,     6,     6,     4,     6,     4,     6,     8,     4,     6,
       4,     6,     5,     7,     1,     1,     1,     2,     1,     2,
       1,     1,     1,     3,     3,     3,     3,     1,     1,     1,
       1,     1,     2,     2,     1,     3,     2,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     2,     2,     3,     1,
       3,     5,     2,     2,     0,     6,     6,     6,     6,     6,
       6,     6,     6,     8,     9,     8,     6,     6,     9,     9,
       9,     7,    10,     1,     1,     8,     8,     8,     8,     8,
       8,     8,     9,     8,     8,     2,     0,     1,     1,     2,
       2,     1,     2,     3,     3,     3,     3,     4,     4,     3,
       3,     3,     4,     4,     3,     4,     4,     1,     1,     1,
       0,     8,     8,    11,     1,     1,     2,     4,     5,     1,
       3,     2,     2,     2,     2,     2,     1,     3,     1,     3,
       1,     2,     2,     4,     3,     2,     2,     2,     2,     2,
       2,     3,     2,     2,     2,     2,     5,     5,     5,     5,
       5,     1,     3,     1,     2,     3,     0,     6,     6,     9,
       3,     0,     3,     0,     5,     2,     0,     3,     3,     3,
       7,     7,    10,     1,     1,     1,     1,     1,     1,    16,
      19,     1,     0,     1,     0,     1,     0,     2,     0,     1,
       3,     4,     5,     2,     2,     4,     4,     0,     1,     3,
       2,     0,     1,     0,     1,     1,     0,     2,     2,     0,
       9,    12,     7,     7,     2,     0,     3,     2,     1,     3,
       1,     3,     2,     1,     1,     2,     3,     2,     1,     3,
       3,     3,     2,     2,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     4,     5,     1,     3,     3,     1,     3,
       3,     5,     6,     1,     3,     2,     1,     3,     1,     0,
       1,     2,     4,     5,     1,     1,     1,     1,     3,     3,
       2,     2,     1,     2,     2,     2,     2,     1,     2,     2,
       2,     2,     1,     1,     1,     3,     2,     1,     4,     0,
       3,     0,     1,     1,     3,     5,     2,     0,     2,     1,
       3,     5,     5,     5,     1,     2,     1,     0,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     3,     5,
       5,     5,     1,     3,     1,     3,     2,     2,     1,     2,
       1,     2,    11,    10,    10,     2,     2,     0,     9,     2,
       0,    10,    11,    11,     5,     5,     8,     4,     4,     7,
       7,     1,     1,     1,     1,     1,     5,     5,     6,     6,
       6,     6,     6,     8,     8,     6,     6,     7,     9,     9,
       8,    10,     6,     6,     6,     6,     6,     6,     6,     8,
       6,     8,     6,     8,     7,     9,     6,     8,     7,     9,
       8,    10,     8,    10,     9,    11,     8,    10,     9,    11,
       8,     8,     7,     6,     6,     6,     6,     8,     8,     8,
       8,     6,     9,     1,     0,     2,     0,     8,     8,     8,
      10,     9,     8,     1,     0,     6,     6,     6,     6,     6,
       6,     6,     9,     9,     6,     6,     6,     8,     6,     8,
       8,     8,     8,     6,     8,     6,     8,     7,     9,     7,
       9,     6,     7,     1,     3,     3,     3,     1,     1,     1,
       1,     1,     7,     6,     6,     6,     6,     6,     6,     7,
       7,     6,     9,     9,     6,     6,     6,     6,     6,     6,
       8,     8,     8,     6,     7,     6,     6,     4,     7,     6,
       4,     5,     5,     3,     4,     3,     1,     1,     3,     5,
       5,     5,     5,     8,     5,     5,     6,     7,     7,     7,
       4,     4,     5,     4,     6,    13,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     0,     3,     2,     0,     2,     2,
       2,     3,     3,     3,     3,     2,     3,     2,     5,     4,
       3,     3,     3,     3,     3,     1,     1,     0,     3,     2,
       2,     1,     2,     1,     3,     2,     1,     0,     2,     3,
       0,     9,    11,    12,    14,     3,     4,     4,     0,     2,
       5,     1,     0,     1,     2,     3,     3,     3,     1,     2,
       1,     1,     1,     1,     1,     1,     0,     5,     4,     6,
       6,     4,     3,     5,     7,     9,     1,     3,     1,     5,
       4,     4,     6,     4,     6,     6,     5,     7,     9,     6,
       1,     0,     6,    11,    11,    11,    13,     9,    11,     1,
       1,    10,     4,     6,     2,     5,     2,     0,     6,     5,
       3,     5,     1,     3,     1,     1,     2,     1,     1,     1,
       1,     0,     1,     0,     1,     0,     1,     0,     1,     0,
       3,     0,     2,     1,     3,     1,     0,     2,     4,     3,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     5,     3,     0,     1,     1,     1,     1,     1,     3,
       9,    12,     3,     0,     2,     3,     2,     3,     7,     1,
       3,     1,     4,     4,     7,     2,     1,     1,     1,     3,
       2,     8,     5,     0,     4,     3,     0,     2,     0,     7,
       2,     0,     5,     3,     0,     2,     2,     2,     3,     1,
       3,     1,     2,     1,     0,     1,     2,     0,     8,     1,
       3,     3,     5,     2,     1,     3,     9,     1,     2,     5,
       5,     6,     6,     7,     2,     0,     3,     1,     2,     5,
       5,     8,     3,     4,     7,     1,     0,     3,     2,     2,
       2,     2,     0,     2,     2,     1,     1,     3,     3,     1,
       2,     4,     4,     2,     3,     5,     5,     1,     1,     9,
       9,     1,     2,     4,     4,     4,     2,     2,     3,     1,
       3,     9,     1,     2,     0,     7,     7,     0,    10,     6,
       0,     1,     0,     2,     0,     3,     3,     4,     4,     4,
       4,     3,     2,     1,     1,     0,     1,     1,     0,     1,
       5,     1,     0,     1,     1,     1,     0,     3,     1,     3,
       4,     3,     2,     2,     1,     1,     1,     0,     2,     4,
       5,     6,     4,     5,     2,     3,     1,     1,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     4,     0,
       1,     3,     1,     1,     1,     1,     1,     2,     4,     4,
       5,     2,     0,     1,     3,     1,     0,     1,     2,     3,
       2,     4,     2,     3,     2,     0,     4,     5,     2,     0,
       1,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       1,     4,     2,     3,     3,     4,     5,     4,     5,     4,
       5,     2,     4,     1,     1,     0,     2,     0,     1,     4,
       5,     4,     0,     2,     2,     2,     1,     1,     0,     5,
       2,     1,     1,     2,     2,     4,     1,     3,     1,     2,
       3,     6,     4,     0,     2,     6,     2,     1,     3,     4,
       0,     2,     0,     2,     0,     2,     4,     0,     1,     0,
       1,     3,     3,     7,    12,     1,     3,     2,     3,     3,
       1,     2,     2,     2,     2,     1,     2,     1,     3,     3,
       2,     2,     3,     5,     6,     2,     3,     3,     4,     0,
       1,     1,     1,     1,     1,     2,     4,     1,     1,     1,
       1,     1,     1,     2,     3,     3,     0,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     2,     1,     3,     0,
       1,     1,     1,     1,     5,     2,     1,     1,     1,     1,
       4,     1,     2,     2,     1,     3,     3,     2,     1,     0,
       5,     2,     5,     2,     1,     3,     3,     0,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     0,     1,     4,     1,     1,     3,     3,     5,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     3,     2,     2,     3,
       5,     4,     6,     3,     5,     4,     6,     4,     6,     5,
       7,     3,     2,     4,     2,     3,     3,     4,     3,     4,
       3,     4,     5,     6,     6,     7,     6,     7,     3,     4,
       4,     6,     3,     3,     4,     3,     4,     4,     5,     4,
       5,     1,     1,     3,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       5,     6,     3,     4,     1,     2,     2,     2,     2,     2,
       2,     0,     1,     2,     1,     1,     2,     4,     1,     1,
       1,     2,     2,     2,     2,     1,     1,     4,     3,     5,
       6,     8,     6,     6,     4,     4,     3,     1,     1,     1,
       1,     5,     1,     1,     4,     1,     4,     1,     4,     1,
       4,     1,     1,     1,     1,     1,     1,     6,     4,     4,
       6,     4,     4,     4,     4,     4,     6,     5,     5,     5,
       4,     6,     4,     4,     4,     4,     5,     7,     7,     9,
       5,     4,     6,     5,     7,     7,     7,     1,     2,     3,
       3,     3,     4,     0,     4,     1,     3,     3,     1,     1,
       1,     2,     2,     0,     2,     3,     3,     4,     2,     2,
       5,     0,     5,     0,     2,     0,     1,     3,     3,     2,
       2,     0,     6,     1,     0,     3,     0,     3,     3,     3,
       0,     1,     4,     2,     2,     2,     2,     2,     3,     2,
       2,     3,     0,     4,     3,     5,     4,     3,     5,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     1,     4,
       1,     4,     1,     2,     1,     2,     1,     3,     1,     3,
       1,     3,     3,     1,     0,     1,     3,     3,     3,     2,
       1,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     7,     5,     3,     5,     5,
       3,     3,     5,     3,     2,     1,     1,     3,     5,     1,
       2,     4,     2,     0,     1,     0,     1,     2,     2,     2,
       3,     5,     1,     0,     1,     2,     0,     2,     1,     0,
       1,     1,     1,     1,     1,     1,     1,     6,     5,     5,
       6,     5,     1,     1,     2,     0,     1,     2,     0,     1,
       3,     3,     2,     2,     0,     2,     2,     0,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     2,     2,     1,
       1,     1,     3,     6,     3,     0,     8,     2,     0,     2,
       3,     1,     0,     1,     1,     0,     3,     0,     1,     1,
       3,     0,     1,     1,     1,     1,     1,     3,     6,     3,
       0,     7,     4,     1,     3,     1,     1,     1,     1,     1,
       3,     6,     5,     1,     1,     3,     0,     2,     0,     8,
       5,     1,     0,     1,     1,     0,     4,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     1,     3,     3,     3,
       3,     1,     3,     5,     1,     3,     1,     3,     1,     1,
       1,     1,     2,     0,     3,     0,     6,     3,     0,     1,
       1,     1,     1,     1,     1,     4,     1,     1,     1,     2,
       3,     0,     1,     3,     3,     3,     3,     3,     0,     6,
       5,     4,     1,     3,     3,     3,     0,     1,     1,     7,
       7,     3,     0,     1,     0,     1,     3,     3,     2,     1,
       1,     1,     3,     1,     2,     1,     3,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     2,     6,     2,
       3,     5,     1,     1,     1,     1,     1,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     3,    10,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  YY_USE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule, core_yyscan_t yyscanner)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]), yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  YY_USE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* parse_toplevel: stmtmulti  */
#line 975 "gram.y"
                        {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
			}
#line 30083 "gram.c"
    break;

  case 3: /* parse_toplevel: MODE_TYPE_NAME Typename  */
#line 979 "gram.y"
                        {
				pg_yyget_extra(yyscanner)->parsetree = list_make1((yyvsp[0].typnam));
			}
#line 30091 "gram.c"
    break;

  case 4: /* parse_toplevel: MODE_PLPGSQL_EXPR PLpgSQL_Expr  */
#line 983 "gram.y"
                        {
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((yyvsp[0].node), 0));
			}
#line 30100 "gram.c"
    break;

  case 5: /* parse_toplevel: MODE_PLPGSQL_ASSIGN1 PLAssignStmt  */
#line 988 "gram.y"
                        {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 1;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 30112 "gram.c"
    break;

  case 6: /* parse_toplevel: MODE_PLPGSQL_ASSIGN2 PLAssignStmt  */
#line 996 "gram.y"
                        {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 2;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 30124 "gram.c"
    break;

  case 7: /* parse_toplevel: MODE_PLPGSQL_ASSIGN3 PLAssignStmt  */
#line 1004 "gram.y"
                        {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 3;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 30136 "gram.c"
    break;

  case 8: /* stmtmulti: stmtmulti ';' toplevel_stmt  */
#line 1024 "gram.y"
                                {
					if ((yyvsp[-2].list) != NIL)
					{
						/* update length of previous stmt */
						updateRawStmtEnd(llast_node(RawStmt, (yyvsp[-2].list)), (yylsp[-1]));
					}
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), makeRawStmt((yyvsp[0].node), (yylsp[-1]) + 1));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 30152 "gram.c"
    break;

  case 9: /* stmtmulti: toplevel_stmt  */
#line 1036 "gram.y"
                                {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1(makeRawStmt((yyvsp[0].node), 0));
					else
						(yyval.list) = NIL;
				}
#line 30163 "gram.c"
    break;

  case 136: /* stmt: %empty  */
#line 1179 "gram.y"
                                { (yyval.node) = NULL; }
#line 30169 "gram.c"
    break;

  case 137: /* CallStmt: CALL func_application  */
#line 1189 "gram.y"
                                {
					CallStmt   *n = makeNode(CallStmt);

					n->funccall = castNode(FuncCall, (yyvsp[0].node));
					(yyval.node) = (Node *) n;
				}
#line 30180 "gram.c"
    break;

  case 138: /* CreateRoleStmt: CREATE ROLE RoleId opt_with OptRoleList  */
#line 1205 "gram.y"
                                {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30193 "gram.c"
    break;

  case 142: /* OptRoleList: OptRoleList CreateOptRoleElem  */
#line 1227 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30199 "gram.c"
    break;

  case 143: /* OptRoleList: %empty  */
#line 1228 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 30205 "gram.c"
    break;

  case 144: /* AlterOptRoleList: AlterOptRoleList AlterOptRoleElem  */
#line 1232 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30211 "gram.c"
    break;

  case 145: /* AlterOptRoleList: %empty  */
#line 1233 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 30217 "gram.c"
    break;

  case 146: /* AlterOptRoleElem: PASSWORD Sconst  */
#line 1238 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 30226 "gram.c"
    break;

  case 147: /* AlterOptRoleElem: PASSWORD NULL_P  */
#line 1243 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("password", NULL, (yylsp[-1]));
				}
#line 30234 "gram.c"
    break;

  case 148: /* AlterOptRoleElem: ENCRYPTED PASSWORD Sconst  */
#line 1247 "gram.y"
                                {
					/*
					 * These days, passwords are always stored in encrypted
					 * form, so there is no difference between PASSWORD and
					 * ENCRYPTED PASSWORD.
					 */
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 30248 "gram.c"
    break;

  case 149: /* AlterOptRoleElem: UNENCRYPTED PASSWORD Sconst  */
#line 1257 "gram.y"
                                {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNENCRYPTED PASSWORD is no longer supported"),
							 errhint("Remove UNENCRYPTED to store the password in encrypted form instead."),
							 parser_errposition((yylsp[-2]))));
				}
#line 30260 "gram.c"
    break;

  case 150: /* AlterOptRoleElem: INHERIT  */
#line 1265 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 30268 "gram.c"
    break;

  case 151: /* AlterOptRoleElem: CONNECTION LIMIT SignedIconst  */
#line 1269 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 30276 "gram.c"
    break;

  case 152: /* AlterOptRoleElem: VALID UNTIL Sconst  */
#line 1273 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("validUntil", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 30284 "gram.c"
    break;

  case 153: /* AlterOptRoleElem: USER role_list  */
#line 1278 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 30292 "gram.c"
    break;

  case 154: /* AlterOptRoleElem: IDENT  */
#line 1282 "gram.y"
                                {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(false), (yylsp[0]));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 30341 "gram.c"
    break;

  case 155: /* CreateOptRoleElem: AlterOptRoleElem  */
#line 1329 "gram.y"
                                                                { (yyval.defelt) = (yyvsp[0].defelt); }
#line 30347 "gram.c"
    break;

  case 156: /* CreateOptRoleElem: SYSID Iconst  */
#line 1332 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("sysid", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
				}
#line 30355 "gram.c"
    break;

  case 157: /* CreateOptRoleElem: ADMIN role_list  */
#line 1336 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 30363 "gram.c"
    break;

  case 158: /* CreateOptRoleElem: ROLE role_list  */
#line 1340 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 30371 "gram.c"
    break;

  case 159: /* CreateOptRoleElem: IN_P ROLE role_list  */
#line 1344 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 30379 "gram.c"
    break;

  case 160: /* CreateOptRoleElem: IN_P GROUP_P role_list  */
#line 1348 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 30387 "gram.c"
    break;

  case 161: /* CreateUserStmt: CREATE USER RoleId opt_with OptRoleList  */
#line 1362 "gram.y"
                                {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30400 "gram.c"
    break;

  case 162: /* AlterRoleStmt: ALTER ROLE RoleSpec opt_with AlterOptRoleList  */
#line 1381 "gram.y"
                                 {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 30413 "gram.c"
    break;

  case 163: /* AlterRoleStmt: ALTER USER RoleSpec opt_with AlterOptRoleList  */
#line 1390 "gram.y"
                                 {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 30426 "gram.c"
    break;

  case 164: /* opt_in_database: %empty  */
#line 1401 "gram.y"
                                                                        { (yyval.str) = NULL; }
#line 30432 "gram.c"
    break;

  case 165: /* opt_in_database: IN_P DATABASE name  */
#line 1402 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 30438 "gram.c"
    break;

  case 166: /* AlterRoleSetStmt: ALTER ROLE RoleSpec opt_in_database SetResetClause  */
#line 1407 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 30451 "gram.c"
    break;

  case 167: /* AlterRoleSetStmt: ALTER ROLE ALL opt_in_database SetResetClause  */
#line 1416 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 30464 "gram.c"
    break;

  case 168: /* AlterRoleSetStmt: ALTER USER RoleSpec opt_in_database SetResetClause  */
#line 1425 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 30477 "gram.c"
    break;

  case 169: /* AlterRoleSetStmt: ALTER USER ALL opt_in_database SetResetClause  */
#line 1434 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 30490 "gram.c"
    break;

  case 170: /* DropRoleStmt: DROP ROLE role_list  */
#line 1456 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30502 "gram.c"
    break;

  case 171: /* DropRoleStmt: DROP ROLE IF_P EXISTS role_list  */
#line 1464 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30514 "gram.c"
    break;

  case 172: /* DropRoleStmt: DROP USER role_list  */
#line 1472 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30526 "gram.c"
    break;

  case 173: /* DropRoleStmt: DROP USER IF_P EXISTS role_list  */
#line 1480 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->roles = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30538 "gram.c"
    break;

  case 174: /* DropRoleStmt: DROP GROUP_P role_list  */
#line 1488 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30550 "gram.c"
    break;

  case 175: /* DropRoleStmt: DROP GROUP_P IF_P EXISTS role_list  */
#line 1496 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30562 "gram.c"
    break;

  case 176: /* CreateGroupStmt: CREATE GROUP_P RoleId opt_with OptRoleList  */
#line 1514 "gram.y"
                                {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30575 "gram.c"
    break;

  case 177: /* AlterGroupStmt: ALTER GROUP_P RoleSpec add_drop USER role_list  */
#line 1533 "gram.y"
                                {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-3].rolespec);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 30589 "gram.c"
    break;

  case 178: /* add_drop: ADD_P  */
#line 1544 "gram.y"
                                                                                        { (yyval.ival) = +1; }
#line 30595 "gram.c"
    break;

  case 179: /* add_drop: DROP  */
#line 1545 "gram.y"
                                                                                                { (yyval.ival) = -1; }
#line 30601 "gram.c"
    break;

  case 180: /* CreateSchemaStmt: CREATE SCHEMA OptSchemaName AUTHORIZATION RoleSpec OptSchemaEltList  */
#line 1557 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 30616 "gram.c"
    break;

  case 181: /* CreateSchemaStmt: CREATE SCHEMA ColId OptSchemaEltList  */
#line 1568 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 30631 "gram.c"
    break;

  case 182: /* CreateSchemaStmt: CREATE SCHEMA IF_P NOT EXISTS OptSchemaName AUTHORIZATION RoleSpec OptSchemaEltList  */
#line 1579 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 30651 "gram.c"
    break;

  case 183: /* CreateSchemaStmt: CREATE SCHEMA IF_P NOT EXISTS ColId OptSchemaEltList  */
#line 1595 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 30671 "gram.c"
    break;

  case 184: /* OptSchemaName: ColId  */
#line 1613 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 30677 "gram.c"
    break;

  case 185: /* OptSchemaName: %empty  */
#line 1614 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 30683 "gram.c"
    break;

  case 186: /* OptSchemaEltList: OptSchemaEltList schema_stmt  */
#line 1619 "gram.y"
                                {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 30693 "gram.c"
    break;

  case 187: /* OptSchemaEltList: %empty  */
#line 1625 "gram.y"
                                { (yyval.list) = NIL; }
#line 30699 "gram.c"
    break;

  case 194: /* VariableSetStmt: SET set_rest  */
#line 1653 "gram.y"
                                {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 30710 "gram.c"
    break;

  case 195: /* VariableSetStmt: SET LOCAL set_rest  */
#line 1660 "gram.y"
                                {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 30721 "gram.c"
    break;

  case 196: /* VariableSetStmt: SET SESSION set_rest  */
#line 1667 "gram.y"
                                {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 30732 "gram.c"
    break;

  case 197: /* set_rest: TRANSACTION transaction_mode_list  */
#line 1677 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 30745 "gram.c"
    break;

  case 198: /* set_rest: SESSION CHARACTERISTICS AS TRANSACTION transaction_mode_list  */
#line 1686 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 30758 "gram.c"
    break;

  case 200: /* generic_set: var_name TO var_list  */
#line 1699 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 30771 "gram.c"
    break;

  case 201: /* generic_set: var_name '=' var_list  */
#line 1708 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 30784 "gram.c"
    break;

  case 202: /* generic_set: var_name TO DEFAULT  */
#line 1717 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 30796 "gram.c"
    break;

  case 203: /* generic_set: var_name '=' DEFAULT  */
#line 1725 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 30808 "gram.c"
    break;

  case 204: /* set_rest_more: generic_set  */
#line 1735 "gram.y"
                                                                                        {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 30814 "gram.c"
    break;

  case 205: /* set_rest_more: var_name FROM CURRENT_P  */
#line 1737 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 30826 "gram.c"
    break;

  case 206: /* set_rest_more: TIME ZONE zone_value  */
#line 1746 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 30842 "gram.c"
    break;

  case 207: /* set_rest_more: CATALOG_P Sconst  */
#line 1758 "gram.y"
                                {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 30854 "gram.c"
    break;

  case 208: /* set_rest_more: SCHEMA Sconst  */
#line 1766 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 30867 "gram.c"
    break;

  case 209: /* set_rest_more: NAMES opt_encoding  */
#line 1775 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 30883 "gram.c"
    break;

  case 210: /* set_rest_more: ROLE NonReservedWord_or_Sconst  */
#line 1787 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 30896 "gram.c"
    break;

  case 211: /* set_rest_more: SESSION AUTHORIZATION NonReservedWord_or_Sconst  */
#line 1796 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 30909 "gram.c"
    break;

  case 212: /* set_rest_more: SESSION AUTHORIZATION DEFAULT  */
#line 1805 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 30921 "gram.c"
    break;

  case 213: /* set_rest_more: XML_P OPTION document_or_content  */
#line 1813 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 30934 "gram.c"
    break;

  case 214: /* set_rest_more: TRANSACTION SNAPSHOT Sconst  */
#line 1823 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 30947 "gram.c"
    break;

  case 215: /* var_name: ColId  */
#line 1833 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 30953 "gram.c"
    break;

  case 216: /* var_name: var_name '.' ColId  */
#line 1835 "gram.y"
                                { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 30959 "gram.c"
    break;

  case 217: /* var_list: var_value  */
#line 1838 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30965 "gram.c"
    break;

  case 218: /* var_list: var_list ',' var_value  */
#line 1839 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30971 "gram.c"
    break;

  case 219: /* var_value: opt_boolean_or_string  */
#line 1843 "gram.y"
                                { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 30977 "gram.c"
    break;

  case 220: /* var_value: NumericOnly  */
#line 1845 "gram.y"
                                { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 30983 "gram.c"
    break;

  case 221: /* iso_level: READ UNCOMMITTED  */
#line 1848 "gram.y"
                                                                                { (yyval.str) = "read uncommitted"; }
#line 30989 "gram.c"
    break;

  case 222: /* iso_level: READ COMMITTED  */
#line 1849 "gram.y"
                                                                                        { (yyval.str) = "read committed"; }
#line 30995 "gram.c"
    break;

  case 223: /* iso_level: REPEATABLE READ  */
#line 1850 "gram.y"
                                                                                        { (yyval.str) = "repeatable read"; }
#line 31001 "gram.c"
    break;

  case 224: /* iso_level: SERIALIZABLE  */
#line 1851 "gram.y"
                                                                                        { (yyval.str) = "serializable"; }
#line 31007 "gram.c"
    break;

  case 225: /* opt_boolean_or_string: TRUE_P  */
#line 1855 "gram.y"
                                                                                                { (yyval.str) = "true"; }
#line 31013 "gram.c"
    break;

  case 226: /* opt_boolean_or_string: FALSE_P  */
#line 1856 "gram.y"
                                                                                                { (yyval.str) = "false"; }
#line 31019 "gram.c"
    break;

  case 227: /* opt_boolean_or_string: ON  */
#line 1857 "gram.y"
                                                                                                { (yyval.str) = "on"; }
#line 31025 "gram.c"
    break;

  case 228: /* opt_boolean_or_string: NonReservedWord_or_Sconst  */
#line 1863 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 31031 "gram.c"
    break;

  case 229: /* zone_value: Sconst  */
#line 1876 "gram.y"
                                {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 31039 "gram.c"
    break;

  case 230: /* zone_value: IDENT  */
#line 1880 "gram.y"
                                {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 31047 "gram.c"
    break;

  case 231: /* zone_value: ConstInterval Sconst opt_interval  */
#line 1884 "gram.y"
                                {
					TypeName   *t = (yyvsp[-2].typnam);

					if ((yyvsp[0].list) != NIL)
					{
						A_Const	   *n = (A_Const *) linitial((yyvsp[0].list));

						if ((n->val.ival.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 31068 "gram.c"
    break;

  case 232: /* zone_value: ConstInterval '(' Iconst ')' Sconst  */
#line 1901 "gram.y"
                                {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 31080 "gram.c"
    break;

  case 233: /* zone_value: NumericOnly  */
#line 1908 "gram.y"
                                                                                        { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 31086 "gram.c"
    break;

  case 234: /* zone_value: DEFAULT  */
#line 1909 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 31092 "gram.c"
    break;

  case 235: /* zone_value: LOCAL  */
#line 1910 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 31098 "gram.c"
    break;

  case 236: /* opt_encoding: Sconst  */
#line 1914 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 31104 "gram.c"
    break;

  case 237: /* opt_encoding: DEFAULT  */
#line 1915 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 31110 "gram.c"
    break;

  case 238: /* opt_encoding: %empty  */
#line 1916 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 31116 "gram.c"
    break;

  case 239: /* NonReservedWord_or_Sconst: NonReservedWord  */
#line 1920 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 31122 "gram.c"
    break;

  case 240: /* NonReservedWord_or_Sconst: Sconst  */
#line 1921 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 31128 "gram.c"
    break;

  case 241: /* VariableResetStmt: RESET reset_rest  */
#line 1925 "gram.y"
                                                                                        { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 31134 "gram.c"
    break;

  case 242: /* reset_rest: generic_reset  */
#line 1929 "gram.y"
                                                                                        { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 31140 "gram.c"
    break;

  case 243: /* reset_rest: TIME ZONE  */
#line 1931 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 31152 "gram.c"
    break;

  case 244: /* reset_rest: TRANSACTION ISOLATION LEVEL  */
#line 1939 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 31164 "gram.c"
    break;

  case 245: /* reset_rest: SESSION AUTHORIZATION  */
#line 1947 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 31176 "gram.c"
    break;

  case 246: /* generic_reset: var_name  */
#line 1958 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 31188 "gram.c"
    break;

  case 247: /* generic_reset: ALL  */
#line 1966 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 31199 "gram.c"
    break;

  case 248: /* SetResetClause: SET set_rest  */
#line 1976 "gram.y"
                                                                        { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 31205 "gram.c"
    break;

  case 249: /* SetResetClause: VariableResetStmt  */
#line 1977 "gram.y"
                                                                        { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 31211 "gram.c"
    break;

  case 250: /* FunctionSetResetClause: SET set_rest_more  */
#line 1982 "gram.y"
                                                                        { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 31217 "gram.c"
    break;

  case 251: /* FunctionSetResetClause: VariableResetStmt  */
#line 1983 "gram.y"
                                                                        { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 31223 "gram.c"
    break;

  case 252: /* VariableShowStmt: SHOW var_name  */
#line 1989 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31234 "gram.c"
    break;

  case 253: /* VariableShowStmt: SHOW TIME ZONE  */
#line 1996 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 31245 "gram.c"
    break;

  case 254: /* VariableShowStmt: SHOW TRANSACTION ISOLATION LEVEL  */
#line 2003 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 31256 "gram.c"
    break;

  case 255: /* VariableShowStmt: SHOW SESSION AUTHORIZATION  */
#line 2010 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 31267 "gram.c"
    break;

  case 256: /* VariableShowStmt: SHOW ALL  */
#line 2017 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 31278 "gram.c"
    break;

  case 257: /* ConstraintsSetStmt: SET CONSTRAINTS constraints_set_list constraints_set_mode  */
#line 2028 "gram.y"
                                {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);

					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 31290 "gram.c"
    break;

  case 258: /* constraints_set_list: ALL  */
#line 2038 "gram.y"
                                                                                                        { (yyval.list) = NIL; }
#line 31296 "gram.c"
    break;

  case 259: /* constraints_set_list: qualified_name_list  */
#line 2039 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 31302 "gram.c"
    break;

  case 260: /* constraints_set_mode: DEFERRED  */
#line 2043 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 31308 "gram.c"
    break;

  case 261: /* constraints_set_mode: IMMEDIATE  */
#line 2044 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 31314 "gram.c"
    break;

  case 262: /* CheckPointStmt: CHECKPOINT  */
#line 2053 "gram.y"
                                {
					CheckPointStmt *n = makeNode(CheckPointStmt);

					(yyval.node) = (Node *) n;
				}
#line 31324 "gram.c"
    break;

  case 263: /* DiscardStmt: DISCARD ALL  */
#line 2069 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 31335 "gram.c"
    break;

  case 264: /* DiscardStmt: DISCARD TEMP  */
#line 2076 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 31346 "gram.c"
    break;

  case 265: /* DiscardStmt: DISCARD TEMPORARY  */
#line 2083 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 31357 "gram.c"
    break;

  case 266: /* DiscardStmt: DISCARD PLANS  */
#line 2090 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 31368 "gram.c"
    break;

  case 267: /* DiscardStmt: DISCARD SEQUENCES  */
#line 2097 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 31379 "gram.c"
    break;

  case 268: /* AlterTableStmt: ALTER TABLE relation_expr alter_table_cmds  */
#line 2117 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31393 "gram.c"
    break;

  case 269: /* AlterTableStmt: ALTER TABLE IF_P EXISTS relation_expr alter_table_cmds  */
#line 2127 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31407 "gram.c"
    break;

  case 270: /* AlterTableStmt: ALTER TABLE relation_expr partition_cmd  */
#line 2137 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31421 "gram.c"
    break;

  case 271: /* AlterTableStmt: ALTER TABLE IF_P EXISTS relation_expr partition_cmd  */
#line 2147 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31435 "gram.c"
    break;

  case 272: /* AlterTableStmt: ALTER TABLE ALL IN_P TABLESPACE name SET TABLESPACE name opt_nowait  */
#line 2157 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 31451 "gram.c"
    break;

  case 273: /* AlterTableStmt: ALTER TABLE ALL IN_P TABLESPACE name OWNED BY role_list SET TABLESPACE name opt_nowait  */
#line 2169 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 31467 "gram.c"
    break;

  case 274: /* AlterTableStmt: ALTER INDEX qualified_name alter_table_cmds  */
#line 2181 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31481 "gram.c"
    break;

  case 275: /* AlterTableStmt: ALTER INDEX IF_P EXISTS qualified_name alter_table_cmds  */
#line 2191 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31495 "gram.c"
    break;

  case 276: /* AlterTableStmt: ALTER INDEX qualified_name index_partition_cmd  */
#line 2201 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31509 "gram.c"
    break;

  case 277: /* AlterTableStmt: ALTER INDEX ALL IN_P TABLESPACE name SET TABLESPACE name opt_nowait  */
#line 2211 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 31525 "gram.c"
    break;

  case 278: /* AlterTableStmt: ALTER INDEX ALL IN_P TABLESPACE name OWNED BY role_list SET TABLESPACE name opt_nowait  */
#line 2223 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 31541 "gram.c"
    break;

  case 279: /* AlterTableStmt: ALTER SEQUENCE qualified_name alter_table_cmds  */
#line 2235 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31555 "gram.c"
    break;

  case 280: /* AlterTableStmt: ALTER SEQUENCE IF_P EXISTS qualified_name alter_table_cmds  */
#line 2245 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31569 "gram.c"
    break;

  case 281: /* AlterTableStmt: ALTER VIEW qualified_name alter_table_cmds  */
#line 2255 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31583 "gram.c"
    break;

  case 282: /* AlterTableStmt: ALTER VIEW IF_P EXISTS qualified_name alter_table_cmds  */
#line 2265 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31597 "gram.c"
    break;

  case 283: /* AlterTableStmt: ALTER MATERIALIZED VIEW qualified_name alter_table_cmds  */
#line 2275 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31611 "gram.c"
    break;

  case 284: /* AlterTableStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name alter_table_cmds  */
#line 2285 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31625 "gram.c"
    break;

  case 285: /* AlterTableStmt: ALTER MATERIALIZED VIEW ALL IN_P TABLESPACE name SET TABLESPACE name opt_nowait  */
#line 2295 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 31641 "gram.c"
    break;

  case 286: /* AlterTableStmt: ALTER MATERIALIZED VIEW ALL IN_P TABLESPACE name OWNED BY role_list SET TABLESPACE name opt_nowait  */
#line 2307 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 31657 "gram.c"
    break;

  case 287: /* AlterTableStmt: ALTER FOREIGN TABLE relation_expr alter_table_cmds  */
#line 2319 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31671 "gram.c"
    break;

  case 288: /* AlterTableStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr alter_table_cmds  */
#line 2329 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31685 "gram.c"
    break;

  case 289: /* alter_table_cmds: alter_table_cmd  */
#line 2341 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31691 "gram.c"
    break;

  case 290: /* alter_table_cmds: alter_table_cmds ',' alter_table_cmd  */
#line 2342 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31697 "gram.c"
    break;

  case 291: /* partition_cmd: ATTACH PARTITION qualified_name PartitionBoundSpec  */
#line 2348 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = (yyvsp[0].partboundspec);
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 31714 "gram.c"
    break;

  case 292: /* partition_cmd: DETACH PARTITION qualified_name opt_concurrently  */
#line 2362 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = (yyvsp[0].boolean);
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 31731 "gram.c"
    break;

  case 293: /* partition_cmd: DETACH PARTITION qualified_name FINALIZE  */
#line 2375 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartitionFinalize;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;
					(yyval.node) = (Node *) n;
				}
#line 31747 "gram.c"
    break;

  case 294: /* index_partition_cmd: ATTACH PARTITION qualified_name  */
#line 2391 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 31764 "gram.c"
    break;

  case 295: /* alter_table_cmd: ADD_P columnDef  */
#line 2408 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31777 "gram.c"
    break;

  case 296: /* alter_table_cmd: ADD_P IF_P NOT EXISTS columnDef  */
#line 2418 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31790 "gram.c"
    break;

  case 297: /* alter_table_cmd: ADD_P COLUMN columnDef  */
#line 2428 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31803 "gram.c"
    break;

  case 298: /* alter_table_cmd: ADD_P COLUMN IF_P NOT EXISTS columnDef  */
#line 2438 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31816 "gram.c"
    break;

  case 299: /* alter_table_cmd: ALTER opt_column ColId alter_column_default  */
#line 2448 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 31829 "gram.c"
    break;

  case 300: /* alter_table_cmd: ALTER opt_column ColId DROP NOT NULL_P  */
#line 2458 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 31841 "gram.c"
    break;

  case 301: /* alter_table_cmd: ALTER opt_column ColId SET NOT NULL_P  */
#line 2467 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 31853 "gram.c"
    break;

  case 302: /* alter_table_cmd: ALTER opt_column ColId DROP EXPRESSION  */
#line 2476 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-2].str);
					(yyval.node) = (Node *) n;
				}
#line 31865 "gram.c"
    break;

  case 303: /* alter_table_cmd: ALTER opt_column ColId DROP EXPRESSION IF_P EXISTS  */
#line 2485 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31878 "gram.c"
    break;

  case 304: /* alter_table_cmd: ALTER opt_column ColId SET STATISTICS SignedIconst  */
#line 2495 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *) n;
				}
#line 31891 "gram.c"
    break;

  case 305: /* alter_table_cmd: ALTER opt_column Iconst SET STATISTICS SignedIconst  */
#line 2505 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					if ((yyvsp[-3].ival) <= 0 || (yyvsp[-3].ival) > PG_INT16_MAX)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("column number must be in range from 1 to %d", PG_INT16_MAX),
								 parser_errposition((yylsp[-3]))));

					n->subtype = AT_SetStatistics;
					n->num = (int16) (yyvsp[-3].ival);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *) n;
				}
#line 31910 "gram.c"
    break;

  case 306: /* alter_table_cmd: ALTER opt_column ColId SET reloptions  */
#line 2521 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31923 "gram.c"
    break;

  case 307: /* alter_table_cmd: ALTER opt_column ColId RESET reloptions  */
#line 2531 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31936 "gram.c"
    break;

  case 308: /* alter_table_cmd: ALTER opt_column ColId SET STORAGE ColId  */
#line 2541 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 31949 "gram.c"
    break;

  case 309: /* alter_table_cmd: ALTER opt_column ColId SET column_compression  */
#line 2551 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetCompression;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 31962 "gram.c"
    break;

  case 310: /* alter_table_cmd: ALTER opt_column ColId ADD_P GENERATED generated_when AS IDENTITY_P OptParenthesizedSeqOptList  */
#line 2561 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					c->contype = CONSTR_IDENTITY;
					c->generated_when = (yyvsp[-3].ival);
					c->options = (yyvsp[0].list);
					c->location = (yylsp[-4]);

					n->subtype = AT_AddIdentity;
					n->name = (yyvsp[-6].str);
					n->def = (Node *) c;

					(yyval.node) = (Node *) n;
				}
#line 31982 "gram.c"
    break;

  case 311: /* alter_table_cmd: ALTER opt_column ColId alter_identity_column_option_list  */
#line 2578 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetIdentity;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31995 "gram.c"
    break;

  case 312: /* alter_table_cmd: ALTER opt_column ColId DROP IDENTITY_P  */
#line 2588 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-2].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32008 "gram.c"
    break;

  case 313: /* alter_table_cmd: ALTER opt_column ColId DROP IDENTITY_P IF_P EXISTS  */
#line 2598 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32021 "gram.c"
    break;

  case 314: /* alter_table_cmd: DROP opt_column IF_P EXISTS ColId opt_drop_behavior  */
#line 2608 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32035 "gram.c"
    break;

  case 315: /* alter_table_cmd: DROP opt_column ColId opt_drop_behavior  */
#line 2619 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32049 "gram.c"
    break;

  case 316: /* alter_table_cmd: ALTER opt_column ColId opt_set_data TYPE_P Typename opt_collate_clause alter_using  */
#line 2633 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 32068 "gram.c"
    break;

  case 317: /* alter_table_cmd: ALTER opt_column ColId alter_generic_options  */
#line 2649 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32081 "gram.c"
    break;

  case 318: /* alter_table_cmd: ADD_P TableConstraint  */
#line 2659 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32093 "gram.c"
    break;

  case 319: /* alter_table_cmd: ALTER CONSTRAINT name ConstraintAttributeSpec  */
#line 2668 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 32112 "gram.c"
    break;

  case 320: /* alter_table_cmd: VALIDATE CONSTRAINT name  */
#line 2684 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32124 "gram.c"
    break;

  case 321: /* alter_table_cmd: DROP CONSTRAINT IF_P EXISTS name opt_drop_behavior  */
#line 2693 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32138 "gram.c"
    break;

  case 322: /* alter_table_cmd: DROP CONSTRAINT name opt_drop_behavior  */
#line 2704 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32152 "gram.c"
    break;

  case 323: /* alter_table_cmd: SET WITHOUT OIDS  */
#line 2715 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOids;
					(yyval.node) = (Node *) n;
				}
#line 32163 "gram.c"
    break;

  case 324: /* alter_table_cmd: CLUSTER ON name  */
#line 2723 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32175 "gram.c"
    break;

  case 325: /* alter_table_cmd: SET WITHOUT CLUSTER  */
#line 2732 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 32187 "gram.c"
    break;

  case 326: /* alter_table_cmd: SET LOGGED  */
#line 2741 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *) n;
				}
#line 32198 "gram.c"
    break;

  case 327: /* alter_table_cmd: SET UNLOGGED  */
#line 2749 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *) n;
				}
#line 32209 "gram.c"
    break;

  case 328: /* alter_table_cmd: ENABLE_P TRIGGER name  */
#line 2757 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32221 "gram.c"
    break;

  case 329: /* alter_table_cmd: ENABLE_P ALWAYS TRIGGER name  */
#line 2766 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32233 "gram.c"
    break;

  case 330: /* alter_table_cmd: ENABLE_P REPLICA TRIGGER name  */
#line 2775 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32245 "gram.c"
    break;

  case 331: /* alter_table_cmd: ENABLE_P TRIGGER ALL  */
#line 2784 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 32256 "gram.c"
    break;

  case 332: /* alter_table_cmd: ENABLE_P TRIGGER USER  */
#line 2792 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 32267 "gram.c"
    break;

  case 333: /* alter_table_cmd: DISABLE_P TRIGGER name  */
#line 2800 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32279 "gram.c"
    break;

  case 334: /* alter_table_cmd: DISABLE_P TRIGGER ALL  */
#line 2809 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 32290 "gram.c"
    break;

  case 335: /* alter_table_cmd: DISABLE_P TRIGGER USER  */
#line 2817 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 32301 "gram.c"
    break;

  case 336: /* alter_table_cmd: ENABLE_P RULE name  */
#line 2825 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32313 "gram.c"
    break;

  case 337: /* alter_table_cmd: ENABLE_P ALWAYS RULE name  */
#line 2834 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32325 "gram.c"
    break;

  case 338: /* alter_table_cmd: ENABLE_P REPLICA RULE name  */
#line 2843 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32337 "gram.c"
    break;

  case 339: /* alter_table_cmd: DISABLE_P RULE name  */
#line 2852 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32349 "gram.c"
    break;

  case 340: /* alter_table_cmd: INHERIT qualified_name  */
#line 2861 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 32361 "gram.c"
    break;

  case 341: /* alter_table_cmd: NO INHERIT qualified_name  */
#line 2870 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 32373 "gram.c"
    break;

  case 342: /* alter_table_cmd: OF any_name  */
#line 2879 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName   *def = makeTypeNameFromNameList((yyvsp[0].list));

					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *) n;
				}
#line 32387 "gram.c"
    break;

  case 343: /* alter_table_cmd: NOT OF  */
#line 2890 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOf;
					(yyval.node) = (Node *) n;
				}
#line 32398 "gram.c"
    break;

  case 344: /* alter_table_cmd: OWNER TO RoleSpec  */
#line 2898 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 32410 "gram.c"
    break;

  case 345: /* alter_table_cmd: SET ACCESS METHOD name  */
#line 2907 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetAccessMethod;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32422 "gram.c"
    break;

  case 346: /* alter_table_cmd: SET TABLESPACE name  */
#line 2916 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32434 "gram.c"
    break;

  case 347: /* alter_table_cmd: SET reloptions  */
#line 2925 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32446 "gram.c"
    break;

  case 348: /* alter_table_cmd: RESET reloptions  */
#line 2934 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32458 "gram.c"
    break;

  case 349: /* alter_table_cmd: REPLICA IDENTITY_P replica_identity  */
#line 2943 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32470 "gram.c"
    break;

  case 350: /* alter_table_cmd: ENABLE_P ROW LEVEL SECURITY  */
#line 2952 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 32481 "gram.c"
    break;

  case 351: /* alter_table_cmd: DISABLE_P ROW LEVEL SECURITY  */
#line 2960 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 32492 "gram.c"
    break;

  case 352: /* alter_table_cmd: FORCE ROW LEVEL SECURITY  */
#line 2968 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 32503 "gram.c"
    break;

  case 353: /* alter_table_cmd: NO FORCE ROW LEVEL SECURITY  */
#line 2976 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 32514 "gram.c"
    break;

  case 354: /* alter_table_cmd: alter_generic_options  */
#line 2983 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_GenericOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32526 "gram.c"
    break;

  case 355: /* alter_column_default: SET DEFAULT a_expr  */
#line 2993 "gram.y"
                                                                { (yyval.node) = (yyvsp[0].node); }
#line 32532 "gram.c"
    break;

  case 356: /* alter_column_default: DROP DEFAULT  */
#line 2994 "gram.y"
                                                                { (yyval.node) = NULL; }
#line 32538 "gram.c"
    break;

  case 357: /* opt_drop_behavior: CASCADE  */
#line 2998 "gram.y"
                                                                        { (yyval.dbehavior) = DROP_CASCADE; }
#line 32544 "gram.c"
    break;

  case 358: /* opt_drop_behavior: RESTRICT  */
#line 2999 "gram.y"
                                                                        { (yyval.dbehavior) = DROP_RESTRICT; }
#line 32550 "gram.c"
    break;

  case 359: /* opt_drop_behavior: %empty  */
#line 3000 "gram.y"
                                                                { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 32556 "gram.c"
    break;

  case 360: /* opt_collate_clause: COLLATE any_name  */
#line 3005 "gram.y"
                                {
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32569 "gram.c"
    break;

  case 361: /* opt_collate_clause: %empty  */
#line 3013 "gram.y"
                                                                { (yyval.node) = NULL; }
#line 32575 "gram.c"
    break;

  case 362: /* alter_using: USING a_expr  */
#line 3017 "gram.y"
                                                                { (yyval.node) = (yyvsp[0].node); }
#line 32581 "gram.c"
    break;

  case 363: /* alter_using: %empty  */
#line 3018 "gram.y"
                                                                { (yyval.node) = NULL; }
#line 32587 "gram.c"
    break;

  case 364: /* replica_identity: NOTHING  */
#line 3023 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 32599 "gram.c"
    break;

  case 365: /* replica_identity: FULL  */
#line 3031 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 32611 "gram.c"
    break;

  case 366: /* replica_identity: DEFAULT  */
#line 3039 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 32623 "gram.c"
    break;

  case 367: /* replica_identity: USING INDEX name  */
#line 3047 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32635 "gram.c"
    break;

  case 368: /* reloptions: '(' reloption_list ')'  */
#line 3057 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 32641 "gram.c"
    break;

  case 369: /* opt_reloptions: WITH reloptions  */
#line 3060 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 32647 "gram.c"
    break;

  case 370: /* opt_reloptions: %empty  */
#line 3061 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 32653 "gram.c"
    break;

  case 371: /* reloption_list: reloption_elem  */
#line 3065 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 32659 "gram.c"
    break;

  case 372: /* reloption_list: reloption_list ',' reloption_elem  */
#line 3066 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 32665 "gram.c"
    break;

  case 373: /* reloption_elem: ColLabel '=' def_arg  */
#line 3072 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 32673 "gram.c"
    break;

  case 374: /* reloption_elem: ColLabel  */
#line 3076 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 32681 "gram.c"
    break;

  case 375: /* reloption_elem: ColLabel '.' ColLabel '=' def_arg  */
#line 3080 "gram.y"
                                {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC, (yylsp[-4]));
				}
#line 32690 "gram.c"
    break;

  case 376: /* reloption_elem: ColLabel '.' ColLabel  */
#line 3085 "gram.y"
                                {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC, (yylsp[-2]));
				}
#line 32698 "gram.c"
    break;

  case 377: /* alter_identity_column_option_list: alter_identity_column_option  */
#line 3092 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 32704 "gram.c"
    break;

  case 378: /* alter_identity_column_option_list: alter_identity_column_option_list alter_identity_column_option  */
#line 3094 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 32710 "gram.c"
    break;

  case 379: /* alter_identity_column_option: RESTART  */
#line 3099 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 32718 "gram.c"
    break;

  case 380: /* alter_identity_column_option: RESTART opt_with NumericOnly  */
#line 3103 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 32726 "gram.c"
    break;

  case 381: /* alter_identity_column_option: SET SeqOptElem  */
#line 3107 "gram.y"
                                {
					if (strcmp((yyvsp[0].defelt)->defname, "as") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "restart") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "owned_by") == 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("sequence option \"%s\" not supported here", (yyvsp[0].defelt)->defname),
								 parser_errposition((yylsp[0]))));
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 32741 "gram.c"
    break;

  case 382: /* alter_identity_column_option: SET GENERATED generated_when  */
#line 3118 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("generated", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 32749 "gram.c"
    break;

  case 383: /* PartitionBoundSpec: FOR VALUES WITH '(' hash_partbound ')'  */
#line 3126 "gram.y"
                                {
					ListCell   *lc;
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_HASH;
					n->modulus = n->remainder = -1;

					foreach (lc, (yyvsp[-1].list))
					{
						DefElem    *opt = lfirst_node(DefElem, lc);

						if (strcmp(opt->defname, "modulus") == 0)
						{
							if (n->modulus != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("modulus for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->modulus = defGetInt32(opt);
						}
						else if (strcmp(opt->defname, "remainder") == 0)
						{
							if (n->remainder != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("remainder for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->remainder = defGetInt32(opt);
						}
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized hash partition bound specification \"%s\"",
											opt->defname),
									 parser_errposition(opt->location)));
					}

					if (n->modulus == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("modulus for hash partition must be specified")));
					if (n->remainder == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("remainder for hash partition must be specified")));

					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 32804 "gram.c"
    break;

  case 384: /* PartitionBoundSpec: FOR VALUES IN_P '(' expr_list ')'  */
#line 3179 "gram.y"
                                {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_LIST;
					n->is_default = false;
					n->listdatums = (yyvsp[-1].list);
					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 32819 "gram.c"
    break;

  case 385: /* PartitionBoundSpec: FOR VALUES FROM '(' expr_list ')' TO '(' expr_list ')'  */
#line 3192 "gram.y"
                                {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_RANGE;
					n->is_default = false;
					n->lowerdatums = (yyvsp[-5].list);
					n->upperdatums = (yyvsp[-1].list);
					n->location = (yylsp[-7]);

					(yyval.partboundspec) = n;
				}
#line 32835 "gram.c"
    break;

  case 386: /* PartitionBoundSpec: DEFAULT  */
#line 3206 "gram.y"
                                {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->is_default = true;
					n->location = (yylsp[0]);

					(yyval.partboundspec) = n;
				}
#line 32848 "gram.c"
    break;

  case 387: /* hash_partbound_elem: NonReservedWord Iconst  */
#line 3218 "gram.y"
                        {
				(yyval.defelt) = makeDefElem((yyvsp[-1].str), (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
			}
#line 32856 "gram.c"
    break;

  case 388: /* hash_partbound: hash_partbound_elem  */
#line 3225 "gram.y"
                        {
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 32864 "gram.c"
    break;

  case 389: /* hash_partbound: hash_partbound ',' hash_partbound_elem  */
#line 3229 "gram.y"
                        {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
			}
#line 32872 "gram.c"
    break;

  case 390: /* AlterCompositeTypeStmt: ALTER TYPE_P any_name alter_type_cmds  */
#line 3243 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TYPE;
					(yyval.node) = (Node *) n;
				}
#line 32886 "gram.c"
    break;

  case 391: /* alter_type_cmds: alter_type_cmd  */
#line 3255 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32892 "gram.c"
    break;

  case 392: /* alter_type_cmds: alter_type_cmds ',' alter_type_cmd  */
#line 3256 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 32898 "gram.c"
    break;

  case 393: /* alter_type_cmd: ADD_P ATTRIBUTE TableFuncElement opt_drop_behavior  */
#line 3262 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 32911 "gram.c"
    break;

  case 394: /* alter_type_cmd: DROP ATTRIBUTE IF_P EXISTS ColId opt_drop_behavior  */
#line 3272 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32925 "gram.c"
    break;

  case 395: /* alter_type_cmd: DROP ATTRIBUTE ColId opt_drop_behavior  */
#line 3283 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32939 "gram.c"
    break;

  case 396: /* alter_type_cmd: ALTER ATTRIBUTE ColId opt_set_data TYPE_P Typename opt_collate_clause opt_drop_behavior  */
#line 3294 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 32959 "gram.c"
    break;

  case 397: /* ClosePortalStmt: CLOSE cursor_name  */
#line 3321 "gram.y"
                                {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32970 "gram.c"
    break;

  case 398: /* ClosePortalStmt: CLOSE ALL  */
#line 3328 "gram.y"
                                {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 32981 "gram.c"
    break;

  case 399: /* CopyStmt: COPY opt_binary qualified_name opt_column_list copy_from opt_program copy_file_name copy_delimiter opt_with copy_options where_clause  */
#line 3364 "gram.y"
                                {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-6].boolean);
					n->is_program = (yyvsp[-5].boolean);
					n->filename = (yyvsp[-4].str);
					n->whereClause = (yyvsp[0].node);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					if (!n->is_from && n->whereClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("WHERE clause not allowed with COPY TO"),
								 parser_errposition((yylsp[0]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-3].defelt))
						n->options = lappend(n->options, (yyvsp[-3].defelt));
					if ((yyvsp[-1].list))
						n->options = list_concat(n->options, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 33019 "gram.c"
    break;

  case 400: /* CopyStmt: COPY '(' PreparableStmt ')' TO opt_program copy_file_name opt_with copy_options  */
#line 3398 "gram.y"
                                {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *) n;
				}
#line 33043 "gram.c"
    break;

  case 401: /* copy_from: FROM  */
#line 3420 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 33049 "gram.c"
    break;

  case 402: /* copy_from: TO  */
#line 3421 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 33055 "gram.c"
    break;

  case 403: /* opt_program: PROGRAM  */
#line 3425 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 33061 "gram.c"
    break;

  case 404: /* opt_program: %empty  */
#line 3426 "gram.y"
                                                                                        { (yyval.boolean) = false; }
#line 33067 "gram.c"
    break;

  case 405: /* copy_file_name: Sconst  */
#line 3435 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 33073 "gram.c"
    break;

  case 406: /* copy_file_name: STDIN  */
#line 3436 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 33079 "gram.c"
    break;

  case 407: /* copy_file_name: STDOUT  */
#line 3437 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 33085 "gram.c"
    break;

  case 408: /* copy_options: copy_opt_list  */
#line 3440 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 33091 "gram.c"
    break;

  case 409: /* copy_options: '(' copy_generic_opt_list ')'  */
#line 3441 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 33097 "gram.c"
    break;

  case 410: /* copy_opt_list: copy_opt_list copy_opt_item  */
#line 3446 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33103 "gram.c"
    break;

  case 411: /* copy_opt_list: %empty  */
#line 3447 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 33109 "gram.c"
    break;

  case 412: /* copy_opt_item: BINARY  */
#line 3452 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 33117 "gram.c"
    break;

  case 413: /* copy_opt_item: FREEZE  */
#line 3456 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("freeze", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 33125 "gram.c"
    break;

  case 414: /* copy_opt_item: DELIMITER opt_as Sconst  */
#line 3460 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 33133 "gram.c"
    break;

  case 415: /* copy_opt_item: NULL_P opt_as Sconst  */
#line 3464 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("null", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 33141 "gram.c"
    break;

  case 416: /* copy_opt_item: CSV  */
#line 3468 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("csv"), (yylsp[0]));
				}
#line 33149 "gram.c"
    break;

  case 417: /* copy_opt_item: HEADER_P  */
#line 3472 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("header", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 33157 "gram.c"
    break;

  case 418: /* copy_opt_item: QUOTE opt_as Sconst  */
#line 3476 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("quote", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 33165 "gram.c"
    break;

  case 419: /* copy_opt_item: ESCAPE opt_as Sconst  */
#line 3480 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("escape", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 33173 "gram.c"
    break;

  case 420: /* copy_opt_item: FORCE QUOTE columnList  */
#line 3484 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 33181 "gram.c"
    break;

  case 421: /* copy_opt_item: FORCE QUOTE '*'  */
#line 3488 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) makeNode(A_Star), (yylsp[-2]));
				}
#line 33189 "gram.c"
    break;

  case 422: /* copy_opt_item: FORCE NOT NULL_P columnList  */
#line 3492 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *) (yyvsp[0].list), (yylsp[-3]));
				}
#line 33197 "gram.c"
    break;

  case 423: /* copy_opt_item: FORCE NULL_P columnList  */
#line 3496 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_null", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 33205 "gram.c"
    break;

  case 424: /* copy_opt_item: ENCODING Sconst  */
#line 3500 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("encoding", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 33213 "gram.c"
    break;

  case 425: /* opt_binary: BINARY  */
#line 3509 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 33221 "gram.c"
    break;

  case 426: /* opt_binary: %empty  */
#line 3512 "gram.y"
                                                                                                { (yyval.defelt) = NULL; }
#line 33227 "gram.c"
    break;

  case 427: /* copy_delimiter: opt_using DELIMITERS Sconst  */
#line 3517 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 33235 "gram.c"
    break;

  case 428: /* copy_delimiter: %empty  */
#line 3520 "gram.y"
                                                                                                { (yyval.defelt) = NULL; }
#line 33241 "gram.c"
    break;

  case 431: /* copy_generic_opt_list: copy_generic_opt_elem  */
#line 3531 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 33249 "gram.c"
    break;

  case 432: /* copy_generic_opt_list: copy_generic_opt_list ',' copy_generic_opt_elem  */
#line 3535 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 33257 "gram.c"
    break;

  case 433: /* copy_generic_opt_elem: ColLabel copy_generic_opt_arg  */
#line 3542 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 33265 "gram.c"
    break;

  case 434: /* copy_generic_opt_arg: opt_boolean_or_string  */
#line 3548 "gram.y"
                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 33271 "gram.c"
    break;

  case 435: /* copy_generic_opt_arg: NumericOnly  */
#line 3549 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 33277 "gram.c"
    break;

  case 436: /* copy_generic_opt_arg: '*'  */
#line 3550 "gram.y"
                                                                                { (yyval.node) = (Node *) makeNode(A_Star); }
#line 33283 "gram.c"
    break;

  case 437: /* copy_generic_opt_arg: '(' copy_generic_opt_arg_list ')'  */
#line 3551 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 33289 "gram.c"
    break;

  case 438: /* copy_generic_opt_arg: %empty  */
#line 3552 "gram.y"
                                                                        { (yyval.node) = NULL; }
#line 33295 "gram.c"
    break;

  case 439: /* copy_generic_opt_arg_list: copy_generic_opt_arg_list_item  */
#line 3557 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 33303 "gram.c"
    break;

  case 440: /* copy_generic_opt_arg_list: copy_generic_opt_arg_list ',' copy_generic_opt_arg_list_item  */
#line 3561 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 33311 "gram.c"
    break;

  case 441: /* copy_generic_opt_arg_list_item: opt_boolean_or_string  */
#line 3568 "gram.y"
                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 33317 "gram.c"
    break;

  case 442: /* CreateStmt: CREATE OptTemp TABLE qualified_name '(' OptTableElementList ')' OptInherit OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3582 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 33339 "gram.c"
    break;

  case 443: /* CreateStmt: CREATE OptTemp TABLE IF_P NOT EXISTS qualified_name '(' OptTableElementList ')' OptInherit OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3602 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 33361 "gram.c"
    break;

  case 444: /* CreateStmt: CREATE OptTemp TABLE qualified_name OF any_name OptTypedTableElementList OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3622 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-10].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 33384 "gram.c"
    break;

  case 445: /* CreateStmt: CREATE OptTemp TABLE IF_P NOT EXISTS qualified_name OF any_name OptTypedTableElementList OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3643 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-13].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 33407 "gram.c"
    break;

  case 446: /* CreateStmt: CREATE OptTemp TABLE qualified_name PARTITION OF qualified_name OptTypedTableElementList PartitionBoundSpec OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3664 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 33430 "gram.c"
    break;

  case 447: /* CreateStmt: CREATE OptTemp TABLE IF_P NOT EXISTS qualified_name PARTITION OF qualified_name OptTypedTableElementList PartitionBoundSpec OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3685 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-15].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 33453 "gram.c"
    break;

  case 448: /* OptTemp: TEMPORARY  */
#line 3716 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 33459 "gram.c"
    break;

  case 449: /* OptTemp: TEMP  */
#line 3717 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 33465 "gram.c"
    break;

  case 450: /* OptTemp: LOCAL TEMPORARY  */
#line 3718 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 33471 "gram.c"
    break;

  case 451: /* OptTemp: LOCAL TEMP  */
#line 3719 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 33477 "gram.c"
    break;

  case 452: /* OptTemp: GLOBAL TEMPORARY  */
#line 3721 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 33488 "gram.c"
    break;

  case 453: /* OptTemp: GLOBAL TEMP  */
#line 3728 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 33499 "gram.c"
    break;

  case 454: /* OptTemp: UNLOGGED  */
#line 3734 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 33505 "gram.c"
    break;

  case 455: /* OptTemp: %empty  */
#line 3735 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 33511 "gram.c"
    break;

  case 456: /* OptTableElementList: TableElementList  */
#line 3739 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 33517 "gram.c"
    break;

  case 457: /* OptTableElementList: %empty  */
#line 3740 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 33523 "gram.c"
    break;

  case 458: /* OptTypedTableElementList: '(' TypedTableElementList ')'  */
#line 3744 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 33529 "gram.c"
    break;

  case 459: /* OptTypedTableElementList: %empty  */
#line 3745 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 33535 "gram.c"
    break;

  case 460: /* TableElementList: TableElement  */
#line 3750 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 33543 "gram.c"
    break;

  case 461: /* TableElementList: TableElementList ',' TableElement  */
#line 3754 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 33551 "gram.c"
    break;

  case 462: /* TypedTableElementList: TypedTableElement  */
#line 3761 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 33559 "gram.c"
    break;

  case 463: /* TypedTableElementList: TypedTableElementList ',' TypedTableElement  */
#line 3765 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 33567 "gram.c"
    break;

  case 464: /* TableElement: columnDef  */
#line 3771 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 33573 "gram.c"
    break;

  case 465: /* TableElement: TableLikeClause  */
#line 3772 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 33579 "gram.c"
    break;

  case 466: /* TableElement: TableConstraint  */
#line 3773 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 33585 "gram.c"
    break;

  case 467: /* TypedTableElement: columnOptions  */
#line 3777 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 33591 "gram.c"
    break;

  case 468: /* TypedTableElement: TableConstraint  */
#line 3778 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 33597 "gram.c"
    break;

  case 469: /* columnDef: ColId Typename opt_column_compression create_generic_options ColQualList  */
#line 3782 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-4].str);
					n->typeName = (yyvsp[-3].typnam);
					n->compression = (yyvsp[-2].str);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 33622 "gram.c"
    break;

  case 470: /* columnOptions: ColId ColQualList  */
#line 3805 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-1].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33645 "gram.c"
    break;

  case 471: /* columnOptions: ColId WITH OPTIONS ColQualList  */
#line 3824 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 33668 "gram.c"
    break;

  case 472: /* column_compression: COMPRESSION ColId  */
#line 3845 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 33674 "gram.c"
    break;

  case 473: /* column_compression: COMPRESSION DEFAULT  */
#line 3846 "gram.y"
                                                                                { (yyval.str) = pstrdup("default"); }
#line 33680 "gram.c"
    break;

  case 474: /* opt_column_compression: column_compression  */
#line 3850 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 33686 "gram.c"
    break;

  case 475: /* opt_column_compression: %empty  */
#line 3851 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 33692 "gram.c"
    break;

  case 476: /* ColQualList: ColQualList ColConstraint  */
#line 3855 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 33698 "gram.c"
    break;

  case 477: /* ColQualList: %empty  */
#line 3856 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 33704 "gram.c"
    break;

  case 478: /* ColConstraint: CONSTRAINT name ColConstraintElem  */
#line 3861 "gram.y"
                                {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 33716 "gram.c"
    break;

  case 479: /* ColConstraint: ColConstraintElem  */
#line 3868 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 33722 "gram.c"
    break;

  case 480: /* ColConstraint: ConstraintAttr  */
#line 3869 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 33728 "gram.c"
    break;

  case 481: /* ColConstraint: COLLATE any_name  */
#line 3871 "gram.y"
                                {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33746 "gram.c"
    break;

  case 482: /* ColConstraintElem: NOT NULL_P  */
#line 3903 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33758 "gram.c"
    break;

  case 483: /* ColConstraintElem: NULL_P  */
#line 3911 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 33770 "gram.c"
    break;

  case 484: /* ColConstraintElem: UNIQUE opt_unique_null_treatment opt_definition OptConsTableSpace  */
#line 3919 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-3]);
					n->nulls_not_distinct = !(yyvsp[-2].boolean);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33787 "gram.c"
    break;

  case 485: /* ColConstraintElem: PRIMARY KEY opt_definition OptConsTableSpace  */
#line 3932 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33803 "gram.c"
    break;

  case 486: /* ColConstraintElem: CHECK '(' a_expr ')' opt_no_inherit  */
#line 3944 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 33820 "gram.c"
    break;

  case 487: /* ColConstraintElem: DEFAULT b_expr  */
#line 3957 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *) n;
				}
#line 33834 "gram.c"
    break;

  case 488: /* ColConstraintElem: GENERATED generated_when AS IDENTITY_P OptParenthesizedSeqOptList  */
#line 3967 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_IDENTITY;
					n->generated_when = (yyvsp[-3].ival);
					n->options = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 33848 "gram.c"
    break;

  case 489: /* ColConstraintElem: GENERATED generated_when AS '(' a_expr ')' STORED  */
#line 3977 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_GENERATED;
					n->generated_when = (yyvsp[-5].ival);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->location = (yylsp[-6]);

					/*
					 * Can't do this in the grammar because of shift/reduce
					 * conflicts.  (IDENTITY allows both ALWAYS and BY
					 * DEFAULT, but generated columns only allow ALWAYS.)  We
					 * can also give a more useful error message and location.
					 */
					if ((yyvsp[-5].ival) != ATTRIBUTE_IDENTITY_ALWAYS)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("for a generated column, GENERATED ALWAYS must be specified"),
								 parser_errposition((yylsp[-5]))));

					(yyval.node) = (Node *) n;
				}
#line 33876 "gram.c"
    break;

  case 490: /* ColConstraintElem: REFERENCES qualified_name opt_column_list key_match key_actions  */
#line 4001 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable = (yyvsp[-3].range);
					n->fk_attrs = NIL;
					n->pk_attrs = (yyvsp[-2].list);
					n->fk_matchtype = (yyvsp[-1].ival);
					n->fk_upd_action = ((yyvsp[0].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[0].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[0].keyactions))->deleteAction->cols;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 33897 "gram.c"
    break;

  case 491: /* opt_unique_null_treatment: NULLS_P DISTINCT  */
#line 4020 "gram.y"
                                                        { (yyval.boolean) = true; }
#line 33903 "gram.c"
    break;

  case 492: /* opt_unique_null_treatment: NULLS_P NOT DISTINCT  */
#line 4021 "gram.y"
                                                { (yyval.boolean) = false; }
#line 33909 "gram.c"
    break;

  case 493: /* opt_unique_null_treatment: %empty  */
#line 4022 "gram.y"
                                                                { (yyval.boolean) = true; }
#line 33915 "gram.c"
    break;

  case 494: /* generated_when: ALWAYS  */
#line 4026 "gram.y"
                                                { (yyval.ival) = ATTRIBUTE_IDENTITY_ALWAYS; }
#line 33921 "gram.c"
    break;

  case 495: /* generated_when: BY DEFAULT  */
#line 4027 "gram.y"
                                        { (yyval.ival) = ATTRIBUTE_IDENTITY_BY_DEFAULT; }
#line 33927 "gram.c"
    break;

  case 496: /* ConstraintAttr: DEFERRABLE  */
#line 4047 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 33939 "gram.c"
    break;

  case 497: /* ConstraintAttr: NOT DEFERRABLE  */
#line 4055 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33951 "gram.c"
    break;

  case 498: /* ConstraintAttr: INITIALLY DEFERRED  */
#line 4063 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33963 "gram.c"
    break;

  case 499: /* ConstraintAttr: INITIALLY IMMEDIATE  */
#line 4071 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33975 "gram.c"
    break;

  case 500: /* TableLikeClause: LIKE qualified_name TableLikeOptionList  */
#line 4083 "gram.y"
                                {
					TableLikeClause *n = makeNode(TableLikeClause);

					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					n->relationOid = InvalidOid;
					(yyval.node) = (Node *) n;
				}
#line 33988 "gram.c"
    break;

  case 501: /* TableLikeOptionList: TableLikeOptionList INCLUDING TableLikeOption  */
#line 4094 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 33994 "gram.c"
    break;

  case 502: /* TableLikeOptionList: TableLikeOptionList EXCLUDING TableLikeOption  */
#line 4095 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 34000 "gram.c"
    break;

  case 503: /* TableLikeOptionList: %empty  */
#line 4096 "gram.y"
                                                                                        { (yyval.ival) = 0; }
#line 34006 "gram.c"
    break;

  case 504: /* TableLikeOption: COMMENTS  */
#line 4100 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 34012 "gram.c"
    break;

  case 505: /* TableLikeOption: COMPRESSION  */
#line 4101 "gram.y"
                                                        { (yyval.ival) = CREATE_TABLE_LIKE_COMPRESSION; }
#line 34018 "gram.c"
    break;

  case 506: /* TableLikeOption: CONSTRAINTS  */
#line 4102 "gram.y"
                                                        { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 34024 "gram.c"
    break;

  case 507: /* TableLikeOption: DEFAULTS  */
#line 4103 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 34030 "gram.c"
    break;

  case 508: /* TableLikeOption: IDENTITY_P  */
#line 4104 "gram.y"
                                                        { (yyval.ival) = CREATE_TABLE_LIKE_IDENTITY; }
#line 34036 "gram.c"
    break;

  case 509: /* TableLikeOption: GENERATED  */
#line 4105 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_GENERATED; }
#line 34042 "gram.c"
    break;

  case 510: /* TableLikeOption: INDEXES  */
#line 4106 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 34048 "gram.c"
    break;

  case 511: /* TableLikeOption: STATISTICS  */
#line 4107 "gram.y"
                                                        { (yyval.ival) = CREATE_TABLE_LIKE_STATISTICS; }
#line 34054 "gram.c"
    break;

  case 512: /* TableLikeOption: STORAGE  */
#line 4108 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 34060 "gram.c"
    break;

  case 513: /* TableLikeOption: ALL  */
#line 4109 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 34066 "gram.c"
    break;

  case 514: /* TableConstraint: CONSTRAINT name ConstraintElem  */
#line 4119 "gram.y"
                                {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 34078 "gram.c"
    break;

  case 515: /* TableConstraint: ConstraintElem  */
#line 4126 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 34084 "gram.c"
    break;

  case 516: /* ConstraintElem: CHECK '(' a_expr ')' ConstraintAttributeSpec  */
#line 4131 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 34102 "gram.c"
    break;

  case 517: /* ConstraintElem: UNIQUE opt_unique_null_treatment '(' columnList ')' opt_c_include opt_definition OptConsTableSpace ConstraintAttributeSpec  */
#line 4146 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-8]);
					n->nulls_not_distinct = !(yyvsp[-7].boolean);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 34123 "gram.c"
    break;

  case 518: /* ConstraintElem: UNIQUE ExistingIndex ConstraintAttributeSpec  */
#line 4163 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 34143 "gram.c"
    break;

  case 519: /* ConstraintElem: PRIMARY KEY '(' columnList ')' opt_c_include opt_definition OptConsTableSpace ConstraintAttributeSpec  */
#line 4180 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-8]);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 34163 "gram.c"
    break;

  case 520: /* ConstraintElem: PRIMARY KEY ExistingIndex ConstraintAttributeSpec  */
#line 4196 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 34183 "gram.c"
    break;

  case 521: /* ConstraintElem: EXCLUDE access_method_clause '(' ExclusionConstraintList ')' opt_c_include opt_definition OptConsTableSpace OptWhereClause ConstraintAttributeSpec  */
#line 4214 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-9]);
					n->access_method = (yyvsp[-8].str);
					n->exclusions = (yyvsp[-6].list);
					n->including = (yyvsp[-4].list);
					n->options = (yyvsp[-3].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-2].str);
					n->where_clause = (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 34205 "gram.c"
    break;

  case 522: /* ConstraintElem: FOREIGN KEY '(' columnList ')' REFERENCES qualified_name opt_column_list key_match key_actions ConstraintAttributeSpec  */
#line 4233 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable = (yyvsp[-4].range);
					n->fk_attrs = (yyvsp[-7].list);
					n->pk_attrs = (yyvsp[-3].list);
					n->fk_matchtype = (yyvsp[-2].ival);
					n->fk_upd_action = ((yyvsp[-1].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[-1].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[-1].keyactions))->deleteAction->cols;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 34229 "gram.c"
    break;

  case 523: /* opt_no_inherit: NO INHERIT  */
#line 4254 "gram.y"
                                                                                {  (yyval.boolean) = true; }
#line 34235 "gram.c"
    break;

  case 524: /* opt_no_inherit: %empty  */
#line 4255 "gram.y"
                                                                                        {  (yyval.boolean) = false; }
#line 34241 "gram.c"
    break;

  case 525: /* opt_column_list: '(' columnList ')'  */
#line 4259 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 34247 "gram.c"
    break;

  case 526: /* opt_column_list: %empty  */
#line 4260 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 34253 "gram.c"
    break;

  case 527: /* columnList: columnElem  */
#line 4264 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34259 "gram.c"
    break;

  case 528: /* columnList: columnList ',' columnElem  */
#line 4265 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 34265 "gram.c"
    break;

  case 529: /* columnElem: ColId  */
#line 4269 "gram.y"
                                {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 34273 "gram.c"
    break;

  case 530: /* opt_c_include: INCLUDE '(' columnList ')'  */
#line 4274 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 34279 "gram.c"
    break;

  case 531: /* opt_c_include: %empty  */
#line 4275 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 34285 "gram.c"
    break;

  case 532: /* key_match: MATCH FULL  */
#line 4279 "gram.y"
                        {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 34293 "gram.c"
    break;

  case 533: /* key_match: MATCH PARTIAL  */
#line 4283 "gram.y"
                        {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 34305 "gram.c"
    break;

  case 534: /* key_match: MATCH SIMPLE  */
#line 4291 "gram.y"
                        {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 34313 "gram.c"
    break;

  case 535: /* key_match: %empty  */
#line 4295 "gram.y"
                        {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 34321 "gram.c"
    break;

  case 536: /* ExclusionConstraintList: ExclusionConstraintElem  */
#line 4301 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 34327 "gram.c"
    break;

  case 537: /* ExclusionConstraintList: ExclusionConstraintList ',' ExclusionConstraintElem  */
#line 4303 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 34333 "gram.c"
    break;

  case 538: /* ExclusionConstraintElem: index_elem WITH any_operator  */
#line 4307 "gram.y"
                        {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 34341 "gram.c"
    break;

  case 539: /* ExclusionConstraintElem: index_elem WITH OPERATOR '(' any_operator ')'  */
#line 4312 "gram.y"
                        {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 34349 "gram.c"
    break;

  case 540: /* OptWhereClause: WHERE '(' a_expr ')'  */
#line 4318 "gram.y"
                                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 34355 "gram.c"
    break;

  case 541: /* OptWhereClause: %empty  */
#line 4319 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 34361 "gram.c"
    break;

  case 542: /* key_actions: key_update  */
#line 4324 "gram.y"
                                {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 34375 "gram.c"
    break;

  case 543: /* key_actions: key_delete  */
#line 4334 "gram.y"
                                {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 34389 "gram.c"
    break;

  case 544: /* key_actions: key_update key_delete  */
#line 4344 "gram.y"
                                {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[-1].keyaction);
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 34401 "gram.c"
    break;

  case 545: /* key_actions: key_delete key_update  */
#line 4352 "gram.y"
                                {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = (yyvsp[-1].keyaction);
					(yyval.keyactions) = n;
				}
#line 34413 "gram.c"
    break;

  case 546: /* key_actions: %empty  */
#line 4360 "gram.y"
                                {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 34429 "gram.c"
    break;

  case 547: /* key_update: ON UPDATE key_action  */
#line 4374 "gram.y"
                                {
					if (((yyvsp[0].keyaction))->cols)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("a column list with %s is only supported for ON DELETE actions",
										((yyvsp[0].keyaction))->action == FKCONSTR_ACTION_SETNULL ? "SET NULL" : "SET DEFAULT"),
								 parser_errposition((yylsp[-2]))));
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 34443 "gram.c"
    break;

  case 548: /* key_delete: ON DELETE_P key_action  */
#line 4386 "gram.y"
                                {
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 34451 "gram.c"
    break;

  case 549: /* key_action: NO ACTION  */
#line 4393 "gram.y"
                                {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_NOACTION;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 34463 "gram.c"
    break;

  case 550: /* key_action: RESTRICT  */
#line 4401 "gram.y"
                                {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_RESTRICT;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 34475 "gram.c"
    break;

  case 551: /* key_action: CASCADE  */
#line 4409 "gram.y"
                                {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_CASCADE;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 34487 "gram.c"
    break;

  case 552: /* key_action: SET NULL_P opt_column_list  */
#line 4417 "gram.y"
                                {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETNULL;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 34499 "gram.c"
    break;

  case 553: /* key_action: SET DEFAULT opt_column_list  */
#line 4425 "gram.y"
                                {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETDEFAULT;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 34511 "gram.c"
    break;

  case 554: /* OptInherit: INHERITS '(' qualified_name_list ')'  */
#line 4434 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 34517 "gram.c"
    break;

  case 555: /* OptInherit: %empty  */
#line 4435 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 34523 "gram.c"
    break;

  case 556: /* OptPartitionSpec: PartitionSpec  */
#line 4439 "gram.y"
                                { (yyval.partspec) = (yyvsp[0].partspec); }
#line 34529 "gram.c"
    break;

  case 557: /* OptPartitionSpec: %empty  */
#line 4440 "gram.y"
                                                        { (yyval.partspec) = NULL; }
#line 34535 "gram.c"
    break;

  case 558: /* PartitionSpec: PARTITION BY ColId '(' part_params ')'  */
#line 4444 "gram.y"
                                {
					PartitionSpec *n = makeNode(PartitionSpec);

					n->strategy = (yyvsp[-3].str);
					n->partParams = (yyvsp[-1].list);
					n->location = (yylsp[-5]);

					(yyval.partspec) = n;
				}
#line 34549 "gram.c"
    break;

  case 559: /* part_params: part_elem  */
#line 4455 "gram.y"
                                                                        { (yyval.list) = list_make1((yyvsp[0].partelem)); }
#line 34555 "gram.c"
    break;

  case 560: /* part_params: part_params ',' part_elem  */
#line 4456 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].partelem)); }
#line 34561 "gram.c"
    break;

  case 561: /* part_elem: ColId opt_collate opt_class  */
#line 4460 "gram.y"
                                {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = (yyvsp[-2].str);
					n->expr = NULL;
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 34576 "gram.c"
    break;

  case 562: /* part_elem: func_expr_windowless opt_collate opt_class  */
#line 4471 "gram.y"
                                {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-2].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 34591 "gram.c"
    break;

  case 563: /* part_elem: '(' a_expr ')' opt_collate opt_class  */
#line 4482 "gram.y"
                                {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-3].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.partelem) = n;
				}
#line 34606 "gram.c"
    break;

  case 564: /* table_access_method_clause: USING name  */
#line 4495 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 34612 "gram.c"
    break;

  case 565: /* table_access_method_clause: %empty  */
#line 4496 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 34618 "gram.c"
    break;

  case 566: /* OptWith: WITH reloptions  */
#line 4501 "gram.y"
                                                                { (yyval.list) = (yyvsp[0].list); }
#line 34624 "gram.c"
    break;

  case 567: /* OptWith: WITHOUT OIDS  */
#line 4502 "gram.y"
                                                                { (yyval.list) = NIL; }
#line 34630 "gram.c"
    break;

  case 568: /* OptWith: %empty  */
#line 4503 "gram.y"
                                                                        { (yyval.list) = NIL; }
#line 34636 "gram.c"
    break;

  case 569: /* OnCommitOption: ON COMMIT DROP  */
#line 4506 "gram.y"
                                                        { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 34642 "gram.c"
    break;

  case 570: /* OnCommitOption: ON COMMIT DELETE_P ROWS  */
#line 4507 "gram.y"
                                                                { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 34648 "gram.c"
    break;

  case 571: /* OnCommitOption: ON COMMIT PRESERVE ROWS  */
#line 4508 "gram.y"
                                                                { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 34654 "gram.c"
    break;

  case 572: /* OnCommitOption: %empty  */
#line 4509 "gram.y"
                                                                                { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 34660 "gram.c"
    break;

  case 573: /* OptTableSpace: TABLESPACE name  */
#line 4512 "gram.y"
                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 34666 "gram.c"
    break;

  case 574: /* OptTableSpace: %empty  */
#line 4513 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 34672 "gram.c"
    break;

  case 575: /* OptConsTableSpace: USING INDEX TABLESPACE name  */
#line 4516 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 34678 "gram.c"
    break;

  case 576: /* OptConsTableSpace: %empty  */
#line 4517 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 34684 "gram.c"
    break;

  case 577: /* ExistingIndex: USING INDEX name  */
#line 4520 "gram.y"
                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 34690 "gram.c"
    break;

  case 578: /* CreateStatsStmt: CREATE STATISTICS any_name opt_name_list ON stats_params FROM from_list  */
#line 4540 "gram.y"
                                {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34706 "gram.c"
    break;

  case 579: /* CreateStatsStmt: CREATE STATISTICS IF_P NOT EXISTS any_name opt_name_list ON stats_params FROM from_list  */
#line 4553 "gram.y"
                                {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34722 "gram.c"
    break;

  case 580: /* stats_params: stats_param  */
#line 4573 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].selem)); }
#line 34728 "gram.c"
    break;

  case 581: /* stats_params: stats_params ',' stats_param  */
#line 4574 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].selem)); }
#line 34734 "gram.c"
    break;

  case 582: /* stats_param: ColId  */
#line 4578 "gram.y"
                                {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = (yyvsp[0].str);
					(yyval.selem)->expr = NULL;
				}
#line 34744 "gram.c"
    break;

  case 583: /* stats_param: func_expr_windowless  */
#line 4584 "gram.y"
                                {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[0].node);
				}
#line 34754 "gram.c"
    break;

  case 584: /* stats_param: '(' a_expr ')'  */
#line 4590 "gram.y"
                                {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[-1].node);
				}
#line 34764 "gram.c"
    break;

  case 585: /* AlterStatsStmt: ALTER STATISTICS any_name SET STATISTICS SignedIconst  */
#line 4607 "gram.y"
                                {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = false;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 34777 "gram.c"
    break;

  case 586: /* AlterStatsStmt: ALTER STATISTICS IF_P EXISTS any_name SET STATISTICS SignedIconst  */
#line 4616 "gram.y"
                                {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = true;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 34790 "gram.c"
    break;

  case 587: /* CreateAsStmt: CREATE OptTemp TABLE create_as_target AS SelectStmt opt_with_data  */
#line 4638 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 34808 "gram.c"
    break;

  case 588: /* CreateAsStmt: CREATE OptTemp TABLE IF_P NOT EXISTS create_as_target AS SelectStmt opt_with_data  */
#line 4652 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 34826 "gram.c"
    break;

  case 589: /* create_as_target: qualified_name opt_column_list table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 4670 "gram.y"
                                {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-5].range);
					(yyval.into)->colNames = (yyvsp[-4].list);
					(yyval.into)->accessMethod = (yyvsp[-3].str);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 34842 "gram.c"
    break;

  case 590: /* opt_with_data: WITH DATA_P  */
#line 4684 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 34848 "gram.c"
    break;

  case 591: /* opt_with_data: WITH NO DATA_P  */
#line 4685 "gram.y"
                                                                                        { (yyval.boolean) = false; }
#line 34854 "gram.c"
    break;

  case 592: /* opt_with_data: %empty  */
#line 4686 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 34860 "gram.c"
    break;

  case 593: /* CreateMatViewStmt: CREATE OptNoLog MATERIALIZED VIEW create_mv_target AS SelectStmt opt_with_data  */
#line 4699 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 34878 "gram.c"
    break;

  case 594: /* CreateMatViewStmt: CREATE OptNoLog MATERIALIZED VIEW IF_P NOT EXISTS create_mv_target AS SelectStmt opt_with_data  */
#line 4713 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 34896 "gram.c"
    break;

  case 595: /* create_mv_target: qualified_name opt_column_list table_access_method_clause opt_reloptions OptTableSpace  */
#line 4730 "gram.y"
                                {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->accessMethod = (yyvsp[-2].str);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 34912 "gram.c"
    break;

  case 596: /* OptNoLog: UNLOGGED  */
#line 4743 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 34918 "gram.c"
    break;

  case 597: /* OptNoLog: %empty  */
#line 4744 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 34924 "gram.c"
    break;

  case 598: /* RefreshMatViewStmt: REFRESH MATERIALIZED VIEW opt_concurrently qualified_name opt_with_data  */
#line 4757 "gram.y"
                                {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);

					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 34937 "gram.c"
    break;

  case 599: /* CreateSeqStmt: CREATE OptTemp SEQUENCE qualified_name OptSeqOptList  */
#line 4778 "gram.y"
                                {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34952 "gram.c"
    break;

  case 600: /* CreateSeqStmt: CREATE OptTemp SEQUENCE IF_P NOT EXISTS qualified_name OptSeqOptList  */
#line 4789 "gram.y"
                                {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34967 "gram.c"
    break;

  case 601: /* AlterSeqStmt: ALTER SEQUENCE qualified_name SeqOptList  */
#line 4803 "gram.y"
                                {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 34980 "gram.c"
    break;

  case 602: /* AlterSeqStmt: ALTER SEQUENCE IF_P EXISTS qualified_name SeqOptList  */
#line 4812 "gram.y"
                                {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 34993 "gram.c"
    break;

  case 603: /* OptSeqOptList: SeqOptList  */
#line 4823 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 34999 "gram.c"
    break;

  case 604: /* OptSeqOptList: %empty  */
#line 4824 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 35005 "gram.c"
    break;

  case 605: /* OptParenthesizedSeqOptList: '(' SeqOptList ')'  */
#line 4827 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 35011 "gram.c"
    break;

  case 606: /* OptParenthesizedSeqOptList: %empty  */
#line 4828 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 35017 "gram.c"
    break;

  case 607: /* SeqOptList: SeqOptElem  */
#line 4831 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35023 "gram.c"
    break;

  case 608: /* SeqOptList: SeqOptList SeqOptElem  */
#line 4832 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 35029 "gram.c"
    break;

  case 609: /* SeqOptElem: AS SimpleTypename  */
#line 4836 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].typnam), (yylsp[-1]));
				}
#line 35037 "gram.c"
    break;

  case 610: /* SeqOptElem: CACHE NumericOnly  */
#line 4840 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cache", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 35045 "gram.c"
    break;

  case 611: /* SeqOptElem: CYCLE  */
#line 4844 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 35053 "gram.c"
    break;

  case 612: /* SeqOptElem: NO CYCLE  */
#line 4848 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 35061 "gram.c"
    break;

  case 613: /* SeqOptElem: INCREMENT opt_by NumericOnly  */
#line 4852 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("increment", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 35069 "gram.c"
    break;

  case 614: /* SeqOptElem: MAXVALUE NumericOnly  */
#line 4856 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 35077 "gram.c"
    break;

  case 615: /* SeqOptElem: MINVALUE NumericOnly  */
#line 4860 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("minvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 35085 "gram.c"
    break;

  case 616: /* SeqOptElem: NO MAXVALUE  */
#line 4864 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("maxvalue", NULL, (yylsp[-1]));
				}
#line 35093 "gram.c"
    break;

  case 617: /* SeqOptElem: NO MINVALUE  */
#line 4868 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("minvalue", NULL, (yylsp[-1]));
				}
#line 35101 "gram.c"
    break;

  case 618: /* SeqOptElem: OWNED BY any_name  */
#line 4872 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("owned_by", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 35109 "gram.c"
    break;

  case 619: /* SeqOptElem: SEQUENCE NAME_P any_name  */
#line 4876 "gram.y"
                                {
					/* not documented, only used by pg_dump */
					(yyval.defelt) = makeDefElem("sequence_name", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 35118 "gram.c"
    break;

  case 620: /* SeqOptElem: START opt_with NumericOnly  */
#line 4881 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("start", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 35126 "gram.c"
    break;

  case 621: /* SeqOptElem: RESTART  */
#line 4885 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 35134 "gram.c"
    break;

  case 622: /* SeqOptElem: RESTART opt_with NumericOnly  */
#line 4889 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 35142 "gram.c"
    break;

  case 625: /* NumericOnly: FCONST  */
#line 4899 "gram.y"
                                                                                        { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 35148 "gram.c"
    break;

  case 626: /* NumericOnly: '+' FCONST  */
#line 4900 "gram.y"
                                                                                { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 35154 "gram.c"
    break;

  case 627: /* NumericOnly: '-' FCONST  */
#line 4902 "gram.y"
                                {
					Float	   *f = makeFloat((yyvsp[0].str));

					doNegateFloat(f);
					(yyval.node) = (Node *) f;
				}
#line 35165 "gram.c"
    break;

  case 628: /* NumericOnly: SignedIconst  */
#line 4908 "gram.y"
                                                                                { (yyval.node) = (Node *) makeInteger((yyvsp[0].ival)); }
#line 35171 "gram.c"
    break;

  case 629: /* NumericOnly_list: NumericOnly  */
#line 4911 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35177 "gram.c"
    break;

  case 630: /* NumericOnly_list: NumericOnly_list ',' NumericOnly  */
#line 4912 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35183 "gram.c"
    break;

  case 631: /* CreatePLangStmt: CREATE opt_or_replace opt_trusted opt_procedural LANGUAGE name  */
#line 4925 "gram.y"
                        {
				/*
				 * We now interpret parameterless CREATE LANGUAGE as
				 * CREATE EXTENSION.  "OR REPLACE" is silently translated
				 * to "IF NOT EXISTS", which isn't quite the same, but
				 * seems more useful than throwing an error.  We just
				 * ignore TRUSTED, as the previous code would have too.
				 */
				CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

				n->if_not_exists = (yyvsp[-4].boolean);
				n->extname = (yyvsp[0].str);
				n->options = NIL;
				(yyval.node) = (Node *) n;
			}
#line 35203 "gram.c"
    break;

  case 632: /* CreatePLangStmt: CREATE opt_or_replace opt_trusted opt_procedural LANGUAGE name HANDLER handler_name opt_inline_handler opt_validator  */
#line 4942 "gram.y"
                        {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);

				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *) n;
			}
#line 35219 "gram.c"
    break;

  case 633: /* opt_trusted: TRUSTED  */
#line 4956 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 35225 "gram.c"
    break;

  case 634: /* opt_trusted: %empty  */
#line 4957 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 35231 "gram.c"
    break;

  case 635: /* handler_name: name  */
#line 4965 "gram.y"
                                                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35237 "gram.c"
    break;

  case 636: /* handler_name: name attrs  */
#line 4966 "gram.y"
                                                                { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 35243 "gram.c"
    break;

  case 637: /* opt_inline_handler: INLINE_P handler_name  */
#line 4970 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 35249 "gram.c"
    break;

  case 638: /* opt_inline_handler: %empty  */
#line 4971 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 35255 "gram.c"
    break;

  case 639: /* validator_clause: VALIDATOR handler_name  */
#line 4975 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 35261 "gram.c"
    break;

  case 640: /* validator_clause: NO VALIDATOR  */
#line 4976 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 35267 "gram.c"
    break;

  case 641: /* opt_validator: validator_clause  */
#line 4980 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 35273 "gram.c"
    break;

  case 642: /* opt_validator: %empty  */
#line 4981 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 35279 "gram.c"
    break;

  case 645: /* CreateTableSpaceStmt: CREATE TABLESPACE name OptTableSpaceOwner LOCATION Sconst opt_reloptions  */
#line 4997 "gram.y"
                                {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);

					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].rolespec);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35293 "gram.c"
    break;

  case 646: /* OptTableSpaceOwner: OWNER RoleSpec  */
#line 5008 "gram.y"
                                                { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 35299 "gram.c"
    break;

  case 647: /* OptTableSpaceOwner: %empty  */
#line 5009 "gram.y"
                                                                { (yyval.rolespec) = NULL; }
#line 35305 "gram.c"
    break;

  case 648: /* DropTableSpaceStmt: DROP TABLESPACE name  */
#line 5023 "gram.y"
                                {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 35317 "gram.c"
    break;

  case 649: /* DropTableSpaceStmt: DROP TABLESPACE IF_P EXISTS name  */
#line 5031 "gram.y"
                                {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 35329 "gram.c"
    break;

  case 650: /* CreateExtensionStmt: CREATE EXTENSION name opt_with create_extension_opt_list  */
#line 5049 "gram.y"
                                {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35342 "gram.c"
    break;

  case 651: /* CreateExtensionStmt: CREATE EXTENSION IF_P NOT EXISTS name opt_with create_extension_opt_list  */
#line 5058 "gram.y"
                                {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35355 "gram.c"
    break;

  case 652: /* create_extension_opt_list: create_extension_opt_list create_extension_opt_item  */
#line 5070 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 35361 "gram.c"
    break;

  case 653: /* create_extension_opt_list: %empty  */
#line 5072 "gram.y"
                                { (yyval.list) = NIL; }
#line 35367 "gram.c"
    break;

  case 654: /* create_extension_opt_item: SCHEMA name  */
#line 5077 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("schema", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 35375 "gram.c"
    break;

  case 655: /* create_extension_opt_item: VERSION_P NonReservedWord_or_Sconst  */
#line 5081 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 35383 "gram.c"
    break;

  case 656: /* create_extension_opt_item: FROM NonReservedWord_or_Sconst  */
#line 5085 "gram.y"
                                {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE EXTENSION ... FROM is no longer supported"),
							 parser_errposition((yylsp[-1]))));
				}
#line 35394 "gram.c"
    break;

  case 657: /* create_extension_opt_item: CASCADE  */
#line 5092 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cascade", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 35402 "gram.c"
    break;

  case 658: /* AlterExtensionStmt: ALTER EXTENSION name UPDATE alter_extension_opt_list  */
#line 5104 "gram.y"
                                {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35414 "gram.c"
    break;

  case 659: /* alter_extension_opt_list: alter_extension_opt_list alter_extension_opt_item  */
#line 5115 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 35420 "gram.c"
    break;

  case 660: /* alter_extension_opt_list: %empty  */
#line 5117 "gram.y"
                                { (yyval.list) = NIL; }
#line 35426 "gram.c"
    break;

  case 661: /* alter_extension_opt_item: TO NonReservedWord_or_Sconst  */
#line 5122 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 35434 "gram.c"
    break;

  case 662: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop object_type_name name  */
#line 5135 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 35448 "gram.c"
    break;

  case 663: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop object_type_any_name any_name  */
#line 5145 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35462 "gram.c"
    break;

  case 664: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop AGGREGATE aggregate_with_argtypes  */
#line 5155 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 35476 "gram.c"
    break;

  case 665: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop CAST '(' Typename AS Typename ')'  */
#line 5165 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 35490 "gram.c"
    break;

  case 666: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop DOMAIN_P Typename  */
#line 5175 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 35504 "gram.c"
    break;

  case 667: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop FUNCTION function_with_argtypes  */
#line 5185 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 35518 "gram.c"
    break;

  case 668: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop OPERATOR operator_with_argtypes  */
#line 5195 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 35532 "gram.c"
    break;

  case 669: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop OPERATOR CLASS any_name USING name  */
#line 5205 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 35546 "gram.c"
    break;

  case 670: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop OPERATOR FAMILY any_name USING name  */
#line 5215 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 35560 "gram.c"
    break;

  case 671: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop PROCEDURE function_with_argtypes  */
#line 5225 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 35574 "gram.c"
    break;

  case 672: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop ROUTINE function_with_argtypes  */
#line 5235 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 35588 "gram.c"
    break;

  case 673: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TRANSFORM FOR Typename LANGUAGE name  */
#line 5245 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-2].typnam), makeString((yyvsp[0].str)));
					(yyval.node) = (Node *) n;
				}
#line 35602 "gram.c"
    break;

  case 674: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TYPE_P Typename  */
#line 5255 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 35616 "gram.c"
    break;

  case 675: /* CreateFdwStmt: CREATE FOREIGN DATA_P WRAPPER name opt_fdw_options create_generic_options  */
#line 5274 "gram.y"
                                {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35629 "gram.c"
    break;

  case 676: /* fdw_option: HANDLER handler_name  */
#line 5285 "gram.y"
                                                                        { (yyval.defelt) = makeDefElem("handler", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 35635 "gram.c"
    break;

  case 677: /* fdw_option: NO HANDLER  */
#line 5286 "gram.y"
                                                                                { (yyval.defelt) = makeDefElem("handler", NULL, (yylsp[-1])); }
#line 35641 "gram.c"
    break;

  case 678: /* fdw_option: VALIDATOR handler_name  */
#line 5287 "gram.y"
                                                                        { (yyval.defelt) = makeDefElem("validator", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 35647 "gram.c"
    break;

  case 679: /* fdw_option: NO VALIDATOR  */
#line 5288 "gram.y"
                                                                                { (yyval.defelt) = makeDefElem("validator", NULL, (yylsp[-1])); }
#line 35653 "gram.c"
    break;

  case 680: /* fdw_options: fdw_option  */
#line 5292 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35659 "gram.c"
    break;

  case 681: /* fdw_options: fdw_options fdw_option  */
#line 5293 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 35665 "gram.c"
    break;

  case 682: /* opt_fdw_options: fdw_options  */
#line 5297 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 35671 "gram.c"
    break;

  case 683: /* opt_fdw_options: %empty  */
#line 5298 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 35677 "gram.c"
    break;

  case 684: /* AlterFdwStmt: ALTER FOREIGN DATA_P WRAPPER name opt_fdw_options alter_generic_options  */
#line 5309 "gram.y"
                                {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35690 "gram.c"
    break;

  case 685: /* AlterFdwStmt: ALTER FOREIGN DATA_P WRAPPER name fdw_options  */
#line 5318 "gram.y"
                                {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 35703 "gram.c"
    break;

  case 686: /* create_generic_options: OPTIONS '(' generic_option_list ')'  */
#line 5330 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 35709 "gram.c"
    break;

  case 687: /* create_generic_options: %empty  */
#line 5331 "gram.y"
                                                                                                        { (yyval.list) = NIL; }
#line 35715 "gram.c"
    break;

  case 688: /* generic_option_list: generic_option_elem  */
#line 5336 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 35723 "gram.c"
    break;

  case 689: /* generic_option_list: generic_option_list ',' generic_option_elem  */
#line 5340 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 35731 "gram.c"
    break;

  case 690: /* alter_generic_options: OPTIONS '(' alter_generic_option_list ')'  */
#line 5347 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 35737 "gram.c"
    break;

  case 691: /* alter_generic_option_list: alter_generic_option_elem  */
#line 5352 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 35745 "gram.c"
    break;

  case 692: /* alter_generic_option_list: alter_generic_option_list ',' alter_generic_option_elem  */
#line 5356 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 35753 "gram.c"
    break;

  case 693: /* alter_generic_option_elem: generic_option_elem  */
#line 5363 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 35761 "gram.c"
    break;

  case 694: /* alter_generic_option_elem: SET generic_option_elem  */
#line 5367 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 35770 "gram.c"
    break;

  case 695: /* alter_generic_option_elem: ADD_P generic_option_elem  */
#line 5372 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 35779 "gram.c"
    break;

  case 696: /* alter_generic_option_elem: DROP generic_option_name  */
#line 5377 "gram.y"
                                {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP, (yylsp[0]));
				}
#line 35787 "gram.c"
    break;

  case 697: /* generic_option_elem: generic_option_name generic_option_arg  */
#line 5384 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 35795 "gram.c"
    break;

  case 698: /* generic_option_name: ColLabel  */
#line 5390 "gram.y"
                                                                { (yyval.str) = (yyvsp[0].str); }
#line 35801 "gram.c"
    break;

  case 699: /* generic_option_arg: Sconst  */
#line 5395 "gram.y"
                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 35807 "gram.c"
    break;

  case 700: /* CreateForeignServerStmt: CREATE SERVER name opt_type opt_foreign_server_version FOREIGN DATA_P WRAPPER name create_generic_options  */
#line 5407 "gram.y"
                                {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 35823 "gram.c"
    break;

  case 701: /* CreateForeignServerStmt: CREATE SERVER IF_P NOT EXISTS name opt_type opt_foreign_server_version FOREIGN DATA_P WRAPPER name create_generic_options  */
#line 5420 "gram.y"
                                {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 35839 "gram.c"
    break;

  case 702: /* opt_type: TYPE_P Sconst  */
#line 5434 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 35845 "gram.c"
    break;

  case 703: /* opt_type: %empty  */
#line 5435 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 35851 "gram.c"
    break;

  case 704: /* foreign_server_version: VERSION_P Sconst  */
#line 5440 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 35857 "gram.c"
    break;

  case 705: /* foreign_server_version: VERSION_P NULL_P  */
#line 5441 "gram.y"
                                                        { (yyval.str) = NULL; }
#line 35863 "gram.c"
    break;

  case 706: /* opt_foreign_server_version: foreign_server_version  */
#line 5445 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 35869 "gram.c"
    break;

  case 707: /* opt_foreign_server_version: %empty  */
#line 5446 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 35875 "gram.c"
    break;

  case 708: /* AlterForeignServerStmt: ALTER SERVER name foreign_server_version alter_generic_options  */
#line 5457 "gram.y"
                                {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 35889 "gram.c"
    break;

  case 709: /* AlterForeignServerStmt: ALTER SERVER name foreign_server_version  */
#line 5467 "gram.y"
                                {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 35902 "gram.c"
    break;

  case 710: /* AlterForeignServerStmt: ALTER SERVER name alter_generic_options  */
#line 5476 "gram.y"
                                {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35914 "gram.c"
    break;

  case 711: /* CreateForeignTableStmt: CREATE FOREIGN TABLE qualified_name '(' OptTableElementList ')' OptInherit SERVER name create_generic_options  */
#line 5496 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35937 "gram.c"
    break;

  case 712: /* CreateForeignTableStmt: CREATE FOREIGN TABLE IF_P NOT EXISTS qualified_name '(' OptTableElementList ')' OptInherit SERVER name create_generic_options  */
#line 5517 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35960 "gram.c"
    break;

  case 713: /* CreateForeignTableStmt: CREATE FOREIGN TABLE qualified_name PARTITION OF qualified_name OptTypedTableElementList PartitionBoundSpec SERVER name create_generic_options  */
#line 5538 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35984 "gram.c"
    break;

  case 714: /* CreateForeignTableStmt: CREATE FOREIGN TABLE IF_P NOT EXISTS qualified_name PARTITION OF qualified_name OptTypedTableElementList PartitionBoundSpec SERVER name create_generic_options  */
#line 5560 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36008 "gram.c"
    break;

  case 715: /* ImportForeignSchemaStmt: IMPORT_P FOREIGN SCHEMA name import_qualification FROM SERVER name INTO name create_generic_options  */
#line 5593 "gram.y"
                        {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);

				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 36024 "gram.c"
    break;

  case 716: /* import_qualification_type: LIMIT TO  */
#line 5607 "gram.y"
                                                        { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 36030 "gram.c"
    break;

  case 717: /* import_qualification_type: EXCEPT  */
#line 5608 "gram.y"
                                                        { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 36036 "gram.c"
    break;

  case 718: /* import_qualification: import_qualification_type '(' relation_expr_list ')'  */
#line 5613 "gram.y"
                        {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));

				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 36048 "gram.c"
    break;

  case 719: /* import_qualification: %empty  */
#line 5621 "gram.y"
                        {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 36059 "gram.c"
    break;

  case 720: /* CreateUserMappingStmt: CREATE USER MAPPING FOR auth_ident SERVER name create_generic_options  */
#line 5637 "gram.y"
                                {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 36073 "gram.c"
    break;

  case 721: /* CreateUserMappingStmt: CREATE USER MAPPING IF_P NOT EXISTS FOR auth_ident SERVER name create_generic_options  */
#line 5647 "gram.y"
                                {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 36087 "gram.c"
    break;

  case 722: /* auth_ident: RoleSpec  */
#line 5659 "gram.y"
                                        { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 36093 "gram.c"
    break;

  case 723: /* auth_ident: USER  */
#line 5660 "gram.y"
                                                        { (yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 36099 "gram.c"
    break;

  case 724: /* DropUserMappingStmt: DROP USER MAPPING FOR auth_ident SERVER name  */
#line 5673 "gram.y"
                                {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 36112 "gram.c"
    break;

  case 725: /* DropUserMappingStmt: DROP USER MAPPING IF_P EXISTS FOR auth_ident SERVER name  */
#line 5682 "gram.y"
                                {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 36125 "gram.c"
    break;

  case 726: /* AlterUserMappingStmt: ALTER USER MAPPING FOR auth_ident SERVER name alter_generic_options  */
#line 5700 "gram.y"
                                {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36138 "gram.c"
    break;

  case 727: /* CreatePolicyStmt: CREATE POLICY name ON qualified_name RowSecurityDefaultPermissive RowSecurityDefaultForCmd RowSecurityDefaultToRole RowSecurityOptionalExpr RowSecurityOptionalWithCheck  */
#line 5727 "gram.y"
                                {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);

					n->policy_name = (yyvsp[-7].str);
					n->table = (yyvsp[-5].range);
					n->permissive = (yyvsp[-4].boolean);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 36155 "gram.c"
    break;

  case 728: /* AlterPolicyStmt: ALTER POLICY name ON qualified_name RowSecurityOptionalToRole RowSecurityOptionalExpr RowSecurityOptionalWithCheck  */
#line 5744 "gram.y"
                                {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);

					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 36170 "gram.c"
    break;

  case 729: /* RowSecurityOptionalExpr: USING '(' a_expr ')'  */
#line 5757 "gram.y"
                                                { (yyval.node) = (yyvsp[-1].node); }
#line 36176 "gram.c"
    break;

  case 730: /* RowSecurityOptionalExpr: %empty  */
#line 5758 "gram.y"
                                                        { (yyval.node) = NULL; }
#line 36182 "gram.c"
    break;

  case 731: /* RowSecurityOptionalWithCheck: WITH CHECK '(' a_expr ')'  */
#line 5762 "gram.y"
                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 36188 "gram.c"
    break;

  case 732: /* RowSecurityOptionalWithCheck: %empty  */
#line 5763 "gram.y"
                                                                        { (yyval.node) = NULL; }
#line 36194 "gram.c"
    break;

  case 733: /* RowSecurityDefaultToRole: TO role_list  */
#line 5767 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 36200 "gram.c"
    break;

  case 734: /* RowSecurityDefaultToRole: %empty  */
#line 5768 "gram.y"
                                                        { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 36206 "gram.c"
    break;

  case 735: /* RowSecurityOptionalToRole: TO role_list  */
#line 5772 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 36212 "gram.c"
    break;

  case 736: /* RowSecurityOptionalToRole: %empty  */
#line 5773 "gram.y"
                                                        { (yyval.list) = NULL; }
#line 36218 "gram.c"
    break;

  case 737: /* RowSecurityDefaultPermissive: AS IDENT  */
#line 5778 "gram.y"
                                {
					if (strcmp((yyvsp[0].str), "permissive") == 0)
						(yyval.boolean) = true;
					else if (strcmp((yyvsp[0].str), "restrictive") == 0)
						(yyval.boolean) = false;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized row security option \"%s\"", (yyvsp[0].str)),
								 errhint("Only PERMISSIVE or RESTRICTIVE policies are supported currently."),
								 parser_errposition((yylsp[0]))));

				}
#line 36236 "gram.c"
    break;

  case 738: /* RowSecurityDefaultPermissive: %empty  */
#line 5791 "gram.y"
                                                        { (yyval.boolean) = true; }
#line 36242 "gram.c"
    break;

  case 739: /* RowSecurityDefaultForCmd: FOR row_security_cmd  */
#line 5795 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 36248 "gram.c"
    break;

  case 740: /* RowSecurityDefaultForCmd: %empty  */
#line 5796 "gram.y"
                                                        { (yyval.str) = "all"; }
#line 36254 "gram.c"
    break;

  case 741: /* row_security_cmd: ALL  */
#line 5800 "gram.y"
                                                        { (yyval.str) = "all"; }
#line 36260 "gram.c"
    break;

  case 742: /* row_security_cmd: SELECT  */
#line 5801 "gram.y"
                                                { (yyval.str) = "select"; }
#line 36266 "gram.c"
    break;

  case 743: /* row_security_cmd: INSERT  */
#line 5802 "gram.y"
                                                { (yyval.str) = "insert"; }
#line 36272 "gram.c"
    break;

  case 744: /* row_security_cmd: UPDATE  */
#line 5803 "gram.y"
                                                { (yyval.str) = "update"; }
#line 36278 "gram.c"
    break;

  case 745: /* row_security_cmd: DELETE_P  */
#line 5804 "gram.y"
                                                { (yyval.str) = "delete"; }
#line 36284 "gram.c"
    break;

  case 746: /* CreateAmStmt: CREATE ACCESS METHOD name TYPE_P am_type HANDLER handler_name  */
#line 5815 "gram.y"
                                {
					CreateAmStmt *n = makeNode(CreateAmStmt);

					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = (yyvsp[-2].chr);
					(yyval.node) = (Node *) n;
				}
#line 36297 "gram.c"
    break;

  case 747: /* am_type: INDEX  */
#line 5826 "gram.y"
                                                { (yyval.chr) = AMTYPE_INDEX; }
#line 36303 "gram.c"
    break;

  case 748: /* am_type: TABLE  */
#line 5827 "gram.y"
                                                { (yyval.chr) = AMTYPE_TABLE; }
#line 36309 "gram.c"
    break;

  case 749: /* CreateTrigStmt: CREATE opt_or_replace TRIGGER name TriggerActionTime TriggerEvents ON qualified_name TriggerReferencing TriggerForSpec TriggerWhen EXECUTE FUNCTION_or_PROCEDURE func_name '(' TriggerFuncArgs ')'  */
#line 5841 "gram.y"
                                {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-15].boolean);
					n->isconstraint = false;
					n->trigname = (yyvsp[-13].str);
					n->relation = (yyvsp[-9].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-12].ival);
					n->events = intVal(linitial((yyvsp[-11].list)));
					n->columns = (List *) lsecond((yyvsp[-11].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = (yyvsp[-8].list);
					n->deferrable = false;
					n->initdeferred = false;
					n->constrrel = NULL;
					(yyval.node) = (Node *) n;
				}
#line 36334 "gram.c"
    break;

  case 750: /* CreateTrigStmt: CREATE opt_or_replace CONSTRAINT TRIGGER name AFTER TriggerEvents ON qualified_name OptConstrFromTable ConstraintAttributeSpec FOR EACH ROW TriggerWhen EXECUTE FUNCTION_or_PROCEDURE func_name '(' TriggerFuncArgs ')'  */
#line 5865 "gram.y"
                                {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-19].boolean);
					if (n->replace) /* not supported, see CreateTrigger */
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE OR REPLACE CONSTRAINT TRIGGER is not supported")));
					n->isconstraint = true;
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = true;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = NIL;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *) n;
				}
#line 36364 "gram.c"
    break;

  case 751: /* TriggerActionTime: BEFORE  */
#line 5893 "gram.y"
                                                                                        { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 36370 "gram.c"
    break;

  case 752: /* TriggerActionTime: AFTER  */
#line 5894 "gram.y"
                                                                                        { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 36376 "gram.c"
    break;

  case 753: /* TriggerActionTime: INSTEAD OF  */
#line 5895 "gram.y"
                                                                                { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 36382 "gram.c"
    break;

  case 754: /* TriggerEvents: TriggerOneEvent  */
#line 5900 "gram.y"
                                { (yyval.list) = (yyvsp[0].list); }
#line 36388 "gram.c"
    break;

  case 755: /* TriggerEvents: TriggerEvents OR TriggerOneEvent  */
#line 5902 "gram.y"
                                {
					int			events1 = intVal(linitial((yyvsp[-2].list)));
					int			events2 = intVal(linitial((yyvsp[0].list)));
					List	   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List	   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 36411 "gram.c"
    break;

  case 756: /* TriggerOneEvent: INSERT  */
#line 5924 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 36417 "gram.c"
    break;

  case 757: /* TriggerOneEvent: DELETE_P  */
#line 5926 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 36423 "gram.c"
    break;

  case 758: /* TriggerOneEvent: UPDATE  */
#line 5928 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 36429 "gram.c"
    break;

  case 759: /* TriggerOneEvent: UPDATE OF columnList  */
#line 5930 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 36435 "gram.c"
    break;

  case 760: /* TriggerOneEvent: TRUNCATE  */
#line 5932 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 36441 "gram.c"
    break;

  case 761: /* TriggerReferencing: REFERENCING TriggerTransitions  */
#line 5936 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 36447 "gram.c"
    break;

  case 762: /* TriggerReferencing: %empty  */
#line 5937 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 36453 "gram.c"
    break;

  case 763: /* TriggerTransitions: TriggerTransition  */
#line 5941 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36459 "gram.c"
    break;

  case 764: /* TriggerTransitions: TriggerTransitions TriggerTransition  */
#line 5942 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 36465 "gram.c"
    break;

  case 765: /* TriggerTransition: TransitionOldOrNew TransitionRowOrTable opt_as TransitionRelName  */
#line 5947 "gram.y"
                                {
					TriggerTransition *n = makeNode(TriggerTransition);

					n->name = (yyvsp[0].str);
					n->isNew = (yyvsp[-3].boolean);
					n->isTable = (yyvsp[-2].boolean);
					(yyval.node) = (Node *) n;
				}
#line 36478 "gram.c"
    break;

  case 766: /* TransitionOldOrNew: NEW  */
#line 5958 "gram.y"
                                                                                                        { (yyval.boolean) = true; }
#line 36484 "gram.c"
    break;

  case 767: /* TransitionOldOrNew: OLD  */
#line 5959 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 36490 "gram.c"
    break;

  case 768: /* TransitionRowOrTable: TABLE  */
#line 5963 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 36496 "gram.c"
    break;

  case 769: /* TransitionRowOrTable: ROW  */
#line 5972 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 36502 "gram.c"
    break;

  case 770: /* TransitionRelName: ColId  */
#line 5976 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 36508 "gram.c"
    break;

  case 771: /* TriggerForSpec: FOR TriggerForOptEach TriggerForType  */
#line 5981 "gram.y"
                                {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 36516 "gram.c"
    break;

  case 772: /* TriggerForSpec: %empty  */
#line 5985 "gram.y"
                                {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = false;
				}
#line 36528 "gram.c"
    break;

  case 775: /* TriggerForType: ROW  */
#line 6000 "gram.y"
                                                                                                        { (yyval.boolean) = true; }
#line 36534 "gram.c"
    break;

  case 776: /* TriggerForType: STATEMENT  */
#line 6001 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 36540 "gram.c"
    break;

  case 777: /* TriggerWhen: WHEN '(' a_expr ')'  */
#line 6005 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[-1].node); }
#line 36546 "gram.c"
    break;

  case 778: /* TriggerWhen: %empty  */
#line 6006 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 36552 "gram.c"
    break;

  case 781: /* TriggerFuncArgs: TriggerFuncArg  */
#line 6015 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36558 "gram.c"
    break;

  case 782: /* TriggerFuncArgs: TriggerFuncArgs ',' TriggerFuncArg  */
#line 6016 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 36564 "gram.c"
    break;

  case 783: /* TriggerFuncArgs: %empty  */
#line 6017 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 36570 "gram.c"
    break;

  case 784: /* TriggerFuncArg: Iconst  */
#line 6022 "gram.y"
                                {
					(yyval.node) = (Node *) makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 36578 "gram.c"
    break;

  case 785: /* TriggerFuncArg: FCONST  */
#line 6025 "gram.y"
                                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 36584 "gram.c"
    break;

  case 786: /* TriggerFuncArg: Sconst  */
#line 6026 "gram.y"
                                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 36590 "gram.c"
    break;

  case 787: /* TriggerFuncArg: ColLabel  */
#line 6027 "gram.y"
                                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 36596 "gram.c"
    break;

  case 788: /* OptConstrFromTable: FROM qualified_name  */
#line 6031 "gram.y"
                                                                                        { (yyval.range) = (yyvsp[0].range); }
#line 36602 "gram.c"
    break;

  case 789: /* OptConstrFromTable: %empty  */
#line 6032 "gram.y"
                                                                                                { (yyval.range) = NULL; }
#line 36608 "gram.c"
    break;

  case 790: /* ConstraintAttributeSpec: %empty  */
#line 6037 "gram.y"
                                { (yyval.ival) = 0; }
#line 36614 "gram.c"
    break;

  case 791: /* ConstraintAttributeSpec: ConstraintAttributeSpec ConstraintAttributeElem  */
#line 6039 "gram.y"
                                {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 36642 "gram.c"
    break;

  case 792: /* ConstraintAttributeElem: NOT DEFERRABLE  */
#line 6065 "gram.y"
                                                                        { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 36648 "gram.c"
    break;

  case 793: /* ConstraintAttributeElem: DEFERRABLE  */
#line 6066 "gram.y"
                                                                        { (yyval.ival) = CAS_DEFERRABLE; }
#line 36654 "gram.c"
    break;

  case 794: /* ConstraintAttributeElem: INITIALLY IMMEDIATE  */
#line 6067 "gram.y"
                                                                { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 36660 "gram.c"
    break;

  case 795: /* ConstraintAttributeElem: INITIALLY DEFERRED  */
#line 6068 "gram.y"
                                                                { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 36666 "gram.c"
    break;

  case 796: /* ConstraintAttributeElem: NOT VALID  */
#line 6069 "gram.y"
                                                                                { (yyval.ival) = CAS_NOT_VALID; }
#line 36672 "gram.c"
    break;

  case 797: /* ConstraintAttributeElem: NO INHERIT  */
#line 6070 "gram.y"
                                                                        { (yyval.ival) = CAS_NO_INHERIT; }
#line 36678 "gram.c"
    break;

  case 798: /* CreateEventTrigStmt: CREATE EVENT TRIGGER name ON ColLabel EXECUTE FUNCTION_or_PROCEDURE func_name '(' ')'  */
#line 6085 "gram.y"
                                {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 36692 "gram.c"
    break;

  case 799: /* CreateEventTrigStmt: CREATE EVENT TRIGGER name ON ColLabel WHEN event_trigger_when_list EXECUTE FUNCTION_or_PROCEDURE func_name '(' ')'  */
#line 6097 "gram.y"
                                {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 36706 "gram.c"
    break;

  case 800: /* event_trigger_when_list: event_trigger_when_item  */
#line 6110 "gram.y"
                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36712 "gram.c"
    break;

  case 801: /* event_trigger_when_list: event_trigger_when_list AND event_trigger_when_item  */
#line 6112 "gram.y"
                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 36718 "gram.c"
    break;

  case 802: /* event_trigger_when_item: ColId IN_P '(' event_trigger_value_list ')'  */
#line 6117 "gram.y"
                        { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list), (yylsp[-4])); }
#line 36724 "gram.c"
    break;

  case 803: /* event_trigger_value_list: SCONST  */
#line 6122 "gram.y"
                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36730 "gram.c"
    break;

  case 804: /* event_trigger_value_list: event_trigger_value_list ',' SCONST  */
#line 6124 "gram.y"
                        { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 36736 "gram.c"
    break;

  case 805: /* AlterEventTrigStmt: ALTER EVENT TRIGGER name enable_trigger  */
#line 6129 "gram.y"
                                {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);

					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 36748 "gram.c"
    break;

  case 806: /* enable_trigger: ENABLE_P  */
#line 6139 "gram.y"
                                                                        { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 36754 "gram.c"
    break;

  case 807: /* enable_trigger: ENABLE_P REPLICA  */
#line 6140 "gram.y"
                                                                { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 36760 "gram.c"
    break;

  case 808: /* enable_trigger: ENABLE_P ALWAYS  */
#line 6141 "gram.y"
                                                                { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 36766 "gram.c"
    break;

  case 809: /* enable_trigger: DISABLE_P  */
#line 6142 "gram.y"
                                                                        { (yyval.chr) = TRIGGER_DISABLED; }
#line 36772 "gram.c"
    break;

  case 810: /* CreateAssertionStmt: CREATE ASSERTION any_name CHECK '(' a_expr ')' ConstraintAttributeSpec  */
#line 6154 "gram.y"
                                {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = NULL;
				}
#line 36784 "gram.c"
    break;

  case 811: /* DefineStmt: CREATE opt_or_replace AGGREGATE func_name aggr_args definition  */
#line 6173 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->replace = (yyvsp[-4].boolean);
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36800 "gram.c"
    break;

  case 812: /* DefineStmt: CREATE opt_or_replace AGGREGATE func_name old_aggr_definition  */
#line 6185 "gram.y"
                                {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->replace = (yyvsp[-3].boolean);
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36817 "gram.c"
    break;

  case 813: /* DefineStmt: CREATE OPERATOR any_operator definition  */
#line 6198 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36832 "gram.c"
    break;

  case 814: /* DefineStmt: CREATE TYPE_P any_name definition  */
#line 6209 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36847 "gram.c"
    break;

  case 815: /* DefineStmt: CREATE TYPE_P any_name  */
#line 6220 "gram.y"
                                {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *) n;
				}
#line 36863 "gram.c"
    break;

  case 816: /* DefineStmt: CREATE TYPE_P any_name AS '(' OptTableFuncElementList ')'  */
#line 6232 "gram.y"
                                {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36876 "gram.c"
    break;

  case 817: /* DefineStmt: CREATE TYPE_P any_name AS ENUM_P '(' opt_enum_val_list ')'  */
#line 6241 "gram.y"
                                {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);

					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36888 "gram.c"
    break;

  case 818: /* DefineStmt: CREATE TYPE_P any_name AS RANGE definition  */
#line 6249 "gram.y"
                                {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);

					n->typeName = (yyvsp[-3].list);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36900 "gram.c"
    break;

  case 819: /* DefineStmt: CREATE TEXT_P SEARCH PARSER any_name definition  */
#line 6257 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36914 "gram.c"
    break;

  case 820: /* DefineStmt: CREATE TEXT_P SEARCH DICTIONARY any_name definition  */
#line 6267 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36928 "gram.c"
    break;

  case 821: /* DefineStmt: CREATE TEXT_P SEARCH TEMPLATE any_name definition  */
#line 6277 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36942 "gram.c"
    break;

  case 822: /* DefineStmt: CREATE TEXT_P SEARCH CONFIGURATION any_name definition  */
#line 6287 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36956 "gram.c"
    break;

  case 823: /* DefineStmt: CREATE COLLATION any_name definition  */
#line 6297 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36970 "gram.c"
    break;

  case 824: /* DefineStmt: CREATE COLLATION IF_P NOT EXISTS any_name definition  */
#line 6307 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 36985 "gram.c"
    break;

  case 825: /* DefineStmt: CREATE COLLATION any_name FROM any_name  */
#line 6318 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 36999 "gram.c"
    break;

  case 826: /* DefineStmt: CREATE COLLATION IF_P NOT EXISTS any_name FROM any_name  */
#line 6328 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 37014 "gram.c"
    break;

  case 827: /* definition: '(' def_list ')'  */
#line 6340 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 37020 "gram.c"
    break;

  case 828: /* def_list: def_elem  */
#line 6343 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37026 "gram.c"
    break;

  case 829: /* def_list: def_list ',' def_elem  */
#line 6344 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 37032 "gram.c"
    break;

  case 830: /* def_elem: ColLabel '=' def_arg  */
#line 6348 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 37040 "gram.c"
    break;

  case 831: /* def_elem: ColLabel  */
#line 6352 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 37048 "gram.c"
    break;

  case 832: /* def_arg: func_type  */
#line 6358 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 37054 "gram.c"
    break;

  case 833: /* def_arg: reserved_keyword  */
#line 6359 "gram.y"
                                                                        { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 37060 "gram.c"
    break;

  case 834: /* def_arg: qual_all_Op  */
#line 6360 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 37066 "gram.c"
    break;

  case 835: /* def_arg: NumericOnly  */
#line 6361 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 37072 "gram.c"
    break;

  case 836: /* def_arg: Sconst  */
#line 6362 "gram.y"
                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 37078 "gram.c"
    break;

  case 837: /* def_arg: NONE  */
#line 6363 "gram.y"
                                                                                { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 37084 "gram.c"
    break;

  case 838: /* old_aggr_definition: '(' old_aggr_list ')'  */
#line 6366 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 37090 "gram.c"
    break;

  case 839: /* old_aggr_list: old_aggr_elem  */
#line 6369 "gram.y"
                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37096 "gram.c"
    break;

  case 840: /* old_aggr_list: old_aggr_list ',' old_aggr_elem  */
#line 6370 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 37102 "gram.c"
    break;

  case 841: /* old_aggr_elem: IDENT '=' def_arg  */
#line 6379 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 37110 "gram.c"
    break;

  case 842: /* opt_enum_val_list: enum_val_list  */
#line 6385 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 37116 "gram.c"
    break;

  case 843: /* opt_enum_val_list: %empty  */
#line 6386 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 37122 "gram.c"
    break;

  case 844: /* enum_val_list: Sconst  */
#line 6390 "gram.y"
                                { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 37128 "gram.c"
    break;

  case 845: /* enum_val_list: enum_val_list ',' Sconst  */
#line 6392 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 37134 "gram.c"
    break;

  case 846: /* AlterEnumStmt: ALTER TYPE_P any_name ADD_P VALUE_P opt_if_not_exists Sconst  */
#line 6403 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-4].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 37150 "gram.c"
    break;

  case 847: /* AlterEnumStmt: ALTER TYPE_P any_name ADD_P VALUE_P opt_if_not_exists Sconst BEFORE Sconst  */
#line 6415 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 37166 "gram.c"
    break;

  case 848: /* AlterEnumStmt: ALTER TYPE_P any_name ADD_P VALUE_P opt_if_not_exists Sconst AFTER Sconst  */
#line 6427 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 37182 "gram.c"
    break;

  case 849: /* AlterEnumStmt: ALTER TYPE_P any_name RENAME VALUE_P Sconst TO Sconst  */
#line 6439 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-5].list);
				n->oldVal = (yyvsp[-2].str);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = false;
				n->skipIfNewValExists = false;
				(yyval.node) = (Node *) n;
			}
#line 37198 "gram.c"
    break;

  case 850: /* opt_if_not_exists: IF_P NOT EXISTS  */
#line 6452 "gram.y"
                                                { (yyval.boolean) = true; }
#line 37204 "gram.c"
    break;

  case 851: /* opt_if_not_exists: %empty  */
#line 6453 "gram.y"
                                                       { (yyval.boolean) = false; }
#line 37210 "gram.c"
    break;

  case 852: /* CreateOpClassStmt: CREATE OPERATOR CLASS any_name opt_default FOR TYPE_P Typename USING name opt_opfamily AS opclass_item_list  */
#line 6471 "gram.y"
                                {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);

					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37226 "gram.c"
    break;

  case 853: /* opclass_item_list: opclass_item  */
#line 6485 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 37232 "gram.c"
    break;

  case 854: /* opclass_item_list: opclass_item_list ',' opclass_item  */
#line 6486 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 37238 "gram.c"
    break;

  case 855: /* opclass_item: OPERATOR Iconst any_operator opclass_purpose opt_recheck  */
#line 6491 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					ObjectWithArgs *owa = makeNode(ObjectWithArgs);

					owa->objname = (yyvsp[-2].list);
					owa->objargs = NIL;
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = owa;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37255 "gram.c"
    break;

  case 856: /* opclass_item: OPERATOR Iconst operator_with_argtypes opclass_purpose opt_recheck  */
#line 6505 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].objwithargs);
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37269 "gram.c"
    break;

  case 857: /* opclass_item: FUNCTION Iconst function_with_argtypes  */
#line 6515 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-1].ival);
					(yyval.node) = (Node *) n;
				}
#line 37282 "gram.c"
    break;

  case 858: /* opclass_item: FUNCTION Iconst '(' type_list ')' function_with_argtypes  */
#line 6524 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-4].ival);
					n->class_args = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 37296 "gram.c"
    break;

  case 859: /* opclass_item: STORAGE Typename  */
#line 6534 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 37308 "gram.c"
    break;

  case 860: /* opt_default: DEFAULT  */
#line 6543 "gram.y"
                                                                { (yyval.boolean) = true; }
#line 37314 "gram.c"
    break;

  case 861: /* opt_default: %empty  */
#line 6544 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 37320 "gram.c"
    break;

  case 862: /* opt_opfamily: FAMILY any_name  */
#line 6547 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 37326 "gram.c"
    break;

  case 863: /* opt_opfamily: %empty  */
#line 6548 "gram.y"
                                                                                { (yyval.list) = NIL; }
#line 37332 "gram.c"
    break;

  case 864: /* opclass_purpose: FOR SEARCH  */
#line 6551 "gram.y"
                                                                { (yyval.list) = NIL; }
#line 37338 "gram.c"
    break;

  case 865: /* opclass_purpose: FOR ORDER BY any_name  */
#line 6552 "gram.y"
                                                                { (yyval.list) = (yyvsp[0].list); }
#line 37344 "gram.c"
    break;

  case 866: /* opclass_purpose: %empty  */
#line 6553 "gram.y"
                                                                                { (yyval.list) = NIL; }
#line 37350 "gram.c"
    break;

  case 867: /* opt_recheck: RECHECK  */
#line 6557 "gram.y"
                                {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = true;
				}
#line 37368 "gram.c"
    break;

  case 868: /* opt_recheck: %empty  */
#line 6570 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 37374 "gram.c"
    break;

  case 869: /* CreateOpFamilyStmt: CREATE OPERATOR FAMILY any_name USING name  */
#line 6576 "gram.y"
                                {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);

					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37386 "gram.c"
    break;

  case 870: /* AlterOpFamilyStmt: ALTER OPERATOR FAMILY any_name USING name ADD_P opclass_item_list  */
#line 6587 "gram.y"
                                {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37400 "gram.c"
    break;

  case 871: /* AlterOpFamilyStmt: ALTER OPERATOR FAMILY any_name USING name DROP opclass_drop_list  */
#line 6597 "gram.y"
                                {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37414 "gram.c"
    break;

  case 872: /* opclass_drop_list: opclass_drop  */
#line 6609 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 37420 "gram.c"
    break;

  case 873: /* opclass_drop_list: opclass_drop_list ',' opclass_drop  */
#line 6610 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 37426 "gram.c"
    break;

  case 874: /* opclass_drop: OPERATOR Iconst '(' type_list ')'  */
#line 6615 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37439 "gram.c"
    break;

  case 875: /* opclass_drop: FUNCTION Iconst '(' type_list ')'  */
#line 6624 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37452 "gram.c"
    break;

  case 876: /* DropOpClassStmt: DROP OPERATOR CLASS any_name USING name opt_drop_behavior  */
#line 6637 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37467 "gram.c"
    break;

  case 877: /* DropOpClassStmt: DROP OPERATOR CLASS IF_P EXISTS any_name USING name opt_drop_behavior  */
#line 6648 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37482 "gram.c"
    break;

  case 878: /* DropOpFamilyStmt: DROP OPERATOR FAMILY any_name USING name opt_drop_behavior  */
#line 6662 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37497 "gram.c"
    break;

  case 879: /* DropOpFamilyStmt: DROP OPERATOR FAMILY IF_P EXISTS any_name USING name opt_drop_behavior  */
#line 6673 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37512 "gram.c"
    break;

  case 880: /* DropOwnedStmt: DROP OWNED BY role_list opt_drop_behavior  */
#line 6696 "gram.y"
                                {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);

					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37524 "gram.c"
    break;

  case 881: /* ReassignOwnedStmt: REASSIGN OWNED BY role_list TO RoleSpec  */
#line 6707 "gram.y"
                                {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);

					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 37536 "gram.c"
    break;

  case 882: /* DropStmt: DROP object_type_any_name IF_P EXISTS any_name_list opt_drop_behavior  */
#line 6726 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37551 "gram.c"
    break;

  case 883: /* DropStmt: DROP object_type_any_name any_name_list opt_drop_behavior  */
#line 6737 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37566 "gram.c"
    break;

  case 884: /* DropStmt: DROP drop_type_name IF_P EXISTS name_list opt_drop_behavior  */
#line 6748 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37581 "gram.c"
    break;

  case 885: /* DropStmt: DROP drop_type_name name_list opt_drop_behavior  */
#line 6759 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37596 "gram.c"
    break;

  case 886: /* DropStmt: DROP object_type_name_on_any_name name ON any_name opt_drop_behavior  */
#line 6770 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37611 "gram.c"
    break;

  case 887: /* DropStmt: DROP object_type_name_on_any_name IF_P EXISTS name ON any_name opt_drop_behavior  */
#line 6781 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-6].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37626 "gram.c"
    break;

  case 888: /* DropStmt: DROP TYPE_P type_name_list opt_drop_behavior  */
#line 6792 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37641 "gram.c"
    break;

  case 889: /* DropStmt: DROP TYPE_P IF_P EXISTS type_name_list opt_drop_behavior  */
#line 6803 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37656 "gram.c"
    break;

  case 890: /* DropStmt: DROP DOMAIN_P type_name_list opt_drop_behavior  */
#line 6814 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37671 "gram.c"
    break;

  case 891: /* DropStmt: DROP DOMAIN_P IF_P EXISTS type_name_list opt_drop_behavior  */
#line 6825 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37686 "gram.c"
    break;

  case 892: /* DropStmt: DROP INDEX CONCURRENTLY any_name_list opt_drop_behavior  */
#line 6836 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 37701 "gram.c"
    break;

  case 893: /* DropStmt: DROP INDEX CONCURRENTLY IF_P EXISTS any_name_list opt_drop_behavior  */
#line 6847 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 37716 "gram.c"
    break;

  case 894: /* object_type_any_name: TABLE  */
#line 6861 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_TABLE; }
#line 37722 "gram.c"
    break;

  case 895: /* object_type_any_name: SEQUENCE  */
#line 6862 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 37728 "gram.c"
    break;

  case 896: /* object_type_any_name: VIEW  */
#line 6863 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_VIEW; }
#line 37734 "gram.c"
    break;

  case 897: /* object_type_any_name: MATERIALIZED VIEW  */
#line 6864 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_MATVIEW; }
#line 37740 "gram.c"
    break;

  case 898: /* object_type_any_name: INDEX  */
#line 6865 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_INDEX; }
#line 37746 "gram.c"
    break;

  case 899: /* object_type_any_name: FOREIGN TABLE  */
#line 6866 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 37752 "gram.c"
    break;

  case 900: /* object_type_any_name: COLLATION  */
#line 6867 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_COLLATION; }
#line 37758 "gram.c"
    break;

  case 901: /* object_type_any_name: CONVERSION_P  */
#line 6868 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_CONVERSION; }
#line 37764 "gram.c"
    break;

  case 902: /* object_type_any_name: STATISTICS  */
#line 6869 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 37770 "gram.c"
    break;

  case 903: /* object_type_any_name: TEXT_P SEARCH PARSER  */
#line 6870 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TSPARSER; }
#line 37776 "gram.c"
    break;

  case 904: /* object_type_any_name: TEXT_P SEARCH DICTIONARY  */
#line 6871 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 37782 "gram.c"
    break;

  case 905: /* object_type_any_name: TEXT_P SEARCH TEMPLATE  */
#line 6872 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 37788 "gram.c"
    break;

  case 906: /* object_type_any_name: TEXT_P SEARCH CONFIGURATION  */
#line 6873 "gram.y"
                                                                        { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 37794 "gram.c"
    break;

  case 907: /* object_type_name: drop_type_name  */
#line 6883 "gram.y"
                                                                                        { (yyval.objtype) = (yyvsp[0].objtype); }
#line 37800 "gram.c"
    break;

  case 908: /* object_type_name: DATABASE  */
#line 6884 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_DATABASE; }
#line 37806 "gram.c"
    break;

  case 909: /* object_type_name: ROLE  */
#line 6885 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_ROLE; }
#line 37812 "gram.c"
    break;

  case 910: /* object_type_name: SUBSCRIPTION  */
#line 6886 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 37818 "gram.c"
    break;

  case 911: /* object_type_name: TABLESPACE  */
#line 6887 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 37824 "gram.c"
    break;

  case 912: /* drop_type_name: ACCESS METHOD  */
#line 6891 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 37830 "gram.c"
    break;

  case 913: /* drop_type_name: EVENT TRIGGER  */
#line 6892 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 37836 "gram.c"
    break;

  case 914: /* drop_type_name: EXTENSION  */
#line 6893 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_EXTENSION; }
#line 37842 "gram.c"
    break;

  case 915: /* drop_type_name: FOREIGN DATA_P WRAPPER  */
#line 6894 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_FDW; }
#line 37848 "gram.c"
    break;

  case 916: /* drop_type_name: opt_procedural LANGUAGE  */
#line 6895 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 37854 "gram.c"
    break;

  case 917: /* drop_type_name: PUBLICATION  */
#line 6896 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 37860 "gram.c"
    break;

  case 918: /* drop_type_name: SCHEMA  */
#line 6897 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_SCHEMA; }
#line 37866 "gram.c"
    break;

  case 919: /* drop_type_name: SERVER  */
#line 6898 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 37872 "gram.c"
    break;

  case 920: /* object_type_name_on_any_name: POLICY  */
#line 6903 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_POLICY; }
#line 37878 "gram.c"
    break;

  case 921: /* object_type_name_on_any_name: RULE  */
#line 6904 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_RULE; }
#line 37884 "gram.c"
    break;

  case 922: /* object_type_name_on_any_name: TRIGGER  */
#line 6905 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_TRIGGER; }
#line 37890 "gram.c"
    break;

  case 923: /* any_name_list: any_name  */
#line 6909 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 37896 "gram.c"
    break;

  case 924: /* any_name_list: any_name_list ',' any_name  */
#line 6910 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 37902 "gram.c"
    break;

  case 925: /* any_name: ColId  */
#line 6913 "gram.y"
                                                                { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 37908 "gram.c"
    break;

  case 926: /* any_name: ColId attrs  */
#line 6914 "gram.y"
                                                                { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 37914 "gram.c"
    break;

  case 927: /* attrs: '.' attr_name  */
#line 6918 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 37920 "gram.c"
    break;

  case 928: /* attrs: attrs '.' attr_name  */
#line 6920 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 37926 "gram.c"
    break;

  case 929: /* type_name_list: Typename  */
#line 6924 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 37932 "gram.c"
    break;

  case 930: /* type_name_list: type_name_list ',' Typename  */
#line 6925 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 37938 "gram.c"
    break;

  case 931: /* TruncateStmt: TRUNCATE opt_table relation_expr_list opt_restart_seqs opt_drop_behavior  */
#line 6937 "gram.y"
                                {
					TruncateStmt *n = makeNode(TruncateStmt);

					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37951 "gram.c"
    break;

  case 932: /* opt_restart_seqs: CONTINUE_P IDENTITY_P  */
#line 6948 "gram.y"
                                                        { (yyval.boolean) = false; }
#line 37957 "gram.c"
    break;

  case 933: /* opt_restart_seqs: RESTART IDENTITY_P  */
#line 6949 "gram.y"
                                                        { (yyval.boolean) = true; }
#line 37963 "gram.c"
    break;

  case 934: /* opt_restart_seqs: %empty  */
#line 6950 "gram.y"
                                                                { (yyval.boolean) = false; }
#line 37969 "gram.c"
    break;

  case 935: /* CommentStmt: COMMENT ON object_type_any_name any_name IS comment_text  */
#line 6961 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37982 "gram.c"
    break;

  case 936: /* CommentStmt: COMMENT ON COLUMN any_name IS comment_text  */
#line 6970 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37995 "gram.c"
    break;

  case 937: /* CommentStmt: COMMENT ON object_type_name name IS comment_text  */
#line 6979 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38008 "gram.c"
    break;

  case 938: /* CommentStmt: COMMENT ON TYPE_P Typename IS comment_text  */
#line 6988 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38021 "gram.c"
    break;

  case 939: /* CommentStmt: COMMENT ON DOMAIN_P Typename IS comment_text  */
#line 6997 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38034 "gram.c"
    break;

  case 940: /* CommentStmt: COMMENT ON AGGREGATE aggregate_with_argtypes IS comment_text  */
#line 7006 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38047 "gram.c"
    break;

  case 941: /* CommentStmt: COMMENT ON FUNCTION function_with_argtypes IS comment_text  */
#line 7015 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38060 "gram.c"
    break;

  case 942: /* CommentStmt: COMMENT ON OPERATOR operator_with_argtypes IS comment_text  */
#line 7024 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38073 "gram.c"
    break;

  case 943: /* CommentStmt: COMMENT ON CONSTRAINT name ON any_name IS comment_text  */
#line 7033 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TABCONSTRAINT;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38086 "gram.c"
    break;

  case 944: /* CommentStmt: COMMENT ON CONSTRAINT name ON DOMAIN_P any_name IS comment_text  */
#line 7042 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->object = (Node *) list_make2(makeTypeNameFromNameList((yyvsp[-2].list)), makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38104 "gram.c"
    break;

  case 945: /* CommentStmt: COMMENT ON object_type_name_on_any_name name ON any_name IS comment_text  */
#line 7056 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-5].objtype);
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38117 "gram.c"
    break;

  case 946: /* CommentStmt: COMMENT ON PROCEDURE function_with_argtypes IS comment_text  */
#line 7065 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38130 "gram.c"
    break;

  case 947: /* CommentStmt: COMMENT ON ROUTINE function_with_argtypes IS comment_text  */
#line 7074 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38143 "gram.c"
    break;

  case 948: /* CommentStmt: COMMENT ON TRANSFORM FOR Typename LANGUAGE name IS comment_text  */
#line 7083 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-4].typnam), makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38156 "gram.c"
    break;

  case 949: /* CommentStmt: COMMENT ON OPERATOR CLASS any_name USING name IS comment_text  */
#line 7092 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38169 "gram.c"
    break;

  case 950: /* CommentStmt: COMMENT ON OPERATOR FAMILY any_name USING name IS comment_text  */
#line 7101 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38182 "gram.c"
    break;

  case 951: /* CommentStmt: COMMENT ON LARGE_P OBJECT_P NumericOnly IS comment_text  */
#line 7110 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38195 "gram.c"
    break;

  case 952: /* CommentStmt: COMMENT ON CAST '(' Typename AS Typename ')' IS comment_text  */
#line 7119 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-5].typnam), (yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38208 "gram.c"
    break;

  case 953: /* comment_text: Sconst  */
#line 7130 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 38214 "gram.c"
    break;

  case 954: /* comment_text: NULL_P  */
#line 7131 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 38220 "gram.c"
    break;

  case 955: /* SecLabelStmt: SECURITY LABEL opt_provider ON object_type_any_name any_name IS security_label  */
#line 7147 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38234 "gram.c"
    break;

  case 956: /* SecLabelStmt: SECURITY LABEL opt_provider ON COLUMN any_name IS security_label  */
#line 7158 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38248 "gram.c"
    break;

  case 957: /* SecLabelStmt: SECURITY LABEL opt_provider ON object_type_name name IS security_label  */
#line 7169 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38262 "gram.c"
    break;

  case 958: /* SecLabelStmt: SECURITY LABEL opt_provider ON TYPE_P Typename IS security_label  */
#line 7180 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38276 "gram.c"
    break;

  case 959: /* SecLabelStmt: SECURITY LABEL opt_provider ON DOMAIN_P Typename IS security_label  */
#line 7191 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38290 "gram.c"
    break;

  case 960: /* SecLabelStmt: SECURITY LABEL opt_provider ON AGGREGATE aggregate_with_argtypes IS security_label  */
#line 7202 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38304 "gram.c"
    break;

  case 961: /* SecLabelStmt: SECURITY LABEL opt_provider ON FUNCTION function_with_argtypes IS security_label  */
#line 7213 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38318 "gram.c"
    break;

  case 962: /* SecLabelStmt: SECURITY LABEL opt_provider ON LARGE_P OBJECT_P NumericOnly IS security_label  */
#line 7224 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38332 "gram.c"
    break;

  case 963: /* SecLabelStmt: SECURITY LABEL opt_provider ON PROCEDURE function_with_argtypes IS security_label  */
#line 7235 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38346 "gram.c"
    break;

  case 964: /* SecLabelStmt: SECURITY LABEL opt_provider ON ROUTINE function_with_argtypes IS security_label  */
#line 7246 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38360 "gram.c"
    break;

  case 965: /* opt_provider: FOR NonReservedWord_or_Sconst  */
#line 7257 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 38366 "gram.c"
    break;

  case 966: /* opt_provider: %empty  */
#line 7258 "gram.y"
                                                                                { (yyval.str) = NULL; }
#line 38372 "gram.c"
    break;

  case 967: /* security_label: Sconst  */
#line 7261 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 38378 "gram.c"
    break;

  case 968: /* security_label: NULL_P  */
#line 7262 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 38384 "gram.c"
    break;

  case 969: /* FetchStmt: FETCH fetch_args  */
#line 7273 "gram.y"
                                {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = false;
					(yyval.node) = (Node *) n;
				}
#line 38395 "gram.c"
    break;

  case 970: /* FetchStmt: MOVE fetch_args  */
#line 7280 "gram.y"
                                {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = true;
					(yyval.node) = (Node *) n;
				}
#line 38406 "gram.c"
    break;

  case 971: /* fetch_args: cursor_name  */
#line 7289 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 38419 "gram.c"
    break;

  case 972: /* fetch_args: from_in cursor_name  */
#line 7298 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 38432 "gram.c"
    break;

  case 973: /* fetch_args: NEXT opt_from_in cursor_name  */
#line 7307 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 38445 "gram.c"
    break;

  case 974: /* fetch_args: PRIOR opt_from_in cursor_name  */
#line 7316 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 38458 "gram.c"
    break;

  case 975: /* fetch_args: FIRST_P opt_from_in cursor_name  */
#line 7325 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 38471 "gram.c"
    break;

  case 976: /* fetch_args: LAST_P opt_from_in cursor_name  */
#line 7334 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *) n;
				}
#line 38484 "gram.c"
    break;

  case 977: /* fetch_args: ABSOLUTE_P SignedIconst opt_from_in cursor_name  */
#line 7343 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 38497 "gram.c"
    break;

  case 978: /* fetch_args: RELATIVE_P SignedIconst opt_from_in cursor_name  */
#line 7352 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 38510 "gram.c"
    break;

  case 979: /* fetch_args: SignedIconst opt_from_in cursor_name  */
#line 7361 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 38523 "gram.c"
    break;

  case 980: /* fetch_args: ALL opt_from_in cursor_name  */
#line 7370 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 38536 "gram.c"
    break;

  case 981: /* fetch_args: FORWARD opt_from_in cursor_name  */
#line 7379 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 38549 "gram.c"
    break;

  case 982: /* fetch_args: FORWARD SignedIconst opt_from_in cursor_name  */
#line 7388 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 38562 "gram.c"
    break;

  case 983: /* fetch_args: FORWARD ALL opt_from_in cursor_name  */
#line 7397 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 38575 "gram.c"
    break;

  case 984: /* fetch_args: BACKWARD opt_from_in cursor_name  */
#line 7406 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 38588 "gram.c"
    break;

  case 985: /* fetch_args: BACKWARD SignedIconst opt_from_in cursor_name  */
#line 7415 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 38601 "gram.c"
    break;

  case 986: /* fetch_args: BACKWARD ALL opt_from_in cursor_name  */
#line 7424 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 38614 "gram.c"
    break;

  case 991: /* GrantStmt: GRANT privileges ON privilege_target TO grantee_list opt_grant_grant_option opt_granted_by  */
#line 7451 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grant_option = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 38632 "gram.c"
    break;

  case 992: /* RevokeStmt: REVOKE privileges ON privilege_target FROM grantee_list opt_granted_by opt_drop_behavior  */
#line 7469 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38651 "gram.c"
    break;

  case 993: /* RevokeStmt: REVOKE GRANT OPTION FOR privileges ON privilege_target FROM grantee_list opt_granted_by opt_drop_behavior  */
#line 7485 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38670 "gram.c"
    break;

  case 994: /* privileges: privilege_list  */
#line 7512 "gram.y"
                                { (yyval.list) = (yyvsp[0].list); }
#line 38676 "gram.c"
    break;

  case 995: /* privileges: ALL  */
#line 7514 "gram.y"
                                { (yyval.list) = NIL; }
#line 38682 "gram.c"
    break;

  case 996: /* privileges: ALL PRIVILEGES  */
#line 7516 "gram.y"
                                { (yyval.list) = NIL; }
#line 38688 "gram.c"
    break;

  case 997: /* privileges: ALL '(' columnList ')'  */
#line 7518 "gram.y"
                                {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 38700 "gram.c"
    break;

  case 998: /* privileges: ALL PRIVILEGES '(' columnList ')'  */
#line 7526 "gram.y"
                                {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 38712 "gram.c"
    break;

  case 999: /* privilege_list: privilege  */
#line 7535 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 38718 "gram.c"
    break;

  case 1000: /* privilege_list: privilege_list ',' privilege  */
#line 7536 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 38724 "gram.c"
    break;

  case 1001: /* privilege: SELECT opt_column_list  */
#line 7540 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 38736 "gram.c"
    break;

  case 1002: /* privilege: REFERENCES opt_column_list  */
#line 7548 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 38748 "gram.c"
    break;

  case 1003: /* privilege: CREATE opt_column_list  */
#line 7556 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 38760 "gram.c"
    break;

  case 1004: /* privilege: ALTER SYSTEM_P  */
#line 7564 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup("alter system");
				n->cols = NIL;
				(yyval.accesspriv) = n;
			}
#line 38771 "gram.c"
    break;

  case 1005: /* privilege: ColId opt_column_list  */
#line 7571 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 38783 "gram.c"
    break;

  case 1006: /* parameter_name_list: parameter_name  */
#line 7582 "gram.y"
                        {
				(yyval.list) = list_make1(makeString((yyvsp[0].str)));
			}
#line 38791 "gram.c"
    break;

  case 1007: /* parameter_name_list: parameter_name_list ',' parameter_name  */
#line 7586 "gram.y"
                        {
				(yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str)));
			}
#line 38799 "gram.c"
    break;

  case 1008: /* parameter_name: ColId  */
#line 7593 "gram.y"
                        {
				(yyval.str) = (yyvsp[0].str);
			}
#line 38807 "gram.c"
    break;

  case 1009: /* parameter_name: parameter_name '.' ColId  */
#line 7597 "gram.y"
                        {
				(yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str));
			}
#line 38815 "gram.c"
    break;

  case 1010: /* privilege_target: qualified_name_list  */
#line 7608 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38828 "gram.c"
    break;

  case 1011: /* privilege_target: TABLE qualified_name_list  */
#line 7617 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38841 "gram.c"
    break;

  case 1012: /* privilege_target: SEQUENCE qualified_name_list  */
#line 7626 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38854 "gram.c"
    break;

  case 1013: /* privilege_target: FOREIGN DATA_P WRAPPER name_list  */
#line 7635 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38867 "gram.c"
    break;

  case 1014: /* privilege_target: FOREIGN SERVER name_list  */
#line 7644 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38880 "gram.c"
    break;

  case 1015: /* privilege_target: FUNCTION function_with_argtypes_list  */
#line 7653 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38893 "gram.c"
    break;

  case 1016: /* privilege_target: PROCEDURE function_with_argtypes_list  */
#line 7662 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38906 "gram.c"
    break;

  case 1017: /* privilege_target: ROUTINE function_with_argtypes_list  */
#line 7671 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38919 "gram.c"
    break;

  case 1018: /* privilege_target: DATABASE name_list  */
#line 7680 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38932 "gram.c"
    break;

  case 1019: /* privilege_target: DOMAIN_P any_name_list  */
#line 7689 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38945 "gram.c"
    break;

  case 1020: /* privilege_target: LANGUAGE name_list  */
#line 7698 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38958 "gram.c"
    break;

  case 1021: /* privilege_target: LARGE_P OBJECT_P NumericOnly_list  */
#line 7707 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38971 "gram.c"
    break;

  case 1022: /* privilege_target: PARAMETER parameter_name_list  */
#line 7716 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PARAMETER_ACL;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38983 "gram.c"
    break;

  case 1023: /* privilege_target: SCHEMA name_list  */
#line 7724 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SCHEMA;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38996 "gram.c"
    break;

  case 1024: /* privilege_target: TABLESPACE name_list  */
#line 7733 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39009 "gram.c"
    break;

  case 1025: /* privilege_target: TYPE_P any_name_list  */
#line 7742 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39022 "gram.c"
    break;

  case 1026: /* privilege_target: ALL TABLES IN_P SCHEMA name_list  */
#line 7751 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39035 "gram.c"
    break;

  case 1027: /* privilege_target: ALL SEQUENCES IN_P SCHEMA name_list  */
#line 7760 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39048 "gram.c"
    break;

  case 1028: /* privilege_target: ALL FUNCTIONS IN_P SCHEMA name_list  */
#line 7769 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39061 "gram.c"
    break;

  case 1029: /* privilege_target: ALL PROCEDURES IN_P SCHEMA name_list  */
#line 7778 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39074 "gram.c"
    break;

  case 1030: /* privilege_target: ALL ROUTINES IN_P SCHEMA name_list  */
#line 7787 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39087 "gram.c"
    break;

  case 1031: /* grantee_list: grantee  */
#line 7799 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 39093 "gram.c"
    break;

  case 1032: /* grantee_list: grantee_list ',' grantee  */
#line 7800 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 39099 "gram.c"
    break;

  case 1033: /* grantee: RoleSpec  */
#line 7804 "gram.y"
                                                                                                { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 39105 "gram.c"
    break;

  case 1034: /* grantee: GROUP_P RoleSpec  */
#line 7805 "gram.y"
                                                                                        { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 39111 "gram.c"
    break;

  case 1035: /* opt_grant_grant_option: WITH GRANT OPTION  */
#line 7810 "gram.y"
                                          { (yyval.boolean) = true; }
#line 39117 "gram.c"
    break;

  case 1036: /* opt_grant_grant_option: %empty  */
#line 7811 "gram.y"
                                    { (yyval.boolean) = false; }
#line 39123 "gram.c"
    break;

  case 1037: /* GrantRoleStmt: GRANT privilege_list TO role_list opt_grant_admin_option opt_granted_by  */
#line 7822 "gram.y"
                                {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->admin_opt = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 39138 "gram.c"
    break;

  case 1038: /* RevokeRoleStmt: REVOKE privilege_list FROM role_list opt_granted_by opt_drop_behavior  */
#line 7836 "gram.y"
                                {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39153 "gram.c"
    break;

  case 1039: /* RevokeRoleStmt: REVOKE ADMIN OPTION FOR privilege_list FROM role_list opt_granted_by opt_drop_behavior  */
#line 7847 "gram.y"
                                {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39168 "gram.c"
    break;

  case 1040: /* opt_grant_admin_option: WITH ADMIN OPTION  */
#line 7859 "gram.y"
                                                                        { (yyval.boolean) = true; }
#line 39174 "gram.c"
    break;

  case 1041: /* opt_grant_admin_option: %empty  */
#line 7860 "gram.y"
                                                                                                        { (yyval.boolean) = false; }
#line 39180 "gram.c"
    break;

  case 1042: /* opt_granted_by: GRANTED BY RoleSpec  */
#line 7863 "gram.y"
                                                                                { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 39186 "gram.c"
    break;

  case 1043: /* opt_granted_by: %empty  */
#line 7864 "gram.y"
                                                                                                        { (yyval.rolespec) = NULL; }
#line 39192 "gram.c"
    break;

  case 1044: /* AlterDefaultPrivilegesStmt: ALTER DEFAULT PRIVILEGES DefACLOptionList DefACLAction  */
#line 7875 "gram.y"
                                {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);

					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 39204 "gram.c"
    break;

  case 1045: /* DefACLOptionList: DefACLOptionList DefACLOption  */
#line 7885 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 39210 "gram.c"
    break;

  case 1046: /* DefACLOptionList: %empty  */
#line 7886 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 39216 "gram.c"
    break;

  case 1047: /* DefACLOption: IN_P SCHEMA name_list  */
#line 7891 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("schemas", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 39224 "gram.c"
    break;

  case 1048: /* DefACLOption: FOR ROLE role_list  */
#line 7895 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 39232 "gram.c"
    break;

  case 1049: /* DefACLOption: FOR USER role_list  */
#line 7899 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 39240 "gram.c"
    break;

  case 1050: /* DefACLAction: GRANT privileges ON defacl_privilege_target TO grantee_list opt_grant_grant_option  */
#line 7911 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 39257 "gram.c"
    break;

  case 1051: /* DefACLAction: REVOKE privileges ON defacl_privilege_target FROM grantee_list opt_drop_behavior  */
#line 7925 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39275 "gram.c"
    break;

  case 1052: /* DefACLAction: REVOKE GRANT OPTION FOR privileges ON defacl_privilege_target FROM grantee_list opt_drop_behavior  */
#line 7940 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39293 "gram.c"
    break;

  case 1053: /* defacl_privilege_target: TABLES  */
#line 7956 "gram.y"
                                                { (yyval.ival) = OBJECT_TABLE; }
#line 39299 "gram.c"
    break;

  case 1054: /* defacl_privilege_target: FUNCTIONS  */
#line 7957 "gram.y"
                                                { (yyval.ival) = OBJECT_FUNCTION; }
#line 39305 "gram.c"
    break;

  case 1055: /* defacl_privilege_target: ROUTINES  */
#line 7958 "gram.y"
                                                { (yyval.ival) = OBJECT_FUNCTION; }
#line 39311 "gram.c"
    break;

  case 1056: /* defacl_privilege_target: SEQUENCES  */
#line 7959 "gram.y"
                                                { (yyval.ival) = OBJECT_SEQUENCE; }
#line 39317 "gram.c"
    break;

  case 1057: /* defacl_privilege_target: TYPES_P  */
#line 7960 "gram.y"
                                                { (yyval.ival) = OBJECT_TYPE; }
#line 39323 "gram.c"
    break;

  case 1058: /* defacl_privilege_target: SCHEMAS  */
#line 7961 "gram.y"
                                                { (yyval.ival) = OBJECT_SCHEMA; }
#line 39329 "gram.c"
    break;

  case 1059: /* IndexStmt: CREATE opt_unique INDEX opt_concurrently opt_index_name ON relation_expr access_method_clause '(' index_params ')' opt_include opt_unique_null_treatment opt_reloptions OptTableSpace where_clause  */
#line 7976 "gram.y"
                                {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-14].boolean);
					n->concurrent = (yyvsp[-12].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilenodeSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 39363 "gram.c"
    break;

  case 1060: /* IndexStmt: CREATE opt_unique INDEX opt_concurrently IF_P NOT EXISTS name ON relation_expr access_method_clause '(' index_params ')' opt_include opt_unique_null_treatment opt_reloptions OptTableSpace where_clause  */
#line 8008 "gram.y"
                                {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-17].boolean);
					n->concurrent = (yyvsp[-15].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilenodeSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 39397 "gram.c"
    break;

  case 1061: /* opt_unique: UNIQUE  */
#line 8040 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 39403 "gram.c"
    break;

  case 1062: /* opt_unique: %empty  */
#line 8041 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 39409 "gram.c"
    break;

  case 1063: /* opt_concurrently: CONCURRENTLY  */
#line 8045 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 39415 "gram.c"
    break;

  case 1064: /* opt_concurrently: %empty  */
#line 8046 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 39421 "gram.c"
    break;

  case 1065: /* opt_index_name: name  */
#line 8050 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 39427 "gram.c"
    break;

  case 1066: /* opt_index_name: %empty  */
#line 8051 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 39433 "gram.c"
    break;

  case 1067: /* access_method_clause: USING name  */
#line 8055 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 39439 "gram.c"
    break;

  case 1068: /* access_method_clause: %empty  */
#line 8056 "gram.y"
                                                                                                { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 39445 "gram.c"
    break;

  case 1069: /* index_params: index_elem  */
#line 8059 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 39451 "gram.c"
    break;

  case 1070: /* index_params: index_params ',' index_elem  */
#line 8060 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 39457 "gram.c"
    break;

  case 1071: /* index_elem_options: opt_collate opt_class opt_asc_desc opt_nulls_order  */
#line 8066 "gram.y"
                {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-3].list);
			(yyval.ielem)->opclass = (yyvsp[-2].list);
			(yyval.ielem)->opclassopts = NIL;
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 39473 "gram.c"
    break;

  case 1072: /* index_elem_options: opt_collate any_name reloptions opt_asc_desc opt_nulls_order  */
#line 8078 "gram.y"
                {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-4].list);
			(yyval.ielem)->opclass = (yyvsp[-3].list);
			(yyval.ielem)->opclassopts = (yyvsp[-2].list);
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 39489 "gram.c"
    break;

  case 1073: /* index_elem: ColId index_elem_options  */
#line 8097 "gram.y"
                                {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->name = (yyvsp[-1].str);
				}
#line 39498 "gram.c"
    break;

  case 1074: /* index_elem: func_expr_windowless index_elem_options  */
#line 8102 "gram.y"
                                {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-1].node);
				}
#line 39507 "gram.c"
    break;

  case 1075: /* index_elem: '(' a_expr ')' index_elem_options  */
#line 8107 "gram.y"
                                {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-2].node);
				}
#line 39516 "gram.c"
    break;

  case 1076: /* opt_include: INCLUDE '(' index_including_params ')'  */
#line 8113 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 39522 "gram.c"
    break;

  case 1077: /* opt_include: %empty  */
#line 8114 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 39528 "gram.c"
    break;

  case 1078: /* index_including_params: index_elem  */
#line 8117 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 39534 "gram.c"
    break;

  case 1079: /* index_including_params: index_including_params ',' index_elem  */
#line 8118 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 39540 "gram.c"
    break;

  case 1080: /* opt_collate: COLLATE any_name  */
#line 8121 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 39546 "gram.c"
    break;

  case 1081: /* opt_collate: %empty  */
#line 8122 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 39552 "gram.c"
    break;

  case 1082: /* opt_class: any_name  */
#line 8125 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 39558 "gram.c"
    break;

  case 1083: /* opt_class: %empty  */
#line 8126 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 39564 "gram.c"
    break;

  case 1084: /* opt_asc_desc: ASC  */
#line 8129 "gram.y"
                                                                        { (yyval.ival) = SORTBY_ASC; }
#line 39570 "gram.c"
    break;

  case 1085: /* opt_asc_desc: DESC  */
#line 8130 "gram.y"
                                                                                { (yyval.ival) = SORTBY_DESC; }
#line 39576 "gram.c"
    break;

  case 1086: /* opt_asc_desc: %empty  */
#line 8131 "gram.y"
                                                                                { (yyval.ival) = SORTBY_DEFAULT; }
#line 39582 "gram.c"
    break;

  case 1087: /* opt_nulls_order: NULLS_LA FIRST_P  */
#line 8134 "gram.y"
                                                        { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 39588 "gram.c"
    break;

  case 1088: /* opt_nulls_order: NULLS_LA LAST_P  */
#line 8135 "gram.y"
                                                                        { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 39594 "gram.c"
    break;

  case 1089: /* opt_nulls_order: %empty  */
#line 8136 "gram.y"
                                                                                { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 39600 "gram.c"
    break;

  case 1090: /* CreateFunctionStmt: CREATE opt_or_replace FUNCTION func_name func_args_with_defaults RETURNS func_return opt_createfunc_opt_list opt_routine_body  */
#line 8154 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 39617 "gram.c"
    break;

  case 1091: /* CreateFunctionStmt: CREATE opt_or_replace FUNCTION func_name func_args_with_defaults RETURNS TABLE '(' table_func_column_list ')' opt_createfunc_opt_list opt_routine_body  */
#line 8168 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 39635 "gram.c"
    break;

  case 1092: /* CreateFunctionStmt: CREATE opt_or_replace FUNCTION func_name func_args_with_defaults opt_createfunc_opt_list opt_routine_body  */
#line 8183 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 39652 "gram.c"
    break;

  case 1093: /* CreateFunctionStmt: CREATE opt_or_replace PROCEDURE func_name func_args_with_defaults opt_createfunc_opt_list opt_routine_body  */
#line 8197 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = true;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 39669 "gram.c"
    break;

  case 1094: /* opt_or_replace: OR REPLACE  */
#line 8212 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 39675 "gram.c"
    break;

  case 1095: /* opt_or_replace: %empty  */
#line 8213 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 39681 "gram.c"
    break;

  case 1096: /* func_args: '(' func_args_list ')'  */
#line 8216 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 39687 "gram.c"
    break;

  case 1097: /* func_args: '(' ')'  */
#line 8217 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 39693 "gram.c"
    break;

  case 1098: /* func_args_list: func_arg  */
#line 8221 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 39699 "gram.c"
    break;

  case 1099: /* func_args_list: func_args_list ',' func_arg  */
#line 8222 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 39705 "gram.c"
    break;

  case 1100: /* function_with_argtypes_list: function_with_argtypes  */
#line 8226 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 39711 "gram.c"
    break;

  case 1101: /* function_with_argtypes_list: function_with_argtypes_list ',' function_with_argtypes  */
#line 8228 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 39717 "gram.c"
    break;

  case 1102: /* function_with_argtypes: func_name func_args  */
#line 8233 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractArgTypes((yyvsp[0].list));
					n->objfuncargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 39730 "gram.c"
    break;

  case 1103: /* function_with_argtypes: type_func_name_keyword  */
#line 8247 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString(pstrdup((yyvsp[0].keyword))));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 39742 "gram.c"
    break;

  case 1104: /* function_with_argtypes: ColId  */
#line 8255 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString((yyvsp[0].str)));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 39754 "gram.c"
    break;

  case 1105: /* function_with_argtypes: ColId indirection  */
#line 8263 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
												  yyscanner);
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 39767 "gram.c"
    break;

  case 1106: /* func_args_with_defaults: '(' func_args_with_defaults_list ')'  */
#line 8278 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 39773 "gram.c"
    break;

  case 1107: /* func_args_with_defaults: '(' ')'  */
#line 8279 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 39779 "gram.c"
    break;

  case 1108: /* func_args_with_defaults_list: func_arg_with_default  */
#line 8283 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 39785 "gram.c"
    break;

  case 1109: /* func_args_with_defaults_list: func_args_with_defaults_list ',' func_arg_with_default  */
#line 8285 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 39791 "gram.c"
    break;

  case 1110: /* func_arg: arg_class param_name func_type  */
#line 8300 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 39805 "gram.c"
    break;

  case 1111: /* func_arg: param_name arg_class func_type  */
#line 8310 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 39819 "gram.c"
    break;

  case 1112: /* func_arg: param_name func_type  */
#line 8320 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 39833 "gram.c"
    break;

  case 1113: /* func_arg: arg_class func_type  */
#line 8330 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 39847 "gram.c"
    break;

  case 1114: /* func_arg: func_type  */
#line 8340 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 39861 "gram.c"
    break;

  case 1115: /* arg_class: IN_P  */
#line 8352 "gram.y"
                                                                                { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 39867 "gram.c"
    break;

  case 1116: /* arg_class: OUT_P  */
#line 8353 "gram.y"
                                                                                        { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 39873 "gram.c"
    break;

  case 1117: /* arg_class: INOUT  */
#line 8354 "gram.y"
                                                                                        { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 39879 "gram.c"
    break;

  case 1118: /* arg_class: IN_P OUT_P  */
#line 8355 "gram.y"
                                                                                { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 39885 "gram.c"
    break;

  case 1119: /* arg_class: VARIADIC  */
#line 8356 "gram.y"
                                                                                        { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 39891 "gram.c"
    break;

  case 1121: /* func_return: func_type  */
#line 8367 "gram.y"
                                {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 39903 "gram.c"
    break;

  case 1122: /* func_type: Typename  */
#line 8381 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 39909 "gram.c"
    break;

  case 1123: /* func_type: type_function_name attrs '%' TYPE_P  */
#line 8383 "gram.y"
                                {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 39919 "gram.c"
    break;

  case 1124: /* func_type: SETOF type_function_name attrs '%' TYPE_P  */
#line 8389 "gram.y"
                                {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 39930 "gram.c"
    break;

  case 1125: /* func_arg_with_default: func_arg  */
#line 8399 "gram.y"
                                {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 39938 "gram.c"
    break;

  case 1126: /* func_arg_with_default: func_arg DEFAULT a_expr  */
#line 8403 "gram.y"
                                {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 39947 "gram.c"
    break;

  case 1127: /* func_arg_with_default: func_arg '=' a_expr  */
#line 8408 "gram.y"
                                {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 39956 "gram.c"
    break;

  case 1128: /* aggr_arg: func_arg  */
#line 8416 "gram.y"
                                {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_DEFAULT ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 39971 "gram.c"
    break;

  case 1129: /* aggr_args: '(' '*' ')'  */
#line 8458 "gram.y"
                                {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 39979 "gram.c"
    break;

  case 1130: /* aggr_args: '(' aggr_args_list ')'  */
#line 8462 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 39987 "gram.c"
    break;

  case 1131: /* aggr_args: '(' ORDER BY aggr_args_list ')'  */
#line 8466 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 39995 "gram.c"
    break;

  case 1132: /* aggr_args: '(' aggr_args_list ORDER BY aggr_args_list ')'  */
#line 8470 "gram.y"
                                {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 40004 "gram.c"
    break;

  case 1133: /* aggr_args_list: aggr_arg  */
#line 8477 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 40010 "gram.c"
    break;

  case 1134: /* aggr_args_list: aggr_args_list ',' aggr_arg  */
#line 8478 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 40016 "gram.c"
    break;

  case 1135: /* aggregate_with_argtypes: func_name aggr_args  */
#line 8483 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					n->objfuncargs = (List *) linitial((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 40029 "gram.c"
    break;

  case 1136: /* aggregate_with_argtypes_list: aggregate_with_argtypes  */
#line 8494 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 40035 "gram.c"
    break;

  case 1137: /* aggregate_with_argtypes_list: aggregate_with_argtypes_list ',' aggregate_with_argtypes  */
#line 8496 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 40041 "gram.c"
    break;

  case 1139: /* opt_createfunc_opt_list: %empty  */
#line 8501 "gram.y"
                                    { (yyval.list) = NIL; }
#line 40047 "gram.c"
    break;

  case 1140: /* createfunc_opt_list: createfunc_opt_item  */
#line 8506 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40053 "gram.c"
    break;

  case 1141: /* createfunc_opt_list: createfunc_opt_list createfunc_opt_item  */
#line 8507 "gram.y"
                                                                  { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 40059 "gram.c"
    break;

  case 1142: /* common_func_opt_item: CALLED ON NULL_P INPUT_P  */
#line 8515 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(false), (yylsp[-3]));
				}
#line 40067 "gram.c"
    break;

  case 1143: /* common_func_opt_item: RETURNS NULL_P ON NULL_P INPUT_P  */
#line 8519 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[-4]));
				}
#line 40075 "gram.c"
    break;

  case 1144: /* common_func_opt_item: STRICT_P  */
#line 8523 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 40083 "gram.c"
    break;

  case 1145: /* common_func_opt_item: IMMUTABLE  */
#line 8527 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("immutable"), (yylsp[0]));
				}
#line 40091 "gram.c"
    break;

  case 1146: /* common_func_opt_item: STABLE  */
#line 8531 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("stable"), (yylsp[0]));
				}
#line 40099 "gram.c"
    break;

  case 1147: /* common_func_opt_item: VOLATILE  */
#line 8535 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("volatile"), (yylsp[0]));
				}
#line 40107 "gram.c"
    break;

  case 1148: /* common_func_opt_item: EXTERNAL SECURITY DEFINER  */
#line 8539 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-2]));
				}
#line 40115 "gram.c"
    break;

  case 1149: /* common_func_opt_item: EXTERNAL SECURITY INVOKER  */
#line 8543 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-2]));
				}
#line 40123 "gram.c"
    break;

  case 1150: /* common_func_opt_item: SECURITY DEFINER  */
#line 8547 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-1]));
				}
#line 40131 "gram.c"
    break;

  case 1151: /* common_func_opt_item: SECURITY INVOKER  */
#line 8551 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 40139 "gram.c"
    break;

  case 1152: /* common_func_opt_item: LEAKPROOF  */
#line 8555 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 40147 "gram.c"
    break;

  case 1153: /* common_func_opt_item: NOT LEAKPROOF  */
#line 8559 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 40155 "gram.c"
    break;

  case 1154: /* common_func_opt_item: COST NumericOnly  */
#line 8563 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cost", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 40163 "gram.c"
    break;

  case 1155: /* common_func_opt_item: ROWS NumericOnly  */
#line 8567 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("rows", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 40171 "gram.c"
    break;

  case 1156: /* common_func_opt_item: SUPPORT any_name  */
#line 8571 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("support", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 40179 "gram.c"
    break;

  case 1157: /* common_func_opt_item: FunctionSetResetClause  */
#line 8575 "gram.y"
                                {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *) (yyvsp[0].vsetstmt), (yylsp[0]));
				}
#line 40188 "gram.c"
    break;

  case 1158: /* common_func_opt_item: PARALLEL ColId  */
#line 8580 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("parallel", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 40196 "gram.c"
    break;

  case 1159: /* createfunc_opt_item: AS func_as  */
#line 8587 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 40204 "gram.c"
    break;

  case 1160: /* createfunc_opt_item: LANGUAGE NonReservedWord_or_Sconst  */
#line 8591 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 40212 "gram.c"
    break;

  case 1161: /* createfunc_opt_item: TRANSFORM transform_type_list  */
#line 8595 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("transform", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 40220 "gram.c"
    break;

  case 1162: /* createfunc_opt_item: WINDOW  */
#line 8599 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("window", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 40228 "gram.c"
    break;

  case 1163: /* createfunc_opt_item: common_func_opt_item  */
#line 8603 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 40236 "gram.c"
    break;

  case 1164: /* func_as: Sconst  */
#line 8608 "gram.y"
                                                                { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 40242 "gram.c"
    break;

  case 1165: /* func_as: Sconst ',' Sconst  */
#line 8610 "gram.y"
                                {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 40250 "gram.c"
    break;

  case 1166: /* ReturnStmt: RETURN a_expr  */
#line 8616 "gram.y"
                                {
					ReturnStmt *r = makeNode(ReturnStmt);

					r->returnval = (Node *) (yyvsp[0].node);
					(yyval.node) = (Node *) r;
				}
#line 40261 "gram.c"
    break;

  case 1167: /* opt_routine_body: ReturnStmt  */
#line 8626 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 40269 "gram.c"
    break;

  case 1168: /* opt_routine_body: BEGIN_P ATOMIC routine_body_stmt_list END_P  */
#line 8630 "gram.y"
                                {
					/*
					 * A compound statement is stored as a single-item list
					 * containing the list of statements as its member.  That
					 * way, the parse analysis code can tell apart an empty
					 * body from no body at all.
					 */
					(yyval.node) = (Node *) list_make1((yyvsp[-1].list));
				}
#line 40283 "gram.c"
    break;

  case 1169: /* opt_routine_body: %empty  */
#line 8640 "gram.y"
                                {
					(yyval.node) = NULL;
				}
#line 40291 "gram.c"
    break;

  case 1170: /* routine_body_stmt_list: routine_body_stmt_list routine_body_stmt ';'  */
#line 8647 "gram.y"
                                {
					/* As in stmtmulti, discard empty statements */
					if ((yyvsp[-1].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[-1].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 40303 "gram.c"
    break;

  case 1171: /* routine_body_stmt_list: %empty  */
#line 8655 "gram.y"
                                {
					(yyval.list) = NIL;
				}
#line 40311 "gram.c"
    break;

  case 1174: /* transform_type_list: FOR TYPE_P Typename  */
#line 8666 "gram.y"
                                            { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 40317 "gram.c"
    break;

  case 1175: /* transform_type_list: transform_type_list ',' FOR TYPE_P Typename  */
#line 8667 "gram.y"
                                                                      { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 40323 "gram.c"
    break;

  case 1176: /* opt_definition: WITH definition  */
#line 8671 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 40329 "gram.c"
    break;

  case 1177: /* opt_definition: %empty  */
#line 8672 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 40335 "gram.c"
    break;

  case 1178: /* table_func_column: param_name func_type  */
#line 8676 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 40349 "gram.c"
    break;

  case 1179: /* table_func_column_list: table_func_column  */
#line 8689 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 40357 "gram.c"
    break;

  case 1180: /* table_func_column_list: table_func_column_list ',' table_func_column  */
#line 8693 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 40365 "gram.c"
    break;

  case 1181: /* AlterFunctionStmt: ALTER FUNCTION function_with_argtypes alterfunc_opt_list opt_restrict  */
#line 8708 "gram.y"
                                {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_FUNCTION;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 40378 "gram.c"
    break;

  case 1182: /* AlterFunctionStmt: ALTER PROCEDURE function_with_argtypes alterfunc_opt_list opt_restrict  */
#line 8717 "gram.y"
                                {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 40391 "gram.c"
    break;

  case 1183: /* AlterFunctionStmt: ALTER ROUTINE function_with_argtypes alterfunc_opt_list opt_restrict  */
#line 8726 "gram.y"
                                {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_ROUTINE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 40404 "gram.c"
    break;

  case 1184: /* alterfunc_opt_list: common_func_opt_item  */
#line 8738 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40410 "gram.c"
    break;

  case 1185: /* alterfunc_opt_list: alterfunc_opt_list common_func_opt_item  */
#line 8739 "gram.y"
                                                                  { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 40416 "gram.c"
    break;

  case 1188: /* RemoveFuncStmt: DROP FUNCTION function_with_argtypes_list opt_drop_behavior  */
#line 8763 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 40431 "gram.c"
    break;

  case 1189: /* RemoveFuncStmt: DROP FUNCTION IF_P EXISTS function_with_argtypes_list opt_drop_behavior  */
#line 8774 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 40446 "gram.c"
    break;

  case 1190: /* RemoveFuncStmt: DROP PROCEDURE function_with_argtypes_list opt_drop_behavior  */
#line 8785 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 40461 "gram.c"
    break;

  case 1191: /* RemoveFuncStmt: DROP PROCEDURE IF_P EXISTS function_with_argtypes_list opt_drop_behavior  */
#line 8796 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 40476 "gram.c"
    break;

  case 1192: /* RemoveFuncStmt: DROP ROUTINE function_with_argtypes_list opt_drop_behavior  */
#line 8807 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 40491 "gram.c"
    break;

  case 1193: /* RemoveFuncStmt: DROP ROUTINE IF_P EXISTS function_with_argtypes_list opt_drop_behavior  */
#line 8818 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 40506 "gram.c"
    break;

  case 1194: /* RemoveAggrStmt: DROP AGGREGATE aggregate_with_argtypes_list opt_drop_behavior  */
#line 8832 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 40521 "gram.c"
    break;

  case 1195: /* RemoveAggrStmt: DROP AGGREGATE IF_P EXISTS aggregate_with_argtypes_list opt_drop_behavior  */
#line 8843 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 40536 "gram.c"
    break;

  case 1196: /* RemoveOperStmt: DROP OPERATOR operator_with_argtypes_list opt_drop_behavior  */
#line 8857 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 40551 "gram.c"
    break;

  case 1197: /* RemoveOperStmt: DROP OPERATOR IF_P EXISTS operator_with_argtypes_list opt_drop_behavior  */
#line 8868 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 40566 "gram.c"
    break;

  case 1198: /* oper_argtypes: '(' Typename ')'  */
#line 8882 "gram.y"
                                {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 40578 "gram.c"
    break;

  case 1199: /* oper_argtypes: '(' Typename ',' Typename ')'  */
#line 8890 "gram.y"
                                        { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 40584 "gram.c"
    break;

  case 1200: /* oper_argtypes: '(' NONE ',' Typename ')'  */
#line 8892 "gram.y"
                                        { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 40590 "gram.c"
    break;

  case 1201: /* oper_argtypes: '(' Typename ',' NONE ')'  */
#line 8894 "gram.y"
                                        { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 40596 "gram.c"
    break;

  case 1202: /* any_operator: all_Op  */
#line 8899 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 40602 "gram.c"
    break;

  case 1203: /* any_operator: ColId '.' any_operator  */
#line 8901 "gram.y"
                                        { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 40608 "gram.c"
    break;

  case 1204: /* operator_with_argtypes_list: operator_with_argtypes  */
#line 8905 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 40614 "gram.c"
    break;

  case 1205: /* operator_with_argtypes_list: operator_with_argtypes_list ',' operator_with_argtypes  */
#line 8907 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 40620 "gram.c"
    break;

  case 1206: /* operator_with_argtypes: any_operator oper_argtypes  */
#line 8912 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 40632 "gram.c"
    break;

  case 1207: /* DoStmt: DO dostmt_opt_list  */
#line 8931 "gram.y"
                                {
					DoStmt *n = makeNode(DoStmt);

					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 40643 "gram.c"
    break;

  case 1208: /* dostmt_opt_list: dostmt_opt_item  */
#line 8940 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40649 "gram.c"
    break;

  case 1209: /* dostmt_opt_list: dostmt_opt_list dostmt_opt_item  */
#line 8941 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 40655 "gram.c"
    break;

  case 1210: /* dostmt_opt_item: Sconst  */
#line 8946 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("as", (Node *) makeString((yyvsp[0].str)), (yylsp[0]));
				}
#line 40663 "gram.c"
    break;

  case 1211: /* dostmt_opt_item: LANGUAGE NonReservedWord_or_Sconst  */
#line 8950 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 40671 "gram.c"
    break;

  case 1212: /* CreateCastStmt: CREATE CAST '(' Typename AS Typename ')' WITH FUNCTION function_with_argtypes cast_context  */
#line 8963 "gram.y"
                                {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].objwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 40686 "gram.c"
    break;

  case 1213: /* CreateCastStmt: CREATE CAST '(' Typename AS Typename ')' WITHOUT FUNCTION cast_context  */
#line 8975 "gram.y"
                                {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 40701 "gram.c"
    break;

  case 1214: /* CreateCastStmt: CREATE CAST '(' Typename AS Typename ')' WITH INOUT cast_context  */
#line 8987 "gram.y"
                                {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *) n;
				}
#line 40716 "gram.c"
    break;

  case 1215: /* cast_context: AS IMPLICIT_P  */
#line 8999 "gram.y"
                                                                { (yyval.ival) = COERCION_IMPLICIT; }
#line 40722 "gram.c"
    break;

  case 1216: /* cast_context: AS ASSIGNMENT  */
#line 9000 "gram.y"
                                                                                { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 40728 "gram.c"
    break;

  case 1217: /* cast_context: %empty  */
#line 9001 "gram.y"
                                                                                        { (yyval.ival) = COERCION_EXPLICIT; }
#line 40734 "gram.c"
    break;

  case 1218: /* DropCastStmt: DROP CAST opt_if_exists '(' Typename AS Typename ')' opt_drop_behavior  */
#line 9006 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make2((yyvsp[-4].typnam), (yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 40749 "gram.c"
    break;

  case 1219: /* opt_if_exists: IF_P EXISTS  */
#line 9018 "gram.y"
                                                                        { (yyval.boolean) = true; }
#line 40755 "gram.c"
    break;

  case 1220: /* opt_if_exists: %empty  */
#line 9019 "gram.y"
                                                                                        { (yyval.boolean) = false; }
#line 40761 "gram.c"
    break;

  case 1221: /* CreateTransformStmt: CREATE opt_or_replace TRANSFORM FOR Typename LANGUAGE name '(' transform_element_list ')'  */
#line 9030 "gram.y"
                                {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);

					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 40776 "gram.c"
    break;

  case 1222: /* transform_element_list: FROM SQL_P WITH FUNCTION function_with_argtypes ',' TO SQL_P WITH FUNCTION function_with_argtypes  */
#line 9043 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[-6].objwithargs), (yyvsp[0].objwithargs));
				}
#line 40784 "gram.c"
    break;

  case 1223: /* transform_element_list: TO SQL_P WITH FUNCTION function_with_argtypes ',' FROM SQL_P WITH FUNCTION function_with_argtypes  */
#line 9047 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), (yyvsp[-6].objwithargs));
				}
#line 40792 "gram.c"
    break;

  case 1224: /* transform_element_list: FROM SQL_P WITH FUNCTION function_with_argtypes  */
#line 9051 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), NULL);
				}
#line 40800 "gram.c"
    break;

  case 1225: /* transform_element_list: TO SQL_P WITH FUNCTION function_with_argtypes  */
#line 9055 "gram.y"
                                {
					(yyval.list) = list_make2(NULL, (yyvsp[0].objwithargs));
				}
#line 40808 "gram.c"
    break;

  case 1226: /* DropTransformStmt: DROP TRANSFORM opt_if_exists FOR Typename LANGUAGE name opt_drop_behavior  */
#line 9062 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make2((yyvsp[-3].typnam), makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40822 "gram.c"
    break;

  case 1227: /* ReindexStmt: REINDEX reindex_target_type opt_concurrently qualified_name  */
#line 9083 "gram.y"
                                {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->params = NIL;
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 40839 "gram.c"
    break;

  case 1228: /* ReindexStmt: REINDEX reindex_target_multitable opt_concurrently name  */
#line 9096 "gram.y"
                                {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->params = NIL;
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 40856 "gram.c"
    break;

  case 1229: /* ReindexStmt: REINDEX '(' utility_option_list ')' reindex_target_type opt_concurrently qualified_name  */
#line 9109 "gram.y"
                                {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->params = (yyvsp[-4].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 40873 "gram.c"
    break;

  case 1230: /* ReindexStmt: REINDEX '(' utility_option_list ')' reindex_target_multitable opt_concurrently name  */
#line 9122 "gram.y"
                                {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->params = (yyvsp[-4].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 40890 "gram.c"
    break;

  case 1231: /* reindex_target_type: INDEX  */
#line 9136 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 40896 "gram.c"
    break;

  case 1232: /* reindex_target_type: TABLE  */
#line 9137 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 40902 "gram.c"
    break;

  case 1233: /* reindex_target_multitable: SCHEMA  */
#line 9140 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_SCHEMA; }
#line 40908 "gram.c"
    break;

  case 1234: /* reindex_target_multitable: SYSTEM_P  */
#line 9141 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 40914 "gram.c"
    break;

  case 1235: /* reindex_target_multitable: DATABASE  */
#line 9142 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 40920 "gram.c"
    break;

  case 1236: /* AlterTblSpcStmt: ALTER TABLESPACE name SET reloptions  */
#line 9153 "gram.y"
                                {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = false;
					(yyval.node) = (Node *) n;
				}
#line 40934 "gram.c"
    break;

  case 1237: /* AlterTblSpcStmt: ALTER TABLESPACE name RESET reloptions  */
#line 9163 "gram.y"
                                {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = true;
					(yyval.node) = (Node *) n;
				}
#line 40948 "gram.c"
    break;

  case 1238: /* RenameStmt: ALTER AGGREGATE aggregate_with_argtypes RENAME TO name  */
#line 9181 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40962 "gram.c"
    break;

  case 1239: /* RenameStmt: ALTER COLLATION any_name RENAME TO name  */
#line 9191 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40976 "gram.c"
    break;

  case 1240: /* RenameStmt: ALTER CONVERSION_P any_name RENAME TO name  */
#line 9201 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40990 "gram.c"
    break;

  case 1241: /* RenameStmt: ALTER DATABASE name RENAME TO name  */
#line 9211 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41004 "gram.c"
    break;

  case 1242: /* RenameStmt: ALTER DOMAIN_P any_name RENAME TO name  */
#line 9221 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41018 "gram.c"
    break;

  case 1243: /* RenameStmt: ALTER DOMAIN_P any_name RENAME CONSTRAINT name TO name  */
#line 9231 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (Node *) (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41032 "gram.c"
    break;

  case 1244: /* RenameStmt: ALTER FOREIGN DATA_P WRAPPER name RENAME TO name  */
#line 9241 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41046 "gram.c"
    break;

  case 1245: /* RenameStmt: ALTER FUNCTION function_with_argtypes RENAME TO name  */
#line 9251 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41060 "gram.c"
    break;

  case 1246: /* RenameStmt: ALTER GROUP_P RoleId RENAME TO RoleId  */
#line 9261 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41074 "gram.c"
    break;

  case 1247: /* RenameStmt: ALTER opt_procedural LANGUAGE name RENAME TO name  */
#line 9271 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41088 "gram.c"
    break;

  case 1248: /* RenameStmt: ALTER OPERATOR CLASS any_name USING name RENAME TO name  */
#line 9281 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41102 "gram.c"
    break;

  case 1249: /* RenameStmt: ALTER OPERATOR FAMILY any_name USING name RENAME TO name  */
#line 9291 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41116 "gram.c"
    break;

  case 1250: /* RenameStmt: ALTER POLICY name ON qualified_name RENAME TO name  */
#line 9301 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41131 "gram.c"
    break;

  case 1251: /* RenameStmt: ALTER POLICY IF_P EXISTS name ON qualified_name RENAME TO name  */
#line 9312 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41146 "gram.c"
    break;

  case 1252: /* RenameStmt: ALTER PROCEDURE function_with_argtypes RENAME TO name  */
#line 9323 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41160 "gram.c"
    break;

  case 1253: /* RenameStmt: ALTER PUBLICATION name RENAME TO name  */
#line 9333 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41174 "gram.c"
    break;

  case 1254: /* RenameStmt: ALTER ROUTINE function_with_argtypes RENAME TO name  */
#line 9343 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41188 "gram.c"
    break;

  case 1255: /* RenameStmt: ALTER SCHEMA name RENAME TO name  */
#line 9353 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41202 "gram.c"
    break;

  case 1256: /* RenameStmt: ALTER SERVER name RENAME TO name  */
#line 9363 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41216 "gram.c"
    break;

  case 1257: /* RenameStmt: ALTER SUBSCRIPTION name RENAME TO name  */
#line 9373 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41230 "gram.c"
    break;

  case 1258: /* RenameStmt: ALTER TABLE relation_expr RENAME TO name  */
#line 9383 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41245 "gram.c"
    break;

  case 1259: /* RenameStmt: ALTER TABLE IF_P EXISTS relation_expr RENAME TO name  */
#line 9394 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41260 "gram.c"
    break;

  case 1260: /* RenameStmt: ALTER SEQUENCE qualified_name RENAME TO name  */
#line 9405 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41275 "gram.c"
    break;

  case 1261: /* RenameStmt: ALTER SEQUENCE IF_P EXISTS qualified_name RENAME TO name  */
#line 9416 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41290 "gram.c"
    break;

  case 1262: /* RenameStmt: ALTER VIEW qualified_name RENAME TO name  */
#line 9427 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41305 "gram.c"
    break;

  case 1263: /* RenameStmt: ALTER VIEW IF_P EXISTS qualified_name RENAME TO name  */
#line 9438 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41320 "gram.c"
    break;

  case 1264: /* RenameStmt: ALTER MATERIALIZED VIEW qualified_name RENAME TO name  */
#line 9449 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41335 "gram.c"
    break;

  case 1265: /* RenameStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name RENAME TO name  */
#line 9460 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41350 "gram.c"
    break;

  case 1266: /* RenameStmt: ALTER INDEX qualified_name RENAME TO name  */
#line 9471 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41365 "gram.c"
    break;

  case 1267: /* RenameStmt: ALTER INDEX IF_P EXISTS qualified_name RENAME TO name  */
#line 9482 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41380 "gram.c"
    break;

  case 1268: /* RenameStmt: ALTER FOREIGN TABLE relation_expr RENAME TO name  */
#line 9493 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41395 "gram.c"
    break;

  case 1269: /* RenameStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr RENAME TO name  */
#line 9504 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41410 "gram.c"
    break;

  case 1270: /* RenameStmt: ALTER TABLE relation_expr RENAME opt_column name TO name  */
#line 9515 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41426 "gram.c"
    break;

  case 1271: /* RenameStmt: ALTER TABLE IF_P EXISTS relation_expr RENAME opt_column name TO name  */
#line 9527 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41442 "gram.c"
    break;

  case 1272: /* RenameStmt: ALTER VIEW qualified_name RENAME opt_column name TO name  */
#line 9539 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41458 "gram.c"
    break;

  case 1273: /* RenameStmt: ALTER VIEW IF_P EXISTS qualified_name RENAME opt_column name TO name  */
#line 9551 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41474 "gram.c"
    break;

  case 1274: /* RenameStmt: ALTER MATERIALIZED VIEW qualified_name RENAME opt_column name TO name  */
#line 9563 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41490 "gram.c"
    break;

  case 1275: /* RenameStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name RENAME opt_column name TO name  */
#line 9575 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41506 "gram.c"
    break;

  case 1276: /* RenameStmt: ALTER TABLE relation_expr RENAME CONSTRAINT name TO name  */
#line 9587 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41521 "gram.c"
    break;

  case 1277: /* RenameStmt: ALTER TABLE IF_P EXISTS relation_expr RENAME CONSTRAINT name TO name  */
#line 9598 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41536 "gram.c"
    break;

  case 1278: /* RenameStmt: ALTER FOREIGN TABLE relation_expr RENAME opt_column name TO name  */
#line 9609 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41552 "gram.c"
    break;

  case 1279: /* RenameStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr RENAME opt_column name TO name  */
#line 9621 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41568 "gram.c"
    break;

  case 1280: /* RenameStmt: ALTER RULE name ON qualified_name RENAME TO name  */
#line 9633 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41583 "gram.c"
    break;

  case 1281: /* RenameStmt: ALTER TRIGGER name ON qualified_name RENAME TO name  */
#line 9644 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41598 "gram.c"
    break;

  case 1282: /* RenameStmt: ALTER EVENT TRIGGER name RENAME TO name  */
#line 9655 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41611 "gram.c"
    break;

  case 1283: /* RenameStmt: ALTER ROLE RoleId RENAME TO RoleId  */
#line 9664 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41625 "gram.c"
    break;

  case 1284: /* RenameStmt: ALTER USER RoleId RENAME TO RoleId  */
#line 9674 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41639 "gram.c"
    break;

  case 1285: /* RenameStmt: ALTER TABLESPACE name RENAME TO name  */
#line 9684 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41653 "gram.c"
    break;

  case 1286: /* RenameStmt: ALTER STATISTICS any_name RENAME TO name  */
#line 9694 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41667 "gram.c"
    break;

  case 1287: /* RenameStmt: ALTER TEXT_P SEARCH PARSER any_name RENAME TO name  */
#line 9704 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41681 "gram.c"
    break;

  case 1288: /* RenameStmt: ALTER TEXT_P SEARCH DICTIONARY any_name RENAME TO name  */
#line 9714 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41695 "gram.c"
    break;

  case 1289: /* RenameStmt: ALTER TEXT_P SEARCH TEMPLATE any_name RENAME TO name  */
#line 9724 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41709 "gram.c"
    break;

  case 1290: /* RenameStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name RENAME TO name  */
#line 9734 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41723 "gram.c"
    break;

  case 1291: /* RenameStmt: ALTER TYPE_P any_name RENAME TO name  */
#line 9744 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41737 "gram.c"
    break;

  case 1292: /* RenameStmt: ALTER TYPE_P any_name RENAME ATTRIBUTE name TO name opt_drop_behavior  */
#line 9754 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41754 "gram.c"
    break;

  case 1295: /* opt_set_data: SET DATA_P  */
#line 9772 "gram.y"
                                                                                { (yyval.ival) = 1; }
#line 41760 "gram.c"
    break;

  case 1296: /* opt_set_data: %empty  */
#line 9773 "gram.y"
                                                                                                { (yyval.ival) = 0; }
#line 41766 "gram.c"
    break;

  case 1297: /* AlterObjectDependsStmt: ALTER FUNCTION function_with_argtypes opt_no DEPENDS ON EXTENSION name  */
#line 9784 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41780 "gram.c"
    break;

  case 1298: /* AlterObjectDependsStmt: ALTER PROCEDURE function_with_argtypes opt_no DEPENDS ON EXTENSION name  */
#line 9794 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41794 "gram.c"
    break;

  case 1299: /* AlterObjectDependsStmt: ALTER ROUTINE function_with_argtypes opt_no DEPENDS ON EXTENSION name  */
#line 9804 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41808 "gram.c"
    break;

  case 1300: /* AlterObjectDependsStmt: ALTER TRIGGER name ON qualified_name opt_no DEPENDS ON EXTENSION name  */
#line 9814 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-5].range);
					n->object = (Node *) list_make1(makeString((yyvsp[-7].str)));
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41823 "gram.c"
    break;

  case 1301: /* AlterObjectDependsStmt: ALTER MATERIALIZED VIEW qualified_name opt_no DEPENDS ON EXTENSION name  */
#line 9825 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41837 "gram.c"
    break;

  case 1302: /* AlterObjectDependsStmt: ALTER INDEX qualified_name opt_no DEPENDS ON EXTENSION name  */
#line 9835 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41851 "gram.c"
    break;

  case 1303: /* opt_no: NO  */
#line 9846 "gram.y"
                                                { (yyval.boolean) = true; }
#line 41857 "gram.c"
    break;

  case 1304: /* opt_no: %empty  */
#line 9847 "gram.y"
                                        { (yyval.boolean) = false;	}
#line 41863 "gram.c"
    break;

  case 1305: /* AlterObjectSchemaStmt: ALTER AGGREGATE aggregate_with_argtypes SET SCHEMA name  */
#line 9858 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41877 "gram.c"
    break;

  case 1306: /* AlterObjectSchemaStmt: ALTER COLLATION any_name SET SCHEMA name  */
#line 9868 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41891 "gram.c"
    break;

  case 1307: /* AlterObjectSchemaStmt: ALTER CONVERSION_P any_name SET SCHEMA name  */
#line 9878 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41905 "gram.c"
    break;

  case 1308: /* AlterObjectSchemaStmt: ALTER DOMAIN_P any_name SET SCHEMA name  */
#line 9888 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41919 "gram.c"
    break;

  case 1309: /* AlterObjectSchemaStmt: ALTER EXTENSION name SET SCHEMA name  */
#line 9898 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_EXTENSION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41933 "gram.c"
    break;

  case 1310: /* AlterObjectSchemaStmt: ALTER FUNCTION function_with_argtypes SET SCHEMA name  */
#line 9908 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41947 "gram.c"
    break;

  case 1311: /* AlterObjectSchemaStmt: ALTER OPERATOR operator_with_argtypes SET SCHEMA name  */
#line 9918 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41961 "gram.c"
    break;

  case 1312: /* AlterObjectSchemaStmt: ALTER OPERATOR CLASS any_name USING name SET SCHEMA name  */
#line 9928 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41975 "gram.c"
    break;

  case 1313: /* AlterObjectSchemaStmt: ALTER OPERATOR FAMILY any_name USING name SET SCHEMA name  */
#line 9938 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41989 "gram.c"
    break;

  case 1314: /* AlterObjectSchemaStmt: ALTER PROCEDURE function_with_argtypes SET SCHEMA name  */
#line 9948 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42003 "gram.c"
    break;

  case 1315: /* AlterObjectSchemaStmt: ALTER ROUTINE function_with_argtypes SET SCHEMA name  */
#line 9958 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42017 "gram.c"
    break;

  case 1316: /* AlterObjectSchemaStmt: ALTER TABLE relation_expr SET SCHEMA name  */
#line 9968 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42031 "gram.c"
    break;

  case 1317: /* AlterObjectSchemaStmt: ALTER TABLE IF_P EXISTS relation_expr SET SCHEMA name  */
#line 9978 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42045 "gram.c"
    break;

  case 1318: /* AlterObjectSchemaStmt: ALTER STATISTICS any_name SET SCHEMA name  */
#line 9988 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42059 "gram.c"
    break;

  case 1319: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH PARSER any_name SET SCHEMA name  */
#line 9998 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42073 "gram.c"
    break;

  case 1320: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH DICTIONARY any_name SET SCHEMA name  */
#line 10008 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42087 "gram.c"
    break;

  case 1321: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH TEMPLATE any_name SET SCHEMA name  */
#line 10018 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42101 "gram.c"
    break;

  case 1322: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name SET SCHEMA name  */
#line 10028 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42115 "gram.c"
    break;

  case 1323: /* AlterObjectSchemaStmt: ALTER SEQUENCE qualified_name SET SCHEMA name  */
#line 10038 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42129 "gram.c"
    break;

  case 1324: /* AlterObjectSchemaStmt: ALTER SEQUENCE IF_P EXISTS qualified_name SET SCHEMA name  */
#line 10048 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42143 "gram.c"
    break;

  case 1325: /* AlterObjectSchemaStmt: ALTER VIEW qualified_name SET SCHEMA name  */
#line 10058 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42157 "gram.c"
    break;

  case 1326: /* AlterObjectSchemaStmt: ALTER VIEW IF_P EXISTS qualified_name SET SCHEMA name  */
#line 10068 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42171 "gram.c"
    break;

  case 1327: /* AlterObjectSchemaStmt: ALTER MATERIALIZED VIEW qualified_name SET SCHEMA name  */
#line 10078 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42185 "gram.c"
    break;

  case 1328: /* AlterObjectSchemaStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name SET SCHEMA name  */
#line 10088 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42199 "gram.c"
    break;

  case 1329: /* AlterObjectSchemaStmt: ALTER FOREIGN TABLE relation_expr SET SCHEMA name  */
#line 10098 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42213 "gram.c"
    break;

  case 1330: /* AlterObjectSchemaStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr SET SCHEMA name  */
#line 10108 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42227 "gram.c"
    break;

  case 1331: /* AlterObjectSchemaStmt: ALTER TYPE_P any_name SET SCHEMA name  */
#line 10118 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42241 "gram.c"
    break;

  case 1332: /* AlterOperatorStmt: ALTER OPERATOR operator_with_argtypes SET '(' operator_def_list ')'  */
#line 10137 "gram.y"
                                {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);

					n->opername = (yyvsp[-4].objwithargs);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 42253 "gram.c"
    break;

  case 1333: /* operator_def_list: operator_def_elem  */
#line 10146 "gram.y"
                                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 42259 "gram.c"
    break;

  case 1334: /* operator_def_list: operator_def_list ',' operator_def_elem  */
#line 10147 "gram.y"
                                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 42265 "gram.c"
    break;

  case 1335: /* operator_def_elem: ColLabel '=' NONE  */
#line 10151 "gram.y"
                                                { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2])); }
#line 42271 "gram.c"
    break;

  case 1336: /* operator_def_elem: ColLabel '=' operator_def_arg  */
#line 10153 "gram.y"
                                                { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2])); }
#line 42277 "gram.c"
    break;

  case 1337: /* operator_def_arg: func_type  */
#line 10158 "gram.y"
                                                                                { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 42283 "gram.c"
    break;

  case 1338: /* operator_def_arg: reserved_keyword  */
#line 10159 "gram.y"
                                                                        { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 42289 "gram.c"
    break;

  case 1339: /* operator_def_arg: qual_all_Op  */
#line 10160 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 42295 "gram.c"
    break;

  case 1340: /* operator_def_arg: NumericOnly  */
#line 10161 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 42301 "gram.c"
    break;

  case 1341: /* operator_def_arg: Sconst  */
#line 10162 "gram.y"
                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 42307 "gram.c"
    break;

  case 1342: /* AlterTypeStmt: ALTER TYPE_P any_name SET '(' operator_def_list ')'  */
#line 10175 "gram.y"
                                {
					AlterTypeStmt *n = makeNode(AlterTypeStmt);

					n->typeName = (yyvsp[-4].list);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 42319 "gram.c"
    break;

  case 1343: /* AlterOwnerStmt: ALTER AGGREGATE aggregate_with_argtypes OWNER TO RoleSpec  */
#line 10191 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42332 "gram.c"
    break;

  case 1344: /* AlterOwnerStmt: ALTER COLLATION any_name OWNER TO RoleSpec  */
#line 10200 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42345 "gram.c"
    break;

  case 1345: /* AlterOwnerStmt: ALTER CONVERSION_P any_name OWNER TO RoleSpec  */
#line 10209 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42358 "gram.c"
    break;

  case 1346: /* AlterOwnerStmt: ALTER DATABASE name OWNER TO RoleSpec  */
#line 10218 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DATABASE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42371 "gram.c"
    break;

  case 1347: /* AlterOwnerStmt: ALTER DOMAIN_P any_name OWNER TO RoleSpec  */
#line 10227 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42384 "gram.c"
    break;

  case 1348: /* AlterOwnerStmt: ALTER FUNCTION function_with_argtypes OWNER TO RoleSpec  */
#line 10236 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42397 "gram.c"
    break;

  case 1349: /* AlterOwnerStmt: ALTER opt_procedural LANGUAGE name OWNER TO RoleSpec  */
#line 10245 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42410 "gram.c"
    break;

  case 1350: /* AlterOwnerStmt: ALTER LARGE_P OBJECT_P NumericOnly OWNER TO RoleSpec  */
#line 10254 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-3].node);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42423 "gram.c"
    break;

  case 1351: /* AlterOwnerStmt: ALTER OPERATOR operator_with_argtypes OWNER TO RoleSpec  */
#line 10263 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42436 "gram.c"
    break;

  case 1352: /* AlterOwnerStmt: ALTER OPERATOR CLASS any_name USING name OWNER TO RoleSpec  */
#line 10272 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42449 "gram.c"
    break;

  case 1353: /* AlterOwnerStmt: ALTER OPERATOR FAMILY any_name USING name OWNER TO RoleSpec  */
#line 10281 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42462 "gram.c"
    break;

  case 1354: /* AlterOwnerStmt: ALTER PROCEDURE function_with_argtypes OWNER TO RoleSpec  */
#line 10290 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42475 "gram.c"
    break;

  case 1355: /* AlterOwnerStmt: ALTER ROUTINE function_with_argtypes OWNER TO RoleSpec  */
#line 10299 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42488 "gram.c"
    break;

  case 1356: /* AlterOwnerStmt: ALTER SCHEMA name OWNER TO RoleSpec  */
#line 10308 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42501 "gram.c"
    break;

  case 1357: /* AlterOwnerStmt: ALTER TYPE_P any_name OWNER TO RoleSpec  */
#line 10317 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42514 "gram.c"
    break;

  case 1358: /* AlterOwnerStmt: ALTER TABLESPACE name OWNER TO RoleSpec  */
#line 10326 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TABLESPACE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42527 "gram.c"
    break;

  case 1359: /* AlterOwnerStmt: ALTER STATISTICS any_name OWNER TO RoleSpec  */
#line 10335 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42540 "gram.c"
    break;

  case 1360: /* AlterOwnerStmt: ALTER TEXT_P SEARCH DICTIONARY any_name OWNER TO RoleSpec  */
#line 10344 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42553 "gram.c"
    break;

  case 1361: /* AlterOwnerStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name OWNER TO RoleSpec  */
#line 10353 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42566 "gram.c"
    break;

  case 1362: /* AlterOwnerStmt: ALTER FOREIGN DATA_P WRAPPER name OWNER TO RoleSpec  */
#line 10362 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42579 "gram.c"
    break;

  case 1363: /* AlterOwnerStmt: ALTER SERVER name OWNER TO RoleSpec  */
#line 10371 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42592 "gram.c"
    break;

  case 1364: /* AlterOwnerStmt: ALTER EVENT TRIGGER name OWNER TO RoleSpec  */
#line 10380 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42605 "gram.c"
    break;

  case 1365: /* AlterOwnerStmt: ALTER PUBLICATION name OWNER TO RoleSpec  */
#line 10389 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42618 "gram.c"
    break;

  case 1366: /* AlterOwnerStmt: ALTER SUBSCRIPTION name OWNER TO RoleSpec  */
#line 10398 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42631 "gram.c"
    break;

  case 1367: /* CreatePublicationStmt: CREATE PUBLICATION name opt_definition  */
#line 10426 "gram.y"
                                {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42643 "gram.c"
    break;

  case 1368: /* CreatePublicationStmt: CREATE PUBLICATION name FOR ALL TABLES opt_definition  */
#line 10434 "gram.y"
                                {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-4].str);
					n->options = (yyvsp[0].list);
					n->for_all_tables = true;
					(yyval.node) = (Node *) n;
				}
#line 42656 "gram.c"
    break;

  case 1369: /* CreatePublicationStmt: CREATE PUBLICATION name FOR pub_obj_list opt_definition  */
#line 10443 "gram.y"
                                {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					n->pubobjects = (List *) (yyvsp[-1].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 42670 "gram.c"
    break;

  case 1370: /* PublicationObjSpec: TABLE relation_expr opt_column_list OptWhereClause  */
#line 10469 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLE;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 42683 "gram.c"
    break;

  case 1371: /* PublicationObjSpec: ALL TABLES IN_P SCHEMA ColId  */
#line 10478 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
					(yyval.publicationobjectspec)->name = (yyvsp[0].str);
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 42694 "gram.c"
    break;

  case 1372: /* PublicationObjSpec: ALL TABLES IN_P SCHEMA CURRENT_SCHEMA  */
#line 10485 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 42704 "gram.c"
    break;

  case 1373: /* PublicationObjSpec: ColId opt_column_list OptWhereClause  */
#line 10491 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					/*
					 * If either a row filter or column list is specified, create
					 * a PublicationTable object.
					 */
					if ((yyvsp[-1].list) || (yyvsp[0].node))
					{
						/*
						 * The OptWhereClause must be stored here but it is
						 * valid only for tables. For non-table objects, an
						 * error will be thrown later via
						 * preprocess_pubobj_list().
						 */
						(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
						(yyval.publicationobjectspec)->pubtable->relation = makeRangeVar(NULL, (yyvsp[-2].str), (yylsp[-2]));
						(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
						(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					}
					else
					{
						(yyval.publicationobjectspec)->name = (yyvsp[-2].str);
					}
					(yyval.publicationobjectspec)->location = (yylsp[-2]);
				}
#line 42735 "gram.c"
    break;

  case 1374: /* PublicationObjSpec: ColId indirection opt_column_list OptWhereClause  */
#line 10518 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = makeRangeVarFromQualifiedName((yyvsp[-3].str), (yyvsp[-2].list), (yylsp[-3]), yyscanner);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					(yyval.publicationobjectspec)->location = (yylsp[-3]);
				}
#line 42749 "gram.c"
    break;

  case 1375: /* PublicationObjSpec: extended_relation_expr opt_column_list OptWhereClause  */
#line 10529 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 42762 "gram.c"
    break;

  case 1376: /* PublicationObjSpec: CURRENT_SCHEMA  */
#line 10538 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 42772 "gram.c"
    break;

  case 1377: /* pub_obj_list: PublicationObjSpec  */
#line 10546 "gram.y"
                                        { (yyval.list) = list_make1((yyvsp[0].publicationobjectspec)); }
#line 42778 "gram.c"
    break;

  case 1378: /* pub_obj_list: pub_obj_list ',' PublicationObjSpec  */
#line 10548 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].publicationobjectspec)); }
#line 42784 "gram.c"
    break;

  case 1379: /* AlterPublicationStmt: ALTER PUBLICATION name SET definition  */
#line 10570 "gram.y"
                                {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42796 "gram.c"
    break;

  case 1380: /* AlterPublicationStmt: ALTER PUBLICATION name ADD_P pub_obj_list  */
#line 10578 "gram.y"
                                {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_AddObjects;
					(yyval.node) = (Node *) n;
				}
#line 42810 "gram.c"
    break;

  case 1381: /* AlterPublicationStmt: ALTER PUBLICATION name SET pub_obj_list  */
#line 10588 "gram.y"
                                {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_SetObjects;
					(yyval.node) = (Node *) n;
				}
#line 42824 "gram.c"
    break;

  case 1382: /* AlterPublicationStmt: ALTER PUBLICATION name DROP pub_obj_list  */
#line 10598 "gram.y"
                                {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_DropObjects;
					(yyval.node) = (Node *) n;
				}
#line 42838 "gram.c"
    break;

  case 1383: /* CreateSubscriptionStmt: CREATE SUBSCRIPTION name CONNECTION Sconst PUBLICATION name_list opt_definition  */
#line 10617 "gram.y"
                                {
					CreateSubscriptionStmt *n =
						makeNode(CreateSubscriptionStmt);
					n->subname = (yyvsp[-5].str);
					n->conninfo = (yyvsp[-3].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42852 "gram.c"
    break;

  case 1384: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name SET definition  */
#line 10636 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_OPTIONS;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42866 "gram.c"
    break;

  case 1385: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name CONNECTION Sconst  */
#line 10646 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_CONNECTION;
					n->subname = (yyvsp[-2].str);
					n->conninfo = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42880 "gram.c"
    break;

  case 1386: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name REFRESH PUBLICATION opt_definition  */
#line 10656 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_REFRESH;
					n->subname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42894 "gram.c"
    break;

  case 1387: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name ADD_P PUBLICATION name_list opt_definition  */
#line 10666 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ADD_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42909 "gram.c"
    break;

  case 1388: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name DROP PUBLICATION name_list opt_definition  */
#line 10677 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_DROP_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42924 "gram.c"
    break;

  case 1389: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name SET PUBLICATION name_list opt_definition  */
#line 10688 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SET_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42939 "gram.c"
    break;

  case 1390: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name ENABLE_P  */
#line 10699 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(true), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 42954 "gram.c"
    break;

  case 1391: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name DISABLE_P  */
#line 10710 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(false), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 42969 "gram.c"
    break;

  case 1392: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name SKIP definition  */
#line 10721 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SKIP;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42983 "gram.c"
    break;

  case 1393: /* DropSubscriptionStmt: DROP SUBSCRIPTION name opt_drop_behavior  */
#line 10739 "gram.y"
                                {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 42996 "gram.c"
    break;

  case 1394: /* DropSubscriptionStmt: DROP SUBSCRIPTION IF_P EXISTS name opt_drop_behavior  */
#line 10748 "gram.y"
                                {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 43009 "gram.c"
    break;

  case 1395: /* RuleStmt: CREATE opt_or_replace RULE name AS ON event TO qualified_name where_clause DO opt_instead RuleActionList  */
#line 10767 "gram.y"
                                {
					RuleStmt   *n = makeNode(RuleStmt);

					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43026 "gram.c"
    break;

  case 1396: /* RuleActionList: NOTHING  */
#line 10782 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 43032 "gram.c"
    break;

  case 1397: /* RuleActionList: RuleActionStmt  */
#line 10783 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 43038 "gram.c"
    break;

  case 1398: /* RuleActionList: '(' RuleActionMulti ')'  */
#line 10784 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 43044 "gram.c"
    break;

  case 1399: /* RuleActionMulti: RuleActionMulti ';' RuleActionStmtOrEmpty  */
#line 10790 "gram.y"
                                { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 43054 "gram.c"
    break;

  case 1400: /* RuleActionMulti: RuleActionStmtOrEmpty  */
#line 10796 "gram.y"
                                { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 43064 "gram.c"
    break;

  case 1406: /* RuleActionStmtOrEmpty: RuleActionStmt  */
#line 10812 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 43070 "gram.c"
    break;

  case 1407: /* RuleActionStmtOrEmpty: %empty  */
#line 10813 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 43076 "gram.c"
    break;

  case 1408: /* event: SELECT  */
#line 10816 "gram.y"
                                                                                        { (yyval.ival) = CMD_SELECT; }
#line 43082 "gram.c"
    break;

  case 1409: /* event: UPDATE  */
#line 10817 "gram.y"
                                                                                                { (yyval.ival) = CMD_UPDATE; }
#line 43088 "gram.c"
    break;

  case 1410: /* event: DELETE_P  */
#line 10818 "gram.y"
                                                                                                { (yyval.ival) = CMD_DELETE; }
#line 43094 "gram.c"
    break;

  case 1411: /* event: INSERT  */
#line 10819 "gram.y"
                                                                                                { (yyval.ival) = CMD_INSERT; }
#line 43100 "gram.c"
    break;

  case 1412: /* opt_instead: INSTEAD  */
#line 10823 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 43106 "gram.c"
    break;

  case 1413: /* opt_instead: ALSO  */
#line 10824 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 43112 "gram.c"
    break;

  case 1414: /* opt_instead: %empty  */
#line 10825 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 43118 "gram.c"
    break;

  case 1415: /* NotifyStmt: NOTIFY ColId notify_payload  */
#line 10838 "gram.y"
                                {
					NotifyStmt *n = makeNode(NotifyStmt);

					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43130 "gram.c"
    break;

  case 1416: /* notify_payload: ',' Sconst  */
#line 10848 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 43136 "gram.c"
    break;

  case 1417: /* notify_payload: %empty  */
#line 10849 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 43142 "gram.c"
    break;

  case 1418: /* ListenStmt: LISTEN ColId  */
#line 10853 "gram.y"
                                {
					ListenStmt *n = makeNode(ListenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43153 "gram.c"
    break;

  case 1419: /* UnlistenStmt: UNLISTEN ColId  */
#line 10863 "gram.y"
                                {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43164 "gram.c"
    break;

  case 1420: /* UnlistenStmt: UNLISTEN '*'  */
#line 10870 "gram.y"
                                {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 43175 "gram.c"
    break;

  case 1421: /* TransactionStmt: ABORT_P opt_transaction opt_transaction_chain  */
#line 10890 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 43188 "gram.c"
    break;

  case 1422: /* TransactionStmt: START TRANSACTION transaction_mode_list_or_empty  */
#line 10899 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43200 "gram.c"
    break;

  case 1423: /* TransactionStmt: COMMIT opt_transaction opt_transaction_chain  */
#line 10907 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 43213 "gram.c"
    break;

  case 1424: /* TransactionStmt: ROLLBACK opt_transaction opt_transaction_chain  */
#line 10916 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 43226 "gram.c"
    break;

  case 1425: /* TransactionStmt: SAVEPOINT ColId  */
#line 10925 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_SAVEPOINT;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43238 "gram.c"
    break;

  case 1426: /* TransactionStmt: RELEASE SAVEPOINT ColId  */
#line 10933 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43250 "gram.c"
    break;

  case 1427: /* TransactionStmt: RELEASE ColId  */
#line 10941 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43262 "gram.c"
    break;

  case 1428: /* TransactionStmt: ROLLBACK opt_transaction TO SAVEPOINT ColId  */
#line 10949 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43274 "gram.c"
    break;

  case 1429: /* TransactionStmt: ROLLBACK opt_transaction TO ColId  */
#line 10957 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43286 "gram.c"
    break;

  case 1430: /* TransactionStmt: PREPARE TRANSACTION Sconst  */
#line 10965 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43298 "gram.c"
    break;

  case 1431: /* TransactionStmt: COMMIT PREPARED Sconst  */
#line 10973 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43310 "gram.c"
    break;

  case 1432: /* TransactionStmt: ROLLBACK PREPARED Sconst  */
#line 10981 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43322 "gram.c"
    break;

  case 1433: /* TransactionStmtLegacy: BEGIN_P opt_transaction transaction_mode_list_or_empty  */
#line 10992 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43334 "gram.c"
    break;

  case 1434: /* TransactionStmtLegacy: END_P opt_transaction opt_transaction_chain  */
#line 11000 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 43347 "gram.c"
    break;

  case 1438: /* transaction_mode_item: ISOLATION LEVEL iso_level  */
#line 11017 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0])), (yylsp[-2])); }
#line 43354 "gram.c"
    break;

  case 1439: /* transaction_mode_item: READ ONLY  */
#line 11020 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(true, (yylsp[-1])), (yylsp[-1])); }
#line 43361 "gram.c"
    break;

  case 1440: /* transaction_mode_item: READ WRITE  */
#line 11023 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 43368 "gram.c"
    break;

  case 1441: /* transaction_mode_item: DEFERRABLE  */
#line 11026 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(true, (yylsp[0])), (yylsp[0])); }
#line 43375 "gram.c"
    break;

  case 1442: /* transaction_mode_item: NOT DEFERRABLE  */
#line 11029 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 43382 "gram.c"
    break;

  case 1443: /* transaction_mode_list: transaction_mode_item  */
#line 11036 "gram.y"
                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 43388 "gram.c"
    break;

  case 1444: /* transaction_mode_list: transaction_mode_list ',' transaction_mode_item  */
#line 11038 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 43394 "gram.c"
    break;

  case 1445: /* transaction_mode_list: transaction_mode_list transaction_mode_item  */
#line 11040 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 43400 "gram.c"
    break;

  case 1447: /* transaction_mode_list_or_empty: %empty  */
#line 11046 "gram.y"
                                        { (yyval.list) = NIL; }
#line 43406 "gram.c"
    break;

  case 1448: /* opt_transaction_chain: AND CHAIN  */
#line 11050 "gram.y"
                                                { (yyval.boolean) = true; }
#line 43412 "gram.c"
    break;

  case 1449: /* opt_transaction_chain: AND NO CHAIN  */
#line 11051 "gram.y"
                                        { (yyval.boolean) = false; }
#line 43418 "gram.c"
    break;

  case 1450: /* opt_transaction_chain: %empty  */
#line 11052 "gram.y"
                                        { (yyval.boolean) = false; }
#line 43424 "gram.c"
    break;

  case 1451: /* ViewStmt: CREATE OptTemp VIEW qualified_name opt_column_list opt_reloptions AS SelectStmt opt_check_option  */
#line 11066 "gram.y"
                                {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 43441 "gram.c"
    break;

  case 1452: /* ViewStmt: CREATE OR REPLACE OptTemp VIEW qualified_name opt_column_list opt_reloptions AS SelectStmt opt_check_option  */
#line 11080 "gram.y"
                                {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 43458 "gram.c"
    break;

  case 1453: /* ViewStmt: CREATE OptTemp RECURSIVE VIEW qualified_name '(' columnList ')' opt_reloptions AS SelectStmt opt_check_option  */
#line 11094 "gram.y"
                                {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 43480 "gram.c"
    break;

  case 1454: /* ViewStmt: CREATE OR REPLACE OptTemp RECURSIVE VIEW qualified_name '(' columnList ')' opt_reloptions AS SelectStmt opt_check_option  */
#line 11113 "gram.y"
                                {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 43502 "gram.c"
    break;

  case 1455: /* opt_check_option: WITH CHECK OPTION  */
#line 11133 "gram.y"
                                                                { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 43508 "gram.c"
    break;

  case 1456: /* opt_check_option: WITH CASCADED CHECK OPTION  */
#line 11134 "gram.y"
                                                { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 43514 "gram.c"
    break;

  case 1457: /* opt_check_option: WITH LOCAL CHECK OPTION  */
#line 11135 "gram.y"
                                                        { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 43520 "gram.c"
    break;

  case 1458: /* opt_check_option: %empty  */
#line 11136 "gram.y"
                                                                { (yyval.ival) = NO_CHECK_OPTION; }
#line 43526 "gram.c"
    break;

  case 1459: /* LoadStmt: LOAD file_name  */
#line 11147 "gram.y"
                                {
					LoadStmt   *n = makeNode(LoadStmt);

					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43537 "gram.c"
    break;

  case 1460: /* CreatedbStmt: CREATE DATABASE name opt_with createdb_opt_list  */
#line 11164 "gram.y"
                                {
					CreatedbStmt *n = makeNode(CreatedbStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43549 "gram.c"
    break;

  case 1461: /* createdb_opt_list: createdb_opt_items  */
#line 11174 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 43555 "gram.c"
    break;

  case 1462: /* createdb_opt_list: %empty  */
#line 11175 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 43561 "gram.c"
    break;

  case 1463: /* createdb_opt_items: createdb_opt_item  */
#line 11179 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 43567 "gram.c"
    break;

  case 1464: /* createdb_opt_items: createdb_opt_items createdb_opt_item  */
#line 11180 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 43573 "gram.c"
    break;

  case 1465: /* createdb_opt_item: createdb_opt_name opt_equal SignedIconst  */
#line 11185 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 43581 "gram.c"
    break;

  case 1466: /* createdb_opt_item: createdb_opt_name opt_equal opt_boolean_or_string  */
#line 11189 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 43589 "gram.c"
    break;

  case 1467: /* createdb_opt_item: createdb_opt_name opt_equal DEFAULT  */
#line 11193 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2]));
				}
#line 43597 "gram.c"
    break;

  case 1468: /* createdb_opt_name: IDENT  */
#line 11210 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 43603 "gram.c"
    break;

  case 1469: /* createdb_opt_name: CONNECTION LIMIT  */
#line 11211 "gram.y"
                                                                        { (yyval.str) = pstrdup("connection_limit"); }
#line 43609 "gram.c"
    break;

  case 1470: /* createdb_opt_name: ENCODING  */
#line 11212 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 43615 "gram.c"
    break;

  case 1471: /* createdb_opt_name: LOCATION  */
#line 11213 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 43621 "gram.c"
    break;

  case 1472: /* createdb_opt_name: OWNER  */
#line 11214 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 43627 "gram.c"
    break;

  case 1473: /* createdb_opt_name: TABLESPACE  */
#line 11215 "gram.y"
                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 43633 "gram.c"
    break;

  case 1474: /* createdb_opt_name: TEMPLATE  */
#line 11216 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 43639 "gram.c"
    break;

  case 1477: /* AlterDatabaseStmt: ALTER DATABASE name WITH createdb_opt_list  */
#line 11236 "gram.y"
                                 {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 43651 "gram.c"
    break;

  case 1478: /* AlterDatabaseStmt: ALTER DATABASE name createdb_opt_list  */
#line 11244 "gram.y"
                                 {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 43663 "gram.c"
    break;

  case 1479: /* AlterDatabaseStmt: ALTER DATABASE name SET TABLESPACE name  */
#line 11252 "gram.y"
                                 {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
														(Node *) makeString((yyvsp[0].str)), (yylsp[0])));
					(yyval.node) = (Node *) n;
				 }
#line 43676 "gram.c"
    break;

  case 1480: /* AlterDatabaseStmt: ALTER DATABASE name REFRESH COLLATION VERSION_P  */
#line 11261 "gram.y"
                                 {
					AlterDatabaseRefreshCollStmt *n = makeNode(AlterDatabaseRefreshCollStmt);

					n->dbname = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				 }
#line 43687 "gram.c"
    break;

  case 1481: /* AlterDatabaseSetStmt: ALTER DATABASE name SetResetClause  */
#line 11271 "gram.y"
                                {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);

					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 43699 "gram.c"
    break;

  case 1482: /* DropdbStmt: DROP DATABASE name  */
#line 11289 "gram.y"
                                {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = false;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 43712 "gram.c"
    break;

  case 1483: /* DropdbStmt: DROP DATABASE IF_P EXISTS name  */
#line 11298 "gram.y"
                                {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = true;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 43725 "gram.c"
    break;

  case 1484: /* DropdbStmt: DROP DATABASE name opt_with '(' drop_option_list ')'  */
#line 11307 "gram.y"
                                {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = false;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 43738 "gram.c"
    break;

  case 1485: /* DropdbStmt: DROP DATABASE IF_P EXISTS name opt_with '(' drop_option_list ')'  */
#line 11316 "gram.y"
                                {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = true;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 43751 "gram.c"
    break;

  case 1486: /* drop_option_list: drop_option  */
#line 11328 "gram.y"
                                {
					(yyval.list) = list_make1((Node *) (yyvsp[0].defelt));
				}
#line 43759 "gram.c"
    break;

  case 1487: /* drop_option_list: drop_option_list ',' drop_option  */
#line 11332 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (Node *) (yyvsp[0].defelt));
				}
#line 43767 "gram.c"
    break;

  case 1488: /* drop_option: FORCE  */
#line 11343 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force", NULL, (yylsp[0]));
				}
#line 43775 "gram.c"
    break;

  case 1489: /* AlterCollationStmt: ALTER COLLATION any_name REFRESH VERSION_P  */
#line 11355 "gram.y"
                                {
					AlterCollationStmt *n = makeNode(AlterCollationStmt);

					n->collname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 43786 "gram.c"
    break;

  case 1490: /* AlterSystemStmt: ALTER SYSTEM_P SET generic_set  */
#line 11373 "gram.y"
                                {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 43797 "gram.c"
    break;

  case 1491: /* AlterSystemStmt: ALTER SYSTEM_P RESET generic_reset  */
#line 11380 "gram.y"
                                {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 43808 "gram.c"
    break;

  case 1492: /* CreateDomainStmt: CREATE DOMAIN_P any_name opt_as Typename ColQualList  */
#line 11397 "gram.y"
                                {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);

					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 43822 "gram.c"
    break;

  case 1493: /* AlterDomainStmt: ALTER DOMAIN_P any_name alter_column_default  */
#line 11411 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 43835 "gram.c"
    break;

  case 1494: /* AlterDomainStmt: ALTER DOMAIN_P any_name DROP NOT NULL_P  */
#line 11421 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 43847 "gram.c"
    break;

  case 1495: /* AlterDomainStmt: ALTER DOMAIN_P any_name SET NOT NULL_P  */
#line 11430 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 43859 "gram.c"
    break;

  case 1496: /* AlterDomainStmt: ALTER DOMAIN_P any_name ADD_P TableConstraint  */
#line 11439 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 43872 "gram.c"
    break;

  case 1497: /* AlterDomainStmt: ALTER DOMAIN_P any_name DROP CONSTRAINT name opt_drop_behavior  */
#line 11449 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43887 "gram.c"
    break;

  case 1498: /* AlterDomainStmt: ALTER DOMAIN_P any_name DROP CONSTRAINT IF_P EXISTS name opt_drop_behavior  */
#line 11461 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43902 "gram.c"
    break;

  case 1499: /* AlterDomainStmt: ALTER DOMAIN_P any_name VALIDATE CONSTRAINT name  */
#line 11473 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43915 "gram.c"
    break;

  case 1502: /* AlterTSDictionaryStmt: ALTER TEXT_P SEARCH DICTIONARY any_name definition  */
#line 11496 "gram.y"
                                {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);

					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43927 "gram.c"
    break;

  case 1503: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ADD_P MAPPING FOR name_list any_with any_name_list  */
#line 11507 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 43943 "gram.c"
    break;

  case 1504: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ALTER MAPPING FOR name_list any_with any_name_list  */
#line 11519 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 43959 "gram.c"
    break;

  case 1505: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ALTER MAPPING REPLACE any_name any_with any_name  */
#line 11531 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 43975 "gram.c"
    break;

  case 1506: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ALTER MAPPING FOR name_list REPLACE any_name any_with any_name  */
#line 11543 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 43991 "gram.c"
    break;

  case 1507: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name DROP MAPPING FOR name_list  */
#line 11555 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 44005 "gram.c"
    break;

  case 1508: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name DROP MAPPING IF_P EXISTS FOR name_list  */
#line 11565 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 44019 "gram.c"
    break;

  case 1511: /* CreateConversionStmt: CREATE opt_default CONVERSION_P any_name FOR Sconst TO Sconst FROM any_name  */
#line 11594 "gram.y"
                        {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);

				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *) n;
			}
#line 44034 "gram.c"
    break;

  case 1512: /* ClusterStmt: CLUSTER opt_verbose qualified_name cluster_index_specification  */
#line 11618 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = NIL;
					if ((yyvsp[-2].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-2])));
					(yyval.node) = (Node *) n;
				}
#line 44049 "gram.c"
    break;

  case 1513: /* ClusterStmt: CLUSTER '(' utility_option_list ')' qualified_name cluster_index_specification  */
#line 11630 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 44062 "gram.c"
    break;

  case 1514: /* ClusterStmt: CLUSTER opt_verbose  */
#line 11639 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = NULL;
					n->indexname = NULL;
					n->params = NIL;
					if ((yyvsp[0].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 44077 "gram.c"
    break;

  case 1515: /* ClusterStmt: CLUSTER opt_verbose name ON qualified_name  */
#line 11651 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->params = NIL;
					if ((yyvsp[-3].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 44092 "gram.c"
    break;

  case 1516: /* cluster_index_specification: USING name  */
#line 11664 "gram.y"
                                                                { (yyval.str) = (yyvsp[0].str); }
#line 44098 "gram.c"
    break;

  case 1517: /* cluster_index_specification: %empty  */
#line 11665 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 44104 "gram.c"
    break;

  case 1518: /* VacuumStmt: VACUUM opt_full opt_freeze opt_verbose opt_analyze opt_vacuum_relation_list  */
#line 11678 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-4].boolean))
						n->options = lappend(n->options,
											 makeDefElem("full", NULL, (yylsp[-4])));
					if ((yyvsp[-3].boolean))
						n->options = lappend(n->options,
											 makeDefElem("freeze", NULL, (yylsp[-3])));
					if ((yyvsp[-2].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("analyze", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 44129 "gram.c"
    break;

  case 1519: /* VacuumStmt: VACUUM '(' utility_option_list ')' opt_vacuum_relation_list  */
#line 11699 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 44142 "gram.c"
    break;

  case 1520: /* AnalyzeStmt: analyze_keyword opt_verbose opt_vacuum_relation_list  */
#line 11710 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 44158 "gram.c"
    break;

  case 1521: /* AnalyzeStmt: analyze_keyword '(' utility_option_list ')' opt_vacuum_relation_list  */
#line 11722 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 44171 "gram.c"
    break;

  case 1522: /* utility_option_list: utility_option_elem  */
#line 11734 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 44179 "gram.c"
    break;

  case 1523: /* utility_option_list: utility_option_list ',' utility_option_elem  */
#line 11738 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 44187 "gram.c"
    break;

  case 1526: /* utility_option_elem: utility_option_name utility_option_arg  */
#line 11750 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 44195 "gram.c"
    break;

  case 1527: /* utility_option_name: NonReservedWord  */
#line 11756 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 44201 "gram.c"
    break;

  case 1528: /* utility_option_name: analyze_keyword  */
#line 11757 "gram.y"
                                                                                        { (yyval.str) = "analyze"; }
#line 44207 "gram.c"
    break;

  case 1529: /* utility_option_arg: opt_boolean_or_string  */
#line 11761 "gram.y"
                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 44213 "gram.c"
    break;

  case 1530: /* utility_option_arg: NumericOnly  */
#line 11762 "gram.y"
                                                                                        { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 44219 "gram.c"
    break;

  case 1531: /* utility_option_arg: %empty  */
#line 11763 "gram.y"
                                                                                        { (yyval.node) = NULL; }
#line 44225 "gram.c"
    break;

  case 1532: /* opt_analyze: analyze_keyword  */
#line 11767 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 44231 "gram.c"
    break;

  case 1533: /* opt_analyze: %empty  */
#line 11768 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 44237 "gram.c"
    break;

  case 1534: /* opt_verbose: VERBOSE  */
#line 11772 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 44243 "gram.c"
    break;

  case 1535: /* opt_verbose: %empty  */
#line 11773 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 44249 "gram.c"
    break;

  case 1536: /* opt_full: FULL  */
#line 11776 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 44255 "gram.c"
    break;

  case 1537: /* opt_full: %empty  */
#line 11777 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 44261 "gram.c"
    break;

  case 1538: /* opt_freeze: FREEZE  */
#line 11780 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 44267 "gram.c"
    break;

  case 1539: /* opt_freeze: %empty  */
#line 11781 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 44273 "gram.c"
    break;

  case 1540: /* opt_name_list: '(' name_list ')'  */
#line 11785 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 44279 "gram.c"
    break;

  case 1541: /* opt_name_list: %empty  */
#line 11786 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 44285 "gram.c"
    break;

  case 1542: /* vacuum_relation: qualified_name opt_name_list  */
#line 11791 "gram.y"
                                {
					(yyval.node) = (Node *) makeVacuumRelation((yyvsp[-1].range), InvalidOid, (yyvsp[0].list));
				}
#line 44293 "gram.c"
    break;

  case 1543: /* vacuum_relation_list: vacuum_relation  */
#line 11798 "gram.y"
                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44299 "gram.c"
    break;

  case 1544: /* vacuum_relation_list: vacuum_relation_list ',' vacuum_relation  */
#line 11800 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 44305 "gram.c"
    break;

  case 1545: /* opt_vacuum_relation_list: vacuum_relation_list  */
#line 11804 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 44311 "gram.c"
    break;

  case 1546: /* opt_vacuum_relation_list: %empty  */
#line 11805 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 44317 "gram.c"
    break;

  case 1547: /* ExplainStmt: EXPLAIN ExplainableStmt  */
#line 11819 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 44329 "gram.c"
    break;

  case 1548: /* ExplainStmt: EXPLAIN analyze_keyword opt_verbose ExplainableStmt  */
#line 11827 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 44344 "gram.c"
    break;

  case 1549: /* ExplainStmt: EXPLAIN VERBOSE ExplainableStmt  */
#line 11838 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 44356 "gram.c"
    break;

  case 1550: /* ExplainStmt: EXPLAIN '(' utility_option_list ')' ExplainableStmt  */
#line 11846 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 44368 "gram.c"
    break;

  case 1561: /* PrepareStmt: PREPARE name prep_type_clause AS PreparableStmt  */
#line 11876 "gram.y"
                                {
					PrepareStmt *n = makeNode(PrepareStmt);

					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 44381 "gram.c"
    break;

  case 1562: /* prep_type_clause: '(' type_list ')'  */
#line 11886 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 44387 "gram.c"
    break;

  case 1563: /* prep_type_clause: %empty  */
#line 11887 "gram.y"
                                                                        { (yyval.list) = NIL; }
#line 44393 "gram.c"
    break;

  case 1569: /* ExecuteStmt: EXECUTE name execute_param_clause  */
#line 11906 "gram.y"
                                {
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44405 "gram.c"
    break;

  case 1570: /* ExecuteStmt: CREATE OptTemp TABLE create_as_target AS EXECUTE name execute_param_clause opt_with_data  */
#line 11915 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 44426 "gram.c"
    break;

  case 1571: /* ExecuteStmt: CREATE OptTemp TABLE IF_P NOT EXISTS create_as_target AS EXECUTE name execute_param_clause opt_with_data  */
#line 11933 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-10].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 44447 "gram.c"
    break;

  case 1572: /* execute_param_clause: '(' expr_list ')'  */
#line 11951 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 44453 "gram.c"
    break;

  case 1573: /* execute_param_clause: %empty  */
#line 11952 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 44459 "gram.c"
    break;

  case 1574: /* DeallocateStmt: DEALLOCATE name  */
#line 11963 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 44470 "gram.c"
    break;

  case 1575: /* DeallocateStmt: DEALLOCATE PREPARE name  */
#line 11970 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 44481 "gram.c"
    break;

  case 1576: /* DeallocateStmt: DEALLOCATE ALL  */
#line 11977 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 44492 "gram.c"
    break;

  case 1577: /* DeallocateStmt: DEALLOCATE PREPARE ALL  */
#line 11984 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 44503 "gram.c"
    break;

  case 1578: /* InsertStmt: opt_with_clause INSERT INTO insert_target insert_rest opt_on_conflict returning_clause  */
#line 12002 "gram.y"
                                {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 44515 "gram.c"
    break;

  case 1579: /* insert_target: qualified_name  */
#line 12019 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
				}
#line 44523 "gram.c"
    break;

  case 1580: /* insert_target: qualified_name AS ColId  */
#line 12023 "gram.y"
                                {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 44532 "gram.c"
    break;

  case 1581: /* insert_rest: SelectStmt  */
#line 12031 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 44542 "gram.c"
    break;

  case 1582: /* insert_rest: OVERRIDING override_kind VALUE_P SelectStmt  */
#line 12037 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 44553 "gram.c"
    break;

  case 1583: /* insert_rest: '(' insert_column_list ')' SelectStmt  */
#line 12044 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 44563 "gram.c"
    break;

  case 1584: /* insert_rest: '(' insert_column_list ')' OVERRIDING override_kind VALUE_P SelectStmt  */
#line 12050 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-5].list);
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 44574 "gram.c"
    break;

  case 1585: /* insert_rest: DEFAULT VALUES  */
#line 12057 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 44584 "gram.c"
    break;

  case 1586: /* override_kind: USER  */
#line 12065 "gram.y"
                                        { (yyval.ival) = OVERRIDING_USER_VALUE; }
#line 44590 "gram.c"
    break;

  case 1587: /* override_kind: SYSTEM_P  */
#line 12066 "gram.y"
                                        { (yyval.ival) = OVERRIDING_SYSTEM_VALUE; }
#line 44596 "gram.c"
    break;

  case 1588: /* insert_column_list: insert_column_item  */
#line 12071 "gram.y"
                                        { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 44602 "gram.c"
    break;

  case 1589: /* insert_column_list: insert_column_list ',' insert_column_item  */
#line 12073 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 44608 "gram.c"
    break;

  case 1590: /* insert_column_item: ColId opt_indirection  */
#line 12078 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 44620 "gram.c"
    break;

  case 1591: /* opt_on_conflict: ON CONFLICT opt_conf_expr DO UPDATE SET set_clause_list where_clause  */
#line 12089 "gram.y"
                                {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 44633 "gram.c"
    break;

  case 1592: /* opt_on_conflict: ON CONFLICT opt_conf_expr DO NOTHING  */
#line 12099 "gram.y"
                                {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 44646 "gram.c"
    break;

  case 1593: /* opt_on_conflict: %empty  */
#line 12108 "gram.y"
                                {
					(yyval.onconflict) = NULL;
				}
#line 44654 "gram.c"
    break;

  case 1594: /* opt_conf_expr: '(' index_params ')' where_clause  */
#line 12115 "gram.y"
                                {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 44666 "gram.c"
    break;

  case 1595: /* opt_conf_expr: ON CONSTRAINT name  */
#line 12124 "gram.y"
                                {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 44678 "gram.c"
    break;

  case 1596: /* opt_conf_expr: %empty  */
#line 12132 "gram.y"
                                {
					(yyval.infer) = NULL;
				}
#line 44686 "gram.c"
    break;

  case 1597: /* returning_clause: RETURNING target_list  */
#line 12138 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 44692 "gram.c"
    break;

  case 1598: /* returning_clause: %empty  */
#line 12139 "gram.y"
                                                                { (yyval.list) = NIL; }
#line 44698 "gram.c"
    break;

  case 1599: /* DeleteStmt: opt_with_clause DELETE_P FROM relation_expr_opt_alias using_clause where_or_current_clause returning_clause  */
#line 12152 "gram.y"
                                {
					DeleteStmt *n = makeNode(DeleteStmt);

					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) n;
				}
#line 44713 "gram.c"
    break;

  case 1600: /* using_clause: USING from_list  */
#line 12165 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 44719 "gram.c"
    break;

  case 1601: /* using_clause: %empty  */
#line 12166 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 44725 "gram.c"
    break;

  case 1602: /* LockStmt: LOCK_P opt_table relation_expr_list opt_lock opt_nowait  */
#line 12178 "gram.y"
                                {
					LockStmt   *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 44738 "gram.c"
    break;

  case 1603: /* opt_lock: IN_P lock_type MODE  */
#line 12188 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival); }
#line 44744 "gram.c"
    break;

  case 1604: /* opt_lock: %empty  */
#line 12189 "gram.y"
                                                                                { (yyval.ival) = AccessExclusiveLock; }
#line 44750 "gram.c"
    break;

  case 1605: /* lock_type: ACCESS SHARE  */
#line 12192 "gram.y"
                                                                { (yyval.ival) = AccessShareLock; }
#line 44756 "gram.c"
    break;

  case 1606: /* lock_type: ROW SHARE  */
#line 12193 "gram.y"
                                                                                { (yyval.ival) = RowShareLock; }
#line 44762 "gram.c"
    break;

  case 1607: /* lock_type: ROW EXCLUSIVE  */
#line 12194 "gram.y"
                                                                        { (yyval.ival) = RowExclusiveLock; }
#line 44768 "gram.c"
    break;

  case 1608: /* lock_type: SHARE UPDATE EXCLUSIVE  */
#line 12195 "gram.y"
                                                                { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 44774 "gram.c"
    break;

  case 1609: /* lock_type: SHARE  */
#line 12196 "gram.y"
                                                                                { (yyval.ival) = ShareLock; }
#line 44780 "gram.c"
    break;

  case 1610: /* lock_type: SHARE ROW EXCLUSIVE  */
#line 12197 "gram.y"
                                                                { (yyval.ival) = ShareRowExclusiveLock; }
#line 44786 "gram.c"
    break;

  case 1611: /* lock_type: EXCLUSIVE  */
#line 12198 "gram.y"
                                                                                { (yyval.ival) = ExclusiveLock; }
#line 44792 "gram.c"
    break;

  case 1612: /* lock_type: ACCESS EXCLUSIVE  */
#line 12199 "gram.y"
                                                                        { (yyval.ival) = AccessExclusiveLock; }
#line 44798 "gram.c"
    break;

  case 1613: /* opt_nowait: NOWAIT  */
#line 12202 "gram.y"
                                                                        { (yyval.boolean) = true; }
#line 44804 "gram.c"
    break;

  case 1614: /* opt_nowait: %empty  */
#line 12203 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 44810 "gram.c"
    break;

  case 1615: /* opt_nowait_or_skip: NOWAIT  */
#line 12207 "gram.y"
                                                                                { (yyval.ival) = LockWaitError; }
#line 44816 "gram.c"
    break;

  case 1616: /* opt_nowait_or_skip: SKIP LOCKED  */
#line 12208 "gram.y"
                                                                        { (yyval.ival) = LockWaitSkip; }
#line 44822 "gram.c"
    break;

  case 1617: /* opt_nowait_or_skip: %empty  */
#line 12209 "gram.y"
                                                                                { (yyval.ival) = LockWaitBlock; }
#line 44828 "gram.c"
    break;

  case 1618: /* UpdateStmt: opt_with_clause UPDATE relation_expr_opt_alias SET set_clause_list from_clause where_or_current_clause returning_clause  */
#line 12225 "gram.y"
                                {
					UpdateStmt *n = makeNode(UpdateStmt);

					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *) n;
				}
#line 44844 "gram.c"
    break;

  case 1619: /* set_clause_list: set_clause  */
#line 12239 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 44850 "gram.c"
    break;

  case 1620: /* set_clause_list: set_clause_list ',' set_clause  */
#line 12240 "gram.y"
                                                                { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 44856 "gram.c"
    break;

  case 1621: /* set_clause: set_target '=' a_expr  */
#line 12245 "gram.y"
                                {
					(yyvsp[-2].target)->val = (Node *) (yyvsp[0].node);
					(yyval.list) = list_make1((yyvsp[-2].target));
				}
#line 44865 "gram.c"
    break;

  case 1622: /* set_clause: '(' set_target_list ')' '=' a_expr  */
#line 12250 "gram.y"
                                {
					int			ncolumns = list_length((yyvsp[-3].list));
					int			i = 1;
					ListCell   *col_cell;

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget  *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) (yyvsp[0].node);
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 44890 "gram.c"
    break;

  case 1623: /* set_target: ColId opt_indirection  */
#line 12274 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 44902 "gram.c"
    break;

  case 1624: /* set_target_list: set_target  */
#line 12284 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 44908 "gram.c"
    break;

  case 1625: /* set_target_list: set_target_list ',' set_target  */
#line 12285 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 44914 "gram.c"
    break;

  case 1626: /* MergeStmt: opt_with_clause MERGE INTO relation_expr_opt_alias USING table_ref ON a_expr merge_when_list  */
#line 12301 "gram.y"
                                {
					MergeStmt  *m = makeNode(MergeStmt);

					m->withClause = (yyvsp[-8].with);
					m->relation = (yyvsp[-5].range);
					m->sourceRelation = (yyvsp[-3].node);
					m->joinCondition = (yyvsp[-1].node);
					m->mergeWhenClauses = (yyvsp[0].list);

					(yyval.node) = (Node *) m;
				}
#line 44930 "gram.c"
    break;

  case 1627: /* merge_when_list: merge_when_clause  */
#line 12315 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44936 "gram.c"
    break;

  case 1628: /* merge_when_list: merge_when_list merge_when_clause  */
#line 12316 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list),(yyvsp[0].node)); }
#line 44942 "gram.c"
    break;

  case 1629: /* merge_when_clause: WHEN MATCHED opt_merge_when_condition THEN merge_update  */
#line 12321 "gram.y"
                                {
					(yyvsp[0].mergewhen)->matched = true;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 44953 "gram.c"
    break;

  case 1630: /* merge_when_clause: WHEN MATCHED opt_merge_when_condition THEN merge_delete  */
#line 12328 "gram.y"
                                {
					(yyvsp[0].mergewhen)->matched = true;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 44964 "gram.c"
    break;

  case 1631: /* merge_when_clause: WHEN NOT MATCHED opt_merge_when_condition THEN merge_insert  */
#line 12335 "gram.y"
                                {
					(yyvsp[0].mergewhen)->matched = false;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 44975 "gram.c"
    break;

  case 1632: /* merge_when_clause: WHEN MATCHED opt_merge_when_condition THEN DO NOTHING  */
#line 12342 "gram.y"
                                {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matched = true;
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 44989 "gram.c"
    break;

  case 1633: /* merge_when_clause: WHEN NOT MATCHED opt_merge_when_condition THEN DO NOTHING  */
#line 12352 "gram.y"
                                {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matched = false;
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 45003 "gram.c"
    break;

  case 1634: /* opt_merge_when_condition: AND a_expr  */
#line 12364 "gram.y"
                                                                { (yyval.node) = (yyvsp[0].node); }
#line 45009 "gram.c"
    break;

  case 1635: /* opt_merge_when_condition: %empty  */
#line 12365 "gram.y"
                                                                        { (yyval.node) = NULL; }
#line 45015 "gram.c"
    break;

  case 1636: /* merge_update: UPDATE SET set_clause_list  */
#line 12370 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_UPDATE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[0].list);
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 45029 "gram.c"
    break;

  case 1637: /* merge_delete: DELETE_P  */
#line 12383 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_DELETE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 45043 "gram.c"
    break;

  case 1638: /* merge_insert: INSERT merge_values_clause  */
#line 12396 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 45056 "gram.c"
    break;

  case 1639: /* merge_insert: INSERT OVERRIDING override_kind VALUE_P merge_values_clause  */
#line 12405 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 45069 "gram.c"
    break;

  case 1640: /* merge_insert: INSERT '(' insert_column_list ')' merge_values_clause  */
#line 12414 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[-2].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 45082 "gram.c"
    break;

  case 1641: /* merge_insert: INSERT '(' insert_column_list ')' OVERRIDING override_kind VALUE_P merge_values_clause  */
#line 12423 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = (yyvsp[-5].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 45095 "gram.c"
    break;

  case 1642: /* merge_insert: INSERT DEFAULT VALUES  */
#line 12432 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;
					(yyval.mergewhen) = n;
				}
#line 45108 "gram.c"
    break;

  case 1643: /* merge_values_clause: VALUES '(' expr_list ')'  */
#line 12444 "gram.y"
                                {
					(yyval.list) = (yyvsp[-1].list);
				}
#line 45116 "gram.c"
    break;

  case 1644: /* DeclareCursorStmt: DECLARE cursor_name cursor_options CURSOR opt_hold FOR SelectStmt  */
#line 12456 "gram.y"
                                {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);

					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 45130 "gram.c"
    break;

  case 1645: /* cursor_name: name  */
#line 12467 "gram.y"
                                                                { (yyval.str) = (yyvsp[0].str); }
#line 45136 "gram.c"
    break;

  case 1646: /* cursor_options: %empty  */
#line 12470 "gram.y"
                                                                { (yyval.ival) = 0; }
#line 45142 "gram.c"
    break;

  case 1647: /* cursor_options: cursor_options NO SCROLL  */
#line 12471 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 45148 "gram.c"
    break;

  case 1648: /* cursor_options: cursor_options SCROLL  */
#line 12472 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 45154 "gram.c"
    break;

  case 1649: /* cursor_options: cursor_options BINARY  */
#line 12473 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 45160 "gram.c"
    break;

  case 1650: /* cursor_options: cursor_options ASENSITIVE  */
#line 12474 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_ASENSITIVE; }
#line 45166 "gram.c"
    break;

  case 1651: /* cursor_options: cursor_options INSENSITIVE  */
#line 12475 "gram.y"
                                                        { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 45172 "gram.c"
    break;

  case 1652: /* opt_hold: %empty  */
#line 12478 "gram.y"
                                                                { (yyval.ival) = 0; }
#line 45178 "gram.c"
    break;

  case 1653: /* opt_hold: WITH HOLD  */
#line 12479 "gram.y"
                                                                                { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 45184 "gram.c"
    break;

  case 1654: /* opt_hold: WITHOUT HOLD  */
#line 12480 "gram.y"
                                                                        { (yyval.ival) = 0; }
#line 45190 "gram.c"
    break;

  case 1657: /* select_with_parens: '(' select_no_parens ')'  */
#line 12533 "gram.y"
                                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 45196 "gram.c"
    break;

  case 1658: /* select_with_parens: '(' select_with_parens ')'  */
#line 12534 "gram.y"
                                                                        { (yyval.node) = (yyvsp[-1].node); }
#line 45202 "gram.c"
    break;

  case 1659: /* select_no_parens: simple_select  */
#line 12549 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 45208 "gram.c"
    break;

  case 1660: /* select_no_parens: select_clause sort_clause  */
#line 12551 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 45219 "gram.c"
    break;

  case 1661: /* select_no_parens: select_clause opt_sort_clause for_locking_clause opt_select_limit  */
#line 12558 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 45231 "gram.c"
    break;

  case 1662: /* select_no_parens: select_clause opt_sort_clause select_limit opt_for_locking_clause  */
#line 12566 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 45243 "gram.c"
    break;

  case 1663: /* select_no_parens: with_clause select_clause  */
#line 12574 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 45255 "gram.c"
    break;

  case 1664: /* select_no_parens: with_clause select_clause sort_clause  */
#line 12582 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 45267 "gram.c"
    break;

  case 1665: /* select_no_parens: with_clause select_clause opt_sort_clause for_locking_clause opt_select_limit  */
#line 12590 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 45279 "gram.c"
    break;

  case 1666: /* select_no_parens: with_clause select_clause opt_sort_clause select_limit opt_for_locking_clause  */
#line 12598 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 45291 "gram.c"
    break;

  case 1667: /* select_clause: simple_select  */
#line 12608 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 45297 "gram.c"
    break;

  case 1668: /* select_clause: select_with_parens  */
#line 12609 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 45303 "gram.c"
    break;

  case 1669: /* simple_select: SELECT opt_all_clause opt_target_list into_clause from_clause where_clause group_clause having_clause window_clause  */
#line 12644 "gram.y"
                                {
					SelectStmt *n = makeNode(SelectStmt);

					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 45321 "gram.c"
    break;

  case 1670: /* simple_select: SELECT distinct_clause target_list into_clause from_clause where_clause group_clause having_clause window_clause  */
#line 12660 "gram.y"
                                {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 45340 "gram.c"
    break;

  case 1671: /* simple_select: values_clause  */
#line 12674 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 45346 "gram.c"
    break;

  case 1672: /* simple_select: TABLE relation_expr  */
#line 12676 "gram.y"
                                {
					/* same as SELECT * FROM relation_expr */
					ColumnRef  *cr = makeNode(ColumnRef);
					ResTarget  *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *) cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *) n;
				}
#line 45369 "gram.c"
    break;

  case 1673: /* simple_select: select_clause UNION set_quantifier select_clause  */
#line 12695 "gram.y"
                                {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 45377 "gram.c"
    break;

  case 1674: /* simple_select: select_clause INTERSECT set_quantifier select_clause  */
#line 12699 "gram.y"
                                {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 45385 "gram.c"
    break;

  case 1675: /* simple_select: select_clause EXCEPT set_quantifier select_clause  */
#line 12703 "gram.y"
                                {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 45393 "gram.c"
    break;

  case 1676: /* with_clause: WITH cte_list  */
#line 12718 "gram.y"
                        {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 45404 "gram.c"
    break;

  case 1677: /* with_clause: WITH_LA cte_list  */
#line 12725 "gram.y"
                        {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 45415 "gram.c"
    break;

  case 1678: /* with_clause: WITH RECURSIVE cte_list  */
#line 12732 "gram.y"
                        {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 45426 "gram.c"
    break;

  case 1679: /* cte_list: common_table_expr  */
#line 12741 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45432 "gram.c"
    break;

  case 1680: /* cte_list: cte_list ',' common_table_expr  */
#line 12742 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 45438 "gram.c"
    break;

  case 1681: /* common_table_expr: name opt_name_list AS opt_materialized '(' PreparableStmt ')' opt_search_clause opt_cycle_clause  */
#line 12746 "gram.y"
                        {
				CommonTableExpr *n = makeNode(CommonTableExpr);

				n->ctename = (yyvsp[-8].str);
				n->aliascolnames = (yyvsp[-7].list);
				n->ctematerialized = (yyvsp[-5].ival);
				n->ctequery = (yyvsp[-3].node);
				n->search_clause = castNode(CTESearchClause, (yyvsp[-1].node));
				n->cycle_clause = castNode(CTECycleClause, (yyvsp[0].node));
				n->location = (yylsp[-8]);
				(yyval.node) = (Node *) n;
			}
#line 45455 "gram.c"
    break;

  case 1682: /* opt_materialized: MATERIALIZED  */
#line 12761 "gram.y"
                                                                                { (yyval.ival) = CTEMaterializeAlways; }
#line 45461 "gram.c"
    break;

  case 1683: /* opt_materialized: NOT MATERIALIZED  */
#line 12762 "gram.y"
                                                                                { (yyval.ival) = CTEMaterializeNever; }
#line 45467 "gram.c"
    break;

  case 1684: /* opt_materialized: %empty  */
#line 12763 "gram.y"
                                                                                        { (yyval.ival) = CTEMaterializeDefault; }
#line 45473 "gram.c"
    break;

  case 1685: /* opt_search_clause: SEARCH DEPTH FIRST_P BY columnList SET ColId  */
#line 12768 "gram.y"
                        {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = false;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 45487 "gram.c"
    break;

  case 1686: /* opt_search_clause: SEARCH BREADTH FIRST_P BY columnList SET ColId  */
#line 12778 "gram.y"
                        {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = true;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 45501 "gram.c"
    break;

  case 1687: /* opt_search_clause: %empty  */
#line 12788 "gram.y"
                        {
				(yyval.node) = NULL;
			}
#line 45509 "gram.c"
    break;

  case 1688: /* opt_cycle_clause: CYCLE columnList SET ColId TO AexprConst DEFAULT AexprConst USING ColId  */
#line 12795 "gram.y"
                        {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-8].list);
				n->cycle_mark_column = (yyvsp[-6].str);
				n->cycle_mark_value = (yyvsp[-4].node);
				n->cycle_mark_default = (yyvsp[-2].node);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-9]);
				(yyval.node) = (Node *) n;
			}
#line 45525 "gram.c"
    break;

  case 1689: /* opt_cycle_clause: CYCLE columnList SET ColId USING ColId  */
#line 12807 "gram.y"
                        {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-4].list);
				n->cycle_mark_column = (yyvsp[-2].str);
				n->cycle_mark_value = makeBoolAConst(true, -1);
				n->cycle_mark_default = makeBoolAConst(false, -1);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 45541 "gram.c"
    break;

  case 1690: /* opt_cycle_clause: %empty  */
#line 12819 "gram.y"
                        {
				(yyval.node) = NULL;
			}
#line 45549 "gram.c"
    break;

  case 1691: /* opt_with_clause: with_clause  */
#line 12825 "gram.y"
                                                                                        { (yyval.with) = (yyvsp[0].with); }
#line 45555 "gram.c"
    break;

  case 1692: /* opt_with_clause: %empty  */
#line 12826 "gram.y"
                                                                                        { (yyval.with) = NULL; }
#line 45561 "gram.c"
    break;

  case 1693: /* into_clause: INTO OptTempTableName  */
#line 12831 "gram.y"
                                {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 45576 "gram.c"
    break;

  case 1694: /* into_clause: %empty  */
#line 12842 "gram.y"
                                { (yyval.into) = NULL; }
#line 45582 "gram.c"
    break;

  case 1695: /* OptTempTableName: TEMPORARY opt_table qualified_name  */
#line 12851 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 45591 "gram.c"
    break;

  case 1696: /* OptTempTableName: TEMP opt_table qualified_name  */
#line 12856 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 45600 "gram.c"
    break;

  case 1697: /* OptTempTableName: LOCAL TEMPORARY opt_table qualified_name  */
#line 12861 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 45609 "gram.c"
    break;

  case 1698: /* OptTempTableName: LOCAL TEMP opt_table qualified_name  */
#line 12866 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 45618 "gram.c"
    break;

  case 1699: /* OptTempTableName: GLOBAL TEMPORARY opt_table qualified_name  */
#line 12871 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 45630 "gram.c"
    break;

  case 1700: /* OptTempTableName: GLOBAL TEMP opt_table qualified_name  */
#line 12879 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 45642 "gram.c"
    break;

  case 1701: /* OptTempTableName: UNLOGGED opt_table qualified_name  */
#line 12887 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 45651 "gram.c"
    break;

  case 1702: /* OptTempTableName: TABLE qualified_name  */
#line 12892 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 45660 "gram.c"
    break;

  case 1703: /* OptTempTableName: qualified_name  */
#line 12897 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 45669 "gram.c"
    break;

  case 1706: /* set_quantifier: ALL  */
#line 12908 "gram.y"
                                                                                                        { (yyval.setquantifier) = SET_QUANTIFIER_ALL; }
#line 45675 "gram.c"
    break;

  case 1707: /* set_quantifier: DISTINCT  */
#line 12909 "gram.y"
                                                                                                { (yyval.setquantifier) = SET_QUANTIFIER_DISTINCT; }
#line 45681 "gram.c"
    break;

  case 1708: /* set_quantifier: %empty  */
#line 12910 "gram.y"
                                                                                                { (yyval.setquantifier) = SET_QUANTIFIER_DEFAULT; }
#line 45687 "gram.c"
    break;

  case 1709: /* distinct_clause: DISTINCT  */
#line 12917 "gram.y"
                                                                                                { (yyval.list) = list_make1(NIL); }
#line 45693 "gram.c"
    break;

  case 1710: /* distinct_clause: DISTINCT ON '(' expr_list ')'  */
#line 12918 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 45699 "gram.c"
    break;

  case 1713: /* opt_distinct_clause: distinct_clause  */
#line 12927 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 45705 "gram.c"
    break;

  case 1714: /* opt_distinct_clause: opt_all_clause  */
#line 12928 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 45711 "gram.c"
    break;

  case 1715: /* opt_sort_clause: sort_clause  */
#line 12932 "gram.y"
                                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 45717 "gram.c"
    break;

  case 1716: /* opt_sort_clause: %empty  */
#line 12933 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 45723 "gram.c"
    break;

  case 1717: /* sort_clause: ORDER BY sortby_list  */
#line 12937 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 45729 "gram.c"
    break;

  case 1718: /* sortby_list: sortby  */
#line 12941 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 45735 "gram.c"
    break;

  case 1719: /* sortby_list: sortby_list ',' sortby  */
#line 12942 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 45741 "gram.c"
    break;

  case 1720: /* sortby: a_expr USING qual_all_Op opt_nulls_order  */
#line 12946 "gram.y"
                                {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 45754 "gram.c"
    break;

  case 1721: /* sortby: a_expr opt_asc_desc opt_nulls_order  */
#line 12955 "gram.y"
                                {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 45767 "gram.c"
    break;

  case 1722: /* select_limit: limit_clause offset_clause  */
#line 12968 "gram.y"
                                {
					(yyval.selectlimit) = (yyvsp[-1].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[0].node);
				}
#line 45776 "gram.c"
    break;

  case 1723: /* select_limit: offset_clause limit_clause  */
#line 12973 "gram.y"
                                {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[-1].node);
				}
#line 45785 "gram.c"
    break;

  case 1724: /* select_limit: limit_clause  */
#line 12978 "gram.y"
                                {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
				}
#line 45793 "gram.c"
    break;

  case 1725: /* select_limit: offset_clause  */
#line 12982 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = (yyvsp[0].node);
					n->limitCount = NULL;
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 45806 "gram.c"
    break;

  case 1726: /* opt_select_limit: select_limit  */
#line 12993 "gram.y"
                                                                                { (yyval.selectlimit) = (yyvsp[0].selectlimit); }
#line 45812 "gram.c"
    break;

  case 1727: /* opt_select_limit: %empty  */
#line 12994 "gram.y"
                                                                                { (yyval.selectlimit) = NULL; }
#line 45818 "gram.c"
    break;

  case 1728: /* limit_clause: LIMIT select_limit_value  */
#line 12999 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[0].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 45831 "gram.c"
    break;

  case 1729: /* limit_clause: LIMIT select_limit_value ',' select_offset_value  */
#line 13008 "gram.y"
                                {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 45844 "gram.c"
    break;

  case 1730: /* limit_clause: FETCH first_or_next select_fetch_first_value row_or_rows ONLY  */
#line 13024 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-2].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 45857 "gram.c"
    break;

  case 1731: /* limit_clause: FETCH first_or_next select_fetch_first_value row_or_rows WITH TIES  */
#line 13033 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-3].node);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 45870 "gram.c"
    break;

  case 1732: /* limit_clause: FETCH first_or_next row_or_rows ONLY  */
#line 13042 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 45883 "gram.c"
    break;

  case 1733: /* limit_clause: FETCH first_or_next row_or_rows WITH TIES  */
#line 13051 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 45896 "gram.c"
    break;

  case 1734: /* offset_clause: OFFSET select_offset_value  */
#line 13063 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 45902 "gram.c"
    break;

  case 1735: /* offset_clause: OFFSET select_fetch_first_value row_or_rows  */
#line 13066 "gram.y"
                                { (yyval.node) = (yyvsp[-1].node); }
#line 45908 "gram.c"
    break;

  case 1736: /* select_limit_value: a_expr  */
#line 13070 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 45914 "gram.c"
    break;

  case 1737: /* select_limit_value: ALL  */
#line 13072 "gram.y"
                                {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 45923 "gram.c"
    break;

  case 1738: /* select_offset_value: a_expr  */
#line 13079 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 45929 "gram.c"
    break;

  case 1739: /* select_fetch_first_value: c_expr  */
#line 13099 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 45935 "gram.c"
    break;

  case 1740: /* select_fetch_first_value: '+' I_or_F_const  */
#line 13101 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 45941 "gram.c"
    break;

  case 1741: /* select_fetch_first_value: '-' I_or_F_const  */
#line 13103 "gram.y"
                                { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 45947 "gram.c"
    break;

  case 1742: /* I_or_F_const: Iconst  */
#line 13107 "gram.y"
                                                                                                { (yyval.node) = makeIntConst((yyvsp[0].ival),(yylsp[0])); }
#line 45953 "gram.c"
    break;

  case 1743: /* I_or_F_const: FCONST  */
#line 13108 "gram.y"
                                                                                                { (yyval.node) = makeFloatConst((yyvsp[0].str),(yylsp[0])); }
#line 45959 "gram.c"
    break;

  case 1744: /* row_or_rows: ROW  */
#line 13112 "gram.y"
                                                                                        { (yyval.ival) = 0; }
#line 45965 "gram.c"
    break;

  case 1745: /* row_or_rows: ROWS  */
#line 13113 "gram.y"
                                                                                                { (yyval.ival) = 0; }
#line 45971 "gram.c"
    break;

  case 1746: /* first_or_next: FIRST_P  */
#line 13116 "gram.y"
                                                                                { (yyval.ival) = 0; }
#line 45977 "gram.c"
    break;

  case 1747: /* first_or_next: NEXT  */
#line 13117 "gram.y"
                                                                                                { (yyval.ival) = 0; }
#line 45983 "gram.c"
    break;

  case 1748: /* group_clause: GROUP_P BY set_quantifier group_by_list  */
#line 13143 "gram.y"
                                {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = (yyvsp[-1].setquantifier) == SET_QUANTIFIER_DISTINCT;
					n->list = (yyvsp[0].list);
					(yyval.groupclause) = n;
				}
#line 45995 "gram.c"
    break;

  case 1749: /* group_clause: %empty  */
#line 13151 "gram.y"
                                {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = false;
					n->list = NIL;
					(yyval.groupclause) = n;
				}
#line 46007 "gram.c"
    break;

  case 1750: /* group_by_list: group_by_item  */
#line 13161 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46013 "gram.c"
    break;

  case 1751: /* group_by_list: group_by_list ',' group_by_item  */
#line 13162 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 46019 "gram.c"
    break;

  case 1752: /* group_by_item: a_expr  */
#line 13166 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 46025 "gram.c"
    break;

  case 1753: /* group_by_item: empty_grouping_set  */
#line 13167 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 46031 "gram.c"
    break;

  case 1754: /* group_by_item: cube_clause  */
#line 13168 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 46037 "gram.c"
    break;

  case 1755: /* group_by_item: rollup_clause  */
#line 13169 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 46043 "gram.c"
    break;

  case 1756: /* group_by_item: grouping_sets_clause  */
#line 13170 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 46049 "gram.c"
    break;

  case 1757: /* empty_grouping_set: '(' ')'  */
#line 13175 "gram.y"
                                {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 46057 "gram.c"
    break;

  case 1758: /* rollup_clause: ROLLUP '(' expr_list ')'  */
#line 13188 "gram.y"
                                {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 46065 "gram.c"
    break;

  case 1759: /* cube_clause: CUBE '(' expr_list ')'  */
#line 13195 "gram.y"
                                {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 46073 "gram.c"
    break;

  case 1760: /* grouping_sets_clause: GROUPING SETS '(' group_by_list ')'  */
#line 13202 "gram.y"
                                {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 46081 "gram.c"
    break;

  case 1761: /* having_clause: HAVING a_expr  */
#line 13208 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 46087 "gram.c"
    break;

  case 1762: /* having_clause: %empty  */
#line 13209 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 46093 "gram.c"
    break;

  case 1763: /* for_locking_clause: for_locking_items  */
#line 13213 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 46099 "gram.c"
    break;

  case 1764: /* for_locking_clause: FOR READ ONLY  */
#line 13214 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 46105 "gram.c"
    break;

  case 1765: /* opt_for_locking_clause: for_locking_clause  */
#line 13218 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 46111 "gram.c"
    break;

  case 1766: /* opt_for_locking_clause: %empty  */
#line 13219 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 46117 "gram.c"
    break;

  case 1767: /* for_locking_items: for_locking_item  */
#line 13223 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46123 "gram.c"
    break;

  case 1768: /* for_locking_items: for_locking_items for_locking_item  */
#line 13224 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 46129 "gram.c"
    break;

  case 1769: /* for_locking_item: for_locking_strength locked_rels_list opt_nowait_or_skip  */
#line 13229 "gram.y"
                                {
					LockingClause *n = makeNode(LockingClause);

					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 46142 "gram.c"
    break;

  case 1770: /* for_locking_strength: FOR UPDATE  */
#line 13240 "gram.y"
                                                                                        { (yyval.ival) = LCS_FORUPDATE; }
#line 46148 "gram.c"
    break;

  case 1771: /* for_locking_strength: FOR NO KEY UPDATE  */
#line 13241 "gram.y"
                                                                                { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 46154 "gram.c"
    break;

  case 1772: /* for_locking_strength: FOR SHARE  */
#line 13242 "gram.y"
                                                                                        { (yyval.ival) = LCS_FORSHARE; }
#line 46160 "gram.c"
    break;

  case 1773: /* for_locking_strength: FOR KEY SHARE  */
#line 13243 "gram.y"
                                                                                { (yyval.ival) = LCS_FORKEYSHARE; }
#line 46166 "gram.c"
    break;

  case 1774: /* locked_rels_list: OF qualified_name_list  */
#line 13247 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 46172 "gram.c"
    break;

  case 1775: /* locked_rels_list: %empty  */
#line 13248 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 46178 "gram.c"
    break;

  case 1776: /* values_clause: VALUES '(' expr_list ')'  */
#line 13259 "gram.y"
                                {
					SelectStmt *n = makeNode(SelectStmt);

					n->valuesLists = list_make1((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 46189 "gram.c"
    break;

  case 1777: /* values_clause: values_clause ',' '(' expr_list ')'  */
#line 13266 "gram.y"
                                {
					SelectStmt *n = (SelectStmt *) (yyvsp[-4].node);

					n->valuesLists = lappend(n->valuesLists, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 46200 "gram.c"
    break;

  case 1778: /* from_clause: FROM from_list  */
#line 13284 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 46206 "gram.c"
    break;

  case 1779: /* from_clause: %empty  */
#line 13285 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 46212 "gram.c"
    break;

  case 1780: /* from_list: table_ref  */
#line 13289 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46218 "gram.c"
    break;

  case 1781: /* from_list: from_list ',' table_ref  */
#line 13290 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 46224 "gram.c"
    break;

  case 1782: /* table_ref: relation_expr opt_alias_clause  */
#line 13297 "gram.y"
                                {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 46233 "gram.c"
    break;

  case 1783: /* table_ref: relation_expr opt_alias_clause tablesample_clause  */
#line 13302 "gram.y"
                                {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);

					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 46246 "gram.c"
    break;

  case 1784: /* table_ref: func_table func_alias_clause  */
#line 13311 "gram.y"
                                {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 46258 "gram.c"
    break;

  case 1785: /* table_ref: LATERAL_P func_table func_alias_clause  */
#line 13319 "gram.y"
                                {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 46271 "gram.c"
    break;

  case 1786: /* table_ref: xmltable opt_alias_clause  */
#line 13328 "gram.y"
                                {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 46282 "gram.c"
    break;

  case 1787: /* table_ref: LATERAL_P xmltable opt_alias_clause  */
#line 13335 "gram.y"
                                {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 46294 "gram.c"
    break;

  case 1788: /* table_ref: select_with_parens opt_alias_clause  */
#line 13343 "gram.y"
                                {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 46334 "gram.c"
    break;

  case 1789: /* table_ref: LATERAL_P select_with_parens opt_alias_clause  */
#line 13379 "gram.y"
                                {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/* same comment as above */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 46364 "gram.c"
    break;

  case 1790: /* table_ref: joined_table  */
#line 13405 "gram.y"
                                {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 46372 "gram.c"
    break;

  case 1791: /* table_ref: '(' joined_table ')' alias_clause  */
#line 13409 "gram.y"
                                {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 46381 "gram.c"
    break;

  case 1792: /* table_ref: json_table opt_alias_clause  */
#line 13414 "gram.y"
                                {
					JsonTable  *jt = castNode(JsonTable, (yyvsp[-1].node));

					jt->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) jt;
				}
#line 46392 "gram.c"
    break;

  case 1793: /* table_ref: LATERAL_P json_table opt_alias_clause  */
#line 13421 "gram.y"
                                {
					JsonTable  *jt = castNode(JsonTable, (yyvsp[-1].node));

					jt->alias = (yyvsp[0].alias);
					jt->lateral = true;
					(yyval.node) = (Node *) jt;
				}
#line 46404 "gram.c"
    break;

  case 1794: /* joined_table: '(' joined_table ')'  */
#line 13450 "gram.y"
                                {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 46412 "gram.c"
    break;

  case 1795: /* joined_table: table_ref CROSS JOIN table_ref  */
#line 13454 "gram.y"
                                {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->join_using_alias = NULL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 46430 "gram.c"
    break;

  case 1796: /* joined_table: table_ref join_type JOIN table_ref join_qual  */
#line 13468 "gram.y"
                                {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = false;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						 /* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 46455 "gram.c"
    break;

  case 1797: /* joined_table: table_ref JOIN table_ref join_qual  */
#line 13489 "gram.y"
                                {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						/* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 46481 "gram.c"
    break;

  case 1798: /* joined_table: table_ref NATURAL join_type JOIN table_ref  */
#line 13511 "gram.y"
                                {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = true;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 46498 "gram.c"
    break;

  case 1799: /* joined_table: table_ref NATURAL JOIN table_ref  */
#line 13524 "gram.y"
                                {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = true;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 46516 "gram.c"
    break;

  case 1800: /* alias_clause: AS ColId '(' name_list ')'  */
#line 13541 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 46526 "gram.c"
    break;

  case 1801: /* alias_clause: AS ColId  */
#line 13547 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 46535 "gram.c"
    break;

  case 1802: /* alias_clause: ColId '(' name_list ')'  */
#line 13552 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 46545 "gram.c"
    break;

  case 1803: /* alias_clause: ColId  */
#line 13558 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 46554 "gram.c"
    break;

  case 1804: /* opt_alias_clause: alias_clause  */
#line 13564 "gram.y"
                                                                        { (yyval.alias) = (yyvsp[0].alias); }
#line 46560 "gram.c"
    break;

  case 1805: /* opt_alias_clause: %empty  */
#line 13565 "gram.y"
                                                                                                { (yyval.alias) = NULL; }
#line 46566 "gram.c"
    break;

  case 1806: /* opt_alias_clause_for_join_using: AS ColId  */
#line 13576 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
					/* the column name list will be inserted later */
				}
#line 46576 "gram.c"
    break;

  case 1807: /* opt_alias_clause_for_join_using: %empty  */
#line 13581 "gram.y"
                                                                                                { (yyval.alias) = NULL; }
#line 46582 "gram.c"
    break;

  case 1808: /* func_alias_clause: alias_clause  */
#line 13590 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 46590 "gram.c"
    break;

  case 1809: /* func_alias_clause: AS '(' TableFuncElementList ')'  */
#line 13594 "gram.y"
                                {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 46598 "gram.c"
    break;

  case 1810: /* func_alias_clause: AS ColId '(' TableFuncElementList ')'  */
#line 13598 "gram.y"
                                {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 46609 "gram.c"
    break;

  case 1811: /* func_alias_clause: ColId '(' TableFuncElementList ')'  */
#line 13605 "gram.y"
                                {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 46620 "gram.c"
    break;

  case 1812: /* func_alias_clause: %empty  */
#line 13612 "gram.y"
                                {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 46628 "gram.c"
    break;

  case 1813: /* join_type: FULL opt_outer  */
#line 13617 "gram.y"
                                                                                { (yyval.jtype) = JOIN_FULL; }
#line 46634 "gram.c"
    break;

  case 1814: /* join_type: LEFT opt_outer  */
#line 13618 "gram.y"
                                                                                        { (yyval.jtype) = JOIN_LEFT; }
#line 46640 "gram.c"
    break;

  case 1815: /* join_type: RIGHT opt_outer  */
#line 13619 "gram.y"
                                                                                        { (yyval.jtype) = JOIN_RIGHT; }
#line 46646 "gram.c"
    break;

  case 1816: /* join_type: INNER_P  */
#line 13620 "gram.y"
                                                                                                { (yyval.jtype) = JOIN_INNER; }
#line 46652 "gram.c"
    break;

  case 1819: /* join_qual: USING '(' name_list ')' opt_alias_clause_for_join_using  */
#line 13641 "gram.y"
                                {
					(yyval.node) = (Node *) list_make2((yyvsp[-2].list), (yyvsp[0].alias));
				}
#line 46660 "gram.c"
    break;

  case 1820: /* join_qual: ON a_expr  */
#line 13645 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 46668 "gram.c"
    break;

  case 1821: /* relation_expr: qualified_name  */
#line 13653 "gram.y"
                                {
					/* inheritance query, implicitly */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 46679 "gram.c"
    break;

  case 1822: /* relation_expr: extended_relation_expr  */
#line 13660 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
				}
#line 46687 "gram.c"
    break;

  case 1823: /* extended_relation_expr: qualified_name '*'  */
#line 13667 "gram.y"
                                {
					/* inheritance query, explicitly */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 46698 "gram.c"
    break;

  case 1824: /* extended_relation_expr: ONLY qualified_name  */
#line 13674 "gram.y"
                                {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 46709 "gram.c"
    break;

  case 1825: /* extended_relation_expr: ONLY '(' qualified_name ')'  */
#line 13681 "gram.y"
                                {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 46720 "gram.c"
    break;

  case 1826: /* relation_expr_list: relation_expr  */
#line 13691 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 46726 "gram.c"
    break;

  case 1827: /* relation_expr_list: relation_expr_list ',' relation_expr  */
#line 13692 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 46732 "gram.c"
    break;

  case 1828: /* relation_expr_opt_alias: relation_expr  */
#line 13706 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
				}
#line 46740 "gram.c"
    break;

  case 1829: /* relation_expr_opt_alias: relation_expr ColId  */
#line 13710 "gram.y"
                                {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 46752 "gram.c"
    break;

  case 1830: /* relation_expr_opt_alias: relation_expr AS ColId  */
#line 13718 "gram.y"
                                {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 46764 "gram.c"
    break;

  case 1831: /* tablesample_clause: TABLESAMPLE func_name '(' expr_list ')' opt_repeatable_clause  */
#line 13732 "gram.y"
                                {
					RangeTableSample *n = makeNode(RangeTableSample);

					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 46779 "gram.c"
    break;

  case 1832: /* opt_repeatable_clause: REPEATABLE '(' a_expr ')'  */
#line 13745 "gram.y"
                                                        { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 46785 "gram.c"
    break;

  case 1833: /* opt_repeatable_clause: %empty  */
#line 13746 "gram.y"
                                                                        { (yyval.node) = NULL; }
#line 46791 "gram.c"
    break;

  case 1834: /* func_table: func_expr_windowless opt_ordinality  */
#line 13762 "gram.y"
                                {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 46806 "gram.c"
    break;

  case 1835: /* func_table: ROWS FROM '(' rowsfrom_list ')' opt_ordinality  */
#line 13773 "gram.y"
                                {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 46821 "gram.c"
    break;

  case 1836: /* rowsfrom_item: func_expr_windowless opt_col_def_list  */
#line 13786 "gram.y"
                                { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 46827 "gram.c"
    break;

  case 1837: /* rowsfrom_list: rowsfrom_item  */
#line 13790 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 46833 "gram.c"
    break;

  case 1838: /* rowsfrom_list: rowsfrom_list ',' rowsfrom_item  */
#line 13791 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 46839 "gram.c"
    break;

  case 1839: /* opt_col_def_list: AS '(' TableFuncElementList ')'  */
#line 13794 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 46845 "gram.c"
    break;

  case 1840: /* opt_col_def_list: %empty  */
#line 13795 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 46851 "gram.c"
    break;

  case 1841: /* opt_ordinality: WITH_LA ORDINALITY  */
#line 13798 "gram.y"
                                                                        { (yyval.boolean) = true; }
#line 46857 "gram.c"
    break;

  case 1842: /* opt_ordinality: %empty  */
#line 13799 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 46863 "gram.c"
    break;

  case 1843: /* where_clause: WHERE a_expr  */
#line 13804 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 46869 "gram.c"
    break;

  case 1844: /* where_clause: %empty  */
#line 13805 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 46875 "gram.c"
    break;

  case 1845: /* where_or_current_clause: WHERE a_expr  */
#line 13810 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 46881 "gram.c"
    break;

  case 1846: /* where_or_current_clause: WHERE CURRENT_P OF cursor_name  */
#line 13812 "gram.y"
                                {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);

					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 46894 "gram.c"
    break;

  case 1847: /* where_or_current_clause: %empty  */
#line 13820 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 46900 "gram.c"
    break;

  case 1848: /* OptTableFuncElementList: TableFuncElementList  */
#line 13825 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 46906 "gram.c"
    break;

  case 1849: /* OptTableFuncElementList: %empty  */
#line 13826 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 46912 "gram.c"
    break;

  case 1850: /* TableFuncElementList: TableFuncElement  */
#line 13831 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 46920 "gram.c"
    break;

  case 1851: /* TableFuncElementList: TableFuncElementList ',' TableFuncElement  */
#line 13835 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 46928 "gram.c"
    break;

  case 1852: /* TableFuncElement: ColId Typename opt_collate_clause  */
#line 13841 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 46951 "gram.c"
    break;

  case 1853: /* xmltable: XMLTABLE '(' c_expr xmlexists_argument COLUMNS xmltable_column_list ')'  */
#line 13866 "gram.y"
                                {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = NIL;
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 46966 "gram.c"
    break;

  case 1854: /* xmltable: XMLTABLE '(' XMLNAMESPACES '(' xml_namespace_list ')' ',' c_expr xmlexists_argument COLUMNS xmltable_column_list ')'  */
#line 13878 "gram.y"
                                {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = (yyvsp[-7].list);
					n->location = (yylsp[-11]);
					(yyval.node) = (Node *) n;
				}
#line 46981 "gram.c"
    break;

  case 1855: /* xmltable_column_list: xmltable_column_el  */
#line 13890 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46987 "gram.c"
    break;

  case 1856: /* xmltable_column_list: xmltable_column_list ',' xmltable_column_el  */
#line 13891 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 46993 "gram.c"
    break;

  case 1857: /* xmltable_column_el: ColId Typename  */
#line 13896 "gram.y"
                                {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-1].str);
					fc->for_ordinality = false;
					fc->typeName = (yyvsp[0].typnam);
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-1]);

					(yyval.node) = (Node *) fc;
				}
#line 47011 "gram.c"
    break;

  case 1858: /* xmltable_column_el: ColId Typename xmltable_column_option_list  */
#line 13910 "gram.y"
                                {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);
					ListCell   *option;
					bool		nullability_seen = false;

					fc->colname = (yyvsp[-2].str);
					fc->typeName = (yyvsp[-1].typnam);
					fc->for_ordinality = false;
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-2]);

					foreach(option, (yyvsp[0].list))
					{
						DefElem   *defel = (DefElem *) lfirst(option);

						if (strcmp(defel->defname, "default") == 0)
						{
							if (fc->coldefexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one DEFAULT value is allowed"),
										 parser_errposition(defel->location)));
							fc->coldefexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "path") == 0)
						{
							if (fc->colexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one PATH value per column is allowed"),
										 parser_errposition(defel->location)));
							fc->colexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "is_not_null") == 0)
						{
							if (nullability_seen)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("conflicting or redundant NULL / NOT NULL declarations for column \"%s\"", fc->colname),
										 parser_errposition(defel->location)));
							fc->is_not_null = boolVal(defel->arg);
							nullability_seen = true;
						}
						else
						{
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized column option \"%s\"",
											defel->defname),
									 parser_errposition(defel->location)));
						}
					}
					(yyval.node) = (Node *) fc;
				}
#line 47072 "gram.c"
    break;

  case 1859: /* xmltable_column_el: ColId FOR ORDINALITY  */
#line 13967 "gram.y"
                                {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-2].str);
					fc->for_ordinality = true;
					/* other fields are ignored, initialized by makeNode */
					fc->location = (yylsp[-2]);

					(yyval.node) = (Node *) fc;
				}
#line 47087 "gram.c"
    break;

  case 1860: /* xmltable_column_option_list: xmltable_column_option_el  */
#line 13981 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 47093 "gram.c"
    break;

  case 1861: /* xmltable_column_option_list: xmltable_column_option_list xmltable_column_option_el  */
#line 13983 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 47099 "gram.c"
    break;

  case 1862: /* xmltable_column_option_el: IDENT b_expr  */
#line 13988 "gram.y"
                                { (yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1])); }
#line 47105 "gram.c"
    break;

  case 1863: /* xmltable_column_option_el: DEFAULT b_expr  */
#line 13990 "gram.y"
                                { (yyval.defelt) = makeDefElem("default", (yyvsp[0].node), (yylsp[-1])); }
#line 47111 "gram.c"
    break;

  case 1864: /* xmltable_column_option_el: NOT NULL_P  */
#line 13992 "gram.y"
                                { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(true), (yylsp[-1])); }
#line 47117 "gram.c"
    break;

  case 1865: /* xmltable_column_option_el: NULL_P  */
#line 13994 "gram.y"
                                { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(false), (yylsp[0])); }
#line 47123 "gram.c"
    break;

  case 1866: /* xmltable_column_option_el: PATH b_expr  */
#line 13996 "gram.y"
                                { (yyval.defelt) = makeDefElem("path", (yyvsp[0].node), (yylsp[-1])); }
#line 47129 "gram.c"
    break;

  case 1867: /* xml_namespace_list: xml_namespace_el  */
#line 14001 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 47135 "gram.c"
    break;

  case 1868: /* xml_namespace_list: xml_namespace_list ',' xml_namespace_el  */
#line 14003 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 47141 "gram.c"
    break;

  case 1869: /* xml_namespace_el: b_expr AS ColLabel  */
#line 14008 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 47153 "gram.c"
    break;

  case 1870: /* xml_namespace_el: DEFAULT b_expr  */
#line 14016 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[0].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 47165 "gram.c"
    break;

  case 1871: /* Typename: SimpleTypename opt_array_bounds  */
#line 14036 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 47174 "gram.c"
    break;

  case 1872: /* Typename: SETOF SimpleTypename opt_array_bounds  */
#line 14041 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = true;
				}
#line 47184 "gram.c"
    break;

  case 1873: /* Typename: SimpleTypename ARRAY '[' Iconst ']'  */
#line 14048 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 47193 "gram.c"
    break;

  case 1874: /* Typename: SETOF SimpleTypename ARRAY '[' Iconst ']'  */
#line 14053 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = true;
				}
#line 47203 "gram.c"
    break;

  case 1875: /* Typename: SimpleTypename ARRAY  */
#line 14059 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 47212 "gram.c"
    break;

  case 1876: /* Typename: SETOF SimpleTypename ARRAY  */
#line 14064 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = true;
				}
#line 47222 "gram.c"
    break;

  case 1877: /* opt_array_bounds: opt_array_bounds '[' ']'  */
#line 14073 "gram.y"
                                        {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 47228 "gram.c"
    break;

  case 1878: /* opt_array_bounds: opt_array_bounds '[' Iconst ']'  */
#line 14075 "gram.y"
                                        {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 47234 "gram.c"
    break;

  case 1879: /* opt_array_bounds: %empty  */
#line 14077 "gram.y"
                                        {  (yyval.list) = NIL; }
#line 47240 "gram.c"
    break;

  case 1880: /* SimpleTypename: GenericType  */
#line 14081 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47246 "gram.c"
    break;

  case 1881: /* SimpleTypename: Numeric  */
#line 14082 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47252 "gram.c"
    break;

  case 1882: /* SimpleTypename: Bit  */
#line 14083 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47258 "gram.c"
    break;

  case 1883: /* SimpleTypename: Character  */
#line 14084 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47264 "gram.c"
    break;

  case 1884: /* SimpleTypename: ConstDatetime  */
#line 14085 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47270 "gram.c"
    break;

  case 1885: /* SimpleTypename: ConstInterval opt_interval  */
#line 14087 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 47279 "gram.c"
    break;

  case 1886: /* SimpleTypename: ConstInterval '(' Iconst ')'  */
#line 14092 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 47289 "gram.c"
    break;

  case 1887: /* SimpleTypename: JsonType  */
#line 14097 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47295 "gram.c"
    break;

  case 1888: /* ConstTypename: Numeric  */
#line 14112 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47301 "gram.c"
    break;

  case 1889: /* ConstTypename: ConstBit  */
#line 14113 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47307 "gram.c"
    break;

  case 1890: /* ConstTypename: ConstCharacter  */
#line 14114 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47313 "gram.c"
    break;

  case 1891: /* ConstTypename: ConstDatetime  */
#line 14115 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47319 "gram.c"
    break;

  case 1892: /* ConstTypename: JsonType  */
#line 14116 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47325 "gram.c"
    break;

  case 1893: /* GenericType: type_function_name opt_type_modifiers  */
#line 14128 "gram.y"
                                {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 47335 "gram.c"
    break;

  case 1894: /* GenericType: type_function_name attrs opt_type_modifiers  */
#line 14134 "gram.y"
                                {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 47345 "gram.c"
    break;

  case 1895: /* opt_type_modifiers: '(' expr_list ')'  */
#line 14141 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 47351 "gram.c"
    break;

  case 1896: /* opt_type_modifiers: %empty  */
#line 14142 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 47357 "gram.c"
    break;

  case 1897: /* Numeric: INT_P  */
#line 14149 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 47366 "gram.c"
    break;

  case 1898: /* Numeric: INTEGER  */
#line 14154 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 47375 "gram.c"
    break;

  case 1899: /* Numeric: SMALLINT  */
#line 14159 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 47384 "gram.c"
    break;

  case 1900: /* Numeric: BIGINT  */
#line 14164 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 47393 "gram.c"
    break;

  case 1901: /* Numeric: REAL  */
#line 14169 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 47402 "gram.c"
    break;

  case 1902: /* Numeric: FLOAT_P opt_float  */
#line 14174 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 47411 "gram.c"
    break;

  case 1903: /* Numeric: DOUBLE_P PRECISION  */
#line 14179 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 47420 "gram.c"
    break;

  case 1904: /* Numeric: DECIMAL_P opt_type_modifiers  */
#line 14184 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 47430 "gram.c"
    break;

  case 1905: /* Numeric: DEC opt_type_modifiers  */
#line 14190 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 47440 "gram.c"
    break;

  case 1906: /* Numeric: NUMERIC opt_type_modifiers  */
#line 14196 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 47450 "gram.c"
    break;

  case 1907: /* Numeric: BOOLEAN_P  */
#line 14202 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 47459 "gram.c"
    break;

  case 1908: /* opt_float: '(' Iconst ')'  */
#line 14209 "gram.y"
                                {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 47484 "gram.c"
    break;

  case 1909: /* opt_float: %empty  */
#line 14230 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 47492 "gram.c"
    break;

  case 1910: /* Bit: BitWithLength  */
#line 14240 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 47500 "gram.c"
    break;

  case 1911: /* Bit: BitWithoutLength  */
#line 14244 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 47508 "gram.c"
    break;

  case 1912: /* ConstBit: BitWithLength  */
#line 14252 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 47516 "gram.c"
    break;

  case 1913: /* ConstBit: BitWithoutLength  */
#line 14256 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 47525 "gram.c"
    break;

  case 1914: /* BitWithLength: BIT opt_varying '(' expr_list ')'  */
#line 14264 "gram.y"
                                {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 47538 "gram.c"
    break;

  case 1915: /* BitWithoutLength: BIT opt_varying  */
#line 14276 "gram.y"
                                {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 47556 "gram.c"
    break;

  case 1916: /* Character: CharacterWithLength  */
#line 14297 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 47564 "gram.c"
    break;

  case 1917: /* Character: CharacterWithoutLength  */
#line 14301 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 47572 "gram.c"
    break;

  case 1918: /* ConstCharacter: CharacterWithLength  */
#line 14307 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 47580 "gram.c"
    break;

  case 1919: /* ConstCharacter: CharacterWithoutLength  */
#line 14311 "gram.y"
                                {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 47595 "gram.c"
    break;

  case 1920: /* CharacterWithLength: character '(' Iconst ')'  */
#line 14324 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName((yyvsp[-3].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 47605 "gram.c"
    break;

  case 1921: /* CharacterWithoutLength: character  */
#line 14332 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName((yyvsp[0].str));
					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[0].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 47617 "gram.c"
    break;

  case 1922: /* character: CHARACTER opt_varying  */
#line 14342 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 47623 "gram.c"
    break;

  case 1923: /* character: CHAR_P opt_varying  */
#line 14344 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 47629 "gram.c"
    break;

  case 1924: /* character: VARCHAR  */
#line 14346 "gram.y"
                                                                                { (yyval.str) = "varchar"; }
#line 47635 "gram.c"
    break;

  case 1925: /* character: NATIONAL CHARACTER opt_varying  */
#line 14348 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 47641 "gram.c"
    break;

  case 1926: /* character: NATIONAL CHAR_P opt_varying  */
#line 14350 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 47647 "gram.c"
    break;

  case 1927: /* character: NCHAR opt_varying  */
#line 14352 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 47653 "gram.c"
    break;

  case 1928: /* opt_varying: VARYING  */
#line 14356 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 47659 "gram.c"
    break;

  case 1929: /* opt_varying: %empty  */
#line 14357 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 47665 "gram.c"
    break;

  case 1930: /* ConstDatetime: TIMESTAMP '(' Iconst ')' opt_timezone  */
#line 14365 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 47678 "gram.c"
    break;

  case 1931: /* ConstDatetime: TIMESTAMP opt_timezone  */
#line 14374 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 47690 "gram.c"
    break;

  case 1932: /* ConstDatetime: TIME '(' Iconst ')' opt_timezone  */
#line 14382 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 47703 "gram.c"
    break;

  case 1933: /* ConstDatetime: TIME opt_timezone  */
#line 14391 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 47715 "gram.c"
    break;

  case 1934: /* ConstInterval: INTERVAL  */
#line 14402 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 47724 "gram.c"
    break;

  case 1935: /* opt_timezone: WITH_LA TIME ZONE  */
#line 14409 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 47730 "gram.c"
    break;

  case 1936: /* opt_timezone: WITHOUT_LA TIME ZONE  */
#line 14410 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 47736 "gram.c"
    break;

  case 1937: /* opt_timezone: %empty  */
#line 14411 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 47742 "gram.c"
    break;

  case 1938: /* opt_interval: YEAR_P  */
#line 14416 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 47748 "gram.c"
    break;

  case 1939: /* opt_interval: MONTH_P  */
#line 14418 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 47754 "gram.c"
    break;

  case 1940: /* opt_interval: DAY_P  */
#line 14420 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 47760 "gram.c"
    break;

  case 1941: /* opt_interval: HOUR_P  */
#line 14422 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 47766 "gram.c"
    break;

  case 1942: /* opt_interval: MINUTE_P  */
#line 14424 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 47772 "gram.c"
    break;

  case 1943: /* opt_interval: interval_second  */
#line 14426 "gram.y"
                                { (yyval.list) = (yyvsp[0].list); }
#line 47778 "gram.c"
    break;

  case 1944: /* opt_interval: YEAR_P TO MONTH_P  */
#line 14428 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 47787 "gram.c"
    break;

  case 1945: /* opt_interval: DAY_P TO HOUR_P  */
#line 14433 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 47796 "gram.c"
    break;

  case 1946: /* opt_interval: DAY_P TO MINUTE_P  */
#line 14438 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 47806 "gram.c"
    break;

  case 1947: /* opt_interval: DAY_P TO interval_second  */
#line 14444 "gram.y"
                                {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 47818 "gram.c"
    break;

  case 1948: /* opt_interval: HOUR_P TO MINUTE_P  */
#line 14452 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 47827 "gram.c"
    break;

  case 1949: /* opt_interval: HOUR_P TO interval_second  */
#line 14457 "gram.y"
                                {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 47838 "gram.c"
    break;

  case 1950: /* opt_interval: MINUTE_P TO interval_second  */
#line 14464 "gram.y"
                                {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 47848 "gram.c"
    break;

  case 1951: /* opt_interval: %empty  */
#line 14470 "gram.y"
                                { (yyval.list) = NIL; }
#line 47854 "gram.c"
    break;

  case 1952: /* interval_second: SECOND_P  */
#line 14475 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 47862 "gram.c"
    break;

  case 1953: /* interval_second: SECOND_P '(' Iconst ')'  */
#line 14479 "gram.y"
                                {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 47871 "gram.c"
    break;

  case 1954: /* JsonType: JSON  */
#line 14487 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("json");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 47880 "gram.c"
    break;

  case 1955: /* a_expr: c_expr  */
#line 14521 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 47886 "gram.c"
    break;

  case 1956: /* a_expr: a_expr TYPECAST Typename  */
#line 14523 "gram.y"
                                        { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 47892 "gram.c"
    break;

  case 1957: /* a_expr: a_expr COLLATE any_name  */
#line 14525 "gram.y"
                                {
					CollateClause *n = makeNode(CollateClause);

					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 47905 "gram.c"
    break;

  case 1958: /* a_expr: a_expr AT TIME ZONE a_expr  */
#line 14534 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 47916 "gram.c"
    break;

  case 1959: /* a_expr: '+' a_expr  */
#line 14550 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 47922 "gram.c"
    break;

  case 1960: /* a_expr: '-' a_expr  */
#line 14552 "gram.y"
                                { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 47928 "gram.c"
    break;

  case 1961: /* a_expr: a_expr '+' a_expr  */
#line 14554 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47934 "gram.c"
    break;

  case 1962: /* a_expr: a_expr '-' a_expr  */
#line 14556 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47940 "gram.c"
    break;

  case 1963: /* a_expr: a_expr '*' a_expr  */
#line 14558 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47946 "gram.c"
    break;

  case 1964: /* a_expr: a_expr '/' a_expr  */
#line 14560 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47952 "gram.c"
    break;

  case 1965: /* a_expr: a_expr '%' a_expr  */
#line 14562 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47958 "gram.c"
    break;

  case 1966: /* a_expr: a_expr '^' a_expr  */
#line 14564 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47964 "gram.c"
    break;

  case 1967: /* a_expr: a_expr '<' a_expr  */
#line 14566 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47970 "gram.c"
    break;

  case 1968: /* a_expr: a_expr '>' a_expr  */
#line 14568 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47976 "gram.c"
    break;

  case 1969: /* a_expr: a_expr '=' a_expr  */
#line 14570 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47982 "gram.c"
    break;

  case 1970: /* a_expr: a_expr LESS_EQUALS a_expr  */
#line 14572 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47988 "gram.c"
    break;

  case 1971: /* a_expr: a_expr GREATER_EQUALS a_expr  */
#line 14574 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47994 "gram.c"
    break;

  case 1972: /* a_expr: a_expr NOT_EQUALS a_expr  */
#line 14576 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48000 "gram.c"
    break;

  case 1973: /* a_expr: a_expr qual_Op a_expr  */
#line 14579 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48006 "gram.c"
    break;

  case 1974: /* a_expr: qual_Op a_expr  */
#line 14581 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 48012 "gram.c"
    break;

  case 1975: /* a_expr: a_expr AND a_expr  */
#line 14584 "gram.y"
                                { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48018 "gram.c"
    break;

  case 1976: /* a_expr: a_expr OR a_expr  */
#line 14586 "gram.y"
                                { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48024 "gram.c"
    break;

  case 1977: /* a_expr: NOT a_expr  */
#line 14588 "gram.y"
                                { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 48030 "gram.c"
    break;

  case 1978: /* a_expr: NOT_LA a_expr  */
#line 14590 "gram.y"
                                { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 48036 "gram.c"
    break;

  case 1979: /* a_expr: a_expr LIKE a_expr  */
#line 14593 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 48045 "gram.c"
    break;

  case 1980: /* a_expr: a_expr LIKE a_expr ESCAPE a_expr  */
#line 14598 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 48058 "gram.c"
    break;

  case 1981: /* a_expr: a_expr NOT_LA LIKE a_expr  */
#line 14607 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 48067 "gram.c"
    break;

  case 1982: /* a_expr: a_expr NOT_LA LIKE a_expr ESCAPE a_expr  */
#line 14612 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 48080 "gram.c"
    break;

  case 1983: /* a_expr: a_expr ILIKE a_expr  */
#line 14621 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 48089 "gram.c"
    break;

  case 1984: /* a_expr: a_expr ILIKE a_expr ESCAPE a_expr  */
#line 14626 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 48102 "gram.c"
    break;

  case 1985: /* a_expr: a_expr NOT_LA ILIKE a_expr  */
#line 14635 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 48111 "gram.c"
    break;

  case 1986: /* a_expr: a_expr NOT_LA ILIKE a_expr ESCAPE a_expr  */
#line 14640 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 48124 "gram.c"
    break;

  case 1987: /* a_expr: a_expr SIMILAR TO a_expr  */
#line 14650 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 48137 "gram.c"
    break;

  case 1988: /* a_expr: a_expr SIMILAR TO a_expr ESCAPE a_expr  */
#line 14659 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 48150 "gram.c"
    break;

  case 1989: /* a_expr: a_expr NOT_LA SIMILAR TO a_expr  */
#line 14668 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 48163 "gram.c"
    break;

  case 1990: /* a_expr: a_expr NOT_LA SIMILAR TO a_expr ESCAPE a_expr  */
#line 14677 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 48176 "gram.c"
    break;

  case 1991: /* a_expr: a_expr IS NULL_P  */
#line 14696 "gram.y"
                                {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 48189 "gram.c"
    break;

  case 1992: /* a_expr: a_expr ISNULL  */
#line 14705 "gram.y"
                                {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 48202 "gram.c"
    break;

  case 1993: /* a_expr: a_expr IS NOT NULL_P  */
#line 14714 "gram.y"
                                {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 48215 "gram.c"
    break;

  case 1994: /* a_expr: a_expr NOTNULL  */
#line 14723 "gram.y"
                                {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 48228 "gram.c"
    break;

  case 1995: /* a_expr: row OVERLAPS row  */
#line 14732 "gram.y"
                                {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 48249 "gram.c"
    break;

  case 1996: /* a_expr: a_expr IS TRUE_P  */
#line 14749 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 48262 "gram.c"
    break;

  case 1997: /* a_expr: a_expr IS NOT TRUE_P  */
#line 14758 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 48275 "gram.c"
    break;

  case 1998: /* a_expr: a_expr IS FALSE_P  */
#line 14767 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 48288 "gram.c"
    break;

  case 1999: /* a_expr: a_expr IS NOT FALSE_P  */
#line 14776 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 48301 "gram.c"
    break;

  case 2000: /* a_expr: a_expr IS UNKNOWN  */
#line 14785 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 48314 "gram.c"
    break;

  case 2001: /* a_expr: a_expr IS NOT UNKNOWN  */
#line 14794 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 48327 "gram.c"
    break;

  case 2002: /* a_expr: a_expr IS DISTINCT FROM a_expr  */
#line 14803 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 48335 "gram.c"
    break;

  case 2003: /* a_expr: a_expr IS NOT DISTINCT FROM a_expr  */
#line 14807 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 48343 "gram.c"
    break;

  case 2004: /* a_expr: a_expr BETWEEN opt_asymmetric b_expr AND a_expr  */
#line 14811 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 48355 "gram.c"
    break;

  case 2005: /* a_expr: a_expr NOT_LA BETWEEN opt_asymmetric b_expr AND a_expr  */
#line 14819 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 48367 "gram.c"
    break;

  case 2006: /* a_expr: a_expr BETWEEN SYMMETRIC b_expr AND a_expr  */
#line 14827 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 48379 "gram.c"
    break;

  case 2007: /* a_expr: a_expr NOT_LA BETWEEN SYMMETRIC b_expr AND a_expr  */
#line 14835 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 48391 "gram.c"
    break;

  case 2008: /* a_expr: a_expr IN_P in_expr  */
#line 14843 "gram.y"
                                {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *) n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 48416 "gram.c"
    break;

  case 2009: /* a_expr: a_expr NOT_LA IN_P in_expr  */
#line 14864 "gram.y"
                                {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 48443 "gram.c"
    break;

  case 2010: /* a_expr: a_expr subquery_Op sub_type select_with_parens  */
#line 14887 "gram.y"
                                {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 48459 "gram.c"
    break;

  case 2011: /* a_expr: a_expr subquery_Op sub_type '(' a_expr ')'  */
#line 14899 "gram.y"
                                {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 48470 "gram.c"
    break;

  case 2012: /* a_expr: UNIQUE opt_unique_null_treatment select_with_parens  */
#line 14906 "gram.y"
                                {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-2]))));
				}
#line 48490 "gram.c"
    break;

  case 2013: /* a_expr: a_expr IS DOCUMENT_P  */
#line 14922 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 48499 "gram.c"
    break;

  case 2014: /* a_expr: a_expr IS NOT DOCUMENT_P  */
#line 14927 "gram.y"
                                {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 48509 "gram.c"
    break;

  case 2015: /* a_expr: a_expr IS NORMALIZED  */
#line 14933 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make1((yyvsp[-2].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 48520 "gram.c"
    break;

  case 2016: /* a_expr: a_expr IS unicode_normal_form NORMALIZED  */
#line 14940 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-2]));
				}
#line 48531 "gram.c"
    break;

  case 2017: /* a_expr: a_expr IS NOT NORMALIZED  */
#line 14947 "gram.y"
                                {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make1((yyvsp[-3].node)),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 48543 "gram.c"
    break;

  case 2018: /* a_expr: a_expr IS NOT unicode_normal_form NORMALIZED  */
#line 14955 "gram.y"
                                {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make2((yyvsp[-4].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-3])),
									 (yylsp[-3]));
				}
#line 48555 "gram.c"
    break;

  case 2019: /* a_expr: a_expr IS json_predicate_type_constraint_opt json_key_uniqueness_constraint_opt  */
#line 14965 "gram.y"
                                {
					JsonFormat *format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
					(yyval.node) = makeJsonIsPredicate((yyvsp[-3].node), format, (yyvsp[-1].ival), (yyvsp[0].boolean), (yylsp[-3]));
				}
#line 48564 "gram.c"
    break;

  case 2020: /* a_expr: a_expr IS NOT json_predicate_type_constraint_opt json_key_uniqueness_constraint_opt  */
#line 14985 "gram.y"
                                {
					JsonFormat *format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);

					(yyval.node) = makeNotExpr(makeJsonIsPredicate((yyvsp[-4].node), format, (yyvsp[-1].ival), (yyvsp[0].boolean), (yylsp[-4])), (yylsp[-4]));
				}
#line 48574 "gram.c"
    break;

  case 2021: /* a_expr: DEFAULT  */
#line 15004 "gram.y"
                                {
					/*
					 * The SQL spec only allows DEFAULT in "contextually typed
					 * expressions", but for us, it's easier to allow it in
					 * any a_expr and then throw error during parse analysis
					 * if it's in an inappropriate context.  This way also
					 * lets us say something smarter than "syntax error".
					 */
					SetToDefault *n = makeNode(SetToDefault);

					/* parse analysis will fill in the rest */
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 48593 "gram.c"
    break;

  case 2022: /* b_expr: c_expr  */
#line 15030 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 48599 "gram.c"
    break;

  case 2023: /* b_expr: b_expr TYPECAST Typename  */
#line 15032 "gram.y"
                                { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 48605 "gram.c"
    break;

  case 2024: /* b_expr: '+' b_expr  */
#line 15034 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 48611 "gram.c"
    break;

  case 2025: /* b_expr: '-' b_expr  */
#line 15036 "gram.y"
                                { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 48617 "gram.c"
    break;

  case 2026: /* b_expr: b_expr '+' b_expr  */
#line 15038 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48623 "gram.c"
    break;

  case 2027: /* b_expr: b_expr '-' b_expr  */
#line 15040 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48629 "gram.c"
    break;

  case 2028: /* b_expr: b_expr '*' b_expr  */
#line 15042 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48635 "gram.c"
    break;

  case 2029: /* b_expr: b_expr '/' b_expr  */
#line 15044 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48641 "gram.c"
    break;

  case 2030: /* b_expr: b_expr '%' b_expr  */
#line 15046 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48647 "gram.c"
    break;

  case 2031: /* b_expr: b_expr '^' b_expr  */
#line 15048 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48653 "gram.c"
    break;

  case 2032: /* b_expr: b_expr '<' b_expr  */
#line 15050 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48659 "gram.c"
    break;

  case 2033: /* b_expr: b_expr '>' b_expr  */
#line 15052 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48665 "gram.c"
    break;

  case 2034: /* b_expr: b_expr '=' b_expr  */
#line 15054 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48671 "gram.c"
    break;

  case 2035: /* b_expr: b_expr LESS_EQUALS b_expr  */
#line 15056 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48677 "gram.c"
    break;

  case 2036: /* b_expr: b_expr GREATER_EQUALS b_expr  */
#line 15058 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48683 "gram.c"
    break;

  case 2037: /* b_expr: b_expr NOT_EQUALS b_expr  */
#line 15060 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48689 "gram.c"
    break;

  case 2038: /* b_expr: b_expr qual_Op b_expr  */
#line 15062 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48695 "gram.c"
    break;

  case 2039: /* b_expr: qual_Op b_expr  */
#line 15064 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 48701 "gram.c"
    break;

  case 2040: /* b_expr: b_expr IS DISTINCT FROM b_expr  */
#line 15066 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 48709 "gram.c"
    break;

  case 2041: /* b_expr: b_expr IS NOT DISTINCT FROM b_expr  */
#line 15070 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 48717 "gram.c"
    break;

  case 2042: /* b_expr: b_expr IS DOCUMENT_P  */
#line 15074 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 48726 "gram.c"
    break;

  case 2043: /* b_expr: b_expr IS NOT DOCUMENT_P  */
#line 15079 "gram.y"
                                {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 48736 "gram.c"
    break;

  case 2044: /* json_predicate_type_constraint_opt: JSON  */
#line 15087 "gram.y"
                                                                                                { (yyval.ival) = JS_TYPE_ANY; }
#line 48742 "gram.c"
    break;

  case 2045: /* json_predicate_type_constraint_opt: JSON VALUE_P  */
#line 15088 "gram.y"
                                                                                        { (yyval.ival) = JS_TYPE_ANY; }
#line 48748 "gram.c"
    break;

  case 2046: /* json_predicate_type_constraint_opt: JSON ARRAY  */
#line 15089 "gram.y"
                                                                                        { (yyval.ival) = JS_TYPE_ARRAY; }
#line 48754 "gram.c"
    break;

  case 2047: /* json_predicate_type_constraint_opt: JSON OBJECT_P  */
#line 15090 "gram.y"
                                                                                        { (yyval.ival) = JS_TYPE_OBJECT; }
#line 48760 "gram.c"
    break;

  case 2048: /* json_predicate_type_constraint_opt: JSON SCALAR  */
#line 15091 "gram.y"
                                                                                        { (yyval.ival) = JS_TYPE_SCALAR; }
#line 48766 "gram.c"
    break;

  case 2049: /* json_key_uniqueness_constraint_opt: WITH_LA_UNIQUE unique_keys  */
#line 15095 "gram.y"
                                                                                { (yyval.boolean) = true; }
#line 48772 "gram.c"
    break;

  case 2050: /* json_key_uniqueness_constraint_opt: WITHOUT unique_keys  */
#line 15096 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 48778 "gram.c"
    break;

  case 2051: /* json_key_uniqueness_constraint_opt: %empty  */
#line 15097 "gram.y"
                                                                { (yyval.boolean) = false; }
#line 48784 "gram.c"
    break;

  case 2054: /* c_expr: columnref  */
#line 15113 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 48790 "gram.c"
    break;

  case 2055: /* c_expr: AexprConst  */
#line 15114 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 48796 "gram.c"
    break;

  case 2056: /* c_expr: PARAM opt_indirection  */
#line 15116 "gram.y"
                                {
					ParamRef   *p = makeNode(ParamRef);

					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 48817 "gram.c"
    break;

  case 2057: /* c_expr: '(' a_expr ')' opt_indirection  */
#line 15133 "gram.y"
                                {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 48834 "gram.c"
    break;

  case 2058: /* c_expr: case_expr  */
#line 15146 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 48840 "gram.c"
    break;

  case 2059: /* c_expr: func_expr  */
#line 15148 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 48846 "gram.c"
    break;

  case 2060: /* c_expr: select_with_parens  */
#line 15150 "gram.y"
                                {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 48862 "gram.c"
    break;

  case 2061: /* c_expr: select_with_parens indirection  */
#line 15162 "gram.y"
                                {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink	   *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *) n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *) a;
				}
#line 48891 "gram.c"
    break;

  case 2062: /* c_expr: EXISTS select_with_parens  */
#line 15187 "gram.y"
                                {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 48907 "gram.c"
    break;

  case 2063: /* c_expr: ARRAY select_with_parens  */
#line 15199 "gram.y"
                                {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 48923 "gram.c"
    break;

  case 2064: /* c_expr: ARRAY array_expr  */
#line 15211 "gram.y"
                                {
					A_ArrayExpr *n = castNode(A_ArrayExpr, (yyvsp[0].node));

					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 48935 "gram.c"
    break;

  case 2065: /* c_expr: explicit_row  */
#line 15219 "gram.y"
                                {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 48950 "gram.c"
    break;

  case 2066: /* c_expr: implicit_row  */
#line 15230 "gram.y"
                                {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 48965 "gram.c"
    break;

  case 2067: /* c_expr: GROUPING '(' expr_list ')'  */
#line 15241 "gram.y"
                          {
				  GroupingFunc *g = makeNode(GroupingFunc);

				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *) g;
			  }
#line 48977 "gram.c"
    break;

  case 2068: /* func_application: func_name '(' ')'  */
#line 15251 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL,
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-2]));
				}
#line 48987 "gram.c"
    break;

  case 2069: /* func_application: func_name '(' func_arg_list opt_sort_clause ')'  */
#line 15257 "gram.y"
                                {
					FuncCall   *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));

					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 49000 "gram.c"
    break;

  case 2070: /* func_application: func_name '(' VARIADIC func_arg_expr opt_sort_clause ')'  */
#line 15266 "gram.y"
                                {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 49014 "gram.c"
    break;

  case 2071: /* func_application: func_name '(' func_arg_list ',' VARIADIC func_arg_expr opt_sort_clause ')'  */
#line 15276 "gram.y"
                                {
					FuncCall   *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-7]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 49028 "gram.c"
    break;

  case 2072: /* func_application: func_name '(' ALL func_arg_list opt_sort_clause ')'  */
#line 15286 "gram.y"
                                {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *) n;
				}
#line 49045 "gram.c"
    break;

  case 2073: /* func_application: func_name '(' DISTINCT func_arg_list opt_sort_clause ')'  */
#line 15299 "gram.y"
                                {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = true;
					(yyval.node) = (Node *) n;
				}
#line 49059 "gram.c"
    break;

  case 2074: /* func_application: func_name '(' '*' ')'  */
#line 15309 "gram.y"
                                {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall   *n = makeFuncCall((yyvsp[-3].list), NIL,
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));

					n->agg_star = true;
					(yyval.node) = (Node *) n;
				}
#line 49082 "gram.c"
    break;

  case 2075: /* func_expr: func_application within_group_clause filter_clause over_clause  */
#line 15340 "gram.y"
                                {
					FuncCall   *n = (FuncCall *) (yyvsp[-3].node);

					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = true;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 49122 "gram.c"
    break;

  case 2076: /* func_expr: json_aggregate_func filter_clause over_clause  */
#line 15376 "gram.y"
                                {
					JsonAggConstructor *n = IsA((yyvsp[-2].node), JsonObjectAgg) ?
						((JsonObjectAgg *) (yyvsp[-2].node))->constructor :
						((JsonArrayAgg *) (yyvsp[-2].node))->constructor;

					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) (yyvsp[-2].node);
				}
#line 49136 "gram.c"
    break;

  case 2077: /* func_expr: func_expr_common_subexpr  */
#line 15386 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 49142 "gram.c"
    break;

  case 2078: /* func_expr_windowless: func_application  */
#line 15396 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 49148 "gram.c"
    break;

  case 2079: /* func_expr_windowless: func_expr_common_subexpr  */
#line 15397 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 49154 "gram.c"
    break;

  case 2080: /* func_expr_windowless: json_aggregate_func  */
#line 15398 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 49160 "gram.c"
    break;

  case 2081: /* func_expr_common_subexpr: COLLATION FOR '(' a_expr ')'  */
#line 15406 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 49171 "gram.c"
    break;

  case 2082: /* func_expr_common_subexpr: CURRENT_DATE  */
#line 15413 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_DATE, -1, (yylsp[0]));
				}
#line 49179 "gram.c"
    break;

  case 2083: /* func_expr_common_subexpr: CURRENT_TIME  */
#line 15417 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME, -1, (yylsp[0]));
				}
#line 49187 "gram.c"
    break;

  case 2084: /* func_expr_common_subexpr: CURRENT_TIME '(' Iconst ')'  */
#line 15421 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 49195 "gram.c"
    break;

  case 2085: /* func_expr_common_subexpr: CURRENT_TIMESTAMP  */
#line 15425 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP, -1, (yylsp[0]));
				}
#line 49203 "gram.c"
    break;

  case 2086: /* func_expr_common_subexpr: CURRENT_TIMESTAMP '(' Iconst ')'  */
#line 15429 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 49211 "gram.c"
    break;

  case 2087: /* func_expr_common_subexpr: LOCALTIME  */
#line 15433 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME, -1, (yylsp[0]));
				}
#line 49219 "gram.c"
    break;

  case 2088: /* func_expr_common_subexpr: LOCALTIME '(' Iconst ')'  */
#line 15437 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 49227 "gram.c"
    break;

  case 2089: /* func_expr_common_subexpr: LOCALTIMESTAMP  */
#line 15441 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP, -1, (yylsp[0]));
				}
#line 49235 "gram.c"
    break;

  case 2090: /* func_expr_common_subexpr: LOCALTIMESTAMP '(' Iconst ')'  */
#line 15445 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 49243 "gram.c"
    break;

  case 2091: /* func_expr_common_subexpr: CURRENT_ROLE  */
#line 15449 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_ROLE, -1, (yylsp[0]));
				}
#line 49251 "gram.c"
    break;

  case 2092: /* func_expr_common_subexpr: CURRENT_USER  */
#line 15453 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_USER, -1, (yylsp[0]));
				}
#line 49259 "gram.c"
    break;

  case 2093: /* func_expr_common_subexpr: SESSION_USER  */
#line 15457 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_SESSION_USER, -1, (yylsp[0]));
				}
#line 49267 "gram.c"
    break;

  case 2094: /* func_expr_common_subexpr: USER  */
#line 15461 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_USER, -1, (yylsp[0]));
				}
#line 49275 "gram.c"
    break;

  case 2095: /* func_expr_common_subexpr: CURRENT_CATALOG  */
#line 15465 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_CATALOG, -1, (yylsp[0]));
				}
#line 49283 "gram.c"
    break;

  case 2096: /* func_expr_common_subexpr: CURRENT_SCHEMA  */
#line 15469 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_SCHEMA, -1, (yylsp[0]));
				}
#line 49291 "gram.c"
    break;

  case 2097: /* func_expr_common_subexpr: CAST '(' a_expr AS Typename ')'  */
#line 15473 "gram.y"
                                { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 49297 "gram.c"
    break;

  case 2098: /* func_expr_common_subexpr: EXTRACT '(' extract_list ')'  */
#line 15475 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("extract"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 49308 "gram.c"
    break;

  case 2099: /* func_expr_common_subexpr: NORMALIZE '(' a_expr ')'  */
#line 15482 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 49319 "gram.c"
    break;

  case 2100: /* func_expr_common_subexpr: NORMALIZE '(' a_expr ',' unicode_normal_form ')'  */
#line 15489 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-5]));
				}
#line 49330 "gram.c"
    break;

  case 2101: /* func_expr_common_subexpr: OVERLAY '(' overlay_list ')'  */
#line 15496 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 49341 "gram.c"
    break;

  case 2102: /* func_expr_common_subexpr: OVERLAY '(' func_arg_list_opt ')'  */
#line 15503 "gram.y"
                                {
					/*
					 * allow functions named overlay() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("overlay")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 49356 "gram.c"
    break;

  case 2103: /* func_expr_common_subexpr: POSITION '(' position_list ')'  */
#line 15514 "gram.y"
                                {
					/*
					 * position(A in B) is converted to position(B, A)
					 *
					 * We deliberately don't offer a "plain syntax" option
					 * for position(), because the reversal of the arguments
					 * creates too much risk of confusion.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 49374 "gram.c"
    break;

  case 2104: /* func_expr_common_subexpr: SUBSTRING '(' substr_list ')'  */
#line 15528 "gram.y"
                                {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 49388 "gram.c"
    break;

  case 2105: /* func_expr_common_subexpr: SUBSTRING '(' func_arg_list_opt ')'  */
#line 15538 "gram.y"
                                {
					/*
					 * allow functions named substring() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("substring")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 49403 "gram.c"
    break;

  case 2106: /* func_expr_common_subexpr: TREAT '(' a_expr AS Typename ')'  */
#line 15549 "gram.y"
                                {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(strVal(llast((yyvsp[-1].typnam)->names))),
											   list_make1((yyvsp[-3].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
				}
#line 49423 "gram.c"
    break;

  case 2107: /* func_expr_common_subexpr: TRIM '(' BOTH trim_list ')'  */
#line 15565 "gram.y"
                                {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 49437 "gram.c"
    break;

  case 2108: /* func_expr_common_subexpr: TRIM '(' LEADING trim_list ')'  */
#line 15575 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 49448 "gram.c"
    break;

  case 2109: /* func_expr_common_subexpr: TRIM '(' TRAILING trim_list ')'  */
#line 15582 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 49459 "gram.c"
    break;

  case 2110: /* func_expr_common_subexpr: TRIM '(' trim_list ')'  */
#line 15589 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 49470 "gram.c"
    break;

  case 2111: /* func_expr_common_subexpr: NULLIF '(' a_expr ',' a_expr ')'  */
#line 15596 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 49478 "gram.c"
    break;

  case 2112: /* func_expr_common_subexpr: COALESCE '(' expr_list ')'  */
#line 15600 "gram.y"
                                {
					CoalesceExpr *c = makeNode(CoalesceExpr);

					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *) c;
				}
#line 49490 "gram.c"
    break;

  case 2113: /* func_expr_common_subexpr: GREATEST '(' expr_list ')'  */
#line 15608 "gram.y"
                                {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 49503 "gram.c"
    break;

  case 2114: /* func_expr_common_subexpr: LEAST '(' expr_list ')'  */
#line 15617 "gram.y"
                                {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 49516 "gram.c"
    break;

  case 2115: /* func_expr_common_subexpr: XMLCONCAT '(' expr_list ')'  */
#line 15626 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 49524 "gram.c"
    break;

  case 2116: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ')'  */
#line 15630 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 49532 "gram.c"
    break;

  case 2117: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ',' xml_attributes ')'  */
#line 15634 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 49540 "gram.c"
    break;

  case 2118: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ',' expr_list ')'  */
#line 15638 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 49548 "gram.c"
    break;

  case 2119: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ',' xml_attributes ',' expr_list ')'  */
#line 15642 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 49556 "gram.c"
    break;

  case 2120: /* func_expr_common_subexpr: XMLEXISTS '(' c_expr xmlexists_argument ')'  */
#line 15646 "gram.y"
                                {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"),
											   list_make2((yyvsp[-2].node), (yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 49569 "gram.c"
    break;

  case 2121: /* func_expr_common_subexpr: XMLFOREST '(' xml_attribute_list ')'  */
#line 15655 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 49577 "gram.c"
    break;

  case 2122: /* func_expr_common_subexpr: XMLPARSE '(' document_or_content a_expr xml_whitespace_option ')'  */
#line 15659 "gram.y"
                                {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));

					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *) x;
				}
#line 49591 "gram.c"
    break;

  case 2123: /* func_expr_common_subexpr: XMLPI '(' NAME_P ColLabel ')'  */
#line 15669 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 49599 "gram.c"
    break;

  case 2124: /* func_expr_common_subexpr: XMLPI '(' NAME_P ColLabel ',' a_expr ')'  */
#line 15673 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 49607 "gram.c"
    break;

  case 2125: /* func_expr_common_subexpr: XMLROOT '(' a_expr ',' xml_root_version opt_xml_root_standalone ')'  */
#line 15677 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 49616 "gram.c"
    break;

  case 2126: /* func_expr_common_subexpr: XMLSERIALIZE '(' document_or_content a_expr AS SimpleTypename ')'  */
#line 15682 "gram.y"
                                {
					XmlSerialize *n = makeNode(XmlSerialize);

					n->xmloption = (yyvsp[-4].ival);
					n->expr = (yyvsp[-3].node);
					n->typeName = (yyvsp[-1].typnam);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 49630 "gram.c"
    break;

  case 2127: /* func_expr_common_subexpr: json_func_expr  */
#line 15692 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 49636 "gram.c"
    break;

  case 2128: /* xml_root_version: VERSION_P a_expr  */
#line 15699 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 49642 "gram.c"
    break;

  case 2129: /* xml_root_version: VERSION_P NO VALUE_P  */
#line 15701 "gram.y"
                                { (yyval.node) = makeNullAConst(-1); }
#line 49648 "gram.c"
    break;

  case 2130: /* opt_xml_root_standalone: ',' STANDALONE_P YES_P  */
#line 15705 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 49654 "gram.c"
    break;

  case 2131: /* opt_xml_root_standalone: ',' STANDALONE_P NO  */
#line 15707 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 49660 "gram.c"
    break;

  case 2132: /* opt_xml_root_standalone: ',' STANDALONE_P NO VALUE_P  */
#line 15709 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 49666 "gram.c"
    break;

  case 2133: /* opt_xml_root_standalone: %empty  */
#line 15711 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 49672 "gram.c"
    break;

  case 2134: /* xml_attributes: XMLATTRIBUTES '(' xml_attribute_list ')'  */
#line 15714 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 49678 "gram.c"
    break;

  case 2135: /* xml_attribute_list: xml_attribute_el  */
#line 15717 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 49684 "gram.c"
    break;

  case 2136: /* xml_attribute_list: xml_attribute_list ',' xml_attribute_el  */
#line 15718 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 49690 "gram.c"
    break;

  case 2137: /* xml_attribute_el: a_expr AS ColLabel  */
#line 15722 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 49702 "gram.c"
    break;

  case 2138: /* xml_attribute_el: a_expr  */
#line 15730 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 49714 "gram.c"
    break;

  case 2139: /* document_or_content: DOCUMENT_P  */
#line 15739 "gram.y"
                                                                        { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 49720 "gram.c"
    break;

  case 2140: /* document_or_content: CONTENT_P  */
#line 15740 "gram.y"
                                                                                                { (yyval.ival) = XMLOPTION_CONTENT; }
#line 49726 "gram.c"
    break;

  case 2141: /* xml_whitespace_option: PRESERVE WHITESPACE_P  */
#line 15743 "gram.y"
                                                        { (yyval.boolean) = true; }
#line 49732 "gram.c"
    break;

  case 2142: /* xml_whitespace_option: STRIP_P WHITESPACE_P  */
#line 15744 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 49738 "gram.c"
    break;

  case 2143: /* xml_whitespace_option: %empty  */
#line 15745 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 49744 "gram.c"
    break;

  case 2144: /* xmlexists_argument: PASSING c_expr  */
#line 15751 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 49752 "gram.c"
    break;

  case 2145: /* xmlexists_argument: PASSING c_expr xml_passing_mech  */
#line 15755 "gram.y"
                                {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 49760 "gram.c"
    break;

  case 2146: /* xmlexists_argument: PASSING xml_passing_mech c_expr  */
#line 15759 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 49768 "gram.c"
    break;

  case 2147: /* xmlexists_argument: PASSING xml_passing_mech c_expr xml_passing_mech  */
#line 15763 "gram.y"
                                {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 49776 "gram.c"
    break;

  case 2150: /* within_group_clause: WITHIN GROUP_P '(' sort_clause ')'  */
#line 15778 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 49782 "gram.c"
    break;

  case 2151: /* within_group_clause: %empty  */
#line 15779 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 49788 "gram.c"
    break;

  case 2152: /* filter_clause: FILTER '(' WHERE a_expr ')'  */
#line 15783 "gram.y"
                                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 49794 "gram.c"
    break;

  case 2153: /* filter_clause: %empty  */
#line 15784 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 49800 "gram.c"
    break;

  case 2154: /* window_clause: WINDOW window_definition_list  */
#line 15792 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 49806 "gram.c"
    break;

  case 2155: /* window_clause: %empty  */
#line 15793 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 49812 "gram.c"
    break;

  case 2156: /* window_definition_list: window_definition  */
#line 15797 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 49818 "gram.c"
    break;

  case 2157: /* window_definition_list: window_definition_list ',' window_definition  */
#line 15799 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 49824 "gram.c"
    break;

  case 2158: /* window_definition: ColId AS window_specification  */
#line 15804 "gram.y"
                                {
					WindowDef  *n = (yyvsp[0].windef);

					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 49835 "gram.c"
    break;

  case 2159: /* over_clause: OVER window_specification  */
#line 15813 "gram.y"
                                { (yyval.windef) = (yyvsp[0].windef); }
#line 49841 "gram.c"
    break;

  case 2160: /* over_clause: OVER ColId  */
#line 15815 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 49859 "gram.c"
    break;

  case 2161: /* over_clause: %empty  */
#line 15829 "gram.y"
                                { (yyval.windef) = NULL; }
#line 49865 "gram.c"
    break;

  case 2162: /* window_specification: '(' opt_existing_window_name opt_partition_clause opt_sort_clause opt_frame_clause ')'  */
#line 15834 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 49884 "gram.c"
    break;

  case 2163: /* opt_existing_window_name: ColId  */
#line 15860 "gram.y"
                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 49890 "gram.c"
    break;

  case 2164: /* opt_existing_window_name: %empty  */
#line 15861 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 49896 "gram.c"
    break;

  case 2165: /* opt_partition_clause: PARTITION BY expr_list  */
#line 15864 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 49902 "gram.c"
    break;

  case 2166: /* opt_partition_clause: %empty  */
#line 15865 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 49908 "gram.c"
    break;

  case 2167: /* opt_frame_clause: RANGE frame_extent opt_window_exclusion_clause  */
#line 15874 "gram.y"
                                {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 49920 "gram.c"
    break;

  case 2168: /* opt_frame_clause: ROWS frame_extent opt_window_exclusion_clause  */
#line 15882 "gram.y"
                                {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 49932 "gram.c"
    break;

  case 2169: /* opt_frame_clause: GROUPS frame_extent opt_window_exclusion_clause  */
#line 15890 "gram.y"
                                {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_GROUPS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 49944 "gram.c"
    break;

  case 2170: /* opt_frame_clause: %empty  */
#line 15898 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49957 "gram.c"
    break;

  case 2171: /* frame_extent: frame_bound  */
#line 15909 "gram.y"
                                {
					WindowDef  *n = (yyvsp[0].windef);

					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 49979 "gram.c"
    break;

  case 2172: /* frame_extent: BETWEEN frame_bound AND frame_bound  */
#line 15927 "gram.y"
                                {
					WindowDef  *n1 = (yyvsp[-2].windef);
					WindowDef  *n2 = (yyvsp[0].windef);

					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_OFFSET_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_OFFSET_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 50021 "gram.c"
    break;

  case 2173: /* frame_bound: UNBOUNDED PRECEDING  */
#line 15973 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 50034 "gram.c"
    break;

  case 2174: /* frame_bound: UNBOUNDED FOLLOWING  */
#line 15982 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 50047 "gram.c"
    break;

  case 2175: /* frame_bound: CURRENT_P ROW  */
#line 15991 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 50060 "gram.c"
    break;

  case 2176: /* frame_bound: a_expr PRECEDING  */
#line 16000 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 50073 "gram.c"
    break;

  case 2177: /* frame_bound: a_expr FOLLOWING  */
#line 16009 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 50086 "gram.c"
    break;

  case 2178: /* opt_window_exclusion_clause: EXCLUDE CURRENT_P ROW  */
#line 16020 "gram.y"
                                                { (yyval.ival) = FRAMEOPTION_EXCLUDE_CURRENT_ROW; }
#line 50092 "gram.c"
    break;

  case 2179: /* opt_window_exclusion_clause: EXCLUDE GROUP_P  */
#line 16021 "gram.y"
                                                        { (yyval.ival) = FRAMEOPTION_EXCLUDE_GROUP; }
#line 50098 "gram.c"
    break;

  case 2180: /* opt_window_exclusion_clause: EXCLUDE TIES  */
#line 16022 "gram.y"
                                                        { (yyval.ival) = FRAMEOPTION_EXCLUDE_TIES; }
#line 50104 "gram.c"
    break;

  case 2181: /* opt_window_exclusion_clause: EXCLUDE NO OTHERS  */
#line 16023 "gram.y"
                                                        { (yyval.ival) = 0; }
#line 50110 "gram.c"
    break;

  case 2182: /* opt_window_exclusion_clause: %empty  */
#line 16024 "gram.y"
                                                                { (yyval.ival) = 0; }
#line 50116 "gram.c"
    break;

  case 2183: /* row: ROW '(' expr_list ')'  */
#line 16038 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 50122 "gram.c"
    break;

  case 2184: /* row: ROW '(' ')'  */
#line 16039 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 50128 "gram.c"
    break;

  case 2185: /* row: '(' expr_list ',' a_expr ')'  */
#line 16040 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 50134 "gram.c"
    break;

  case 2186: /* explicit_row: ROW '(' expr_list ')'  */
#line 16043 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 50140 "gram.c"
    break;

  case 2187: /* explicit_row: ROW '(' ')'  */
#line 16044 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 50146 "gram.c"
    break;

  case 2188: /* implicit_row: '(' expr_list ',' a_expr ')'  */
#line 16047 "gram.y"
                                                        { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 50152 "gram.c"
    break;

  case 2189: /* sub_type: ANY  */
#line 16050 "gram.y"
                                                                                                { (yyval.ival) = ANY_SUBLINK; }
#line 50158 "gram.c"
    break;

  case 2190: /* sub_type: SOME  */
#line 16051 "gram.y"
                                                                                                { (yyval.ival) = ANY_SUBLINK; }
#line 50164 "gram.c"
    break;

  case 2191: /* sub_type: ALL  */
#line 16052 "gram.y"
                                                                                                { (yyval.ival) = ALL_SUBLINK; }
#line 50170 "gram.c"
    break;

  case 2192: /* all_Op: Op  */
#line 16055 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 50176 "gram.c"
    break;

  case 2193: /* all_Op: MathOp  */
#line 16056 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 50182 "gram.c"
    break;

  case 2194: /* MathOp: '+'  */
#line 16059 "gram.y"
                                                                                        { (yyval.str) = "+"; }
#line 50188 "gram.c"
    break;

  case 2195: /* MathOp: '-'  */
#line 16060 "gram.y"
                                                                                                { (yyval.str) = "-"; }
#line 50194 "gram.c"
    break;

  case 2196: /* MathOp: '*'  */
#line 16061 "gram.y"
                                                                                                { (yyval.str) = "*"; }
#line 50200 "gram.c"
    break;

  case 2197: /* MathOp: '/'  */
#line 16062 "gram.y"
                                                                                                { (yyval.str) = "/"; }
#line 50206 "gram.c"
    break;

  case 2198: /* MathOp: '%'  */
#line 16063 "gram.y"
                                                                                                { (yyval.str) = "%"; }
#line 50212 "gram.c"
    break;

  case 2199: /* MathOp: '^'  */
#line 16064 "gram.y"
                                                                                                { (yyval.str) = "^"; }
#line 50218 "gram.c"
    break;

  case 2200: /* MathOp: '<'  */
#line 16065 "gram.y"
                                                                                                { (yyval.str) = "<"; }
#line 50224 "gram.c"
    break;

  case 2201: /* MathOp: '>'  */
#line 16066 "gram.y"
                                                                                                { (yyval.str) = ">"; }
#line 50230 "gram.c"
    break;

  case 2202: /* MathOp: '='  */
#line 16067 "gram.y"
                                                                                                { (yyval.str) = "="; }
#line 50236 "gram.c"
    break;

  case 2203: /* MathOp: LESS_EQUALS  */
#line 16068 "gram.y"
                                                                                        { (yyval.str) = "<="; }
#line 50242 "gram.c"
    break;

  case 2204: /* MathOp: GREATER_EQUALS  */
#line 16069 "gram.y"
                                                                                        { (yyval.str) = ">="; }
#line 50248 "gram.c"
    break;

  case 2205: /* MathOp: NOT_EQUALS  */
#line 16070 "gram.y"
                                                                                        { (yyval.str) = "<>"; }
#line 50254 "gram.c"
    break;

  case 2206: /* qual_Op: Op  */
#line 16074 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 50260 "gram.c"
    break;

  case 2207: /* qual_Op: OPERATOR '(' any_operator ')'  */
#line 16076 "gram.y"
                                        { (yyval.list) = (yyvsp[-1].list); }
#line 50266 "gram.c"
    break;

  case 2208: /* qual_all_Op: all_Op  */
#line 16081 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 50272 "gram.c"
    break;

  case 2209: /* qual_all_Op: OPERATOR '(' any_operator ')'  */
#line 16083 "gram.y"
                                        { (yyval.list) = (yyvsp[-1].list); }
#line 50278 "gram.c"
    break;

  case 2210: /* subquery_Op: all_Op  */
#line 16088 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 50284 "gram.c"
    break;

  case 2211: /* subquery_Op: OPERATOR '(' any_operator ')'  */
#line 16090 "gram.y"
                                        { (yyval.list) = (yyvsp[-1].list); }
#line 50290 "gram.c"
    break;

  case 2212: /* subquery_Op: LIKE  */
#line 16092 "gram.y"
                                        { (yyval.list) = list_make1(makeString("~~")); }
#line 50296 "gram.c"
    break;

  case 2213: /* subquery_Op: NOT_LA LIKE  */
#line 16094 "gram.y"
                                        { (yyval.list) = list_make1(makeString("!~~")); }
#line 50302 "gram.c"
    break;

  case 2214: /* subquery_Op: ILIKE  */
#line 16096 "gram.y"
                                        { (yyval.list) = list_make1(makeString("~~*")); }
#line 50308 "gram.c"
    break;

  case 2215: /* subquery_Op: NOT_LA ILIKE  */
#line 16098 "gram.y"
                                        { (yyval.list) = list_make1(makeString("!~~*")); }
#line 50314 "gram.c"
    break;

  case 2216: /* expr_list: a_expr  */
#line 16110 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 50322 "gram.c"
    break;

  case 2217: /* expr_list: expr_list ',' a_expr  */
#line 16114 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 50330 "gram.c"
    break;

  case 2218: /* func_arg_list: func_arg_expr  */
#line 16121 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 50338 "gram.c"
    break;

  case 2219: /* func_arg_list: func_arg_list ',' func_arg_expr  */
#line 16125 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 50346 "gram.c"
    break;

  case 2220: /* func_arg_expr: a_expr  */
#line 16131 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 50354 "gram.c"
    break;

  case 2221: /* func_arg_expr: param_name COLON_EQUALS a_expr  */
#line 16135 "gram.y"
                                {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 50368 "gram.c"
    break;

  case 2222: /* func_arg_expr: param_name EQUALS_GREATER a_expr  */
#line 16145 "gram.y"
                                {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 50382 "gram.c"
    break;

  case 2223: /* func_arg_list_opt: func_arg_list  */
#line 16156 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 50388 "gram.c"
    break;

  case 2224: /* func_arg_list_opt: %empty  */
#line 16157 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 50394 "gram.c"
    break;

  case 2225: /* type_list: Typename  */
#line 16160 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 50400 "gram.c"
    break;

  case 2226: /* type_list: type_list ',' Typename  */
#line 16161 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 50406 "gram.c"
    break;

  case 2227: /* array_expr: '[' expr_list ']'  */
#line 16165 "gram.y"
                                {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 50414 "gram.c"
    break;

  case 2228: /* array_expr: '[' array_expr_list ']'  */
#line 16169 "gram.y"
                                {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 50422 "gram.c"
    break;

  case 2229: /* array_expr: '[' ']'  */
#line 16173 "gram.y"
                                {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 50430 "gram.c"
    break;

  case 2230: /* array_expr_list: array_expr  */
#line 16178 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 50436 "gram.c"
    break;

  case 2231: /* array_expr_list: array_expr_list ',' array_expr  */
#line 16179 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 50442 "gram.c"
    break;

  case 2232: /* extract_list: extract_arg FROM a_expr  */
#line 16185 "gram.y"
                                {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 50450 "gram.c"
    break;

  case 2233: /* extract_arg: IDENT  */
#line 16194 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 50456 "gram.c"
    break;

  case 2234: /* extract_arg: YEAR_P  */
#line 16195 "gram.y"
                                                                                                { (yyval.str) = "year"; }
#line 50462 "gram.c"
    break;

  case 2235: /* extract_arg: MONTH_P  */
#line 16196 "gram.y"
                                                                                                { (yyval.str) = "month"; }
#line 50468 "gram.c"
    break;

  case 2236: /* extract_arg: DAY_P  */
#line 16197 "gram.y"
                                                                                                { (yyval.str) = "day"; }
#line 50474 "gram.c"
    break;

  case 2237: /* extract_arg: HOUR_P  */
#line 16198 "gram.y"
                                                                                                { (yyval.str) = "hour"; }
#line 50480 "gram.c"
    break;

  case 2238: /* extract_arg: MINUTE_P  */
#line 16199 "gram.y"
                                                                                                { (yyval.str) = "minute"; }
#line 50486 "gram.c"
    break;

  case 2239: /* extract_arg: SECOND_P  */
#line 16200 "gram.y"
                                                                                                { (yyval.str) = "second"; }
#line 50492 "gram.c"
    break;

  case 2240: /* extract_arg: Sconst  */
#line 16201 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 50498 "gram.c"
    break;

  case 2241: /* unicode_normal_form: NFC  */
#line 16205 "gram.y"
                                                                                                        { (yyval.str) = "NFC"; }
#line 50504 "gram.c"
    break;

  case 2242: /* unicode_normal_form: NFD  */
#line 16206 "gram.y"
                                                                                                { (yyval.str) = "NFD"; }
#line 50510 "gram.c"
    break;

  case 2243: /* unicode_normal_form: NFKC  */
#line 16207 "gram.y"
                                                                                                { (yyval.str) = "NFKC"; }
#line 50516 "gram.c"
    break;

  case 2244: /* unicode_normal_form: NFKD  */
#line 16208 "gram.y"
                                                                                                { (yyval.str) = "NFKD"; }
#line 50522 "gram.c"
    break;

  case 2245: /* overlay_list: a_expr PLACING a_expr FROM a_expr FOR a_expr  */
#line 16214 "gram.y"
                                {
					/* overlay(A PLACING B FROM C FOR D) is converted to overlay(A, B, C, D) */
					(yyval.list) = list_make4((yyvsp[-6].node), (yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 50531 "gram.c"
    break;

  case 2246: /* overlay_list: a_expr PLACING a_expr FROM a_expr  */
#line 16219 "gram.y"
                                {
					/* overlay(A PLACING B FROM C) is converted to overlay(A, B, C) */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 50540 "gram.c"
    break;

  case 2247: /* position_list: b_expr IN_P b_expr  */
#line 16227 "gram.y"
                                                                                        { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 50546 "gram.c"
    break;

  case 2248: /* substr_list: a_expr FROM a_expr FOR a_expr  */
#line 16249 "gram.y"
                                {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 50554 "gram.c"
    break;

  case 2249: /* substr_list: a_expr FOR a_expr FROM a_expr  */
#line 16253 "gram.y"
                                {
					/* not legal per SQL, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[0].node), (yyvsp[-2].node));
				}
#line 50563 "gram.c"
    break;

  case 2250: /* substr_list: a_expr FROM a_expr  */
#line 16258 "gram.y"
                                {
					/*
					 * Because we aren't restricting data types here, this
					 * syntax can end up resolving to textregexsubstr().
					 * We've historically allowed that to happen, so continue
					 * to accept it.  However, ruleutils.c will reverse-list
					 * such a call in regular function call syntax.
					 */
					(yyval.list) = list_make2((yyvsp[-2].node), (yyvsp[0].node));
				}
#line 50578 "gram.c"
    break;

  case 2251: /* substr_list: a_expr FOR a_expr  */
#line 16269 "gram.y"
                                {
					/* not legal per SQL */

					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-2].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 50599 "gram.c"
    break;

  case 2252: /* substr_list: a_expr SIMILAR a_expr ESCAPE a_expr  */
#line 16286 "gram.y"
                                {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 50607 "gram.c"
    break;

  case 2253: /* trim_list: a_expr FROM expr_list  */
#line 16291 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 50613 "gram.c"
    break;

  case 2254: /* trim_list: FROM expr_list  */
#line 16292 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 50619 "gram.c"
    break;

  case 2255: /* trim_list: expr_list  */
#line 16293 "gram.y"
                                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 50625 "gram.c"
    break;

  case 2256: /* in_expr: select_with_parens  */
#line 16297 "gram.y"
                                {
					SubLink	   *n = makeNode(SubLink);

					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *) n;
				}
#line 50637 "gram.c"
    break;

  case 2257: /* in_expr: '(' expr_list ')'  */
#line 16304 "gram.y"
                                                                                        { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 50643 "gram.c"
    break;

  case 2258: /* case_expr: CASE case_arg when_clause_list case_default END_P  */
#line 16315 "gram.y"
                                {
					CaseExpr   *c = makeNode(CaseExpr);

					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *) c;
				}
#line 50658 "gram.c"
    break;

  case 2259: /* when_clause_list: when_clause  */
#line 16329 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 50664 "gram.c"
    break;

  case 2260: /* when_clause_list: when_clause_list when_clause  */
#line 16330 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 50670 "gram.c"
    break;

  case 2261: /* when_clause: WHEN a_expr THEN a_expr  */
#line 16335 "gram.y"
                                {
					CaseWhen   *w = makeNode(CaseWhen);

					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *) w;
				}
#line 50683 "gram.c"
    break;

  case 2262: /* case_default: ELSE a_expr  */
#line 16346 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 50689 "gram.c"
    break;

  case 2263: /* case_default: %empty  */
#line 16347 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 50695 "gram.c"
    break;

  case 2264: /* case_arg: a_expr  */
#line 16350 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 50701 "gram.c"
    break;

  case 2265: /* case_arg: %empty  */
#line 16351 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 50707 "gram.c"
    break;

  case 2266: /* columnref: ColId  */
#line 16355 "gram.y"
                                {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 50715 "gram.c"
    break;

  case 2267: /* columnref: ColId indirection  */
#line 16359 "gram.y"
                                {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 50723 "gram.c"
    break;

  case 2268: /* indirection_el: '.' attr_name  */
#line 16366 "gram.y"
                                {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 50731 "gram.c"
    break;

  case 2269: /* indirection_el: '.' '*'  */
#line 16370 "gram.y"
                                {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 50739 "gram.c"
    break;

  case 2270: /* indirection_el: '[' a_expr ']'  */
#line 16374 "gram.y"
                                {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 50752 "gram.c"
    break;

  case 2271: /* indirection_el: '[' opt_slice_bound ':' opt_slice_bound ']'  */
#line 16383 "gram.y"
                                {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 50765 "gram.c"
    break;

  case 2272: /* opt_slice_bound: a_expr  */
#line 16394 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 50771 "gram.c"
    break;

  case 2273: /* opt_slice_bound: %empty  */
#line 16395 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 50777 "gram.c"
    break;

  case 2274: /* indirection: indirection_el  */
#line 16399 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 50783 "gram.c"
    break;

  case 2275: /* indirection: indirection indirection_el  */
#line 16400 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 50789 "gram.c"
    break;

  case 2276: /* opt_indirection: %empty  */
#line 16404 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 50795 "gram.c"
    break;

  case 2277: /* opt_indirection: opt_indirection indirection_el  */
#line 16405 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 50801 "gram.c"
    break;

  case 2287: /* json_parse_expr: JSON '(' json_value_expr json_key_uniqueness_constraint_opt json_returning_clause_opt ')'  */
#line 16426 "gram.y"
                                {
					JsonParseExpr *n = makeNode(JsonParseExpr);

					n->expr = (JsonValueExpr *) (yyvsp[-3].node);
					n->unique_keys = (yyvsp[-2].boolean);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 50815 "gram.c"
    break;

  case 2288: /* json_scalar_expr: JSON_SCALAR '(' a_expr json_returning_clause_opt ')'  */
#line 16439 "gram.y"
                                {
					JsonScalarExpr *n = makeNode(JsonScalarExpr);

					n->expr = (Expr *) (yyvsp[-2].node);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 50828 "gram.c"
    break;

  case 2289: /* json_serialize_expr: JSON_SERIALIZE '(' json_value_expr json_output_clause_opt ')'  */
#line 16451 "gram.y"
                                {
					JsonSerializeExpr *n = makeNode(JsonSerializeExpr);

					n->expr = (JsonValueExpr *) (yyvsp[-2].node);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 50841 "gram.c"
    break;

  case 2290: /* json_value_func_expr: JSON_VALUE '(' json_api_common_syntax json_returning_clause_opt json_value_on_behavior_clause_opt ')'  */
#line 16467 "gram.y"
                                {
					JsonFuncExpr *n = makeNode(JsonFuncExpr);

					n->op = JSON_VALUE_OP;
					n->common = (JsonCommon *) (yyvsp[-3].node);
					n->output = (JsonOutput *) (yyvsp[-2].node);
					n->on_empty = (yyvsp[-1].on_behavior).on_empty;
					n->on_error = (yyvsp[-1].on_behavior).on_error;
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 50857 "gram.c"
    break;

  case 2291: /* json_api_common_syntax: json_context_item ',' json_path_specification json_as_path_name_clause_opt json_passing_clause_opt  */
#line 16484 "gram.y"
                                {
					JsonCommon *n = makeNode(JsonCommon);

					n->expr = (JsonValueExpr *) (yyvsp[-4].node);
					n->pathspec = (yyvsp[-2].node);
					n->pathname = (yyvsp[-1].str);
					n->passing = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 50872 "gram.c"
    break;

  case 2292: /* json_context_item: json_value_expr  */
#line 16497 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 50878 "gram.c"
    break;

  case 2293: /* json_path_specification: a_expr  */
#line 16501 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 50884 "gram.c"
    break;

  case 2294: /* json_as_path_name_clause_opt: AS json_table_path_name  */
#line 16505 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 50890 "gram.c"
    break;

  case 2295: /* json_as_path_name_clause_opt: %empty  */
#line 16506 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 50896 "gram.c"
    break;

  case 2296: /* json_table_path_name: name  */
#line 16510 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 50902 "gram.c"
    break;

  case 2297: /* json_passing_clause_opt: PASSING json_arguments  */
#line 16514 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 50908 "gram.c"
    break;

  case 2298: /* json_passing_clause_opt: %empty  */
#line 16515 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 50914 "gram.c"
    break;

  case 2299: /* json_arguments: json_argument  */
#line 16519 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 50920 "gram.c"
    break;

  case 2300: /* json_arguments: json_arguments ',' json_argument  */
#line 16520 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 50926 "gram.c"
    break;

  case 2301: /* json_argument: json_value_expr AS ColLabel  */
#line 16525 "gram.y"
                        {
				JsonArgument *n = makeNode(JsonArgument);

				n->val = (JsonValueExpr *) (yyvsp[-2].node);
				n->name = (yyvsp[0].str);
				(yyval.node) = (Node *) n;
			}
#line 50938 "gram.c"
    break;

  case 2302: /* json_value_expr: a_expr json_format_clause_opt  */
#line 16536 "gram.y"
                        {
				(yyval.node) = (Node *) makeJsonValueExpr((Expr *) (yyvsp[-1].node), castNode(JsonFormat, (yyvsp[0].node)));
			}
#line 50946 "gram.c"
    break;

  case 2303: /* json_format_clause_opt: FORMAT json_representation  */
#line 16543 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
					castNode(JsonFormat, (yyval.node))->location = (yylsp[-1]);
				}
#line 50955 "gram.c"
    break;

  case 2304: /* json_format_clause_opt: %empty  */
#line 16548 "gram.y"
                                {
					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
				}
#line 50963 "gram.c"
    break;

  case 2305: /* json_representation: JSON json_encoding_clause_opt  */
#line 16555 "gram.y"
                                {
					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_JSON, (yyvsp[0].ival), (yylsp[-1]));
				}
#line 50971 "gram.c"
    break;

  case 2306: /* json_encoding_clause_opt: ENCODING json_encoding  */
#line 16562 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[0].ival); }
#line 50977 "gram.c"
    break;

  case 2307: /* json_encoding_clause_opt: %empty  */
#line 16563 "gram.y"
                                                                                        { (yyval.ival) = JS_ENC_DEFAULT; }
#line 50983 "gram.c"
    break;

  case 2308: /* json_encoding: name  */
#line 16567 "gram.y"
                                                                                                { (yyval.ival) = makeJsonEncoding((yyvsp[0].str)); }
#line 50989 "gram.c"
    break;

  case 2309: /* json_behavior_error: ERROR_P  */
#line 16571 "gram.y"
                                        { (yyval.jsbehavior) = makeJsonBehavior(JSON_BEHAVIOR_ERROR, NULL); }
#line 50995 "gram.c"
    break;

  case 2310: /* json_behavior_null: NULL_P  */
#line 16575 "gram.y"
                                        { (yyval.jsbehavior) = makeJsonBehavior(JSON_BEHAVIOR_NULL, NULL); }
#line 51001 "gram.c"
    break;

  case 2311: /* json_behavior_true: TRUE_P  */
#line 16579 "gram.y"
                                        { (yyval.jsbehavior) = makeJsonBehavior(JSON_BEHAVIOR_TRUE, NULL); }
#line 51007 "gram.c"
    break;

  case 2312: /* json_behavior_false: FALSE_P  */
#line 16583 "gram.y"
                                        { (yyval.jsbehavior) = makeJsonBehavior(JSON_BEHAVIOR_FALSE, NULL); }
#line 51013 "gram.c"
    break;

  case 2313: /* json_behavior_unknown: UNKNOWN  */
#line 16587 "gram.y"
                                        { (yyval.jsbehavior) = makeJsonBehavior(JSON_BEHAVIOR_UNKNOWN, NULL); }
#line 51019 "gram.c"
    break;

  case 2314: /* json_behavior_empty: EMPTY_P  */
#line 16591 "gram.y"
                                        { (yyval.jsbehavior) = makeJsonBehavior(JSON_BEHAVIOR_EMPTY_OBJECT, NULL); }
#line 51025 "gram.c"
    break;

  case 2315: /* json_behavior_empty_array: EMPTY_P ARRAY  */
#line 16595 "gram.y"
                                        { (yyval.jsbehavior) = makeJsonBehavior(JSON_BEHAVIOR_EMPTY_ARRAY, NULL); }
#line 51031 "gram.c"
    break;

  case 2316: /* json_behavior_empty_array: EMPTY_P  */
#line 16597 "gram.y"
                                                { (yyval.jsbehavior) = makeJsonBehavior(JSON_BEHAVIOR_EMPTY_ARRAY, NULL); }
#line 51037 "gram.c"
    break;

  case 2317: /* json_behavior_empty_object: EMPTY_P OBJECT_P  */
#line 16601 "gram.y"
                                                { (yyval.jsbehavior) = makeJsonBehavior(JSON_BEHAVIOR_EMPTY_OBJECT, NULL); }
#line 51043 "gram.c"
    break;

  case 2318: /* json_behavior_default: DEFAULT a_expr  */
#line 16605 "gram.y"
                                        { (yyval.jsbehavior) = makeJsonBehavior(JSON_BEHAVIOR_DEFAULT, (yyvsp[0].node)); }
#line 51049 "gram.c"
    break;

  case 2322: /* json_value_on_behavior_clause_opt: json_value_behavior ON EMPTY_P  */
#line 16617 "gram.y"
                                                                        { (yyval.on_behavior).on_empty = (yyvsp[-2].jsbehavior); (yyval.on_behavior).on_error = NULL; }
#line 51055 "gram.c"
    break;

  case 2323: /* json_value_on_behavior_clause_opt: json_value_behavior ON EMPTY_P json_value_behavior ON ERROR_P  */
#line 16619 "gram.y"
                                                                        { (yyval.on_behavior).on_empty = (yyvsp[-5].jsbehavior); (yyval.on_behavior).on_error = (yyvsp[-2].jsbehavior); }
#line 51061 "gram.c"
    break;

  case 2324: /* json_value_on_behavior_clause_opt: json_value_behavior ON ERROR_P  */
#line 16621 "gram.y"
                                                                        { (yyval.on_behavior).on_empty = NULL; (yyval.on_behavior).on_error = (yyvsp[-2].jsbehavior); }
#line 51067 "gram.c"
    break;

  case 2325: /* json_value_on_behavior_clause_opt: %empty  */
#line 16623 "gram.y"
                                                                        { (yyval.on_behavior).on_empty = NULL; (yyval.on_behavior).on_error = NULL; }
#line 51073 "gram.c"
    break;

  case 2326: /* json_query_expr: JSON_QUERY '(' json_api_common_syntax json_output_clause_opt json_wrapper_clause_opt json_quotes_clause_opt json_query_on_behavior_clause_opt ')'  */
#line 16634 "gram.y"
                                {
					JsonFuncExpr *n = makeNode(JsonFuncExpr);

					n->op = JSON_QUERY_OP;
					n->common = (JsonCommon *) (yyvsp[-5].node);
					n->output = (JsonOutput *) (yyvsp[-4].node);
					n->wrapper = (yyvsp[-3].ival);
					if (n->wrapper != JSW_NONE && (yyvsp[-2].js_quotes) != JS_QUOTES_UNSPEC)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("SQL/JSON QUOTES behavior must not be specified when WITH WRAPPER is used"),
								 parser_errposition((yylsp[-2]))));
					n->omit_quotes = (yyvsp[-2].js_quotes) == JS_QUOTES_OMIT;
					n->on_empty = (yyvsp[-1].on_behavior).on_empty;
					n->on_error = (yyvsp[-1].on_behavior).on_error;
					n->location = (yylsp[-7]);
					(yyval.node) = (Node *) n;
				}
#line 51096 "gram.c"
    break;

  case 2327: /* json_wrapper_clause_opt: json_wrapper_behavior WRAPPER  */
#line 16655 "gram.y"
                                                                        { (yyval.ival) = (yyvsp[-1].ival); }
#line 51102 "gram.c"
    break;

  case 2328: /* json_wrapper_clause_opt: %empty  */
#line 16656 "gram.y"
                                                                                        { (yyval.ival) = 0; }
#line 51108 "gram.c"
    break;

  case 2329: /* json_wrapper_behavior: WITHOUT array_opt  */
#line 16660 "gram.y"
                                                                                        { (yyval.ival) = JSW_NONE; }
#line 51114 "gram.c"
    break;

  case 2330: /* json_wrapper_behavior: WITH json_conditional_or_unconditional_opt array_opt  */
#line 16661 "gram.y"
                                                                               { (yyval.ival) = (yyvsp[-1].ival); }
#line 51120 "gram.c"
    break;

  case 2331: /* array_opt: ARRAY  */
#line 16665 "gram.y"
                                                                                                { }
#line 51126 "gram.c"
    break;

  case 2332: /* array_opt: %empty  */
#line 16666 "gram.y"
                                                                                        { }
#line 51132 "gram.c"
    break;

  case 2333: /* json_conditional_or_unconditional_opt: CONDITIONAL  */
#line 16670 "gram.y"
                                                                                                { (yyval.ival) = JSW_CONDITIONAL; }
#line 51138 "gram.c"
    break;

  case 2334: /* json_conditional_or_unconditional_opt: UNCONDITIONAL  */
#line 16671 "gram.y"
                                                                                        { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 51144 "gram.c"
    break;

  case 2335: /* json_conditional_or_unconditional_opt: %empty  */
#line 16672 "gram.y"
                                                                                        { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 51150 "gram.c"
    break;

  case 2336: /* json_quotes_clause_opt: json_quotes_behavior QUOTES json_on_scalar_string_opt  */
#line 16676 "gram.y"
                                                                              { (yyval.js_quotes) = (yyvsp[-2].js_quotes); }
#line 51156 "gram.c"
    break;

  case 2337: /* json_quotes_clause_opt: %empty  */
#line 16677 "gram.y"
                                                                                        { (yyval.js_quotes) = JS_QUOTES_UNSPEC; }
#line 51162 "gram.c"
    break;

  case 2338: /* json_quotes_behavior: KEEP  */
#line 16681 "gram.y"
                                                                                                { (yyval.js_quotes) = JS_QUOTES_KEEP; }
#line 51168 "gram.c"
    break;

  case 2339: /* json_quotes_behavior: OMIT  */
#line 16682 "gram.y"
                                                                                                { (yyval.js_quotes) = JS_QUOTES_OMIT; }
#line 51174 "gram.c"
    break;

  case 2340: /* json_on_scalar_string_opt: ON SCALAR STRING  */
#line 16686 "gram.y"
                                                                                        { }
#line 51180 "gram.c"
    break;

  case 2341: /* json_on_scalar_string_opt: %empty  */
#line 16687 "gram.y"
                                                                                        { }
#line 51186 "gram.c"
    break;

  case 2347: /* json_query_on_behavior_clause_opt: json_query_behavior ON EMPTY_P  */
#line 16700 "gram.y"
                                                                        { (yyval.on_behavior).on_empty = (yyvsp[-2].jsbehavior); (yyval.on_behavior).on_error = NULL; }
#line 51192 "gram.c"
    break;

  case 2348: /* json_query_on_behavior_clause_opt: json_query_behavior ON EMPTY_P json_query_behavior ON ERROR_P  */
#line 16702 "gram.y"
                                                                        { (yyval.on_behavior).on_empty = (yyvsp[-5].jsbehavior); (yyval.on_behavior).on_error = (yyvsp[-2].jsbehavior); }
#line 51198 "gram.c"
    break;

  case 2349: /* json_query_on_behavior_clause_opt: json_query_behavior ON ERROR_P  */
#line 16704 "gram.y"
                                                                        { (yyval.on_behavior).on_empty = NULL; (yyval.on_behavior).on_error = (yyvsp[-2].jsbehavior); }
#line 51204 "gram.c"
    break;

  case 2350: /* json_query_on_behavior_clause_opt: %empty  */
#line 16706 "gram.y"
                                                                        { (yyval.on_behavior).on_empty = NULL; (yyval.on_behavior).on_error = NULL; }
#line 51210 "gram.c"
    break;

  case 2351: /* json_table: JSON_TABLE '(' json_api_common_syntax json_table_columns_clause json_table_plan_clause_opt json_table_error_clause_opt ')'  */
#line 16716 "gram.y"
                                {
					JsonTable *n = makeNode(JsonTable);

					n->common = (JsonCommon *) (yyvsp[-4].node);
					n->columns = (yyvsp[-3].list);
					n->plan = (JsonTablePlan *) (yyvsp[-2].node);
					n->on_error = (yyvsp[-1].jsbehavior);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 51225 "gram.c"
    break;

  case 2352: /* json_table_columns_clause: COLUMNS '(' json_table_column_definition_list ')'  */
#line 16729 "gram.y"
                                                                              { (yyval.list) = (yyvsp[-1].list); }
#line 51231 "gram.c"
    break;

  case 2353: /* json_table_column_definition_list: json_table_column_definition  */
#line 16734 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 51237 "gram.c"
    break;

  case 2354: /* json_table_column_definition_list: json_table_column_definition_list ',' json_table_column_definition  */
#line 16736 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 51243 "gram.c"
    break;

  case 2360: /* json_table_ordinality_column_definition: ColId FOR ORDINALITY  */
#line 16749 "gram.y"
                                {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_FOR_ORDINALITY;
					n->name = (yyvsp[-2].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 51256 "gram.c"
    break;

  case 2361: /* json_table_regular_column_definition: ColId Typename json_table_column_path_specification_clause_opt json_wrapper_clause_opt json_quotes_clause_opt json_value_on_behavior_clause_opt  */
#line 16765 "gram.y"
                                {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_REGULAR;
					n->name = (yyvsp[-5].str);
					n->typeName = (yyvsp[-4].typnam);
					n->format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
					n->wrapper = (yyvsp[-2].ival); /* JSW_NONE */
					n->omit_quotes = (yyvsp[-1].js_quotes); /* false */
					n->pathspec = (yyvsp[-3].str);
					n->on_empty = (yyvsp[0].on_behavior).on_empty;
					n->on_error = (yyvsp[0].on_behavior).on_error;
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 51276 "gram.c"
    break;

  case 2362: /* json_table_exists_column_definition: ColId Typename EXISTS json_table_column_path_specification_clause_opt json_exists_error_clause_opt  */
#line 16786 "gram.y"
                                {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_EXISTS;
					n->name = (yyvsp[-4].str);
					n->typeName = (yyvsp[-3].typnam);
					n->format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
					n->wrapper = JSW_NONE;
					n->omit_quotes = false;
					n->pathspec = (yyvsp[-1].str);
					n->on_empty = NULL;
					n->on_error = (yyvsp[0].jsbehavior);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 51296 "gram.c"
    break;

  case 2365: /* json_table_error_clause_opt: json_table_error_behavior ON ERROR_P  */
#line 16809 "gram.y"
                                                                { (yyval.jsbehavior) = (yyvsp[-2].jsbehavior); }
#line 51302 "gram.c"
    break;

  case 2366: /* json_table_error_clause_opt: %empty  */
#line 16810 "gram.y"
                                                                                        { (yyval.jsbehavior) = NULL; }
#line 51308 "gram.c"
    break;

  case 2367: /* json_table_column_path_specification_clause_opt: PATH Sconst  */
#line 16814 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 51314 "gram.c"
    break;

  case 2368: /* json_table_column_path_specification_clause_opt: %empty  */
#line 16815 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 51320 "gram.c"
    break;

  case 2369: /* json_table_formatted_column_definition: ColId Typename FORMAT json_representation json_table_column_path_specification_clause_opt json_wrapper_clause_opt json_quotes_clause_opt json_query_on_behavior_clause_opt  */
#line 16824 "gram.y"
                                {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_FORMATTED;
					n->name = (yyvsp[-7].str);
					n->typeName = (yyvsp[-6].typnam);
					n->format = castNode(JsonFormat, (yyvsp[-4].node));
					n->pathspec = (yyvsp[-3].str);
					n->wrapper = (yyvsp[-2].ival);
					if (n->wrapper != JSW_NONE && (yyvsp[-1].js_quotes) != JS_QUOTES_UNSPEC)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("SQL/JSON QUOTES behavior must not be specified when WITH WRAPPER is used"),
								 parser_errposition((yylsp[-1]))));
					n->omit_quotes = (yyvsp[-1].js_quotes) == JS_QUOTES_OMIT;
					n->on_empty = (yyvsp[0].on_behavior).on_empty;
					n->on_error = (yyvsp[0].on_behavior).on_error;
					n->location = (yylsp[-7]);
					(yyval.node) = (Node *) n;
				}
#line 51345 "gram.c"
    break;

  case 2370: /* json_table_nested_columns: NESTED path_opt Sconst json_as_path_name_clause_opt json_table_columns_clause  */
#line 16850 "gram.y"
                                {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_NESTED;
					n->pathspec = (yyvsp[-2].str);
					n->pathname = (yyvsp[-1].str);
					n->columns = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 51360 "gram.c"
    break;

  case 2371: /* path_opt: PATH  */
#line 16863 "gram.y"
                                                                                                { }
#line 51366 "gram.c"
    break;

  case 2372: /* path_opt: %empty  */
#line 16864 "gram.y"
                                                                                        { }
#line 51372 "gram.c"
    break;

  case 2373: /* json_table_plan_clause_opt: json_table_specific_plan  */
#line 16868 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 51378 "gram.c"
    break;

  case 2374: /* json_table_plan_clause_opt: json_table_default_plan  */
#line 16869 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 51384 "gram.c"
    break;

  case 2375: /* json_table_plan_clause_opt: %empty  */
#line 16870 "gram.y"
                                                                                        { (yyval.node) = NULL; }
#line 51390 "gram.c"
    break;

  case 2376: /* json_table_specific_plan: PLAN '(' json_table_plan ')'  */
#line 16874 "gram.y"
                                                                        { (yyval.node) = (yyvsp[-1].node); }
#line 51396 "gram.c"
    break;

  case 2380: /* json_table_plan_simple: json_table_path_name  */
#line 16885 "gram.y"
                                {
					JsonTablePlan *n = makeNode(JsonTablePlan);

					n->plan_type = JSTP_SIMPLE;
					n->pathname = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 51409 "gram.c"
    break;

  case 2383: /* json_table_plan_outer: json_table_plan_simple OUTER_P json_table_plan_primary  */
#line 16902 "gram.y"
                                { (yyval.node) = makeJsonTableJoinedPlan(JSTPJ_OUTER, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-2])); }
#line 51415 "gram.c"
    break;

  case 2384: /* json_table_plan_inner: json_table_plan_simple INNER_P json_table_plan_primary  */
#line 16907 "gram.y"
                                { (yyval.node) = makeJsonTableJoinedPlan(JSTPJ_INNER, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-2])); }
#line 51421 "gram.c"
    break;

  case 2387: /* json_table_plan_union: json_table_plan_primary UNION json_table_plan_primary  */
#line 16917 "gram.y"
                                { (yyval.node) = makeJsonTableJoinedPlan(JSTPJ_UNION, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-2])); }
#line 51427 "gram.c"
    break;

  case 2388: /* json_table_plan_union: json_table_plan_union UNION json_table_plan_primary  */
#line 16919 "gram.y"
                                { (yyval.node) = makeJsonTableJoinedPlan(JSTPJ_UNION, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-2])); }
#line 51433 "gram.c"
    break;

  case 2389: /* json_table_plan_cross: json_table_plan_primary CROSS json_table_plan_primary  */
#line 16924 "gram.y"
                                { (yyval.node) = makeJsonTableJoinedPlan(JSTPJ_CROSS, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-2])); }
#line 51439 "gram.c"
    break;

  case 2390: /* json_table_plan_cross: json_table_plan_cross CROSS json_table_plan_primary  */
#line 16926 "gram.y"
                                { (yyval.node) = makeJsonTableJoinedPlan(JSTPJ_CROSS, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-2])); }
#line 51445 "gram.c"
    break;

  case 2391: /* json_table_plan_primary: json_table_plan_simple  */
#line 16930 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 51451 "gram.c"
    break;

  case 2392: /* json_table_plan_primary: '(' json_table_plan ')'  */
#line 16932 "gram.y"
                                {
					castNode(JsonTablePlan, (yyvsp[-1].node))->location = (yylsp[-2]);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 51460 "gram.c"
    break;

  case 2393: /* json_table_default_plan: PLAN DEFAULT '(' json_table_default_plan_choices ')'  */
#line 16940 "gram.y"
                        {
				JsonTablePlan *n = makeNode(JsonTablePlan);

				n->plan_type = JSTP_DEFAULT;
				n->join_type = (yyvsp[-1].ival);
				n->location = (yylsp[-4]);
				(yyval.node) = (Node *) n;
			}
#line 51473 "gram.c"
    break;

  case 2394: /* json_table_default_plan_choices: json_table_default_plan_inner_outer  */
#line 16951 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[0].ival) | JSTPJ_UNION; }
#line 51479 "gram.c"
    break;

  case 2395: /* json_table_default_plan_choices: json_table_default_plan_inner_outer ',' json_table_default_plan_union_cross  */
#line 16953 "gram.y"
                                                                        { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 51485 "gram.c"
    break;

  case 2396: /* json_table_default_plan_choices: json_table_default_plan_union_cross  */
#line 16954 "gram.y"
                                                                        { (yyval.ival) = (yyvsp[0].ival) | JSTPJ_OUTER; }
#line 51491 "gram.c"
    break;

  case 2397: /* json_table_default_plan_choices: json_table_default_plan_union_cross ',' json_table_default_plan_inner_outer  */
#line 16956 "gram.y"
                                                                        { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 51497 "gram.c"
    break;

  case 2398: /* json_table_default_plan_inner_outer: INNER_P  */
#line 16960 "gram.y"
                                                                                                        { (yyval.ival) = JSTPJ_INNER; }
#line 51503 "gram.c"
    break;

  case 2399: /* json_table_default_plan_inner_outer: OUTER_P  */
#line 16961 "gram.y"
                                                                                                        { (yyval.ival) = JSTPJ_OUTER; }
#line 51509 "gram.c"
    break;

  case 2400: /* json_table_default_plan_union_cross: UNION  */
#line 16965 "gram.y"
                                                                                                        { (yyval.ival) = JSTPJ_UNION; }
#line 51515 "gram.c"
    break;

  case 2401: /* json_table_default_plan_union_cross: CROSS  */
#line 16966 "gram.y"
                                                                                                        { (yyval.ival) = JSTPJ_CROSS; }
#line 51521 "gram.c"
    break;

  case 2402: /* json_returning_clause_opt: RETURNING Typename  */
#line 16971 "gram.y"
                                {
					JsonOutput *n = makeNode(JsonOutput);

					n->typeName = (yyvsp[0].typnam);
					n->returning = makeNode(JsonReturning);
					n->returning->format =
						makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, (yylsp[0]));
					(yyval.node) = (Node *) n;
				}
#line 51535 "gram.c"
    break;

  case 2403: /* json_returning_clause_opt: %empty  */
#line 16980 "gram.y"
                                                                                        { (yyval.node) = NULL; }
#line 51541 "gram.c"
    break;

  case 2404: /* json_output_clause_opt: RETURNING Typename json_format_clause_opt  */
#line 16985 "gram.y"
                                {
					JsonOutput *n = makeNode(JsonOutput);

					n->typeName = (yyvsp[-1].typnam);
					n->returning = makeNode(JsonReturning);
					n->returning->format = (JsonFormat *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 51554 "gram.c"
    break;

  case 2405: /* json_output_clause_opt: %empty  */
#line 16993 "gram.y"
                                                                                        { (yyval.node) = NULL; }
#line 51560 "gram.c"
    break;

  case 2406: /* json_exists_predicate: JSON_EXISTS '(' json_api_common_syntax json_returning_clause_opt json_exists_error_clause_opt ')'  */
#line 17002 "gram.y"
                                {
					JsonFuncExpr *p = makeNode(JsonFuncExpr);

					p->op = JSON_EXISTS_OP;
					p->common = (JsonCommon *) (yyvsp[-3].node);
					p->output = (JsonOutput *) (yyvsp[-2].node);
					p->on_error = (yyvsp[-1].jsbehavior);
					p->location = (yylsp[-5]);
					(yyval.node) = (Node *) p;
				}
#line 51575 "gram.c"
    break;

  case 2407: /* json_exists_error_clause_opt: json_exists_error_behavior ON ERROR_P  */
#line 17015 "gram.y"
                                                                        { (yyval.jsbehavior) = (yyvsp[-2].jsbehavior); }
#line 51581 "gram.c"
    break;

  case 2408: /* json_exists_error_clause_opt: %empty  */
#line 17016 "gram.y"
                                                                                                { (yyval.jsbehavior) = NULL; }
#line 51587 "gram.c"
    break;

  case 2415: /* json_object_constructor: JSON_OBJECT '(' json_object_args ')'  */
#line 17033 "gram.y"
                                {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 51595 "gram.c"
    break;

  case 2418: /* json_object_func_args: func_arg_list  */
#line 17045 "gram.y"
                                {
					List	   *func = list_make1(makeString("json_object"));

					(yyval.node) = (Node *) makeFuncCall(func, (yyvsp[0].list), COERCE_EXPLICIT_CALL, (yylsp[0]));
				}
#line 51605 "gram.c"
    break;

  case 2419: /* json_object_constructor_args: json_object_constructor_args_opt json_output_clause_opt  */
#line 17054 "gram.y"
                                {
					JsonObjectConstructor *n = (JsonObjectConstructor *) (yyvsp[-1].node);

					n->output = (JsonOutput *) (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 51617 "gram.c"
    break;

  case 2420: /* json_object_constructor_args_opt: json_name_and_value_list json_object_constructor_null_clause_opt json_key_uniqueness_constraint_opt  */
#line 17067 "gram.y"
                                {
					JsonObjectConstructor *n = makeNode(JsonObjectConstructor);

					n->exprs = (yyvsp[-2].list);
					n->absent_on_null = (yyvsp[-1].boolean);
					n->unique = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 51630 "gram.c"
    break;

  case 2421: /* json_object_constructor_args_opt: %empty  */
#line 17076 "gram.y"
                                {
					JsonObjectConstructor *n = makeNode(JsonObjectConstructor);

					n->exprs = NULL;
					n->absent_on_null = false;
					n->unique = false;
					(yyval.node) = (Node *) n;
				}
#line 51643 "gram.c"
    break;

  case 2422: /* json_name_and_value_list: json_name_and_value  */
#line 17088 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 51649 "gram.c"
    break;

  case 2423: /* json_name_and_value_list: json_name_and_value_list ',' json_name_and_value  */
#line 17090 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 51655 "gram.c"
    break;

  case 2424: /* json_name_and_value: c_expr VALUE_P json_value_expr  */
#line 17100 "gram.y"
                                { (yyval.node) = makeJsonKeyValue((yyvsp[-2].node), (yyvsp[0].node)); }
#line 51661 "gram.c"
    break;

  case 2425: /* json_name_and_value: a_expr ':' json_value_expr  */
#line 17103 "gram.y"
                                { (yyval.node) = makeJsonKeyValue((yyvsp[-2].node), (yyvsp[0].node)); }
#line 51667 "gram.c"
    break;

  case 2426: /* json_object_constructor_null_clause_opt: NULL_P ON NULL_P  */
#line 17107 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 51673 "gram.c"
    break;

  case 2427: /* json_object_constructor_null_clause_opt: ABSENT ON NULL_P  */
#line 17108 "gram.y"
                                                                                { (yyval.boolean) = true; }
#line 51679 "gram.c"
    break;

  case 2428: /* json_object_constructor_null_clause_opt: %empty  */
#line 17109 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 51685 "gram.c"
    break;

  case 2429: /* json_array_constructor: JSON_ARRAY '(' json_value_expr_list json_array_constructor_null_clause_opt json_output_clause_opt ')'  */
#line 17118 "gram.y"
                                {
					JsonArrayConstructor *n = makeNode(JsonArrayConstructor);

					n->exprs = (yyvsp[-3].list);
					n->absent_on_null = (yyvsp[-2].boolean);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 51699 "gram.c"
    break;

  case 2430: /* json_array_constructor: JSON_ARRAY '(' select_no_parens json_output_clause_opt ')'  */
#line 17133 "gram.y"
                                {
					JsonArrayQueryConstructor *n = makeNode(JsonArrayQueryConstructor);

					n->query = (yyvsp[-2].node);
					n->format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
					/* n->format = $4; */
					n->absent_on_null = true /* $5 */;
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 51715 "gram.c"
    break;

  case 2431: /* json_array_constructor: JSON_ARRAY '(' json_output_clause_opt ')'  */
#line 17147 "gram.y"
                                {
					JsonArrayConstructor *n = makeNode(JsonArrayConstructor);

					n->exprs = NIL;
					n->absent_on_null = true;
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 51729 "gram.c"
    break;

  case 2432: /* json_value_expr_list: json_value_expr  */
#line 17159 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 51735 "gram.c"
    break;

  case 2433: /* json_value_expr_list: json_value_expr_list ',' json_value_expr  */
#line 17160 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));}
#line 51741 "gram.c"
    break;

  case 2434: /* json_array_constructor_null_clause_opt: NULL_P ON NULL_P  */
#line 17164 "gram.y"
                                                                                        { (yyval.boolean) = false; }
#line 51747 "gram.c"
    break;

  case 2435: /* json_array_constructor_null_clause_opt: ABSENT ON NULL_P  */
#line 17165 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 51753 "gram.c"
    break;

  case 2436: /* json_array_constructor_null_clause_opt: %empty  */
#line 17166 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 51759 "gram.c"
    break;

  case 2439: /* json_object_aggregate_constructor: JSON_OBJECTAGG '(' json_name_and_value json_object_constructor_null_clause_opt json_key_uniqueness_constraint_opt json_output_clause_opt ')'  */
#line 17181 "gram.y"
                                {
					JsonObjectAgg *n = makeNode(JsonObjectAgg);

					n->arg = (JsonKeyValue *) (yyvsp[-4].node);
					n->absent_on_null = (yyvsp[-3].boolean);
					n->unique = (yyvsp[-2].boolean);
					n->constructor = makeNode(JsonAggConstructor);
					n->constructor->output = (JsonOutput *) (yyvsp[-1].node);
					n->constructor->agg_order = NULL;
					n->constructor->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 51776 "gram.c"
    break;

  case 2440: /* json_array_aggregate_constructor: JSON_ARRAYAGG '(' json_value_expr json_array_aggregate_order_by_clause_opt json_array_constructor_null_clause_opt json_output_clause_opt ')'  */
#line 17202 "gram.y"
                                {
					JsonArrayAgg *n = makeNode(JsonArrayAgg);

					n->arg = (JsonValueExpr *) (yyvsp[-4].node);
					n->absent_on_null = (yyvsp[-2].boolean);
					n->constructor = makeNode(JsonAggConstructor);
					n->constructor->agg_order = (yyvsp[-3].list);
					n->constructor->output = (JsonOutput *) (yyvsp[-1].node);
					n->constructor->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 51792 "gram.c"
    break;

  case 2441: /* json_array_aggregate_order_by_clause_opt: ORDER BY sortby_list  */
#line 17216 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 51798 "gram.c"
    break;

  case 2442: /* json_array_aggregate_order_by_clause_opt: %empty  */
#line 17217 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 51804 "gram.c"
    break;

  case 2443: /* opt_target_list: target_list  */
#line 17226 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 51810 "gram.c"
    break;

  case 2444: /* opt_target_list: %empty  */
#line 17227 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 51816 "gram.c"
    break;

  case 2445: /* target_list: target_el  */
#line 17231 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 51822 "gram.c"
    break;

  case 2446: /* target_list: target_list ',' target_el  */
#line 17232 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 51828 "gram.c"
    break;

  case 2447: /* target_el: a_expr AS ColLabel  */
#line 17236 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 51840 "gram.c"
    break;

  case 2448: /* target_el: a_expr BareColLabel  */
#line 17244 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 51852 "gram.c"
    break;

  case 2449: /* target_el: a_expr  */
#line 17252 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 51864 "gram.c"
    break;

  case 2450: /* target_el: '*'  */
#line 17260 "gram.y"
                                {
					ColumnRef  *n = makeNode(ColumnRef);

					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 51881 "gram.c"
    break;

  case 2451: /* qualified_name_list: qualified_name  */
#line 17282 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 51887 "gram.c"
    break;

  case 2452: /* qualified_name_list: qualified_name_list ',' qualified_name  */
#line 17283 "gram.y"
                                                                 { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 51893 "gram.c"
    break;

  case 2453: /* qualified_name: ColId  */
#line 17295 "gram.y"
                                {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 51901 "gram.c"
    break;

  case 2454: /* qualified_name: ColId indirection  */
#line 17299 "gram.y"
                                {
					(yyval.range) = makeRangeVarFromQualifiedName((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 51909 "gram.c"
    break;

  case 2455: /* name_list: name  */
#line 17305 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 51915 "gram.c"
    break;

  case 2456: /* name_list: name_list ',' name  */
#line 17307 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 51921 "gram.c"
    break;

  case 2457: /* name: ColId  */
#line 17311 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 51927 "gram.c"
    break;

  case 2458: /* attr_name: ColLabel  */
#line 17313 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 51933 "gram.c"
    break;

  case 2459: /* file_name: Sconst  */
#line 17315 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 51939 "gram.c"
    break;

  case 2460: /* func_name: type_function_name  */
#line 17326 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 51945 "gram.c"
    break;

  case 2461: /* func_name: ColId indirection  */
#line 17328 "gram.y"
                                        {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 51954 "gram.c"
    break;

  case 2462: /* AexprConst: Iconst  */
#line 17339 "gram.y"
                                {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 51962 "gram.c"
    break;

  case 2463: /* AexprConst: FCONST  */
#line 17343 "gram.y"
                                {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 51970 "gram.c"
    break;

  case 2464: /* AexprConst: Sconst  */
#line 17347 "gram.y"
                                {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 51978 "gram.c"
    break;

  case 2465: /* AexprConst: BCONST  */
#line 17351 "gram.y"
                                {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 51986 "gram.c"
    break;

  case 2466: /* AexprConst: XCONST  */
#line 17355 "gram.y"
                                {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 51999 "gram.c"
    break;

  case 2467: /* AexprConst: func_name Sconst  */
#line 17364 "gram.y"
                                {
					/* generic type 'literal' syntax */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-1].list));

					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 52011 "gram.c"
    break;

  case 2468: /* AexprConst: func_name '(' func_arg_list opt_sort_clause ')' Sconst  */
#line 17372 "gram.y"
                                {
					/* generic syntax with a type modifier */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell   *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 52047 "gram.c"
    break;

  case 2469: /* AexprConst: ConstTypename Sconst  */
#line 17404 "gram.y"
                                {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 52055 "gram.c"
    break;

  case 2470: /* AexprConst: ConstInterval Sconst opt_interval  */
#line 17408 "gram.y"
                                {
					TypeName   *t = (yyvsp[-2].typnam);

					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 52066 "gram.c"
    break;

  case 2471: /* AexprConst: ConstInterval '(' Iconst ')' Sconst  */
#line 17415 "gram.y"
                                {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 52078 "gram.c"
    break;

  case 2472: /* AexprConst: TRUE_P  */
#line 17423 "gram.y"
                                {
					(yyval.node) = makeBoolAConst(true, (yylsp[0]));
				}
#line 52086 "gram.c"
    break;

  case 2473: /* AexprConst: FALSE_P  */
#line 17427 "gram.y"
                                {
					(yyval.node) = makeBoolAConst(false, (yylsp[0]));
				}
#line 52094 "gram.c"
    break;

  case 2474: /* AexprConst: NULL_P  */
#line 17431 "gram.y"
                                {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 52102 "gram.c"
    break;

  case 2475: /* Iconst: ICONST  */
#line 17436 "gram.y"
                                                                                        { (yyval.ival) = (yyvsp[0].ival); }
#line 52108 "gram.c"
    break;

  case 2476: /* Sconst: SCONST  */
#line 17437 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 52114 "gram.c"
    break;

  case 2477: /* SignedIconst: Iconst  */
#line 17439 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[0].ival); }
#line 52120 "gram.c"
    break;

  case 2478: /* SignedIconst: '+' Iconst  */
#line 17440 "gram.y"
                                                                                        { (yyval.ival) = + (yyvsp[0].ival); }
#line 52126 "gram.c"
    break;

  case 2479: /* SignedIconst: '-' Iconst  */
#line 17441 "gram.y"
                                                                                        { (yyval.ival) = - (yyvsp[0].ival); }
#line 52132 "gram.c"
    break;

  case 2480: /* RoleId: RoleSpec  */
#line 17446 "gram.y"
                                {
					RoleSpec   *spc = (RoleSpec *) (yyvsp[0].rolespec);

					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_ROLE:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_ROLE"),
									 parser_errposition((yylsp[0]))));
							break;
					}
				}
#line 52175 "gram.c"
    break;

  case 2481: /* RoleSpec: NonReservedWord  */
#line 17487 "gram.y"
                                {
					/*
					 * "public" and "none" are not keywords, but they must
					 * be treated specially here.
					 */
					RoleSpec   *n;

					if (strcmp((yyvsp[0].str), "public") == 0)
					{
						n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
						n->roletype = ROLESPEC_PUBLIC;
					}
					else if (strcmp((yyvsp[0].str), "none") == 0)
					{
						ereport(ERROR,
								(errcode(ERRCODE_RESERVED_NAME),
								 errmsg("role name \"%s\" is reserved",
										"none"),
								 parser_errposition((yylsp[0]))));
					}
					else
					{
						n = makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
						n->rolename = pstrdup((yyvsp[0].str));
					}
					(yyval.rolespec) = n;
				}
#line 52207 "gram.c"
    break;

  case 2482: /* RoleSpec: CURRENT_ROLE  */
#line 17515 "gram.y"
                                {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_ROLE, (yylsp[0]));
				}
#line 52215 "gram.c"
    break;

  case 2483: /* RoleSpec: CURRENT_USER  */
#line 17519 "gram.y"
                                {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
				}
#line 52223 "gram.c"
    break;

  case 2484: /* RoleSpec: SESSION_USER  */
#line 17523 "gram.y"
                                {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
				}
#line 52231 "gram.c"
    break;

  case 2485: /* role_list: RoleSpec  */
#line 17529 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 52237 "gram.c"
    break;

  case 2486: /* role_list: role_list ',' RoleSpec  */
#line 17531 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 52243 "gram.c"
    break;

  case 2487: /* PLpgSQL_Expr: opt_distinct_clause opt_target_list from_clause where_clause group_clause having_clause window_clause opt_sort_clause opt_select_limit opt_for_locking_clause  */
#line 17548 "gram.y"
                                {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-9].list);
					n->targetList = (yyvsp[-8].list);
					n->fromClause = (yyvsp[-7].list);
					n->whereClause = (yyvsp[-6].node);
					n->groupClause = ((yyvsp[-5].groupclause))->list;
					n->groupDistinct = ((yyvsp[-5].groupclause))->distinct;
					n->havingClause = (yyvsp[-4].node);
					n->windowClause = (yyvsp[-3].list);
					n->sortClause = (yyvsp[-2].list);
					if ((yyvsp[-1].selectlimit))
					{
						n->limitOffset = (yyvsp[-1].selectlimit)->limitOffset;
						n->limitCount = (yyvsp[-1].selectlimit)->limitCount;
						if (!n->sortClause &&
							(yyvsp[-1].selectlimit)->limitOption == LIMIT_OPTION_WITH_TIES)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
						n->limitOption = (yyvsp[-1].selectlimit)->limitOption;
					}
					n->lockingClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 52274 "gram.c"
    break;

  case 2488: /* PLAssignStmt: plassign_target opt_indirection plassign_equals PLpgSQL_Expr  */
#line 17581 "gram.y"
                                {
					PLAssignStmt *n = makeNode(PLAssignStmt);

					n->name = (yyvsp[-3].str);
					n->indirection = check_indirection((yyvsp[-2].list), yyscanner);
					/* nnames will be filled by calling production */
					n->val = (SelectStmt *) (yyvsp[0].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 52289 "gram.c"
    break;

  case 2489: /* plassign_target: ColId  */
#line 17593 "gram.y"
                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 52295 "gram.c"
    break;

  case 2490: /* plassign_target: PARAM  */
#line 17594 "gram.y"
                                                                                        { (yyval.str) = psprintf("$%d", (yyvsp[0].ival)); }
#line 52301 "gram.c"
    break;

  case 2493: /* ColId: IDENT  */
#line 17615 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 52307 "gram.c"
    break;

  case 2494: /* ColId: unreserved_keyword  */
#line 17616 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52313 "gram.c"
    break;

  case 2495: /* ColId: col_name_keyword  */
#line 17617 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52319 "gram.c"
    break;

  case 2496: /* type_function_name: IDENT  */
#line 17622 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 52325 "gram.c"
    break;

  case 2497: /* type_function_name: unreserved_keyword  */
#line 17623 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52331 "gram.c"
    break;

  case 2498: /* type_function_name: type_func_name_keyword  */
#line 17624 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52337 "gram.c"
    break;

  case 2499: /* NonReservedWord: IDENT  */
#line 17629 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 52343 "gram.c"
    break;

  case 2500: /* NonReservedWord: unreserved_keyword  */
#line 17630 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52349 "gram.c"
    break;

  case 2501: /* NonReservedWord: col_name_keyword  */
#line 17631 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52355 "gram.c"
    break;

  case 2502: /* NonReservedWord: type_func_name_keyword  */
#line 17632 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52361 "gram.c"
    break;

  case 2503: /* ColLabel: IDENT  */
#line 17638 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 52367 "gram.c"
    break;

  case 2504: /* ColLabel: unreserved_keyword  */
#line 17639 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52373 "gram.c"
    break;

  case 2505: /* ColLabel: col_name_keyword  */
#line 17640 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52379 "gram.c"
    break;

  case 2506: /* ColLabel: type_func_name_keyword  */
#line 17641 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52385 "gram.c"
    break;

  case 2507: /* ColLabel: reserved_keyword  */
#line 17642 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52391 "gram.c"
    break;

  case 2508: /* BareColLabel: IDENT  */
#line 17648 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 52397 "gram.c"
    break;

  case 2509: /* BareColLabel: bare_label_keyword  */
#line 17649 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52403 "gram.c"
    break;


#line 52407 "gram.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 18651 "gram.y"


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static RawStmt *
makeRawStmt(Node *stmt, int stmt_location)
{
	RawStmt    *rs = makeNode(RawStmt);

	rs->stmt = stmt;
	rs->stmt_location = stmt_location;
	rs->stmt_len = 0;			/* might get changed later */
	return rs;
}

/* Adjust a RawStmt to reflect that it doesn't run to the end of the string */
static void
updateRawStmtEnd(RawStmt *rs, int end_location)
{
	/*
	 * If we already set the length, don't change it.  This is for situations
	 * like "select foo ;; select bar" where the same statement will be last
	 * in the string for more than one semicolon.
	 */
	if (rs->stmt_len > 0)
		return;

	/* OK, update length of RawStmt */
	rs->stmt_len = end_location - rs->stmt_location;
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int			nfields = 0;
	ListCell   *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast   *n = makeNode(TypeCast);

	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.sval.type = T_String;
	n->val.sval.sval = str;
	n->location = location;

   return (Node *) n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node	   *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.ival.type = T_Integer;
	n->val.ival.ival = val;
	n->location = location;

   return (Node *) n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.fval.type = T_Float;
	n->val.fval.fval = str;
	n->location = location;

   return (Node *) n;
}

static Node *
makeBoolAConst(bool state, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.boolval.type = T_Boolean;
	n->val.boolval.boolval = state;
	n->location = location;

   return (Node *) n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.bsval.type = T_BitString;
	n->val.bsval.bsval = str;
	n->location = location;

   return (Node *) n;
}

static Node *
makeNullAConst(int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->isnull = true;
	n->location = location;

	return (Node *) n;
}

static Node *
makeAConst(Node *v, int location)
{
	Node	   *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(castNode(Float, v)->fval, location);
			break;

		case T_Integer:
			n = makeIntConst(castNode(Integer, v)->ival, location);
			break;

		default:
			/* currently not used */
			Assert(false);
			n = NULL;
	}

	return n;
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static RoleSpec *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec   *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	Integer	   *ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC ||
			!equal(lastd->argType, firsto->argType))
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = makeInteger(list_length(directargs));

	return list_make2(list_concat(directargs, orderedargs),
					  ndirectargs);
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					SelectLimit *limitClause,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitClause && limitClause->limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitOffset))));
		stmt->limitOffset = limitClause->limitOffset;
	}
	if (limitClause && limitClause->limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitCount))));
		stmt->limitCount = limitClause->limitCount;
	}
	if (limitClause && limitClause->limitOption != LIMIT_OPTION_DEFAULT)
	{
		if (stmt->limitOption)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple limit options not allowed")));
		if (!stmt->sortClause && limitClause->limitOption == LIMIT_OPTION_WITH_TIES)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
		if (limitClause->limitOption == LIMIT_OPTION_WITH_TIES && stmt->lockingClause)
		{
			ListCell   *lc;

			foreach(lc, stmt->lockingClause)
			{
				LockingClause *lock = lfirst_node(LockingClause, lc);

				if (lock->waitPolicy == LockWaitSkip)
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("%s and %s options cannot be used together",
									"SKIP LOCKED", "WITH TIES")));
			}
		}
		stmt->limitOption = limitClause->limitOption;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const	   *con = (A_Const *) n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (IsA(&con->val, Integer))
		{
			con->val.ival.ival = -con->val.ival.ival;
			return n;
		}
		if (IsA(&con->val, Float))
		{
			doNegateFloat(&con->val.fval);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Float *v)
{
	char	   *oldval = v->fval;

	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->fval = oldval+1;	/* just strip the '-' */
	else
		v->fval = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod, int location)
{
	SQLValueFunction *svf = makeNode(SQLValueFunction);

	svf->op = op;
	/* svf->type will be filled during parse analysis */
	svf->typmod = typmod;
	svf->location = location;
	return (Node *) svf;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_DEFAULT &&
			p->mode != FUNC_PARAM_IN &&
			p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName   *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar   *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/*
 * Convert a relation_name with name and namelist to a RangeVar using
 * makeRangeVar.
 */
static RangeVar *
makeRangeVarFromQualifiedName(char *name, List *namelist, int location,
							  core_yyscan_t yyscanner)
{
	RangeVar   *r;

	check_qualified_name(namelist, yyscanner);
	r = makeRangeVar(NULL, NULL, location);

	switch (list_length(namelist))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = name;
			r->relname = strVal(linitial(namelist));
			break;
		case 2:
			r->catalogname = name;
			r->schemaname = strVal(linitial(namelist));
			r->relname = strVal(lsecond(namelist));
			break;
		default:
			ereport(ERROR,
					errcode(ERRCODE_SYNTAX_ERROR),
					errmsg("improper qualified name (too many dotted names): %s",
						   NameListToString(lcons(makeString(name), namelist))),
						   parser_errposition(location));
			break;
	}

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;

	*collClause = NULL;
	foreach(cell, qualList)
	{
		Node	   *n = (Node *) lfirst(cell);

		if (IsA(n, Constraint))
		{
			/* keep it in list */
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = foreach_delete_current(qualList, cell);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*
 * Process pubobjspec_list to check for errors in any of the objects and
 * convert PUBLICATIONOBJ_CONTINUATION into appropriate PublicationObjSpecType.
 */
static void
preprocess_pubobj_list(List *pubobjspec_list, core_yyscan_t yyscanner)
{
	ListCell   *cell;
	PublicationObjSpec *pubobj;
	PublicationObjSpecType prevobjtype = PUBLICATIONOBJ_CONTINUATION;

	if (!pubobjspec_list)
		return;

	pubobj = (PublicationObjSpec *) linitial(pubobjspec_list);
	if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
		ereport(ERROR,
				errcode(ERRCODE_SYNTAX_ERROR),
				errmsg("invalid publication object list"),
				errdetail("One of TABLE or ALL TABLES IN SCHEMA must be specified before a standalone table or schema name."),
				parser_errposition(pubobj->location));

	foreach(cell, pubobjspec_list)
	{
		pubobj = (PublicationObjSpec *) lfirst(cell);

		if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
			pubobj->pubobjtype = prevobjtype;

		if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLE)
		{
			/* relation name or pubtable must be set for this type of object */
			if (!pubobj->name && !pubobj->pubtable)
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("invalid table name at or near"),
						parser_errposition(pubobj->location));

			if (pubobj->name)
			{
				/* convert it to PublicationTable */
				PublicationTable *pubtable = makeNode(PublicationTable);

				pubtable->relation =
					makeRangeVar(NULL, pubobj->name, pubobj->location);
				pubobj->pubtable = pubtable;
				pubobj->name = NULL;
			}
		}
		else if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_SCHEMA ||
				 pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA)
		{
			/* WHERE clause is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->whereClause)
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("WHERE clause not allowed for schema"),
						parser_errposition(pubobj->location));

			/* Column list is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->columns)
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("column specification not allowed for schema"),
						parser_errposition(pubobj->location));

			/*
			 * We can distinguish between the different type of schema
			 * objects based on whether name and pubtable is set.
			 */
			if (pubobj->name)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
			else if (!pubobj->name && !pubobj->pubtable)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
			else
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("invalid schema name at or near"),
						parser_errposition(pubobj->location));
		}

		prevobjtype = pubobj->pubobjtype;
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctematerialized = CTEMaterializeDefault;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}
